[![PyPI](https://img.shields.io/pypi/v/pyfurc?style=flat-square)][pypi-url]
[![GA](https://img.shields.io/github/workflow/status/klunkean/pyfurc/tests?style=flat-square)][ga-url]
[![Documentation Status](https://readthedocs.org/projects/pyfurc/badge/?version=latest&style=flat-square)][rtd-url]
![Python Version](https://img.shields.io/badge/python-3.8-blue?style=flat-square)


[pypi-url]: https://pypi.org/project/pyfurc/
[rtd-url]: https://pyfurc.readthedocs.io/en/latest/
[ga-url]: https://github.com/klunkean/pyfurc/actions/workflows/tests.yml
# What is pyfurc?

pyfurc is a python module that facilitates calculations for non-linear
mechanical systems exhibiting bifurcations with the generalized
path-following FORTRAN program [AUTO-07p](http://indy.cs.concordia.ca/auto/)
directly in python.

Energy expressions, degrees of freedom and loads are defined
using  [sympy](https://docs.sympy.org/latest/index.html)
symbolic math processing functionality, and equilibrium equations
are automatically derived symbolically.

pyfurc then generates FORTRAN code for the bifurcation problem,
calls the AUTO-07p routines and reads the result into a
[pandas](https://pandas.pydata.org/docs/user_guide/index.html) DataFrame
for post-processing in python.

The basic functionality looks like this:

<img src="doc/source/_static/img/pyfurc_diagram.png" alt="drawing" width="550"/>

## Solving a bifurcation problem can be this simple:

```python
import pyfurc as pf
import sympy as sp
import matplotlib.pyplot as plt

phi = pf.Dof("\\varphi")
P = pf.Load("P")

cT = 10/3.1415
ell = 0.5

V = pf.Energy(1/2*cT*phi**2-P*ell*(1-sp.cos(phi)))
bf = pf.BifurcationProblem(V, name="hinged_cantilever")
bf.set_parameter("RL1", 12.73)  #set maximum load

solver = pf.BifurcationProblemSolver(bf)
solver.solve()  # solve problem

for dat in bf.solution.raw_data:
    plt.plot(dat["U(1)"], dat["PAR(1)"])
```

To get started, check out the Quickstart section below or take a look at the
in-depth installation guides in the [Documentation](https://pyfurc.readthedocs.io/en/latest/).

Part of the documentation is an [in-depth tutorial](https://pyfurc.readthedocs.io/en/latest/usage/tutorial.html) where a simple example problem is solved in different ways.

# Quickstart

Prerequisites:

* Running Linux distribution (only tested on Ubuntu so far)
* Python 3.8.2+
* pip

For installing pyfurc run

```bash
pip3 install pyfurc
```

# Documentation and Tutorial

The [Documentation](https://pyfurc.readthedocs.io/en/latest/) is hosted on readthedocs.



<!-- ## 2.2 Testing
Open up a python 3 console and type `import pyfurc` if there is no error message the installation should have been successful.

# 3 Installing and using Jupyter-Notebook on WSL
This is optional but I really like jupyter-notebooks maybe you do too.

## 3.1 Installation
Open up a Ubuntu Terminal and run
```shell
pip3 install notebook
```
All done!

In the Ubuntu Terminal now run
```shell
jupyter notebook
```

The output should contain
```
http://localhost:8888/?token=xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
```
somewhere. Copy the part after `token=`, i.e. the `xxxxxx...` from above.

Now open your favorite browser in Windows and navigate to
```
127.0.0.1:8888
```
For future convenience set a password at the bottom of the page! Here you must supply the token we just copied.

Once you have set the password you're redirected to jupyter's landing page showing you the home directory of your Ubuntu file system (should be empty).

On the top right, click "new" -> "python3".

Now you have a jupyter notebook to play with. Type
```python
print("Hello World!")
```
in the first cell and hit Ctrl+Enter.

# 4 A first Example: Hinged cantilever

Consider the following system:

![hinged_cant.png](doc/img/hinged_cant.png)

The total energy in the system is given by
```math
\begin{aligned}
V(\varphi) &= U(\varphi)-P\mathcal E(\varphi)\\&=\frac12 c_\mathrm{T}\varphi^2-F\ell\left(1-\cos\varphi\right)
\end{aligned}
```
## 4.1 Implementing this problem using pyfurc

First we import needed modules

```python
import pyfurc as pf
import sympy as sp
from math import pi
```
### 4.1.1 Defining physical quantities

Let us first define all contained variables as `pyfurc.PhysicalQuantity`.

It is important to set the `quantity_type` kwarg which may be one of `DOF`, `load` or `parameter`.

The `value` kwarg is optional (default=0.0) and will set the initial values if `quantity_type` is `DOF` or `load`, or the fixed constant value if `quantity_type` is `parameter`. The values can be changed later.


```python
phi = pf.PhysicalQuantity("\\varphi", quantity_type="DOF", value=0.0)
P = pf.PhysicalQuantity("P", quantity_type="load", value=0.0)
cT = pf.PhysicalQuantity("c_T", quantity_type="parameter", value=10/pi)
ell = pf.PhysicalQuantity("ell", quantity_type="parameter", value=0.5)
```

Next we define the energy expression using these quantites as a sympy expression. This is possible since `PhysicalQuantity` is a subclass of `sympy.Symbol`.

### 4.1.2 Defining the energy
First we define the energy as a symbolic expression `V_expr`
```python
V_expr = 1/2*cT*phi**2-P*ell*(1-sp.cos(phi))
```

To use this energy expression for the bifurcation analysis we create a `pyfurc.Energy` object from this expression:


```python
V = pf.Energy(V_expr)
```

We can print information about the energy:


```python
V.info()
```
Output:

    Potential energy with 1 DOF(s):
    -P*ell*(-cos(\varphi) + 1) + 0.5*\varphi**2*c_T

    The DOFs are:
    	\varphi - Fortran Name: U(1) - Init. Value: 0.000000
    The parameters are:
    	c_T - Fortran Name: PAR(2) - Value: 3.183099
    	ell - Fortran Name: PAR(3) - Value: 0.500000
    The load is:
    	P - Fortran Name: PAR(1) - Init. Value: 0.000000



Or directly access the information dicts `params`, `dofs` or `load`, e.g.:


```python
print(V.params)
```
Output:

    {c_T: {'name': 'PAR(2)', 'value': 3.183098861837907}, ell: {'name': 'PAR(3)', 'value': 0.5}}



The `pyfurc.Energy` class can also determine and output the equilibrium equations as symbolic objects:


```python
V.equilibrium()
```
Output:

```math
[ - P \ell \sin{\left (\varphi \right )} + 1.0 \varphi c_{T}]
```

The derivatives are calculated symbolically using sympy.

### 4.1.3 Defining the Bifurcation Problem

Now having defined a `pyfurc.Energy`, we use this energy to setup our bifurcation problem to be solved. Let us initialize a `pyfurc.BifurcationProblem` with the name `hinged`. The name will be used for the AUTO files.


```python
bf = pf.BifurcationProblem(V, name="hinged")
```

The problem class contains all calculation parameters which can be printed as follows:


```python
bf.print_parameters()
```
Output:

    NTST	: 50
    IAD	: 3
    EPSL	: 1e-07
    EPSU	: 1e-07
    EPSS	: 1e-05
    ITMX	: 8
    ITNW	: 5
    DS	: 0.1
    DSMIN	: 0.001
    DSMAX	: 0.2
    IADS	: 1
    STOP	: []
    NMX	: 200
    RL0	: 0.0
    RL1	: 0.0
    MXBF	: 10
    NPR	: 200
    IID	: 2
    IPLT	: 0
    UZR	: {}
    UZSTOP	: {}



Refer to the AUTO documentation for detailed descriptions of the parameters. The names are identical with the names used in the AUTO `c.xxx` file

To change a parameter we use the `set_parameter(name, value)` method. For example we set the maximum load `RL1`, as above, to a value of `12.73`:


```python
bf.set_parameter("RL1", 12.73)
```
### 4.1.4 Defining the solver

Having defined the problem we can instantiate a `BifurcationProblemSolver` object which handles the AUTO code generation and execution.


```python
solver = pf.BifurcationProblemSolver(bf)
```

To solve the problem we call the `solve()` method:


```python
solver.solve()
```

Output:

    Running AUTO on problem hinged
    ------------------------------------------------------------------------
    gfortran -fopenmp -O -c hinged.f90 -o hinged.o
    gfortran -fopenmp -O hinged.o -o hinged.exe /home/andre/localtu/prog/auto/07p/lib/*.o
    Starting hinged ...

      BR    PT  TY  LAB    PAR(1)        L2-NORM         U(1)
       1     1  EP    1   0.00000E+00   0.00000E+00   0.00000E+00
       1    33  BP    2   6.36620E+00   0.00000E+00   0.00000E+00
       1    65  EP    3   1.27662E+01   0.00000E+00   0.00000E+00

      BR    PT  TY  LAB    PAR(1)        L2-NORM         U(1)
       2    59  EP    4   1.28314E+01   1.90442E+00   1.90442E+00

      BR    PT  TY  LAB    PAR(1)        L2-NORM         U(1)
       2    59  EP    5   1.28314E+01   1.90442E+00  -1.90442E+00

     Total Time    0.628E-02
    hinged ... done

    ------------------------------------------------------------------------


The `BifurcationProblem` we just solved now has an attribute `solution` which (for now) only contains raw data we can plot manually (you need to install `matplotlib` for this: `pip3 install matplotlib`)


```python
import matplotlib.pyplot as plt
for dat in bf.solution.raw_data:
    plt.plot(dat["U(1)"], dat["PAR(1)"])
```

Output:

![png](doc/img/hinged_bifurcation_plot.png)


The post-processing capabilities are to be extended soon.

## 4.2 Summary and whole code

This is what we have done:

* Define `PhysicalQuantity` objects and set values
* Define `Energy` Object
* Define `BifurcationProblem` object and set parameters
* Define `BifurcationProblemSolver` object and call `solve` method
* Plot results from `BifurcationProblem.solution`

## 4.3 Runnable Code:
```python
import pyfurc as pf
import sympy as sp
from math import pi
import matplotlib.pyplot as plt

# Physical quantities
phi = pf.PhysicalQuantity("\\varphi", quantity_type="DOF", value=0.0)
P = pf.PhysicalQuantity("P", quantity_type="load", value=0.0)
cT = pf.PhysicalQuantity("c_T", quantity_type="parameter", value=10/pi)
ell = pf.PhysicalQuantity("ell", quantity_type="parameter", value=0.5)

# Energy
V_expr = 1/2*cT*phi**2-P*ell*(1-sp.cos(phi))
V = pf.Energy(V_expr)

# BifurcationProblem
bf = pf.BifurcationProblem(V, name="hinged")
bf.set_parameter("RL1", 12.73)  #set maximum load

# BifurcationProblemSolver
solver = pf.BifurcationProblemSolver(bf)
solver.solve()  # solve problem

# Plot solution (manually)
for dat in bf.solution.raw_data:
    plt.plot(dat["U(1)"], dat["PAR(1)"])
```

Output

    Running AUTO on problem hinged
    ------------------------------------------------------------------------
    gfortran -fopenmp -O -c hinged.f90 -o hinged.o
    gfortran -fopenmp -O hinged.o -o hinged.exe /home/andre/localtu/prog/auto/07p/lib/*.o
    Starting hinged ...

      BR    PT  TY  LAB    PAR(1)        L2-NORM         U(1)
       1     1  EP    1   0.00000E+00   0.00000E+00   0.00000E+00
       1    33  BP    2   6.36620E+00   0.00000E+00   0.00000E+00
       1    65  EP    3   1.27662E+01   0.00000E+00   0.00000E+00

      BR    PT  TY  LAB    PAR(1)        L2-NORM         U(1)
       2    59  EP    4   1.28314E+01   1.90442E+00   1.90442E+00

      BR    PT  TY  LAB    PAR(1)        L2-NORM         U(1)
       2    59  EP    5   1.28314E+01   1.90442E+00  -1.90442E+00

     Total Time    0.530E-02
    hinged ... done

    ------------------------------------------------------------------------

# pyfurc roadmap:

* Add support for continuous systems (Ritz)
* Automatic assembly of the Hessian, symbolic determination of critical points
* Automatic evaluation of the stability of equilibrium paths
* Expand postprocessing capabilities -->

NOTE: this is a beta version of AUTO-07p.
It is already usable, but some of the demos and the manual
in particular need more work.
Please have a look at the manual, doc/auto.pdf,
in particular Chapter 1, for information about
requirements and differences with earlier versions
of AUTO. See the file CHANGELOG for changes between
sub-versions of AUTO-07p.

---------
For installation instructions see the AUTO manual.  
The LaTeX source file of the manual is in doc/auto.tex. 

Note that you must define the correct path to the
AUTO directory in your (.bashrc) resource file.

This version of AUTO incorporates both a Unix and 
a Python command language user interface (CLUI).

This directory contains the following files:

README    : This file.
autlib1.f : Auto library routines (including main program)
autlib2.f : Auto library routines (bvp linear equation routines)
autlib3.f : Auto library routines (interface routines)
autlib4.f : Auto library routines (Floquet routines)
autlib5.f : Auto library routines (HomPack)
stdat.f   : A subroutine for starting orbits from numerical data
eispack.f : contains EISPACK routines needed by AUTO
autlab.f  : A utility program for rewriting AUTO data files
86to97.f  : A utility program to convert AUTO86 Data-files 
94to97.f  : A utility program to convert older AUTO94 Data-files 
double.f  : A utility program for ``doubling'' solutions in q.xxx
Makefile  : To compile the source files

Type "make" to compile.

This directory contains the following:

README : this file.
auto97.c : the Graphic User Interface(GUI) source code of AUTO97.
c.aut : the default AUTO-constants file.
aut.f : the default AUTO-equations file.
Makefile.in : GUI makefile input file.
auto.makefile.in : makefile used by the GUI at run time.
Makefile : parsed copy of Makefile.in.
auto.makefile : parsed copy of auto.makefile.in.
==============================================================

Type "make" to compile PLAUT.
Type "make clean" to remove unnecessary files after compilation.
===============================================================
Known Problems :

 - The s-file orbit is not plotted correctly if, for example, the
   first two lines of the data set look like :

     1   20    9    3    4    1   41    5   87   10    4
       0.0000000000E+00 -1.0483288692E-26 -3.8282567843E-16  1.5654469197E+00  1.5654469197E+00
                                     ====


 - Axes labelling algorithm does not always work properly.

 - One should be able to select "A" ("all") after typing 2D while 
   one is already in the 2D mode.

This directory contains auto.tex: the AUTO user manual TeX file.

Type ``make'' to create auto.ps, the PostScript form of the manual.

The file auto.ps is used by the GUI and by the @mn command for 
the display of the on-line manual.

Type "auto selec.auto" to run a selection of demos.

The results are then compared to the results of
runs on other machines. Such results may already be in files
in the current directory. Apart from the listed CPU time, 
there should be no significant differences between *_log07p and
hyper.all.
In case of suspected portability problems send the file *_log07p
to doedel@cs.concordia.ca and bartoldeman@gmail.com.

If the test fails completely (no AUTO output at all) then you
may have a Unix-related problem. First try to run a demo, e.g. ``ab''
in a clean directory (see the manual for details). If this demo
does not give results either then you may want to consult a system's 
analyst.
===================================================================
To run all runs of all demos, type "auto all.auto"
In this very comprehensive test it is likely that some demos will
give somewhat different results on different machines. This is to
be expected for very sensitive calculations performed on machines
of different architecture. 
===================================================================
To run a selection of HomCont demos only, type "auto hom.auto"
===================================================================
To run all demos that were also present in AUTO97, type 
"auto all97.auto"
===================================================================
To run some specified demos, type for instance
"auto demo.auto abc dd2"
===================================================================
To run the Python regression tests, run
"auto python.auto"
===================================================================

           Computation of Periodic Solutions of the CR3BP
           ----------------------------------------------

 Running the Python script r3b.auto will generate the families of periodic 
 solutions L1, H1, and V1, for the case of the mass-ratio mu=0.063 :

 	auto r3b.auto			| auto('r3b.auto')

 where as in the following examples, the left hand side command can be used
 at the shell prompt, and the right hand side command at the Python CLUI
 prompt. Note that the commands starting with @ work in both interfaces,
 but cannot be used in the expert scripts with a .py suffix.

 For example, the data generated for the Lyapunov family L1 will consist of

	b.L1	-  the bifurcation diagram data
	s.L1	-  a selection of periodic orbits
	d.L1	-  diagnostic data, including Floquet multipliers

 The necessary labeled starting solutions are first computed and stored
 in the file s.start. Each starting solution is an equilibrium ("libration
 point"), and its data also contains the period of a bifurcating family of
 periodic orbits.
 The Table below shows the label of each of the starting solutions in 
 s.start, indicating which libration point it corresponds to, and which 
 family of periodic orbits it will generate:

		Label	Libration Pt.	Family
		  1	    L1		  L1
	  	  2         L1		  V1
	  	  3         L2		  L2
	  	  4         L2		  V2
	  	  5         L3		  L3
	  	  6         L3		  V3
	  	  7         L4		  V4
	  	  8         L5		  V5

 Note (by looking at the constant-files c.r3b.*) that actually only the 
 starting solutions labeled 1 and 2 are used in the current calculations, 
 as executed by the Python script.

 Starting solution for other values of mu can be generated using the script
 compute_lps.py, for instance by running

	autox compute_lps.py 0.05	| import compute_lps
					| compute_lps.compute(0.05)

 After that, it is necessary to run r3b.auto again to regenerate the
 families.

 The demos L1a, H1a, H1b, H1c, V1a, V1b can be run subsequent to the r3b
 demo to compute 2D unstable manifolds of selected periodic orbits that
 belong to the L1, V1, and H1 families.


    Computing Unstable Manifolds of Periodic Orbits in the CR3BP
    ------------------------------------------------------------

 Instructions for computing 2-d unstable manifolds of periodic orbits 
 in the Circular Restricted 3-Body Problem (CR3BP) using AUTO-07p. 

 The instructions below are for the Halo family L1 in AUTO demo L1a.
 ===================================================================

 Instructions for computing 2-d unstable manifolds of other periodic 
 orbits in the CR3BP are similar (Demos H1a, H1b, H1c, V1a, V1b), and
 are given after these instructions.

 Select a labeled solution which has exactly one Floquet multiplier with
 absolute value greater than 1. (Floquet multipliers can be found in the file
 d.L1 generated by demo r3b.) Enter the label of the periodic solution
 in the file L1a.auto at label= in L1a.auto. Also enter the size of the
 initial step into the direction of the unstable manifold there at step=
 Note that representative values of these three quantities have already
 been entered there.
 Now run the Python script L1a.auto:

	auto L1a.auto			| auto('L1a.auto')

 This will run r3b.auto as above if this was not already done.

 Through various computational steps the execution of the Python script
 will result in AUTO files b.L1a, s.L1a, and d.L1a, where the orbits in 
 s.L1a constitute the manifold, which can be viewed with the graphics 
 program plaut04 or r3bplaut04 :

	@pl L1a or             @r3b L1a | plot3('L1a',r3b=True)

 The various steps executed by the Python commands in the script file
 L1a.auto are explained below, however, showing instead the equivalent 
 Linux versions of these AUTO commands.

 The Python script L1aX.auto in L1a does the same as L1a.auto, but with 
 additional calculations that generate additional AUTO data files, e.g., 
 to detect heteroclinic connections. Some of these additional runs take 
 quite a bit of CPU time and generate big data files.
----------------------------------------------------------------------------
----------------------------------------------------------------------------

               Detailed AUTO shell and Python commands for the L1a demo.
               ---------------------------------------------------------

mkdir r3b		| mkdir r3b
cd r3b			| cd r3b
@dm r3b			| demo('r3b')

		Copy the r3b demo to the local directory r3b.

auto r3b.auto		| auto('r3b.auto')

		Generate the CR3BP AUTO data files.

autox ext.py L1 3 -1e-5 | import ext
			| sext=ext.get('L1',3,-1e-5)

		Convert the data for a selected labeled solution from s.L1, 
		adding a zero adjoint variable. The solution label is 3,
                and the initial step size into the unstable manifold is -1e-5.
		The ext.py script looks for the relevant Floquet multiplier in
		d.L1. The converted solution will be written in the file s.ext
		or stored in sext.

@r flq ext		| flq=run(sext,c='flq',e='flq')

		Compute the Floquet eigenfunction. Free scalar variables in
		this run (see c.flq) are: 

		PAR(1) = unfolding parameter 
		PAR(4) = multiplier
		PAR(5) = norm of eigenfunction

		If this run is successful then PAR(5) should become nonzero,
		in fact, PAR(5) should reach the value 1.  If the run is 
		not successful then see REMARK 1 below.

@sv flq			| save(flq,'flq')

		Save the results in b.flq, s.flq, and d.flq .

autox data.py		| import data
			| startman=data.get(flq('UZ1'))

		Extract data for a selected orbit from s.flq. These data 
		are for both the orbit and its Floquet eigenfunction. It 
		is assumed that s.flq contains only one labeled solution, 
		with label 2. If you did the "optional" computation (see 
		Remark 2) then you may need to change the label of the 
		restart solution:
                   autox data.py flq n		| startman=data.get(flq(n))
		where n is the different label number.
                The extracted data may be saved in a file called s.startman,
                which contains a new starting solution that can be used as
		a base for the manifold computations.
                The orbit coordinates are at "time zero", and the Floquet
		eigenfunction are saved at PAR(25:30) and PAR(31:36),
		respectively.

@R man L1a.0 startman | startL1a = run(startman,e='man',c='man.L1a.0')

                This step does a time integration using continuation in the
                "period" T, i.e., PAR(11), which here is the "integration
                time". The labeled solutions from this run all correspond
                to the same orbit, except that the orbit gets longer and
                longer. The starting point of the orbit is the point on the
                periodic orbit at "time zero" plus a small distance (epsilon)
                into the direction of the unstable manifold. In AUTO, epsilon
                corresponds to PAR(6). This parameter epsilon is initialized
                in the file flq.dat . (The sign of epsilon is significant!)
                The parameters in this run (see c.man.L1a.0) are:

		PAR(3)  = energy
		PAR(11) = integration time
		PAR(12) = length of the orbit
		PAR(21) = x-coord at end point
		PAR(22) = y-coord at end point
		PAR(23) = z-coord at end point

@sv startL1a		| save(startL1a,'startL1a')

		Save the results in b.startL1a, s.startL1a, and d.startL1a . (*)

@R man L1a.1 startL1a	| L1a=run(startL1a,c='man.L1a.1')

		Look at c.man.L1a.1 to see from which label in s.startL1a this
		run starts. In this run the y-coordinate of the end point 
		(PAR(22)) is kept fixed, while the "period" (PAR(11)), 
		i.e., the total integration time, is allowed to vary, as 
		is the value of epsilon, i.e., PAR(6). Note that if PAR(6) 
		becomes "large" then the manifold may no longer be accurate.
		The free parameters in this run are:

		PAR(3)  = energy
		PAR(6)  = "starting distance"
		PAR(11) = integration time
		PAR(12) = length of the orbit
		PAR(21) = x-coord at end point
		PAR(23) = z-coord at end point

@sv L1a			| save(L1a,'L1a')

		Save the results in b.L1a, s.L1a, and d.L1a .

@R man L1a.2 startL1a	| L1a2=run(startL1a,c='man.L1a.2')

		Another run, starting from a longer initial orbit, which 
		computes part of the manifold. The free parameters are the 
		same as in the preceding run. This computation results in 
		the orbit winding around the selected periodic L1 orbit.

@sv L1a2 		| save(L1a2,'L1a2')

		Save the results in b.L1a2, s.L1a2, and d.L1a2 .

----------------------------------------------------------------------------
----------------------------------------------------------------------------

Use

auto clean.auto		| auto('clean.auto')

to remove all generated files.

----------------------------------------------------------------------------
----------------------------------------------------------------------------
----------------------------REMARK 1----------------------------------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
 If the run to compute the Floquet eigenfunction is not successful, i.e., if 
 PAR(5) does not become nonzero, then try to compute the Floquet eigenfunction
 in more stages, as follows:
 
		Give the label of the selected solution, and a value that 
		is smaller than the associated Floquet multiplier (magnitude
		greater than 1) .

autox ext.py L1 3 -1e-5 2000 | import ext
			     | sext=ext.get('L1',3,-1e-5,2000)
@R flq 2 ext		     | flq=run(sext,c='flq.2',e='flq')

		Continue the approximate multiplier; If all goes well then 
		the actual multiplier will be detected as a branch point 
		(BP) with Label 2. Free scalar variables in this run are: 

		PAR(1) = unfolding parameter 
		PAR(4) = multiplier
		PAR(5) = norm of eigenfunction

@sv flq			     | save(flq,'flq')
@R flq 3		     | flq=run(flq,e='flq',c='flq.3')

		Switch branches at the BP, thereby generating the nonzero 
		Floquet eigenfunction. The free scalar variables are : 

		PAR(1) = unfolding parameter 
		PAR(4) = multiplier
		PAR(5) = norm of eigenfunction

		If all goes well then PAR(5) should become nonzero, and the
		corresponding solution should have Label 4.

@sv flq			     | save(flq,'flq')
----------------------------------------------------------------------------
----------------------------------------------------------------------------
----------------------------REMARK 2----------------------------------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
 One can also follow the orbit, its multiplier and eigenfunction, as follows:

@R flq 4		     | flq=run(flq,e='flq',c='flq.3')

		Free scalar variables in this run are

		PAR(1)  = unfolding parameter 
		PAR(4)  = multiplier
		PAR(11) = period

		The norm, PAR(5), of the eigenfunction is fixed in this run.

@sv flq			     | save(flq,'flq')
----------------------------------------------------------------------------
----------------------------------------------------------------------------

 The instructions below are for the Halo family H1 in AUTO demo H1a.
 ===================================================================

 Follow the instructions for L1a above, where you replace L by H throughout,
 for instance you can run everything in one go using

	auto H1a.auto			| auto('H1a.auto')

 or with the extra calculations:

	auto H1aX.auto			| auto('H1aX.auto')

 The Floquet eigenfunction is now computed from label 7 with step size -1e-3.

 The detailed commands are likewise, except for the manifold calculations
 following (*) (at @sv startL1a):

@R man H1a.1 startH1a	| H1a=run(startH1a,e='man',c='man.H1a.1')

		Look at c.man.H1a.1 to see from which label in s.startH1a this
		run starts. In this run the x-coordinate of the end point 
		(PAR(21)) is kept fixed, while the "period" (PAR(11)), 
		i.e., the total integration time, is allowed to vary, as 
		is the value of epsilon, i.e., PAR(6). Note that if PAR(6) 
		becomes "large" then the manifold may no longer be accurate.
		The free parameters in this run are:

		PAR(3)  = energy
		PAR(6)  = "starting distance"
		PAR(11) = integration time
		PAR(12) = length of the orbit
		PAR(22) = y-coord at end point
		PAR(23) = z-coord at end point

@sv H1a			| save(H1a,'H1a')

		Save the results in b.H1a, s.H1a, and d.H1a .

@R man H1a.2 startH1a	| hetH1a=run(startH1a,e='man',c='man.H1a.2')

		Another run, starting from a longer initial orbit, which 
		computes part of the manifold. The free parameters are the 
		same as in the preceding run. This computation results in 
		the detection of a connecting orbit.

@sv hetH1a 		| save(hetH1a,'hetH1a')

		Save the results in b.hetH1a, s.hetH1a, and d.hetH1a .
----------------------------------------------------------------------------
----------------------------------------------------------------------------

 The instructions below are for the Halo family H1 in AUTO demo H1b.
 ===================================================================

 Follow the instructions for L1a above, where you replace L by H, and a by b
 throughout; for instance you can run everything in one go using

	auto H1b.auto			| auto('H1b.auto')

 or with the extra calculations:

	auto H1bX.auto			| auto('H1bX.auto')

 The Floquet eigenfunction is now computed from label 3 with step size -1e-5.

 The detailed commands follow the ones for H1a above, except that there
 is one extra run:

@R man H1b.3 startH1b	| het2H1b=run(startH1b,e='man',c='man.H1b.3')

		Another run, starting from a longer initial orbit, which 
		computes part of the manifold. The free parameters are the 
		same as in the preceding run. This computation results in 
		the detection of another connecting orbit.

@sv het2H1b	    	| save(het2H1b,'het2H1b')

		Save the results in b.het2H1b, s.het2H1b, and d.het2H1b .
----------------------------------------------------------------------------
----------------------------------------------------------------------------

 The instructions below are for the Halo family H1 in AUTO demo H1c.
 ===================================================================

 Follow the instructions for L1a above, where you replace L by H, and a by c
 throughout; for instance you can run everything in one go using

	auto H1c.auto			| auto('H1c.auto')

 The Floquet eigenfunction is now computed from label 68 with step size -1e-2.

 The detailed commands follow the ones for H1a above, except that the last
 run is left out, and so the H1cX.auto script is not necessary.

----------------------------------------------------------------------------
----------------------------------------------------------------------------

 The instructions below are for the Halo family V1 in AUTO demo V1a.
 ===================================================================

 Follow the instructions for L1a above, where you replace L by V throughout,
 for instance you can run everything in one go using

	auto V1a.auto			| auto('V1a.auto')

 The Floquet eigenfunction is now computed from label 8 with step size -1e-5.

 The detailed commands are likewise, except for the manifold calculations
 following (*) (at @sv startL1a):

@R man V1a.1 startV1a	| V1a=run(startV1a,e='man',c='man.V1a.1')

		Look at c.man.V1a.1 to see from which label in s.startV1a this
		run starts. In this run the z-coordinate of the end point 
		(PAR(23)) is kept fixed, while the "period" (PAR(11)), 
		i.e., the total integration time, is allowed to vary, as 
		is the value of epsilon, i.e., PAR(6). Note that if PAR(6) 
		becomes "large" then the manifold may no longer be accurate.
		The free parameters in this run are:

		PAR(3)  = energy
		PAR(6)  = "starting distance"
		PAR(11) = integration time
		PAR(12) = length of the orbit
		PAR(21) = x-coord at end point
		PAR(22) = y-coord at end point

@sv V1a			| save(V1a,'V1a')

		Save the results in b.V1a, s.V1a, and d.V1a .
----------------------------------------------------------------------------
----------------------------------------------------------------------------

 The instructions below are for the Halo family V1 in AUTO demo V1b.
 ===================================================================

 Follow the instructions for L1a above, where you replace L by V, and a by b
 throughout; for instance you can run everything in one go using

	auto V1b.auto			| auto('V1b.auto')

 or with the extra calculations:

	auto V1bX.auto			| auto('V1bX.auto')

 The Floquet eigenfunction is now computed from label 12 with step size 1e-5.

 The detailed commands are likewise, except for the manifold calculations
 following (*) (at @sv startL1a):

@R man V1b.1 startV1b	| V1b=run(startV1b,e='man',c='man.V1b.1')

		Look at c.man.V1b.1 to see from which label in s.startV1b this
		run starts. In this run the x-coordinate of the end point 
		(PAR(21)) is kept fixed, while the "period" (PAR(11)), 
		i.e., the total integration time, is allowed to vary, as 
		is the value of epsilon, i.e., PAR(6). Note that if PAR(6) 
		becomes "large" then the manifold may no longer be accurate.
		The free parameters in this run are:

		PAR(3)  = energy
		PAR(6)  = "starting distance"
		PAR(11) = integration time
		PAR(12) = length of the orbit
		PAR(22) = y-coord at end point
		PAR(23) = z-coord at end point

@sv V1b			| save(V1b,'V1b')

		Save the results in b.V1b, s.V1b, and d.V1b .

@R man V1b.2 startV1b	| hetV1b=run(startV1b,e='man',c='man.V1b.2')

		Another run, starting from a longer initial orbit, which 
		computes part of the manifold. The free parameters are the 
		same as in the preceding run. This computation results in 
		the detection of a connecting orbit.

@sv hetV1b		| save(hetV1b,'hetV1b')

		Save the results in b.hetV1b, s.hetV1b, and d.hetV1b .
----------------------------------------------------------------------------
----------------------------------------------------------------------------

This directory contains example scripts for computing period
solutions to the N-body problem.  

3d.c:  This file contains the equations for the circular restricted
       3-body problem in a rotating frame.   

c.3d:  This is the basic AUTO constants file which is read in
       and modified by all of the scripts.

There are two "basic" AUTO command line user interface scripts.
Basic AUTO CLUI script are run by typing:

auto scriptname

Basic AUTO CLUI scripts always end with the suffix ".auto",
and they provide access to most, but not all, Python
syntax.  The also allow the use of non-standard 
Python syntax such as 'cd /tmp'.


In addition, there are two "expert" AUTO CLUI scripts.  Expert AUTO
CLUI script are run by typing:

autox scriptname

Expert AUTO CLUI scripts always end with the suffix ".autox".
Expert AUTO CLUI scripts provide access to the full capabilities of
the Python language, at the expense of a slightly more cumbersome
syntax.  For example, the non-standard Python syntax 'cd /tmp'
is not allowed, and must be replaced with 'cd ('/tmp')'.  Also,
the AUTO CLUI libraries must be explicitly included 
using the command 'from AUTOclui import *'.

------------------------------------------------------------

compute_lagrange_points_family.auto:

	This is a basic script which computes and plots all of the
	lagrange points as a function of the ratio of the masses of
	the two planets.

compute_lagrange_points_0.5.auto:

	This is a basic script which computes all of the lagrange
	points for the case where the masses of the two planets are
	equal, and saves the data.  This script is used to compute
	starting data for the compute_periodic_family.xauto script.

compute_periodic_family.xauto:

	NOTE: This script depends on the results of the 
	compute_lagrange_points_0.5.auto script, so that
	script must be run before this script is used.

	This is an expert script which starts at a lagrange
	point computed by compute_lagrange_points_0.5.auto
	and continues in the ratio of the masses until
	a specified mass ratio is reached.  It then computes
	a family of periodic orbits for each pair of
	purely complex eigenvalues.  Finally, for each bifurcation
	point detected on the primary branch a bifurcating
	branch is also computed.  E.g. the command
	
	autox compute_periodic_family.xauto l1 0.0123

	computes families of periodic orbits emanating from l1
	for mass ratio 0.0123.

        To run the same problem with branch switching do:

        autox -- compute_periodic_family.xauto -b l1 0.0123

to_matlab.xauto: 

	This script takes a set of AUTO data files and creates
	a set of files formatted for importing into Matlab
	for either plotting or further calculations.
	E.g. the command

	autox to_matlab.xauto foo bar

	will take the solution file 's.foo' and bifurcation diagram
	file 'b.foo' and create the following files:

	'bar_bifur'       :  This files contains the bifurcation diagram
			     from 'b.foo'

	'bar_solution_??' :  These files each contain one solution from
			     the file 's.foo'.  The '??' is replaced
			     with the solution label number.

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   ext :    Spurious solutions to a boundary value problem
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION P,S,PI,Q

       P= U(1) + U(1)**2 + U(1)**3
       S=SIN(P)
       PI=4*ATAN(1.d0)
       Q=(PAR(1)*PI)**2

       F(1)=U(2)
       F(2)=-Q*S

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0.d0

       U(1)=0.d0
       U(2)=0.d0

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

       FB(1)=U0(1)
       FB(2)=U1(1)

      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   stw :         Sharp traveling waves
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
! Parameter assignment: ( Components of PAR(.) )
!
!      PAR :             (1)  : homotopy parameter
!                   (2)  (3)  : A0, A1, A2      (problem parameters)
!              (4)  (5)  (6)  : B0, B1, B2      (problem parameters)
!              (7)  (8)  (9)  : C0, C1, C2      (problem parameters)
!                       (10)  :         c       (wave speed)
!                       (11)  :         T       (period)
!                  (12) (13)  : eps-0, eps-1    (radii)
!                  (14) (15)  : mu-0 , mu-1     (eigenvalues)
!                  (16) (17)  : v-0(1), v-0(2)  (eigenvector)
!                  (18) (19)  : v-1(1), v-1(2)  (eigenvector)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION PERIOD

       PERIOD=PAR(11)
       CALL FFFF(NDIM,U,ICP,PAR,IJAC,F,DFDU)
       F(1)=PERIOD*F(1)
       F(2)=PERIOD*F(2)

      END SUBROUTINE FUNC

      SUBROUTINE FFFF(NDIM,U,ICP,PAR,IJAC,F,DFDU)
!     ---------- ----
!
! The reduced system for traveling waves is defined here. A separate subroutine 
! is used because the system and the Jacobian are also needed in the subroutines
! BCND and ICND below. The computation should be done with JAC=0. The derivatives
! below are for use in BCND and ICND only. 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM)

      DOUBLE PRECISION FA,FB,FC,C,DFA,DFB,DFC,P(2:9)

! A0, A1, A2:
       P(2)= (1-PAR(1))* 2   + PAR(1)* 2
       P(3)= (1-PAR(1))* 0   + PAR(1)* 1

! B0, B1, B2:
       P(4)= (1-PAR(1))* 2   + PAR(1)* 0
       P(5)= (1-PAR(1))* 0   + PAR(1)* 1
       P(6)= (1-PAR(1))* 0   + PAR(1)* 0

! C0, C1, C2:
       P(7)= (1-PAR(1))* 0   + PAR(1)* 0
       P(8)= (1-PAR(1))* 1   + PAR(1)* 1
       P(9)= (1-PAR(1))*(-1) + PAR(1)*(-1)

      FA     =        P(2)*U(1) + P(3)*U(1)**2
      FB     = P(4) + P(5)*U(1) + P(6)*U(1)**2
      FC     = P(7) + P(8)*U(1) + P(9)*U(1)**2

      C      = PAR(10)

       F(1)= FA * U(2)
       F(2)= -C * U(2)  -  FB * U(2)**2  -  FC

      IF(IJAC.EQ.0)RETURN

      DFA    = P(2) + 2*P(3)*U(1)
      DFB    = P(5) + 2*P(6)*U(1)
      DFC    = P(8) + 2*P(9)*U(1)

       DFDU(1,1)= DFA*U(2)
       DFDU(1,2)= FA

       DFDU(2,1)= -DFB*U(2)**2 - DFC
       DFDU(2,2)= -C - 2*FB*U(2)

      END SUBROUTINE FFFF

      SUBROUTINE STPNT(NDIM,U,PAR,T) 
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION PERIOD, TSC, E

! homotopy parameter :
       PAR(1)= 0

! starting period
       PERIOD=100.

! c, T:
       PAR(10)= 1
       PAR(11)= PERIOD

! eps-0, eps-1:
       PAR(12)= 0.5*DSQRT(5.D0)/(1+EXP(0.5*PERIOD))
       PAR(13)= PAR(12)

!  mu-0,  mu-1:
       PAR(14)= 1
       PAR(15)= -1

! v-0(1), v-0(2):
       PAR(16)= 2/DSQRT(5.D0)
       PAR(17)= 1/DSQRT(5.D0)

! v-1(1), v-1(2):
       PAR(18)= 1
       PAR(19)= 0

! Exact solution
       TSC=PERIOD*(T-0.5)
       E=EXP(TSC)
       U(1)=1/(1+E)
       U(2)=-0.5*E/(1+E)

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
! Local
      DOUBLE PRECISION V0(2),V1(2),G0(2),G1(2),DGDU0(2,2),DGDU1(2,2)

      V0(1)=U0(1) - PAR(12)*PAR(16)
      V0(2)=U0(2) - PAR(12)*PAR(17)
      V1(1)=U1(1) - PAR(13)*PAR(18)
      V1(2)=U1(2) - PAR(13)*PAR(19)

      CALL FFFF(NDIM,V0,ICP,PAR,1,G0,DGDU0)
      CALL FFFF(NDIM,V1,ICP,PAR,1,G1,DGDU1)

! Define eigenvalues and eigenvectors at t=0:
      FB(1)= DGDU0(1,1)*PAR(16) + DGDU0(1,2)*PAR(17) - PAR(14)*PAR(16)
      FB(2)= DGDU0(2,1)*PAR(16) + DGDU0(2,2)*PAR(17) - PAR(14)*PAR(17)

! Define eigenvalues and eigenvectors at t=1:
      FB(3)= DGDU1(1,1)*PAR(18) + DGDU1(1,2)*PAR(19) - PAR(15)*PAR(18)
      FB(4)= DGDU1(2,1)*PAR(18) + DGDU1(2,2)*PAR(19) - PAR(15)*PAR(19)

! Normalize the eigenvectors:
      FB(5)= PAR(16)**2 + PAR(17)**2 -1
      FB(6)= PAR(18)**2 + PAR(19)**2 -1

! Boundary condition at t=0:
      FB(7)= G0(1)
      FB(8)= G0(2)

! Boundary condition at t=1:
      FB(9)= G1(1)
      FB(10)=G1(2)

      END SUBROUTINE BCND

      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!     ---------- ----

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)
! Local
      DOUBLE PRECISION DFDU(2,2),F(2),F0(2),DGDU0(1)

      CALL FFFF(NDIM,U   ,ICP,PAR,1,F ,DFDU )
      CALL FFFF(NDIM,UOLD,ICP,PAR,0,F0,DGDU0)

! The integral phase condition is defined here:
       FI(1)= ( F(1) - F0(1) ) * ( DFDU(1,1)*F(1) + DFDU(1,2)*F(2) ) &
            + ( F(2) - F0(2) ) * ( DFDU(2,1)*F(1) + DFDU(2,2)*F(2) )

      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   Henon :    The Henon map
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION x, y, alpha, beta

      x=U(1)
      y=U(2)
      alpha=PAR(1)
      beta=PAR(2)

       F(1)=y
       F(2)=alpha-beta*x-y**2

      IF(IJAC.EQ.0)RETURN 

       DFDU(1,1)=0
       DFDU(1,2)=1
       DFDU(2,1)=-beta
       DFDU(2,2)=-2*y

      IF(IJAC.EQ.1)RETURN 

       DFDP(1,1)=0
       DFDP(1,2)=0
       DFDP(2,1)=1 
       DFDP(2,2)=-x

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=2 ! alpha
       PAR(2)=0 ! beta

       U(1)=1
       U(2)=1

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   1cl :    A one-cell, two-substrate enzyme model 
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION S,A,S0,A0,AL,RH,RK,D,R,DRDS,DRDA,DRDK

       S=U(1)
       A=U(2)

       S0=PAR(1)
       A0=PAR(2)
       AL=PAR(3)
       RH=PAR(4)
       RK=PAR(5)

       D=1+S+RK*S**2
       R=S*A/D

       F(1)=   (S0-S) - RH*R
       F(2)=AL*(A0-A) - RH*R

       IF(IJAC.EQ.0)RETURN

       DRDS=( A*D - S*A*(1+2*RK*S) ) / D**2
       DRDA=S/D
       DRDK=-S**3*A/D**2

       DFDU(1,1)=-1 - RH*DRDS
       DFDU(1,2)=   - RH*DRDA
       DFDU(2,1)=   - RH*DRDS
       DFDU(2,2)=-AL- RH*DRDA

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives

       DFDP(1,1)=1
       DFDP(1,2)=0
       DFDP(1,3)=0
       DFDP(1,4)=-R
       DFDP(1,5)=-RH*DRDK

       DFDP(2,1)=0
       DFDP(2,2)=AL
       DFDP(2,3)=A0-A
       DFDP(2,4)=-R
       DFDP(2,5)=-RH*DRDK

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=110.
       PAR(2)=500.
       PAR(3)=0.2
       PAR(4)=2.021628
       PAR(5)=0.1

       U(1)=4.555974E+01
       U(2)=1.777987E+02

      END SUBROUTINE STPNT

      SUBROUTINE BCND
      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   kar :       The Von Karman swirling flow
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION U1,U2,U3,U4,U5,GAMMA,ZINF

       U1=U(1)
       U2=U(2)
       U3=U(3)
       U4=U(4)
       U5=U(5)

       GAMMA=PAR(1)
       ZINF =PAR(3)

       F(1)=ZINF*U2
       F(2)=ZINF*U3
       F(3)=ZINF*( - 2*GAMMA*U4 + U2*U2 - 2*U1*U3 - U4*U4)
       F(4)=ZINF*U5
       F(5)=ZINF*(2*GAMMA*U2 + 2*U2*U4 - 2*U1*U5)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION GAMMA,FINF,ZINF

       GAMMA=1.
       FINF =0.
       ZINF =500.

       PAR(1)=GAMMA 
       PAR(2)=-FINF
       PAR(3)=ZINF

       U(1)=0.
       U(2)=0.
       U(3)=0.
       U(4)=0.
       U(5)=0.

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

      DOUBLE PRECISION GAMMA,FINF,C,A,B

       GAMMA=PAR(1)
       FINF=-PAR(2)

       C=SQRT(FINF**4 + 4*GAMMA**2)
       A=SQRT(C + FINF**2) / SQRT(2.d0)
       B=SQRT(C - FINF**2) / SQRT(2.d0)

       F(1)=U0(1)
       F(2)=U0(2)
       F(3)=U0(4)-1+GAMMA
       F(4)=(FINF+A)*U1(2) + U1(3) - GAMMA*U1(4)/A
       F(5)=A*B**2*U1(2)/GAMMA + (FINF+A)*U1(4) + U1(5)
       F(6)=U1(1)-FINF

      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   int :    An ODE with boundary and integral constraints
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION E

       E=EXP(U(1)) 
       F(1)=U(2) 
       F(2)=-PAR(1)*E 

      IF(IJAC.EQ.0)RETURN 

       DFDU(1,1)=0.0 
       DFDU(1,2)=1 
       DFDU(2,1)=-PAR(1)*E 
       DFDU(2,2)=0.0 

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DFDP(1,1)=0.0 
       DFDP(2,1)=-E 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T) 
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0
       PAR(2)=0
       PAR(3)=0

       U(1)=0.0 
       U(2)=0.0 

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

       FB(1)=U0(1)-U1(1)-PAR(2) 

      IF(IJAC.EQ.0)RETURN 

       DBC(1,1)=1.0 
       DBC(1,2)=0.0 

       DBC(1,3)=-1.0 
       DBC(1,4)=0.0 

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DBC(1,5)=0.0 
       DBC(1,6)=-1.0 
       DBC(1,7)=0.0 

      END SUBROUTINE BCND

      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

       FI(1)=U(1)-PAR(3) 

      IF(IJAC.EQ.0)RETURN 

       DINT(1,1)=1.0 
       DINT(1,2)=0.0 

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DINT(1,3)=0.0 
       DINT(1,4)=0.0 
       DINT(1,5)=-1.0 

      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!----------------------------------------------------------------------
!     brc  :  A parabolic PDE (the Brusselator)
!---------------------------------------------------------------------- 
!----------------------------------------------------------------------
! (Discretized in space by polynomial collocation at Chebyshev points)
!---------------------------------------------------------------------- 
!----------------------------------------------------------------------
! NOTE: The value of the constant NE is defined in the module brc below.
!
!      NE  :  the dimension of the PDE system
!
!      NN  :  the number of Chebyshev collocation points in space is
!             determined by the AUTO-constant NDIM:
!             NN = NDIM/NE
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      MODULE brc
        SAVE
        INTEGER, PARAMETER :: NE=2
        DOUBLE PRECISION, ALLOCATABLE :: D2(:,:)
      END MODULE brc

      SUBROUTINE FF(NE,U,PAR,F) 
!     ---------- -- 
!     Define the nonlinear term

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NE
      DOUBLE PRECISION, INTENT(IN) :: U(NE),PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NE)

      DOUBLE PRECISION X,Y,A,B

        X=U(1)
        Y=U(2)
        A=PAR(1)
        B=PAR(2)

        F(1)= X**2*Y - (B+1)*X + A
        F(2)=-X**2*Y + B*X

      END SUBROUTINE FF

      SUBROUTINE SETDC(NE,DC,PAR) 
!     ---------- ----- 
!     Set the diffusion constants (constant, or in terms of PAR)

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NE
      DOUBLE PRECISION, INTENT(OUT) :: DC(NE)
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)

        DC(1)=PAR(3)/PAR(5)**2
        DC(2)=PAR(4)/PAR(5)**2

      END SUBROUTINE SETDC

      SUBROUTINE SETBC(NE,PAR,U0,U1) 
!     ---------- ----- 
! Set the boundary values (to be kept fixed in time)

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NE
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: U0(NE),U1(NE)

      DOUBLE PRECISION A,B

        A=PAR(1)
        B=PAR(2)

        U0(1)=A
        U0(2)=B/A
        U1(1)=A
        U1(2)=B/A

      END SUBROUTINE SETBC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 
! Define the starting stationary solution on the spatial mesh

      USE brc
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM/NE,NE),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      INTEGER I,NN
      DOUBLE PRECISION A,B,Dx,Dy,RL

! Set the parameter values
        A=2.d0
        B=5.45d0
        Dx=0.008d0
        Dy=0.004d0
        RL=0.4

        PAR(1)=A
        PAR(2)=B
        PAR(3)=Dx
        PAR(4)=Dy
        PAR(5)=RL

! Set the starting solution at the Chebyshev collocation points
        NN=NDIM/NE
        DO I=1,NN
          U(I,1)=A
          U(I,2)=B/A
        ENDDO

      END SUBROUTINE STPNT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!                Problem-independent subroutines
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      USE brc
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM/NE,NE), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM/NE,NE)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION W(NE),FW(NE),DC(NE),U0(NE),U1(NE)
      INTEGER I,J,K,NN,NP

! Problem-independent initialization :
        NN=NDIM/NE
        NP=NN+1

        CALL SETDC(NE,DC,PAR)
        CALL SETBC(NE,PAR,U0,U1)

        DO I=1,NN
          DO K=1,NE
            W(K)=U(I,K)
          ENDDO
          CALL FF(NE,W,PAR,FW)
          DO J=1,NE
            F(I,J)=FW(J) + DC(J)*(U0(J)*D2(I,0)+U1(J)*D2(I,NP))
            DO K=1,NN
              F(I,J)=F(I,J)+DC(J)*D2(I,K)*U(K,J)
            ENDDO
          ENDDO
        ENDDO

      END SUBROUTINE FUNC

      SUBROUTINE GENCF(PAR,NN)
!     ---------- -----

      USE brc
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NN
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)

      DOUBLE PRECISION, ALLOCATABLE :: X(:),XX(:,:),CC(:,:),RI(:,:)
      INTEGER, ALLOCATABLE :: IR(:),IC(:)

      DOUBLE PRECISION pi,C,DET
      INTEGER I,J,K,M,NP

        NP=NN+1
        M=NN+2
        ALLOCATE(D2(NN,0:NP))
        ALLOCATE(X(M),XX(M,M),CC(M,0:NP),RI(M,M),IR(M),IC(M))

        pi=4*ATAN(1.d0)
        X(1)=0.d0
        DO K=2,NP
          C=COS( (2*K-3)*pi/(2*NN) )
          X(K)=(1+C)/2
        ENDDO
        X(M)=1.d0

        DO I=1,M
          DO J=1,M
            RI(I,J)=0.d0
            XX(I,J)=X(I)**(J-1)
          ENDDO
          RI(I,I)=1.d0
        ENDDO

        CALL GE(0,M,M,XX,M,M,CC,M,RI,IR,IC,DET) 

        DO I=1,NN
          DO J=0,NP
            D2(I,J)=0.d0
            DO K=2,M-1
              D2(I,J)=D2(I,J)+CC(K+1,J)*K*(K-1)*X(I+1)**(K-2)
            ENDDO
          ENDDO
        ENDDO
        DEALLOCATE(X,XX,CC,RI,IR,IC)

      END SUBROUTINE GENCF

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      USE brc
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      LOGICAL, SAVE :: ifrst = .TRUE.

! Problem-independent initialization :
      IF(ifrst)THEN
         CALL GENCF(PAR,NDIM/NE)
         ifrst=.FALSE.
      ENDIF

      END SUBROUTINE PVLS

!---------------------------------------------------------------------
!---------------------------------------------------------------------
! snh: Bifurcations of global reinjection orbits near a saddle-node
!      Hopf bifurcation: cycle-to-point connections
!
! Parameters:
!   PAR(1) : nu1
!   PAR(2) : nu2
!   PAR(3) : d
!   PAR(4) : codimension of connection (0 or 1)
!
!   PAR(5) : delta: distance from cycle to start connection
!   PAR(6) : eps: distance from end connection to point
!   PAR(7) : mu: log of the Floquet multiplier
!   PAR(8) : h: norm of eigenfunction for cycle at 0
!   PAR(9) : T^-: time for connection from cycle (U(7:9)) to section
!   PAR(10) : T^+: time for connection from section (U(10:12)) to point
!   PAR(11) : T: period of the cycle
!   PAR(21) : sigma-: U1(9)-pi (phi-distance W^u(P) from section phi=pi)
!                     ( distance to W^u(b) for codim 0 connection)
!   PAR(22) : sigma+: U0(12)-pi (phi-distance W^s(E) from section phi=pi)
!   PAR(23) : eta: gap size for Lin vector
!   PAR(24) : Z_x: Lin vector (x-coordinate)
!   PAR(25) : Z_y: Lin vector (y-coordinate)
!   PAR(26) : Z_z: Lin vector (z-coordinate)
!---------------------------------------------------------------------
!---------------------------------------------------------------------

  SUBROUTINE RHS(U,PAR,F,JAC,A)

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: U(3), PAR(*)
    LOGICAL, INTENT(IN) :: JAC
    DOUBLE PRECISION, INTENT(OUT) :: F(3), A(3,3)

    DOUBLE PRECISION x, y, phi
    DOUBLE PRECISION nu1, nu2, alpha, beta, omega, c, d, fp, s
    DOUBLE PRECISION sphi, x2y2, cphinu, cphinu2

    nu1 = PAR(1)
    nu2 = PAR(2)
    d = PAR(3)
    fp = 4*atan(1.0d0)*d
    alpha = -1
    s = -1
    c = 0
    omega = 1
    beta = 0

    x = U(1)
    y = U(2)
    phi = U(3)

    sphi = sin(phi)
    x2y2 = x*x + y*y
    cphinu = 2*cos(phi)+nu2
    cphinu2 = cphinu*cphinu

    F(1) = nu1*x - omega*y - (alpha*x - beta*y)*sphi - x2y2*x + d*cphinu2
    F(2) = nu1*y + omega*x - (alpha*y + beta*x)*sphi - x2y2*y + fp*cphinu2
    F(3) = nu2 + s*x2y2 + 2.0*cos(phi) + c*x2y2*x2y2

    IF(JAC)THEN
       A(1,1) = nu1 - alpha*sphi - 3*x**2 - y**2
       A(1,2) = -omega + beta*sphi - 2*x*y
       A(1,3) = -(alpha*x - beta*y)*cos(phi) - d*4*(2*cos(phi)+nu2)*sphi

       A(2,1) = omega - beta*sphi - 2*x*y
       A(2,2) = nu1 - alpha*sphi - 3*y**2 - x*x
       A(2,3) = -(alpha*y + beta*x)*cos(phi) - fp*4*(2*cos(phi) + nu2)*sphi

       A(3,1) = 2*s*x + 4*c*x2y2*x
       A(3,2) = 2*s*y + 4*c*x2y2*y
       A(3,3) = -2*sphi
    ENDIF

  END SUBROUTINE RHS

  SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
! ---------- --- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    DOUBLE PRECISION T,mu
    DOUBLE PRECISION A(3,3)

    CALL RHS(U,PAR,F,NDIM>3,A)
    IF(NDIM==3)RETURN

    F(4:6) = MATMUL(A,U(4:6))

    T = PAR(11)
    F(1:6) = F(1:6) * T

    ! log of Floquet multiplier in PAR(7)
    mu = PAR(7)
    F(4:6) = F(4:6) - mu*U(4:6)

    IF (NDIM==6) RETURN

    CALL RHS(U(7:9),PAR,F(7:9),.FALSE.,A)

    T = PAR(9)
    F(7:9) = F(7:9) * T

    IF (NDIM==9) RETURN

    CALL RHS(U(10:12),PAR,F(10:12),.FALSE.,A)

    T = PAR(10)
    F(10:12) = F(10:12) * T

  END SUBROUTINE FUNC

  SUBROUTINE STPNT(NDIM,U,PAR,T)
  !--------- -----
  
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: T

    INTEGER, PARAMETER :: codim = 1
    DOUBLE PRECISION, PARAMETER :: nu1 = 0, nu2 = -1.46d0, d = 0.01d0
    DOUBLE PRECISION, PARAMETER :: delta = -1d-5, eps = 1d-6
    DOUBLE PRECISION fp(3), ev(3), pi
    DOUBLE PRECISION, SAVE :: s(6)

    IF(NDIM==9)THEN
       IF(T==0)THEN
          s(1:6) = U(1:6)
       ENDIF
       U(7:9) = s(1:3) + PAR(5)*s(4:6)
       RETURN
    ELSEIF(NDIM==12)THEN
       fp = (/0d0, 0d0, acos(-nu2/2)/)
       ev = (/0d0, 0d0, 1d0/)
       U(10:12) = fp(1:3) + PAR(6)*ev(1:3)
       RETURN
    ENDIF

    PAR(1:3) = (/nu1,nu2,d/)
    PAR(4) = codim
    PAR(5) = delta
    PAR(6) = eps
    PAR(21:22) = 0.0

    ! homotopy: equilibrium b and its phase-shifted version, to find
    ! the "heteroclinic" orbit in negative time.
    pi = 4 * ATAN(1D0)
    PAR(11) = -0.1
    PAR(12) = 0
    PAR(13) = 0
    PAR(14) = acos(-PAR(2)/2)
    PAR(15) = 0
    PAR(16) = 0
    PAR(17) = acos(-PAR(2)/2)+2*pi
    PAR(18) = 0.01d0 ! epsilon_0 distance

    ! equilibrium a
    U(1:3) = (/ 0.0d0, 0.0d0, 2*pi-acos(-nu2/2) /)

  END SUBROUTINE STPNT

  SUBROUTINE PVLS(NDIM,U,PAR)
  !--------- ----

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    
    DOUBLE PRECISION, EXTERNAL :: GETP
    DOUBLE PRECISION d(3), normlv
    INTEGER i, NBC, codim
    DOUBLE PRECISION pi
    LOGICAL, SAVE :: FIRST = .TRUE.

    IF (FIRST) THEN
       FIRST = .FALSE.
       ! initialization for BCND
       pi = 4d0 * ATAN(1d0)
       IF (NDIM==9) THEN
          codim = NINT(PAR(4))
          IF (codim == 0) THEN
             IF (PAR(21)==0) THEN
                ! distance to W^u(b) where b is the phase-shifted equilibrium
                PAR(21) = GETP("BV1",9,U) - PAR(17)
             ENDIF
          ELSE
             PAR(21) = GETP("BV0",9,U) - pi
          ENDIF
       ELSEIF (NDIM==12) THEN
          NBC = AINT(GETP("NBC",0,U))
          IF (NBC==15) THEN
             PAR(22) = GETP("BV0",12,U) - pi
          ELSEIF (NBC==17) THEN
             ! check if Lin vector initialized:
             IF (DOT_PRODUCT(PAR(24:26),PAR(24:26)) > 0) RETURN
             DO i=1,3
                d(i) = GETP("BV1",6+i,U) - GETP("BV0",9+i,U)
             ENDDO
             normlv = sqrt(DOT_PRODUCT(d,d))
             ! gap size in PAR(23)
             PAR(23) = normlv
             ! Lin vector in PAR(24)-PAR(26)
             PAR(24:26) = d(1:3)/normlv
          ENDIF
       ENDIF
    ENDIF
  END SUBROUTINE PVLS

  SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
  !--------- ----

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    DOUBLE PRECISION nu2, delta, eps, fp(3), ev(3), eta
    DOUBLE PRECISION pi
    INTEGER codim

    ! Periodicity boundary conditions on state variables
    FB(1:3) = U0(1:3) - U1(1:3)

    ! Floquet boundary condition
    FB(4:6) = U1(4:6) - U0(4:6)

    ! normalization
    FB(7) = PAR(8) - DOT_PRODUCT(U0(4:6),U0(4:6))
    IF (NBC==7) RETURN

    delta = PAR(5)
    FB(8:10) = U0(7:9) - (U0(1:3) + delta*U0(4:6))
    pi = 4d0 * ATAN(1d0)
    codim = NINT(PAR(4))
    IF(codim == 0)THEN
       ! projection boundary condition for codimension-zero connection
       nu2 = PAR(2)
       FB(11) = COS(U1(9) - PAR(21)) +nu2/2
       RETURN
    ENDIF
    FB(11) = U1(9) - pi - PAR(21)

    IF (NBC==11) RETURN

    nu2 = PAR(2)
    eps = PAR(6)
    IF (abs(nu2) > 2) THEN
       ! truncate nu2 to [-2,2] to avoid floating point exceptions with acos
       nu2 = sign(2d0, nu2)
    ENDIF

    fp = (/0d0, 0d0, acos(-nu2/2)/)
    ev = (/0d0, 0d0, 1d0/)

    FB(12:14) = U1(10:12) - (fp(1:3) + eps*ev(1:3))

    IF (NBC==15) THEN
       FB(15) = U0(12) - pi - PAR(22)
       RETURN
    ENDIF

    eta = PAR(23)
    FB(15:17) = U1(7:9) - U0(10:12) - eta*PAR(24:26)

  END SUBROUTINE BCND

  SUBROUTINE ICND(NDIM,PAR,ICP,NINTS,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
  !--------- ----
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NINTS, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINTS)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINTS,*)

    INTEGER codim

    ! Integral phase condition
    FI(1) = DOT_PRODUCT(U(1:3),UPOLD(1:3))
    IF (NINTS==1) RETURN

    codim = NINT(PAR(4))
    IF (codim == 0) THEN
       ! phase condition for codimension-zero connection
       FI(2) = DOT_PRODUCT(UPOLD(7:9),U(7:9)-UOLD(7:9))
       RETURN
    ENDIF
    FI(2) = DOT_PRODUCT(UPOLD(10:12),U(10:12)-UOLD(10:12))
  END SUBROUTINE ICND

  SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP)
  END SUBROUTINE FOPT

MODULE MAPS

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
  USE AE
  USE TOOLBOXAE
  USE EQUILIBRIUM
  USE INTERFACES

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: AUTODS

CONTAINS

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for Discrete Dynamical Systems
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ------
  SUBROUTINE INITDS(AP)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP

    CALL INITEQ(AP)
    ! ** Continuation of singular points
    SELECT CASE(AP%ITPST)
    CASE(7) ! ** PD continuation
       AP%NFPR=2
       AP%NDIM=2*AP%NDIM+1
    CASE(8) ! Neimark-Sacker
       AP%NFPR=2
       AP%NDIM=2*AP%NDIM+2
    END SELECT

  END SUBROUTINE INITDS

! ---------- ------
  SUBROUTINE AUTODS(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    CALL INITDS(AP)
    SELECT CASE(AP%ITPST)
    CASE(0)   ! ** Discrete dynamical systems : fixed points.
       CALL AUTOAE(AP,ICP,ICU,FNDS,STPNDS,FNCSDS)
    CASE(1)   ! BP continuation (maps)
       CALL AUTOAE(AP,ICP,ICU,FNBPDS,STPNBPDS,FNCSDS)
    CASE(2,7) ! ** PD or fold continuation (maps)
       CALL AUTOAE(AP,ICP,ICU,FNLPDS,STPNLPDS,FNCSDS)
    CASE(8)   ! Neimark-Sacker bifurcation continuation (maps)
       CALL AUTOAE(AP,ICP,ICU,FNNS,STPNNS,FNCSDS)
    END SELECT

  END SUBROUTINE AUTODS

! ---------- ----
  SUBROUTINE FNDS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generate the equations for continuing fixed points.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    INTEGER I, J, ITDS, NPAR, NFPR
    DOUBLE PRECISION, ALLOCATABLE :: FN(:),DFDU1(:,:),DFDP1(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: DFDU2(:,:)

    ITDS=NINT(PAR(11))
    CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)
    IF(ITDS>=2)THEN
       NFPR=AP%NFPR
       NPAR=AP%NPAR
       ALLOCATE(FN(NDIM),DFDU1(NDIM,NDIM),DFDP1(NDIM,NPAR), &
            DFDU2(NDIM,NDIM))
       DO I=2,ITDS
          ! with iterations use the chain rule
          FN(:)=F(:)
          CALL FUNI(AP,NDIM,FN,UOLD,ICP,PAR,IJAC,F,DFDU1,DFDP1)
          IF(IJAC>0)THEN
             ! DFDU=DFDU1*DFDU
             CALL DGEMM('n','n',NDIM,NDIM,NDIM,1.d0,DFDU1, &
                  NDIM,DFDU,NDIM,0.d0,DFDU2,NDIM)
             DFDU(:,:NDIM)=DFDU2(:,:)
             IF(IJAC>1)THEN
                ! DFDP=DFDU1*DFDP+DFDP1
                DO J=1,NFPR
                   CALL DGEMV('n',NDIM,NDIM,1.d0,DFDU1,NDIM, &
                        DFDP(1,ICP(J)),1,1d0,DFDP1(1,ICP(J)),1)
                   DFDP(:,ICP(J))=DFDP1(:,ICP(J))
                ENDDO
             ENDIF
          ENDIF
       ENDDO
       DEALLOCATE(FN,DFDU1,DFDU2,DFDP1)
    ENDIF

    F(:)=F(:)-U(:)

    IF(IJAC.EQ.0)RETURN

    DO I=1,NDIM
       DFDU(I,I)=DFDU(I,I)-1
    ENDDO

  END SUBROUTINE FNDS

! ---------- --------
  SUBROUTINE STPNDS(AP,PAR,ICP,U,UDOT,NODIR)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNAE(AP,PAR,ICP,U,UDOT,NODIR)
    IF(PAR(11)==0d0)THEN
       PAR(11)=1d0
    ENDIF
    IF(AP%ISW==-1)THEN
       IF(AP%ITP==7) THEN
          ! period doubling
          PAR(11)=PAR(11)*2
       ELSEIF(AP%ITP==8.OR.(MOD(AP%ITP,10)==8))THEN
          ! this could work if the torus has a resonance
          PAR(11)=PAR(11)*(2d0/PAR(12))
       ENDIF
    ENDIF

  END SUBROUTINE STPNDS

! ---------- ------
  SUBROUTINE FNLPDS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-par continuation of folds (maps)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNLPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNDS)

  END SUBROUTINE FNLPDS

! ---------- --------
  SUBROUTINE STPNLPDS(AP,PAR,ICP,U,UDOT,NODIR)

    ! Generates starting data for the 2-parameter continuation of
    ! Neimark-Sacker bifurcation point (map).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNLPF(AP,PAR,ICP,U,UDOT,NODIR,FNDS)

  END SUBROUTINE STPNLPDS

! ---------- ------
  SUBROUTINE FNBPDS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-par continuation of folds (maps)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNBPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNDS)

  END SUBROUTINE FNBPDS

! ---------- --------
  SUBROUTINE STPNBPDS(AP,PAR,ICP,U,UDOT,NODIR)

    ! Generates starting data for the 2-parameter continuation of
    ! Neimark-Sacker bifurcation point (map).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNBPF(AP,PAR,ICP,U,UDOT,NODIR,FNDS)

  END SUBROUTINE STPNBPDS

! ---------- ----
  SUBROUTINE FNNS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-parameter continuation of Neimark-
    ! Sacker bifurcation points in maps.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNHBF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNDS,FFNSX)

  END SUBROUTINE FNNS

! ---------- -----
  SUBROUTINE FFNSX(AP,U,PAR,DFDU,DFDV)

    USE SUPPORT, ONLY: PI
    USE AUTO_CONSTANTS, ONLY: TY

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: U(AP%NDM*2+2), PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: DFDU(AP%NDM,AP%NDM)
    DOUBLE PRECISION, INTENT(OUT) :: DFDV(AP%NDM,AP%NDM+1)

    INTEGER I,NDM
    DOUBLE PRECISION THTA,F

    NDM=AP%NDM
    IF(AP%ITP==8)THEN
       ! initialization
       IF(LEN_TRIM(TY)>2)THEN
          READ(TY(3:),'(I5)')I
          PAR(12)=PAR(I)
       ENDIF
       THTA=PAR(12)
       U(2*NDM+1)=THTA
    ENDIF

    ! construct matrix for extended Neimark-Sacker system
    ! Kuznetsov, 3rd ed., (10.83)
    ! A^2-2cA+I, and the derivative to theta: 2sA
    ! where A=DFDU+I, c=cos(theta), and s=sin(theta), so if B=DFDU:
    ! (B+I)^2-2c(B+I)+I=B^2+2(1-c)B+2(1-c)I, 2s(B+I)v=2sBv+2sv
    CALL DGEMM('n','n',NDM,NDM,NDM,1.d0,DFDU,NDM,DFDU,NDM,0.d0,DFDV,NDM)
    THTA=U(NDM*2+1)
    F=2*(1-COS(THTA))
    DFDV(:,:)=DFDV(:,:)+F*DFDU(:,:)
    DO I=1,NDM
       DFDV(I,I)=DFDV(I,I)+F
    ENDDO
    F=2*SIN(THTA)
    CALL DGEMV('n',NDM,NDM,F,DFDU,NDM,U(NDM+1),1,0d0,DFDV(1,NDM+1),1)
    DFDV(:,NDM+1)=DFDV(:,NDM+1)+F*U(NDM+1:2*NDM)

  END SUBROUTINE FFNSX

! ---------- ------
  SUBROUTINE STPNNS(AP,PAR,ICP,U,UDOT,NODIR)

    USE SUPPORT, ONLY: PI

    ! Generates starting data for the 2-parameter continuation of
    ! Neimark-Sacker bifurcation point (map).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNHBF(AP,PAR,ICP,U,UDOT,NODIR,FNDS,FFNSX)

  END SUBROUTINE STPNNS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSDS(AP,ICP,U,NDIM,PAR,ITEST,ATYPE) RESULT(Q)

    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    USE SUPPORT, ONLY: AA=>P0V

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    SELECT CASE(ITEST)
    CASE(4)
       Q=FNRNDS(AP,ATYPE,U,AA)
    CASE(6)
       Q=FNHBDS(AP,PAR,ATYPE,AA)
    CASE DEFAULT
       Q=FNCSEQF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FNDS)
    END SELECT

  END FUNCTION FNCSDS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNRNDS(AP,ATYPE,U,AA)

    USE SUPPORT, ONLY: CHECKSP, PI, LBTYPE

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: U(AP%NDIM), AA(AP%NDIM+1,AP%NDIM+1)
! Local
    INTEGER NTOP,ITPST
    DOUBLE PRECISION THETA

    FNRNDS = 0
    ATYPE=''
    ITPST=AP%ITPST

    IF(ITPST==2.OR.ITPST==7)THEN
       ! Rn on Fold/PD curve
       IF(AP%ITPST==2)THEN
          IF(.NOT.CHECKSP('R1',AP%IPS,AP%ILP,AP%ISP))RETURN
          ATYPE='R1'
       ELSE
          IF(.NOT.CHECKSP('R2',AP%IPS,AP%ILP,AP%ISP))RETURN
          ATYPE='R2'
       ENDIF
       FNRNDS=FNBTAE(AP,U,AA)
    ELSEIF(ITPST==8)THEN
       ! check the angle for resonances on Torus bifurcations
       THETA=U(AP%NDIM-1)
       SELECT CASE(NINT(THETA*6/PI(1d0)))
       CASE(3) ! 1:4 res
          ATYPE='R4'
       CASE(4) ! 1:3 res
          ATYPE='R3'
       CASE(6) ! 1:2 res
          ATYPE='R2'
       CASE DEFAULT ! 1:1 res
          ATYPE='R1'
       END SELECT
       IF(.NOT.CHECKSP(ATYPE,AP%IPS,AP%ILP,AP%ISP))ATYPE=''
       FNRNDS=THETA*(THETA-PI(.5d0))*(THETA-PI(2d0/3))*(THETA-PI(1d0))
    ELSE
       RETURN
    ENDIF

    NTOP=MOD(AP%NTOT-1,9999)+1
    IF(LEN_TRIM(ATYPE)>0.AND.AP%IID>=2)WRITE(9,101)ABS(AP%IBR),NTOP+1,FNRNDS
101 FORMAT(I4,I6,9X,'Rn   Function:',ES14.5)

  END FUNCTION FNRNDS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNHBDS(AP,PAR,ATYPE,AA)

    USE SUPPORT, ONLY: PI, EVV, EIG, CHECKSP, LBTYPE

    DOUBLE PRECISION, PARAMETER :: RLARGE=1.0d+30

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: AA(AP%NDIM+1,AP%NDIM+1)
! Local
    COMPLEX(KIND(1.0D0)), ALLOCATABLE :: EV(:)
    DOUBLE PRECISION, ALLOCATABLE :: AAA(:,:)
    INTEGER NDM,ISP,IID,IBR,NTOT,NTOP,NINS,I,LOC,ITPST
    DOUBLE PRECISION RIMHB,REV

    NDM=AP%NDM
    ISP=AP%ISP
    IID=AP%IID
    IBR=AP%IBR
    ITPST=AP%ITPST
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    ATYPE=''
    FNHBDS=0d0

    ALLOCATE(EV(NDM))

! Compute the eigenvalues of the Jacobian

    ALLOCATE(AAA(NDM,NDM))
    AAA(:,:)=AA(1:NDM,1:NDM)
    CALL EIG(AP,NDM,NDM,AAA,EV)
    DEALLOCATE(AAA)
    EV(:)=EV(:)+1d0
    DO I=1,NDM
       IF(EV(I)==CMPLX(0d0,0d0,KIND(1d0)))THEN
          EV(I)=CMPLX(-RLARGE,0.d0,KIND(1.0D0))
       ELSE
          EV(I)=LOG(EV(I))
       ENDIF
    ENDDO

    IF(ITPST==8)THEN ! TR
       CALL STABEQ(AP,AA,EV,NINS,LOC,3)
    ELSEIF(ITPST==2.OR.ITPST==7)THEN ! LP/PD
       CALL STABEQ(AP,AA,EV,NINS,LOC,2)
    ELSE
       CALL STABEQ(AP,AA,EV,NINS,LOC,1)
    ENDIF
    EVV(:)=EXP(EV(:))

    ! Check if not continuing a BP and not Rn already
    IF(ITPST==1.OR.MOD(AP%ITP,10)<-4)GOTO 100

    REV=0.d0
    IF(LOC>0)THEN
       REV=REAL(EV(LOC))
       RIMHB=ABS(AIMAG(EV(LOC)))
       ATYPE=TPSPAE(AP%EPSS,ITPST,RIMHB)
       IF(TRIM(ATYPE)=='TR')PAR(12)=RIMHB
    ENDIF

    IF(.NOT.CHECKSP(ATYPE,AP%IPS,AP%ILP,ISP))THEN
       ATYPE=''
    ELSE
       FNHBDS=REV
       IF(IID>=2)WRITE(9,101)ABS(IBR),NTOP+1,FNHBDS
    ENDIF
    AP%HBFF=FNHBDS
    IF(LEN_TRIM(ATYPE)>0)THEN
       IF(NINS==AP%NINS)ATYPE=TRIM(ATYPE)//'0'
    ENDIF
100 AP%NINS=NINS
    CALL PRINTEIG(AP)
    DEALLOCATE(EV)

101 FORMAT(I4,I6,9X,'Hopf Function:',ES14.5)

  END FUNCTION FNHBDS

! ------------ -------- ------
  CHARACTER(3) FUNCTION TPSPAE(EPSS,ITPST,RIMHB) RESULT(ATYPE)

! Determines type of secondary bifurcation of maps.
    
    USE SUPPORT, ONLY: PI

    INTEGER, INTENT(IN) :: ITPST
    DOUBLE PRECISION, INTENT(IN) :: EPSS, RIMHB

    ATYPE=''
    IF(ABS(RIMHB-PI(1d0)) <= SQRT(EPSS))THEN
!       ** period doubling (flip)
       IF(ITPST==0)THEN ! plain flip
          ATYPE='PD'
       ELSEIF(ITPST==8)THEN ! torus + flip
          ATYPE='PTR'
       ELSEIF(ITPST==2)THEN ! fold+flip
          ATYPE='LPD'
       ENDIF
    ELSEIF(RIMHB > SQRT(EPSS))THEN
!       ** torus (Neimark-Sacker) bifurcation
       IF(ITPST==0)THEN ! plain torus
          ATYPE='TR'
       ELSEIF(ITPST==8)THEN ! torus+torus
          ATYPE='TTR'
       ELSEIF(ITPST==2)THEN ! fold+torus
          ATYPE='LTR'
       ELSEIF(ITPST==7)THEN ! flip+torus
          ATYPE='PTR'
       ENDIF
    ELSE
!       ** something else... (close to fold -- normal folds are detected
!       in FNLPAE!)
       IF(ITPST==7)THEN ! flip+fold
          ATYPE='LPD'
       ELSEIF(ITPST==8)THEN ! torus+fold
          ATYPE='LTR'
       ENDIF
    ENDIF

  END FUNCTION TPSPAE

END MODULE MAPS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   ezp :    Complex bifurcation in a boundary value problem
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      COMPLEX(KIND(1.0D0)), INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      COMPLEX(KIND(1.0D0)), INTENT(OUT) :: F(NDIM)
      COMPLEX(KIND(1.0D0)), INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      COMPLEX(KIND(1.0D0)) :: U1, U2, RL, E

       U1=U(1)
       U2=U(2)

       RL=PAR(1)

       E=CDEXP(U1)
       F(1)=U2
       F(2)=-RL*E

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      COMPLEX(KIND(1.0D0)), INTENT(INOUT) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       U(1)=0
       U(2)=0

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      COMPLEX(KIND(1.0D0)), INTENT(IN) :: U0(NDIM), U1(NDIM)
      COMPLEX(KIND(1.0D0)), INTENT(OUT) :: F(NBC)
      COMPLEX(KIND(1.0D0)), INTENT(INOUT) :: DBC(NBC,*)

       F(1)=U0(1)
       F(2)=U1(1)

      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   enz :    A two-cell, one-substrate enzyme model 
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION R,s,s1,s2,s0,mu,rho,kappa

       R(s)=s/(1+s+kappa*s**2)
       s1=U(1)
       s2=U(2)
       s0=PAR(1)
       mu=PAR(2)
       rho=PAR(3)
       kappa=PAR(4)

       F(1)=(s0   -s1) + (s2-s1) - rho * R(s1)
       F(2)=(s0+mu-s2) + (s1-s2) - rho * R(s2)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0
       PAR(2)=0
       PAR(3)=100
       PAR(4)=1

       U(1)=0
       U(2)=0

      END SUBROUTINE STPNT

      SUBROUTINE BCND
      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   nag :    Heteroclinic orbits : A saddle-saddle connection 
!----------------------------------------------------------------------
!----------------------------------------------------------------------
! Parameter assignment:
!
!           PAR(1) , PAR(2) : a      , c      (parameters)
!           PAR(3) , PAR(4) : eps-0  , eps-1  (radii)
!           PAR(5) , PAR(6) : mu-0   , mu-1   (eigenvalues)
!           PAR(7) , PAR(8) : v-0(1) , v-0(2) (eigenvector)
!           PAR(9) , PAR(10): v-1(1) , v-1(2) (eigenvector)
!           PAR(11)         : period
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION PERIOD, DUMMY(1)

       CALL FFFF(2,U,ICP,PAR,0,F,DUMMY)

       PERIOD=PAR(11)
       F(1)=PERIOD*F(1)
       F(2)=PERIOD*F(2)

      END SUBROUTINE FUNC

      SUBROUTINE FFFF(NDM,U,ICP,PAR,IJAC,F,DFDU)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM)

      DOUBLE PRECISION A,C

       A=PAR(1)
       C=PAR(2)
       F(1)= U(2)
       F(2)= C*U(2) - U(1) * (1-U(1)) * (U(1)-A)

      IF(IJAC.EQ.0)RETURN

       DFDU(1,1)= 0
       DFDU(1,2)= 1

       DFDU(2,1)= - (1-U(1))*(U(1)-A) + U(1)*(U(1)-A) - U(1)*(1-U(1))
       DFDU(2,2)= C

      END SUBROUTINE FFFF

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION PERIOD, SIGN, R, V1, V2, X, E, U0, V0, EPS

! The following initialization is done only in the first call
       IF(T==0)THEN
!        Select period and connection (read from the constants-file)
         PERIOD=100.
         SIGN=1.0
         R = 0.5*SQRT(2.D0)
         V1= 1./SQRT(1+R**2)
         V2= R /SQRT(1+R**2)
         X  = -0.5*PERIOD
         E  = EXP(X/SQRT(2.D0))
         U0 = E/(1+E)
         V0 = ( E/(1+E)**2 ) / SQRT(2.D0)
         EPS= SQRT( U0**2 + V0**2 )
         PAR(1)= 0.5
         PAR(2)= 0
         PAR(3)= EPS
         PAR(4)= EPS
         PAR(5)= R
         PAR(6)=-R
         PAR(7)= SIGN*V1
         PAR(8)= SIGN*V2
         PAR(9)= -SIGN*V1
         PAR(10)= SIGN*V2
         PAR(11)= PERIOD
         PAR(12)= SIGN
       ENDIF

! Specify exact solution as starting point :

       PERIOD=PAR(11)
       SIGN  =PAR(12)

       X=PERIOD*SIGN*(T-0.5)
       E=DEXP(X/DSQRT(2.D0))
       U(1)=E/(1+E)
       U(2)=SIGN*E/(1+E)**2/DSQRT(2.D0)

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
! Local
      INTEGER, PARAMETER :: NDM=2
      DOUBLE PRECISION V0(NDM),V1(NDM),G0(NDM),G1(NDM)
      DOUBLE PRECISION DGDU0(NDM,NDM),DGDU1(NDM,NDM)

      V0(1)=U0(1) - PAR(3)*PAR(7)
      V0(2)=U0(2) - PAR(3)*PAR(8)
      V1(1)=U1(1) - PAR(4)*PAR(9)
      V1(2)=U1(2) - PAR(4)*PAR(10)

      CALL FFFF(NDM,V0,ICP,PAR,1,G0,DGDU0)
      CALL FFFF(NDM,V1,ICP,PAR,1,G1,DGDU1)

      FB(1)= DGDU0(1,1)*PAR(7) + DGDU0(1,2)*PAR(8) - PAR(5)*PAR(7)
      FB(2)= DGDU0(2,1)*PAR(7) + DGDU0(2,2)*PAR(8) - PAR(5)*PAR(8)
      FB(3)= DGDU1(1,1)*PAR(9) + DGDU1(1,2)*PAR(10)- PAR(6)*PAR(9)
      FB(4)= DGDU1(2,1)*PAR(9) + DGDU1(2,2)*PAR(10)- PAR(6)*PAR(10)
      FB(5)= PAR(7)**2 + PAR(8)**2 -1
      FB(6)= PAR(9)**2 + PAR(10)**2 -1
      FB(7)= G0(1)
      FB(8)= G0(2)
      FB(9)= G1(1)
      FB(10)=G1(2)

      END SUBROUTINE BCND

      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!     ---------- ----

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)
! Local
      INTEGER, PARAMETER :: NDM=2
      DOUBLE PRECISION F(NDM),F0(NDM),DFDU(NDM,NDM),DUMMY(1)

      CALL FFFF(NDM,U   ,ICP,PAR,1,F ,DFDU)
      CALL FFFF(NDM,UOLD,ICP,PAR,0,F0,DUMMY)

       FI(1)= ( F(1) - F0(1) ) * ( DFDU(1,1)*F(1) + DFDU(1,2)*F(2) ) &
            + ( F(2) - F0(2) ) * ( DFDU(2,1)*F(1) + DFDU(2,2)*F(2) )

      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

module compat

implicit none
public :: autoflush, autim, autargc, autgetarg

contains

! This file calls Unix extensions (see f2003.f90 for the new Standard forms)

  subroutine autoflush(i)
    integer, intent(in) :: i
    call flush(i)
  end subroutine autoflush

!-----------------------------------------------------------------------
!          Timing AUTO
!-----------------------------------------------------------------------

! ------ --------- --------
  double precision function autim()

    real t(2),etime
    autim = etime(t)

  end function autim

  integer function autargc()
    integer iargc
    autargc = iargc()
  end function autargc

  subroutine autgetarg(number,value)
    integer, intent(in) :: number
    character(len=*), intent(out) :: value
    call getarg(number,value)
  end subroutine autgetarg

end module compat

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!           Setting up of the Jacobian and right hand side
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      MODULE SOLVEBV

      USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

      IMPLICIT NONE
      PRIVATE

      PUBLIC ::SOLVBV

      INTERFACE
         INTEGER FUNCTION IDAMAX(N,DX,INCX)
            INTEGER, INTENT(IN) :: N,INCX
            DOUBLE PRECISION, INTENT(IN) :: DX(*)
         END FUNCTION IDAMAX
      END INTERFACE

      CONTAINS

!     ---------- ------
      SUBROUTINE SOLVBV(IFST,AP,DET,PAR,ICP,FUNI,BCNI,ICNI,RDS,  &
       NLLV,RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM, &
       DUPS,DRL,P0,P1,THL,THU)

!$    USE OMP_LIB
      USE AUTOMPI
      USE SUPPORT, ONLY: AUTOSTOP

! Sets up and solves the linear equations for one Newton/Chord iteration

      include 'interfaces.h'
      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER IFST,NLLV,ICP(*),NDIM
      DOUBLE PRECISION, INTENT(OUT) :: DET
      DOUBLE PRECISION PAR(*),RDS
      DOUBLE PRECISION RLOLD(AP%NFPR),RLCUR(AP%NFPR),RLDOT(AP%NFPR)
      DOUBLE PRECISION UPS(NDIM,0:*),UDOTPS(NDIM,0:*),UOLDPS(NDIM,0:*)
      DOUBLE PRECISION UPOLDP(NDIM,0:*),DUPS(NDIM,0:*),DTM(*)
      DOUBLE PRECISION DRL(AP%NFPR)
      DOUBLE PRECISION, INTENT(OUT) :: P0(*),P1(*)
      DOUBLE PRECISION THL(*),THU(*)

! Local
      DOUBLE PRECISION, ALLOCATABLE, SAVE :: &
           A(:,:,:),B(:,:,:),C(:,:,:),D(:,:),A1(:,:,:),A2(:,:,:), &
           S1(:,:,:),S2(:,:,:),BB(:,:,:),CC(:,:,:),C2(:,:,:),     &
           CDBC(:,:),DD(:,:,:)
      INTEGER, ALLOCATABLE, SAVE :: &
           ICF(:,:),IRF(:,:),IPR(:,:),IPC(:,:)
      DOUBLE PRECISION, ALLOCATABLE :: &
           FCFC(:,:),FAA(:,:),SOL(:,:),FC(:)
      INTEGER, ALLOCATABLE :: NP(:)
      INTEGER IAM,KWT,NTST,NCOL,NBC,NINT,IID,NFPR,NPAR
      INTEGER NRC,NFC,NROW,NCLM
      INTEGER NA,IT,NT,MNT,I,NA2
      INTEGER ISHAPE(8)

! Most of the required memory is allocated below

! This is an interesting section of code.  The main point
! is that setubv and conpar only get called when ifst
! is 1.  This is a optimization since you can solve
! the system using the previously factored jacobian.
! One thing to watch out for is that two seperate calls
! of solvbv_ talk to each other through these arrays,
! so it is only safe to get rid of them when ifst is
! 1 (since their entries will then be recreated in conpar
!  and setubv).


      IAM=MPIIAM()
      KWT=MPIKWT()

      NDIM=AP%NDIM
      NTST=AP%NTST
      NCOL=AP%NCOL
      NBC=AP%NBC
      NINT=AP%NINT
      IID=AP%IID
      NFPR=AP%NFPR
      NPAR=AP%NPAR
      NRC=NINT+1
      NFC=NRC+NBC
      NROW=NDIM*NCOL
      NCLM=NROW+NDIM

      ALLOCATE(NP(KWT))
      IF(KWT.GT.NTST)THEN
        PRINT*,'NTST is less than the number of nodes'
        CALL AUTOSTOP()
      ELSE
        CALL PARTITION(NTST,KWT,NP)
      ENDIF

!     NTST is the global one, NA is the local one.
!     The value of NTST may be different in different nodes.
      NA=NP(IAM+1)
      IF(KWT>1)THEN
         ! used "ghost" entries past NA+1 are stored close, in order
         ! of the furthest distance, for example for node 0,
         ! NA+2 stores the entries at NTST+1 (from node KWT-1)
         ! NA+3 stores the entries at (NTST+1)/2+1 (from node (KWT+1)/2-1)
         ! and so on, following the left recursion level in BCKSUB
         NA2=NA+CEILING(LOG(DBLE(NTST+1))/LOG(2.d0))
      ELSE
         NA2=NTST
      ENDIF

      ALLOCATE(FC(NFC))
      MNT = 1
!$    MNT = OMP_GET_MAX_THREADS()
      IF(MNT.GT.NA)THEN
         MNT=NA
!$       CALL OMP_SET_NUM_THREADS(NA)
      ENDIF
      IF(IFST.EQ.1)THEN
         IF(ALLOCATED(A))THEN
!            !a sufficient check to see if array dimensions have changed:
            ISHAPE(1:3)=SHAPE(A)
            ISHAPE(4:6)=SHAPE(CC)
            ISHAPE(7:8)=SHAPE(CDBC)
            IF(ISHAPE(1)/=NCLM.OR.ISHAPE(2)/=NROW.OR.ISHAPE(3)/=NA    &
           .OR.ISHAPE(4)/=NDIM.OR.ISHAPE(5)/=NRC.OR.ISHAPE(6)/=NA2 &
           .OR.ISHAPE(7)/=2*NDIM+NFPR.OR.ISHAPE(8)/=NBC)THEN
!              Free floating point arrays
               DEALLOCATE(A,B,C,D,A1,A2,S1,S2,BB,CC,C2,CDBC,DD)
!              Free integer arrays
               DEALLOCATE(ICF,IRF,IPR,IPC)
            ENDIF
         ENDIF

         IF(.NOT.ALLOCATED(A))THEN
            ALLOCATE(A(NCLM,NROW,NA),B(NFPR,NROW,NA))
            ALLOCATE(C(NCLM,NRC,NA),D(NFPR,NRC))
            ALLOCATE(A1(NDIM,NDIM,NA2),A2(NDIM,NDIM,NA2))
            ALLOCATE(S1(NDIM,NDIM,NA2-1),S2(NDIM,NDIM,NA2-1))
            ALLOCATE(BB(NFPR,NDIM,NA2),CC(NDIM,NRC,NA2))
            ALLOCATE(C2(NDIM,NRC,NA2),CDBC(2*NDIM+NFPR,NBC))
            ALLOCATE(DD(NFPR,NRC,NA2))

            ALLOCATE(ICF(NCLM,NA),IRF(NROW,NA),IPR(NDIM,NA2-1))
            ALLOCATE(IPC(NDIM,NA2-1))
         ENDIF
      ENDIF

      DO I=1,NFPR
         PAR(ICP(I))=RLCUR(I)
      ENDDO
      IF(IAM.EQ.0)THEN
         CALL SUBVBC(NDIM,NTST*NCOL,NBC,NFPR,BCNI, &
                 AP,PAR,NPAR,ICP,CDBC,FC,UPS,IFST)
         CALL SETFCDD(IFST,D,FC(NBC+1),NFPR,NINT)
         CALL SUBVPSA(NFPR,RDS,D(1,NRC),FC(NFC),RLCUR,RLOLD,RLDOT,THL,IFST)
      ENDIF
!     The matrices D and FC are unused in all nodes except the first.

      ALLOCATE(FCFC(NRC,NA2),FAA(NDIM,NA2),SOL(NDIM,NA2+1))

!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(I,IT,NT)

      IT = 0
!$    IT = OMP_GET_THREAD_NUM()
      NT = 1
!$    NT = OMP_GET_NUM_THREADS()
      IF(NLLV>=0.OR.IFST==1) &
        CALL SETUBV(NDIM,NA,NCOL,NINT,NFPR,NRC,NROW,NCLM,                &
         FUNI,ICNI,AP,PAR,NPAR,ICP,A,B,C,DD,DUPS,                        &
         FCFC,UPS,UOLDPS,RLOLD,UDOTPS,UPOLDP,DTM,THU,                    &
         IFST,IAM,IT,NT,IRF,ICF,IID,NLLV)

      I = (IT*NA+NT-1)/NT+1
      CALL BRBD(A(1,1,I),B(1,1,I),C(1,1,I),D,DD,DUPS(1,(I-1)*NCOL),FAA,FC,&
        FCFC,P0,P1,IFST,IID,NLLV,DET,NDIM,NTST,NA,NBC,NROW,NCLM,         &
        NFPR,NFC,A1,A2,BB,CC,C2,CDBC,                                    &
        SOL,S1,S2,IPR,IPC,IRF(1,I),ICF(1,I),IAM,KWT,IT,NT)

!$OMP END PARALLEL

      DEALLOCATE(FCFC,FAA)

      DUPS(:,NA*NCOL)=SOL(:,NA+1)
      IF(IAM==0.AND.NTST>NA)THEN
         DUPS(:,NTST*NCOL)=FC(1:NDIM)
      ENDIF
      DRL(:)=FC(NDIM+1:)

      DEALLOCATE(NP,FC,SOL)
      END SUBROUTINE SOLVBV

!     ---------- -------
      SUBROUTINE SETFCDD(IFST,DD,FC,NCB,NRC)

      INTEGER, INTENT(IN) :: IFST,NCB,NRC
      DOUBLE PRECISION FC(*),DD(NCB,*)

      INTEGER I,J

      DO I=1,NRC
        IF(IFST.EQ.1)THEN
          DO J=1,NCB
            DD(J,I)=0.0D0
          ENDDO
        ENDIF
        FC(I)=0.0D0
      ENDDO

      END SUBROUTINE SETFCDD

!     ---------- ---------
      SUBROUTINE SUBVBC(NDIM,NTNC,NBC,NCB,BCNI, &
       AP,PAR,NPAR,ICP,CDBC,FC,UPS,IFST)

!     This subroutine handles a non-parallel part of SETUBV, that is,
!     * the boundary conditions (not much to parallelize here and
!       HomCont relies on non-parallel execution): the array CDBC
!       and parts of FC.

      include 'interfaces.h'

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER NDIM,NTNC,NBC,NCB,ICP(*),IFST,NPAR
      DOUBLE PRECISION CDBC(2*NDIM+NCB,NBC)
      DOUBLE PRECISION UPS(NDIM,0:NTNC),FC(*),PAR(*)

! Local
      DOUBLE PRECISION, ALLOCATABLE :: UBC0(:),UBC1(:),FBC(:),DBC(:,:)
      INTEGER I,K

      ALLOCATE(UBC0(NDIM),UBC1(NDIM),FBC(NBC),DBC(NBC,2*NDIM+NPAR))
      DBC(:,:)=0.d0

!     Boundary conditions :

       IF(NBC.GT.0)THEN
         DO I=1,NDIM
            UBC0(I)=UPS(I,0)
            UBC1(I)=UPS(I,NTNC)
         ENDDO
         CALL BCNI(AP,NDIM,PAR,ICP,NBC,UBC0,UBC1,FBC,IFST*2,DBC)
         DO I=1,NBC
            FC(I)=-FBC(I)
            IF(IFST.EQ.1)THEN
               DO K=1,NDIM
                  CDBC(K,I)=DBC(I,K)
                  CDBC(NDIM+K,I)=DBC(I,NDIM+K)
               ENDDO
               DO K=1,NCB
                  CDBC(2*NDIM+K,I)=DBC(I,2*NDIM+ICP(K))
               ENDDO
            ENDIF
         ENDDO    
       ENDIF
       DEALLOCATE(UBC0,UBC1,FBC,DBC)
       END SUBROUTINE SUBVBC

!     ---------- -------
      SUBROUTINE SUBVPSA(NCB,RDS,DDPA,FCPA,RLCUR,RLOLD,RLDOT,THL,IFST)

      USE MESH

!     This subroutine handles a non-parallel part of SETUBV, that is,
!     * creating the parameter dependent pseudo-arclength parts of FC and D:
!       (the bottom element FCPA and row DDPA)

      INTEGER, INTENT(IN) :: NCB,IFST
      DOUBLE PRECISION, INTENT(IN) :: RDS,THL(NCB)
      DOUBLE PRECISION, INTENT(IN) :: RLCUR(NCB),RLOLD(NCB),RLDOT(NCB)
      DOUBLE PRECISION, INTENT(OUT) :: DDPA(NCB),FCPA

! Local
      INTEGER I
      DOUBLE PRECISION RLSUM

!     Pseudo-arclength equation :

       RLSUM=0.d0
       DO I=1,NCB
          IF(IFST.EQ.1)THEN
             DDPA(I)=THL(I)*RLDOT(I)
          ENDIF
          RLSUM=RLSUM+THL(I)*(RLCUR(I)-RLOLD(I))*RLDOT(I)
       ENDDO
       FCPA=RDS-RLSUM

       END SUBROUTINE SUBVPSA

!     ---------- ------
      SUBROUTINE SETUBV(NDIM,NA,NCOL,NINT,NCB,NRC,NRA,NCA,FUNI,         &
       ICNI,AP,PAR,NPAR,ICP,AA,BB,CC,DD,FA,FCFC,                        &
       UPS,UOLDPS,RLOLD,UDOTPS,UPOLDP,DTM,THU,IFST,IAM,IT,NT,IRF,ICF,IDB,NLLV)

      USE MESH

      INTEGER NDIM,NA,NCOL,NINT,NCB,NRC,NRA,NCA,IFST,IAM,IT,NT,NPAR
      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER ICP(*),IRF(NRA,*),ICF(NCA,*),IDB,NLLV
      DOUBLE PRECISION AA(NCA,NRA,*),BB(NCB,NRA,*),CC(NCA,NRC,*)
      DOUBLE PRECISION DD(NCB,NRC,*),FA(NRA,*),FCFC(NRC,*)
      DOUBLE PRECISION UPS(NDIM,0:*),UOLDPS(NDIM,0:*),RLOLD(NCB),UDOTPS(NDIM,0:*)
      DOUBLE PRECISION UPOLDP(NDIM,0:*),DTM(*),PAR(*),THU(*)

      include 'interfaces.h'

! Local
      DOUBLE PRECISION WI(0:NCOL),WP(0:NCOL,NCOL),WT(0:NCOL,NCOL)
      INTEGER I,N,II


      CALL WINT(NCOL,WI)
      CALL GENWTS(NCOL,WT,WP)

      I = (IT*NA+NT-1)/NT+1
      N = ((IT+1)*NA+NT-1)/NT+1-I
      II = (I-1)*NCOL
      CALL SUBVPA(NDIM,N,NCOL,NINT,NCB,NRC,NRA,NCA,FUNI,ICNI,     &
           AP,PAR,NPAR,ICP,AA(1,1,I),BB(1,1,I),CC(1,1,I),         &
           DD(1,1,I),FA(1,I),FCFC(1,I),UPS(1,II),UOLDPS(1,II),    &
           RLOLD,UDOTPS(1,II),UPOLDP(1,II),DTM(I),THU,WI,WP,WT,   &
           IRF(1,I),ICF(1,I),IFST,NLLV)

      CONTAINS

!     ---------- ---------
      SUBROUTINE SUBVPA(NDIM,N,NCOL,NINT,NCB,NRC,NRA,NCA,FUNI,  &
       ICNI,AP,PAR,NPAR,ICP,AA,BB,CC,DD,FA,FC,                  &
       UPS,UOLDPS,RLOLD,UDOTPS,UPOLDP,DTM,THU,WI,WP,WT,IRF,ICF,IFST,NLLV)

!     This is the per-CPU parallelized part of SETUBV

      include 'interfaces.h'

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER NDIM,N,NCOL,NINT,NCB,NRC,NRA,NCA,ICP(*),NPAR
      DOUBLE PRECISION AA(NCA,NRA,*),BB(NCB,NRA,*),CC(NCA,NRC,*)
      DOUBLE PRECISION DD(NCB,NRC,*),UPS(NDIM,0:*),UOLDPS(NDIM,0:*),RLOLD(NCB)
      DOUBLE PRECISION UDOTPS(NDIM,0:*),UPOLDP(NDIM,0:*),FA(NRA,*),FC(NRC,*)
      DOUBLE PRECISION DTM(*),PAR(*),THU(*)
      DOUBLE PRECISION WI(0:*),WP(0:NCOL,*),WT(0:NCOL,*)
      INTEGER IRF(NRA,*),ICF(NCA,*),IFST,NLLV

! Local
      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: DFDU,DFDP,U, &
        F,FICD,DICD,UID,UIP,PRM
      DOUBLE PRECISION WPLOC(0:NCOL)
      INTEGER I,J,JJ,K,IC,IC1,J1,K1,IB
      INTEGER, ALLOCATABLE :: IAMAX(:)

      ALLOCATE(DFDU(NDIM*NDIM),DFDP(NDIM*NPAR),U(3*NDIM+NCB))
      ALLOCATE(F(NDIM),FICD(NINT))
      ALLOCATE(DICD(NINT*(NDIM+NPAR)))
      ALLOCATE(UID(NDIM),UIP(NDIM),PRM(NPAR),IAMAX(NRA))

! Initialize to zero.

       DFDU(:)=0.d0
       DFDP(:)=0.d0
       DICD(:)=0.d0

       DO I=1,NPAR
          PRM(I)=PAR(I)
       ENDDO
       ! In U store: U, UOLD, RLOLD, UPOLDP
       U(:)=0.d0
       U(2*NDIM+1:2*NDIM+NCB)=RLOLD(:)
       DO J=1,N

! Generate AA , BB and FA :

          DO IC=1,NCOL
             IC1=(IC-1)*NDIM+1
             JJ=(J-1)*NCOL
             DO IB=0,NCOL
                WPLOC(IB)=WP(IB,IC)/DTM(J)
             ENDDO
             CALL SBVFUN(NDIM,NCOL,NCB,NCA,FUNI,AP,PRM,ICP,    &
                  AA(1,IC1,J),BB(1,IC1,J),FA(IC1,J),UPS(1,JJ), &
                  UOLDPS(1,JJ),UPOLDP(1,JJ),WPLOC,WT(0,IC),DFDU,DFDP, &
                  U,U(NDIM+1),F,IFST,NLLV)
             IF(IFST.EQ.1)THEN
                DO K=0,NDIM-1
                   IAMAX(IC1+K)=NDIM+IDAMAX(NRA-NDIM,AA(NDIM+1,IC1+K,J),1)
                ENDDO
             ENDIF
          ENDDO
!     
!     Generate CC, DD and FC :

         IF(IFST.EQ.1)DD(:,:,J)=0d0
         IF(NLLV.EQ.0)FC(:,J)=0d0
         DO K=0,NCOL
            J1=(J-1)*NCOL+K
            K1=K*NDIM+1
!     
!     Integral constraints+pseudo-arclength equation :
!     
            CALL SBVICN(NDIM,NINT,NCB,NCA,ICNI,AP,PRM,ICP,            &
                 CC(K1,1,J),DD(1,1,J),FC(1,J),UPS(1,J1),UOLDPS(1,J1), &
                 UDOTPS(1,J1),UPOLDP(1,J1),DTM(J),THU,WI(K),FICD,DICD,&
                 U,U(NDIM+1),UID,UIP,IFST,NLLV)
         ENDDO

!     debug: do condensation of parameters later after printing
         IF(IDB>4.AND.IAM==0)CYCLE

!      Condensation of parameters:
         IF(IFST.EQ.1)THEN
            CALL CONPAR(NDIM,NRA,NCA,AA(1,1,J),NCB,BB(1,1,J),NRC,      &
                 CC(1,1,J),DD(1,1,J),FA(1,J),FC(1,J),IRF(1,J),ICF(1,J),&
                 IAMAX,NLLV)
         ELSEIF(NLLV==0)THEN
            CALL CONRHS(NDIM,NRA,NCA,AA(1,1,J),NRC,                   &
                 CC(1,1,J),FA(1,J),FC(1,J),IRF(1,J))
         ENDIF
       ENDDO
!     
       DEALLOCATE(DFDU,DFDP,U,F,FICD,DICD)
       DEALLOCATE(UID,UIP,PRM,IAMAX)
      END SUBROUTINE SUBVPA

!     ---------- ---------
      SUBROUTINE SBVFUN(NDIM,NCOL,NCB,NCA,FUNI,AP,PAR,ICP,            &
       AA,BB,FA,UPS,UOLDPS,UPOLDP,WPLOC,WT,DFDU,DFDP,U,UOLD,F,IFST,NLLV)

!     Does one call to FUNI and stores the result in AA, BB, and FA.

      include 'interfaces.h'

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER, INTENT(IN) :: NDIM,NCOL,NCB,NCA,ICP(*)
      INTEGER, INTENT(IN) :: IFST,NLLV
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: WT(0:NCOL),WPLOC(0:NCOL)
      DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NCOL)
      DOUBLE PRECISION, INTENT(IN) :: UOLDPS(NDIM,0:NCOL),UPOLDP(NDIM,0:NCOL)
      DOUBLE PRECISION, INTENT(OUT) :: AA(NCA,*),BB(NCB,*),FA(*),U(*)
      DOUBLE PRECISION, INTENT(INOUT) :: UOLD(*),DFDU(NDIM,*),DFDP(NDIM,*)
      DOUBLE PRECISION, INTENT(OUT) :: F(*)

! Local
      DOUBLE PRECISION WTTMP
      INTEGER I,IB,IB1,J,K

      DO K=1,NDIM
         U(K)=DOT_PRODUCT(WT(:),UPS(K,:))
         UOLD(K)=DOT_PRODUCT(WT(:),UOLDPS(K,:))
         UOLD(NDIM+NCB+K)=DOT_PRODUCT(WT(:),UPOLDP(K,:))
      ENDDO
      CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,IFST*2,F,DFDU,DFDP)
      IF(IFST.EQ.1)THEN
         DO I=1,NDIM
!     use U instead of DFDU in inner loop to better utilize the CPU cache
            DO J=1,NDIM
               U(J)=DFDU(I,J)
            ENDDO
            DO IB=0,NCOL
               WTTMP=-WT(IB)
               IB1=IB*NDIM
               DO K=1,NDIM
                  AA(IB1+K,I)=WTTMP*U(K)
               ENDDO
               AA(IB1+I,I)=AA(IB1+I,I)+WPLOC(IB)
            ENDDO
         ENDDO
         DO I=1,NDIM
            DO K=1,NCB
               BB(K,I)=-DFDP(I,ICP(K))
            ENDDO
         ENDDO
      ENDIF
      IF(NLLV.EQ.0)THEN
         DO I=1,NDIM
            FA(I)=F(I)-DOT_PRODUCT(WPLOC(:),UPS(I,:))
         ENDDO
      ENDIF
      END SUBROUTINE SBVFUN

!     ---------- ------
      SUBROUTINE SBVICN(NDIM,NINT,NCB,NCA,ICNI,AP,PAR,ICP,CC,DD,FC,   &
       UPS,UOLDPS,UDOTPS,UPOLDP,DTM,THU,WI,FICD,DICD,UIC,UIO,UID,UIP, &
       IFST,NLLV)

!     Does one call to ICNI (integral constraints) and stores the
!     result in CC, DD and FC; and stores the pseudo-arclength
!     result too.

      include 'interfaces.h'
      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER, INTENT(IN) :: NDIM,NINT,NCB,NCA,ICP(*),IFST,NLLV
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: UPS(*),UDOTPS(*)
      DOUBLE PRECISION, INTENT(IN) :: UOLDPS(*),UPOLDP(*),DTM,WI,THU(*)
      DOUBLE PRECISION, INTENT(OUT) :: CC(NCA,*),FICD(*),DICD(NINT,*)
      DOUBLE PRECISION, INTENT(OUT) :: UIC(*),UID(*),UIP(*)
      DOUBLE PRECISION, INTENT(INOUT) :: UIO(*),DD(NCB,*),FC(*)

! Local
      INTEGER I,M
      DOUBLE PRECISION DFCDU

      IF(NINT.GT.0)THEN
         DO I=1,NDIM
            UIC(I)=UPS(I)
            UIO(I)=UOLDPS(I)
            UID(I)=UDOTPS(I)
            UIP(I)=UPOLDP(I)
         ENDDO
         CALL ICNI(AP,NDIM,PAR,ICP,NINT,UIC,UIO,UID,UIP,FICD,IFST*2,DICD)
         DO M=1,NINT
            IF(IFST.EQ.1)THEN
               DO I=1,NDIM
                  CC(I,M)=DTM*WI*DICD(M,I)
               ENDDO
               DO I=1,NCB
                  DD(I,M)=DD(I,M)+DTM*WI*DICD(M,NDIM+ICP(I))
               ENDDO
            ENDIF
            IF(NLLV.EQ.0)THEN
               FC(M)=FC(M)-DTM*WI*FICD(M)
            ENDIF
         ENDDO
      ENDIF
!     
!     Pseudo-arclength equation :
!     
      DO I=1,NDIM
         DFCDU=DTM*THU(I)*WI*UDOTPS(I)
         IF(IFST.EQ.1)THEN
            CC(I,NINT+1)=DFCDU
         ENDIF
         IF(NLLV.EQ.0)THEN
            FC(NINT+1)=FC(NINT+1)-DFCDU*(UPS(I)-UOLDPS(I))
         ENDIF
      ENDDO
      END SUBROUTINE SBVICN

      END SUBROUTINE SETUBV

!     ---------- ----
      SUBROUTINE BRBD(A,B,C,D,DD,FA,FAA,FC,FCFC,P0,P1,IFST,  &
        IDB,NLLV,DET,NOV,NTST,NA,NBC,NRA,NCA,                &
        NCB,NFC,A1,A2,BB,CC,C2,CDBC,                         &
        SOL,S1,S2,IPR,IPC,IRF,ICF,IAM,KWT,IT,NT)

! Solves linear systems with matrix profile:

!     -----------------------------------------------
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !XXXXXXXXXX                                !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !        XXXXXXXXXX                        !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                XXXXXXXXXX                !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                        XXXXXXXXXX        !XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     !                                XXXXXXXXXX!XX!
!     -----------------------------------------------
!     !XX                                      XX!XX!
!     !XX                                      XX!XX!
!     !XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX!XX!
!     !XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX!XX!
!     !XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX!XX!
!     -----------------------------------------------


! partioned as


!      ---------   ------   ------
!      !     ! !   !    !   !    !
!      !  A  !B!   ! XA !   ! FA !
!      !     ! ! . !    ! = !    !   .
!      !-----!-!   !----!   !----!
!      !  CDBC !   !    !   !    !
!      !-----!-!   ! XC !   ! FC !
!      !  C  !D!   !    !   !    !
!      !-----!-!   !----!   !----!


! Input parameters :

!   NA    number of blocks in A,
!   NRA   number of rows in each block of A,
!   NCA   number of columns in each block of A,
!   A     the matrix in the schematic representation above,

!   NCB   number of columns in each block of B,
!         (note that B is also three dimensional),
!   B     the matrix in the schema above,

!   NRC   the number of rows of the two dimensional matrix C,
!   C     the matrix C in the schema above,

!   D      the matrix D above,

!   NFC   the number of rows of the two dimensional matrices C+CDBC, XC and FC
!   C     the matrix C in the schema above,

!   CDBC  the matrix CDBC above,
!   NBC   the number of rows of the two dimensional matrix CDBC

!   FA     part of the right hand side vector,
!          (note that FA is also two dimensional),
!   FC     part of the right hand side vector.

!   IFST   = 1 on first call,
!          = 0  on subsequent calls with the same right hand side.

!   IDB   = 0..2 no debug output,
!         = 3    output of the residuals of the reduced system on unit 9,
!         = 4    output of the reduced Jacobian matrix and solution vector
!                on unit 9,
!         = 5    output of most matrices on unit 9 (see PRINT1),

!   IPR, IPC, ICF: Integer arrays

!   NLLV : If NLLV>0 then a null vector will be returned.
!          If NLLV = -1 then the system will be solved with zero right
!          hand side, except for the last equation, for which the right
!          hand side entry will be set to 1 (i.e., the last entry of FC
!          will be set to 1, otherwise FA and FC are zero).
!          If the linear system is the same as in the preceding call
!          then IFST=0 may be used even if NLLV is nonzero.

! Returned values :

!   FA     Part of solution vector corresponding to XA in the diagram.
!   FC     Part of solution vector corresponding to XC in the diagram.

! Notes: The number of columns of overlap for every two consecutive
!        blocks should be equal to the number NOV (NDIM).
!        Parts of the reduction are done in SUBVPA.

! Arguments
      INTEGER, INTENT(IN) :: IFST,IDB,NLLV,NOV,NTST,NA,NBC,NRA
      INTEGER, INTENT(IN) :: NCA,NCB,NFC,IAM,KWT,IT,NT
      DOUBLE PRECISION, INTENT(OUT) :: DET
      DOUBLE PRECISION A(NCA,NRA,*),B(NCB,NRA,*),C(NCA,NFC-NBC,*)
      DOUBLE PRECISION D(NCB,*),DD(NCB,NFC-NBC,*)
      DOUBLE PRECISION FA(NRA,*),FAA(NOV,*),FC(*),FCFC(NFC-NBC,*)
      DOUBLE PRECISION, INTENT(OUT) :: P0(*),P1(*)
      DOUBLE PRECISION A1(NOV,NOV,*),A2(NOV,NOV,*)
      DOUBLE PRECISION BB(NCB,NOV,*),CC(NOV,NFC-NBC,*),C2(NOV,NFC-NBC,*)
      DOUBLE PRECISION CDBC(*),SOL(NOV,*),S1(*),S2(*)
      INTEGER   IPR(*),IPC(*),IRF(NRA,*),ICF(NCA,*)

! Local
      INTEGER I,J,K,II,N,NRC,NTSTNA
      INTEGER, ALLOCATABLE :: IAMAX(:)
      DOUBLE PRECISION, ALLOCATABLE :: FCC(:),E(:,:),X(:)

      NRC=NFC-NBC
      I = (IT*NA+NT-1)/NT+1
      N = ((IT+1)*NA+NT-1)/NT+1-I

      IF(IDB.GT.4.and.IAM.EQ.0)THEN
!$OMP BARRIER
!$OMP MASTER
         CALL PRINT1(NA,NRA,NCA,NCB,NFC,NBC,A,B,C,CDBC,D,DD, &
           FA,FC,FCFC,IFST,NLLV)
!$OMP END MASTER
!$OMP BARRIER
         IF(IFST.EQ.1.OR.NLLV>=0)THEN
            ALLOCATE(IAMAX(NRA))
            DO J=1,N
               IF(IFST.EQ.1)THEN
                  DO K=1,NRA
                     IAMAX(K)= NOV+IDAMAX(NRA-NOV,A(NOV+1,K,J),1)
                  ENDDO
                  CALL CONPAR(NOV,NRA,NCA,A(1,1,J),NCB,B(1,1,J),NRC,   &
                       C(1,1,J),DD(1,1,I+J-1),FA(1,J),FCFC(1,I+J-1),   &
                       IRF(1,J),ICF(1,J),IAMAX,NLLV)
               ELSEIF(NLLV==0)THEN
                  CALL CONRHS(NOV,NRA,NCA,A(1,1,J),NRC,                &
                       C(1,1,J),FA(1,J),FCFC(1,I+J-1),IRF(1,J))
               ENDIF
            ENDDO
            DEALLOCATE(IAMAX)
         ENDIF
      ENDIF

      IF(IFST.EQ.1)THEN
         CALL COPYCP(N,NOV,NRA,NCA,A,NCB,B,NRC,C,A1(1,1,I),A2(1,1,I),   &
             BB(1,1,I),CC(1,1,I),C2(1,1,I))
      ENDIF
      IF(NLLV.NE.0)THEN
         FA(:,:N)=0d0
         IF(IT.EQ.0)THEN
            FC(:NFC)=0d0
         ENDIF         
      ENDIF
      CALL CPYRHS(N,NOV,NRA,FAA(1,I),FA)

      CALL REDUCE(A1,A2,BB,CC,C2,DD,FAA,FCFC,                           &
           NTST,NOV,NCB,NRC,S1,S2,IPC,IPR,IFST,NLLV,IT,NT,IAM,KWT)

! Solve the system generated by REDUCE
! by Gauss elimination with complete pivoting.

! REDUCE already has a barrier.
!$OMP MASTER
      IF(IAM.EQ.0)THEN
         ! This is where we sum into the global copy of the d array
         IF(KWT>1)THEN
            NTSTNA=NA+1
         ELSE
            NTSTNA=NTST
         ENDIF
         DO J=1,NRC
            IF(IFST.EQ.1)THEN
               DO K=1,NCB
                  D(K,J)=D(K,J)+DD(K,J,NTSTNA)
               ENDDO
            ENDIF
            IF(NLLV.EQ.0)THEN
               FC(NBC+J)=FC(NBC+J)+FCFC(J,NTSTNA)
            ENDIF
         ENDDO
         ALLOCATE(FCC(NOV+NFC),E(NOV+NFC,NOV+NFC))
         CALL DIMRGE(E,CC,C2,CDBC,D,FC,                               &
           NTSTNA,NFC,NBC,NOV,NCB,IDB,NLLV,FCC,P0,P1,DET,A1,A2,FAA,BB)
         DO II=1,NOV
            SOL(II,1)=FCC(II)
         ENDDO
         DEALLOCATE(FCC,E)
      ENDIF
!$OMP END MASTER

! Backsubstitution in the reduction process.

      CALL BCKSUB(S1,A2,S2,BB,FAA,SOL,FC,NTST,NOV,NCB,IPC,IT,NT,IAM,KWT)

! Backsubstitution in the condensation of parameters process.

      ALLOCATE(X(NOV+1:NRA))
      CALL INFPAR(A,B,FA,SOL(1,I),FC,N,NOV,NRA,NCA,NCB,ICF,X)
      DEALLOCATE(X)

      END SUBROUTINE BRBD

!     ---------- ------
      SUBROUTINE CONPAR(NOV,NRA,NCA,A,NCB,B,NRC,C,D,FA,FC,IRF,ICF,IAMAX,NLLV)

! Arguments
      INTEGER, INTENT(IN) :: NOV,NRA,NCA,NCB,NRC,NLLV
      INTEGER, INTENT(OUT) :: ICF(NCA),IRF(NRA)
      DOUBLE PRECISION, INTENT(INOUT) :: A(NCA,NRA),B(NCB,NRA)
      DOUBLE PRECISION, INTENT(INOUT) :: C(NCA,NRC),D(NCB,NRC)
      DOUBLE PRECISION, INTENT(INOUT) :: FA(NRA),FC(NRC)
      INTEGER, INTENT(INOUT) :: IAMAX(NRA)
! Local
      INTEGER IC,IRP,IR,IPIV,JPIV,L
      DOUBLE PRECISION PIV,TPIV,RM,TMP

! Note that the summation of the adjacent overlapped part of C
! is delayed until REDUCE, in order to merge it with other communications.

! This is a per-CPU, per-element process function for
! Condensation of parameters (Elimination of local variables).

         DO IC=NOV+1,NCA-NOV
            IRP=IC-NOV
!           **Search for pivot (Complete pivoting)
            PIV = ABS(A(IAMAX(IRP),IRP))
            IPIV = IRP
            DO IR=IRP+1,NRA
               TPIV = ABS(A(IAMAX(IR),IR))
               IF(PIV.LT.TPIV)THEN
                  PIV = TPIV
                  IPIV = IR
               ENDIF
            ENDDO
!           **Move indices
            IRF(IRP)=IPIV
            JPIV=IAMAX(IPIV)
            IF(IRP.NE.IPIV)THEN
!              **Physically swap rows
               DO L=1,NCA
                  TMP=A(L,IPIV)
                  A(L,IPIV)=A(L,IRP)
                  A(L,IRP)=TMP
               ENDDO
               DO L=1,NCB
                  TMP=B(L,IPIV)
                  B(L,IPIV)=B(L,IRP)
                  B(L,IRP)=TMP
               ENDDO
               TMP=FA(IPIV)
               FA(IPIV)=FA(IRP)
               FA(IRP)=TMP
               IAMAX(IPIV)=IAMAX(IRP)
            ENDIF
            ICF(IC)=JPIV
            IF(IC.NE.JPIV)THEN
!              **Physically swap columns
               DO IR=1,IRP-1
                  TMP=A(JPIV,IR)
                  A(JPIV,IR)=A(IC,IR)
                  A(IC,IR)=TMP
               ENDDO
            ENDIF
!           **End of pivoting; elimination starts here
            PIV=A(JPIV,IRP)
            A(JPIV,IRP)=A(IC,IRP)
            A(IC,IRP)=PIV
            DO IR=IRP+1,NRA
!              **Swap columns of A physically
               RM=A(JPIV,IR)/PIV
               A(JPIV,IR)=A(IC,IR)
               A(IC,IR)=RM
               IF(RM.NE.0.0)THEN
                  CALL IMSBRA(NOV,NCA,NRA,A(1,IR),A(1,IRP),IC+1,IAMAX(IR),RM)
                  DO L=1,NCB
                     B(L,IR)=B(L,IR)-RM*B(L,IRP)
                  ENDDO
                  IF(NLLV.EQ.0)THEN
                     FA(IR)=FA(IR)-RM*FA(IRP)
                  ENDIF
               ELSEIF(IAMAX(IR).EQ.JPIV)THEN
                  IAMAX(IR)=IC+IDAMAX(NRA-IC,A(IC+1,IR),1)
               ELSEIF(IAMAX(IR).EQ.IC)THEN
                  IAMAX(IR)=JPIV
               ENDIF
            ENDDO
            DO IR=1,NRC
!              **Swap columns of C physically
               RM=C(JPIV,IR)/PIV
               C(JPIV,IR)=C(IC,IR)
               C(IC,IR)=RM
               IF(RM.NE.0.0)THEN
                  CALL SUBRAC(NOV,NCA,C(1,IR),A(1,IRP),IC+1,RM)
                  DO L=1,NCB
                     D(L,IR)=D(L,IR)-RM*B(L,IRP)
                  ENDDO
                  IF(NLLV.EQ.0)THEN
                     FC(IR)=FC(IR)-RM*FA(IRP)
                  ENDIF
               ENDIF
            ENDDO
         ENDDO

      CONTAINS

!     ---------- ------
      SUBROUTINE IMSBRA(NOV,NCA,NRA,A,AP,ICP1,IAMAX,RM)

! Arguments
      DOUBLE PRECISION, INTENT(IN) :: AP(*),RM
      DOUBLE PRECISION, INTENT(INOUT) :: A(*)
      INTEGER, INTENT(IN) :: NOV,NRA,NCA,ICP1
      INTEGER, INTENT(OUT) :: IAMAX
! Local
      INTEGER L
      DOUBLE PRECISION PPIV,TPIV,V

      DO L=1,NOV
         A(L)=A(L)-RM*AP(L)
      ENDDO
      PPIV=0d0
      IAMAX=ICP1
      DO L=ICP1,NRA
         V=A(L)-RM*AP(L)
!     Also recalculate absolute maximum for current row
         A(L)=V
         TPIV=DABS(V)
         IF(PPIV.LT.TPIV)THEN
            PPIV=TPIV
            IAMAX=L
         ENDIF
      ENDDO
      DO L=NCA-NOV+1,NCA
         A(L)=A(L)-RM*AP(L)
      ENDDO
      END SUBROUTINE IMSBRA

!     ---------- ------
      SUBROUTINE SUBRAC(NOV,NCA,C,AP,ICP1,RM)
! Arguments
      DOUBLE PRECISION, INTENT(IN) :: AP(*),RM
      DOUBLE PRECISION, INTENT(INOUT) :: C(*)
      INTEGER, INTENT(IN) :: NOV,NCA,ICP1
! Local
      INTEGER L

      DO L=1,NOV
         C(L)=C(L)-RM*AP(L)
      ENDDO
      DO L=ICP1,NCA
         C(L)=C(L)-RM*AP(L)
      ENDDO
      END SUBROUTINE SUBRAC

      END SUBROUTINE CONPAR

!     ---------- ------
      SUBROUTINE CONRHS(NOV,NRA,NCA,A,NRC,C,FA,FC,IRF)

! Arguments
      INTEGER   NOV,NRA,NCA
      INTEGER   NRC,IRF(NRA)
      DOUBLE PRECISION A(NCA,NRA),C(NCA,NRC)
      DOUBLE PRECISION FA(NRA),FC(*)

! Local
      INTEGER   IC,IR,IPIV,IRP
      DOUBLE PRECISION RM,TMP

! Condensation of right hand side (one element).

      DO IR=1,NRA-NOV
         IPIV=IRF(IR)
         IF(IR.NE.IPIV)THEN
!     **Physically swap rows
            TMP=FA(IPIV)
            FA(IPIV)=FA(IR)
            FA(IR)=TMP
         ENDIF
      ENDDO
      DO IC=NOV+1,NCA-NOV
         IRP=IC-NOV
         RM=FA(IRP)
         IF(RM.NE.0.0)THEN
            DO IR=IRP+1,NRA
               FA(IR)=FA(IR)-RM*A(IC,IR)
            ENDDO
            DO IR=1,NRC
               FC(IR)=FC(IR)-RM*C(IC,IR)
            ENDDO
         ENDIF
      ENDDO

      END SUBROUTINE CONRHS

!     ---------- ------
      SUBROUTINE COPYCP(NA,NOV,NRA,NCA,A,NCB,B,NRC,C,A1,A2,BB,CC,C2)

! Arguments
      INTEGER, INTENT(IN) :: NA,NOV,NRA,NCA
      INTEGER, INTENT(IN) :: NCB,NRC
      DOUBLE PRECISION, INTENT(IN) :: A(NCA,NRA,*),B(NCB,NRA,*),C(NCA,NRC,*)
      DOUBLE PRECISION, INTENT(OUT) :: A1(NOV,NOV,*),A2(NOV,NOV,*)
      DOUBLE PRECISION, INTENT(OUT) :: BB(NCB,NOV,*),CC(NOV,NRC,*),C2(NOV,NRC,*)

!     DOUBLE PRECISION FA(NRA,*),FAA(NOV,*)

! Local
      INTEGER   I,IR,IR1,IC,IC1

! Copies the condensed sytem generated by CONPAR into workspace.

      DO I=1,NA
         DO IR=1,NOV
            IR1=NRA-NOV+IR
            DO IC=1,NOV
               IC1=NCA-NOV+IC
               A1(IC,IR,I)=A(IC,IR1,I)
               A2(IC,IR,I)=A(IC1,IR1,I)
            ENDDO     
            DO IC=1,NCB
               BB(IC,IR,I)=B(IC,IR1,I)
            ENDDO
         ENDDO
         DO IR=1,NRC
            DO IC=1,NOV
               CC(IC,IR,I)=C(IC,IR,I)
               C2(IC,IR,I)=C(NRA+IC,IR,I)
            ENDDO
         ENDDO
      ENDDO

      END SUBROUTINE COPYCP

!     ---------- ------
      SUBROUTINE CPYRHS(NA,NOV,NRA,FAA,FA)

      USE AUTOMPI

! Arguments
      INTEGER   NA,NOV,NRA

      DOUBLE PRECISION FA(NRA,*),FAA(NOV,*)

! Local
      INTEGER   I,IR

!     **Copy the RHS
      DO I=1,NA
         DO IR=1,NOV
            FAA(IR,I)=FA(NRA-NOV+IR,I)
         ENDDO         
      ENDDO

      END SUBROUTINE CPYRHS

!     ---------- ------
      SUBROUTINE REDUCE(A1,A2,BB,CC,C2,DD,FAA,FCFC,                &
           NTST,NOV,NCB,NRC,S1,S2,IPC,IPR,IFST,NLLV,IT,NT,IAM,KWT)

      USE AUTOMPI

! Arguments
      INTEGER, INTENT(IN) :: NTST,NOV,NCB,NRC,IFST,NLLV,IT,NT,IAM,KWT
      INTEGER, INTENT(INOUT) :: IPC(NOV,*),IPR(NOV,*)
      DOUBLE PRECISION, INTENT(INOUT) :: A1(NOV,NOV,*),A2(NOV,NOV,*)
      DOUBLE PRECISION, INTENT(INOUT) :: BB(NCB,NOV,*)
      DOUBLE PRECISION, INTENT(OUT) :: S1(NOV,NOV,*),S2(NOV,NOV,*)
      DOUBLE PRECISION, INTENT(INOUT) :: CC(NOV,NRC,*),C2(NOV,NRC,*)
      DOUBLE PRECISION, INTENT(INOUT) :: DD(NCB,NRC,*),FAA(NOV,*),FCFC(NRC,*)

! Local 
      INTEGER IAMAX,PLO,PHI,NA,MPLO,MPHI
      LOGICAL DOMPI
      ALLOCATABLE IAMAX(:)

      ALLOCATE(IAMAX(2*NOV))

      MPLO = (IAM*NTST+KWT-1)/KWT+1
      MPHI = ((IAM+1)*NTST+KWT-1)/KWT
      NA = MPHI-MPLO+1
      PLO = MPLO+(IT*NA+NT-1)/NT
      PHI = MPLO+((IT+1)*NA+NT-1)/NT-1
      DOMPI = KWT>1.AND.NT==1
!     Reduce non-overlapping pieces
      CALL REDUCER(1,NTST,1)

!$OMP BARRIER
!$OMP MASTER

!     Reduce overlapping pieces
      IF(NT>1)THEN
         DOMPI = KWT>1
         PLO = MPLO
         PHI = MPHI
         CALL REDUCER(1,NTST,1)
      ENDIF
!$OMP END MASTER

      DEALLOCATE(IAMAX)

      CONTAINS

!      --------- ---------- -------
       RECURSIVE SUBROUTINE REDUCER(LO,HI,LEVEL)

! Arguments
       INTEGER, INTENT(IN) :: LO,HI,LEVEL

! Local 
       INTEGER IR,IC,I0,I1,I2,MID

       IF(HI<PLO.OR.LO>PHI)RETURN
! This is a check for the master reduction so it will stop as soon
! as there is no more overlap (already handled by nodes).
       IF(NT>1.AND.PHI-PLO==NA-1.AND.LO>=PLO)THEN
          IF((LO-PLO)*NT/NA==(HI-PLO)*NT/NA)RETURN
       ENDIF

! Use nested dissection for reduction; this is naturally a recursive
! procedure.

       MID=(LO+HI)/2

       IF(LO<MID) &
            CALL REDUCER(LO,MID,LEVEL+1)

       IF(MID+1<HI) &
            CALL REDUCER(MID+1,HI,LEVEL)

       IF(DOMPI)THEN
          CALL MPIREDUCE(A1,A2,BB,CC,C2,DD,FAA,FCFC,NTST,NOV,NCB,NRC,IFST,&
               NLLV,LO,HI,LEVEL)
       ELSE
          ! OpenMP parallel section without overlap
          IF(NT>1.AND.PHI-PLO<NA-1.AND.HI>PHI)RETURN
       ENDIF
       IF(LO<PLO)RETURN

! Initialization

       I0=LO-MPLO+1
       I1=MID-MPLO+1
       I2=HI-MPLO+1
       IF(DOMPI.AND.I2>NA)THEN
          I2=NA+LEVEL
          IF(I1>NA)THEN
             I1=NA+LEVEL+1
          ENDIF
       ENDIF
       IF(NLLV==0)THEN
          DO IR=1,NRC
             FCFC(IR,I2)=FCFC(IR,I2)+FCFC(IR,I1)
          ENDDO
       ENDIF
       IF(IFST.EQ.1)THEN
          DO IR=1,NOV
             DO IC=1,NOV
                S1(IC,IR,I1)=A1(IC,IR,I0)
             ENDDO
          ENDDO
          DO IR=1,NRC
             DO IC=1,NOV
                CC(IC,IR,I1+1)=CC(IC,IR,I1+1)+C2(IC,IR,I1)
             ENDDO
             DO IC=1,NCB
                DD(IC,IR,I2)=DD(IC,IR,I2)+DD(IC,IR,I1)
             ENDDO
          ENDDO

          CALL REDBLK(S1(1,1,I1),A2(1,1,I1),  S2(1,1,I1),BB(1,1,I1),FAA(1,I1), &
                      A1(1,1,I0),A1(1,1,I1+1),A2(1,1,I2),BB(1,1,I2),FAA(1,I2), &
                      CC(1,1,I0),CC(1,1,I1+1),C2(1,1,I2),DD(1,1,I2),FCFC(1,I2),&
                      IPC(1,I1),IPR(1,I1),IAMAX,NOV,NCB,NRC)
       ELSEIF(NLLV==0)THEN
          CALL REDRHSBLK(A2(1,1,I1),FAA(1,I1),    &
               A1(1,1,I1+1),FAA(1,I2),            &
               CC(1,1,I1+1),FCFC(1,I2),NOV,NRC,IPR(1,I1))
       ENDIF

       END SUBROUTINE REDUCER

!      ---------- ------
       SUBROUTINE REDBLK(S11,A21,S21,BB1,FAA1, &
                         A11,A12,A22,BB2,FAA2, &
                         CC1,CC2,CC3,DD,FC,  &
           IPC,IPR,IAMAX,NOV,NCB,NRC)

! Arguments
       INTEGER, INTENT(IN) :: NOV,NCB,NRC
       INTEGER, INTENT(OUT) :: IPC(NOV),IPR(NOV),IAMAX(NOV*2)
       DOUBLE PRECISION, INTENT(INOUT) :: S11(NOV,NOV),A21(NOV,NOV)
       DOUBLE PRECISION, INTENT(OUT)   :: S21(NOV,NOV),A11(NOV,NOV)
       DOUBLE PRECISION, INTENT(INOUT) :: A12(NOV,NOV),A22(NOV,NOV)
       DOUBLE PRECISION, INTENT(INOUT) :: CC1(NOV,NRC),CC2(NOV,NRC),CC3(NOV,NRC)
       DOUBLE PRECISION, INTENT(INOUT) :: BB1(NCB,NOV),BB2(NCB,NOV),DD(NCB,NRC)
       DOUBLE PRECISION, INTENT(INOUT) :: FAA1(NOV),FAA2(NOV),FC(*)

! Local
       INTEGER K1,K2,IR,IC,IPIV1,IPIV2,JPIV,JPIV1,JPIV2,ITMP
       DOUBLE PRECISION PIV1,PIV2,TPIV,TMP

         DO K1=1,NOV
            DO K2=1,NOV
               S21(K2,K1) = 0.0D0
               A11(K2,K1) = 0.0D0
            ENDDO
         ENDDO

         DO K1=1,NOV
            IAMAX(K1)=IDAMAX(NOV,A21(1,K1),1)
         ENDDO
         DO K1=1,NOV
            IAMAX(NOV+K1)=IDAMAX(NOV,A12(1,K1),1)
         ENDDO

         DO IC=1,NOV

! Complete pivoting; rows are swapped physically, columns also
            PIV1 = 0.d0
            IPIV1 = IC
            DO K1=IC,NOV
               TPIV=DABS(A21(IAMAX(K1),K1))
               IF(PIV1.LT.TPIV)THEN
                  PIV1   = TPIV
                  IPIV1  = K1
               ENDIF
            ENDDO
            JPIV1=IAMAX(IPIV1)

            PIV2 = 0.d0
            IPIV2 = 1
            DO K1=1,NOV
               TPIV=DABS(A12(IAMAX(NOV+K1),K1))
               IF(PIV2.LT.TPIV)THEN
                  PIV2   = TPIV
                  IPIV2  = K1
               ENDIF
            ENDDO
            JPIV2=IAMAX(NOV+IPIV2)

! rows and columns are swapped physically

            IF(PIV1.GE.PIV2)THEN
               JPIV        = JPIV1
               IPR(IC)     = IPIV1
               IF(IC.NE.IPIV1) &
                  CALL REDSWP(IC,NOV,NCB, &
                    S11(1,IC),S11(1,IPIV1),A21(1,IC),A21(1,IPIV1), &
                    S21(1,IC),S21(1,IPIV1),BB1(1,IC),BB1(1,IPIV1), &
                    FAA1(IC),FAA1(IPIV1))
            ELSE
               JPIV        = JPIV2
               IPR(IC)     = NOV+IPIV2
               CALL REDSWP(IC,NOV,NCB, &
                    S11(1,IC),A11(1,IPIV2),A21(1,IC),A12(1,IPIV2), &
                    S21(1,IC),A22(1,IPIV2),BB1(1,IC),BB2(1,IPIV2), &
                    FAA1(IC),FAA2(IPIV2))
            ENDIF
            IAMAX(IPR(IC)) = IAMAX(IC)
            IPC(IC) = JPIV
            IF(JPIV.NE.IC)THEN
               DO IR=1,NOV
                  TMP          = A12(IC,IR)
                  A12(IC,IR)   = A12(JPIV,IR)
                  A12(JPIV,IR) = TMP
                  TMP          = A21(IC,IR)
                  A21(IC,IR)   = A21(JPIV,IR)
                  A21(JPIV,IR) = TMP
               ENDDO
            ENDIF

! End of pivoting; Elimination starts here

            DO IR=IC+1,NOV
               CALL REDELIM(IC,NOV,NCB,IAMAX(IR),JPIV,         &
                    A21(1,IR),A21(1,IC),S11(1,IR),S11(1,IC),   &
                    S21(1,IR),S21(1,IC),BB1(1,IR),BB1(1,IC),   &
                    FAA1(IR),FAA1(IC))
            ENDDO

            DO IR=1,NOV
               CALL REDELIM(IC,NOV,NCB,IAMAX(NOV+IR),JPIV,     &
                    A12(1,IR),A21(1,IC),A11(1,IR),S11(1,IC),   &
                    A22(1,IR),S21(1,IC),BB2(1,IR),BB1(1,IC),   &
                    FAA2(IR),FAA1(IC))
            ENDDO

            DO IR=1,NRC
               TMP          = CC2(IC,IR)
               CC2(IC,IR)   = CC2(JPIV,IR)
               CC2(JPIV,IR) = TMP
               ITMP=0
               CALL REDELIM(IC,NOV,NCB,ITMP,JPIV,              &
                    CC2(1,IR),A21(1,IC),CC1(1,IR),S11(1,IC),   &
                    CC3(1,IR),S21(1,IC),DD(1,IR),BB1(1,IC),    &
                    FC(IR),FAA1(IC))
            ENDDO
         ENDDO

       END SUBROUTINE REDBLK

!      ---------- ------
       SUBROUTINE REDSWP(IC,NOV,NCB,S11,A11,A12,A21,S21,A22,BB1,BB2,F1,F2)

       INTEGER, INTENT(IN) :: IC,NOV,NCB
       DOUBLE PRECISION, INTENT(INOUT) :: S11(NOV),A11(NOV),A12(NOV),A21(NOV)
       DOUBLE PRECISION, INTENT(INOUT) :: S21(NOV),A22(NOV),BB1(NCB),BB2(NCB)
       DOUBLE PRECISION, INTENT(INOUT) :: F1,F2

       INTEGER L
       DOUBLE PRECISION TMP
! Swapping
       DO L=1,NOV
          TMP    = S11(L)
          S11(L) = A11(L)
          A11(L) = TMP                  
          IF(L.GE.IC)THEN
             TMP    = A21(L)
             A21(L) = A12(L)
             A12(L) = TMP
          ENDIF
          TMP    = S21(L)
          S21(L) = A22(L)
          A22(L) = TMP
       ENDDO
       DO L=1,NCB
          TMP    = BB1(L)
          BB1(L) = BB2(L)
          BB2(L) = TMP
       ENDDO
       IF(NLLV==0)THEN
          TMP = F1
          F1 = F2
          F2 = TMP
       ENDIF
       END SUBROUTINE REDSWP

!      ---------- -------
       SUBROUTINE REDELIM(IC,NOV,NCB,IAMAX,JPIV,A12,A21,A11,S11,A22,S21,&
            BB2,BB1,F2,F1)

       INTEGER, INTENT(IN) :: IC,NOV,NCB,JPIV
       INTEGER, INTENT(INOUT) :: IAMAX
       DOUBLE PRECISION, INTENT(INOUT) :: A12(NOV),A11(NOV),A22(NOV),BB2(NCB),F2
       DOUBLE PRECISION, INTENT(IN) :: A21(NOV),S11(NOV),S21(NOV),BB1(NCB),F1

       INTEGER L
       DOUBLE PRECISION RM,V,PPIV,TPIV

       RM = A12(IC)/A21(IC)
       A12(IC) = RM

       IF(RM.NE.0.0)THEN
          IF(IAMAX.EQ.0)THEN
             DO L=IC+1,NOV
                A12(L)=A12(L)-RM*A21(L)
             ENDDO
          ELSE
             PPIV=0d0
             IAMAX=IC+1
             DO L=IC+1,NOV
                V=A12(L)-RM*A21(L)
!     Also recalculate absolute maximum for current row
                A12(L)=V
                TPIV=DABS(V)
                IF(PPIV.LT.TPIV)THEN
                   PPIV=TPIV
                   IAMAX=L
                ENDIF
             ENDDO
          ENDIF
          DO L=1,NOV
             A11(L) = A11(L)-RM*S11(L)
             A22(L) = A22(L)-RM*S21(L)
          ENDDO
          DO L=1,NCB
             BB2(L) = BB2(L)-RM*BB1(L)
          ENDDO
          IF(NLLV==0)THEN
             F2 = F2-RM*F1
          ENDIF
       ELSEIF(IAMAX.EQ.JPIV)THEN
!     recalculate absolute maximum for current row
          IF(IC<NOV)THEN
             IAMAX = IC+IDAMAX(NOV-IC,A12(IC+1),1)
          ENDIF
       ELSEIF(IAMAX.EQ.IC)THEN
          IAMAX = JPIV
       ENDIF

       END SUBROUTINE REDELIM

!      ---------- ---------
       SUBROUTINE REDRHSBLK(A21,FAA1,A12,FAA2,CC,FC,NOV,NRC,IPR)

! Arguments
       INTEGER, INTENT(IN) :: NOV,NRC,IPR(NOV)
       DOUBLE PRECISION, INTENT(IN) :: A12(NOV,NOV),A21(NOV,NOV)
       DOUBLE PRECISION, INTENT(IN) :: CC(NOV,NRC)
       DOUBLE PRECISION, INTENT(INOUT) :: FAA1(NOV),FAA2(NOV),FC(*)

! Local
       INTEGER IC,IR,IPIV1,L1
       DOUBLE PRECISION RM

! Reduce with the right hand side for one block
       DO IC=1,NOV
         IPIV1 = IPR(IC)
         IF(IPIV1.LE.NOV)THEN
            RM          = FAA1(IPIV1)
            FAA1(IPIV1) = FAA1(IC)
         ELSE
            L1       = IPIV1-NOV
            RM       = FAA2(L1)
            FAA2(L1) = FAA1(IC)
         ENDIF
         FAA1(IC) = RM
         DO IR=IC+1,NOV
            FAA1(IR) = FAA1(IR)-A21(IC,IR)*RM
         ENDDO
         DO IR=1,NOV
            FAA2(IR) = FAA2(IR)-A12(IC,IR)*RM
         ENDDO
         DO IR=1,NRC
            FC(IR)= FC(IR)-CC(IC,IR)*RM
         ENDDO
       ENDDO

       END SUBROUTINE REDRHSBLK

      END SUBROUTINE REDUCE

!     ---------- ------
      SUBROUTINE DIMRGE(E,CC,C2,CDBC,D,FC, &
           NA,NFC,NBC,NOV,NCB,IDB,NLLV,FCC,P0,P1,DET,A1,A2,FAA,BB)

      USE SUPPORT
! Arguments
      INTEGER   NA,NFC,NBC,NOV,NCB,IDB,NLLV
      DOUBLE PRECISION E(NOV+NFC,*),CC(NOV,NFC-NBC,*),C2(NOV,NFC-NBC,*)
      DOUBLE PRECISION CDBC(2*NOV+NCB,NBC),D(NCB,*)
      DOUBLE PRECISION, INTENT(OUT) :: P0(NOV,*),P1(NOV,*)
      DOUBLE PRECISION A1(NOV,NOV,*),FAA(NOV,*),A2(NOV,NOV,*)
      DOUBLE PRECISION BB(NCB,NOV,*),FC(*),FCC(*)
      DOUBLE PRECISION, INTENT(OUT) :: DET

! Local
      INTEGER  I,J,NCR,NRC
      DOUBLE PRECISION, ALLOCATABLE :: XE(:)
      ALLOCATE(XE(NOV+NFC))

      NCR     = NFC+NOV
      NRC     = NFC-NBC

! Copy
      DO I=1,NOV
         DO J=1,NOV
            E(I,J)     = A1(J,I,1)
            P0(I,J)    = A1(J,I,1)
            E(I,NOV+J) = A2(J,I,NA)
            P1(I,J)    = A2(J,I,NA)
         ENDDO
         DO J=1,NCB
            E(I,2*NOV+J) = BB(J,I,NA)
         ENDDO
      ENDDO

      DO I=1,NBC
         DO J=1,2*NOV+NCB
            E(NOV+I,J)     = CDBC(J,I)
         ENDDO
      ENDDO
      DO I=1,NRC
         DO J=1,NOV
            E(NOV+NBC+I,J)       = CC(J,I,1)
            E(NOV+NBC+I,NOV+J)   = C2(J,I,NA)
         ENDDO
         DO J=1,NCB
            E(NOV+NBC+I,2*NOV+J) = D(J,I)
         ENDDO
      ENDDO

      DO I=1,NOV
         XE(I)=FAA(I,NA)
      ENDDO

      DO I=1,NFC
         XE(NOV+I) = FC(I)
      ENDDO
!     
      IF(IDB.GE.3)THEN
         WRITE(9,101)
         WRITE(9,100)(XE(I),I=1,NCR)
      ENDIF
!     
      IF(IDB.GE.4)THEN
         WRITE(9,102)
         DO I=1,NCR
            WRITE(9,100)(E(I,J),J=1,NCR)
         ENDDO
      ENDIF

! Solve for FCC
      IF(NLLV>0)THEN
         CALL NLVC(NCR,NCR,NLLV,E,FCC)
         DET=0.d0
      ELSE
         IF(NLLV<0)THEN
            DO I=1,NCR-1
               XE(I)=0.D0
            ENDDO
            XE(NCR)=1.D0
         ENDIF
         CALL GEL(NCR,E,1,FCC,XE,DET)
      ENDIF

      IF(IDB.GE.4)THEN
         WRITE(9,103)
         WRITE(9,100)(FCC(I),I=1,NCR)
      ENDIF


 100  FORMAT(1X,10E11.3)
 101  FORMAT(/,1X,'Residuals of reduced system:')
 102  FORMAT(/,1X,'Reduced Jacobian matrix:')
 103  FORMAT(/,1X,'Solution vector:')

      DO I=1,NFC
         FC(I)=FCC(NOV+I)
      ENDDO

      DEALLOCATE(XE)
      END SUBROUTINE DIMRGE

!     ---------- ------
      SUBROUTINE BCKSUB(S1,A2,S2,BB,FAA,SOL,FC,NTST,NOV,NCB,IPC,IT,NT,IAM,KWT)

      USE AUTOMPI

! Arguments
      INTEGER, INTENT(IN) :: NTST,NOV,NCB,IPC(NOV,*),IT,NT,IAM,KWT
      DOUBLE PRECISION, INTENT(IN) :: S1(NOV,NOV,*),S2(NOV,NOV,*)
      DOUBLE PRECISION, INTENT(IN) :: A2(NOV,NOV,*),BB(NCB,NOV,*)
      DOUBLE PRECISION, INTENT(IN) :: FAA(NOV,*)
      DOUBLE PRECISION, INTENT(INOUT) :: FC(*)
      DOUBLE PRECISION, INTENT(OUT) :: SOL(NOV,*)

! Local
      INTEGER I,PLO,PHI,NA,MPLO,MPHI,NTSTNA
      LOGICAL DOMPI

      MPLO = (IAM*NTST+KWT-1)/KWT+1
      MPHI = ((IAM+1)*NTST+KWT-1)/KWT
      NA = MPHI-MPLO+1
!$OMP MASTER
! do global backsubsitution until there is no overlap left
      IF(IAM==0)THEN
         IF(NTST==NA)THEN
            NTSTNA=NTST
         ELSE
            NTSTNA=NA+1
         ENDIF 
         DO I=1,NOV
            SOL(I,NTSTNA+1) = FC(I)
         ENDDO
      ENDIF
      IF(NT>1)THEN
         PLO = MPLO
         PHI = MPHI
         DOMPI = KWT>1
         CALL BCKSUBR(1,NTST,1)
      ENDIF
!$OMP END MASTER
!$OMP BARRIER
      PLO = MPLO+(IT*NA+NT-1)/NT
      PHI = MPLO+((IT+1)*NA+NT-1)/NT-1
      DOMPI = KWT>1.AND.NT==1
      CALL BCKSUBR(1,NTST,1)

      CONTAINS

!      Back substitution within the interval [MPLO,MPHI]; LO is in [PLO,PHI]
!      --------- ---------- -------
       RECURSIVE SUBROUTINE BCKSUBR(LO,HI,LEVEL)

! Arguments
       INTEGER, INTENT(IN) :: LO,HI,LEVEL

! Local
       INTEGER MID,I,I0,I1

       IF(LO>=HI.OR.HI<PLO.OR.LO>PHI)RETURN
! This is a check for the master reduction so it will stop as soon
! as there is no more overlap (already handled by nodes).
       IF(NT>1.AND.PHI-PLO==NA-1.AND.LO>=PLO)THEN
          IF((LO-PLO)*NT/NA==(HI-PLO)*NT/NA)RETURN
       ENDIF
       MID=(LO+HI)/2
       I=MID-MPLO+1
       I0=LO-MPLO+1
       I1=HI-MPLO+1
       IF((PHI-PLO==NA-1.OR.HI<=PHI).AND.LO>=PLO)THEN
          IF(DOMPI.AND.I1>NA)THEN
             I1=NA+LEVEL
             IF(I>NA)THEN
                I=NA+LEVEL+1
             ENDIF
          ENDIF
          CALL BCKSUB1(S1(1,1,I),A2(1,1,I),S2(1,1,I),BB(1,1,I),     &
               FAA(1,I),SOL(1,I0),SOL(1,I+1),SOL(1,I1+1),FC(NOV+1), &
               NOV,NCB,IPC(1,I))
       ENDIF
       IF(DOMPI)THEN
          CALL MPIBCKSUB(SOL,FC,NTST,NOV,NCB,LO,HI,LEVEL)
       ENDIF
       ! For MPI and ghost elements there are two possibilities:
       ! 1. HI and MID are both beyond the end. In that case the
       !    (MID+1,HI) recursion applies to a different process,
       !    so the level can be the same.
       !    The (LO,MID) recursion increases the level so the new
       !    HI ghost refers to the old MID ghost.
       ! 2. Only HI is beyond the end. In that case the
       !    (MID+1,HI) recursion is in the same process and should
       !    not increase the level, because the new HI ghost is the
       !    same as the old HI ghost, and the old MID ghost does not
       !    exist.
       !    The (LO,MID) recursion is local so does not need ghost
       !    elements.
       CALL BCKSUBR(MID+1,HI,LEVEL)
       CALL BCKSUBR(LO,MID,LEVEL+1)

       END SUBROUTINE BCKSUBR

!      ---------- -------
       SUBROUTINE BCKSUB1(S1,A2,S2,BB,FAA,FCC,SOL1,SOL2,FC,NOV,NCB,IPC)

! Arguments
         INTEGER, INTENT(IN) :: NOV,NCB,IPC(NOV)
         DOUBLE PRECISION, INTENT(IN) :: S1(NOV,NOV),S2(NOV,NOV)
         DOUBLE PRECISION, INTENT(IN) :: A2(NOV,NOV),BB(NCB,NOV)
         DOUBLE PRECISION, INTENT(IN) :: SOL2(NOV),FAA(NOV),FC(*),FCC(*)
         DOUBLE PRECISION, INTENT(OUT) :: SOL1(NOV)

! Local
         INTEGER K,L
         DOUBLE PRECISION SM,TMP

! Backsubstitution process for 1 block row
         DO K=NOV,1,-1
            SM=FAA(K)
            DO L=1,NOV
               SM=SM-FCC(L)*S1(L,K)
               SM=SM-SOL2(L)*S2(L,K)
            ENDDO
            DO L=1,NCB
               SM=SM-FC(L)*BB(L,K)
            ENDDO
            DO L=K+1,NOV
               SM=SM-SOL1(L)*A2(L,K)
            ENDDO
            SOL1(K)=SM/A2(K,K)
         ENDDO
!     Revert column pivoting on SOL1
         DO K=NOV,1,-1
            TMP=SOL1(K)
            SOL1(K)=SOL1(IPC(K))
            SOL1(IPC(K))=TMP
         ENDDO

       END SUBROUTINE BCKSUB1

      END SUBROUTINE BCKSUB

!     ---------- ------
      SUBROUTINE INFPAR(A,B,FA,SOL,FC,NA,NOV,NRA,NCA,NCB,ICF,X)

!  Arguments
      INTEGER, INTENT(IN) :: NA,NOV,NRA,NCA,NCB,ICF(NCA,*)
      DOUBLE PRECISION, INTENT(IN) :: A(NCA,NRA,*),B(NCB,NRA,*),FC(*)
      DOUBLE PRECISION, INTENT(IN) :: SOL(NOV,*)
      DOUBLE PRECISION, INTENT(OUT) :: X(NOV+1:NRA),FA(NRA,*)

! Local
      INTEGER I,J,IR
      DOUBLE PRECISION SM,TMP

! Determine the local varables by backsubstitition.

! Backsubstitution in the condensation of parameters; no communication.
      DO I=1,NA
         DO IR=NRA-NOV,1,-1
            SM=FA(IR,I)
            DO J=1,NOV
               SM=SM-A(J,IR,I)*SOL(J,I)
               SM=SM-A(NRA+J,IR,I)*SOL(J,I+1)
            ENDDO
            DO J=1,NCB
               SM=SM-B(J,IR,I)*FC(NOV+J)
            ENDDO
            DO J=IR+1,NRA-NOV
               SM=SM-A(J+NOV,IR,I)*X(J+NOV)
            ENDDO
            X(NOV+IR)=SM/A(NOV+IR,IR,I)
         ENDDO    
!        **Copy SOL into FA 
         DO J=1,NOV
            FA(J,I)=SOL(J,I)
         ENDDO
!        **Undo pivots and copy X into FA
         DO J=NRA,NOV+1,-1
            TMP=X(ICF(J,I))
            X(ICF(J,I))=X(J)
            X(J)=TMP
         ENDDO
         DO J=NOV+1,NRA
            FA(J,I)=X(J)
         ENDDO
      ENDDO

      END SUBROUTINE INFPAR

!     ---------- ------
      SUBROUTINE PRINT1(NA,NRA,NCA,NCB,NFC,NBC,A,B,C,CDBC,D,DD,FA, &
       FC,FCFC,IFST,NLLV)

      INTEGER, INTENT(IN) :: NA,NRA,NCA,NCB,NFC,NBC,IFST,NLLV
      DOUBLE PRECISION A(NCA,NRA,*),B(NCB,NRA,*),C(NCA,NFC-NBC,*)
      DOUBLE PRECISION CDBC(2*(NCA-NRA)+NCB,NBC),D(NCB,*),DD(NCB,NFC-NBC,*)
      DOUBLE PRECISION FA(NRA,*),FC(*),FCFC(NFC-NBC,*)

      INTEGER I,IR,IC
      DOUBLE PRECISION, ALLOCATABLE :: D1(:)
      DOUBLE PRECISION FC1

       WRITE(9,101)
       DO I=1,NA
         WRITE(9,102)I
         DO IR=1,NRA
           IF(NLLV==0)THEN
              WRITE(9,103)(A(IC,IR,I),IC=1,NCA),(B(IC,IR,I),IC=1,NCB),FA(IR,I)
           ELSE
              WRITE(9,103)(A(IC,IR,I),IC=1,NCA),(B(IC,IR,I),IC=1,NCB),0d0
           ENDIF
         ENDDO
       ENDDO

       WRITE(9,104)
       DO I=1,NA
         WRITE(9,102)I
         DO IR=1,NFC
           IF(IR.GT.NBC)THEN
             WRITE(9,103)(C(IC,IR-NBC,I),IC=1,NCA)
           ELSEIF(I.EQ.1)THEN
             WRITE(9,103)(CDBC(IC,IR),IC=1,NCA-NRA)
           ELSEIF(I.EQ.NA)THEN
             WRITE(9,103)(CDBC(NCA-NRA+IC,IR),IC=1,NCA-NRA)
           ENDIF
         ENDDO
       ENDDO

       WRITE(9,105)
       DO IR=1,NBC
         WRITE(9,103)(CDBC(2*(NCA-NRA)+IC,IR),IC=1,NCB),FC(IR)
       ENDDO
       ALLOCATE(D1(NCB))
       DO IR=1,NFC-NBC
         DO IC=1,NCB
           D1(IC)=D(IC,IR)
           IF(IFST==1)THEN
              DO I=1,NA
                 D1(IC)=D1(IC)+DD(IC,IR,I)
              ENDDO
           ENDIF
         ENDDO
         IF(NLLV==0)THEN
            FC1=FC(NBC+IR)
            DO I=1,NA
               FC1=FC1+FCFC(IR,I)
            ENDDO
         ELSE
            FC1=0
         ENDIF
         WRITE(9,103)(D1(IC),IC=1,NCB),FC1
       ENDDO
       DEALLOCATE(D1)

 101   FORMAT(' AA , BB , FA (Full dimension) :')
 102   FORMAT(' I=',I3)
 103   FORMAT(1X,12E10.3)
 104   FORMAT(' CC (Full dimension) :')
 105   FORMAT(' DD , FC')

      END SUBROUTINE PRINT1

      END MODULE SOLVEBV

!----------------------------------------------------------------------
!   lor:  Point-to-cycle connection in the Lorenz model via homotopy
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!     Adjoint scaled eigenfunction of the cycle in the Lorenz model
!
!     PAR(10)=square norm of the eigenfunction at T=0
!     PAR(12)=log(FM)
!---------------------------------------------------------------------- 

  SUBROUTINE RHS(N,U,PAR,F,DFDU,IJAC) 
! ---------- ---- 

    IMPLICIT NONE
    INTEGER N
    DOUBLE PRECISION U(N),PAR(*),F(N),DFDU(N,N)
    LOGICAL IJAC

    DOUBLE PRECISION x,y,z,r,b,sigma

!     System parameters
!     PAR(1)		! r
!     PAR(2)		! b
!     PAR(3)		! sigma

!     Variables
    x=U(1)
    y=U(2)
    z=U(3)
!     Parameters
    r=PAR(1)
    b=PAR(2)
    sigma=PAR(3)
!     RHS
    F(1)=sigma*(y-x)
    F(2)=r*x-y-x*z
    F(3)=x*y-b*z

    IF(.NOT.IJAC)RETURN

!     Jacobian elements
    DFDU(1,1)=-sigma
    DFDU(1,2)=sigma
    DFDU(1,3)=0.0d0
    DFDU(2,1)=r-z
    DFDU(2,2)=-1.d0
    DFDU(2,3)=-x
    DFDU(3,1)=y
    DFDU(3,2)=x
    DFDU(3,3)=-b

  END SUBROUTINE RHS

  SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
! ---------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,*), DFDP(NDIM,*)

    DOUBLE PRECISION A(3,3)
!     Variables
!     U(1)-U(3) = limit cycle
!     U(4)-U(6) = adjoint eigenfunction 
!     U(7)-U(9) = connecting orbit 
!     Cycle equations
    CALL RHS(3,U,PAR,F,A,NDIM/=3)
    IF(NDIM==3)RETURN
    F(1:3) = PAR(11)*F(1:3)

!     Adjoint variational equations
!     PAR(11) = cycle period
!     PAR(12) = log(FM) 
    F(4:6) = -PAR(11)*MATMUL(TRANSPOSE(A(:,:)),U(4:6))-PAR(12)*U(4:6)
    IF(NDIM==6)RETURN

!     Connecting orbit equations
    CALL RHS(3,U(7),PAR,F(7),A,.FALSE.) 
!     PAR(13) = connection interval     
    F(7:9) = PAR(13)*F(7:9)

  END SUBROUTINE FUNC

  SUBROUTINE STPNT(NDIM,U,PAR,T) 
! ---------- ----- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM), PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: T

    DOUBLE PRECISION r,b,sigma,v1,v2,v3,vnorm,eps,i


    IF (NDIM==9) THEN
       !extend system
       eps=PAR(23)
       U(7:9)=PAR(14:16) + eps*PAR(17:19)
       RETURN
    ENDIF

! Parameter values for the starting equilibrium
    r=0.d0
    b=8.0d0/3.0d0
    sigma=10.0d0
    U(1:3)=0.

    PAR(1)=r
    PAR(2)=b
    PAR(3)=sigma
!     Eigenvalue approx
    PAR(12)=-1.0d0
!     Initial connection time
    PAR(13)=0.0d0

!     Equilibrium coordinates
    PAR(14:16)=U(1:3)

!     Normalized exit eigenvector of the equilibrium
    r=21.0d0
    v1=1.0-sigma+SQRT((1.0-sigma)**2+4.0*r*sigma)
    v2=2.0*r
    v3=0.0D0
    vnorm=SQRT(v1**2+v2**2+v3**2)
    PAR(17)=v1/vnorm
    PAR(18)=v2/vnorm
    PAR(19)=v3/vnorm
!     Exit eigenvalue
    PAR(20)=(-1.0d0-sigma+SQRT((1.0d0-sigma)**2+4.0d0*r*sigma))/2.0d0

! epsilon for the starting point y0
    PAR(23)=-1d-4

  END SUBROUTINE STPNT


  SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
! ---------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    DOUBLE PRECISION X(3),R(3),A(3,3),V(3),H(3),epsilon,rlambda

!     Periodic boundary conditions
!     ----------------------------
    FB(1:3) = U0(1:3) - U1(1:3)
    FB(4:6) = U1(4:6) - U0(4:6)

!     Eigenfunction normalisation
    FB(7) = DOT_PRODUCT(U0(4:6),U0(4:6)) - PAR(10)
    IF(NBC == 7)RETURN

    ! Exit eigenvector
    V(:) = PAR(17:19)

    ! Connecting orbit starting point 
    epsilon = PAR(23)
    FB(8:10) = U0(7:9)-PAR(14:16)-epsilon*V(:)
       
    ! Equilibrium coordinates
    CALL RHS(3,PAR(14:16),PAR,FB(11:13),A,.TRUE.) 

    ! Exit eigenvalue
    rlambda = PAR(20)
    FB(14:16) = MATMUL(A(:,:),V(:))-rlambda*V(:)

    ! Exit vector normalization
    FB(17) = DOT_PRODUCT(V(:),V(:)) - 1.0d0

    ! Connection endpoint in the orthogonal plane to velocity
    H(:) = U1(7:9) - U0(1:3)
    CALL RHS(3,U0,PAR,R,A,.FALSE.)
    FB(18) = DOT_PRODUCT(H(:),R(:)) - PAR(21)

    ! Projection boundary condition at the endpoint
    FB(19) = DOT_PRODUCT(H(:),U0(4:6)) - PAR(22)

  END SUBROUTINE BCND

  SUBROUTINE PVLS(NDIM,U,PAR)
! ---------- ----

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    DOUBLE PRECISION GETP

    DOUBLE PRECISION X(3),W(3),F(3),A(3,3),H(3),length

    IF(NDIM==6)THEN
       ! Initial values for homotopy parameters
       ! Base point on the cycle       
       X(1)=GETP('BV0',1,U)
       X(2)=GETP('BV0',2,U)
       X(3)=GETP('BV0',3,U)
       ! End point of the initial connection
       length=PAR(23)*EXP(PAR(20)*PAR(13))
       H(1:3)=PAR(14:16)+length*PAR(17:19)-X(1:3)
       CALL RHS(3,X,PAR,F,A,.FALSE.)

       ! Homotopy parameter
       PAR(21) = DOT_PRODUCT(H,F)

       ! Eigenfunction at t=0           
       W(1)=GETP('BV0',4,U)
       W(2)=GETP('BV0',5,U)
       W(3)=GETP('BV0',6,U)
       ! Homotopy parameter
       PAR(22) = DOT_PRODUCT(H,W)
    ENDIF

  END SUBROUTINE PVLS

  SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT) 
! ---------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM),UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    ! Integral phase condition 
    ! ------------------------
    FI(1) = DOT_PRODUCT(U(:3),UPOLD(:3))

  END SUBROUTINE ICND

  SUBROUTINE FOPT 
  END SUBROUTINE FOPT

module compat

implicit none
public :: autoflush, autim, autargc, autgetarg

contains

! This file calls no extensions (see f2003.f90 for the new Standard forms)
! You can edit it to adjust these routines to the compiler that is used.

  subroutine autoflush(i)
    integer, intent(in) :: i
    !call flush(i)
  end subroutine autoflush

!-----------------------------------------------------------------------
!          Timing AUTO
!-----------------------------------------------------------------------

! ------ --------- --------
  double precision function autim()

    !call cpu_time(etime)
    !autim = etime
    autim = -1

  end function autim

  integer function autargc()
    autargc = 0
  end function autargc

  subroutine autgetarg(number,value)
    integer, intent(in) :: number
    character(len=*), intent(out) :: value
  end subroutine autgetarg

end module compat

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for the Continuation of general BVPs
!        (incl. BPs and Folds)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
MODULE TOOLBOXBV

  USE AUTO_CONSTANTS, ONLY : AUTOPARAMETERS
  USE INTERFACES
  USE BVP
  USE SUPPORT

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: INITBVP,AUTOBVP,STPNBV,STPNBV1,FNCSBV,FNBLF,BCBLF,ICBLF,STPNBL

  DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

CONTAINS

! ---------- -------
  SUBROUTINE INITBVP(AP,ICP)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)

    INTEGER I, ISW, ITP, NDIM, NBC, NINT, NFPR, NXP, NPAR
    ISW = AP%ISW
    ITP = AP%ITP
    NDIM = AP%NDIM
    NBC = AP%NBC
    NINT = AP%NINT
    NPAR = AP%NPAR

    ! Two-Parameter Continuation for IPS=4 or IPS=7.
    IF(ABS(ISW)==2.AND.(ITP==5.OR.(ABS(ITP)/10)==5))THEN
       ! ** Continuation of folds (BVP; start/restart)
       NDIM=2*NDIM
       NBC=2*NBC
       NINT=2*NINT+1
       NFPR=NBC+NINT-NDIM+1
       DO I=2,NFPR/2
          ICP(NFPR/2+I)=NPAR+I-1
       ENDDO
       ! PAR(NPAR+NFPR/2) contains a norm
       AP%NPARI=NFPR/2
       IF(ITP==5)THEN
          ! ** Continuation of folds (BVP; start)
          ICP(NFPR/2+1)=NPAR+NFPR/2
          AP%ISW=-2
       ENDIF
    ENDIF
    IF(ABS(ISW)>=2.AND.(ITP==6.OR.ABS(ITP)/10==6)) THEN
       ! ** BP cont (BVP, start and restart) (by F. Dercole).
       NXP=NBC+NINT-NDIM+1
       DO I=1,NXP+NDIM-1
          ICP(NXP+I+2)=NPAR+I ! psi^*_2,psi^*_3
       ENDDO
       DO I=1,NXP
          ICP(2*NXP+NDIM+I+1)=NPAR+NXP+NDIM+I ! d
       ENDDO
       IF(ITP==6)THEN
          ! ** BP cont (BVP; start)
          ICP(NXP+1)=NPAR+NXP+NDIM ! a
          ICP(NXP+2)=NPAR+2*NXP+NDIM+1 ! b
          DO I=1,NXP
             ICP(3*NXP+NDIM+I+1)=NPAR+2*NXP+NDIM+1+I ! q
             ICP(4*NXP+NDIM+I+1)=NPAR+3*NXP+NDIM+1+I ! r
          ENDDO
          ICP(5*NXP+NDIM+2)=NPAR+4*NXP+NDIM+2 ! c1
          ICP(5*NXP+NDIM+3)=NPAR+4*NXP+NDIM+3 ! c2
          AP%NPARI=4*NXP+NDIM+3
          AP%ISW=-ABS(ISW)
          NDIM=4*NDIM
          NBC=3*NBC+NDIM/2+NXP
          NINT=3*NINT+NXP+5
       ELSE
          ! ** BP cont (BVP; restart 1 or 2)
          AP%NPARI=2*NXP+NDIM
          IF(ABS(ISW)==2)THEN
             ! ** Non-generic case
             ICP(NXP+2)=NPAR+2*NXP+NDIM+1 ! b
             AP%NPARI=AP%NPARI+1
          ENDIF
          NDIM=2*NDIM
          NBC=NBC+NDIM+NXP
          NINT=NINT+NXP+1
       ENDIF
    ENDIF
    AP%NDIM = NDIM
    AP%NBC = NBC
    AP%NINT = NINT
    AP%NFPR = NBC+NINT-NDIM+1

  END SUBROUTINE INITBVP

! ---------- -------
  SUBROUTINE AUTOBVP(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    INTEGER ISW, ITP

    CALL INITBVP(AP,ICP)

    ISW = AP%ISW
    ITP = AP%ITP

    IF(ABS(ISW)<=1)THEN
       ! ** Boundary value problems (here IPS=4)
       CALL AUTOBV(AP,ICP,ICU,FUNI,BCNI,ICNI,STPNBV,FNCSBV)
    ELSE
       ! Two-Parameter Continuation for IPS=4 or IPS=7.
       IF(ABS(ISW)==2)THEN
          IF(ITP==5)THEN
             ! ** Continuation of folds (BVP, start).
             CALL AUTOBV(AP,ICP,ICU,FNBL,BCBL,ICBL,STPNBL,FNCSBV)
          ELSE IF(ABS(ITP)/10==5) THEN
             ! ** Continuation of folds (BVP, restart).
             CALL AUTOBV(AP,ICP,ICU,FNBL,BCBL,ICBL,STPNBV,FNCSBV)
          ENDIF
       ENDIF
       IF((ITP==6.OR.(ABS(ITP)/10)==6)) THEN
          ! ** BP cont (BVP, start and restart) (by F. Dercole).
          CALL AUTOBV(AP,ICP,ICU,FNBBP,BCBBP,ICBBP,STPNBBP,FNCSBV)
       ENDIF
    ENDIF

  END SUBROUTINE AUTOBVP

! ---------- ------
  SUBROUTINE STPNBV(AP,PAR,ICP,NTSR,NCOLRS,RLDOT, &
       UPS,UDOTPS,TM,NODIR)

    USE MESH

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR),TM(0:*)
    DOUBLE PRECISION, INTENT(OUT) :: UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*)

    INTEGER NDIM,IPS,ISW,NTST,NCOL,NDIMRD,NTSRS
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    NDIM=AP%NDIM
    IPS=AP%IPS
    ISW=AP%ISW
    NTST=AP%NTST
    NCOL=AP%NCOL

    IF(AP%IRS==0)THEN
       CALL STPNUB(AP,PAR,RLDOT,UPS,UDOTPS,TM,NODIR)
       RETURN
    ENDIF

    ALLOCATE(UPSR(NDIM,0:NCOLRS*NTSR),UDOTPSR(NDIM,0:NCOLRS*NTSR), &
         TMR(0:NTSR))
    CALL STPNBV1(AP,PAR,ICP,NDIM,NTSRS,NDIMRD,NCOLRS,RLDOT, &
         UPSR,UDOTPSR,TMR,NODIR)
    CALL ADAPT2(NTSR,NCOLRS,NDIM,NTST,NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,(IPS==2.OR.IPS==12) .AND. ABS(ISW)<=1)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNBV

! ---------- -------
  SUBROUTINE STPNBV1(AP,PAR,ICP,NDIM,NTSRS,NDIMRD,NCOLRS,RLDOT, &
       UPS,UDOTPS,TM,NODIR)

    USE IO

! This subroutine locates and retrieves the information required to
! restart computation at the point with label IRS.
! This information is expected on unit 3.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    INTEGER, INTENT(OUT) :: NTSRS,NCOLRS,NDIMRD,NODIR
    DOUBLE PRECISION, INTENT(OUT) :: UPS(*),UDOTPS(*),TM(*)
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR)
! Local
    INTEGER NFPR,NFPRS,ITPRS,NDIMRS,I
    INTEGER, ALLOCATABLE :: ICPRS(:)

    NFPR=AP%NFPR

    ALLOCATE(ICPRS(NFPR))
    ICPRS(:)=0
    CALL READBV(AP,PAR,ICPRS,NTSRS,NCOLRS,NDIMRD,RLDOT,UPS, &
         UDOTPS,TM,ITPRS,NDIM)

! Take care of the case where the free parameters have been changed at
! the restart point.

    NODIR=0
    NFPRS=GETNFPR3()
    NDIMRS=GETNDIM3()
    IF(NFPRS.NE.NFPR.OR.NDIM.NE.NDIMRS)THEN
       NODIR=1
    ELSE
       DO I=1,NFPR
          IF(ICPRS(I).NE.ICP(I)) THEN
             NODIR=1
             EXIT
          ENDIF
       ENDDO
    ENDIF
    DEALLOCATE(ICPRS)

  END SUBROUTINE STPNBV1

! ---------- ------
  SUBROUTINE STPNUB(AP,PAR,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE MESH
    USE AUTO_CONSTANTS, ONLY : DATFILE, UVALS, PARVALS, unames, parnames
    USE SUPPORT, ONLY: NAMEIDX, AUTOSTOP

! Generates a starting point for the continuation of a branch of
! of solutions to general boundary value problems by calling the user
! supplied subroutine STPNT where an analytical solution is given.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR)
    DOUBLE PRECISION, INTENT(OUT) :: TM(0:*),UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*)

    INTEGER NDIM,IPS,NTST,NCOL,ISW,NTSR,ios,I,J
    DOUBLE PRECISION TEMP,PERIOD
    DOUBLE PRECISION, ALLOCATABLE :: TMR(:),UPSR(:,:),UDOTPSR(:,:),U(:)

    NDIM=AP%NDIM
    IPS=AP%IPS
    NTST=AP%NTST
    NCOL=AP%NCOL
    ISW=AP%ISW

! Generate the (initially uniform) mesh.

    CALL MSH(NTST,TM)

    IF(DATFILE/='')THEN
       OPEN(3,FILE=TRIM(DATFILE),STATUS='old',ACCESS='sequential',&
            IOSTAT=ios)
       IF(ios/=0)THEN
          OPEN(3,FILE=TRIM(DATFILE)//'.dat',STATUS='old',&
               ACCESS='sequential',IOSTAT=ios)
       ENDIF
       IF(ios/=0)THEN
          WRITE(6,"(A,A,A)")'Datafile ',TRIM(DATFILE),' not found.'
          CALL AUTOSTOP()
       ENDIF
       NTSR=-1
       DO
          READ(3,*,END=2)TEMP,(TEMP,I=1,NDIM)
          NTSR=NTSR+1
       ENDDO
2      CONTINUE
       ALLOCATE(TMR(0:NTSR),UPSR(NDIM,0:NTSR),UDOTPSR(NDIM,0:NTSR),U(NDIM))
       REWIND 3
       DO J=0,NTSR
          READ(3,*)TMR(J),UPSR(:,J)
       ENDDO
       CLOSE(3)
       UDOTPSR(:,:)=0.d0
       PERIOD=TMR(NTSR)-TMR(0)
       DO I=NTSR,0,-1
          TMR(I)=(TMR(I)-TMR(0))/PERIOD
       ENDDO
       CALL ADAPT2(NTSR,1,NDIM,NTST,NCOL,NDIM, &
            TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,(IPS==2.OR.IPS==12).AND.ABS(ISW)<=1)
       IF(AP%NPAR>10)THEN
          PAR(11)=PERIOD
       ENDIF
       CALL STPNT(NDIM,U,PAR,0d0)
       RLDOT(:)=0.d0
       DEALLOCATE(TMR,UPSR,UDOTPSR,U)
    ELSE
       DO J=0,NTST*NCOL
          UPS(:,J)=0.d0
          CALL STPNT(NDIM,UPS(1,J),PAR,DBLE(J)/(NTST*NCOL))
       ENDDO
    ENDIF

! override parameter values with values from constants file

    DO I=1,SIZE(UVALS)
       UPS(NAMEIDX(UVALS(I)%INDEX,unames),0:NTST*NCOL)=UVALS(I)%VAR
    ENDDO
    DO I=1,SIZE(PARVALS)
       PAR(NAMEIDX(PARVALS(I)%INDEX,parnames))=PARVALS(I)%VAR
    ENDDO

    NODIR=1

  END SUBROUTINE STPNUB

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSBV(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE) RESULT(Q)

    USE AUTO_CONSTANTS, ONLY : NPARX
    USE SUPPORT, ONLY: P1=>P1V

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: UPS(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    Q=0.d0
    ATYPE=''
    SELECT CASE(ITEST)
    CASE(0)
       CALL PVLSI(AP,UPS,NDIM,PAR)
    CASE(1)
       Q=FNLPBV(AP,ATYPE)
    CASE(2)
       Q=FNBPBV(AP,ATYPE,P1)
    END SELECT

  END FUNCTION FNCSBV
       
! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNLPBV(AP,ATYPE)

    USE MESH
    USE SOLVEBV
    USE SUPPORT, ONLY: CHECKSP

! RETURNS A QUANTITY THAT CHANGES SIGN AT A LIMIT POINT (BVP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    INTEGER IID,IBR,NTOT,NTOP

    ATYPE=''
    FNLPBV=0d0
    IF(.NOT.CHECKSP('LP',AP%IPS,AP%ILP,AP%ISP))RETURN

    IID=AP%IID
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    FNLPBV=AP%FLDF
    IF(IID.GE.2)THEN
       WRITE(9,101)ABS(IBR),NTOP+1,FNLPBV
    ENDIF

! Set the quantity to be returned.

    ATYPE='LP'

101 FORMAT(I4,I6,9X,'Fold Function ',ES14.5)

  END FUNCTION FNLPBV

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNBPBV(AP,ATYPE,P1)

    USE SUPPORT

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: P1(*)

! Local
    DOUBLE PRECISION, ALLOCATABLE :: PP(:)
    INTEGER IID,I,IBR,NTOP,NTOT,NDIM
    DOUBLE PRECISION U(1),F(1),DET

    ATYPE=''
    FNBPBV=0d0
    AP%BIFF=FNBPBV
    IF(.NOT.CHECKSP('BP',AP%IPS,AP%ILP,AP%ISP))RETURN

    NDIM=AP%NDIM
    IID=AP%IID

    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

! Compute the determinant of P1.

    ALLOCATE(PP(NDIM**2))
    DO I=1,NDIM**2
       PP(I)=P1(I)
    ENDDO
    CALL GEL(NDIM,PP,0,U,F,DET)
    DEALLOCATE(PP)

! AP%DET contains the determinant of the reduced system.
! Set the determinant of the normalized reduced system.

    IF(ABS(AP%DET)/HUGE(DET).LT.ABS(DET))THEN
       FNBPBV=AP%DET/DET
       ATYPE='BP'
    ENDIF
    AP%BIFF=FNBPBV

    IF(IID.GE.2)WRITE(9,101)ABS(IBR),NTOP+1,FNBPBV
101 FORMAT(I4,I6,9X,'BP   Function ',ES14.5)

  END FUNCTION FNBPBV

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for the Continuation of Folds for BVP.
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNBL(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNBLF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

  END SUBROUTINE FNBL

! ---------- -----
  SUBROUTINE FNBLF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

    ! Generates the equations for the 2-parameter continuation
    ! of folds (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),DFP(:,:),FF1(:),FF2(:)
    INTEGER NDM,NFPR,NFPX,NPAR,I,J
    DOUBLE PRECISION UU,UMX,EP,P

    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ! Generate the function.

    CALL FFBL(AP,U,UOLD,ICP,PAR,F,NDM,DFDU,DFDP,FUNI)

    IF(IJAC==0)RETURN

    ! Generate the Jacobian.

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,NPAR,NDM,NDIM)
    DFDU(1:NDM,NDM+1:NDIM)=0d0
    DFDU(NDM+1:NDIM,NDM+1:NDIM)=DFDU(1:NDM,1:NDM)
    IF(IJAC==2)THEN
       NFPX=NFPR/2-1
       DO I=1,NFPR-NFPX
          DFDP(1:NDM,ICP(I))=DFDP(1:NDM,ICP(I))
       ENDDO
       DO I=1,NFPX
          DFDP(1:NDM,ICP(NFPR-NFPX+I))=0d0
          DFDP(NDM+1:NDIM,ICP(NFPR-NFPX+I))=DFDP(1:NDM,ICP(I+1))
       ENDDO
    ENDIF

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I))>UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(FF1(NDIM),FF2(NDIM),DFU(NDM,NDM),DFP(NDM,NPAR))
    DO I=1,NDM
       UU=U(I)
       U(I)=UU-EP
       CALL FFBL(AP,U,UOLD,ICP,PAR,FF1,NDM,DFU,DFP,FUNI)
       U(I)=UU+EP
       CALL FFBL(AP,U,UOLD,ICP,PAR,FF2,NDM,DFU,DFP,FUNI)
       U(I)=UU
       DO J=NDM+1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF (IJAC==1)THEN
       DEALLOCATE(DFU,DFP,FF1)
       RETURN
    ENDIF

    NFPX=NFPR/2-1
    DO I=1,NFPR-NFPX
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FFBL(AP,U,UOLD,ICP,PAR,FF1,NDM,DFU,DFP,FUNI)
       DO J=1,NDIM
          DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(DFU,DFP,FF1)
  END SUBROUTINE FNBLF

! ---------- ----
  SUBROUTINE FFBL(AP,U,UOLD,ICP,PAR,F,NDM,DFDU,DFDP,FUNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDM
    DOUBLE PRECISION, INTENT(IN) :: UOLD(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(2*NDM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    include 'interfaces.h'

    INTEGER NFPR,NFPX,I,J

    NFPR=AP%NFPR

    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,2,F,DFDU,DFDP)

    NFPX=NFPR/2-1
    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(I,J)*U(NDM+J)
       ENDDO
       DO J=1,NFPX
          F(NDM+I)=F(NDM+I) + DFDP(I,ICP(1+J))*PAR(ICP(NFPR-NFPX+J))
       ENDDO
    ENDDO

  END SUBROUTINE FFBL

! ---------- ----
  SUBROUTINE BCBL(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    ! Generates the boundary conditions for the 2-parameter continuation
    ! of folds (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    CALL BCBLF(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC,BCNI)

  END SUBROUTINE BCBL

! ---------- -----
  SUBROUTINE BCBLF(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC,BCNI)

    ! Generates the boundary conditions for the 2-parameter continuation
    ! of folds (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: FF1(:),FF2(:),DFU(:,:)
    INTEGER NDM,NBC0,NFPR,NPAR,I,J
    DOUBLE PRECISION UMX,EP,P,UU

    NDM=AP%NDM
    NBC0=NBC/2
    NFPR=AP%NFPR
    NPAR=AP%NPAR
    ALLOCATE(DFU(NBC0,2*NDM+NPAR))

    ! Generate the function.

    CALL FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,F,DFU,BCNI)

    IF(IJAC==0)THEN
       DEALLOCATE(DFU)
       RETURN
    ENDIF

    ALLOCATE(FF1(NBC),FF2(NBC))

    ! Derivatives with respect to U0.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U0(I))>UMX)UMX=DABS(U0(I))
    ENDDO
    EP=HMACH*(1+UMX)
    DO I=1,NDIM
       UU=U0(I)
       U0(I)=UU-EP
       CALL FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,FF1,DFU,BCNI)
       U0(I)=UU+EP
       CALL FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,FF2,DFU,BCNI)
       U0(I)=UU
       DO J=1,NBC
          DBC(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    ! Derivatives with respect to U1.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U1(I))>UMX)UMX=DABS(U1(I))
    ENDDO
    EP=HMACH*(1+UMX)
    DO I=1,NDIM
       UU=U1(I)
       U1(I)=UU-EP
       CALL FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,FF1,DFU,BCNI)
       U1(I)=UU+EP
       CALL FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,FF2,DFU,BCNI)
       U1(I)=UU
       DO J=1,NBC
          DBC(J,NDIM+I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF1)
    IF(IJAC==1)THEN
       DEALLOCATE(FF2,DFU)
       RETURN
    ENDIF

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,FF2,DFU,BCNI)
       DO J=1,NBC
          DBC(J,2*NDIM+ICP(I))=(FF2(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(DFU,FF2)
  END SUBROUTINE BCBLF

! ---------- ----
  SUBROUTINE FBBL(AP,NDIM,PAR,ICP,NBC0,U0,U1,F,DBC,BCNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC0
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC0+AP%NDM+AP%NFPR/2-1)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC0,*)
    include 'interfaces.h'

    INTEGER NDM,NFPR,NFPX,I,J

    NDM=AP%NDM
    NFPR=AP%NFPR

    NFPX=NFPR/2-1
    CALL BCNI(AP,NDM,PAR,ICP,NBC0,U0,U1,F,2,DBC)
    DO I=1,NBC0
       F(NBC0+I)=0.d0
       DO J=1,NDM
          F(NBC0+I)=F(NBC0+I)+DBC(I,J)*U0(NDM+J)
          F(NBC0+I)=F(NBC0+I)+DBC(I,NDM+J)*U1(NDM+J)
       ENDDO
       DO J=1,NFPX
          F(NBC0+I)=F(NBC0+I) + DBC(I,NDIM+ICP(1+J))*PAR(ICP(NFPR-NFPX+J))
       ENDDO
    ENDDO

  END SUBROUTINE FBBL

! ---------- ----
  SUBROUTINE ICBL(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Generates integral conditions for the 2-parameter continuation of
    ! folds (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    CALL ICBLF(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT,ICNI)

  END SUBROUTINE ICBL

! ---------- -----
  SUBROUTINE ICBLF(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT,ICNI)

    ! Generates integral conditions for the 2-parameter continuation of
    ! folds (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: FF1(:),FF2(:),DFU(:,:)
    INTEGER NDM,NNT0,NFPR,NPAR,I,J,NFPX
    DOUBLE PRECISION UMX,EP,P,UU

    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ! Note that PAR(NPAR) is used to keep the norm of the null vector

    F(NINT)=-PAR(NPAR)
    DO I=1,NDM
       F(NINT)=F(NINT)+U(NDM+I)*U(NDM+I)
    ENDDO
    IF(IJAC/=0)THEN
       DINT(NINT,NDM+1:NDIM)=2*U(NDM+1:NDIM)
       IF(IJAC/=1.AND.ICP(NFPR/2+1)==NPAR)THEN
          DINT(NINT,NDIM+NPAR)=-1
       ENDIF
    ENDIF

    IF(NINT==1)RETURN

    NNT0=(NINT-1)/2
    NFPX=NFPR/2-1
    ALLOCATE(DFU(NNT0,NDM+NPAR))

    ! Generate the function.

    CALL FIBL(AP,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,F,DFU,ICNI)
    DO I=1,NFPX
       F(NINT)=F(NINT)+PAR(ICP(NFPR-NFPX+I))**2
    ENDDO

    IF(IJAC==0)THEN
       DEALLOCATE(DFU)
       RETURN
    ENDIF

    ! Generate the Jacobian.

    DINT(1:NNT0,1:NDM)=DFU(1:NNT0,1:NDM)
    DINT(NNT0+1:NINT-1,NDM+1:NDIM)=DFU(1:NNT0,1:NDM)
    IF(IJAC/=1)THEN
       DO I=1,NFPR
          DINT(1:NNT0,NDIM+ICP(I))=DFU(1:NNT0,NDM+ICP(I))
          IF(I>=NFPR-NFPX+1)THEN
             DINT(NNT0+1:NINT-1,NDIM+ICP(I))=DFU(1:NNT0,NDM+ICP(I-NFPX-1))
             DINT(NINT,NDIM+ICP(I))=2*PAR(ICP(I))
          ENDIF
       ENDDO
    ENDIF

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I))>UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(FF1(NINT),FF2(NINT))
    DO I=1,NDM
       UU=U(I)
       U(I)=UU-EP
       CALL FIBL(AP,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FF1,DFU,ICNI)
       U(I)=UU+EP
       CALL FIBL(AP,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FF2,DFU,ICNI)
       U(I)=UU
       DO J=NNT0+1,NINT-1
          DINT(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC==1)THEN
       DEALLOCATE(FF1,DFU)
       RETURN
    ENDIF

    DO I=1,NFPR-NFPX
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FIBL(AP,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FF1,DFU,ICNI)
       DO J=NNT0+1,NINT-1
          DINT(J,NDIM+ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(FF1,DFU)
  END SUBROUTINE ICBLF

! ---------- ----
  SUBROUTINE FIBL(AP,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,F,DINT,ICNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NINT,NNT0
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*),UDOT(*),UPOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(*),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NNT0,*)
    include 'interfaces.h'
    INTEGER NDM,NFPR,NFPX,I,J

    NDM=AP%NDM
    NFPR=AP%NFPR
    NFPX=NFPR/2-1

    CALL ICNI(AP,NDM,PAR,ICP,NNT0,U,UOLD,UDOT,UPOLD,F,2,DINT)
    DO I=1,NNT0
       F(NNT0+I)=0.d0
       DO J=1,NDM
          F(NNT0+I)=F(NNT0+I)+DINT(I,J)*U(NDM+J)
       ENDDO
       DO J=1,NFPX
          F(NNT0+I)=F(NNT0+I) + DINT(I,NDM+ICP(1+J))*PAR(ICP(NFPR-NFPX+J))
       ENDDO
    ENDDO

  END SUBROUTINE FIBL

! ---------- ------
  SUBROUTINE STPNBL(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE IO
    USE MESH

    ! Generates starting data for the 2-parameter continuation of folds.
    ! (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    INTEGER, ALLOCATABLE :: ICPRS(:)
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER NDIM,NDM,NFPR,NDIMRD,ITPRS,I,NPAR

    NDIM=AP%NDIM
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ALLOCATE(ICPRS(NFPR))
    ALLOCATE(UPSR(NDM,0:NCOLRS*NTSR),UDOTPSR(NDM,0:NCOLRS*NTSR),TMR(0:NTSR))
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOT,UPSR, &
         UDOTPSR,TMR,ITPRS,NDM)
    DEALLOCATE(ICPRS)

    DO I=NFPR/2+1,NFPR
       PAR(ICP(I))=0.d0
    ENDDO

    NODIR=0
    CALL ADAPT2(NTSR,NCOLRS,NDM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNBL

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!   Subroutines for BP cont (BVPs) (by F. Dercole)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- -----
  SUBROUTINE FNBBP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-parameter continuation
    ! of BP (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),DFP(:,:),FF1(:),FF2(:)
    INTEGER NDM,NFPR,NPAR,I,J
    DOUBLE PRECISION UMX,EP,P,UU

    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN
       CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)
       RETURN
    ENDIF

    ! Generate the function.

    CALL FFBBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,F,NDM,DFDU,DFDP)

    IF(IJAC==0)RETURN

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I))>UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(FF1(NDIM),FF2(NDIM),DFU(NDM,NDM),DFP(NDM,NPAR))
    DO I=1,NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FFBBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,FF1,NDM,DFU,DFP)
       U(I)=UU+EP
       CALL FFBBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,FF2,NDM,DFU,DFP)
       U(I)=UU
       DO J=1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF (IJAC==1)THEN
       DEALLOCATE(DFU,DFP,FF1)
       RETURN
    ENDIF

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FFBBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,FF1,NDM,DFU,DFP)
       DO J=1,NDIM
          DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(DFU,DFP,FF1)

  END SUBROUTINE FNBBP

! ---------- -----
  SUBROUTINE FFBBP(AP,NDIM,U,UOLD,UPOLD,ICP,PAR,F,NDM,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NDM
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UPOLD(NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: FI(:),DINT(:,:)
    DOUBLE PRECISION DUM(1)
    INTEGER ISW,NBC,NINT,NBC0,NNT0,NFPX,I,J,NPARU

    ISW=AP%ISW
    NBC=AP%NBC
    NINT=AP%NINT
    NPARU=AP%NPAR-AP%NPARI ! real - internal

    IF(ISW<0) THEN
       !        ** start
       NBC0=(4*NBC-NINT-5*NDM+2)/15
       NNT0=(-NBC+4*NINT+5*NDM-23)/15
    ELSE IF(ISW==2) THEN
       !        ** Non-generic case
       NBC0=(2*NBC-NINT-3*NDM)/3
       NNT0=(-NBC+2*NINT+3*NDM-3)/3
    ELSE
       !        ** generic case
       NBC0=(2*NBC-NINT-3*NDM)/3
       NNT0=(-NBC+2*NINT+3*NDM-3)/3
    ENDIF
    NFPX=NBC0+NNT0-NDM+1

    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,2,F,DFDU,DFDP)

    IF((ISW==2).OR.(ISW<0)) THEN
       !        ** Non-generic and/or start
       DO I=1,NDM
          F(I)=F(I)-PAR(NPARU+2*NFPX+NDM+1)*U(NDM+I)
       ENDDO
    ENDIF

    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)-DFDU(J,I)*U(NDM+J)
       ENDDO
    ENDDO

    IF(NNT0>0) THEN
       ALLOCATE(FI(NNT0),DINT(NNT0,NDM))
       CALL ICNI(AP,NDM,PAR,ICP,NNT0,U,UOLD,DUM,UPOLD,FI,1,DINT)
       DO I=1,NDM
          DO J=1,NNT0
             F(NDM+I)=F(NDM+I)+DINT(J,I)*PAR(NPARU+NBC0+J)
          ENDDO
       ENDDO
       DEALLOCATE(FI,DINT)
    ENDIF

    IF(ISW<0) THEN
       !        ** start
       DO I=1,NDM
          F(NDM+I)=F(NDM+I)+PAR(NPARU+4*NFPX+NDM+2)*U(2*NDM+I)+ &
               PAR(NPARU+4*NFPX+NDM+3)*U(3*NDM+I)
          F(2*NDM+I)=0.d0
          F(3*NDM+I)=0.d0
          DO J=1,NDM
             F(2*NDM+I)=F(2*NDM+I)+DFDU(I,J)*U(2*NDM+J)
             F(3*NDM+I)=F(3*NDM+I)+DFDU(I,J)*U(3*NDM+J)
          ENDDO
          DO J=1,NFPX
             F(2*NDM+I)=F(2*NDM+I)+DFDP(I,ICP(J))*PAR(NPARU+2*NFPX+NDM+1+J)
             F(3*NDM+I)=F(3*NDM+I)+DFDP(I,ICP(J))*PAR(NPARU+3*NFPX+NDM+1+J)
          ENDDO
       ENDDO
    ENDIF

  END SUBROUTINE FFBBP

! ---------- -----
  SUBROUTINE BCBBP(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    ! Generates the boundary conditions for the 2-parameter continuation
    ! of BP (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: FF1(:),FF2(:),DFU(:,:)
    INTEGER ISW,NINT,NDM,NFPR,NPAR,NBC0,I,J
    DOUBLE PRECISION UMX,EP,P,UU

    ISW=AP%ISW
    NINT=AP%NINT
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN
       CALL BCNI(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)
       RETURN
    ENDIF

    IF(ISW<0) THEN
       ! ** start
       NBC0=(4*NBC-NINT-5*NDM+2)/15
    ELSE IF(ISW==2) THEN
       ! ** Non-generic case
       NBC0=(2*NBC-NINT-3*NDM)/3
    ELSE
       ! ** generic case
       NBC0=(2*NBC-NINT-3*NDM)/3
    ENDIF

    ! Generate the function.

    ALLOCATE(DFU(NBC0,2*NDM+NPAR))
    CALL FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,F,DFU)

    IF(IJAC==0)THEN
       DEALLOCATE(DFU)
       RETURN
    ENDIF

    ALLOCATE(FF1(NBC),FF2(NBC))

    ! Derivatives with respect to U0.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U0(I))>UMX)UMX=DABS(U0(I))
    ENDDO
    EP=HMACH*(1+UMX)
    DO I=1,NDIM
       UU=U0(I)
       U0(I)=UU-EP
       CALL FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,FF1,DFU)
       U0(I)=UU+EP
       CALL FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,FF2,DFU)
       U0(I)=UU
       DO J=1,NBC
          DBC(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    ! Derivatives with respect to U1.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U1(I))>UMX)UMX=DABS(U1(I))
    ENDDO
    EP=HMACH*(1+UMX)
    DO I=1,NDIM
       UU=U1(I)
       U1(I)=UU-EP
       CALL FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,FF1,DFU)
       U1(I)=UU+EP
       CALL FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,FF2,DFU)
       U1(I)=UU
       DO J=1,NBC
          DBC(J,NDIM+I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC==1)THEN
       DEALLOCATE(FF1,DFU)
       RETURN
    ENDIF

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,FF1,DFU)
       DO J=1,NBC
          DBC(J,2*NDIM+ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(FF1,DFU)

    RETURN
  END SUBROUTINE BCBBP

  !     ---------- -----
  SUBROUTINE FBBBP(AP,NDIM,PAR,ICP,NBC,NBC0,U0,U1,FB,DBC)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,NBC0
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC0,*)

    INTEGER ISW,NINT,NDM,NNT0,NFPX,I,J,NPARU,IBC

    ISW=AP%ISW
    NINT=AP%NINT
    NDM=AP%NDM
    NPARU=AP%NPAR-AP%NPARI

    IF(ISW<0) THEN
       !        ** start
       NNT0=(-NBC+4*NINT+5*NDM-23)/15
    ELSE IF(ISW==2) THEN
       !        ** Non-generic case
       NNT0=(-NBC+2*NINT+3*NDM-3)/3
    ELSE
       !        ** generic case
       NNT0=(-NBC+2*NINT+3*NDM-3)/3
    ENDIF
    NFPX=NBC0+NNT0-NDM+1

    CALL BCNI(AP,NDM,PAR,ICP,NBC0,U0,U1,FB,2,DBC)

    IF((ISW==2).OR.(ISW<0)) THEN
       !        ** Non-generic and/or start
       DO I=1,NBC0
          FB(I)=FB(I)+PAR(NPARU+2*NFPX+NDM+1)*PAR(NPARU+I)
       ENDDO
    ENDIF

    DO I=1,NDM
       FB(NBC0+I)=-U0(NDM+I)
       FB(NBC0+NDM+I)=U1(NDM+I)
       DO J=1,NBC0
          FB(NBC0+I)=FB(NBC0+I)+DBC(J,I)*PAR(NPARU+J)
          FB(NBC0+NDM+I)=FB(NBC0+NDM+I)+DBC(J,NDM+I)*PAR(NPARU+J)
       ENDDO
    ENDDO
    DO I=1,NFPX
       FB(NBC0+2*NDM+I)=PAR(NPARU+NFPX+NDM+I)
       DO J=1,NBC0
          FB(NBC0+2*NDM+I)=FB(NBC0+2*NDM+I)+ &
               DBC(J,2*NDM+ICP(I))*PAR(NPARU+J)
       ENDDO
    ENDDO

    IF(ISW<0) THEN
       !        ** start
       IBC=NBC0+2*NDM+NFPX
       DO I=1,NBC0
          FB(IBC+I)=0.d0
          FB(IBC+NBC0+I)=0.d0
          DO J=1,NDM
             FB(IBC+I)=FB(IBC+I)+DBC(I,J)*U0(2*NDM+J)
             FB(IBC+I)=FB(IBC+I)+DBC(I,NDM+J)*U1(2*NDM+J)
             FB(IBC+NBC0+I)=FB(IBC+NBC0+I)+DBC(I,J)*U0(3*NDM+J)
             FB(IBC+NBC0+I)=FB(IBC+NBC0+I)+DBC(I,NDM+J)*U1(3*NDM+J)
          ENDDO
          DO J=1,NFPX
             FB(IBC+I)=FB(IBC+I)+DBC(I,2*NDM+ICP(J))*PAR(NPARU+2*NFPX+NDM+1+J)
             FB(IBC+NBC0+I)=FB(IBC+NBC0+I)+ &
                  DBC(I,2*NDM+ICP(J))*PAR(NPARU+3*NFPX+NDM+1+J)
          ENDDO
       ENDDO
    ENDIF

  END SUBROUTINE FBBBP

! ---------- -----
  SUBROUTINE ICBBP(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Generates integral conditions for the 2-parameter continuation
    ! of BP (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: FF1(:),FF2(:),DFU(:)
    INTEGER ISW,NBC,NDM,NFPR,NPAR,NNT0,I,J
    DOUBLE PRECISION UMX,EP,P,UU

    ISW=AP%ISW
    NBC=AP%NBC
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN
       CALL ICNI(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)
       RETURN
    ENDIF

    IF(ISW<0) THEN
       !        ** start
       NNT0=(-NBC+4*NINT+5*NDM-23)/15
    ELSE IF(ISW==2) THEN
       !        ** Non-generic case
       NNT0=(-NBC+2*NINT+3*NDM-3)/3
    ELSE
       !        ** generic case
       NNT0=(-NBC+2*NINT+3*NDM-3)/3
    ENDIF

    ! Generate the function.

    IF(NNT0>0) THEN
       ALLOCATE(DFU(NNT0*(NDM+NPAR)))
    ELSE
       ALLOCATE(DFU(1))
    ENDIF
    CALL FIBBP(AP,NDIM,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,F,DFU)

    IF(IJAC==0)THEN
       DEALLOCATE(DFU)
       RETURN
    ENDIF

    ALLOCATE(FF1(NINT),FF2(NINT))

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I))>UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DO I=1,NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FIBBP(AP,NDIM,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FF1,DFU)
       U(I)=UU+EP
       CALL FIBBP(AP,NDIM,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FF2,DFU)
       U(I)=UU
       DO J=1,NINT
          DINT(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC==1)THEN
       DEALLOCATE(FF1,DFU)
       RETURN
    ENDIF

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FIBBP(AP,NDIM,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FF1,DFU)
       DO J=1,NINT
          DINT(J,NDIM+ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(FF1,DFU)

  END SUBROUTINE ICBBP

  !     ---------- -----
  SUBROUTINE FIBBP(AP,NDIM,PAR,ICP,NINT,NNT0,U,UOLD,UDOT,UPOLD,FI,DINT)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,NNT0
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NNT0,*)

    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: F(:),DFU(:,:),DFP(:,:)
    INTEGER ISW,NBC,NDM,NBC0,NFPX,NPAR,I,J,K,NPARU

    ISW=AP%ISW
    NBC=AP%NBC
    NDM=AP%NDM
    NPAR=AP%NPAR
    NPARU=NPAR-AP%NPARI

    IF(ISW<0) THEN
       ! ** start
       NBC0=(4*NBC-NINT-5*NDM+2)/15
    ELSE IF(ISW==2) THEN
       ! ** Non-generic case
       NBC0=(2*NBC-NINT-3*NDM)/3
    ELSE
       ! ** generic case
       NBC0=(2*NBC-NINT-3*NDM)/3
    ENDIF
    NFPX=NBC0+NNT0-NDM+1

    ALLOCATE(F(NDM),DFU(NDM,NDM),DFP(NDM,NPAR))
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,2,F,DFU,DFP)
    IF(NNT0>0) THEN
       CALL ICNI(AP,NDM,PAR,ICP,NNT0,U,UOLD,UDOT,UPOLD,FI,2,DINT)

       IF((ISW==2).OR.(ISW<0)) THEN
          ! ** Non-generic and/or start
          ! (18) int_0^1 h(x,p) dt + b phi_3^* = 0
          DO I=1,NNT0
             FI(I)=FI(I)+PAR(NPARU+2*NFPX+NDM+1)*PAR(NPARU+NBC0+I)
          ENDDO
       ENDIF
    ENDIF

    ! (13b) -d + int_0^1 (-f_p(x,p)^T phi_1^* + h_p(x,p)^T phi_3^*) dt = 0
    DO I=1,NFPX
       FI(NNT0+I)=-PAR(NPARU+NFPX+NDM+I)
       DO J=1,NDM
          FI(NNT0+I)=FI(NNT0+I)-DFP(J,ICP(I))*U(NDM+J)
       ENDDO
       DO J=1,NNT0
          FI(NNT0+I)=FI(NNT0+I)+DINT(J,NDM+ICP(I))*PAR(NPARU+NBC0+J)
       ENDDO
    ENDDO

    ! ** start
    IF(ISW<0) THEN
       ! (15b) int_0^1 -f(x,p)^T phi_1^* dt + c_1 q + c_2 r = 0
       DO I=1,NFPX
          FI(NNT0+I)=FI(NNT0+I)+ &
               PAR(NPARU+4*NFPX+NDM+2)*PAR(NPARU+2*NFPX+NDM+1+I)+ &
               PAR(NPARU+4*NFPX+NDM+3)*PAR(NPARU+3*NFPX+NDM+1+I)
       ENDDO

       ! (9a) int_0^1 (h_x(x,p)v + h_p(x,p)q) dt = 0
       ! (9b) int_0^1 (h_x(x,p)w + h_p(x,p)r) dt = 0
       DO K=2,3
          DO I=1,NNT0
             FI(NFPX+K*NNT0+I)=0.d0
             DO J=1,NDM
                FI(NFPX+K*NNT0+I)=FI(NFPX+K*NNT0+I)+DINT(I,J)*U(K*NDM+J)
             ENDDO
             DO J=1,NFPX
                FI(NFPX+K*NNT0+I)=FI(NFPX+K*NNT0+I)+DINT(I,NDM+ICP(J))* &
                     PAR(NPARU+K*NFPX+NDM+1+J)
             ENDDO
          ENDDO
       ENDDO
       ! (10a) int_0^1 <v, v_old> dt + <q, q_old> - 1 = 0
       ! (10b) int_0^1 <w, w_old> dt + <r, r_old> - 1 = 0
       ! (11a) int_0^1 <v, w_old> dt + <q, r_old> = 0
       ! (11b) int_0^1 <w, v_old> dt + <r, q_old> = 0
       FI(NFPX+4*NNT0+1)=-1.d0
       FI(NFPX+4*NNT0+2)=-1.d0
       FI(NFPX+4*NNT0+3)=0.d0
       FI(NFPX+4*NNT0+4)=0.d0
       DO I=1,NDM
          FI(NFPX+4*NNT0+1)=FI(NFPX+4*NNT0+1)+U(2*NDM+I)*UOLD(2*NDM+I)
          FI(NFPX+4*NNT0+2)=FI(NFPX+4*NNT0+2)+U(3*NDM+I)*UOLD(3*NDM+I)
          FI(NFPX+4*NNT0+3)=FI(NFPX+4*NNT0+3)+U(2*NDM+I)*UOLD(3*NDM+I)
          FI(NFPX+4*NNT0+4)=FI(NFPX+4*NNT0+4)+U(3*NDM+I)*UOLD(2*NDM+I)
       ENDDO
       DO I=1,NFPX
          FI(NFPX+4*NNT0+1)=FI(NFPX+4*NNT0+1)+PAR(NPARU+2*NFPX+NDM+1+I)* &
               UOLD(NDIM+3*NFPX+NDM+1+I)
          FI(NFPX+4*NNT0+2)=FI(NFPX+4*NNT0+2)+PAR(NPARU+3*NFPX+NDM+1+I)* &
               UOLD(NDIM+4*NFPX+NDM+1+I)
          FI(NFPX+4*NNT0+3)=FI(NFPX+4*NNT0+3)+PAR(NPARU+2*NFPX+NDM+1+I)* &
               UOLD(NDIM+4*NFPX+NDM+1+I)
          FI(NFPX+4*NNT0+4)=FI(NFPX+4*NNT0+4)+PAR(NPARU+3*NFPX+NDM+1+I)* &
               UOLD(NDIM+3*NFPX+NDM+1+I)
       ENDDO
       DEALLOCATE(F,DFU,DFP)
    ENDIF

    ! (13c) -a + int_0^1 ||phi_1^*||^2 dt + ||phi_2^*||^2 + ||phi_3^*||^2 = 0
    FI(NINT)=-PAR(NPARU+NFPX+NDM)
    DO I=1,NDM
       FI(NINT)=FI(NINT)+U(NDM+I)**2
    ENDDO
    DO I=1,NBC0+NNT0
       FI(NINT)=FI(NINT)+PAR(NPARU+I)**2
    ENDDO

  END SUBROUTINE FIBBP

! ---------- -------
  SUBROUTINE STPNBBP(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP, ONLY: STSDRBV
    USE IO
    USE MESH

    ! Generates starting data for the 2-parameter continuation
    ! of BP (BVP).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    INTEGER, ALLOCATABLE :: ICPRS(:)
    DOUBLE PRECISION, ALLOCATABLE :: RVDOT(:)
    DOUBLE PRECISION, ALLOCATABLE :: RLDOTRS(:)
    DOUBLE PRECISION, ALLOCATABLE :: UPST(:,:),UDOTPST(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: VDOTPST(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER NDIM,ISW,NBC,NINT,NFPR
    INTEGER ITPRS,NDM,NBC0,NNT0,NFPX,NDIMRD,NPARU
    TYPE(AUTOPARAMETERS) AP2

    NDIM=AP%NDIM
    ISW=AP%ISW
    NBC=AP%NBC
    NINT=AP%NINT
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPARU=AP%NPAR-AP%NPARI

    IF(ISW>0) THEN
       !        ** restart
       CALL STPNBV(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)
       RETURN
    ENDIF

    ALLOCATE(UPSR(NDIM,0:NCOLRS*NTSR), &
         UDOTPSR(NDIM,0:NCOLRS*NTSR),TMR(0:NTSR))
    !        ** start
    NBC0=(4*NBC-NINT-5*NDM+2)/15
    NNT0=(-NBC+4*NINT+5*NDM-23)/15
    NFPX=NBC0+NNT0-NDM+1

    ALLOCATE(ICPRS(NFPR),RLDOTRS(NFPR))

    ! Start
    
    ! ** allocation
    ALLOCATE(UPST(NDM,0:NTSR*NCOLRS),UDOTPST(NDM,0:NTSR*NCOLRS))
    ALLOCATE(VDOTPST(NDM,0:NTSR*NCOLRS),RVDOT(NFPX))

    ! ** read the std branch
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOTRS,UPST, &
         UDOTPST,TMR,ITPRS,NDM)

    ! Compute the second null vector

    ! ** redefine AP
    AP2=AP
    AP2%NDIM=NDM
    AP2%NTST=NTSR
    AP2%NCOL=NCOLRS
    AP2%NBC=NBC0
    AP2%NINT=NNT0
    AP2%NFPR=NFPX

    CALL STSDRBV(AP2,PAR,ICPRS,FNBBP,BCBBP,ICBBP, &
         RLDOTRS,UPST,UDOTPST,TMR,VDOTPST,RVDOT)

    !        ** init UPS,PAR
    UPSR(1:NDM,:)=UPST(:,:)
    UPSR(NDM+1:2*NDM,:)=0.d0
    UPSR(2*NDM+1:3*NDM,:)=UDOTPST(:,:)
    UPSR(3*NDM+1:4*NDM,:)=VDOTPST(:,:)
    UDOTPSR(:,:)=0.d0

    !        ** init a,d,b
    PAR(NPARU+1:NPARU+2*NFPX+NDM+1)=0
    !        ** init q,r
    PAR(NPARU+2*NFPX+NDM+2:NPARU+3*NFPX+NDM+1)=RLDOTRS(1:NFPX)
    PAR(NPARU+3*NFPX+NDM+2:NPARU+4*NFPX+NDM+1)=RVDOT(1:NFPX)
    !        ** init c1,c2
    PAR(NPARU+4*NFPX+NDM+2:NPARU+4*NFPX+NDM+3)=0

    RLDOT(1:NFPX+1)=0
    RLDOT(NFPX+2)=1 ! b
    RLDOT(NFPX+3:5*NFPX+NDM+3)=0

    DEALLOCATE(UPST,UDOTPST,VDOTPST,RVDOT)

    NODIR=0

    DEALLOCATE(ICPRS,RLDOTRS)

    CALL ADAPT2(NTSR,NCOLRS,NDIM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)
  END SUBROUTINE STPNBBP

END MODULE TOOLBOXBV

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   Demo sspg: Size-structured plant growth
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
! 
!----67--0---------0---------3---------4---------5---------6---------7---

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!--------- ---- 

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
   DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
   DOUBLE PRECISION, INTENT(OUT) :: F(NDIM), DFDU(NDIM,*), DFDP(NDIM,*)

   DOUBLE PRECISION m,s

!  Parameters
   m=PAR(1)
   s=PAR(2)

!  Equations
   F(1) = -U(2)
   F(2) = -U(1)*U(2)-m*U(2)

   IF(IJAC.EQ.0)RETURN 

   DFDU(1,1) = 0.0
   DFDU(1,2) = -1.0
   DFDU(2,1) = -U(2)
   DFDU(2,2) = -U(1)-m

   IF(IJAC.EQ.1)RETURN 

   DFDP(1,1) = 0.0
   DFDP(1,2) = 0.0
   DFDP(2,1) = -U(2)
   DFDP(2,2) = 0.0

 END SUBROUTINE FUNC

 SUBROUTINE STPNT(NDIM,U,PAR,T) 
!---------- ----- 

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM
   DOUBLE PRECISION, INTENT(IN) :: T
   DOUBLE PRECISION, INTENT(OUT) :: U(NDIM), PAR(*)

!  Parameters initialization
   PAR(1:2)=(/1.0,4.0/)

!  Trivial solution
   U(1:2)=0.0

 END SUBROUTINE STPNT

 SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!---------- ---- 

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
   DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
   DOUBLE PRECISION, INTENT(OUT) :: FB(NBC), DBC(NBC,*)

   DOUBLE PRECISION m,s

!  Parameters
   m=PAR(1)
   s=PAR(2)

!  Equations
   FB(1) = U1(1)
   FB(2) = -U0(2)+s*U0(1)

   IF(IJAC.EQ.0)RETURN 

   DBC(1,1) = 0.0
   DBC(1,2) = 0.0
   DBC(1,3) = 1.0
   DBC(1,4) = 0.0
   DBC(2,1) = s
   DBC(2,2) = -1.0
   DBC(2,3) = 0.0
   DBC(2,4) = 0.0

   IF(IJAC.EQ.1)RETURN 

   DBC(1,5) = 0.0
   DBC(1,6) = 0.0
   DBC(2,5) = 0.0
   DBC(2,6) = U0(1)

 END SUBROUTINE BCND

 SUBROUTINE ICND
 END SUBROUTINE ICND

 SUBROUTINE FOPT 
 END SUBROUTINE FOPT

 SUBROUTINE PVLS
 END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   r3b :    The Restricted 3-Body Problem
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!---------- ---- 

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
   DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
   DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
   DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,*), DFDP(NDIM,*)

   DOUBLE PRECISION x,y,z,xp,yp,zp,lambda,mu,dE,dM,mc,dE3,dM3,dE5,dM5
   DOUBLE PRECISION dEx,dEy,dEz,cx,cy,cz,dx,dy,dz,ex,ey,ez,vx,vy,vz
   DOUBLE PRECISION vxp,vyp,vzp,dMx,dMy,dMz

   x  = U(1)        
   y  = U(2) 
   z  = U(3) 
   xp = U(4) 
   yp = U(5) 
   zp = U(6) 

   lambda  = PAR(1)
   mu = PAR(2)

   dE  = SQRT((x+mu)**2 + y**2 + z**2)
   dM  = SQRT( (x-1+mu)**2 + y**2 + z**2 )
   mc = 1 - mu
   dE3 = 1/dE**3
   dM3 = 1/dM**3

   F(1)= xp
   F(2)= yp
   F(3)= zp
   F(4)= 2*yp + x - mc*dE3*(x+mu) - mu*dM3*(x-1+mu) + lambda*xp
   F(5)=-2*xp + y - mc*dE3*y       - mu*dM3*y         + lambda*yp
   F(6)=          - mc*dE3*z       - mu*dM3*z         + lambda*zp

   IF(NDIM==6)RETURN

! Set up the linearized equations
   dE5 = 1/dE**5
   dM5 = 1/dM**5

   dEx = -3*(x+mu)*dE5
   dEy = -3*y*dE5
   dEz = -3*z*dE5

   dMx = -3*(x-1+mu)*dM5
   dMy = -3*y*dM5
   dMz = -3*z*dM5

   cx = 1 - mc*dE3 - mc*(x+mu)*dEx - mu*dM3 - mu*(x-1+mu)*dMx
   cy = -mc*(x+mu)*dEy - mu*(x-1+mu)*dMy
   cz = -mc*(x+mu)*dEz - mu*(x-1+mu)*dMz

   dx = -mc*y*dEx - mu*y*dMx
   dy = 1 - mc*dE3 - mc*y*dEy - mu*dM3 - mu*y*dMy
   dz = -mc*y*dEz - mu*y*dMz

   ex = -mc*z*dEx - mu*z*dMx
   ey = -mc*z*dEy - mu*z*dMy
   ez = -mc*dE3 - mc*z*dEz - mu*dM3 - mu*z*dMz

   vx = U(7)       
   vy = U(8)       
   vz = U(9)
   vxp= U(10)       
   vyp= U(11)      
   vzp= U(12)

   F(7) = vxp
   F(8) = vyp
   F(9) = vzp
   F(10)= cx*vx + cy*vy + cz*vz + 2*vyp
   F(11)= dx*vx + dy*vy + dz*vz - 2*vxp
   F(12)= ex*vx + ey*vy + ez*vz

! Scale
   F = F * PAR(11)
 
 END SUBROUTINE FUNC
!---------------------------------------------------------------------- 
 SUBROUTINE STPNT(NDIM,U,PAR,T)
!---------- -----

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM
   DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM), PAR(*)
   DOUBLE PRECISION, INTENT(IN) :: T

   DOUBLE PRECISION lambda,mu

   lambda  =  0.
   mu =  0.

   PAR(:2) = (/ lambda, mu /)

   U = (/ 0.14107D0, 0.99D0, 0D0, 0D0, 0D0, 0D0 /)

 END SUBROUTINE STPNT

 SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!---------- ----

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
   DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
   DOUBLE PRECISION, INTENT(OUT) :: FB(NBC), DBC(NBC,*)

   DOUBLE PRECISION fm

! Periodicity boundary conditions
   FB(1:6) = U0(1:6) - U1(1:6)

! Floquet eigenvalue/vector boundary relation
   fm = PAR(4)
   FB(7:12) = U1(7:12) - fm*U0(7:12)
 
 END SUBROUTINE BCND
!---------------------------------------------------------------------- 

 SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!---------- ----

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
   DOUBLE PRECISION, INTENT(IN) :: PAR(*)
   DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
   DOUBLE PRECISION, INTENT(OUT) :: FI(NINT), DINT(NINT,*)

! Integral phase condition
   FI(1) = DOT_PRODUCT(U(1:6),UPOLD(1:6))

! Integral Floquet eigenfunction normalization
   FI(2) = -PAR(5)+DOT_PRODUCT(U(7:12),U(7:12))

 END SUBROUTINE ICND
!---------------------------------------------------------------------- 

 SUBROUTINE PVLS(NDIM,U,PAR)
!---------- ----

   IMPLICIT NONE
   INTEGER, INTENT(IN) :: NDIM
   DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
   DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

   DOUBLE PRECISION GETP,mu,x,y,z,xp,yp,zp,d1,d2,EU,E,realfm,imagfm,ncmplx
   DOUBLE PRECISION routh,pi
   INTEGER i,j

   mu = PAR(2)

   x  = U(1)
   y  = U(2)
   z  = U(3)
   xp = U(4)
   yp = U(5)
   zp = U(6)

   d1 = SQRT((x+mu)**2 + y**2 + z**2)
   ! PVLS is called for initialization of MPI workers, but results are not
   ! used. In that case all variables are 0.
   IF(d1==0)RETURN
   d2 = SQRT( (x-1+mu)**2 + y**2 + z**2 )

   EU = (x**2 + y**2)/2 + (1-mu)/d1 + mu/d2
   E  = (xp**2 + yp**2 + zp**2)/2 - EU - mu*(1-mu)/2
   PAR(3) = E
   IF(NDIM==12)RETURN
   PAR(16)=y

! Maximum real Floquet multiplier: PAR(4)
! If there are two real multipliers with absolute value > 1
! then PAR(4)=0.

   PAR(4) = 0
   ncmplx = 0
   DO i=1,NDIM
      imagfm = GETP('EIG',I*2,U)
      IF (imagfm == 0) THEN
         realfm = GETP('EIG',I*2-1,U)
         IF (ABS(realfm) > ABS(PAR(4))) THEN
            PAR(4) = realfm
         ENDIF
      ELSE
         ncmplx = ncmplx + 1
      ENDIF
   ENDDO
   IF (ncmplx == 0) THEN
      ! no complex multipliers mean 6 real multipliers: 1,1, two with
      ! absolute value greater than 1 and two less than one
      PAR(4) = 0
   ELSEIF (ncmplx == 4) THEN
      ! all non-trivial multipliers complex: must be 1 without rounding
      ! errors
      PAR(4) = 1
   ENDIF

!  Put purely imaginary eigenvalues in PAR(5), PAR(6) and PAR(7)

   j=1
   PAR(5) = 0
   PAR(6) = 0
   PAR(7) = 0
   pi = 4*ATAN(1d0)
   DO i=1,NDIM
      imagfm = GETP('EIG',I*2,U)
      IF (imagfm > 1d-5) THEN
         realfm = GETP('EIG',I*2-1,U)
         routh = 0.5d0*(1d0-sqrt(69d0)/9d0)
         ! above Routh's ratio we have one period for L4/L5, otherwise 3.
         IF (ABS(realfm) < EPSILON(1d0) .OR. mu < routh .OR. ABS(y) < 0.1) THEN
            PAR(4+j) = 2*pi/imagfm            
            j=j+1
         ENDIF
      ENDIF
   ENDDO

 END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
 SUBROUTINE FOPT 
 END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

C plautdev.f
       SUBROUTINE SQUARE(X,Y,SIDE,THETA)
       INCLUDE 'plautcom.f'
       CALL MOVEA(X,Y)
       CALL RROTAT(THETA)
       CALL DRAWR(0.,SIDE)
       CALL DRAWR(SIDE,0.)
       CALL DRAWR(0.,-SIDE)
       CALL DRAWR(-SIDE,0.)
       CALL RROTAT(-THETA)
       CALL ANMODE
       RETURN
       END
C
      SUBROUTINE ANMODE
      INCLUDE 'plautcom.f'
      CALL ALFMOD
      CALL TSEND
      RETURN
       END
C
      SUBROUTINE SEEMRG(MLEFT,MRIGHT)
      INCLUDE 'plautcom.f'
      MLEFT=KLMRGN
      MRIGHT=KRMRGN
      RETURN
      END
C
      SUBROUTINE SEETRM(IBAUDR,ITERM,ICSIZE,MAXSCR)
      INCLUDE 'plautcom.f'
      IBAUDR=KBAUDR
      ITERM=KTERM
      ICSIZE=KSIZEF
      MAXSCR=4096/KFACTR
      RETURN
      END
C
      SUBROUTINE SEETW(MINX,MAXX,MINY,MAXY)
      INCLUDE 'plautcom.f'
      MINX=KMINSX
      MAXX=KMAXSX
      MINY=KMINSY
      MAXY=KMAXSY
      RETURN
      END
C
      SUBROUTINE SEEDW(XMIN,XMAX,YMIN,YMAX)
      INCLUDE 'plautcom.f'
      XMIN=TMINVX
      XMAX=TMAXVX
      YMIN=TMINVY
      YMAX=TMAXVY
      RETURN
      END
C
      SUBROUTINE SEEMOD(LINE,IZAXIS,MODE)
      INCLUDE 'plautcom.f'
      LINE=KLINE
      IZAXIS=KZAXIS
      MODE=KKMODE
      RETURN
      END
C
      SUBROUTINE SEETRN(XFAC,YFAC,KEY)
      INCLUDE 'plautcom.f'
      XFAC=TRFACX
      YFAC=TRFACY
      KEY=KEYCON
      RETURN
      END
C
      SUBROUTINE SEEREL(RCOS,RSIN,SCALE)
      INCLUDE 'plautcom.f'
      RCOS=TRCOSF
      RSIN=TRSINF
      SCALE=TRSCAL
      RETURN
      END
C
      SUBROUTINE TTBLSZ(ITBLSZ)
      INCLUDE 'plautcom.f'
      KTBLSZ=ITBLSZ
      RETURN
      END
C
      SUBROUTINE TERM(ITERM,ISCAL)
      INCLUDE 'plautcom.f'
      KTERM=ITERM
      KFACTR=4
      IF(ISCAL .GT. 1025)KFACTR=1
      CALL RESET
      RETURN
      END
C
      SUBROUTINE DASHSR(X,Y,L)
      INCLUDE 'plautcom.f'
      CALL REL2AB(X,Y,RX,RY)
      CALL DASHSA(RX,RY,L)
      RETURN
      END
C
      SUBROUTINE DASHSA(X,Y,L)
      INCLUDE 'plautcom.f'
      CALL LVLCHT
      XOLD=TIMAGX
      YOLD=TIMAGY
      KEY=KEYCON
      IF(KEYCON .LT. 1)KEY=5
      IF(KEYCON .GT. 4)KEY=4
      GO TO (100, 100, 200, 400, 100),KEY
100   CALL DASHA(X,Y,L)
      XOLD=X
      YOLD=Y
      RETURN
200   DX=X-XOLD
      DY=Y-YOLD
      YSTEP=SIGN(5.0/TRFACY,DY)
      IF(ABS(DY*.75) .LT. ABS(YSTEP)) GO TO 100
      FRAC=DX/DY
      NSEG=INT((DY/YSTEP)+.9999)
      YOUT=YOLD
300   IF(NSEG .LT. 2) GO TO 100
      YOUT=YOUT+YSTEP
      XOUT=XOLD+(YOUT-YOLD)*FRAC
      CALL DASHA(XOUT,YOUT,L)
      NSEG=NSEG-1
      GO TO 300
400   CONTINUE
      GO TO 100
      END
C
      SUBROUTINE DRAWSR(X,Y)
      INCLUDE 'plautcom.f'
      CALL REL2AB(X,Y,RX,RY)
      CALL DRAWSA(RX,RY)
      RETURN
      END
C
      SUBROUTINE DRAWSA(X,Y)
      INCLUDE 'plautcom.f'
      CALL LVLCHT
      XOLD=TIMAGX
      YOLD=TIMAGY
      KEY=KEYCON
      IF(KEYCON .LT. 1)KEY=5
      IF(KEYCON .GT. 4)KEY=4
      GO TO (100, 100, 200, 400, 100),KEY
100   CALL DRAWA(X,Y)
      XOLD=X
      YOLD=Y
      RETURN
200   DX=X-XOLD
      DY=Y-YOLD
      YSTEP=SIGN(5.0/TRFACY,DY)
      IF(ABS(DY*.75) .LT. ABS(YSTEP)) GO TO 100
      FRAC=DX/DY
      NSEG=INT((DY/YSTEP)+.9999)
      YOUT=YOLD
300   IF(NSEG .LT. 2) GO TO 100
      YOUT=YOUT+YSTEP
      XOUT=XOLD+(YOUT-YOLD)*FRAC
      CALL DRAWA(XOUT,YOUT)
      NSEG=NSEG-1
      GO TO 300
400   CONTINUE
      GO TO 100
      END
C
      SUBROUTINE INCPLT(IONOFF,IDIR,NO)
      INCLUDE 'plautcom.f'
      DIMENSION IPLTBL(8),KBMUP(10)
      DATA IPLTBL(1),IPLTBL(2),IPLTBL(3),IPLTBL(4)/4,5,1,9/
      DATA IPLTBL(5),IPLTBL(6),IPLTBL(7),IPLTBL(8)/8,10,2,6/
      DATA KBMUP(1),KBMUP(2),KBMUP(3),KBMUP(4)/0,1,1,1/
      DATA KBMUP(5),KBMUP(6),KBMUP(7),KBMUP(8)/0,-1,-1,-1/
      DATA KBMUP(9),KBMUP(10)/0,1/
      IF(KKMODE .NE. 3)CALL IPMOD
      IPEN=32+IONOFF*48
      CALL TOUTPT(IPEN)
      IPEN=64
      KMOVEF=IABS(IONOFF-1)
      NDXPLT=MOD(IDIR,8)+1
      IPLTCH=IPLTBL(NDXPLT)+IPEN
      KBMUPX=KBMUP(NDXPLT)
      KBMUPY=KBMUP(NDXPLT+2)
      DO I=1,NO
         CALL TOUTPT(IPLTCH)
         KBEAMX=KBEAMX+KBMUPX
         KBEAMY=KBEAMY+KBMUPY
      ENDDO
      RETURN
      END
C
      SUBROUTINE RROTAT(DEG)
      INCLUDE 'plautcom.f'
      TRSINF=SIN(DEG/57.29578)
      TRCOSF=COS(DEG/57.29578)
      RETURN
      END
C
      SUBROUTINE RSCALE(FACTOR)
      INCLUDE 'plautcom.f'
      TRSCAL=FACTOR
      RETURN
      END
C
      SUBROUTINE FINITT(IX,IY)
      INCLUDE 'plautcom.f'
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      CALL MOVABS(IX,IY)
      CALL ALFMOD
      CALL TSEND
      RETURN
      END
C
      SUBROUTINE BELL
      INCLUDE 'plautcom.f'
      CALL TOUTPT(7)
      KMOVEF=0
      RETURN
      END
C
      SUBROUTINE VWINDO(XMIN,XRANGE,YMIN,YRANGE)
      INCLUDE 'plautcom.f'
      TMINVX=XMIN
      TMAXVX=XMIN+XRANGE
      TMINVY=YMIN
      TMAXVY=YMIN+YRANGE
      CALL RESCAL
      RETURN
      END
C
      SUBROUTINE SWINDO(MINX,LENX,MINY,LENY)
      INCLUDE 'plautcom.f'
      KMINSX=MINX
      KMAXSX=MINX+LENX
      KMINSY=MINY
      KMAXSY=MINY+LENY
      CALL RESCAL
      RETURN
      END
C
      SUBROUTINE TWINDO(MINX,MAXX,MINY,MAXY)
      INCLUDE 'plautcom.f'
      KMINSX=MINX
      KMAXSX=MAXX
      KMINSY=MINY
      KMAXSY=MAXY
      CALL RESCAL
      RETURN
      END
C
      SUBROUTINE DWINDO(XMIN,XMAX,YMIN,YMAX)
      INCLUDE 'plautcom.f'
      TMINVX=XMIN
      TMAXVX=XMAX
      TMINVY=YMIN
      TMAXVY=YMAX
      CALL RESCAL
      RETURN
      END
C
      SUBROUTINE LWINDO(XMIN,XMAX,YMIN,YMAX,KEY)
      INCLUDE 'plautcom.f'
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
      IF(KEY-3.GT.0.OR.KEY.LE.0)THEN
         CALL LINTRN
         RETURN
      ENDIF
      CALL LOGTRN(KEY)
      RETURN
      END
C
      SUBROUTINE POINTR(X,Y)
      INCLUDE 'plautcom.f'
      CALL REL2AB(X,Y,RX,RY)
      CALL POINTA(RX,RY)
      RETURN
      END
C
      SUBROUTINE DASHR(X,Y,L)
      INCLUDE 'plautcom.f'
      CALL REL2AB(X,Y,XL,YL)
      CALL DASHA(XL,YL,L)
      RETURN
      END
C
      SUBROUTINE DASHA(X,Y,L)
      INCLUDE 'plautcom.f'
      CALL LVLCHT
      CALL V2ST(1,X,Y,IX,IY)
      IF(KGNFLG .EQ. 1)GO TO 10
      CALL DSHMOD(L)
      CALL TKDASH(IX,IY)
10    RETURN
      END
C
      SUBROUTINE DSHREL(IX,IY,L)
      INCLUDE 'plautcom.f'
      JX=IX+KBEAMX
      JY=IY+KBEAMY
      CALL DSHABS(JX,JY,L)
      RETURN
      END
C
      SUBROUTINE DSHABS(IX,IY,L)
      INCLUDE 'plautcom.f'
      CALL DSHMOD(L)
      CALL TKDASH(IX,IY)
      RETURN
      END
C
      SUBROUTINE DRAWR(X,Y)
      INCLUDE 'plautcom.f'
      CALL REL2AB(X,Y,RX,RY)
      CALL DRAWA(RX,RY)
      RETURN
      END
C
      SUBROUTINE POINTA(X,Y)
      INCLUDE 'plautcom.f'
      CALL LVLCHT
      CALL V2ST(0,X,Y,IX,IY)
      IF(KGNFLG .EQ. 1)GO TO 10
      IF(KKMODE .NE. 2)CALL PNTMOD
      CALL TKPNT(IX,IY)
10    RETURN
      END
C
      SUBROUTINE DRAWA(X,Y)
      INCLUDE 'plautcom.f'
      IF(KLINE .EQ. 0)GO TO 5
      KLINE=0
      CALL CWSEND
5     CONTINUE
      CALL LVLCHT
      CALL V2ST(1,X,Y,IX,IY)
      IF(KGNFLG .EQ. 1)GO TO 10
      IF(KKMODE.NE.1)CALL VECMOD
      IF(KMOVEF.EQ.1)CALL XYCNVT(KBEAMX,KBEAMY)
      CALL XYCNVT(IX,IY)
10    RETURN
      END
C
      SUBROUTINE MOVER(X,Y)
      INCLUDE 'plautcom.f'
      CALL REL2AB(X,Y,RX,RY)
      CALL MOVEA(RX,RY)
      RETURN
      END
C
      SUBROUTINE REL2AB(XIN,YIN,XOUT,YOUT)
      INCLUDE 'plautcom.f'
      CALL LVLCHT
      XOUT=(((XIN*TRCOSF)-(YIN*TRSINF))*TRSCAL)+TIMAGX
      YOUT=(((XIN*TRSINF)+(YIN*TRCOSF))*TRSCAL)+TIMAGY
      RETURN
      END
C
      SUBROUTINE MOVEA(X,Y)
      INCLUDE 'plautcom.f'
      CALL LVLCHT
      CALL V2ST(0,X,Y,IX,IY)
      IF(KGNFLG .EQ. 1)GO TO 10
      CALL VECMOD
      CALL XYCNVT(IX,IY)
10    RETURN
      END
C
      SUBROUTINE VCURSR(ICHAR,X,Y)
      INCLUDE 'plautcom.f'
      CALL SCURSR(ICHAR,IXA,IYA)
      CALL REVCOT(IXA,IYA,X,Y)
      RETURN
      END
C
      SUBROUTINE V2ST(I,X,Y,IX,IY)
      INCLUDE 'plautcom.f'
      DIMENSION BUFIN(4),BFOUT(4)
      EQUIVALENCE (BUFIN(1),XS),(BUFIN(2),YS),(BUFIN(3),XE),
     1(BUFIN(4),YE)
      EQUIVALENCE (BFOUT(1),CXS),(BFOUT(2),CYS),(BFOUT(3),CXE),
     1            (BFOUT(4),CYE)
      XE=X
      YE=Y
      IF(I .EQ. 0) GO TO 10
      XS=TIMAGX
      YS=TIMAGY
      CALL CLIPT(BUFIN,BFOUT)
      IF(KGNFLG .EQ. 1) GO TO 110
      IF(CXS .EQ. TREALX .AND. CYS .EQ. TREALY) GO TO 120
      MODE=KKMODE
      CALL VECMOD
      CALL WINCOT(CXS,CYS,IX,IY)
      CALL XYCNVT(IX,IY)
      KKMODE=MODE
      GO TO 120
10    CALL PCLIPT(XE,YE)
      IF(KGNFLG .EQ. 1) GO TO 110
      CXE=XE
      CYE=YE
120   CALL WINCOT(CXE,CYE,IX,IY)
      TREALX=CXE
      TREALY=CYE
110   TIMAGX=X
      TIMAGY=Y
      RETURN
      END
C
      SUBROUTINE CLIPT(BUFIN,OUTBF)
      INCLUDE 'plautcom.f'
      DIMENSION  BUFIN(*),OUTBF(*)
      GSTAX=BUFIN(1)
      GSTAY=BUFIN(2)
      GENDX=BUFIN(3)
      GENDY=BUFIN(4)
      IF(GSTAX.GE.TMINVX)GO TO 10
      IF(GENDX.GE.TMINVX)GO TO 20
      GO TO 110
10    IF(GSTAX.LE.TMAXVX)GO TO 20
      IF(GENDX.LE.TMAXVX)GO TO 20
      GO TO 110
20    IF(GSTAY.GE.TMINVY)GO TO 21
      IF(GENDY.GE.TMINVY)GO TO 30
      GO TO 110
21    IF(GSTAY.LE.TMAXVY)GO TO 30
      IF(GENDY.LE.TMAXVY)GO TO 30
      GO TO 110
30    IF(GSTAX.NE.GENDX)GO TO 31
      DSTAX=GSTAX
      DENDX=GSTAX
      CALL PARCLT(GSTAY,GENDY,TMINVY,TMAXVY,DSTAY,DENDY)
      GO TO 120
31    IF(GSTAY.NE.GENDY)GO TO 40
      DSTAY=GSTAY
      DENDY=GSTAY
      CALL PARCLT(GSTAX,GENDX,TMINVX,TMAXVX,DSTAX,DENDX)
      GO TO 120
40    A=GENDX-GSTAX
      B=GENDY-GSTAY
      IF(GSTAX.LT.TMINVX)GO TO 41
      IF(GSTAX.LE.TMAXVX)GO TO 43
      Q=TMAXVX
      GO TO 42
43    IF(GSTAY.GT.TMAXVY)GO TO 140
      IF(GSTAY.LT.TMINVY)GO TO 44
      DSTAX=GSTAX
      DSTAY=GSTAY
      GO TO 150
41    Q=TMINVX
42    DSTAY=GSTAY+((Q-GSTAX)*B/A)
      IF(DSTAY.GT.TMAXVY)GO TO 140
      IF(DSTAY.LT.TMINVY)GO TO 44
      DSTAX=Q
      GO TO 150
44    R=TMINVY
      GO TO 45
140   R=TMAXVY
45    DSTAX=GSTAX+((R-GSTAY)*A/B)
      IF(DSTAX.GT.TMAXVX)GO TO 110
      IF(DSTAX.LT.TMINVX)GO TO 110
      DSTAY=R
150   IF(GENDX.LT.TMINVX)GO TO 50
      IF(GENDX.GT.TMAXVX)GO TO 51
      IF(GENDY.GT.TMAXVY)GO TO 160
      IF(GENDY.LT.TMINVY)GO TO 52
      DENDX=GENDX
      DENDY=GENDY
      GO TO 120
51    Q=TMAXVX
      GO TO 53
50    Q=TMINVX
53    DENDY=GSTAY+((Q-GSTAX)*B/A)
      IF(DENDY.GT.TMAXVY)GO TO 160
      IF(DENDY.LT.TMINVY)GO TO 52
      DENDX=Q
      GO TO 120
52    R=TMINVY
      GO TO 60
160   R=TMAXVY
60    DENDX=GSTAX+((R-GSTAY)*A/B)
      DENDY=R
120   OUTBF(1)=DSTAX
      OUTBF(2)=DSTAY
      OUTBF(3)=DENDX
      OUTBF(4)=DENDY
      KGNFLG=0
      GO TO 70
110   KGNFLG=1
70    RETURN
      END
C
      SUBROUTINE PARCLT(RL1,RL2,RM1,RM2,RN1,RN2)
      INCLUDE 'plautcom.f'
      IF(RL1.LT.RM1)GO TO 10
      IF(RL1.GT.RM2)GO TO 20
      RN1=RL1
      IF(RL2-RM1.LT.0)GO TO 30
      GO TO 40
10    RN1=RM1
40    IF(RL2.LE.RM2)GO TO 50
      RN2=RM2
      GO TO 60
50    RN2=RL2
      GO TO 60
20    RN1=RM2
      IF(RL2.GE.RM1)GO TO 50
30    RN2=RM1
60    RETURN
      END
C
      SUBROUTINE LINTRN
      INCLUDE 'plautcom.f'
      KEYCON=1
      CALL RESCAL
      RETURN
      END
C
      SUBROUTINE LOGTRN(ITYPE)
      INCLUDE 'plautcom.f'
      KEYCON=2
      TRPAR1=ITYPE
      CALL RESCAL
      RETURN
      END
C
      SUBROUTINE POLTRN(ANGMIN,ANGMAX,RSUPRS)
      INCLUDE 'plautcom.f'
      KEYCON=3
      TRPAR1=ANGMIN
      TRPAR2=ANGMAX
      TRPAR5=RSUPRS
      CALL PSCAL
      RETURN
      END
C
      SUBROUTINE RESCAL
      INCLUDE 'plautcom.f'
      KGRAFL=0
      KEY=KEYCON
      IF(KEYCON .LT. 1)KEY=5
      IF(KEYCON .GT. 4)KEY=4
      GO TO (100,200,300,400,500),KEY
100   TRPAR1=0.
200   KEYL=INT(TRPAR1+1.001)
      GO TO (210,220,210,220),KEYL
210   TRFACX=FLOAT(KMAXSX-KMINSX)/(TMAXVX-TMINVX)
      GO TO 250
220   TRPAR2=ALOG(TMINVX)
      TRFACX=FLOAT(KMAXSX-KMINSX)/(ALOG(TMAXVX)-TRPAR2)
250   GO TO (260,260,280,280),KEYL
260   TRFACY=FLOAT(KMAXSY-KMINSY)/(TMAXVY-TMINVY)
      GO TO 600
280   TRPAR3=ALOG(TMINVY)
      TRFACY=FLOAT(KMAXSY-KMINSY)/(ALOG(TMAXVY)-TRPAR3)
      GO TO 600
300   CALL PSCAL
      GO TO 600
400   CONTINUE
      GO TO 600
500   TRFACX=1.
      TRFACY=1.
600   RETURN
      END
C
      SUBROUTINE PSCAL
      INCLUDE 'plautcom.f'
      LOGICAL ANEG
      ANEG=TRPAR1 .GT. TRPAR2
      KGRAFL=0
      PIDV2=90.00
      TRPAR3=0.
      TRPAR4=0.
      TRFACY=1.
      TRPAR6=0.
      R1=TMINVX
      R2=TMAXVX
      RMAX=AMAX1(ABS(R1),ABS(R2))
      TRFACX=1000./RMAX
      THMIN=AMIN1(TRPAR1,TRPAR2)
      THMAX=AMAX1(TRPAR2,TRPAR1)
      CALL WINCOT(R1,THMIN,IX1,IY1)
      CALL WINCOT(R1,THMAX,IX2,IY2)
      CALL WINCOT(R2,THMIN,IX3,IY3)
      CALL WINCOT(R2,THMAX,IX4,IY4)
      IXMIN=MIN0(IX1,IX2,IX3,IX4)
      IXMAX=MAX0(IX1,IX2,IX3,IX4)
      IYMIN=MIN0(IY1,IY2,IY3,IY4)
      IYMAX=MAX0(IY1,IY2,IY3,IY4)
      X=THMIN/PIDV2
      IF(THMIN.GT.0.)X=X+.999
      QUAD=FLOAT(IFIX(X))*PIDV2
      NQUAD=0
200   IF(QUAD.GE.THMAX)GO TO 300
      NQUAD=NQUAD+1
      CALL WINCOT(R1,QUAD,IX1,IY1)
      CALL WINCOT(R2,QUAD,IX2,IY2)
      IXMIN=MIN0(IX1,IX2,IXMIN)
      IXMAX=MAX0(IX1,IX2,IXMAX)
      IYMIN=MIN0(IY1,IY2,IYMIN)
      IYMAX=MAX0(IY1,IY2,IYMAX)
      QUAD=QUAD+PIDV2
      IF(NQUAD.LT.4)GO TO 200
300   TSRANX=KMAXSX-KMINSX
      TSRANY=KMAXSY-KMINSY
      XRANGE=IXMAX-IXMIN
      YRANGE=IYMAX-IYMIN
      FACTOR=AMIN1(ABS(TSRANX)/XRANGE,ABS(TSRANY)/YRANGE)
      TRPAR3=FLOAT(KMINSX)-FACTOR*FLOAT(IXMIN)
      TRPAR4=FLOAT(KMINSY)-FACTOR*FLOAT(IYMIN)
      TRFACX=TRFACX*FACTOR
      TRFACY=(TRPAR2-TRPAR1)/(TMAXVY-TMINVY)
      TRFACY=SIGN(1.,TSRANX*TSRANY)*TRFACY
      AANG=0.
      IF(ANEG.AND.TSRANY.LT.0..OR.TSRANX.LT.0..AND..NOT.ANEG)
     1 AANG=180.
      TRPAR6=TMINVY-(TRPAR1+AANG)/TRFACY
      RETURN
      END
C
      SUBROUTINE WINCOT(X,Y,IX,IY)
      INCLUDE 'plautcom.f'
      DATA DE2RAD/0.01745/
      DX=X-TMINVX
      DY=Y-TMINVY
      KEY=KEYCON
      IF(KEYCON .LT. 1)KEY=5
      IF(KEYCON .GT. 4)KEY=4
      GO TO(500,300,600,700,100),KEY
100   IX=INT(X)
      IY=INT(Y)
      GO TO 800
300   KEYL=INT(TRPAR1+.001)
      IF(KEYL .EQ. 2) GO TO 400
      DX=ALOG(X)-TRPAR2
400   IF(KEYL .EQ. 1) GO TO 500
      DY=ALOG(Y)-TRPAR3
500   IX=IFIX(DX*TRFACX)+KMINSX
      IY=IFIX(DY*TRFACY)+KMINSY
      GO TO 800
600   A=(Y-TRPAR6)*TRFACY
      R=(X-TRPAR5)*TRFACX
      IX=INT(R*COS(A*DE2RAD)+TRPAR3)
      IY=INT(R*SIN(A*DE2RAD)+TRPAR4)
      GO TO 800
700   CONTINUE
800   RETURN
      END
C
      SUBROUTINE LVLCHT
      INCLUDE 'plautcom.f'
      IF(KGRAFL.NE.0)GO TO 10
      CALL REVCOT(KBEAMX,KBEAMY,TREALX,TREALY)
      TIMAGX=TREALX
      TIMAGY=TREALY
      KGRAFL=1
10    RETURN
      END
C
      SUBROUTINE REVCOT(IX,IY,X,Y)
      INCLUDE 'plautcom.f'
      LOGICAL DEC
      E=2.7182818284
      DX=FLOAT(IX-KMINSX)/TRFACX
      DY=FLOAT(IY-KMINSY)/TRFACY
      KEY=KEYCON
      IF(KEYCON .LT. 1)KEY=5
      IF(KEYCON .GT. 4)KEY=4
      GO TO(300, 400, 500, 600, 100  ),KEY
100   X=IX
      Y=IY
      GO TO 700
300   X=DX+TMINVX
      Y=DY+TMINVY
      GO TO 700
400   KEYL=INT(TRPAR1)
      X=DX+TMINVX
      Y=DY+TMINVY
      IF(KEYL .NE. 2)X=E**(DX+TRPAR2)
      IF(KEYL .NE. 1)Y=E**(DY+TRPAR3)
      GO TO 700
500   DX=FLOAT(IX)-TRPAR3
      DY=FLOAT(IY)-TRPAR4
      Y=ATAN2(DY,DX)*57.2957795131
      X=SQRT(DY*DY+DX*DX)/TRFACX+TRPAR5
      DEC=.FALSE.
510   IF(Y .GT. TRPAR1) GO TO 530
      Y=Y+360.0
      GO TO 510
530   IF(Y .LE. TRPAR2) GO TO 550
      Y=Y-360.0
      DEC=.TRUE.
      GO TO 530
550   IF(DEC .AND. Y .LT. TRPAR1)Y=Y+360.0
      IF(TMINVX .GE. 0.)GO TO 560
      TR1A=AMOD(TRPAR1+180.,360.)
      TR2A=AMOD(TRPAR2+180.,360.)
      IF(Y.GT.AMAX1(TR1A,TR2A).OR.Y.LT.AMIN1(TR1A,TR2A))
     1 GO TO 560
      Y=AMOD(Y+180.,360.)
      X=-X
560   Y=Y/TRFACY+TRPAR6
      GO TO 700
600   CONTINUE
700   CALL PCLIPT(X,Y)
      RETURN
      END
C
      SUBROUTINE PCLIPT(X,Y)
      INCLUDE 'plautcom.f'
      KGNFLG=0
      IF(X.LT.TMINVX)GO TO 10
      IF(X.GT.TMAXVX)GO TO 10
      IF(Y.LT.TMINVY)GO TO 10
      IF(Y.LE.TMAXVY)GO TO 20
10    KGNFLG=1
20    RETURN
      END
C
      SUBROUTINE PNTREL(IX,IY)
      INCLUDE 'plautcom.f'
      JX=KBEAMX+IX
      JY=KBEAMY+IY
      CALL PNTABS(JX,JY)
      RETURN
      END
C
      SUBROUTINE PNTABS(IX,IY)
      INCLUDE 'plautcom.f'
      IF(KKMODE .NE. 2)CALL PNTMOD
      CALL TKPNT(IX,IY)
      KGRAFL=0
      RETURN
      END
C
      SUBROUTINE DRWREL(IX,IY)
      INCLUDE 'plautcom.f'
      JX=KBEAMX+IX
      JY=KBEAMY+IY
      CALL DRWABS(JX,JY)
      RETURN
      END
C
      SUBROUTINE DRWABS(IX,IY)
      INCLUDE 'plautcom.f'
      IF(KLINE .EQ. 0)GO TO 5
      KLINE=0
      CALL CWSEND
5     CONTINUE
      IF(KKMODE.NE.1)CALL VECMOD
      IF(KMOVEF.EQ.1)CALL XYCNVT(KBEAMX,KBEAMY)
      CALL XYCNVT(IX,IY)
      KGRAFL=0
      RETURN
      END
C
      SUBROUTINE SETMRG(MLEFT,MRIGHT)
      INCLUDE 'plautcom.f'
      KLMRGN=MLEFT
      KRMRGN=MRIGHT
      RETURN
      END
C
      SUBROUTINE MOVREL(IX,IY)
      INCLUDE 'plautcom.f'
      JX=KBEAMX+IX
      JY=KBEAMY+IY
      CALL MOVABS(JX,JY)
      RETURN
      END
C
      SUBROUTINE SETTAB(ITAB,ITBTBL)
      INCLUDE 'plautcom.f'
      DIMENSION ITBTBL(1)
      KGNFLG=0
      IF(ITAB.LE.0)GO TO 10
      I=1
20    IF(ITBTBL(I).EQ.ITAB)GO TO 10
      IF(ITAB.LT.ITBTBL(I))GO TO 60
      IF(ITBTBL(I).EQ.0)GO TO 60
      I=I+1
      IF(I.LE.KTBLSZ)GO TO 20
30    KGNFLG=1
10    RETURN
60    ITEMP=ITBTBL(I)
      ITBTBL(I)=ITAB
70    IF(ITEMP.EQ.0)GO TO 10
      I=I+1
      IF(I.GT.KTBLSZ)GO TO 30
      ITEMPA=ITBTBL(I)
      ITBTBL(I)=ITEMP
      ITEMP=ITEMPA
      GO TO 70
      END
C
      SUBROUTINE RSTTAB(ITAB,ITBTBL)
      INCLUDE 'plautcom.f'
      DIMENSION ITBTBL(1)
      IF(ITAB.LT.0)GO TO 10
      IF(ITAB.EQ.0)GO TO 20
      DO I=1,KTBLSZ
        IF(ITAB.EQ.ITBTBL(I))GO TO 50
      ENDDO
      GO TO 10
50    J=KTBLSZ-1
      DO K=I,J
        ITBTBL(K)=ITBTBL(K+1)
      ENDDO
      ITBTBL(KTBLSZ)=0
      GO TO 10
20    DO II=1,KTBLSZ
        ITBTBL(II)=0
      ENDDO
10    RETURN
      END
C
      SUBROUTINE TABHOR(ITBTBL)
      INCLUDE 'plautcom.f'
      DIMENSION ITBTBL(1)
      KFLG=0
      DO 10 K=1,KTBLSZ
      IF(ITBTBL(K).NE.0)KFLG=1
      IF(ITBTBL(K).GT.KBEAMX)GO TO 20
10    CONTINUE
      IF(KFLG.EQ.0)GO TO 30
15    CALL NEWLIN
      GO TO 30
20    IF (ITBTBL(K).GE.KRMRGN) GO TO 15
      CALL MOVABS(ITBTBL(K),KBEAMY)
      CALL ALFMOD
30    RETURN
      END
C
      SUBROUTINE TABVER(ITBTBL)
      INCLUDE 'plautcom.f'
      DIMENSION ITBTBL (1)
      DO 10 K=1,KTBLSZ
      I=KTBLSZ-K+1
      IF(ITBTBL(I) .LE. 0)GO TO 10
      IF(ITBTBL(I) .LT. KBEAMY)GO TO 30
10    CONTINUE
      GO TO 20
30    CALL MOVABS(KBEAMX,ITBTBL(I))
      CALL ALFMOD
20    RETURN
      END
C
      SUBROUTINE DSHMOD(L)
      INCLUDE 'plautcom.f'
      IF(KKMODE .EQ. 4) GO TO 10
      KKMODE=4
      CALL TOUTPT(31)
      CALL TOUTPT(29)
      KMOVEF=1
      DO I=1,5
        KPCHAR(I)=-1
      ENDDO
      CALL XYCNVT(KBEAMX,KBEAMY)
10    KDASHT=L
      RETURN
      END
C
      SUBROUTINE TKDASH(IX,IY)
      INCLUDE 'plautcom.f'
      DIMENSION DTABL(10), U(9), WORK(10),ISIMHD(4)
      DATA ISIMHD(1),ISIMHD(2),ISIMHD(3)/12,31212,32/
      DATA ISIMHD(4),IDTYPE/52,-1/
      DATA U(1),U(2),U(3),U(4),U(5)/5.,-5.,10.,-10.,25./
      DATA U(6),U(7),U(8),U(9)/-25.,50.,-50.,0./
      DATA LASTX,LASTY/-1,-1/
      IF(KDASHT .LT. 0)GO TO 320
      IF(KDASHT .GT. 4)GO TO 101
      IF(KTERM .GE. 3)GO TO 103
      IF(KDASHT .EQ. 0)GO TO 330
      KDASHT=ISIMHD(KDASHT)
101   IF(KLINE .EQ. 0)GO TO 104
      KLINE=0
      CALL CWSEND
      GO TO 104
103   IF(KLINE .EQ. KDASHT)GO TO 330
      KLINE=KDASHT
      CALL CWSEND
      GO TO 330
104   CONTINUE
      IF(KDASHT .EQ. 0)GO TO 330
      IF(KDASHT .EQ. IDTYPE)GO TO 170
      ICHAR=KDASHT
      DO NO=1,10
120     IF(ICHAR.EQ.0)GO TO 150
        I=ICHAR-((ICHAR/10)*10)
        ICHAR=ICHAR/10
        IF(I.EQ.0)GO TO 120
        WORK(NO)=U(I)
      ENDDO
      NO=11
150   NO=NO-1
      DO I=1,NO
        ISUB=NO+1-I
        DTABL(I)=WORK(ISUB)
      ENDDO
      D1=DTABL(1)
      NUM=NO-1
      DO 165 K=1,NUM
      DCUR=DTABL(K)
      IF(DCUR*DTABL(K+1).GT.0. .OR. DCUR*D1 .LT.0.)GO TO 165
      DTABL(K)=DTABL(K)-1.
      DTABL(K+1)=DTABL(K+1)-1.
165   CONTINUE
      IDTYPE=KDASHT
      I=0
      SEGLEN=0
170   IF(NO-1.LT.0)GO TO 320
      IF(NO-1.EQ.0)GO TO 330
      IF(LASTX-KBEAMX.NE.0)GO TO 200
      IF(LASTY-KBEAMY.EQ.0)GO TO 210
200   SEGLEN=0
      I=0
210   X=FLOAT(KBEAMX)
      Y=FLOAT(KBEAMY)
      DX=FLOAT(IX-KBEAMX)
      DY=FLOAT(IY-KBEAMY)
      DIAG=SQRT(DX*DX+DY*DY)
      DIST=DIAG
      IF (SEGLEN-1.5.GT.0)GO TO 230
220   I=MOD(I,NO)+1
      SEGLEN=ABS(DTABL(I))
230   IF(SEGLEN-DIST.GE.0)GO TO 270
      F=SEGLEN/DIAG
      X=X+DX*F
      Y=Y+DY*F
      IF (DTABL(I).GT.0)GO TO 260
      CALL TOUTPT(29)
      KMOVEF=1
260   CALL XYCNVT(IFIX(X),IFIX(Y))
      DIST=DIST-SEGLEN
      SEGLEN=0
      GO TO 220
270   IF(DTABL(I).GT.0)GO TO 290
      CALL TOUTPT(29)
      KMOVEF=1
290   CALL XYCNVT(IX,IY)
      LASTX=IX
      LASTY=IY
      SEGLEN=SEGLEN-DIST
      GO TO 340
320   CALL TOUTPT(29)
      KMOVEF=1
330   CALL XYCNVT(IX,IY)
      NO=1-NO
      IDTYPE=KDASHT
340   RETURN
      END
C
      SUBROUTINE HDCOPY
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2)
      DATA ICODE(1),ICODE(2)/27,23/
      CALL TOUTST(2,ICODE)
      CALL IOWAIT(10)
      RETURN
      END
C
      FUNCTION KIN(RI)
      INCLUDE 'plautcom.f'
      KIN=INT(RI*546.0/FLOAT(KFACTR))
      IF(KTERM .GT. 1)KIN=INT(RI*285.7/FLOAT(KFACTR))
      RETURN
      END
C
      FUNCTION KCM(RC)
      INCLUDE 'plautcom.f'
      KCM=INT(RC*215.2/FLOAT(KFACTR))
      IF(KTERM .GT. 1)KCM=INT(RC*112.48/FLOAT(KFACTR))
      RETURN
      END
C
      SUBROUTINE DCURSR(ICHAR,IX,IY)
      INCLUDE 'plautcom.f'
      CALL SCURSR(ICHAR,IX,IY)
      RETURN
      END
C
      SUBROUTINE SCURSR(ICHAR,IX,IY)
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2),IN(5)
      DATA ICODE(1),ICODE(2)/27,26/
      KMOFLG(1)=1
      CALL TOUTST(2,ICODE)
      KINLFT=0
      CALL TINSTR(5,IN)
      KMOFLG(1)=0
      CALL RECOVR
      ICHAR=IN(1)
      IX=MOD(IN(2),32)*32+MOD(IN(3),32)
      IY=MOD(IN(4),32)*32+MOD(IN(5),32)
      IX=IX*4/KFACTR
      IY=IY*4/KFACTR
      RETURN
      END
C
      SUBROUTINE SVSTAT(RARRAY)
      INCLUDE 'plautcom.f'
      DIMENSION RARRAY(60),IB(41),RB(19)
      EQUIVALENCE (IB(1),KMOFLG(1)),(RB(1),TMINVX)
      DO I=1,19
        RARRAY(I)=RB(I)
      ENDDO
      DO I=1,41
        RARRAY(I+19)=IB(I)
      ENDDO
      RETURN
      END
C
      SUBROUTINE RESTAT(RARRAY)
      INCLUDE 'plautcom.f'
      DIMENSION RARRAY(60),IB(41),RB(19)
      EQUIVALENCE (IB(1),KMOFLG(1)),(RB(1),TMINVX)
      DO I=1,19
        RB(I)=RARRAY(I)
      ENDDO
      DO I=1,41
        IB(I)=INT(RARRAY(I+19))
      ENDDO
      IF(KTERM .GT. 1)CALL CHRSIZ(KSIZEF)
      IF(KTERM .GT. 2)CALL CWSEND
      CALL RECOVR
      RETURN
      END
C
      SUBROUTINE INITT(KCPS,KREAD,KWRITE,KBUF,KBL)
      INCLUDE 'plautcom.f'
      KBAUDR = KCPS
      KPAD2 = KCPS / 22 + 1
      KMOFLG(1)=0
      KTERM=1
      KFACTR=4
      KUNIT=3
      KINLFT=0
      KOTLFT=72
      CALL IOSET(KREAD,KWRITE,KBUF,KBL)
      CALL RESET
      CALL NEWPAG
      RETURN
      END
C
      SUBROUTINE SEELOC(IX,IY)
      INCLUDE 'plautcom.f'
      IX=KBEAMX
      IY=KBEAMY
      RETURN
      END
C
      SUBROUTINE SEEBUF(KFORM)
      INCLUDE 'plautcom.f'
      KFORM=KUNIT
      RETURN
      END
C
      SUBROUTINE SETBUF(KFORM)
      INCLUDE 'plautcom.f'
      KUNIT=KFORM
      IF(KUNIT .LT. 1)KUNIT=1
      IF(KUNIT .GT. 3)KUNIT=3
      RETURN
      END
C
      FUNCTION LEFTIO(IOBUF)
      INCLUDE 'plautcom.f'
      ITEMP=KINLFT
      IF(IOBUF .EQ. 2)ITEMP = KOTLFT
      LEFTIO=ITEMP
      RETURN
      END
C
      SUBROUTINE RESET
      INCLUDE 'plautcom.f'
      KEYCON=1
      TRFACX=1.
      TRFACY=1.
      KBEAMX=0
      KHOMEY=3068/KFACTR
      KBEAMY=KHOMEY
      KMINSX=0
      KMAXSX=4095/KFACTR
      KMINSY=0
      KMAXSY=3120/KFACTR
      KHORSZ=56
      KLINE=0
      KZAXIS=0
      KLMRGN=0
      KRMRGN=4040/KFACTR
      KSIZEF=1
      KTBLSZ=10
      KVERSZ=88
      TMINVX=0.
      TMAXVX=4095./FLOAT(KFACTR)
      TMINVY=0.
      TMAXVY=3120./FLOAT(KFACTR)
      TRCOSF=1.
      TRSINF=0.
      TRSCAL=1.
      CALL MOVABS(KLMRGN,KHOMEY)
      IF(KTERM .GE. 3)CALL CWSEND
      IF(KTERM .GE. 2)CALL CHRSIZ(1)
      CALL ALFMOD
      RETURN
      END
C
      SUBROUTINE TKPNT(IX,IY)
      INCLUDE 'plautcom.f'
      IF(KTERM .GE. 3)GO TO 10
      CALL TOUTPT(29)
      KMOVEF=1
      CALL XYCNVT(IX,IY)
10    CALL XYCNVT(IX,IY)
      RETURN
      END
C
      LOGICAL FUNCTION GENFLG(ITEM)
      INCLUDE 'plautcom.f'
      GENFLG=KGNFLG .EQ. ITEM
      RETURN
      END
C
      SUBROUTINE NEWLIN
      INCLUDE 'plautcom.f'
      CALL CARTN
      CALL LINEF
      RETURN
      END
C
      SUBROUTINE CARTN
      INCLUDE 'plautcom.f'
      IF(KLMRGN.EQ.0)GO TO 10
      CALL MOVABS(KLMRGN,KBEAMY)
      CALL ALFMOD
      GO TO 30
10    IF(KKMODE.NE.0)CALL ALFMOD
      CALL TOUTPT(13)
      KBEAMX=0
      IF(KTERM .GE. 2)CALL CWSEND
30    RETURN
      END
C
      SUBROUTINE LINEF
      INCLUDE 'plautcom.f'
      IF(KKMODE .NE. 0)CALL ALFMOD
      CALL TOUTPT(10)
      KBEAMY=KBEAMY-(KVERSZ+KFACTR/2)/KFACTR
      IF(KBEAMY .GE. 0)GO TO 200
      KBEAMY=KHOMEY
      CALL MOVABS(KBEAMX,KBEAMY)
      CALL ALFMOD
200   IF(KTERM .GE. 2)CALL CWSEND
      RETURN
      END
C
      SUBROUTINE BAKSP
      INCLUDE 'plautcom.f'
      IF(KKMODE.EQ.0)CALL ALFMOD
      CALL TOUTPT(8)
      KBEAMX=KBEAMX-(KHORSZ+KFACTR/2)/KFACTR
      IF(KBEAMX.GE.0)GO TO 10
      KBEAMX=KBEAMX+4095/KFACTR
10    RETURN
      END
C
      SUBROUTINE HOME
      INCLUDE 'plautcom.f'
      CALL MOVABS(KLMRGN,KHOMEY)
      CALL ALFMOD
      RETURN
      END
C
      SUBROUTINE ERASE
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2)
      DATA ICODE(1),ICODE(2)/27,12/
      CALL TOUTST(2,ICODE)
      CALL IOWAIT(3)
      CALL RECOVR
      RETURN
      END
C
      SUBROUTINE RECOVR
      INCLUDE 'plautcom.f'
      IFLAG=KGRAFL
      KMOVEF=0
      MODE=KKMODE+1
      IY=KBEAMY
      CALL ALFMOD
      CALL MOVABS(KBEAMX,IY)
      IF(MODE .LT. 1)MODE=1
      IF(MODE .GT.5)MODE=5
      GO TO (100,200,120,200,200),MODE
100   CALL ALFMOD
      GO TO 200
120   CALL PNTMOD
200   KGRAFL=IFLAG
      RETURN
      END
C
      SUBROUTINE NEWPAG
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2)
      DATA ICODE(1),ICODE(2)/27,12/
      IF(KKMODE .NE. 0)CALL ALFMOD
      CALL TOUTST(2,ICODE)
      CALL IOWAIT(3)
      IF(KLMRGN.EQ.0)GO TO 10
      CALL MOVABS(KLMRGN,KHOMEY)
      CALL ALFMOD
      GO TO 20
10    KBEAMX=0
      KBEAMY=KHOMEY
20    RETURN
      END
C
      SUBROUTINE MOVABS(IX,IY)
      INCLUDE 'plautcom.f'
      CALL VECMOD
      CALL XYCNVT(IX,IY)
      KGRAFL=0
      RETURN
      END
C
      SUBROUTINE IOWAIT(ITIME)
      INCLUDE 'plautcom.f'
      IF(KBAUDR.LE.0)GO TO 20
      KOUNT = ITIME * KBAUDR
      DO J=1,KOUNT
        CALL TOUTPT(22)
      ENDDO
20    RETURN
      END
C
      SUBROUTINE VECMOD
      INCLUDE 'plautcom.f'
      IF(KKMODE.EQ.1)GO TO 10
      CALL TOUTPT(31)
      DO II=1,5
        KPCHAR(II)=-1
      ENDDO
      KKMODE=1
10    CALL TOUTPT(29)
      KMOVEF=1
      RETURN
      END
C
      SUBROUTINE CSIZE(IHORZ,IVERT)
      INCLUDE 'plautcom.f'
      IHORZ=(KHORSZ+KFACTR/2)/KFACTR
      IVERT=(KVERSZ+KFACTR/2)/KFACTR
      RETURN
      END
C
      SUBROUTINE PNTMOD
      INCLUDE 'plautcom.f'
      CALL TOUTPT(31)
      DO II=1,5
        KPCHAR(II)=-1
      ENDDO
      KKMODE=2
      IF(KTERM .GE. 3)CALL TOUTPT(28)
      RETURN
      END
C
      SUBROUTINE IPMOD
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2)
      DATA ICODE(1),ICODE(2)/31,30/
      CALL TOUTST(2,ICODE)
      KKMODE=3
      KGRAFL=0
      RETURN
      END
C
      SUBROUTINE XYCNVT(IX,IY)
      INCLUDE 'plautcom.f'
      DIMENSION IPLT(6),IOPT(6)
      DATA IDREW,ISYN /0,22/
      CALL PLTCHR(IX,IY,IPLT)
      LEN=0
      IF(KPCHAR(1) .EQ. IPLT(1))GO TO 10
      LEN=1
      KPCHAR(1)=IPLT(1)
      IOPT(1)=IPLT(1)
10    IF(KTERM .LE. 2)GO TO 20
      IF(KPCHAR(2) .EQ. IPLT(2))GO TO 20
      LEN=LEN+1
      KPCHAR(2)=IPLT(2)
      IOPT(LEN)=IPLT(2)
      GO TO 30
20    IF(KPCHAR(3) .NE. IPLT(3))GO TO 30
      IF(KPCHAR(4) .EQ. IPLT(4))GO TO 40
30    LEN=LEN+1
      KPCHAR(3)=IPLT(3)
      IOPT(LEN)=IPLT(3)
      IF(KPCHAR(4) .EQ. IPLT(4))GO TO 50
      LEN=LEN+1
      KPCHAR(4)=IPLT(4)
      IOPT(LEN)=IPLT(4)
40    IF(KPCHAR(5) .NE. IPLT(5))GO TO 50
      IF(LEN .NE. 0)GO TO 50
      IF(KMOVEF .EQ. 1)GO TO 50
      IF(IDREW .EQ. 1)GO TO 80
50    LEN=LEN+1
      KPCHAR(5)=IPLT(5)
      IOPT(LEN)=IPLT(5)
60    IF(LEN .GE. KPAD2)GO TO 70
      LEN=LEN+1
      IOPT(LEN)=ISYN
      GO TO 60
70    CALL TOUTST(LEN,IOPT)
      IDREW=1
      IF(KMOVEF .EQ. 1)IDREW=0
      KMOVEF=0
80    KBEAMX=IX
      KBEAMY=IY
      RETURN
      END
C
      FUNCTION LINWDT(NUMCHR)
      INCLUDE 'plautcom.f'
      LINWDT=(KHORSZ * NUMCHR + KFACTR/2)/KFACTR
      RETURN
      END
C
      FUNCTION LINHGT(NUMLIN)
      INCLUDE 'plautcom.f'
      LINHGT=(KVERSZ * NUMLIN + KFACTR/2)/KFACTR
      RETURN
      END
C
      SUBROUTINE CHRSIZ(K)
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2),ICHRTB(2,4)
      COMMON /TKCHRT/ ICHRTB
      DATA ICHRTB(1,1),ICHRTB(2,1)/56,88/
      DATA ICHRTB(1,2),ICHRTB(2,2)/51,83/
      DATA ICHRTB(1,3),ICHRTB(2,3)/34,53/
      DATA ICHRTB(1,4),ICHRTB(2,4)/31,48/
      DATA ICODE(1)/27/
      IF(KTERM .LE. 1)GO TO 10
      IF(K .LT. 1)K=1
      IF(K .GT. 4)K=4
      KSIZEF=K
      KHORSZ=ICHRTB(1,K)
      KVERSZ=ICHRTB(2,K)
      ICODE(2)=55+K
      CALL TOUTST(2,ICODE)
10    RETURN
      END
C
      SUBROUTINE CZAXIS(ICODE)
      INCLUDE 'plautcom.f'
      IF(KTERM .LE. 1)GO TO 10
      KZAXIS=ICODE
      CALL CWSEND
10    RETURN
      END
C
      SUBROUTINE CWSEND
      INCLUDE 'plautcom.f'
      DIMENSION ICODE(2)
      DATA ICODE(1)/27/
      ICODE(2)=96+KZAXIS*8+KLINE
      CALL TOUTST(2,ICODE)
      RETURN
      END
C
      SUBROUTINE PLTCHR(IX,IY,ICHAR)
      INCLUDE 'plautcom.f'
      DIMENSION ICHAR(*)
      KX=IX*KFACTR
      KY=IY*KFACTR
      ICHAR(1)=MOD(KY/128,32)+32
      ICHAR(2)=MOD(KY,4)*4+MOD(KX,4)+96
      ICHAR(3)=MOD(KY/4,32)+96
      ICHAR(4)=MOD(KX/128,32)+32
      ICHAR(5)=MOD(KX/4,32)+64
      RETURN
      END
C
      SUBROUTINE A1IN(NCHAR,IA1)
      INCLUDE 'plautcom.f'
      DIMENSION IADE(74), IA1(1)
      CALL ALFMOD
      ISEND = MIN0(NCHAR,74)
      CALL TINSTR(ISEND,IADE)
      CALL KAS2A1(ISEND,IADE,IA1)
      RETURN
      END
C
      SUBROUTINE AINST(NCHAR,IAM)
      INCLUDE 'plautcom.f'
      DIMENSION IADE(74), IAM(1)
      CALL ALFMOD
      ISEND = MIN0(NCHAR,74)
      CALL TINSTR(ISEND,IADE)
      CALL KAS2AM(ISEND,IADE,IAM)
      RETURN
      END
C
      SUBROUTINE TINPUT(IN)
      INCLUDE 'plautcom.f'
      DIMENSION INT(1)
      CALL TINSTR(1,INT)
      IN=INT(1)
      RETURN
      END
C
      SUBROUTINE A1OUT(NCHAR,IA1)
      INCLUDE 'plautcom.f'
      DIMENSION IADE(72),IA1(1)
      ITEMP=NCHAR
      DO I=1,NCHAR,72
        ISEND=72
        IF(ITEMP .LT. 72)ISEND=ITEMP
        CALL KA12AS(ISEND,IA1(I),IADE)
        CALL ANSTR(ISEND,IADE)
        ITEMP=ITEMP-72
      ENDDO
      RETURN
      END
C
      SUBROUTINE AOUTST(NCHAR,IAM)
      INCLUDE 'plautcom.f'
      DIMENSION IADE(72)
      ITEMP = NCHAR
      DO I=1,NCHAR,72
        ISEND = MIN0(ITEMP,72)
        CALL KAM2AS(ISEND)
        CALL ANSTR(ISEND,IADE)
        ITEMP = ITEMP - 72
      ENDDO
      RETURN
      END
C
      SUBROUTINE ANSTR(NCHAR,IADE)
      INCLUDE 'plautcom.f'
      DIMENSION IADE(1)
      IPT=1
      IF(KKMODE .NE. 0)CALL ALFMOD
      IF(KBEAMX .LT. KLMRGN)GO TO 10
      IF(KBEAMX .LT. KRMRGN)GO TO 20
10    CALL NEWLIN
20    ISEND=((KRMRGN-KBEAMX)*KFACTR+KHORSZ-1)/KHORSZ
      IF(ISEND .LT. 1)ISEND=1
      IEND=IPT+ISEND-1
      IF(IEND .GT. NCHAR)ISEND=NCHAR-IPT+1
      CALL TOUTST(ISEND,IADE(IPT))
      KBEAMX=KBEAMX+(ISEND*KHORSZ+KFACTR/2)/KFACTR
      IPT=IPT+ISEND
      IF(IEND .LT. NCHAR)GO TO 10
      RETURN
      END
C
      SUBROUTINE ANCHO(ICHAR)
      INCLUDE 'plautcom.f'
      IF(KKMODE.EQ.0)GO TO 10
      CALL ALFMOD
10    CALL TOUTPT(ICHAR)
      KBEAMX=KBEAMX+(KHORSZ+KFACTR/2)/KFACTR
      IF(KBEAMX.LT.KRMRGN)GO TO 20
      CALL NEWLIN
20    RETURN
      END
C
      SUBROUTINE TOUTPT(KKOUT)
      INCLUDE 'plautcom.f'
      DIMENSION KOUT(1)
      KOUT(1)=KKOUT
      CALL TOUTST(1,KOUT)
      RETURN
      END
C
      SUBROUTINE ALFMOD
      INCLUDE 'plautcom.f'
      CALL TOUTPT(31)
      KKMODE=0
      IF(KBEAMY.GT.KHOMEY) KBEAMY=KHOMEY
      RETURN
      END
C
      SUBROUTINE TOUTST(LEN,IADE)
      INCLUDE 'plautcom.f'
      integer*2 iout(75) 
      INTEGER IADE(1), FIRST, BLOKLEN
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      DATA BLOKLEN /73/
                       
      IF((LEN.LE.0) .OR. (KWRITE.LE.0))RETURN
      FIRST = 1
      LAST = BLOKLEN
                    
20    IF(LAST.GT.LEN)LAST = LEN
      NXTOUT = 0
      DO I=FIRST,LAST
        NXTOUT = NXTOUT + 1
        IOUT(NXTOUT) = IADE(I)
      ENDDO
      WRITE(KWRITE,101)char(iout(1))
      if(nxtout.gt.1)then
        do 99 i=2,nxtout
          write(kwrite,101)char(iout(i))
 99     continue
      endif
101   FORMAT(A1,$)
            IF(LAST.GE.LEN)RETURN
      FIRST = FIRST + BLOKLEN
      LAST = LAST + BLOKLEN
      GO TO 20
      END
C
      SUBROUTINE TINSTR(NCHAR,IADE)
      INCLUDE 'plautcom.f'
      INTEGER IBUFF(75), IADE(1)
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      DATA IBLANK /32/
      IF(NCHAR.LE.0)RETURN
      IF(INMODE.EQ.0 .AND. KINLFT.GT.0)GO TO 20
      CALL ADEIN(IGOT,IBUFF)
      NXTOUT = 0
      MOVENUM = 0
      KINLFT = IGOT
      IF(KINLFT .LE. 0)GO TO 60
20    MOVENUM = NCHAR
      IF(MOVENUM .GT. KINLFT)MOVENUM = KINLFT
      DO 40 I=1,MOVENUM
      NXTOUT = NXTOUT + 1
      IADE(I) = IBUFF(NXTOUT)
40    CONTINUE
      KINLFT = IGOT - NXTOUT
      IF(MOVENUM .LT. NCHAR)GO TO 60
      IF(INMODE .EQ. 1)KINLFT = 0
      RETURN
60    KINLFT = 0
      MOVENUM = MOVENUM + 1
      DO 80 I=MOVENUM,NCHAR
      IADE(I) = IBLANK
80    CONTINUE
      RETURN
      END
C
      SUBROUTINE ADEIN(ICOUNT,IBUFF)
      INCLUDE 'plautcom.f'
      INTEGER  IPK(75), IBUFF(1)
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      ICOUNT = 0
      IF((KREAD.EQ.0) .OR. (KWRITE.EQ.0))RETURN
      READ(KREAD,101)IPK
101   FORMAT(75A1)
      DO 40 I=1,75
      IF(IPK(I) .EQ. 0)GO TO 40
      IF(IPK(I) .EQ. 15) GO TO 80
      IF(IPK(I) .NE. 10) GO TO 30
      ITEMP = MAX0(ITEMP-1,0)
      GO TO 40
30    ITEMP = ITEMP + 1
      IBUFF(ITEMP) = IPK(I)
40    CONTINUE
80    ICOUNT = MAX0(ITEMP,0)
      RETURN
      END
C
      SUBROUTINE IOSET(KIN,KOUT,KBUF,KBL)
      INCLUDE 'plautcom.f'
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      DATA KREAD, KWRITE, KSPOOL, INMODE /3*0,0/
      KREAD = KIN
      KWRITE = KOUT
      IF((KREAD.LT.0) .OR. (KREAD.GT.99)) KREAD = 0
      IF((KWRITE.LT.0) .OR. (KWRITE.GT.99)) KWRITE = 0
      RETURN
      END
C
      SUBROUTINE TSEND
      INCLUDE 'plautcom.f'
      RETURN
      END
C
      SUBROUTINE BUFMOD
      INCLUDE 'plautcom.f'
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      INMODE = 0
      RETURN
      END
C
      SUBROUTINE LINMOD
      INCLUDE 'plautcom.f'
      COMMON /TIOCOM/ KREAD, KWRITE, KSPOOL, INMODE
      INMODE = 1
      KINLFT = 0
      RETURN
      END
C
      SUBROUTINE KAS2A1(NCHAR,KADE,KA1)
      INCLUDE 'plautcom.f'
      INTEGER KA1(1), KADE(1)
      IF(NCHAR .LE. 0)RETURN
      DO I=1,NCHAR
        KA1(I) = KADE(I)
      ENDDO
      RETURN
      END
C
      SUBROUTINE KA12AS(NCHAR,KA1,KADE)
      INCLUDE 'plautcom.f'
      INTEGER KA1(1), KADE(1)
      IF(NCHAR .LE. 0)RETURN
      DO I=1,NCHAR
        KADE(I) = KA1(I)
      ENDDO
      RETURN
      END
C
      SUBROUTINE KAS2AM(NCHAR,KADE,KAM)
      INCLUDE 'plautcom.f'
      INTEGER  KADE(1), KAM(1)
      IF(NCHAR .LE. 0) RETURN
      IN = 0
      IOUT = 0
      LEFT = NCHAR
      IF(LEFT .LT. 4) GO TO 60
20    IOUT = IOUT + 1
      KAM(IOUT) = KADE(IN+1)+KADE(IN+2)*256
      KAM(IOUT) = KAM(IOUT)+KADE(IN+3)*65536+KADE(IN+4)*16777216
      IN = IN + 4
      LEFT = LEFT - 4
      IF(LEFT .GE. 4) GO TO 20
      IF(LEFT .EQ. 0) RETURN
60    IOUT = IOUT + 1
      IF(LEFT.NE.3) GO TO 61
      KAM(IOUT)=KADE(IN+1)+KADE(IN+2)*256+KADE(IN+3)*65536+32*16777216
      RETURN
61    IF(LEFT.NE.2) GO TO 62
      KAM(IOUT)=KADE(IN+1)+KADE(IN+2)*256+32*65536+32*16777216
      RETURN
62    IF(LEFT.NE.1) RETURN
      KAM(IOUT)=KADE(IN+1)+32*256+32*65536+32*16777216
      RETURN
      END
C
      SUBROUTINE KAM2AS(NCHAR)
      INCLUDE 'plautcom.f'
      IF(NCHAR .LE. 0) RETURN
      RETURN
      END

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for Optimization
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE OPTIMIZATION

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
  USE AE
  USE BVP
  USE INTERFACES
  USE TOOLBOXAE
  USE TOOLBOXBV
  USE PERIODIC
  USE SUPPORT

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: AUTOOP

  DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

  INTERFACE
     SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP)
       INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
       DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
       DOUBLE PRECISION, INTENT(OUT) :: FS
       DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM),DFDP(*)
     END SUBROUTINE FOPT
  END INTERFACE

CONTAINS

! ---------- ------
  SUBROUTINE AUTOOP(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    INTEGER IPS, ISW, ITP, NDIM, NFPR, NFPRPREV, I, IC, JC, NNEG
    IPS = AP%IPS
    ISW = AP%ISW
    ITP = AP%ITP
    NDIM = AP%NDIM
    NFPR = AP%NFPR

    IF(IPS==15.AND.ABS(ISW)==1) THEN
       ! ** Optimization of periodic solutions.
       NFPRPREV=NFPR
       NFPR=0
       DO I=1,AP%NICP
          IF(ICU(I)>0)THEN
             NFPR=NFPR+1
             ICP(NFPR)=ICU(I)
          ENDIF
       ENDDO
       ICP(NFPR+1)=10
       ICP(NFPR+2)=13
       ICP(NFPR+3)=14
       NFPR=NFPR+3
       AP%NFPR=NFPR
       AP%NDIM=2*NDIM
       AP%NBC=AP%NDIM
       AP%NINT=NFPR-1
       ! overload to define optimality integrals
       NNEG=0
       DO I=1,AP%NICP
          IC=ICU(I)
          JC=ABS(IC)-20        
          IF(IC<0.AND.JC>0.AND.JC<=11)THEN
             NNEG=NNEG+1
             ICP(NFPR+NNEG)=JC
          ENDIF
       ENDDO
       AP%NICP=NFPR-3
       IF(NFPRPREV<6)THEN
          CALL AUTOBV(AP,ICP,ICU,FNPO,BCPS,ICPO,STPNPO,FNCSBV)
       ELSE
          CALL AUTOBV(AP,ICP,ICU,FNPO,BCPS,ICPO,STPNBV,FNCSBV)
       ENDIF
    ELSE IF(IPS==5) THEN
       ! ** Algebraic optimization problems.
       IF(MOD(ITP,10)==2.OR.AP%IRS==0)NFPR=NFPR+1
       AP%NFPR=NFPR
       ICP(1)=10
       IF(NFPR==2) THEN
          AP%NDIM=NDIM+1
          IF(AP%IRS>0) THEN
             CALL AUTOAE(AP,ICP,ICU,FNC1,STPNAE,FNCSAE)
          ELSE
             CALL AUTOAE(AP,ICP,ICU,FNC1,STPNC1,FNCSAE)
          ENDIF
       ELSE
          AP%NDIM=2*NDIM+NFPR
          IF(MOD(ITP,10)/=2) THEN
             CALL AUTOAE(AP,ICP,ICU,FNC2,STPNAE,FNCSAE)
          ELSE
             CALL AUTOAE(AP,ICP,ICU,FNC2,STPNC2,FNCSAE)
          ENDIF
       ENDIF
    ENDIF
  END SUBROUTINE AUTOOP

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!     Subroutines for the Optimization of Algebraic Systems
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNC1(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generate the equations for the continuation scheme used for
    ! the optimization of algebraic systems (one parameter).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DDU(:),DDP(:)
    INTEGER JAC,NDM,NFPR,NPAR,I

    JAC=AP%JAC
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR
    ALLOCATE(DDU(NDM),DDP(NPAR))

    PAR(ICP(2))=U(NDIM)
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Rearrange (Since dimensions in FNC1 and FUNI differ).

    IF(IJAC.NE.0)THEN
       CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
       CALL EXPANDJAC(DFDP,NPAR,NDM,NDIM)
    ENDIF

    CALL FOPI(JAC,NFPR,NDM,U,ICP,PAR,IJAC,F(NDIM),DDU,DDP)
    F(NDIM)=PAR(ICP(1))-F(NDIM)

    IF(IJAC.NE.0)THEN
       DO I=1,NDM
          DFDU(NDIM,I)=-DDU(I)
          DFDU(I,NDIM)=DFDP(I,ICP(2))
          DFDP(I,ICP(1))=0
       ENDDO
       DFDU(NDIM,NDIM)=-DDP(ICP(2))
       DFDP(NDIM,ICP(1))=1
    ENDIF

    DEALLOCATE(DDU,DDP)
  END SUBROUTINE FNC1

! ---------- ------
  SUBROUTINE STPNC1(AP,PAR,ICP,U,UDOT,NODIR)

    ! Generate starting data for optimization problems (one parameter).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)
    ! Local
    INTEGER NDIM,JAC,NDM,NFPR
    DOUBLE PRECISION DUM(1),T,FOP

    NDIM=AP%NDIM
    JAC=AP%JAC
    NDM=AP%NDM
    NFPR=AP%NFPR

    T=0.d0
    U(:NDIM)=0.d0
    CALL STPNT(NDIM,U,PAR,T)
    CALL FOPI(JAC,NFPR,NDM,U,ICP,PAR,0,FOP,DUM,DUM)
    PAR(ICP(1))=FOP
    U(NDIM)=PAR(ICP(2))
    NODIR=1
    UDOT(:NDIM)=0d0

  END SUBROUTINE STPNC1

! ---------- ----
  SUBROUTINE FNC2(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generate the equations for the continuation scheme used for the
    ! optimization of algebraic systems (more than one parameter).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DDP(:),DFU(:),DFP(:),FF1(:),FF2(:)
    INTEGER NDM,NPAR,I,J
    DOUBLE PRECISION UMX,EP,UU

    NDM=AP%NDM
    NPAR=AP%NPAR

    ! Generate the function.

    ALLOCATE(DDP(NPAR))
    CALL FFC2(AP,NDIM,U,UOLD,ICP,PAR,F,NDM,DFDU,DFDP,DDP)

    IF(IJAC.EQ.0)THEN
       DEALLOCATE(DDP)
       RETURN
    ENDIF

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(DFU(NDM*NDM),DFP(NDM*NPAR),FF1(NDIM),FF2(NDIM))
    DO I=1,NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FFC2(AP,NDIM,U,UOLD,ICP,PAR,FF1,NDM,DFU,DFP,DDP)
       U(I)=UU+EP
       CALL FFC2(AP,NDIM,U,UOLD,ICP,PAR,FF2,NDM,DFU,DFP,DDP)
       U(I)=UU
       DO J=1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO
    DEALLOCATE(DFU,DFP,FF1,FF2,DDP)

    IF (IJAC.EQ.1)RETURN

    DO I=1,NDIM
       DFDP(I,ICP(1))=0.d0
    ENDDO
    DFDP(NDIM,ICP(1))=1.d0

  END SUBROUTINE FNC2

! ---------- ----
  SUBROUTINE FFC2(AP,NDIM,U,UOLD,ICP,PAR,F,NDM,DFDU,DFDP,DDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NDM
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*),DDP(AP%NPAR)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    ! Local
    INTEGER JAC,NFPR,NPAR,NDM2,ICPM,I,J
    DOUBLE PRECISION FOP

    JAC=AP%JAC
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    DO I=2,NFPR
       PAR(ICP(I))=U(2*NDM+I)
    ENDDO
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,2,F,DFDU,DFDP)
    CALL FOPI(JAC,NFPR,NDM,U,ICP,PAR,2,FOP,F(NDM+1),DDP)

    DO I=1,NDM
       F(NDM+I)=F(NDM+I)*U(2*NDM+1)
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(J,I)*U(NDM+J)
       ENDDO
    ENDDO

    NDM2=2*NDM
    ICPM=NFPR-2
    DO I=1,ICPM
       F(NDM2+I)=DDP(ICP(I+1))*U(NDM2+1)
    ENDDO

    DO I=1,ICPM
       DO J=1,NDM
          F(NDM2+I)=F(NDM2+I)+U(NDM+J)*DFDP(J,ICP(I+1))
       ENDDO
    ENDDO

    F(NDIM-1)=U(NDM2+1)*U(NDM2+1)-1
    DO J=1,NDM
       F(NDIM-1)=F(NDIM-1)+U(NDM+J)*U(NDM+J)
    ENDDO
    F(NDIM)=PAR(ICP(1))-FOP

  END SUBROUTINE FFC2

! ---------- ------
  SUBROUTINE STPNC2(AP,PAR,ICP,U,UDOT,NODIR)

    USE IO
    USE SUPPORT

    ! Generates starting data for the continuation equations for
    ! optimization of algebraic systems (More than one parameter).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:),DFP(:),DD(:,:),DU(:),V(:),F(:),DP(:)
    INTEGER, ALLOCATABLE :: ICPRS(:)
    INTEGER NDIM,JAC,NDM,NFPR,NPAR,I,J
    DOUBLE PRECISION FOP

    NDIM=AP%NDIM
    JAC=AP%JAC
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ALLOCATE(ICPRS(NFPR))
    CALL READLB(AP,ICPRS,U,UDOT,PAR)
    DEALLOCATE(ICPRS)

    IF(NFPR.EQ.3)THEN
       ALLOCATE(DFU(NDM*NDM),DFP(NDM*NPAR),F(NDM),V(NDM+1))
       ALLOCATE(DD(NDM+1,NDM+1),DU(NDM),DP(NPAR))
       CALL FUNI(AP,NDM,U,U,ICP,PAR,2,F,DFU,DFP)
       CALL FOPI(JAC,NFPR,NDM,U,ICP,PAR,2,FOP,DU,DP)
       !       TRANSPOSE
       DO I=1,NDM
          DO J=1,NDM
             DD(I,J)=DFU((I-1)*NDM+J)
          ENDDO
       ENDDO
       DO I=1,NDM
          DD(I,NDM+1)=DU(I)
          DD(NDM+1,I)=DFP((ICP(2)-1)*NDM+I)
       ENDDO
       DD(NDM+1,NDM+1)=DP(ICP(2))
       CALL NLVC(NDM+1,NDM+1,1,DD,V)
       CALL NRMLZ(NDM+1,V)
       DO I=1,NDM+1
          U(NDM+I)=V(I)
       ENDDO
       PAR(ICP(1))=FOP
       DEALLOCATE(DFU,DFP,F,V,DD,DU,DP)
    ENDIF

    DO I=1,NFPR-1
       U(NDIM-NFPR+1+I)=PAR(ICP(I+1))
    ENDDO

    NODIR=1
  END SUBROUTINE STPNC2

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for Optimization of Periodic Solutions
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNPO(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for periodic optimization problems.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:),FF1(:),FF2(:),UPOLD(:)
    INTEGER NDM,NFPR,I,J
    DOUBLE PRECISION UMX,EP,P,PERIOD,UU,DUMDU(1),DUMDP(1)

    NDM=AP%NDM
    NFPR=AP%NFPR

    ! Generate F(UOLD)

    ALLOCATE(UPOLD(NDIM))
    CALL FUNC(NDM,UOLD,ICP,PAR,0,UPOLD,DUMDU,DUMDP)
    PERIOD=PAR(11)
    DO I=1,NDM
       UPOLD(I)=PERIOD*UPOLD(I)
    ENDDO

    ! Generate the function.

    CALL FFPO(AP,U,UOLD,UPOLD,ICP,PAR,F,NDM,DFDU)

    IF(IJAC.EQ.0)THEN
       DEALLOCATE(UPOLD)
       RETURN
    ENDIF

    ALLOCATE(DFU(NDIM*NDIM),FF1(NDIM),FF2(NDIM))

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DO I=1,NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FFPO(AP,U,UOLD,UPOLD,ICP,PAR,FF1,NDM,DFU)
       U(I)=UU+EP
       CALL FFPO(AP,U,UOLD,UPOLD,ICP,PAR,FF2,NDM,DFU)
       U(I)=UU
       DO J=1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(UPOLD,DFU,FF1)
       RETURN
    ENDIF

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FFPO(AP,U,UOLD,UPOLD,ICP,PAR,FF1,NDM,DFU)
       DO J=1,NDIM
          DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(UPOLD,DFU,FF1)
  END SUBROUTINE FNPO

! ---------- ----
  SUBROUTINE FFPO(AP,U,UOLD,UPOLD,ICP,PAR,F,NDM,DFDU)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDM
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*),UPOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(*),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDM*2)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,*)
    ! Local
    INTEGER JAC,NFPR,I,J
    DOUBLE PRECISION DUMDP(1),PERIOD,RKAPPA,GAMMA,DFU,FOP

    JAC=AP%JAC
    NFPR=AP%NFPR
    PERIOD=PAR(11)
    RKAPPA=PAR(13)
    GAMMA =PAR(14)

    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,1,F(NDM+1),DFDU,DUMDP)
    CALL FOPI(JAC,NFPR,NDM,U,ICP,PAR,1,FOP,F,DUMDP)

    DO I=1,NDM
       DFU=F(I)
       F(I)=F(NDM+I)
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)-DFDU(J,I)*U(NDM+J)
       ENDDO
       F(I)=PERIOD*F(I)
       F(NDM+I)=PERIOD*F(NDM+I)+ RKAPPA*UPOLD(I) + GAMMA*DFU
    ENDDO

  END SUBROUTINE FFPO

! ---------- ----
  SUBROUTINE ICPO(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Generates integral conditions for periodic optimization problems.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:),DFP(:),F1(:),F2(:)
    INTEGER NPAR,NDM,NFPR,I,J
    DOUBLE PRECISION UMX,EP,P,UU

    NPAR=AP%NPAR
    ALLOCATE(DFU(NDIM*NDIM),DFP(NDIM*NPAR))

    NDM=AP%NDM
    NFPR=AP%NFPR

    ! Generate the function.

    CALL FIPO(AP,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,NDM,DFU,DFP)

    IF(IJAC.EQ.0)THEN
       DEALLOCATE(DFU,DFP)
       RETURN
    ENDIF

    ! Generate the Jacobian.

    ALLOCATE(F1(NINT),F2(NINT))
    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DO I=1,NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FIPO(AP,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F1,NDM,DFU,DFP)
       U(I)=UU+EP
       CALL FIPO(AP,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F2,NDM,DFU,DFP)
       U(I)=UU
       DO J=1,NINT
          DINT(J,I)=(F2(J)-F1(J))/(2*EP)
       ENDDO
    ENDDO

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FIPO(AP,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F1,NDM,DFU,DFP)
       DO J=1,NINT
          DINT(J,NDIM+ICP(I))=(F1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(F1,F2,DFU,DFP)
  END SUBROUTINE ICPO

! ---------- ----
  SUBROUTINE FIPO(AP,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,NDM,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDM,NINT
    DOUBLE PRECISION, INTENT(IN)::UOLD(2*NDM),UDOT(2*NDM),UPOLD(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(2*NDM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)

    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFP(:),F(:)
    INTEGER JAC,NFPR,NPAR,INDX,I,J,L
    DOUBLE PRECISION FOP

    JAC=AP%JAC
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    FI(1)=0.d0
    DO I=1,NDM
       FI(1)=FI(1)+(U(I)-UOLD(I))*UPOLD(I)
    ENDDO

    ALLOCATE(F(NDM),DFP(NPAR))
    DO I=1,NPAR
       DFP(I)=0.d0
    ENDDO
    CALL FOPI(JAC,NFPR,NDM,U,ICP,PAR,2,FOP,F,DFP)
    FI(2)=PAR(10)-FOP

    FI(3)=PAR(13)**2+PAR(14)**2-PAR(12)
    DO I=1,NDM
       FI(3)=FI(3)+U(NDM+I)**2
    ENDDO

    DO I=1,NDM
       DO J=1,NPAR
          DFDP(I,J)=0.d0
       ENDDO
    ENDDO
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,2,F,DFDU,DFDP)

    DO L=4,NINT
       INDX=ICP(NFPR+L-3)
       IF(INDX.EQ.11)THEN
          FI(L)=-PAR(14)*DFP(INDX) - PAR(20+INDX)
          DO I=1,NDM
             FI(L)=FI(L)+F(I)*U(NDM+I)
          ENDDO
       ELSE
          FI(L)=-PAR(14)*DFP(INDX) - PAR(20+INDX)
          DO I=1,NDM
             FI(L)=FI(L)+PAR(11)*DFDP(I,INDX)*U(NDM+I)
          ENDDO
       ENDIF
    ENDDO

    DEALLOCATE(DFP,F)
  END SUBROUTINE FIPO

! ---------- ------
  SUBROUTINE STPNPO(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP
    USE IO
    USE MESH

    ! Generates starting data for optimization of periodic solutions.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    INTEGER, ALLOCATABLE :: ICPRS(:)
    DOUBLE PRECISION, ALLOCATABLE :: U(:),TEMP(:),DTMTEMP(:)
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER NDIM,NTST,NCOL,NDM,NFPR,NPAR,NDIMRD,ITPRS,I,J,K
    DOUBLE PRECISION FS,DUMU(1),DUMP(1)

    NDIM=AP%NDIM
    NTST=AP%NTST
    NCOL=AP%NCOL
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ALLOCATE(ICPRS(NFPR))
    ALLOCATE(UPSR(NDM,0:NCOLRS*NTSR),UDOTPSR(NDM,0:NCOLRS*NTSR), &
         TMR(0:NTSR))
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOT,UPSR, &
         UDOTPSR,TMR,ITPRS,NDM)
    DEALLOCATE(ICPRS)
    ALLOCATE(U(NDM),TEMP(0:NTSR*NCOLRS),DTMTEMP(NTSR))
    DO J=1,NTSR
       DTMTEMP(J)=TMR(J)-TMR(J-1)
    ENDDO

    ! Compute the starting value of the objective functional
    DO J=0,NTSR*NCOLRS
       DO K=1,NDM
          U(K)=UPSR(K,J)
       ENDDO
       CALL FOPT(NDM,U,ICP,PAR,0,FS,DUMU,DUMP)
       TEMP(J)=FS
    ENDDO
    PAR(10)=RINTG(NTSR,NCOLRS,1,1,TEMP,DTMTEMP)
    DEALLOCATE(U,TEMP,DTMTEMP)

    ! Complement starting data

    DO I=12,NPAR
       PAR(I)=0.d0
    ENDDO

    NODIR=1
    CALL ADAPT2(NTSR,NCOLRS,NDM,NTST,NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNPO

! ---------- ----
  SUBROUTINE FOPI(JAC,NFPR,NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Interface subroutine to user supplied FOPT.

    INTEGER, INTENT(IN) :: JAC,NFPR,NDIM,ICP(*),IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U(*),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM),DFDP(*)
    ! Local
    INTEGER IJC,I
    DOUBLE PRECISION UU,UMX,EP,P,F1,F2


    ! Generate the objective function.

    IF(JAC.EQ.0)THEN
       IJC=0
    ELSE
       IJC=IJAC
    ENDIF
    CALL FOPT(NDIM,U,ICP,PAR,IJC,F,DFDU,DFDP)

    IF(JAC.EQ.1 .OR. IJAC.EQ.0)RETURN

    ! Generate the Jacobian by differencing.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DO I=1,NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FOPT(NDIM,U,ICP,PAR,0,F1,DFDU,DFDP)
       U(I)=UU+EP
       CALL FOPT(NDIM,U,ICP,PAR,0,F2,DFDU,DFDP)
       U(I)=UU
       DFDU(I)=(F2-F1)/(2*EP)
    ENDDO

    IF(IJAC.EQ.1)RETURN

    DO I=1,NFPR
       P=PAR(ICP(I))
       EP=HMACH*( 1 +ABS(P) )
       PAR(ICP(I))=P+EP
       CALL FOPT(NDIM,U,ICP,PAR,0,F1,DFDU,DFDP)
       DFDP(ICP(I))=(F1-F)/EP
       PAR(ICP(I))=P
    ENDDO

  END SUBROUTINE FOPI

END MODULE OPTIMIZATION

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   bvp :    A nonlinear ODE eigenvalue problem
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!--------- ---- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
  DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
  DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,*), DFDP(NDIM,*)

  DOUBLE PRECISION pi

  pi = 4.d0*ATAN(1.d0)

  F(1) = U(2)
  F(2) = -( PAR(1)*pi )**2 * U(1) + U(1)**2

END SUBROUTINE FUNC

SUBROUTINE STPNT(NDIM,U,PAR,T) 
!--------- ----- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM
  DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM), PAR(*)
  DOUBLE PRECISION, INTENT(IN) :: T

  PAR(1:2) = 0.0d0

  U = 0.0d0

END SUBROUTINE STPNT

SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!--------- ---- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
  DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
  DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
  DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

  FB = (/ U0(1), U1(1) /)

END SUBROUTINE BCND

SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!--------- ----

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
  DOUBLE PRECISION, INTENT(IN) :: PAR(*)
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
  DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
  DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

  FI = (/ U(1)-PAR(2) /)

END SUBROUTINE ICND

SUBROUTINE FOPT 
END SUBROUTINE FOPT

SUBROUTINE PVLS
END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   spb :    A singularly perturbed BVP
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION U1,U2,EPS,RL

       U1=U(1)
       U2=U(2)
       EPS=PAR(2)
       RL =PAR(3)

       F(1)=U2 
       F(2)=RL * ( U1*(U1**2-1)*U2 + U1 ) / EPS 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,X)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: X

      DOUBLE PRECISION GAMMA,EPS,RL,S

       GAMMA=1.2
       EPS=0.1
       RL=0.

       PAR(1)=GAMMA
       PAR(2)=EPS
       PAR(3)=RL

       S=GAMMA-1.5
       U(1)=1.5 + S*X
       U(2)=S

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

       FB(1)=U0(1)-1.5
       FB(2)=U1(1)-PAR(1) 

      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!          Periodic Solutions and Fixed Period Orbits
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE PERIODIC

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
  USE INTERFACES
  USE TOOLBOXBV
  USE BVP
  USE SUPPORT

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: AUTOPS,INITPS
  PUBLIC :: BCPS,ICPS,STPNPS,FNCSPS ! Periodic solutions
  PUBLIC :: FNPLF,BCPL,ICPL,STPNPL ! Fold cont of periodic sol

  DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

CONTAINS

! ---------- ------
  SUBROUTINE INITPS(AP,ICP)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(*)

    INTEGER IPS, ITP, ISW, NICP, NDIM, NBC, NINT, NPAR, NPARI

    IPS = AP%IPS
    ITP = AP%ITP
    ISW = AP%ISW
    NICP = AP%NICP
    NDIM = AP%NDIM
    NBC = AP%NBC
    NINT = AP%NINT
    NPAR = AP%NPAR
    NPARI = AP%NPARI

    IF(ABS(ISW)<=1)THEN
       IF(IPS/=7)THEN
          ! ** Periodic Solutions
          NBC=NDIM
          NINT=1
          ! **ISW=1 when starting from a HB
          IF(ITP==3.OR.(ABS(ITP)/10)==3)ISW=1
          IF(NICP==1)THEN
             ! **Variable period
             ICP(2)=11
          ENDIF
       ENDIF
    ELSE
       IF(ABS(ITP)/10==5 .OR. ITP==5)THEN
          NDIM=2*NDIM
          NBC=NDIM
          NINT=3
          NPARI=2
          IF(ICP(3)==11 .OR. NICP==2)THEN
             ! ** Variable period
             IF( ITP/=5 )ICP(3)=ICP(2)
             ICP(2)=11
          ENDIF
          IF( ITP==5 )THEN
             ! ** Fold continuation (Periodic solutions); start
             ISW=-2
             ICP(3)=NPAR+2
          ENDIF
          ICP(4)=NPAR+1
       ELSEIF(ITP==6.OR.ABS(ITP)/10==6)THEN
          ! ** BP cont (Periodic solutions); start/restart (by F. Dercole)
          IF(ABS(ISW)==2)THEN
             ! ** Non-generic case
             IF(ICP(3)==11 .OR. NICP==2)THEN
                ! ** Variable period
                ICP(3)=ICP(2)
                ICP(2)=11 ! T
             ENDIF
             ICP(4)=NPAR+3 ! b
             NPARI=3
          ELSE
             ! ** Generic case
             IF(ICP(4)==11 .OR. NICP==3)THEN
                ! ** Variable period
                ICP(4)=ICP(3)
                ICP(3)=ICP(2)
                ICP(2)=11 ! T
             ENDIF
             NPARI=2
          ENDIF
          ICP(5)=NPAR+1     ! phi^*_3
          NDIM=2*NDIM
          NINT=4
          IF(ITP==6)THEN
             ! start
             NDIM=2*NDIM
             NINT=10
             ICP(3)=NPAR+2   ! a
             ICP(4)=NPAR+3   ! b
             ICP(6)=NPAR+4   ! q1
             ICP(7)=NPAR+5   ! q2/beta1
             ICP(8)=NPAR+6   ! r1
             ICP(9)=NPAR+7   ! r2/beta2
             ICP(10)=NPAR+8  ! c1
             ICP(11)=NPAR+9  ! c2
             ISW=-ABS(ISW)
             NPARI=9
          ENDIF
          NBC=NDIM
       ELSEIF(ITP==7.OR.ABS(ITP)/10==7)THEN
          ! ** Continuation of period doubling bifurcations; start/restart
          NDIM=2*NDIM
          NBC=NDIM
          NINT=2
          IF(ITP==7)THEN
             ! start
             IF(ICP(3)==11 .OR. NICP==2)THEN
                ! ** Variable period
                ICP(2)=11
             ENDIF
             ICP(3)=NPAR+1
             ISW=-2
          ELSEIF(NICP==2)THEN
             ! ** restart with variable period
             ICP(3)=11
          ENDIF
          NPARI=1
       ELSE IF(ITP==8.OR.ABS(ITP)/10==8)THEN
          ! ** Continuation of torus bifurcations; start/restart
          NDIM=3*NDIM
          NBC=NDIM
          NINT=3
          IF(ITP==8)THEN
             ! start
             ICP(2)=11
             ICP(3)=12
             ICP(4)=NPAR+1
             ISW=-2
          ELSEIF(NICP<4)THEN
             ! **restart if not specified by user
             ICP(3)=11
             ICP(4)=12
          ENDIF
          NPARI=1
       ENDIF
    ENDIF
    AP%NDIM=NDIM
    AP%NBC=NBC
    AP%NINT=NINT
    AP%NFPR=NBC+NINT-NDIM+1
    AP%NPARI=NPARI
    AP%ISW=ISW
    AP%NTEST=3

  END SUBROUTINE INITPS

! ---------- ------
  SUBROUTINE AUTOPS(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    INTEGER IPS, ISW, ITP

    CALL INITPS(AP,ICP)
    IPS = AP%IPS
    ISW = AP%ISW
    ITP = AP%ITP

    IF(ABS(ISW)<=1)THEN
       IF(IPS==2)THEN
          ! ** Periodic solutions
          CALL AUTOBV(AP,ICP,ICU,FNPS,BCPS,ICPS,STPNPS,FNCSPS)
       ELSE 
          ! Boundary value problems with Floquet multipliers. (IPS=7)
          CALL AUTOBV(AP,ICP,ICU,FUNI,BCNI,ICNI,STPNPS,FNCSPS)
       ENDIF
    ELSE ! here IPS=2
       IF(ABS(ISW)==2)THEN
          IF(ITP==5) THEN 
             ! ** Fold continuation (Periodic solutions, start).
             CALL AUTOBV(AP,ICP,ICU,FNPL,BCPL,ICPL,STPNPL,FNCSPS)
          ELSE IF((ABS(ITP)/10)==5)THEN
             ! ** Fold continuation (Periodic solutions, restart).
             CALL AUTOBV(AP,ICP,ICU,FNPL,BCPL,ICPL,STPNBV,FNCSPS)
          ELSE IF(ITP==7) THEN
             ! ** Continuation of period doubling bifurcations (start).
             CALL AUTOBV(AP,ICP,ICU,FNPD,BCPD,ICPD,STPNPD,FNCSPS)
          ELSE IF(ABS(ITP)/10==7)THEN
             ! ** Continuation of period doubling bifurcations (restart).
             CALL AUTOBV(AP,ICP,ICU,FNPD,BCPD,ICPD,STPNBV,FNCSPS)
          ELSE IF(ITP==8)THEN
             ! ** Continuation of torus bifurcations (start).
             CALL AUTOBV(AP,ICP,ICU,FNTR,BCTR,ICTR,STPNTR,FNCSPS)
          ELSE IF(ABS(ITP)/10==8)THEN
             ! ** Continuation of torus bifurcations (restart).
             CALL AUTOBV(AP,ICP,ICU,FNTR,BCTR,ICTR,STPNBV,FNCSPS)
          ENDIF
       ENDIF
       IF(ITP==6.OR.(ABS(ITP)/10)==6) THEN
          ! ** BP cont (Periodic sol., start and restart) (by F. Dercole).
          CALL AUTOBV(AP,ICP,ICU,FNPBP,BCPBP,ICPBP,STPNPBP,FNCSPS)
       ENDIF
    ENDIF
  END SUBROUTINE AUTOPS

! ---------- ----
  SUBROUTINE FNPS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the continuation of periodic orbits.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    INTEGER J
    DOUBLE PRECISION PERIOD

    ! Generate the function.

    CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,ABS(IJAC),F,DFDU,DFDP)
    PERIOD=PAR(11)
    IF(IJAC==2.OR.IJAC==-1)THEN
       DO J=1,AP%NFPR
          IF(ICP(J)==11)THEN
             !          **Variable period continuation
             DFDP(:,11)=F(:)
          ELSEIF(IJAC==2.AND.ICP(J)<=AP%NPAR-AP%NPARI)THEN
             DFDP(:,ICP(J))=PERIOD*DFDP(:,ICP(J))
          ENDIF
       ENDDO
    ENDIF
    F(:)=PERIOD*F(:)
    IF(IJAC.EQ.0)RETURN
    !      **Generate the Jacobian.
    DFDU(:,:)=PERIOD*DFDU(:,:)

  END SUBROUTINE FNPS

! ---------- ----
  SUBROUTINE BCPS(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    USE BVP, ONLY: IRTN, NRTN
    USE SUPPORT, ONLY : PI

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    INTEGER NFPR,I,J

    NFPR=AP%NFPR

    DO I=1,NBC
       F(I)=U0(I)-U1(I)
    ENDDO

    ! Rotations
    IF(IRTN.NE.0)THEN
       DO I=1,NBC/2
          IF(NRTN(I).NE.0)F(I)=F(I) + PI(2.d0)*NRTN(I)
       ENDDO
    ENDIF

    IF(IJAC.EQ.0)RETURN

    DO I=1,NBC
       DO J=1,2*NDIM
          DBC(I,J)=0.d0
       ENDDO
       DBC(I,I)=1.D0
       DBC(I,NDIM+I)=-1.d0
       DO J=1,NFPR
          DBC(I,2*NDIM+ICP(J))=0.d0
       ENDDO
    ENDDO

  END SUBROUTINE BCPS

! ---------- ----
  SUBROUTINE ICPS(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    INTEGER NPAR,NN,I

    F(1)=0.d0
    DO I=1,NDIM
       F(1)=F(1)+(U(I)-UOLD(I))*UPOLD(I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    NPAR=AP%NPAR
    NN=NDIM+NPAR
    DO I=1,NN
       DINT(1,I)=0.d0
    ENDDO

    DO I=1,NDIM
       DINT(1,I)=UPOLD(I)
    ENDDO

  END SUBROUTINE ICPS

! ---------- -----
  SUBROUTINE PDBLE(NDIM,NTST,NCOL,UPS,UDOTPS,TM,PAR)

    ! Preprocesses restart data for switching branches at a period doubling


    INTEGER, INTENT(IN) :: NDIM,NCOL
    INTEGER, INTENT(INOUT) :: NTST
    DOUBLE PRECISION,INTENT(INOUT) :: TM(0:*),UPS(NDIM,0:*),&
         UDOTPS(NDIM,0:*),PAR(*)

    INTEGER NTC,I,J

    PAR(11)=2.d0*PAR(11)

    DO I=0,NTST-1
       TM(I)=.5d0*TM(I)
       TM(NTST+I)=.5d0+TM(I)
    ENDDO
    TM(2*NTST)=1

    NTC=NTST*NCOL
    DO J=0,NTC
       UPS(:,NTC+J)=   UPS(:,NTC)+   UPS(:,J)-   UPS(:,0)
       UDOTPS(:,NTC+J)=UDOTPS(:,NTC)+UDOTPS(:,J)-UDOTPS(:,0)
    ENDDO

    NTST=2*NTST

  END SUBROUTINE PDBLE

! ---------- ------
  SUBROUTINE STPNPS(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP
    USE MESH

    ! Generates starting data for the continuation of a branch of periodic
    ! solutions.
    ! If IPS is not equal to 2 then the user must have supplied
    ! BCND, ICND, and period-scaled F in FUNC, and the user period-scaling of F
    ! must be taken into account.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)

    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER NDIM,IRS,ISW,ITP,NDIMRD,NTSR2

    NDIM=AP%NDIM
    IRS=AP%IRS
    ISW=AP%ISW
    ITP=AP%ITP

    IF(IRS==0)THEN
       CALL STPNBV(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)
       RETURN
    ENDIF

    IF(ISW==-1.AND.ITP==7) THEN
       !               period doubling
       NTSR2=NTSR*2
    ELSE
       NTSR2=NTSR
    ENDIF
    ALLOCATE(UPSR(NDIM,0:NCOLRS*NTSR2), &
         UDOTPSR(NDIM,0:NCOLRS*NTSR2),TMR(0:NTSR2))
    CALL STPNBV1(AP,PAR,ICP,NDIM,NTSR,NDIMRD,NCOLRS, &
         RLDOT,UPSR,UDOTPSR,TMR,NODIR)
    IF(ISW==-1.AND.ITP==7) THEN

       ! Special case : Preprocess restart data in case of branch switching
       ! at a period doubling bifurcation.

       CALL PDBLE(NDIM,NTSR,NCOLRS,UPSR,UDOTPSR,TMR,PAR)
    ENDIF
    CALL ADAPT2(NTSR,NCOLRS,NDIM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.TRUE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNPS

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!    Subroutines for the Continuation of Folds for Periodic Solution
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNPL(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNPLF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNPS)

  END SUBROUTINE FNPL

! ---------- -----
  SUBROUTINE FNPLF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),DFP(:,:),FF1(:),FF2(:)
    INTEGER NDM,NFPR,NPAR,I,J
    DOUBLE PRECISION UMX,UU,EP,P

    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ! Generate the function.

    CALL FFPL(AP,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP,FUNI)

    IF(IJAC.EQ.0)RETURN

    ! Generate the Jacobian.

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,NPAR,NDM,NDIM)
    DFDU(1:NDM,NDM+1:NDIM)=0d0
    DFDU(NDM+1:NDIM,NDM+1:NDIM)=DFDU(1:NDM,1:NDM)
    IF(IJAC==2)THEN
       IF(ICP(2)==11)THEN
          DFDP(NDM+1:NDIM,11)= &
               (F(NDM+1:NDIM)-PAR(NPAR-1)*DFDP(1:NDM,11))/PAR(11)
       ENDIF
       DFDP(1:NDM,NPAR-1)=0d0
       DFDP(NDM+1:NDIM,NPAR-1)=DFDP(1:NDM,ICP(2))
       IF(ICP(3)==NPAR)THEN
          DFDP(1:NDM,NPAR)=0d0
       ENDIF
    ENDIF

    UMX=0.d0
    DO I=1,NDM
       IF(ABS(U(I))>UMX)UMX=ABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(DFU(NDM,NDM),DFP(NDM,NPAR),FF1(NDIM),FF2(NDIM))
    DO I=1,NDM
       UU=U(I)
       U(I)=UU-EP
       CALL FFPL(AP,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DFP,FUNI)
       U(I)=UU+EP
       CALL FFPL(AP,U,UOLD,ICP,PAR,0,FF2,NDM,DFU,DFP,FUNI)
       U(I)=UU
       DO J=NDM+1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF (IJAC.EQ.1)THEN
       DEALLOCATE(DFU,DFP,FF1)
       RETURN
    ENDIF

    DO I=1,NFPR-1
       IF(ICP(I)==11)CYCLE
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FFPL(AP,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DFP,FUNI)
       DO J=NDM+1,NDIM
          DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(DFU,DFP,FF1)
  END SUBROUTINE FNPLF

! ---------- ----
  SUBROUTINE FFPL(AP,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP,FUNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(2*NDM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    include 'interfaces.h'

    INTEGER IJC,I,J,NPAR

    IJC=IJAC
    IF(IJC==0)IJC=-1
    IF(ICP(2)/=11)IJC=2
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IJC,F,DFDU,DFDP)

    NPAR=AP%NPAR
    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(I,J)*U(NDM+J)
       ENDDO
       F(NDM+I)=F(NDM+I)+PAR(NPAR-1)*DFDP(I,ICP(2))
    ENDDO

  END SUBROUTINE FFPL

! ---------- ----
  SUBROUTINE BCPL(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    ! Boundary conditions for continuing folds (Periodic solutions)

    USE BVP, ONLY: IRTN, NRTN
    USE SUPPORT, ONLY : PI

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    INTEGER NDM,NPAR,NN,I,J

    DO I=1,NDIM
       F(I)=U0(I)-U1(I)
    ENDDO

    ! Rotations
    IF(IRTN.NE.0)THEN
       NDM=AP%NDM
       DO I=1,NDM
          IF(NRTN(I).NE.0)F(I)=F(I) + PI(2.d0)*NRTN(I)
       ENDDO
    ENDIF

    IF(IJAC.EQ.0)RETURN

    NPAR=AP%NPAR
    NN=2*NDIM+NPAR
    DO I=1,NBC
       DO J=1,NN
          DBC(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDIM
       DBC(I,I)=1
       DBC(I,NDIM+I)=-1
    ENDDO

  END SUBROUTINE BCPL

! ---------- ----
  SUBROUTINE ICPL(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Integral conditions for continuing folds (Periodic solutions)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    INTEGER NDM,NPAR,NN,I,J

    NDM=AP%NDM
    NPAR=AP%NPAR

    F(1)=0.d0
    F(2)=0.d0
    F(3)=PAR(NPAR-1)**2 - PAR(NPAR)

    DO I=1,NDM
       F(1)=F(1)+(U(I)-UOLD(I))*UPOLD(I)
       F(2)=F(2)+U(NDM+I)*UPOLD(I)
       F(3)=F(3)+U(NDM+I)*U(NDM+I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    NN=NDIM+NPAR
    DO I=1,NINT
       DO J=1,NN
          DINT(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDM
       DINT(1,I)=UPOLD(I)
       DINT(2,NDM+I)=UPOLD(I)
       DINT(3,NDM+I)=2.d0*U(NDM+I)
    ENDDO

    DINT(3,NDIM+NPAR-1)=2.d0*PAR(NPAR-1)
    DINT(3,NDIM+NPAR)=-1.d0

  END SUBROUTINE ICPL

! ---------- ------
  SUBROUTINE STPNPL(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP
    USE IO
    USE MESH

    ! Generates starting data for the 2-parameter continuation of folds
    ! on a branch of periodic solutions.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    INTEGER ICPRS(4),NDIM,NDM,ITPRS,NDIMRD,NPAR
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)

    NDIM=AP%NDIM
    NDM=AP%NDM
    NPAR=AP%NPAR

    ALLOCATE(UPSR(NDM,0:NCOLRS*NTSR),UDOTPSR(NDM,0:NCOLRS*NTSR), &
         TMR(0:NTSR))
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOT,UPSR, &
         UDOTPSR,TMR,ITPRS,NDM)

    ! Complement starting data
    PAR(NPAR-1)=0.d0
    PAR(NPAR)=0.d0

    NODIR=0
    CALL ADAPT2(NTSR,NCOLRS,NDM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNPL

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!   Subroutines for BP cont (Periodic Solutions) (by F. Dercole)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- -----
  SUBROUTINE FNPBP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:),DFP(:),FF1(:),FF2(:)
    INTEGER NDM,NFPR,NPAR,I,J,ISW,IP,NPARU
    DOUBLE PRECISION UMX,EP,P,UU

    ISW=AP%ISW
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN
       CALL FNPS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)
       RETURN
    ENDIF

    ! Generate the function.

    CALL FFPBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,IJAC,F,NDM,DFDU,DFDP)

    IF(IJAC.EQ.0)RETURN

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,NPAR,NDM,NDIM)

    DFDU(1:NDM,NDM+1:NDIM)=0
    NPARU=NPAR-AP%NPARI
    IF(ISW==2.OR.ISW<0)THEN
       !        ** Non-generic and/or start, derivatives of -b phi_1^* in (18)
       DO I=1,NDM
          DFDU(I,NDM+I)=-PAR(NPARU+3) ! b
       ENDDO
    ENDIF
    DO I=1,NDM ! d(13a)/d phi_1^* = -f_x(x,p)^T
       DFDU(NDM+1:2*NDM,NDM+I)=-DFDU(I,1:NDM)
    ENDDO
    IF(ISW<0)THEN ! start
       DFDU(NDM+1:2*NDM,2*NDM+1:4*NDM)=0
       DO I=1,NDM
          ! d(15a)/dv = c1, d(15a)/dw = c2
          DFDU(NDM+I,2*NDM+I)=PAR(NPARU+8)
          DFDU(NDM+I,3*NDM+I)=PAR(NPARU+9)
       ENDDO
       DFDU(2*NDM+1:4*NDM,1:2*NDM)=0
       ! d(9a)/dv = d(9b)/dw = f_x(x,p)
       DFDU(2*NDM+1:3*NDM,2*NDM+1:3*NDM)=DFDU(1:NDM,1:NDM)
       DFDU(2*NDM+1:3*NDM,3*NDM+1:4*NDM)=0
       DFDU(3*NDM+1:4*NDM,2*NDM+1:3*NDM)=0
       DFDU(3*NDM+1:4*NDM,3*NDM+1:4*NDM)=DFDU(1:NDM,1:NDM)
    ENDIF

    ALLOCATE(DFU(NDM*NDM),DFP(NDM*NPAR))
    ALLOCATE(FF1(NDIM),FF2(NDIM))

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DO I=1,NDM
       UU=U(I)
       U(I)=UU-EP
       CALL FFPBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,0,FF1,NDM,DFU,DFP)
       U(I)=UU+EP
       CALL FFPBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,0,FF2,NDM,DFU,DFP)
       U(I)=UU
       DO J=NDM+1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF (IJAC.EQ.1)THEN
       DEALLOCATE(DFU,DFP,FF1)
       RETURN
    ENDIF

    DO I=1,NFPR
       ! note: restart uses only PAR(NPARU+1) and perhaps PAR(NPARU+3)
       IP=ICP(I)
       IF(IP==11)THEN
          DFDP(NDM+1:2*NDM,11)=F(NDM+1:2*NDM)/PAR(11)
          IF(ISW<0)THEN
             DFDP(2*NDM+1:3*NDM,11)=&
                  (F(2*NDM+1:3*NDM)-DFDP(1:NDM,11)*PAR(NPARU+5))/PAR(11)
             DFDP(3*NDM+1:4*NDM,11)=&
                  (F(3*NDM+1:4*NDM)-DFDP(1:NDM,11)*PAR(NPARU+7))/PAR(11)
          ENDIF
       ELSEIF(IP<=NPARU)THEN
          P=PAR(IP)
          PAR(IP)=P+EP
          CALL FFPBP(AP,NDIM,U,UOLD,UOLD(NDIM+NFPR+1),ICP,PAR,0,FF1,NDM,DFU,DFP)
          PAR(IP)=P
          DO J=NDM+1,NDIM
             DFDP(J,IP)=(FF1(J)-F(J))/EP
          ENDDO
       ENDIF
    ENDDO
    DEALLOCATE(DFU,DFP,FF1)

    IP=NPARU+1 ! phi^*_3
    DFDP(1:NDM,IP)=0
    DFDP(NDM+1:2*NDM,IP)=UOLD(NDIM+NFPR+1:NDIM+NFPR+NDM) ! =UPOLD(1:NDM)=h_x
    DFDP(2*NDM+1:NDIM,IP)=0
    DFDP(:,NPARU+2)=0 ! a

    IF(ISW<0) THEN
       ! start
       DO J=2,3
          DO I=1,2
             ! derivatives to q1, q2, r1, r2
             IP=NPARU+2*J+I-1
             DFDP(1:2*NDM,IP)=0
             ! d(9a)/dq = d(9b)/dr = f_p(x,p)
             DFDP(J*NDM+1:(J+1)*NDM,IP)=DFDP(1:NDM,ICP(I))
             DFDP((5-J)*NDM+1:(6-J)*NDM,IP)=0
          ENDDO
          ! derivatives to c1, c2
          IP=NPARU+6+J
          DFDP(1:NDM,IP)=0
          DFDP(NDM+1:2*NDM,IP)=U(J*NDM+1:(J+1)*NDM)
          DFDP(2*NDM+1:4*NDM,IP)=0
       ENDDO
    ENDIF

    IF(ISW<0.OR.ISW==2)THEN ! non-generic and/or start
       IP=NPARU+3 ! b
       DFDP(1:NDM,IP)=-U(NDM+1:2*NDM)
       DFDP(NDM+1:NDIM,IP)=0
    ENDIF

  END SUBROUTINE FNPBP

! ---------- -----
  SUBROUTINE FFPBP(AP,NDIM,U,UOLD,UPOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC,NDM
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UPOLD(NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    ! Local
    INTEGER ISW,I,J,NPARU,IJC

    ISW=AP%ISW

    IF(ISW<0) THEN
       IJC=MAX(IJAC,2)
    ELSE
       IJC=MAX(IJAC,1)
    ENDIF
    CALL FNPS(AP,NDM,U,UOLD,ICP,PAR,IJC,F,DFDU,DFDP)

    NPARU=AP%NPAR-AP%NPARI

    ! (13a) \dot phi_1^* = -f_x(x,p)^T phi_1^* + h_x(x,p)^T phi_3^*
    !       where h_x=DINT
    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)-DFDU(J,I)*U(NDM+J)
       ENDDO
       F(NDM+I)=F(NDM+I)+UPOLD(I)*PAR(NPARU+1)
    ENDDO
    IF(ISW<0) THEN
       !        ** start
       ! (9a) \dot v = f_x(x,p)v + f_p(x,p)q
       ! (9b) \dot w = f_x(x,p)w + f_p(x,p)r
       ! (15a) \dot phi_1^* = -f_x(x,p)^T phi_1^*+h_x(x,p)^T phi_3^*+c1 v+c2 w
       DO I=1,NDM
          F(2*NDM+I)=0.d0
          F(3*NDM+I)=0.d0
          DO J=1,NDM
             F(2*NDM+I)=F(2*NDM+I)+DFDU(I,J)*U(2*NDM+J)
             F(3*NDM+I)=F(3*NDM+I)+DFDU(I,J)*U(3*NDM+J)
          ENDDO
          F(NDM+I)=F(NDM+I)+PAR(NPARU+8)*U(2*NDM+I)+PAR(NPARU+9)*U(3*NDM+I)
          DO J=1,2
             F(2*NDM+I)=F(2*NDM+I)+DFDP(I,ICP(J))*PAR(NPARU+3+J)
             F(3*NDM+I)=F(3*NDM+I)+DFDP(I,ICP(J))*PAR(NPARU+5+J)
          ENDDO
       ENDDO
    ENDIF

    IF((ISW.EQ.2).OR.(ISW.LT.0)) THEN
       !        ** Non-generic and/or start
       ! (18) \dot x = f(x,p) - b phi_1^*
       DO I=1,NDM
          F(I)=F(I)-PAR(NPARU+3)*U(NDM+I)
       ENDDO
    ENDIF

  END SUBROUTINE FFPBP

! ---------- -----
  SUBROUTINE BCPBP(AP,NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)

    ! Boundary conditions for continuing BP (Periodic solutions)

    USE BVP, ONLY: IRTN, NRTN
    USE SUPPORT, ONLY : PI

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    INTEGER ISW,NDM,NPAR,NN,I,J,NPARU

    ISW=AP%ISW
    NDM=AP%NDM
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN
       CALL BCPS(AP,NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
       RETURN
    ENDIF

    DO I=1,NDIM
       FB(I)=U0(I)-U1(I)
    ENDDO

    NPARU=NPAR-AP%NPARI
    IF((ISW.EQ.2).OR.(ISW.LT.0)) THEN
       !        ** Non-generic and/or start
       DO I=1,NDM
          FB(I)=FB(I)+PAR(NPARU+3)*U0(NDM+I)
       ENDDO
    ENDIF

    ! Rotations
    IF(IRTN.NE.0)THEN
       DO I=1,NDM
          IF(NRTN(I).NE.0)FB(I)=FB(I)+PI(2.d0)*NRTN(I)
       ENDDO
    ENDIF

    IF(IJAC.EQ.0)RETURN

    NN=2*NDIM+NPAR
    DO I=1,NBC
       DO J=1,NN
          DBC(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDIM
       DBC(I,I)=1
       DBC(I,NDIM+I)=-1
    ENDDO

    IF((ISW.EQ.2).OR.(ISW.LT.0)) THEN
       !        ** Non-generic and/or start
       DO I=1,NDM
          DBC(I,NDM+I)=PAR(NPARU+3)
       ENDDO
    ENDIF

    IF(IJAC.EQ.1)RETURN

    IF((ISW.EQ.2).OR.(ISW.LT.0)) THEN
       !        ** Non-generic and/or start
       DO I=1,NDM
          DBC(I,2*NDIM+NPARU+3)=U0(NDM+I)
       ENDDO
    ENDIF

  END SUBROUTINE BCPBP

! ---------- -----
  SUBROUTINE ICPBP(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)

    ! Integral conditions for continuing BP (Periodic solutions)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: F(:),DFU(:,:),DFP(:,:),DFP0(:,:),DFP1(:,:)
    INTEGER NFPR,NDM,NPAR,NPARU,ISW,I,J,K
    DOUBLE PRECISION UMX,EP,P,UU

    ISW=AP%ISW
    NDM=AP%NDM
    NPAR=AP%NPAR
    NFPR=AP%NFPR
    NPARU=NPAR-AP%NPARI

    IF(NDIM==NDM)THEN
       CALL ICPS(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
       RETURN
    ENDIF

    ! Generate the function.

    ALLOCATE(F(NDM),DFU(NDM,NDM),DFP(NDM,NPAR))
    CALL FNPS(AP,NDM,U,UOLD,ICP,PAR,2,F,DFU,DFP)

    ! (5) int_0^1 h(x,p) dt = 0
    ! (13c) int_0^1 ||phi_1^*||^2 dt + ||phi_3^*||^2 - a = 0
    !       (phi_2^*=0 because of periodic BCs)
    FI(1)=0.d0
    FI(NINT)=PAR(NPARU+1)**2-PAR(NPARU+2)
    DO I=1,NDM
       FI(1)=FI(1)+(U(I)-UOLD(I))*UPOLD(I)
       FI(NINT)=FI(NINT)+U(NDM+I)**2
    ENDDO

    IF((ISW.EQ.2).OR.(ISW.LT.0)) THEN
       !        ** Non-generic and/or start
       ! (18) int_0^1 h(x,p) dt + b phi_3^* = 0
       FI(1)=FI(1)+PAR(NPARU+3)*PAR(NPARU+1)
    ENDIF

    ! (13b) int_0^1 -f_p(x,p)^T phi_1^* dt = 0 (h_p=0)
    DO I=1,2
       FI(1+I)=0.d0
       DO J=1,NDM
          FI(1+I)=FI(1+I)-DFP(J,ICP(I))*U(NDM+J)
       ENDDO
    ENDDO

    IF(ISW<0) THEN
       !        ** start
       ! (15b) int_0^1 -f(x,p)^T phi_1^* dt + c_1 q + c_2 r = 0
       DO I=1,2
          FI(1+I)=FI(1+I)+PAR(NPARU+8)*PAR(NPARU+3+I)+&
               PAR(NPARU+9)*PAR(NPARU+5+I)
       ENDDO
       ! (9a) int_0^1 h_x(x,p)v dt = 0
       ! (9b) int_0^1 h_x(x,p)w dt = 0
       ! (10a) int_0^1 <v, v_old> dt + <q, q_old> - 1 = 0
       ! (10b) int_0^1 <w, w_old> dt + <r, r_old> - 1 = 0
       ! (11a) int_0^1 <v, w_old> dt + <q, r_old> = 0
       ! (11b) int_0^1 <w, v_old> dt + <r, q_old> = 0
       FI(4)=0.d0
       FI(5)=0.d0
       FI(6)=PAR(NPARU+4)*UOLD(NDIM+6)+PAR(NPARU+5)*UOLD(NDIM+7)-1.d0
       FI(7)=PAR(NPARU+6)*UOLD(NDIM+8)+PAR(NPARU+7)*UOLD(NDIM+9)-1.d0
       FI(8)=PAR(NPARU+4)*UOLD(NDIM+8)+PAR(NPARU+5)*UOLD(NDIM+9)
       FI(9)=PAR(NPARU+6)*UOLD(NDIM+6)+PAR(NPARU+7)*UOLD(NDIM+7)
       DO I=1,NDM
          FI(4)=FI(4)+U(2*NDM+I)*UPOLD(I)
          FI(5)=FI(5)+U(3*NDM+I)*UPOLD(I)
          FI(6)=FI(6)+U(2*NDM+I)*UOLD(2*NDM+I)
          FI(7)=FI(7)+U(3*NDM+I)*UOLD(3*NDM+I)
          FI(8)=FI(8)+U(2*NDM+I)*UOLD(3*NDM+I)
          FI(9)=FI(9)+U(3*NDM+I)*UOLD(2*NDM+I)
       ENDDO
    ENDIF

    IF(IJAC.EQ.0)THEN
       DEALLOCATE(F,DFU,DFP)
       RETURN
    ENDIF

    ! Generate the Jacobian.

    ! derivatives for (5) int_0^1 h(x,p) dt = 0
    DINT(1,1:NDM)=UPOLD(1:NDM)
    DINT(1,NDM+1:NDIM)=0

    ! derivatives for (13c) int_0^1 ||phi_1^*||^2 dt + ||phi_3^*||^2 - a = 0
    DINT(NINT,1:NDM)=0d0
    DINT(NINT,NDM+1:2*NDM)=2*U(NDM+1:2*NDM)
    DINT(NINT,2*NDM+1:NDIM)=0

    ! derivatives for (13b) int_0^1 -f_p(x,p)^T phi_1^* dt = 0
    DO I=1,2
       ! DINT(1+I,1:NDM) determined by finite differences
       DINT(1+I,NDM+1:2*NDM)=-DFP(1:NDM,ICP(I))
       DINT(1+I,2*NDM+1:NDIM)=0
    ENDDO

    IF(ISW<0)THEN
       ! Derivatives for (9a)-(11b) (see below)
       DINT(4:9,1:NDIM)=0
       DINT(4,2*NDM+1:3*NDM)=UPOLD(1:NDM)
       DINT(5,3*NDM+1:4*NDM)=UPOLD(1:NDM)
       DINT(6,2*NDM+1:3*NDM)=UOLD(2*NDM+1:3*NDM)
       DINT(7,3*NDM+1:4*NDM)=UOLD(3*NDM+1:4*NDM)
       DINT(8,2*NDM+1:3*NDM)=UOLD(3*NDM+1:4*NDM)
       DINT(9,3*NDM+1:4*NDM)=UOLD(2*NDM+1:3*NDM)
    ENDIF

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(DFP0(NDM,2),DFP1(NDM,2))
    IF(IJAC/=1)THEN
       DFP0(:,1)=DFP(:,ICP(1))
       DFP0(:,2)=DFP(:,ICP(2))
    ENDIF

    DO I=1,NDM
       ! derivatives for (13b) int_0^1 -f_p(x,p)^T phi_1^* dt = 0 (h_p=0)
       UU=U(I)
       U(I)=UU-EP
       CALL FNPS(AP,NDM,U,UOLD,ICP,PAR,2,F,DFU,DFP)
       DFP1(:,1)=DFP(:,ICP(1))
       DFP1(:,2)=DFP(:,ICP(2))
       U(I)=UU+EP
       CALL FNPS(AP,NDM,U,UOLD,ICP,PAR,2,F,DFU,DFP)
       U(I)=UU
       DO J=1,2
          DINT(J+1,I)=0
          DO K=1,NDM
             DINT(J+1,I)=DINT(J+1,I)-U(NDM+K)*(DFP(K,ICP(J))-DFP1(K,J))/(2*EP)
          ENDDO
       ENDDO
    ENDDO

    DEALLOCATE(DFP1)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(F,DFU,DFP,DFP0)
       RETURN
    ENDIF

    DINT(1:NINT,NDIM+NPARU+1:NDIM+NPAR)=0d0
    IF(ISW==2.OR.ISW<0)THEN !        ** Non-generic and/or start
       DINT(1,NDIM+NPARU+3)=PAR(NPARU+1) ! d(18)/db
       DINT(1,NDIM+NPARU+1)=PAR(NPARU+3) ! d(18)/dphi_3^*
    ENDIF

    ! derivatives for (13c) int_0^1 ||phi_1^*||^2 dt + ||phi_3^*||^2 - a = 0
    DINT(NINT,NDIM+NPARU+1)=2*PAR(NPARU+1)
    DINT(NINT,NDIM+NPARU+2)=-1

    IF(ISW<0) THEN
       !        ** start
       ! derivatives for (15b) int_0^1 -f(x,p)^T phi_1^* dt + c_1 q + c_2 r = 0
       DO I=1,2
          DINT(1+I,NDIM+NPARU+3+I)=PAR(NPARU+8)
          DINT(1+I,NDIM+NPARU+8)=PAR(NPARU+3+I)
          DINT(1+I,NDIM+NPARU+5+I)=PAR(NPARU+9)
          DINT(1+I,NDIM+NPARU+9)=PAR(NPARU+5+I)
       ENDDO
       ! derivatives for (10a)-(11b)
       DINT(6,NDIM+NPARU+4)=UOLD(NDIM+6)
       DINT(6,NDIM+NPARU+5)=UOLD(NDIM+7)
       DINT(7,NDIM+NPARU+6)=UOLD(NDIM+8)
       DINT(7,NDIM+NPARU+7)=UOLD(NDIM+9)
       DINT(8,NDIM+NPARU+4)=UOLD(NDIM+8)
       DINT(8,NDIM+NPARU+5)=UOLD(NDIM+9)
       DINT(9,NDIM+NPARU+6)=UOLD(NDIM+6)
       DINT(9,NDIM+NPARU+7)=UOLD(NDIM+7)
    ENDIF

    DO I=1,NFPR
       IF(ICP(I)>=NPARU)CYCLE
       ! derivatives for (13b) int_0^1 -f_p(x,p)^T phi_1^* dt = 0 (h_p=0)
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FNPS(AP,NDM,U,UOLD,ICP,PAR,2,F,DFU,DFP)
       DO J=1,2
          DINT(J+1,NDIM+ICP(I))=0d0
          DO K=1,NDM
             DINT(J+1,NDIM+ICP(I))=DINT(J+1,NDIM+ICP(I))-U(NDM+K)* &
                  (DFP(K,ICP(J))-DFP0(K,J))/EP
          ENDDO
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(F,DFU,DFP,DFP0)

  END SUBROUTINE ICPBP

! ---------- -------
  SUBROUTINE STPNPBP(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP
    USE IO
    USE MESH

    ! Generates starting data for the 2-parameter continuation of BP
    ! on a branch of periodic solutions.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    INTEGER ICPRS(11)
    DOUBLE PRECISION RLDOTRS(11),RVDOT(2)
    DOUBLE PRECISION, ALLOCATABLE :: UPST(:,:),UDOTPST(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: VDOTPST(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER NDIM,ISW,NDM,NFPR,ITPRS,NDIMRD,NPAR
    TYPE(AUTOPARAMETERS) AP2

    NDIM=AP%NDIM
    ISW=AP%ISW
    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    IF(ISW>0) THEN
       !        ** restart
       CALL STPNBV(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)
       RETURN
    ENDIF

    ALLOCATE(UPSR(NDIM,0:NCOLRS*NTSR),UDOTPSR(NDIM,0:NCOLRS*NTSR), &
         TMR(0:NTSR))

    ! Start
    !        ** allocation
    ALLOCATE(UPST(NDM,0:NTSR*NCOLRS),UDOTPST(NDM,0:NTSR*NCOLRS))
    ALLOCATE(VDOTPST(NDM,0:NTSR*NCOLRS))

    !        ** read the std branch
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOTRS,UPST, &
         UDOTPST,TMR,ITPRS,NDM)

    ! Compute the second null vector

    !        ** redefine IAP
    AP2=AP
    AP2%NDIM=NDM
    AP2%NTST=NTSR
    AP2%NCOL=NCOLRS
    AP2%NBC=NDM
    AP2%NINT=1
    AP2%NFPR=2

    CALL STSDRBV(AP2,PAR,ICPRS,FNPBP,BCPBP,ICPBP, &
         RLDOTRS,UPST,UDOTPST,TMR,VDOTPST,RVDOT)

    !        ** init UPS,PAR
    UPSR(1:NDM,:)=UPST(:,:)
    UPSR(NDM+1:2*NDM,:)=0.d0
    UPSR(2*NDM+1:3*NDM,:)=UDOTPST(:,:)
    UPSR(3*NDM+1:4*NDM,:)=VDOTPST(:,:)
    UDOTPSR(:,:)=0.d0

    !        ** init phi^*_3,a,b,q,r,c1,c2
    PAR(NPAR-9+1:NPAR-9+3)=0.d0
    PAR(NPAR-9+4:NPAR-9+5)=RLDOTRS(1:2)
    PAR(NPAR-9+6:NPAR-9+7)=RVDOT(1:2)
    PAR(NPAR-9+8:NPAR-9+9)=0.d0
    RLDOT(1:3)=0.d0
    RLDOT(4)=1.d0
    RLDOT(5:11)=0.d0

    DEALLOCATE(UPST,UDOTPST,VDOTPST)

    NODIR=0

    CALL ADAPT2(NTSR,NCOLRS,NDIM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)
  END SUBROUTINE STPNPBP

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!   Subroutines for the Continuation of Period Doubling Bifurcations
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNPD(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE ::DFU(:,:),FF1(:),FF2(:)
    INTEGER NDM,NFPR,I,J,NPAR
    DOUBLE PRECISION UMX,EP,P,UU,DUMDP(1)

    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ! Generate the function.

    CALL FFPD(AP,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP)

    IF(IJAC.EQ.0)RETURN

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,NPAR,NDM,NDIM)

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DFDU(1:NDM,1:NDM)=PAR(11)*DFDU(1:NDM,1:NDM)
    DFDU(1:NDM,NDM+1:2*NDM)=0
    DFDU(NDM+1:2*NDM,NDM+1:2*NDM)=DFDU(1:NDM,1:NDM)

    ALLOCATE(DFU(NDM,NDM),FF1(NDIM),FF2(NDIM))
    DO I=1,NDM
       UU=U(I)
       U(I)=UU-EP
       CALL FFPD(AP,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DUMDP)
       U(I)=UU+EP
       CALL FFPD(AP,U,UOLD,ICP,PAR,0,FF2,NDM,DFU,DUMDP)
       U(I)=UU
       DO J=NDM+1,NDIM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(FF1,DFU)
       RETURN
    ENDIF

    DO I=1,NFPR
       IF(ICP(I)==NPAR)THEN
          DFDP(:,ICP(I))=0
       ELSEIF(ICP(I)==11)THEN
          DFDP(1:NDIM,11)=F(1:NDIM)/PAR(11)
       ELSE
          DFDP(1:NDM,ICP(I))=PAR(11)*DFDP(1:NDM,ICP(I))
          P=PAR(ICP(I))
          PAR(ICP(I))=P+EP
          CALL FFPD(AP,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DUMDP)
          DO J=NDM+1,NDIM
             DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
          ENDDO
          PAR(ICP(I))=P
       ENDIF
    ENDDO

    DEALLOCATE(FF1,DFU)
  END SUBROUTINE FNPD

! ---------- ----
  SUBROUTINE FFPD(AP,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(2*NDM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(2*NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    ! Local
    INTEGER I,J
    DOUBLE PRECISION PERIOD

    PERIOD=PAR(11)
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,MAX(IJAC,1),F,DFDU,DFDP)

    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(I,J)*U(NDM+J)
       ENDDO
       F(I)=PERIOD*F(I)
       F(NDM+I)=PERIOD*F(NDM+I)
    ENDDO

  END SUBROUTINE FFPD

! ---------- ----
  SUBROUTINE BCPD(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    USE BVP, ONLY: IRTN, NRTN
    USE SUPPORT, ONLY : PI

    ! Generate boundary conditions for the 2-parameter continuation
    ! of period doubling bifurcations.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    INTEGER NDM,NPAR,NN,I,J
    NDM=AP%NDM

    DO I=1,NDM
       F(I)=U0(I)-U1(I)
       F(NDM+I)=U0(NDM+I)+U1(NDM+I)
    ENDDO

    ! Rotations
    IF(IRTN.NE.0)THEN
       DO I=1,NDM
          IF(NRTN(I).NE.0)F(I)=F(I) + PI(2.d0)*NRTN(I)
       ENDDO
    ENDIF

    IF(IJAC.EQ.0)RETURN

    NPAR=AP%NPAR
    NN=2*NDIM+NPAR
    DO I=1,NBC
       DO J=1,NN
          DBC(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDIM
       DBC(I,I)=1
       IF(I.LE.NDM) THEN
          DBC(I,NDIM+I)=-1
       ELSE
          DBC(I,NDIM+I)=1
       ENDIF
    ENDDO

  END SUBROUTINE BCPD

! ---------- ----
  SUBROUTINE ICPD(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    INTEGER NDM,NPAR,NN,I,J

    NDM=AP%NDM
    NPAR=AP%NPAR

    F(1)=0.d0
    F(2)=-PAR(NPAR)

    DO I=1,NDM
       F(1)=F(1)+(U(I)-UOLD(I))*UPOLD(I)
       F(2)=F(2)+U(NDM+I)*U(NDM+I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    NN=NDIM+NPAR
    DO I=1,NINT
       DO J=1,NN
          DINT(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDM
       DINT(1,I)=UPOLD(I)
       DINT(2,NDM+I)=2.d0*U(NDM+I)
    ENDDO

    DINT(2,NDIM+NPAR)=-1.d0

  END SUBROUTINE ICPD

! ---------- ------
  SUBROUTINE STPNPD(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP
    USE IO
    USE MESH

    ! Generates starting data for the 2-parameter continuation of
    ! period-doubling bifurcations on a branch of periodic solutions.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER ICPRS(4),NDIM,NDM,NDIMRD,ITPRS,NPAR

    NDIM=AP%NDIM
    NDM=AP%NDM
    NPAR=AP%NPAR

    ALLOCATE(UPSR(NDM,0:NCOLRS*NTSR),UDOTPSR(NDM,0:NCOLRS*NTSR), &
         TMR(0:NTSR))
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOT,UPSR, &
         UDOTPSR,TMR,ITPRS,NDM)

    ! Complement starting data 
    PAR(NPAR)=0.d0

    NODIR=0
    CALL ADAPT2(NTSR,NCOLRS,NDM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNPD

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!       Subroutines for the Continuation of Torus Bifurcations
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNTR(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-parameter continuation of
    ! torus bifurcations.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE ::DFU(:,:),FF1(:),FF2(:)
    INTEGER NDM,NFPR,NPAR,I,J
    DOUBLE PRECISION EP,UMX,P,UU,DUMDP(1)

    NDM=AP%NDM
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ! Generate the function.

    CALL FFTR(AP,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP)

    IF(IJAC.EQ.0)RETURN

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,NPAR,NDM,NDIM)

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DFDU(1:NDM,1:NDM)=PAR(11)*DFDU(1:NDM,1:NDM)
    DFDU(1:NDM,NDM+1:3*NDM)=0
    DFDU(NDM+1:2*NDM,NDM+1:2*NDM)=DFDU(1:NDM,1:NDM)
    DFDU(NDM+1:2*NDM,2*NDM+1:3*NDM)=0
    DFDU(2*NDM+1:3*NDM,NDM+1:2*NDM)=0
    DFDU(2*NDM+1:3*NDM,2*NDM+1:3*NDM)=DFDU(1:NDM,1:NDM)

    ALLOCATE(FF1(NDIM),FF2(NDIM),DFU(NDM,NDM))
    DO I=1,NDM
       UU=U(I)
       U(I)=UU-EP
       CALL FFTR(AP,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DUMDP)
       U(I)=UU+EP
       CALL FFTR(AP,U,UOLD,ICP,PAR,0,FF2,NDM,DFU,DUMDP)
       U(I)=UU
       DO J=NDM+1,3*NDM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(FF1,DFU)
       RETURN
    ENDIF

    DO I=1,NFPR
       IF(ICP(I)==12.OR.ICP(I)==NPAR)THEN
          DFDP(:,ICP(I))=0
       ELSEIF(ICP(I)==11)THEN
          DFDP(1:NDIM,11)=F(1:NDIM)/PAR(11)
       ELSE
          DFDP(1:NDM,ICP(I))=PAR(11)*DFDP(1:NDM,ICP(I))
          P=PAR(ICP(I))
          PAR(ICP(I))=P+EP
          CALL FFTR(AP,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DUMDP)
          DO J=NDM+1,3*NDM
             DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
          ENDDO
          PAR(ICP(I))=P
       ENDIF
    ENDDO

    DEALLOCATE(FF1,DFU)
  END SUBROUTINE FNTR

! ---------- ----
  SUBROUTINE FFTR(AP,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(*),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDM*3)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,*),DFDP(NDM,*)
    ! Local
    INTEGER NDM2,I,J
    DOUBLE PRECISION PERIOD

    PERIOD=PAR(11)
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,MAX(IJAC,1),F,DFDU,DFDP)

    NDM2=2*NDM
    DO I=1,NDM
       F(NDM+I)=0.d0
       F(NDM2+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(I,J)*U(NDM+J)
          F(NDM2+I)=F(NDM2+I)+DFDU(I,J)*U(NDM2+J)
       ENDDO
       F(NDM+I)=PERIOD*F(NDM+I)
       F(NDM2+I)=PERIOD*F(NDM2+I)
       F(I)=PERIOD*F(I)
    ENDDO

  END SUBROUTINE FFTR

! ---------- ----
  SUBROUTINE BCTR(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    USE BVP, ONLY: IRTN, NRTN
    USE SUPPORT, ONLY : PI

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    INTEGER NDM,NDM2,NN,NPAR,I,J
    DOUBLE PRECISION THETA,SS,CS

    NDM=AP%NDM
    NPAR=AP%NPAR

    NDM2=2*NDM
    THETA=PAR(12)

    SS=SIN(THETA)
    CS=COS(THETA)

    DO I=1,NDM
       F(I)=U0(I)-U1(I)
       F(NDM+I)= U1(NDM+I) -CS*U0(NDM+I) +SS*U0(NDM2+I)
       F(NDM2+I)=U1(NDM2+I)-CS*U0(NDM2+I)-SS*U0(NDM+I)
    ENDDO

    ! Rotations
    IF(IRTN.NE.0)THEN
       DO I=1,NDM
          IF(NRTN(I).NE.0)F(I)=F(I) + PI(2.d0)*NRTN(I)
       ENDDO
    ENDIF

    IF(IJAC.EQ.0)RETURN

    NN=2*NDIM+NPAR
    DO I=1,NBC
       DO J=1,NN
          DBC(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDM
       DBC(I,I)=1
       DBC(I,NDIM+I)=-1
       DBC(NDM+I,NDM+I)=-CS
       DBC(NDM+I,NDM2+I)=SS
       DBC(NDM+I,NDIM+NDM+I)=1
       DBC(NDM+I,2*NDIM+12)=CS*U0(NDM2+I)+SS*U0(NDM+I)
       DBC(NDM2+I,NDM+I)=-SS
       DBC(NDM2+I,NDM2+I)=-CS
       DBC(NDM2+I,NDIM+NDM2+I)=1
       DBC(NDM2+I,2*NDIM+12)=SS*U0(NDM2+I)-CS*U0(NDM+I)
    ENDDO

  END SUBROUTINE BCTR

! ---------- ----
  SUBROUTINE ICTR(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    INTEGER NDM,NDM2,NN,NPAR,I,J

    NDM=AP%NDM
    NPAR=AP%NPAR
    NDM2=2*NDM

    F(1)=0.d0
    F(2)=0.d0
    F(3)=-PAR(NPAR)

    DO I=1,NDM
       F(1)=F(1)+(U(I)-UOLD(I))*UPOLD(I)
       F(2)=F(2)+U(NDM+I)*UOLD(NDM2+I)-U(NDM2+I)*UOLD(NDM+I)
       F(3)=F(3)+U(NDM+I)*U(NDM+I) +U(NDM2+I)*U(NDM2+I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    NN=NDIM+NPAR
    DO I=1,NINT
       DO J=1,NN
          DINT(I,J)=0.d0
       ENDDO
    ENDDO

    DO I=1,NDM
       DINT(1,I)=UPOLD(I)
       DINT(2,NDM+I)=UOLD(NDM2+I)
       DINT(2,NDM2+I)=-UOLD(NDM+I)
       DINT(3,NDM+I)=2*U(NDM+I)
       DINT(3,NDM2+I)=2*U(NDM2+I)
    ENDDO

    DINT(3,NDIM+NPAR)=-1

  END SUBROUTINE ICTR

! ---------- ------
  SUBROUTINE STPNTR(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE BVP
    USE IO
    USE MESH
    USE AUTO_CONSTANTS, ONLY: TY

    ! Generates starting data for the 2-parameter continuation of torus
    ! bifurcations.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    DOUBLE PRECISION T,DT,THETA
    INTEGER ICPRS(4),NDIM,NDM,NPAR,NDIMRD,ITPRS,I,J,K
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)

    NDIM=AP%NDIM
    NDM=AP%NDM
    NPAR=AP%NPAR

    ALLOCATE(UPSR(NDIM,0:NCOLRS*NTSR),UDOTPSR(NDIM,0:NCOLRS*NTSR), &
         TMR(0:NTSR))
    CALL READBV(AP,PAR,ICPRS,NTSR,NCOLRS,NDIMRD,RLDOT,UPSR, &
         UDOTPSR,TMR,ITPRS,NDIM)

    T=0.d0
    DT=0.d0
    IF(LEN_TRIM(TY)>2)THEN
       READ(TY(3:),'(I5)')I
       PAR(12)=PAR(I)
    ENDIF
    THETA=PAR(12)
    DO I=0,NTSR*NCOLRS
       IF(MOD(I,NCOLRS)==0)THEN
          J=I/NCOLRS
          T=TMR(J)
          IF(J<NTSR)DT=(TMR(J+1)-T)/NCOLRS
       ENDIF
       DO K=NDM+1,2*NDM
          UPSR(K,I)        = 0.0001d0*COS(T*THETA)
          UPSR(K+NDM,I)    = 0.0001d0*SIN(T*THETA)
          UDOTPSR(K,I)     = 0.d0
          UDOTPSR(K+NDM,I) = 0.d0
       ENDDO
       T=T+DT
    ENDDO

    PAR(NPAR)=0.d0

    NODIR=0
    CALL ADAPT2(NTSR,NCOLRS,NDIM,AP%NTST,AP%NCOL,NDIM, &
         TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
    DEALLOCATE(TMR,UPSR,UDOTPSR)

  END SUBROUTINE STPNTR

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSPS(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE) RESULT(Q)
    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    USE SUPPORT, ONLY: P0=>P0V, P1=>P1V, EV=>EVV

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: UPS(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    Q=FNCSBV(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE)
    IF(ITEST==3)THEN
        Q=FNSPBV(AP,PAR,ATYPE,P0,P1,EV)
    ENDIF
  END FUNCTION FNCSPS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNSPBV(AP,PAR,ATYPE,P0,P1,EV)

    USE FLOQUET
    USE SUPPORT, ONLY: PI, LBTYPE, CHECKSP, NULLVC

! This function returns a quantity that changes sign when a complex
! pair of eigenvalues of the linearized Poincare map moves in or out
! of the unit circle or when a real eigenvalues passes through -1.

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: P0(AP%NDIM,*),P1(AP%NDIM,*)
    COMPLEX(KIND(1.0D0)), INTENT(INOUT) :: EV(*)

! Local
    COMPLEX(KIND(1.0D0)) ZINS,ZTMP
    INTEGER ISP,ISW,IID,IBR,NTOT,NTOP,I,J,L,LOC,NINS,NINS1,NDIM,NDM,ITMP,SKIP
    DOUBLE PRECISION D,AMIN,AZM1,AZINS,tol,V,THETA
    DOUBLE PRECISION, ALLOCATABLE :: Q0(:,:),Q1(:,:),U(:)
    INTEGER, ALLOCATABLE :: IC(:),IR(:),IRPIV(:)

    NDIM=AP%NDIM
    NDM=AP%NDM
    ISP=AP%ISP
    ISW=AP%ISW
    IID=AP%IID
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

! Initialize.

    FNSPBV=0.d0
    AP%SPBF=FNSPBV
    D=0.d0
    ATYPE=''

    IF(ISP==0)RETURN

    IF(IID.GE.4)THEN
       CALL EVECS(NDIM,P0,P1,.FALSE.)
    ENDIF
    IF(NDIM>NDM)THEN
       ! on loci we can take the eigenvalues of the lower right hand
       ! block; however, the rows of P0 and P1 are a linear combination wrt
       ! those corresponding to the original coordinates
       ! (Q 0)
       ! (* Q) (for PD and LP continuations)
       ! or
       ! (Q    0)
       ! (* -Q^T) (for BP continuations)
       ! or
       ! (Q 0 0)
       ! (* Q 0) (for TR continuations)
       ! (* 0 Q)
       ! any combination of rows from the right hand block that is invertible
       ! suffices though,
       ! so we swap rows according to the echelon form obtained from NULLVC
       ALLOCATE(Q1(NDIM,NDM),IC(NDM),IRPIV(NDM),U(NDM))
       Q1(:,:)=P1(:,NDIM-NDM+1:NDIM)
       CALL NULLVC(NDIM,NDM,0,Q1,U,IC,IRPIV)
       DEALLOCATE(Q1,IC,U)

       ALLOCATE(Q0(NDM,NDM),Q1(NDM,NDM),IR(NDIM))       
       ! swap rows in IR according to IRPIV
       DO I=1,NDIM
          IR(I)=I
       ENDDO
       DO I=1,NDM
          J=IRPIV(I)
          IF(J/=I)THEN
             ITMP=IR(J)
             IR(J)=IR(I)
             IR(I)=ITMP
          ENDIF
       ENDDO
       IF(AP%ITPST==6)THEN
          ! BP cont: took negative of transpose (adjoint variational
          ! equation) in flow: swap P0/P1
          ! EVECS then needs the left eigenvector
          DO I=1,NDM
             Q0(I,:)=P1(IR(I),NDIM-NDM+1:NDIM)
             Q1(I,:)=P0(IR(I),NDIM-NDM+1:NDIM)
          ENDDO
       ELSE
          DO I=1,NDM
             Q0(I,:)=P0(IR(I),NDIM-NDM+1:NDIM)
             Q1(I,:)=P1(IR(I),NDIM-NDM+1:NDIM)
          ENDDO
       ENDIF
       IF(IID.GE.4)THEN
          CALL EVECS(NDM,Q0,Q1,AP%ITPST==6)
       ENDIF

!  Compute the Floquet multipliers
       CALL FLOWKM(NDM, Q0, Q1, IID, EV)
       DEALLOCATE(Q0,Q1,IR,IRPIV)
    ELSE
       IF(IID.GE.4)THEN
          CALL EVECS(NDIM,P0,P1,.FALSE.)
       ENDIF
!  Compute the Floquet multipliers
       CALL FLOWKM(NDM, P0, P1, IID, EV)
    ENDIF

! The algorithm in FLOWKM causes the first multiplier to be closest to z=1.

    L=1
    IF(AP%ITPST==5.OR.AP%ITPST==7)THEN
       ! Find the remaining multiplier closest to z=1/-1 on PD/LP curves
       ! to be able to detect 1:1 and 1:2 resonances.
       L=2
       IF(AP%ITPST==7)THEN
          ! For PD: Find the multiplier closest to z=-1.
          V=-1.d0
       ELSE
          ! For LP: Find the multiplier closest to z=1.
          V=1.d0
       ENDIF
       AMIN=HUGE(1.d0)
       LOC=2
       DO J=2,NDM
          IF(EV(J)==CMPLX( HUGE(1.0D0), HUGE(1.0D0), KIND(1.0D0) ))CYCLE
          ! do not select a complex multiplier
          IF(AIMAG(EV(J))/=0)CYCLE
          AZM1= ABS( EV(J) - V )
          IF(AZM1<AMIN)THEN
             AMIN=AZM1
             LOC=J
          ENDIF
       ENDDO
       IF(LOC.NE.2) THEN
          ZTMP=EV(LOC)
          ! shift EV(2:LOC-1) to EV(3:LOC) to preserve ordering
          ! (a+bi, a-bi) for complex multipliers.
          DO J=LOC-1,2,-1
             EV(J+1)=EV(J)
          ENDDO
          EV(2)=ZTMP
       ENDIF
    ENDIF

! Order the remaining Floquet multipliers by distance from |z|=1.
! Using an insertion sort algorithm.

    IF(NDM.GE.3)THEN
       DO I=L+2,NDM
          ! complex conjugate pairs from FLOWKM are ordered a+bi, a-bi
          ! keep them ordered this way
          ZINS=EV(I)
          IF(AIMAG(ZINS)<0)CYCLE ! ignore a-bi
          IF(ZINS==CMPLX( HUGE(1.0D0), HUGE(1.0D0), KIND(1.0D0) ))CYCLE
          AZINS=ABS(ABS(ZINS) - 1.d0) 
          J=I
          SKIP=0 ! real number
          IF(AIMAG(ZINS)>0)THEN
             ! complex number: shift by two to insert the pair
             SKIP=1
          ENDIF
          DO WHILE(J>L+1)
             ZTMP=EV(J-1)
             IF(AIMAG(ZTMP)<=0)THEN
                ! ignore a+bi for comparison (preceeded by a-bi, counting down)
                IF(ABS(ABS(ZTMP) - 1.d0)<=AZINS)EXIT
             ENDIF
             EV(J+SKIP)=ZTMP
             J=J-1
          ENDDO
          EV(J+SKIP)=CMPLX( REAL(ZINS), -AIMAG(ZINS), KIND(1.0D0) ) ! overwritten for real numbers
          EV(J)=ZINS
       ENDDO
    ENDIF

    ATYPE=TPSPBV(NDM,AP%EPSS,AP%ITPST,PAR,AP%NPAR,EV,THETA)
    IF(.NOT.CHECKSP(ATYPE,AP%IPS,AP%ILP,ISP)) ATYPE=''
    IF(ATYPE=='TR') PAR(12)=THETA !try to find TR bif

! Print error message if the Floquet multiplier at z=1 is inaccurate.
! (ISP is set to negative and detection of bifurations is discontinued)

    AMIN= ABS( EV(1) - 1.d0 )
    IF(AMIN>5.0D-2 .AND. LEN_TRIM(ATYPE)>0) THEN
       NINS=0
       AP%NINS=NINS
       ISP=-ISP
       AP%ISP=ISP
       IF(IID>0)THEN
          IF(IID.GE.2)WRITE(9,101)ABS(IBR),NTOP+1
          DO I=1,NDM
             WRITE(9,105)ABS(IBR),NTOP+1,I,EV(I)
          ENDDO
          WRITE(9,104)ABS(IBR),NTOP+1,NINS
       ENDIF
       RETURN
    ENDIF

! Restart automatic detection if the Floquet multiplier at z=1 is
! sufficiently accurate again.

    IF(ISP.LT.0)THEN
       IF(AMIN.LT.1.0E-2)THEN
          IF(IID>0)WRITE(9,102)ABS(IBR),NTOP+1
          ISP=-ISP
          AP%ISP=ISP
       ELSE
          IF(IID>0)THEN
             DO I=1,NDM
                WRITE(9,105)ABS(IBR),NTOP+1,I,EV(I),ABS(EV(I))
             ENDDO
          ENDIF
          RETURN
       ENDIF
    ENDIF

! Count the number of Floquet multipliers inside the unit circle.
!
! Set tolerance for deciding if a multiplier is outside |z=1|.
! Use, for example, tol=1d-3 for conservative systems.
    tol=1.d-5

    NINS1=1
    IF(NDM>1) THEN
       DO I=2,NDM
          IF(EV(I)==CMPLX( HUGE(1.0D0), HUGE(1.0D0), KIND(1.0D0) ))CYCLE
          IF( ABS(EV(I)).LE.(1.d0+tol))NINS1=NINS1+1
       ENDDO
       IF(LEN_TRIM(ATYPE)>0)THEN
          IF(ISW.EQ.2)THEN
             IF(AP%ITPST==8)THEN
                ! check the angle for resonances on Torus bifurcations
                THETA=PAR(12)
                D=THETA*(THETA-PI(.5d0))*(THETA-PI(2d0/3))*(THETA-PI(1d0))
             ELSEIF(NDM>2)THEN
                IF(ABS(AIMAG(EV(3)))<SQRT(SQRT(AP%EPSS)).AND. &
                     ((AP%ITPST==5.AND.REAL(EV(3))>0.AND. &
                     ABS( EV(2)-1.d0 )<5.0d-2).OR. &
                     ((AP%ITPST==7.AND.REAL(EV(3))<0.AND. &
                     ABS( EV(2)+1.d0 )<5.0d-2))))THEN
                   ! On LP curve: look for 1:1 resonance
                   ! On PD curve: look for 1:2 resonance
                   D= ABS(EV(3)) - 1.d0
                ENDIF
             ENDIF
          ELSE
             IF(AIMAG(EV(2))/=0.d0 .OR. REAL(EV(2))<0.d0)THEN
!               *Ignore if second multiplier is real positive
                D= ABS(EV(2)) - 1.d0
             ENDIF
          ENDIF
       ENDIF
    ENDIF
    IF( LEN_TRIM(ATYPE)>0 .AND. IID>=2 ) WRITE(9,103)ABS(IBR),NTOP+1,D
    FNSPBV=D
    AP%SPBF=FNSPBV

    NINS=AP%NINS
    IF(LEN_TRIM(ATYPE)>0)THEN
       IF(NINS1==NINS.AND.AP%ITPST/=8)ATYPE=TRIM(ATYPE)//'0'
    ENDIF
    NINS=NINS1
    AP%NINS=NINS

    IF(IID>0)THEN
! Print the Floquet multipliers.

       WRITE(9,104)ABS(IBR),NTOP+1,NINS
       DO I=1,NDM
          IF(EV(I)==CMPLX( HUGE(1.0D0), HUGE(1.0D0), KIND(1.0D0) ))THEN
             WRITE(9,105)ABS(IBR),NTOP+1,I,EV(I),REAL(EV(I))
          ELSE
             WRITE(9,105)ABS(IBR),NTOP+1,I,EV(I),ABS(EV(I))
          ENDIF
       ENDDO
    ENDIF

101 FORMAT(I4,I6,' NOTE:Multiplier inaccurate')
102 FORMAT(I4,I6,' NOTE:Multiplier accurate again')
103 FORMAT(I4,I6,9X,'SPB  Function ',ES14.5)
104 FORMAT(I4,I6,9X,'Multipliers:     Stable:',I4)
105 FORMAT(I4,I6,9X,'Multiplier',I3,1X,2ES14.5, &
         '  Abs. Val.',ES14.5)

  END FUNCTION FNSPBV

! ------------ -------- ------
  CHARACTER(2) FUNCTION TPSPBV(NDM,EPSS,ITPST,PAR,NPAR,EV,THETA)

! Determines type of secondary periodic bifurcation.

    USE SUPPORT, ONLY: PI

    INTEGER, INTENT(IN) :: NDM,ITPST,NPAR
    DOUBLE PRECISION, INTENT(IN) :: EPSS
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(NPAR)
    DOUBLE PRECISION, INTENT(OUT) :: THETA
    COMPLEX(KIND(1.0D0)), INTENT(IN) :: EV(NDM)

    INTEGER LOC,LOC1,I
    DOUBLE PRECISION AMIN,AZM1,D,AD

    THETA=0
    IF(NDM<=2)THEN
       ! None of these bifurcations occur for flat systems.
       TPSPBV=''
       RETURN
    ENDIF
    IF(ITPST==5)THEN
       ! 1:1 resonance
       TPSPBV='R1'
       RETURN
    ELSEIF(ITPST==7)THEN
       ! 1:2 resonance
       TPSPBV='R2'
       RETURN
    ELSEIF(ITPST==8)THEN
       TPSPBV=''
       SELECT CASE(NINT(PAR(12)*6/PI(1d0)))
       CASE(0) ! 1:1 res
          TPSPBV='R1'
       CASE(3) ! 1:4 res
          TPSPBV='R4'
       CASE(4) ! 1:3 res
          TPSPBV='R3'
       CASE(6) ! 1:2 res
          TPSPBV='R2'
       END SELECT
       RETURN
    ENDIF

! Find the eigenvalue closest to z=1.

    LOC=1
    AMIN=HUGE(1.d0)
    DO I=1,NDM
       AZM1= ABS( EV(I) - 1.d0 )
       IF(AZM1.LE.AMIN)THEN
          AMIN=AZM1
          LOC=I
       ENDIF
    ENDDO

! Find the eigenvalue closest to the unit circle
! (excluding the eigenvalue at z=1).

    LOC1=1
    AMIN=HUGE(1.d0)
    DO I=1,NDM
       IF(I.NE.LOC)THEN
          D= ABS(EV(I)) - 1.d0
          AD=ABS(D)
          IF(AD.LE.AMIN)THEN
             AMIN=AD
             LOC1=I
          ENDIF
       ENDIF
    ENDDO

    IF(ABS(AIMAG(EV(LOC1))).GT.SQRT(EPSS))THEN
!       ** torus bifurcation
       TPSPBV='TR'
       THETA=ABS(ATAN2(AIMAG(EV(LOC1)),REAL(EV(LOC1))))
    ELSE IF(REAL(EV(LOC1)).LT.-.5d0)THEN
!       ** period doubling
       TPSPBV='PD'
    ELSE
!       ** something else...
       TPSPBV=''
    ENDIF

  END FUNCTION TPSPBV

! ---------- -----
  SUBROUTINE EVECS(NDIM,P0,P1,TRANS)

    USE SUPPORT

    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(IN) :: P0(NDIM,*),P1(NDIM,*)
    LOGICAL, INTENT(IN) :: TRANS

! Local
    DOUBLE PRECISION, ALLOCATABLE :: Q0(:,:),Q1(:,:),P(:,:),Z(:,:),WR(:),WI(:)
    DOUBLE PRECISION, ALLOCATABLE :: WORK(:)
    INTEGER I,J,IERR,LWORK
    DOUBLE PRECISION DET,WORKINFO(1)
    CHARACTER(1) JOBVL,JOBVR

    ALLOCATE(Q0(NDIM,NDIM), Q1(NDIM,NDIM), P(NDIM,NDIM))
    ALLOCATE(Z(NDIM,NDIM), WR(NDIM), WI(NDIM))

    DO I=1,NDIM
       DO J=1,NDIM
          Q0(I,J)=-P0(I,J)
          Q1(I,J)= P1(I,J)
       ENDDO
    ENDDO

    CALL GEL(NDIM,Q1,NDIM,P,Q0,DET)
    IF(TRANS)THEN
       JOBVL='V'
       JOBVR='N'
    ELSE
       JOBVL='N'
       JOBVR='V'
    ENDIF
    CALL DGEEV(JOBVL,JOBVR,NDIM,P,NDIM,WR,WI,Z,NDIM,Z,NDIM,WORKINFO,-1,IERR)
    LWORK=NINT(WORKINFO(1))
    ALLOCATE(WORK(LWORK))
    CALL DGEEV(JOBVL,JOBVR,NDIM,P,NDIM,WR,WI,Z,NDIM,Z,NDIM,WORK,LWORK,IERR)
    DEALLOCATE(WORK)

    WRITE(9,100)
    WRITE(9,101)
    DO I=1,NDIM
       WRITE(9,102)WR(I),WI(I),(Z(I,J),J=1,NDIM)
    ENDDO
    WRITE(9,101)
100 FORMAT(" Multipliers + eigenvectors obtained from - P1^-1 P0 :")
101 FORMAT(" ")
102 FORMAT(2ES14.5," | ",8ES14.5)

    DEALLOCATE(Q0,Q1,P,Z,WR,WI)
  END SUBROUTINE EVECS

END MODULE PERIODIC

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!   frc :      A periodically forced system
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION FHN,Z,A,B,R,EPS,BET,D,V,W,X,Y,SS

       FHN(Z) = Z*(Z-A)*(1-Z) 

       A  = PAR(1) 
       B  = PAR(2) 
       R  = PAR(3) 
       EPS= PAR(4) 
       BET= PAR(5) 
       D  = PAR(6)

       V=U(1)
       W=U(2)
       X=U(3)
       Y=U(4)
       SS = X**2 + Y**2    

       F(1) = ( FHN(V) - W )/EPS
       F(2) = V - D*W - ( B + R*X )
       F(3) =  X + BET*Y - X*SS    
       F(4) = -BET*X + Y - Y*SS    

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)  
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION A,B,R,EPS,BET,D,TPI

       A  =0.5
       B  = A
       R  =0.
       EPS=0.005
       BET=100
       D  =1.0

       PAR(1)=A
       PAR(2)=B
       PAR(3)=R
       PAR(4)=EPS
       PAR(5)=BET
       PAR(6)=D
       TPI=8*ATAN(1.0D0)
       PAR(11)=TPI/BET

       U(1)=B
       U(2)=B*(B-A)*(1-B)
       U(3)=SIN(TPI*T)
       U(4)=COS(TPI*T)

      END SUBROUTINE STPNT

      SUBROUTINE BCND
      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    General Support Routines
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE SUPPORT

USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

IMPLICIT NONE
PRIVATE
PUBLIC :: MUELLER, EIG, PI, GESC, GELI, GEL, NLVC, NULLVC, NRMLZ, RNRMV
PUBLIC :: LBTYPE, LBITP, CHECKSP, INITSTOPCNTS, STOPPED, FNCS, INIT2, INIT3
PUBLIC :: NAMEIDX, PVLI, DIRECTION, AUTOSTOP, EXPANDJAC
PUBLIC :: DTV,AV,P0V,P1V,EVV
 
DOUBLE PRECISION, ALLOCATABLE, SAVE :: DTV(:),P0V(:,:),P1V(:,:)
TYPE(AUTOPARAMETERS), SAVE :: AV
COMPLEX(KIND(1.0D0)), ALLOCATABLE, SAVE :: EVV(:)

CHARACTER(LEN=3), PARAMETER :: ATYPES(-9:14) = &
     (/ 'MX ','R4 ','R3 ','R2 ','R1 ','UZ ','ZH ','CP ','BT ','   ', &
        'BP ','LP ','HB ','   ','LP ','BP ','PD ','TR ','EP ', &
        'GH ','LPD','LTR','PTR','TTR' /)

CONTAINS

! ---------- -------
  SUBROUTINE MUELLER(Q0,Q1,Q,S0,S1,S,RDS)

! Mueller's method with bracketing

    DOUBLE PRECISION, INTENT(IN) :: Q,S
    DOUBLE PRECISION, INTENT(INOUT) :: Q0,Q1,S0,S1
    DOUBLE PRECISION, INTENT(OUT) :: RDS

    DOUBLE PRECISION H0,H1,D,A,B,R,DQ

    H0=S0-S
    H1=S1-S
    D=H0*H1*(H1-H0)
    A=( H1**2*(Q0-Q) - H0**2*(Q1-Q) ) / D
    B=(-H1*(Q0-Q)    + H0*(Q1-Q)    ) / D
    IF(A**2>4*B*Q)THEN
       R=SQRT(A**2-4*B*Q)
       IF(A<0)THEN
          R=-R
       ENDIF
    ELSE
       R=0
    ENDIF
    RDS=-2*Q / (A+R)

    DQ=Q1*Q
    IF(DQ<0.d0)THEN
       Q0=Q1
       S0=S1
    ENDIF
    Q1=Q
    S1=S
  END SUBROUTINE MUELLER

! ---------- ---
  SUBROUTINE EIG(AP,NDIM,M1A,A,EV)

! This subroutine uses the LAPACK subroutine DGEEV to compute the
! eigenvalues of the general real matrix A.
! NDIM is the dimension of A.
! M1A is the first dimension of A as in the DIMENSION statement.
! The eigenvalues are to be returned in the complex vector EV.
    
    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM, M1A
    DOUBLE PRECISION, INTENT(INOUT) :: A(M1A,NDIM)
    COMPLEX(KIND(1.0D0)), INTENT(OUT) :: EV(NDIM)

! Local
    INTEGER IID,IBR,NTOT,NTOP,IER,MATZ,I,IV1(1)
    DOUBLE PRECISION, ALLOCATABLE :: WR(:),WI(:),Z(:,:)
    DOUBLE PRECISION FV1(1)
    ALLOCATE(WR(NDIM),WI(NDIM),Z(M1A,NDIM))

    IID=AP%IID
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    IER=0
    IF(IID>=4)THEN 
       MATZ=1
    ELSE
       MATZ=0
    ENDIF

    CALL RG(M1A,NDIM,A,WR,WI,MATZ,Z,IV1,FV1,IER)
    IF(IER/=0)WRITE(9,'(I4,I6,A)') IBR,NTOP,&
         'NOTE:Error return from EISPACK routine RG'
    IF(MATZ/=0)THEN
       WRITE(9,'(A)')' Eigenvalues:'
       DO I=1,NDIM
          WRITE(9,'(4X,7ES19.10E3)')WR(I),WI(I)
       ENDDO
       WRITE(9,'(A)')' Eigenvectors (by row):'
       DO I=1,NDIM
          WRITE(9,'(4X,7ES19.10E3)')Z(:NDIM,I)
       ENDDO
    ENDIF

    DO I=1,NDIM
       EV(I) = CMPLX(WR(I),WI(I),KIND(1.0D0))
    ENDDO

    DEALLOCATE(WR,WI,Z)
  END SUBROUTINE EIG

! ---------- ------
  SUBROUTINE NULLVC(m,n,k,A,u,icpiv,irpiv)

! Finds a null-vector of a singular matrix A.
! The null space of A is assumed to be K-dimensional.
!
! Parameters :
!
!     m : number of equations,
!     k : dimension of nullspace,
!     A : m * n matrix of coefficients,
!     u : on exit U contains the null vector,
!    ic : integer array of dimension at least N.
!

    INTEGER, INTENT(IN) :: m,n,k
    DOUBLE PRECISION, INTENT(INOUT) :: A(m,n)
    INTEGER, INTENT(OUT) :: icpiv(n), irpiv(n)
    DOUBLE PRECISION, INTENT(OUT) :: U(n)

    INTEGER i,j,jj,l,ipiv,jpiv
    DOUBLE PRECISION p,piv,rm,sm,tmp,amax

!   Elimination.

    amax = 0
    DO JJ=1,N-K
       IPIV=JJ
       JPIV=JJ
       PIV=0.d0
       DO i=jj,m
          DO j=jj,n
             p=ABS(A(i,j))
             IF(p>piv)THEN
                piv=p
                ipiv=i
                jpiv=j
             ENDIF
          ENDDO
       ENDDO
       IF(JJ==1)THEN
          ! now piv is ||A||_max
          amax = piv
       ENDIF
       IF(piv<=amax/HUGE(piv))THEN
          WRITE(9,"(8x,A,I3,A,ES11.4E3,A,ES11.4E3,A,ES11.4E3,A/A)") &
               ' NOTE:Pivot ',jj,' = ',piv,' <= ||A||_max/',HUGE(piv),' = ', &
               amax/HUGE(piv),' in NLVC : ',&
               '        A null space may be multi-dimensional'
          ! to avoid overflow in most cases
          piv = MAX(amax/HUGE(piv),TINY(piv))
          A(ipiv,jpiv) = piv
       ENDIF

       irpiv(jj)=ipiv
       IF(jj/=ipiv)THEN
          DO i=1,n
             tmp=A(jj,i)
             A(jj,i)=A(ipiv,i)
             A(ipiv,i)=tmp
          ENDDO
       ENDIF

       icpiv(jj)=jpiv
       IF(jj/=jpiv)THEN
          DO i=1,m
             tmp=A(i,jj)
             A(i,jj)=A(i,jpiv)
             A(i,jpiv)=tmp
          ENDDO
       ENDIF

       piv=A(jj,jj)
       DO l=jj+1,m
          rm=A(l,jj)/piv
          IF(rm/=0.d0)THEN
             DO i=jj+1,n
                A(l,i)=A(l,i)-rm*A(jj,i)
             ENDDO
          ENDIF
       ENDDO
    ENDDO

!   Backsubstitution :

    DO i=n,n-k+1,-1
       u(i)=1.d0
    ENDDO

    DO i=n-k,1,-1
       sm=0.d0
       DO j=i+1,n
          sm=sm+A(i,j)*u(j)
       ENDDO
       u(i)=-sm/A(i,i)
    ENDDO

!   undo column swapping on u

    DO i=n-k,1,-1
       jpiv=icpiv(i)
       IF(jpiv/=i)THEN
          tmp=u(i)
          u(i)=u(jpiv)
          u(jpiv)=tmp
       ENDIF
    ENDDO

  END SUBROUTINE NULLVC

! ---------- ----
  SUBROUTINE NLVC(m,n,k,A,U)

! Finds a null-vector of a singular matrix A.
! The null space of A is assumed to be k-dimensional.
!
! Parameters :
!
!     M : number of equations,
!     K : dimension of nullspace,
!     A : M * N matrix of coefficients,
!     U : on exit U contains the null vector,
!
    INTEGER, INTENT(IN) :: m,n,k
    DOUBLE PRECISION, INTENT(INOUT) :: A(m,n)
    DOUBLE PRECISION, INTENT(OUT) :: U(n)

    INTEGER, ALLOCATABLE :: icpiv(:),irpiv(:)

    ALLOCATE(icpiv(n),irpiv(n))
    CALL NULLVC(m,n,k,A,U,icpiv,irpiv)
    DEALLOCATE(icpiv,irpiv)

  END SUBROUTINE NLVC

! ------ --------- -------- -----
  DOUBLE PRECISION FUNCTION RNRMV(N,V)

    INTEGER, INTENT(IN) :: N
    DOUBLE PRECISION, INTENT(IN) :: V(N)

    INTEGER I

! Returns the L2-norm of the vector V.

    RNRMV = 0.d0
    DO I=1,N
       RNRMV=RNRMV+V(I)**2
    ENDDO
    RNRMV=SQRT(RNRMV)

  END FUNCTION RNRMV

! ---------- -----
  SUBROUTINE NRMLZ(NDIM,V)

    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(INOUT) :: V(NDIM)

    INTEGER I
    DOUBLE PRECISION SS

! Scale the vector V so that its discrete L2-norm becomes 1.

    SS=0.d0
    DO I=1,NDIM
       SS=SS+V(I)*V(I)
    ENDDO
    V(:)=V(:)/SQRT(SS)

  END SUBROUTINE NRMLZ

! ------ --------- --------
  DOUBLE PRECISION FUNCTION PI(R)

    DOUBLE PRECISION, INTENT(IN) :: R
    PI=R*4.0d0*ATAN(1.d0)

  END FUNCTION PI

! ---------- ---------
  SUBROUTINE EXPANDJAC(JAC,M,N1,N2)

! The Jacobian JAC(N1,M) is unpacked to JAC(N2,M) where N2 > N1

    INTEGER, INTENT(IN) :: M, N1, N2
    DOUBLE PRECISION, INTENT(INOUT) :: JAC(M*N2)

    INTEGER I, J

    DO I=M-1,1,-1
       DO J=N1,1,-1
          JAC(I*N2+J)=JAC(I*N1+J)
       ENDDO
    ENDDO
  END SUBROUTINE EXPANDJAC

! ---------- ----
  SUBROUTINE GELI(N,M1A,A,NRHS,NDX,U,M1F,F,ICPIV,DET,SCALE)

! Solves the linear system  A U = F by Gauss elimination
! with complete pivoting. Optionally returns a scaled determinant.
!
! Parameters :
!
!   N   : number of equations,
!   M1A : first dimension of A from DIMENSION statement,
!   A   : N * N matrix of coefficients,
!   NRHS: 0   if no right hand sides (determinant only),
!         >0   if there are NRHS right hand sides,
!   NDX : first dimension of U from DIMENSION statement,
!   U   : on exit U contains the solution vector(s),
!   M1F : first dimension of F from DIMENSION statement,
!   F   : right hand side vector(s),
!  ICPIV: integer vector of dimension at least N.
!
! The input matrix A is overwritten.

    INTEGER, INTENT(IN) :: N,M1A,NRHS,NDX,M1F
    DOUBLE PRECISION, INTENT(INOUT) :: A(M1A,N),F(M1F,NRHS)
    DOUBLE PRECISION, INTENT(OUT) :: U(NDX,NRHS),DET
    INTEGER, INTENT(OUT) :: ICPIV(N)
    LOGICAL, INTENT(IN) :: SCALE

    INTEGER I,J,L,JJ,IRH,IPIV,JPIV
    DOUBLE PRECISION P,PIV,AP,RM,SM,amax,TMP

!   Elimination.

    DET=1.d0

    amax = ABS(A(1,1))
    DO JJ=1,N-1
       IPIV=JJ
       JPIV=JJ
       PIV=0.d0
       DO I=JJ,N
          DO J=JJ,N
             P=ABS(A(I,J))
             IF(P.GT.PIV)THEN
                PIV=P
                IPIV=I
                JPIV=J
             ENDIF
          ENDDO
       ENDDO

       AP=A(IPIV,JPIV)
       IF(SCALE)THEN
          DET=DET*LOG10(10+ABS(AP)) * atan(AP)
       ELSE
          DET=DET*AP
       ENDIF
       IF(IPIV.NE.JJ)DET=-DET
       IF(JPIV.NE.JJ)DET=-DET

       IF(JJ==1)THEN
          ! now PIV is ||A||_max
          amax = PIV
       ENDIF
       IF(PIV<=amax/HUGE(PIV))THEN
          WRITE(9,"(8x,A,I3,A,ES11.4E3,A,ES11.4E3,A,ES11.4E3,A)")&
               ' NOTE:Pivot ',JJ,' = ',PIV,' <= ||A||_max/',HUGE(PIV),' = ', &
               amax/HUGE(PIV),' in GE'
          ! to avoid overflow in most cases
          A(IPIV,JPIV) = MAX(amax/HUGE(PIV),TINY(PIV))
       ENDIF

       IF(IPIV/=JJ)THEN
          ! swap rows
          DO I=1,N
             TMP=A(JJ,I)
             A(JJ,I)=A(IPIV,I)
             A(IPIV,I)=TMP
          ENDDO
          DO IRH=1,NRHS
             TMP=F(JJ,IRH)
             F(JJ,IRH)=F(IPIV,IRH)
             F(IPIV,IRH)=TMP
          ENDDO
       ENDIF

       ICPIV(JJ)=JPIV
       IF(JPIV/=JJ)THEN
          ! swap columns
          DO J=1,N
             TMP=A(J,JJ)
             A(J,JJ)=A(J,JPIV)
             A(J,JPIV)=TMP
          ENDDO
       ENDIF

       DO L=JJ+1,N
          RM=A(L,JJ)/A(JJ,JJ)
          IF(RM.NE.0.d0)THEN
             DO I=JJ+1,N
                A(L,I)=A(L,I)-RM*A(JJ,I)
             ENDDO
             DO IRH=1,NRHS
                F(L,IRH)=F(L,IRH)-RM*F(JJ,IRH)
             ENDDO
          ENDIF
       ENDDO
    ENDDO
    AP=A(N,N)
    IF(ABS(AP)<=amax/HUGE(AP))THEN
       WRITE(9,"(8x,A,I3,A,ES11.4E3,A,ES11.4E3,A,ES11.4E3,A)")&
            ' NOTE:Pivot ',N,' = ',ABS(AP),' <= ||A||_max/',HUGE(AP),' = ', &
            amax/HUGE(AP),' in GE'
       ! to avoid overflow in most cases
       A(N,N) = MAX(amax/HUGE(AP),TINY(AP))
    ENDIF
    IF(SCALE)THEN
       DET=DET*LOG10(10+ABS(AP)) * atan(AP)
    ELSE
       DET=DET*AP
    ENDIF

!   Backsubstitution :

    DO IRH=1,NRHS
       U(N,IRH)=F(N,IRH)/A(N,N)
       DO I=N-1,1,-1
          SM=0.d0
          DO J=I+1,N
             SM=SM+A(I,J)*U(J,IRH)
          ENDDO
          U(I,IRH)=(F(I,IRH)-SM)/A(I,I)
       ENDDO
    ENDDO

!   undo column swapping on U

    DO I=N-1,1,-1
       JPIV=ICPIV(I)
       IF(JPIV/=I)THEN
          DO IRH=1,NRHS
             TMP=U(I,IRH)
             U(I,IRH)=U(JPIV,IRH)
             U(JPIV,IRH)=TMP
          ENDDO
       ENDIF
    ENDDO

  END SUBROUTINE GELI

! ---------- ---
  SUBROUTINE GEL(N,A,NRHS,U,F,DET)
    INTEGER, INTENT(IN) :: N,NRHS
    DOUBLE PRECISION, INTENT(INOUT) :: A(N,N),F(N,NRHS)
    DOUBLE PRECISION, INTENT(OUT) :: U(N,NRHS),DET
    INTEGER, ALLOCATABLE :: ICPIV(:)
    ALLOCATE(ICPIV(N))
    CALL GELI(N,N,A,NRHS,N,U,N,F,ICPIV,DET,.FALSE.)
    DEALLOCATE(ICPIV)
  END SUBROUTINE GEL

! ---------- ----
  SUBROUTINE GESC(N,A,NRHS,U,F,DET)
    INTEGER, INTENT(IN) :: N,NRHS
    DOUBLE PRECISION, INTENT(INOUT) :: A(N,N),F(N,NRHS)
    DOUBLE PRECISION, INTENT(OUT) :: U(N,NRHS),DET
    INTEGER, ALLOCATABLE :: ICPIV(:)
    ALLOCATE(ICPIV(N))
    CALL GELI(N,N,A,NRHS,N,U,N,F,ICPIV,DET,.TRUE.)
    DEALLOCATE(ICPIV)
  END SUBROUTINE GESC

! ------------ -------- ------
  CHARACTER(3) FUNCTION LBTYPE(ITP)

    ! returns the string label type corresponding to numerical type ITP
    INTEGER, INTENT(IN) :: ITP

    SELECT CASE(ITP)
    CASE(-32)
       LBTYPE='GH'
    CASE(23,83)
       LBTYPE='LTR'
    CASE(77,87)
       LBTYPE='PTR'
    CASE(28,78)
       LBTYPE='LPD'
    CASE(88)
       LBTYPE='TTR'
    CASE DEFAULT
       LBTYPE=ATYPES(MOD(ITP,10))
    END SELECT
  END FUNCTION LBTYPE

! ------- -------- -----
  INTEGER FUNCTION LBITP(ATYPE,BVP) RESULT(ITP)

    ! returns the basic numeric type corresponding to string label ATYPE
    CHARACTER(LEN=*), INTENT(IN) :: ATYPE
    LOGICAL, INTENT(IN) :: BVP
    INTEGER NTY

    ITP=0
    SELECT CASE(TRIM(ATYPE))
    CASE('GH')
       ITP=-2
    CASE('LTR')
       ITP=3
    CASE('PTR')
       ITP=7
    CASE('LPD','TTR')
       ITP=8
    CASE DEFAULT
       DO NTY=-9,9
          IF(ATYPE==ATYPES(NTY).AND..NOT.(BVP.AND.(NTY==1.OR.NTY==2))) THEN
             ITP=NTY
             RETURN
          ENDIF
       ENDDO
    END SELECT
  END FUNCTION LBITP

! ------- -------- -------
  LOGICAL FUNCTION CHECKSP(ATYPE,IPS,ILP,ISP)
    USE AUTO_CONSTANTS, ONLY : SP
    CHARACTER(LEN=*), INTENT(IN) :: ATYPE
    INTEGER, INTENT(IN) :: IPS,ILP,ISP

    ! determine if the given TY label needs to be checked
    INTEGER I,J,M

    CHECKSP = .FALSE.
    SELECT CASE(TRIM(ATYPE))
    CASE('UZ')
       CHECKSP = .TRUE.
    CASE('HB','BT','ZH','GH','CP')
       CHECKSP = (IPS==-1.OR.IPS==1.OR.IPS==11).AND.ISP/=0.AND.ISP/=3
    CASE('LP')
       CHECKSP = ILP/=0
    CASE('BP')
       IF(IPS<2.OR.IPS==5.OR.IPS==11)THEN
          CHECKSP = ISP/=0 ! AE
       ELSE
          CHECKSP = ABS(ISP)>=2.AND.ABS(ISP)/=4 ! BVP
       ENDIF
    CASE('PD','TR','R1','R2','R3','R4','LPD','LTR','PTR','TTR')
       IF(IPS==-1)THEN ! maps
          CHECKSP = ISP/=0.AND.IPS/=3
       ELSE ! cycles
          CHECKSP = (ISP==2.OR.ISP==4) .AND. (IPS==2.OR.IPS==7.OR.IPS==12)
       ENDIF
    END SELECT

    DO I=1,SIZE(SP)
       J=SCAN(SP(I)(3:),"-0123456789")+2
       IF(J==2)THEN
          J=LEN_TRIM(SP(I))+1
       ENDIF
       IF (SP(I)(1:J-1)==TRIM(ATYPE)) THEN
          CHECKSP=.TRUE.
          IF (LEN_TRIM(SP(I))>J-1)THEN
             READ(SP(I)(J:),*)M
             IF(M==0)THEN
                CHECKSP=.FALSE.
             ENDIF
          ENDIF
          EXIT
       ENDIF
    ENDDO
  END FUNCTION CHECKSP

! ---------- ------------
  SUBROUTINE INITSTOPCNTS(ISP,ILP,ITPST,COUNTS)
    USE AUTO_CONSTANTS, ONLY : STOPS, SP
    INTEGER, INTENT(IN) :: ISP,ILP,ITPST
    INTEGER, INTENT(OUT) :: COUNTS(-9:14)

    ! initialize the COUNTS array that determines when we need to stop
    ! at a special point
    INTEGER NTY,I,J

    COUNTS(:) = 0

    ! initialize from IPS, ISP, ILP, ITPST
    IF(ISP<0)THEN
       COUNTS(-8:-5) = 1 ! R4,R3,R2,R1
       COUNTS(-3:-1) = 1 ! ZH,Cusp,BT
       COUNTS(1) = 1 ! BP (AE)
       COUNTS(3) = 1 ! HB (AE)
       COUNTS(6:8) = 1 ! BP(BVP),PD,TR
       COUNTS(10:14) = 1 ! GH,LPD,LTR,PTR,TTR
    ENDIF
    IF(ILP<0)THEN
       COUNTS(2) = 1 ! LP (AE)
       COUNTS(5) = 1 ! LP (BVP)
    ENDIF
    IF(ITPST==3)THEN
       !BT on Hopf bif must always stop it
       COUNTS(-1) = 1
    ENDIF

    ! look both at SP and STOP: SP is for backwards compatibility
    ! but STOP is preferred
    DO I=1,SIZE(SP)
       J=SCAN(SP(I)(3:),"-0123456789")+2
       IF (J>2) THEN
          DO NTY=-9,14
             IF(SP(I)(1:J-1)==TRIM(ATYPES(NTY))) THEN
                READ(SP(I)(J:),*)COUNTS(NTY)
             ENDIF
          ENDDO
       ENDIF
    ENDDO
    DO I=1,SIZE(STOPS)
       J=SCAN(STOPS(I)(3:),"-0123456789")+2
       IF (J>2) THEN
          DO NTY=-9,14
             IF(STOPS(I)(1:J-1)==TRIM(ATYPES(NTY))) THEN
                READ(STOPS(I)(J:),*)COUNTS(NTY)
             ENDIF
          ENDDO
       ENDIF
    ENDDO
  END SUBROUTINE INITSTOPCNTS

! ------- -------- -------
  LOGICAL FUNCTION STOPPED(IUZ,ITEST,NUZR,ITP,COUNTS)
    INTEGER, INTENT(IN) :: IUZ(*),ITEST,NUZR,ITP
    INTEGER, INTENT(INOUT) :: COUNTS(-9:10)

    ! determine if the given TY label has been reached n times so
    ! we need to stop
    INTEGER NTY

    IF(ITEST<=NUZR)THEN
       IF(IUZ(ITEST)<0)THEN
          STOPPED=.TRUE.
          RETURN
       ENDIF
    ENDIF
       
    SELECT CASE(ITP)
    CASE(-32)
       NTY=10 ! 'GH'
    CASE(28,78)
       NTY=11 ! 'LPD'
    CASE(23,83)
       NTY=12 ! 'LTR'
    CASE(77,87)
       NTY=13 ! 'PTR'
    CASE(88)
       NTY=14 ! 'TTR'
    CASE DEFAULT
       NTY=MOD(ITP,10)
    END SELECT

    STOPPED = .FALSE.
    IF (COUNTS(NTY) > 0) THEN
       IF (COUNTS(NTY)==1) THEN
          STOPPED=.TRUE.
       ENDIF
       COUNTS(NTY) = COUNTS(NTY) - 1
    ENDIF
  END FUNCTION STOPPED

! ------- -------- ---------
  LOGICAL FUNCTION DIRECTION(IIS, ITP)

    ! include direction info in solution files depending on IIS and
    ! the type of the point
    INTEGER, INTENT(IN) :: IIS, ITP

    INTEGER ITP0

    ITP0=MOD(ITP,10)
    DIRECTION=.TRUE.
    SELECT CASE(IIS)
    CASE(0) ! never
       DIRECTION=.FALSE.
    CASE(1) ! only for BP/LP(BVP)/PD/TR
       DIRECTION=ITP0==1.OR.(ITP0>=5.AND.ITP0<=8)
    CASE(2) ! for all points except regular (every NPR step)
       DIRECTION=ITP0/=4
    END SELECT
  END FUNCTION DIRECTION

! FNCS and FNUZ are the same for AE and BVP
! ------ --------- -------- ----
  DOUBLE PRECISION FUNCTION FNCS(AP,ICP,UPS,PAR,ATYPE,IUZ,VUZ,ITEST,FNCI)

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: UPS(*)
    INTEGER, INTENT(IN) :: IUZ(*),ICP(*),ITEST
    DOUBLE PRECISION, INTENT(IN) :: VUZ(*)

    INTEGER NUZR

    NUZR=AP%NUZR

    IF(ITEST<=NUZR)THEN
       FNCS=FNUZ(AP,PAR,ATYPE,IUZ,VUZ,ITEST)
    ELSE
       FNCS=FNCI(AP,ICP,UPS,AP%NDIM,PAR,ITEST-NUZR,ATYPE)
    ENDIF

  END FUNCTION FNCS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNUZ(AP,PAR,ATYPE,IUZ,VUZ,IUZR)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    INTEGER, INTENT(IN) :: IUZ(*),IUZR
    DOUBLE PRECISION, INTENT(IN) :: VUZ(*)

    INTEGER IID,IBR,NTOT,NTOP

    ATYPE=''
    FNUZ=0.d0
    IF(.NOT.CHECKSP('UZ',AP%IPS,AP%ILP,AP%ISP))RETURN

    IID=AP%IID
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    FNUZ=PAR(ABS(IUZ(IUZR)))-VUZ(IUZR)
    ATYPE='UZ'

    IF(IID.GE.3)WRITE(9,101)ABS(IBR),NTOP+1,IUZR,FNUZ
101 FORMAT(I4,I6,9X,'User Func.',I3,1X,ES14.5)

  END FUNCTION FNUZ

! ---------- ----
  SUBROUTINE PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

    DOUBLE PRECISION Q
    CHARACTER(4) ATYPEDUM

    Q=FNCI(AP,ICP,UPS,NDIM,PAR,0,ATYPEDUM)

  END SUBROUTINE PVLI

! ------- -------- -------
  INTEGER FUNCTION NAMEIDX(NAME,NAMES)

    USE AUTO_CONSTANTS, ONLY: INDEXSTR
    CHARACTER(13), INTENT(IN) :: NAME
    TYPE(INDEXSTR), INTENT(IN) :: NAMES(:)
    CHARACTER(13) PNAME
    INTEGER I,SIGN,ios

    ! map a symbolic parameter name or an ascii integer to an index

    SIGN=1
    IF(NAME(1:1)=='-')THEN
       PNAME=NAME(2:)
       SIGN=-1
    ELSE
       PNAME=NAME
    ENDIF
    DO I=1,SIZE(NAMES)
       IF(NAMES(I)%STR==PNAME)THEN
          NAMEIDX=NAMES(I)%INDEX*SIGN
          RETURN
       ENDIF
    ENDDO
    IF(TRIM(PNAME)=='PERIOD')THEN
       NAMEIDX=SIGN*11
    ELSE
       READ(NAME,*,IOSTAT=ios)NAMEIDX
       IF(ios/=0)THEN
          WRITE(6,"(A,A,A)")"Name '",TRIM(NAME),"' not found."
          CALL AUTOSTOP()
       ENDIF
    ENDIF
  END FUNCTION NAMEIDX

! ---------- -----
  SUBROUTINE INIT2(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*), ICU(*)

    INTEGER I,IPS,NICP,NFPR,NPAR,NPARI

    ! check output (user-specified) parameters
    NICP=AP%NICP
    DO I=1,NICP
       IF(ICU(I)<=0)THEN
          WRITE(6,'(A,I5,A,I5)') &
                  "Invalid parameter index ",ICU(I), &
                  " specified in ICP index ",I
          CALL AUTOSTOP()
       ENDIF
    ENDDO
    ! check active continuation parameters
    NFPR=AP%NFPR
    DO I=NICP+1,NFPR
       IF(ICP(I)==0)THEN
          WRITE(6,'(A/A,I5,A,I5,A)') &
               "Insufficient number of parameters in ICP.", &
               "You specified ",NICP," but need at least ", &
               NFPR-I+1+NICP, " continuation parameters."
          CALL AUTOSTOP()
       ENDIF
    ENDDO
    NPARI=AP%NPARI
    NPAR=AP%NPAR
    NPAR=MAX(MAXVAL(ICP(:NFPR)),NPAR+NPARI)
    IPS=AP%IPS
    IF(ABS(IPS)==1.OR.IPS==2.OR.IPS>=7)THEN
       !HB period and period for periodic orbits stored in PAR(11)
       NPAR=MAX(11,NPAR)
       IF(CHECKSP('TR',IPS,AP%ILP,AP%ISP))THEN
          ! the torus angle is stored in PAR(12)
          NPAR=MAX(12,NPAR)
       ENDIF
    ENDIF
    AP%NPAR=NPAR
    AP%NTEST=AP%NTEST+AP%NUZR
  END SUBROUTINE INIT2

! ---------- -----
  SUBROUTINE INIT3(AP,ICP,PAR,THL,THU,IUZ,VUZ)

    USE AUTO_CONSTANTS, ONLY: IVTHL,IVTHU,IVUZR,IVUZSTOP,unames,parnames,SVFILE

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(:), THL(*), THU(*), VUZ(*)
    INTEGER, INTENT(INOUT) :: IUZ(*)

    INTEGER I,J,K,IND
    CHARACTER(258) :: SOLFILE, BIFFILE, DIAFILE

    PAR(:)=0.d0
    ! redefine thl to be nfpr indexed
    DO I=1,AP%NFPR
       THL(I)=1.0D0
       DO J=1,SIZE(IVTHL)
          IF(ICP(I)==NAMEIDX(IVTHL(J)%INDEX,parnames))THEN
             THL(I)=IVTHL(J)%VAR
          ENDIF
       ENDDO
    ENDDO
    DO I=1,AP%NDIM
       THU(I)=1.d0
    ENDDO
    DO I=1,SIZE(IVTHU)
       THU(NAMEIDX(IVTHU(I)%INDEX,unames))=IVTHU(I)%VAR
    ENDDO
    !     set IUZ/VUZ
    K=0
    DO I=1,SIZE(IVUZR)
       IND=NAMEIDX(IVUZR(I)%INDEX,parnames)
       DO J=1,SIZE(IVUZR(I)%VAR)
          K=K+1
          IUZ(K)=IND
          VUZ(K)=IVUZR(I)%VAR(J)
       ENDDO
    ENDDO
    DO I=1,SIZE(IVUZSTOP)
       IND=NAMEIDX(IVUZSTOP(I)%INDEX,parnames)
       DO J=1,SIZE(IVUZSTOP(I)%VAR)
          K=K+1
          IUZ(K)=-IND
          VUZ(K)=IVUZSTOP(I)%VAR(J)
       ENDDO
    ENDDO

    ! only now open the output files
    IF(AP%NTOT==0)THEN
       IF(SVFILE/='')THEN
          BIFFILE='b.'//SVFILE
          SOLFILE='s.'//SVFILE
          DIAFILE='d.'//SVFILE
       ELSE
          BIFFILE='fort.7'
          SOLFILE='fort.8'
          DIAFILE='fort.9'
       ENDIF
       OPEN(7,FILE=BIFFILE,STATUS='unknown',ACCESS='sequential')
       OPEN(8,FILE=SOLFILE,STATUS='unknown',ACCESS='sequential')
       OPEN(9,FILE=DIAFILE,STATUS='unknown',ACCESS='sequential')
    ENDIF

  END SUBROUTINE INIT3

  SUBROUTINE AUTOSTOP()
    USE AUTOMPI, ONLY: MPIEND
    CALL MPIEND()
    STOP
  END SUBROUTINE AUTOSTOP

END MODULE SUPPORT

! The following functions and subroutines are called from
! various demos so cannot be inside the module

! ---------- --
  SUBROUTINE GE(IAM,N,M1A,A,NRHS,NDX,U,M1F,F,IR,IC,DET)
    USE SUPPORT
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: IAM,N,M1A,NRHS,NDX,M1F,IR(N)
    DOUBLE PRECISION, INTENT(INOUT) :: A(M1A,N),F(M1F,NRHS)
    DOUBLE PRECISION, INTENT(OUT) :: U(NDX,NRHS),DET
    INTEGER, INTENT(OUT) :: IC(N)
    CALL GELI(N,M1A,A,NRHS,NDX,U,M1F,F,IC,DET,.FALSE.)
  END SUBROUTINE GE

! ------ --------- -------- ----
  DOUBLE PRECISION FUNCTION GETP(CODE,IC,UPS)

    USE MESH
    USE SUPPORT
    USE AUTOMPI, ONLY: MPIIAM
    IMPLICIT NONE

    CHARACTER(3), INTENT(IN) :: CODE
    INTEGER, INTENT(IN) :: IC
    DOUBLE PRECISION, INTENT(IN) :: UPS(AV%NDIM*AV%NCOL,*)

    INTEGER NDIM,IPS,NTST,NCOL,NBC,NINT
    DOUBLE PRECISION WI(0:AV%NCOL)

    NDIM=AV%NDIM
    IPS=AV%IPS
    NTST=AV%NTST
    NCOL=AV%NCOL
    NBC=AV%NBC
    NINT=AV%NINT

    GETP=0
    IF(MPIIAM()>0)THEN
       RETURN
    ENDIF

    IF( IPS<=1 .OR. IPS==5 .OR. IPS==11)THEN
       SELECT CASE(CODE)
       CASE('NRM','nrm')
          GETP=ABS(UPS(IC,1))
       CASE('INT','int','MAX','max','MIN','min','BV1','bv1')
          GETP=UPS(IC,1)
       CASE('HBF','hbf')
          GETP=AV%HBFF
       CASE('BIF','bif')
          GETP=AV%DET
       CASE('SPB','spb','MXT','mxt','MNT','mnt','DTM','dtm','WIN','win')
          GETP=0.
       END SELECT
    ELSE
       SELECT CASE(CODE)
       CASE('NRM','nrm')
          GETP=RNRM2(NTST,NCOL,NDIM,IC,UPS,DTV)
       CASE('INT','int')
          GETP=RINTG(NTST,NCOL,NDIM,IC,UPS,DTV)
       CASE('MAX','max')
          GETP=RMXUPS(NTST,NCOL,NDIM,IC,UPS)
       CASE('MIN','min')
          GETP=RMNUPS(NTST,NCOL,NDIM,IC,UPS)
       CASE('MXT','mxt')
          GETP=RMXUPST(NTST,NCOL,NDIM,IC,UPS,DTV)
       CASE('MNT','mnt')
          GETP=RMNUPST(NTST,NCOL,NDIM,IC,UPS,DTV)
       CASE('DTM','dtm')
          GETP=DTV(IC)
       CASE('WIN','win')
          CALL WINT(NCOL,WI)
          GETP=WI(IC)
       CASE('BV1','bv1')
          GETP=UPS(IC,AV%NTST+1)
       CASE('HBF','hbf')
          GETP=0.d0
       CASE('BIF','bif')
          GETP=AV%BIFF
       CASE('SPB','spb')
          GETP=AV%SPBF
       END SELECT
    ENDIF
    SELECT CASE(CODE) 
    CASE('BV0','bv0')
       GETP=UPS(IC,1)
    CASE('STP','stp')
       GETP=AV%RDS
    CASE('FLD','fld')
       GETP=AV%FLDF
    CASE('STA','sta')
       GETP=AV%NINS
    CASE('EIG','eig')
       IF(MOD(IC,2)==1)THEN
          GETP=REAL(EVV((IC+1)/2))
       ELSE
          GETP=AIMAG(EVV(IC/2))
       ENDIF
    CASE('NDI','ndi','NDX','ndx')
       GETP=NDIM
    CASE('NTS','nts')
       GETP=NTST
    CASE('NCO','nco')
       GETP=NCOL
    CASE('NBC','nbc')
       GETP=NBC
    CASE('NIN','nin')
       GETP=NINT
    END SELECT

  END FUNCTION GETP

! ---------- -------
  SUBROUTINE GETMDMX(NDIM1,P0,P1,NMM)
    USE SUPPORT
    IMPLICIT NONE

    INTEGER, INTENT(IN) :: NDIM1
    DOUBLE PRECISION, INTENT(OUT) :: P0(NDIM1,NDIM1),P1(NDIM1,NDIM1)
    LOGICAL, INTENT(OUT) :: NMM

    INTEGER NDIM,IPS,ISP,NTOT

    NDIM=AV%NDIM
    IPS=AV%IPS
    ISP=AV%ISP
    NTOT=AV%NTOT
    NMM=.FALSE.
    IF(NDIM==NDIM1.AND.NTOT>0.AND.ABS(ISP)>0.AND. &
         (IPS==2.OR.IPS==7.OR.IPS==12))THEN
       P0=P0V
       P1=P1V
       NMM=.TRUE.
    ENDIF

  END SUBROUTINE GETMDMX
!
! because some demos call RG here is a wrapper around DGEEV
!
  SUBROUTINE RG(M1A,NDIM,A,WR,WI,MATZ,Z,IV1,FV1,IER)

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: M1A,NDIM,MATZ,IV1(NDIM)
    DOUBLE PRECISION, INTENT(IN) :: FV1(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: A(M1A,NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: WR(NDIM),WI(NDIM),Z(M1A,NDIM)
    INTEGER, INTENT(OUT) :: IER

    CHARACTER(1) JOBVR
    INTEGER LWORK
    DOUBLE PRECISION WORKINFO(1)
    DOUBLE PRECISION, ALLOCATABLE :: WORK(:)

    IF(MATZ==1)THEN
       JOBVR='V'
    ELSE
       JOBVR='N'
    ENDIF
    CALL DGEEV('N',JOBVR,NDIM,A,M1A,WR,WI,Z,M1A,Z,M1A,WORKINFO,-1,IER)
    LWORK=NINT(WORKINFO(1))
    ALLOCATE(WORK(LWORK))
    CALL DGEEV('N',JOBVR,NDIM,A,M1A,WR,WI,Z,M1A,Z,M1A,WORK,LWORK,IER)
    DEALLOCATE(WORK)

  END SUBROUTINE RG

! dummy file, used in case MPI is not available.

module autompi

use auto_constants, only: autoparameters

implicit none
private

public :: mpiini, mpiiap, mpiwfi, mpireduce, mpibcksub, mpisbv, mpicbv
public :: mpibcast, mpibcast1, mpibcasti, mpibcast1i, mpibcast1l, mpibcastap
public :: mpireducemax, mpireducemin
public :: mpigat, mpiscat, mpiend, mpitim, mpiiam, mpikwt, partition
public :: mpigats

contains

subroutine mpiini()
end subroutine mpiini

integer function mpiiam()
  mpiiam = 0
end function mpiiam

integer function mpikwt()
  mpikwt = 1
end function mpikwt

subroutine mpiiap(ap)
  type(autoparameters) :: ap
end subroutine mpiiap

logical function mpiwfi()
  mpiwfi = .false.
end function mpiwfi

subroutine partition(n,kwt,m)
  integer n,kwt,m(kwt)
  m(1) = n
end subroutine partition

subroutine mpireduce(a1,a2,bb,cc,c2,dd,faa,fcfc,ntst,nov,ncb,nrc,ifst,nllv,&
     lo,hi,level)
  integer, intent(in) :: ntst,nov,ncb,nrc,ifst,nllv,lo,hi,level
  double precision, intent(inout) :: a1(nov,nov,*),a2(nov,nov,*),bb(ncb,nov,*)
  double precision, intent(inout) :: cc(nov,nrc,*),c2(nov,nrc,*)
  double precision, intent(inout) :: dd(ncb,nrc,*),faa(nov,*)
  double precision, intent(inout) :: fcfc(nrc,*)
end subroutine mpireduce

subroutine mpibcksub(sol,fc,ntst,nov,ncb,lo,hi,level)
  integer, intent(in) :: ntst,nov,ncb,lo,hi,level
  double precision, intent(inout) :: sol(nov,*),fc(*)
end subroutine mpibcksub

subroutine mpisbv(solvbv)
  logical, intent(in) :: solvbv
end subroutine mpisbv

subroutine mpicbv(npar,par,rds)
  integer, intent(in) :: npar
  double precision :: par(npar)
  double precision :: rds
end subroutine mpicbv

subroutine mpibcast(buf,len)
  integer, intent(in) :: len
  double precision, intent(inout) :: buf(len)
end subroutine mpibcast

subroutine mpibcast1(buf)
  double precision, intent(inout) :: buf
end subroutine mpibcast1

subroutine mpibcasti(buf,len)
  integer, intent(in) :: len
  integer, intent(inout) :: buf(len)
end subroutine mpibcasti

subroutine mpibcast1i(buf)
  integer, intent(inout) :: buf
end subroutine mpibcast1i

subroutine mpibcast1l(buf)
  logical, intent(inout) :: buf
end subroutine mpibcast1l

subroutine mpibcastap(ap)
  type(autoparameters), intent(inout) :: ap
end subroutine mpibcastap

subroutine mpiscat(buf,ndx,n,add)
  integer, intent(in) :: ndx,n,add
  double precision, intent(inout) :: buf(ndx,*)
end subroutine mpiscat

subroutine mpigat(buf,ndx,n)
  integer, intent(in) :: ndx,n
  double precision, intent(inout) :: buf(ndx,*)
end subroutine mpigat

subroutine mpigats(buf,ndx,n,linelen)
  integer, intent(in) :: ndx,n,linelen
  character(linelen), intent(inout) :: buf(*)
end subroutine mpigats

subroutine mpireducemax(buf,n)
  integer, intent(in) :: n
  double precision, intent(inout) :: buf(n)
end subroutine mpireducemax

subroutine mpireducemin(buf,n)
  integer, intent(in) :: n
  double precision, intent(inout) :: buf(n)
end subroutine mpireducemin

subroutine mpiend()
end subroutine mpiend

subroutine mpitim(tim)
  double precision tim
end subroutine mpitim  

end module autompi

!---------------------------------------------------------------------
!---------------------------------------------------------------------
! pcl: Finding a point-to-cycle heteroclinic connection in the
!      Lorenz equations
! 
! Parameters:
!   PAR(1) : rho
!   PAR(2) : beta
!   PAR(3) : sigma
!
!   PAR(11) : T: period of the cycle
!   PAR(12) : mu: log of the Floquet multiplier
!   PAR(13) : h: norm of eigenfunction for cycle at 0
!   PAR(14) : T^+: time for connection from section to cycle (U(7:9))
!   PAR(15) : delta: distance from end connection to cycle
!   PAR(16) : T^-: time for connection from point to section (U(10:12))
!   PAR(17) : eps: distance from point to start connection
!   PAR(21) : sigma+: U0(7)-10 (x-distance W^s(P) from section x=10)
!   PAR(22) : sigma-: U1(10)-10 (x-distance W^u(E) from section x=10)
!   PAR(23) : eta: gap size for Lin vector
!   PAR(24) : Z_x: Lin vector (x-coordinate)
!   PAR(25) : Z_y: Lin vector (y-coordinate)
!   PAR(26) : Z_z: Lin vector (z-coordinate)
!---------------------------------------------------------------------
!---------------------------------------------------------------------

  SUBROUTINE RHS(U,PAR,F,JAC,A)

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: U(3), PAR(*)
    LOGICAL, INTENT(IN) :: JAC
    DOUBLE PRECISION, INTENT(OUT) :: F(3), A(3,3)

    DOUBLE PRECISION rho, beta, sigma
    DOUBLE PRECISION x, y, z

    rho = PAR(1)
    beta = PAR(2)
    sigma = PAR(3)

    x = U(1)
    y = U(2)
    z = U(3)

    F(1) = sigma * (y - x)
    F(2) = rho * x - y - x * z
    F(3) = x * y - beta * z

    IF(JAC)THEN
       A(1,1) = -sigma
       A(1,2) = sigma
       A(1,3) = 0

       A(2,1) = rho - z
       A(2,2) = -1
       A(2,3) = -x

       A(3,1) = y
       A(3,2) = x
       A(3,3) = -beta
    ENDIF

  END SUBROUTINE RHS

  SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
! ---------- --- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    DOUBLE PRECISION T,mu
    DOUBLE PRECISION A(3,3)

    CALL RHS(U,PAR,F,NDIM>3,A)
    IF(NDIM==3)RETURN

    F(4:6) = MATMUL(A,U(4:6))

    T = PAR(11)
    F(1:6) = F(1:6) * T

    ! log of Floquet multiplier in PAR(12)
    mu = PAR(12)
    F(4:6) = F(4:6) - mu*U(4:6)

    IF (NDIM==6) RETURN

    CALL RHS(U(7:9),PAR,F(7:9),.FALSE.,A)

    T = PAR(14)
    F(7:9) = F(7:9) * T

    IF (NDIM==9) RETURN

    CALL RHS(U(10:12),PAR,F(10:12),.FALSE.,A)

    T = PAR(16)
    F(10:12) = F(10:12) * T

  END SUBROUTINE FUNC

  SUBROUTINE STPNT(NDIM,U,PAR,T)
  !--------- -----
  
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: T

    DOUBLE PRECISION, PARAMETER :: delta = 1d-7, eps = 1d-7
    DOUBLE PRECISION rho, beta, sigma, ev(3), nev
    DOUBLE PRECISION, SAVE :: s(6)

    IF(NDIM==9)THEN
       IF(T==0)THEN
          s(1:6) = U(1:6)
       ENDIF
       U(7:9) = s(1:3) + delta*s(4:6)
       RETURN
    ELSEIF(NDIM==12)THEN
       rho = PAR(1)
       beta = PAR(2)
       sigma = PAR(3)

       ! unstable eigenvector at the 0 equilibrium
       ev(1) = rho/(-0.5+0.5*sigma+0.5*sqrt(1-2*sigma+sigma*sigma+4*rho*sigma))
       ev(2) = 1
       ev(3) = 0
       nev = sqrt(DOT_PRODUCT(ev,ev))
       ev(1:3) = ev(1:3) / nev

       U(10:12) = eps*ev(1:3)
       RETURN
    ENDIF

    rho = 0
    beta = 8d0/3d0
    sigma = 10d0
    PAR(1:3) = (/rho,beta,sigma/)
    PAR(15) = delta
    PAR(17) = eps
    PAR(21:22) = 0

    U(1:3) = 0

  END SUBROUTINE STPNT

  SUBROUTINE PVLS(NDIM,U,PAR)
  !--------- ----

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    
    DOUBLE PRECISION, EXTERNAL :: GETP
    DOUBLE PRECISION d(3),normlv
    INTEGER i, NBC
    LOGICAL, SAVE :: FIRST = .TRUE.

    IF (FIRST) THEN ! initialization for BCND
       FIRST = .FALSE.
       IF (NDIM==9) THEN
          PAR(21) = GETP("BV0",7,U) - 10
       ELSEIF (NDIM == 12) THEN
          NBC = AINT(GETP("NBC",0,U))
          IF (NBC == 15) THEN
             PAR(22) = GETP("BV1",10,U) - 10
          ELSEIF (NBC == 17) THEN
             ! check if Lin vector initialized:
             IF (DOT_PRODUCT(PAR(24:26),PAR(24:26)) > 0) RETURN
             DO i=1,3
                d(i) = GETP("BV0",6+i,U) - GETP("BV1",9+i,U)
             ENDDO
             normlv = sqrt(DOT_PRODUCT(d,d))
             ! gap size in PAR(23)
             PAR(23) = normlv
             ! Lin vector in PAR(24)-PAR(26)
             PAR(24:26) = d(1:3)/normlv
          ENDIF
       ENDIF
       RETURN
    ENDIF

  END SUBROUTINE PVLS

  SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
  !--------- ----

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    DOUBLE PRECISION rho, beta, sigma, delta, eps, ev(3), nev, eta

    ! Periodicity boundary conditions on state variables
    FB(1:3) = U0(1:3) - U1(1:3)

    ! Floquet boundary condition
    FB(4:6) = U1(4:6) - U0(4:6)

    ! normalization
    FB(7) = PAR(13) - DOT_PRODUCT(U0(4:6),U0(4:6))
    IF (NBC==7) RETURN

    delta = PAR(15)
    FB(8:10) = U1(7:9) - (U0(1:3) + delta*U0(4:6))
    FB(11) = U0(7) - 10 - PAR(21)

    IF (NBC==11) RETURN

    rho = PAR(1)
    beta = PAR(2)
    sigma = PAR(3)
    eps = PAR(17)

    ! unstable eigenvector at the 0 equilibrium
    ev(1) = rho/(-0.5+0.5*sigma+0.5*sqrt(1-2*sigma+sigma*sigma+4*rho*sigma))
    ev(2) = 1
    ev(3) = 0
    nev = sqrt(DOT_PRODUCT(ev,ev))
    ev(1:3) = ev(1:3) / nev

    FB(12:14) = U0(10:12) - eps*ev(1:3)

    IF (NBC==15) THEN
       FB(15) = U1(10) - 10 - PAR(22)
       RETURN
    ENDIF

    eta = PAR(23)
    FB(15:17) = U0(7:9) - U1(10:12) - eta*PAR(24:26)

  END SUBROUTINE BCND

  SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
  !--------- ----
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    ! Integral phase condition
    FI(1) = DOT_PRODUCT(U(1:3),UPOLD(1:3))
    IF (NINT==1) RETURN

    FI(2) = DOT_PRODUCT(UPOLD(10:12),U(10:12)-UOLD(10:12))
  END SUBROUTINE ICND

  SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP)
  END SUBROUTINE FOPT

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   phs :    A Hopf bifurcation leading to a homoclinic orbit
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

       F(1)=-PAR(1)*U(1) - U(2) 
       F(2)= U(1) * (1 - U(1)) 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=-1.0 

       U(1)=0.0 
       U(2)=0.0 

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   fsh :     Heteroclinic orbits : a saddle-node copnnection
!----------------------------------------------------------------------
!----------------------------------------------------------------------
! Parameter assignment:
!
!           PAR(1)           :                   (unused)
!           PAR(2)           : c                 (wave speed)
!           PAR(4)           : eps-1        1    (radius)
!           PAR(11)          : period
!           PAR(12)          : mu-1              (eigenvalue  at 1)
!           PAR(13) , PAR(14): v(1)    , v(2)    (eigenvector at 1)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION PERIOD,DUMMY(1)
      INTEGER I

       CALL FFFF(2,U,ICP,PAR,IJAC,F,DUMMY)
       PERIOD=PAR(11)
       DO I=1,NDIM
         F(I)=PERIOD*F(I)
       ENDDO

      END SUBROUTINE FUNC

      SUBROUTINE FFFF(NDM,U,ICP,PAR,IJAC,F,DFDU)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM)

      DOUBLE PRECISION C

       C=PAR(2)
       F(1)= U(2)
       F(2)= C*U(2) - U(1) * (1-U(1))

      IF(IJAC.EQ.0)RETURN

       DFDU(1,1)= 0
       DFDU(1,2)= 1

       DFDU(2,1)= -1 + 2*U(1)
       DFDU(2,2)= C

      END SUBROUTINE FFFF

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION PERIOD, C, EP1, D, RMU1, V11, V12

      IF(T==0)THEN
!       Set the starting period, wave speed, and radius
        PERIOD=0.01
        C=11.
        EP1=0.001
        D = SQRT(C**2+4)
        PAR(2)= C
        PAR(4)= EP1
        PAR(11)= PERIOD
        PAR(12)= (C-D)/2
        PAR(13) =    1./SQRT(1+PAR(12)**2)
        PAR(14)=PAR(12)/SQRT(1+PAR(12)**2)
       ENDIF

       C     =PAR(2)
       EP1   =PAR(4)
       PERIOD=PAR(11)
       D=SQRT(C**2+4)
       RMU1= (C-D)/2
       V11 =  1./SQRT(1+RMU1**2)
       V12 =RMU1/SQRT(1+RMU1**2)

       U(1)=1-EP1*V11
       U(2)= -EP1*V12

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
! Local
      INTEGER, PARAMETER :: NDM=2
      DOUBLE PRECISION V1(NDM),G1(NDM),DGDU1(NDM,NDM)

      V1(1)=U1(1) + PAR(4)*PAR(13)
      V1(2)=U1(2) + PAR(4)*PAR(14)

      CALL FFFF(NDM,V1,ICP,PAR,1,G1,DGDU1)

      FB(1)= DGDU1(1,1)*PAR(13) + DGDU1(1,2)*PAR(14)- PAR(12)*PAR(13)
      FB(2)= DGDU1(2,1)*PAR(13) + DGDU1(2,2)*PAR(14)- PAR(12)*PAR(14)
      FB(3)= PAR(13)**2 + PAR(14)**2 -1
      FB(4)= G1(1)
      FB(5)= G1(2)

      END SUBROUTINE BCND

      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)
! Local
      INTEGER, PARAMETER :: NDM=2
      DOUBLE PRECISION F(NDM),F0(NDM),DFDU(NDM,NDM),DUMMY(1)

      CALL FFFF(NDM,U   ,ICP,PAR,1,F ,DFDU)
      CALL FFFF(NDM,UOLD,ICP,PAR,0,F0,DUMMY)

       FI(1)= ( F(1) - F0(1) ) * ( DFDU(1,1)*F(1) + DFDU(1,2)*F(2) ) &
            + ( F(2) - F0(2) ) * ( DFDU(2,1)*F(1) + DFDU(2,2)*F(2) )

      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   cir :    Homoclinic Bifurcation in an Electronic Circuit
!                (the same equations as in demo tor)
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION rn,be,ga,r,a3,b3,x,y,z

       rn=PAR(1) 
       be=PAR(2) 
       ga=PAR(3) 
       r =PAR(4) 
       a3=PAR(5) 
       b3=PAR(6) 

       x=U(1)
       y=U(2)
       z=U(3)

       F(1)= ( -(be+rn)*x + be*y - a3*x**3 + b3*(y-x)**3 )/r
       F(2)=  be*x - (be+ga)*y - z - b3*(y-x)**3
       F(3)= y

       IF(IJAC.EQ.0)RETURN

       DFDU(1,1)=( -(be+rn) -3*a3*x**2 - 3*b3*(y-x)**2  )/r
       DFDU(1,2)=( be + 3*b3*(y-x)**2 )/r
       DFDU(1,3)=0

       DFDU(2,1)=be + 3*b3*(y-x)**2
       DFDU(2,2)=-(be+ga) - 3*b3*(y-x)**2
       DFDU(2,3)=-1

       DFDU(3,1)=0
       DFDU(3,2)=1
       DFDU(3,3)=0

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DFDP(1,1)=-x/r
       DFDP(2,1)=0
       DFDP(3,1)=0

       DFDP(1,2)=( -x + y )/r
       DFDP(2,2)=x-y
       DFDP(3,2)=0

       DFDP(1,3)=0
       DFDP(2,3)=-y
       DFDP(3,3)=0

       DFDP(1,4)=-F(1)/r
       DFDP(2,4)=0
       DFDP(3,4)=0

       DFDP(1,5)=x**3/r
       DFDP(2,5)=0
       DFDP(3,5)=0

       DFDP(1,6)=(y-x)**3 / r
       DFDP(2,6)=-(y-x)**3
       DFDP(3,6)=0

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

!----------------------------------------------------------------------
! Problem parameters (only PAR(1-9) are available to the user) :

       PAR(1)=-0.721309D0         ! nu
       PAR(2)=0.6                 ! beta
       PAR(3)=0.0                 ! gamma
       PAR(4)=0.6                 ! r
       PAR(5)=0.328578            ! a_3
       PAR(6)=0.933578            ! b_3

       PAR(11)=36.13              ! Truncated time interval 

!----------------------------------------------------------------------
! If IEQUIB >0 put initial equilibrium in PAR(11+i), i=1,...,NDIM :

      PAR(12) = 0.0
      PAR(13) = 0.0
      PAR(14) = 0.0

      END SUBROUTINE STPNT

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
! Homoclinic bifurcations COMMON block needed here :
      INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV

      INTEGER I

! If IEQUIB =0 put analytic equilibrium in PAR(11+i), i=1..NDIM

      IF(IEQUIB.EQ.0)THEN
        DO I=1,NDIM
          PAR(11+I)= 0.0
        ENDDO
      ENDIF

      END SUBROUTINE PVLS

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   ab :            The A --> B reaction 
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

! Evaluates the algebraic equations or ODE right hand side

! Input arguments :
!      NDIM   :   Dimension of the ODE system 
!      U      :   State variables
!      ICP    :   Array indicating the free parameter(s)
!      PAR    :   Equation parameters

! Values to be returned :
!      F      :   ODE right hand side values

! Normally unused Jacobian arguments : IJAC, DFDU, DFDP (see manual)

      IMPLICIT NONE
      INTEGER NDIM, IJAC, ICP(*)
      DOUBLE PRECISION U(NDIM), PAR(*), F(NDIM), DFDU(*), DFDP(*)
      DOUBLE PRECISION U1,U2,E

       U1=U(1)
       U2=U(2)

       E=EXP(U2)

       F(1)=-U1 + PAR(1)*(1-U1)*E
       F(2)=-U2 + PAR(1)*PAR(2)*(1-U1)*E - PAR(3)*U2

      END SUBROUTINE FUNC
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

! Input arguments :
!      NDIM   :   Dimension of the ODE system 

! Values to be returned :
!      U      :   A starting solution vector
!      PAR    :   The corresponding equation-parameter values
!      T      :	  Not used here

      IMPLICIT NONE
      INTEGER NDIM
      DOUBLE PRECISION U(NDIM), PAR(*), T

! Initialize the equation parameters
       PAR(1)=0.
       PAR(2)=8.
       PAR(3)=3.

! Initialize the solution
       U(1)=0.
       U(2)=0.

      END SUBROUTINE STPNT
!----------------------------------------------------------------------
!----------------------------------------------------------------------
! The following subroutines are not used here,
! but they must be supplied as dummy routines

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS
!----------------------------------------------------------------------
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   obv :    Optimization in a boundary value problem
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION P, E

       P=U(1) + PAR(2)*U(1)**2 + PAR(3)*U(1)**4
       E=EXP(P)

       F(1)= U(2)
       F(2)=-PAR(1)*E
       F(3)= PAR(1)*E*(1+2*PAR(2)*U(1)+4*PAR(3)*U(1)**3 )*U(4) &
                             + PAR(15)*2*(U(1)-1.0)
       F(4)=-U(3)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0.001
       PAR(10)=1.0

       U(1)=0.0
       U(2)=0.0
       U(3)=0.0
       U(4)=0.0

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

       FB(1)=U0(1)
       FB(2)=U1(1)
       FB(3)=U0(3)-PAR(13)
       FB(4)=U0(4)
       FB(5)=U1(3)+PAR(14)
       FB(6)=U1(4)

      END SUBROUTINE BCND

      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

      DOUBLE PRECISION P, E

       P=U(1) + PAR(2)*U(1)**2 + PAR(3)*U(1)**4
       E=EXP(P)

       FI(1)=U(3)**2 - PAR(16)
       FI(2)=PAR(10)-(U(1)-1.0)**2 &
               - 0.1*( PAR(1)**2+PAR(2)**2+PAR(3)**2 )
       FI(3)=-E*U(4)-PAR(15)*0.2*PAR(1)
         IF(NINT.EQ.3)RETURN
       FI(4)=-PAR(1)*E*U(1)**2*U(4)-PAR(15)*0.2*PAR(2) - PAR(17)
         IF(NINT.EQ.4)RETURN
       FI(5)=-PAR(1)*E*U(1)**4*U(4)-PAR(15)*0.2*PAR(3) - PAR(18)

      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    Output (Algebraic Problems)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE IO

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

  IMPLICIT NONE
  PRIVATE
  PUBLIC :: READC, FINDLB, READLB, READBV, WRLINE, WRBAR, STHD, NEWLAB, &
       GETNDIM3, GETNTST3, GETNCOL3, GETNFPR3, GETIPS3

  TYPE SOLUTION
     INTEGER :: IBR, NTOT, ITP, LAB, NFPR, ISW, NTPL, NAR, NROWPR, NTST, NCOL,&
          NPAR, NPARI, NDM, IPS, IPRIV
     DOUBLE PRECISION, DIMENSION(:,:), POINTER :: UPS, UDOTPS
     DOUBLE PRECISION, DIMENSION(:), POINTER :: TM
     DOUBLE PRECISION, DIMENSION(:), POINTER :: RLDOT, PAR
     INTEGER, DIMENSION(:), POINTER :: ICP
     TYPE(SOLUTION), POINTER :: NEXT
  END TYPE SOLUTION
  TYPE(SOLUTION), POINTER :: ROOTSOL, CURSOL
  INTEGER, SAVE :: MBR=0, MLAB=0
CONTAINS

! ------------- -------- -------
  CHARACTER(13) FUNCTION getname(is, ind)
    USE AUTO_CONSTANTS, ONLY: INDEXSTR
    TYPE(INDEXSTR), INTENT(IN) :: is(:)
    INTEGER, INTENT(IN) :: ind
    INTEGER i

    getname = ''
    DO i = 1, SIZE(is)
       IF (is(i)%index == ind) THEN
          getname = is(i)%str
          RETURN
       ENDIF
    ENDDO
  END FUNCTION getname

! ---------- -----
  SUBROUTINE READC(UNITC,EOF,LINE,NPOS,STR,KEYEND,POS,LISTLEN,IERR)

! Reads the file of continuation constants

    USE AUTO_CONSTANTS

    INTEGER, INTENT(IN) :: UNITC
    LOGICAL, INTENT(OUT) :: EOF
    INTEGER, INTENT(INOUT) :: LINE
    CHARACTER(*), INTENT(INOUT) :: STR
    INTEGER, INTENT(INOUT) :: NPOS
    INTEGER, INTENT(OUT) :: KEYEND, POS, LISTLEN, IERR

    INTEGER I,J,IC,N
    INTEGER NICP
    DOUBLE PRECISION RC
    CHARACTER(LEN=1) :: C,PREV
    INTEGER LISTLEN2,ios

    TYPE INDEXSTRL
       CHARACTER(13) INDEX
       CHARACTER(2048) STRL
    END TYPE INDEXSTRL
    TYPE(INDEXSTRL),ALLOCATABLE :: IVUZRS(:)

    CHARACTER(LEN=*), PARAMETER :: ICONSTANTS(24) = (/                    &
         "NDIM", "IPS ", "ILP ", "NTST", "NCOL", "IAD ", "IADS", "ISP ",  &
         "ISW ", "IPLT", "NBC ", "NINT", "NMX ", "NPR ", "MXBF", "IID ",  &
         "ITMX", "ITNW", "NWTN", "JAC ", "NPAR", "IBR ", "LAB ", "IIS " /)
    CHARACTER(LEN=*), PARAMETER :: RCONSTANTS(10) = (/                    &
         "DS   ", "DSMIN", "DSMAX", "RL0  ", "RL1  ", "A0   ", "A1   ",   &
         "EPSL ", "EPSU ", "EPSS " /)

    EOF=.FALSE.
    POS=0
    KEYEND=0
    LISTLEN=0
    IERR=0
    IF(NPOS==1)THEN
       LINE=LINE+1
       N=READINTEGER(UNITC,STR(1:1),IERR)
       IF(IERR/=0)THEN
          IF(IERR==4)THEN
             IERR=0
             EOF=.TRUE.
          ELSEIF(IERR==-1)THEN
             CALL READOLDC(UNITC,N,EOF,LINE,IERR)
          ENDIF
          RETURN
       ENDIF
       NEWCFILE=.TRUE.
       CALL READLINE(UNITC,STR,2,EOF)
       IF(EOF)RETURN
    ELSE
       STR=STR(NPOS:)
    ENDIF
    STR=ADJUSTL(STR)
    IF(LEN_TRIM(STR)==0)RETURN
    ! comment on line
    IF(STR(1:1)=='#'.OR.STR(1:1)=='!')THEN
       NPOS=1
       RETURN
    ENDIF
    ! look for = after keyword
    KEYEND=SCAN(STR,'= ')-1
    IF(KEYEND==-1)GOTO 3
    POS=SCAN(STR,'=')+1
    STR(POS:)=ADJUSTL(STR(POS:))
    CALL SCANVALUE(UNITC,STR(POS:),NPOS,LISTLEN)
    IF(NPOS/=1)THEN
       NPOS=NPOS+POS-1
    ENDIF
    DO I=1,SIZE(ICONSTANTS)
       IF(STR(1:KEYEND)==TRIM(ICONSTANTS(I)))THEN
          READ(STR(POS:),*,ERR=3)IC
          SELECT CASE(I)
          CASE(1)
             NDIM=IC
          CASE(2)
             IPS=IC
          CASE(3)
             ILP=IC
          CASE(4)
             NTST=IC
          CASE(5)
             NCOL=IC
          CASE(6)
             IAD=IC
          CASE(7)
             IADS=IC
          CASE(8)
             ISP=IC
          CASE(9)
             ISW=IC
          CASE(10)
             IPLT=IC
          CASE(11)
             NBC=IC
          CASE(12)
             NINT=IC
          CASE(13)
             NMX=IC
          CASE(14)
             NPR=IC
          CASE(15)
             MXBF=IC
          CASE(16)
             IID=IC
          CASE(17)
             ITMX=IC
          CASE(18)
             ITNW=IC
          CASE(19)
             NWTN=IC
          CASE(20)
             JAC=IC
          CASE(21)
             NPAR=IC
          CASE(22)
             IBR=IC
          CASE(23)
             LAB=IC
          CASE(24)
             IIS=IC
          END SELECT
          RETURN
       ENDIF
    ENDDO
    DO I=1,SIZE(RCONSTANTS)
       IF(STR(1:KEYEND)==TRIM(RCONSTANTS(I)))THEN
          READ(STR(POS:),*,ERR=3)RC
          SELECT CASE(I)
          CASE(1)
             DS=RC
          CASE(2)
             DSMIN=RC
          CASE(3)
             DSMAX=RC
          CASE(4)
             RL0=RC
          CASE(5)
             RL1=RC
          CASE(6)
             A0=RC
          CASE(7)
             A1=RC
          CASE(8)
             EPSL=RC
          CASE(9)
             EPSU=RC
          CASE(10)
             EPSS=RC
          END SELECT
          RETURN
       ENDIF
    ENDDO
    SELECT CASE(STR(1:KEYEND))
    CASE('IRS')
       READ(STR(POS:),*,ERR=3)SIRS
       READ(SIRS,*,IOSTAT=ios)IRS
       IF(ios/=0)IRS=1
    CASE('ICP')
       NICP=LISTLEN
       DEALLOCATE(ICU)
       ALLOCATE(ICU(NICP))
       READ(STR(POS:),*,ERR=3)ICU            
    CASE('UZR','UZSTOP')
       ALLOCATE(IVUZRS(LISTLEN))
       READ(STR(POS:),*,ERR=3)IVUZRS
       IF(STR(1:KEYEND)=='UZSTOP')THEN
          DO I=1,SIZE(IVUZSTOP)
             DEALLOCATE(IVUZSTOP(I)%VAR)
          ENDDO
          DEALLOCATE(IVUZSTOP)
          ALLOCATE(IVUZSTOP(LISTLEN))
       ELSE
          DO I=1,SIZE(IVUZR)
             DEALLOCATE(IVUZR(I)%VAR)
          ENDDO
          DEALLOCATE(IVUZR)
          ALLOCATE(IVUZR(LISTLEN))
       ENDIF
       DO I=1,LISTLEN
          PREV=' '
          LISTLEN2=0
          DO J=1,LEN_TRIM(IVUZRS(I)%STRL)
             C=IVUZRS(I)%STRL(J:J)
             IF(C/=' '.AND.C/=','.AND.(PREV==' '.OR.PREV==','))THEN
                LISTLEN2=LISTLEN2+1
             ENDIF
             PREV=C
          ENDDO
          IF(STR(1:KEYEND)=='UZSTOP')THEN
             ALLOCATE(IVUZSTOP(I)%VAR(LISTLEN2))
             IVUZSTOP(I)%INDEX=IVUZRS(I)%INDEX
             READ(IVUZRS(I)%STRL,*,ERR=3)IVUZSTOP(I)%VAR
          ELSE
             ALLOCATE(IVUZR(I)%VAR(LISTLEN2))
             IVUZR(I)%INDEX=IVUZRS(I)%INDEX
             READ(IVUZRS(I)%STRL,*,ERR=3)IVUZR(I)%VAR
          ENDIF
       ENDDO
       DEALLOCATE(IVUZRS)
    CASE('THL')
       IF(ALLOCATED(IVTHL))DEALLOCATE(IVTHL)
       ALLOCATE(IVTHL(LISTLEN))
       READ(STR(POS:),*,ERR=3)IVTHL
    CASE('THU')
       DEALLOCATE(IVTHU)
       ALLOCATE(IVTHU(LISTLEN))
       READ(STR(POS:),*,ERR=3)IVTHU
    CASE('SP')
       IF(ALLOCATED(SP))DEALLOCATE(SP)
       ALLOCATE(SP(LISTLEN))
       READ(STR(POS:),*,ERR=3)SP
    CASE('STOP')
       IF(ALLOCATED(STOPS))DEALLOCATE(STOPS)
       ALLOCATE(STOPS(LISTLEN))
       READ(STR(POS:),*,ERR=3)STOPS
    CASE('PAR')
       IF(ALLOCATED(PARVALS))DEALLOCATE(PARVALS)
       ALLOCATE(PARVALS(LISTLEN))
       READ(STR(POS:),*,ERR=3)PARVALS
    CASE('U')
       IF(ALLOCATED(UVALS))DEALLOCATE(UVALS)
       ALLOCATE(UVALS(LISTLEN))
       READ(STR(POS:),*,ERR=3)UVALS
    CASE('parnames')
       IF(ALLOCATED(parnames))DEALLOCATE(parnames)
       ALLOCATE(parnames(LISTLEN))
       READ(STR(POS:),*,ERR=3)parnames
    CASE('unames')
       IF(ALLOCATED(unames))DEALLOCATE(unames)
       ALLOCATE(unames(LISTLEN))
       READ(STR(POS:),*,ERR=3)unames
    CASE('s')
       READ(STR(POS:),*)SFILE
       IF(TRIM(SFILE)=='/')THEN
          ! special case from Python interface: s='/' is followed on
          ! the next lines by the solution
          EOF=.TRUE.
          RETURN
       ENDIF
    CASE('dat')
       READ(STR(POS:),*)DATFILE
    CASE('sv')
       READ(STR(POS:),*)SVFILE
    CASE('e')
       READ(STR(POS:),*)EFILE
    CASE('TY')
       READ(STR(POS:),*,ERR=3)TY
    CASE DEFAULT
       IERR=1
    END SELECT
    RETURN
3   IERR=3
  END SUBROUTINE READC

! ---------- --------
  SUBROUTINE READLINE(UNITC,STR,NPOS,EOF)

! reads a line from unit unitc into str(npos:), replacing tabs with spaces
! in str(:) where appropriate

    INTEGER, INTENT(IN) :: UNITC, NPOS
    CHARACTER(*), INTENT(INOUT) :: STR
    LOGICAL, INTENT(OUT) :: EOF

    CHARACTER(LEN=1) :: C,QUOTE
    LOGICAL :: QUOTEESC
    INTEGER :: ios, I

    EOF=.FALSE.
    READ(UNITC,'(A)',IOSTAT=ios) STR(NPOS:)
    IF(ios/=0)THEN
       EOF=.TRUE.
       RETURN
    ENDIF
    QUOTE=' '
    QUOTEESC=.FALSE.
    DO I=1,LEN_TRIM(STR)
       C=STR(I:I)
       IF(QUOTE==' ')THEN
          ! replace a tab with spaces if not in a string
          IF(IACHAR(C)==9)THEN
             STR(I:I)=' '
          ELSEIF(C=="'".OR.C=='"')THEN
             QUOTE=STR(I:I)
          ENDIF
       ELSEIF(C==QUOTE)THEN
          ! ignore "" and ''
          IF(STR(I+1:I+1)==C.OR.QUOTEESC)THEN
             QUOTEESC=.NOT.QUOTEESC
          ELSE
             QUOTE=' '
          ENDIF
       ENDIF
    ENDDO
  END SUBROUTINE READLINE

! ---------- ---------
  SUBROUTINE SCANVALUE(UNITC,STR,NPOS,LISTLEN)
    IMPLICIT NONE

!   Scans STR(:) for a value
!   NPOS points to the next keyword on the same line,
!     or is set to 1 if there is none
!   LISTLEN gives the number of items in lists delimited by [] or {}
!   [] characters are removed

    INTEGER, INTENT(IN) :: UNITC
    CHARACTER(*), INTENT(INOUT) :: STR
    INTEGER, INTENT(OUT) :: NPOS,LISTLEN

    INTEGER I,LEVEL,LENSTR
    CHARACTER(1) C,PREV,QUOTE
    LOGICAL QUOTEESC,ISDICT,EOF
    LISTLEN=1
    LEVEL=0
    QUOTE=' '
    QUOTEESC=.FALSE.
    PREV=' '

    NPOS=1
    ISDICT=.FALSE.
    LENSTR=LEN_TRIM(STR)
    I=1
    DO
       IF(I>LENSTR)THEN
          IF(LEVEL==0)EXIT
          LENSTR=LEN_TRIM(STR)
          CALL READLINE(UNITC,STR(LENSTR+1:),1,EOF)
          IF(EOF)EXIT
          LENSTR=LEN_TRIM(STR)
       ENDIF
       NPOS=I
       C=STR(I:I)
       IF(QUOTE==' ')THEN
          SELECT CASE(C)
          CASE(',',' ')
             IF(LEVEL==0)EXIT
             IF(PREV==':'.OR.PREV=='['.OR.PREV=='{')C=PREV
             !eat ',' and ' ' after ':', '[', or '{'
          CASE(':')
             STR(I:I)=','
          CASE(']','}')
             IF(C=='}') ISDICT=.FALSE.
             STR(I:I)=' '
             IF(LEVEL==1.AND.(PREV=='['.OR.PREV=='{'))LISTLEN=0
             LEVEL=LEVEL-1
             IF(C==']'.AND.ISDICT) STR(I:I)="'"
          CASE DEFAULT
             IF((PREV==','.OR.PREV==' ').AND.LEVEL==1)THEN
                LISTLEN=LISTLEN+1
             ENDIF
             SELECT CASE(C)
             CASE('[','{')
                STR(I:I)=' '
                LEVEL=LEVEL+1
                IF(C=='{')THEN
                   ISDICT=.TRUE.
                ELSEIF(ISDICT)THEN
                   STR(I:I)="'"
                ENDIF
             CASE('"',"'")
                QUOTE=C
             END SELECT
          END SELECT
       ELSEIF(C==QUOTE)THEN
          ! ignore "" and ''
          IF(STR(I+1:I+1)==C.OR.QUOTEESC)THEN
             QUOTEESC=.NOT.QUOTEESC
          ELSE
             QUOTE=' '
          ENDIF
       ENDIF
       PREV=C
       I=I+1
    ENDDO
    I=VERIFY(STR(NPOS:)," ,")
    IF(I==0)THEN
       NPOS=1
    ELSE
       NPOS=NPOS+I-1
       IF(NPOS>=LEN_TRIM(STR))NPOS=1
    ENDIF
  END SUBROUTINE SCANVALUE

! ------- -------- -----------
  INTEGER FUNCTION READINTEGER(UNITC,C,IERR)

    ! read arbitrary positive integer from unit 2 without advancing
    ! input, to work around advance='no' restriction for list-directed
    ! input.
    ! on output: C contains the last-read character
    ! ierr:-1: no problems and number read
    !       0: no number read
    !       3: error reading
    !       4: eof
    INTEGER, INTENT(IN) :: UNITC
    CHARACTER(1), INTENT(OUT) :: C
    INTEGER, INTENT(OUT) :: IERR

    INTEGER N

    READINTEGER = 0

    N = 0
    IERR = 0
    DO
       READ(UNITC,'(A1)',ERR=3,END=4,EOR=5,ADVANCE='NO')C
       IF(IERR==0.AND.(IACHAR(C)==9.OR.C==' '))CYCLE
       IF(LLT(C, '0').OR.LGT(C, '9'))EXIT
       IERR = -1
       N = N*10 + IACHAR(C) - IACHAR('0')
    ENDDO
    READINTEGER = N
    RETURN

3   IERR = 3
    RETURN

4   IERR = 4
5   RETURN

  END FUNCTION READINTEGER

! ---------- --------
  SUBROUTINE READOLDC(UNITC,N,EOF,LINE,IERR)

! Reads the continuation constants in the old format
    USE AUTO_CONSTANTS

    INTEGER I
    INTEGER NUZR,NICP
    INTEGER LISTLEN,ios
    CHARACTER(1) C

    INTEGER, INTENT(IN) :: UNITC, N
    LOGICAL, INTENT(INOUT) :: EOF
    INTEGER, INTENT(INOUT) :: LINE
    INTEGER, INTENT(OUT) :: IERR

    NDIM=N
    READ(UNITC,*,ERR=3,END=4) IPS,SIRS,ILP
    READ(SIRS,*,IOSTAT=ios)IRS
    IF(ios/=0)IRS=1
    LINE=LINE+1
    LISTLEN=READINTEGER(UNITC,C,IERR)
    IF(IERR==0.OR.IERR==3)GOTO 3
    IF(IERR==4)GOTO 4
    DEALLOCATE(ICU)
    NICP=LISTLEN
    IF(LISTLEN==0)NICP=1
    ALLOCATE(ICU(NICP))
    ICU(1)='1'
    READ(UNITC,*,ERR=3,END=4) (ICU(I),I=1,LISTLEN)
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) NMX,RL0,RL1,A0,A1
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) NPR,MXBF,IID,ITMX,ITNW,NWTN,JAC
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) EPSL,EPSU,EPSS
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) DS,DSMIN,DSMAX,IADS
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) LISTLEN
    !allocate: no THL vs. non-allocated:default THL (in SUB. INIT1)
    IF(ALLOCATED(IVTHL))DEALLOCATE(IVTHL)
    ALLOCATE(IVTHL(LISTLEN))
    IF(LISTLEN>0)THEN
       DO I=1,LISTLEN
          LINE=LINE+1
          READ(UNITC,*,ERR=3,END=4)IVTHL(I)
       ENDDO
    ENDIF
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4) LISTLEN
    IF(LISTLEN>0)THEN
       DEALLOCATE(IVTHU)
       ALLOCATE(IVTHU(LISTLEN))
       DO I=1,LISTLEN
          LINE=LINE+1
          READ(UNITC,*,ERR=3,END=4)IVTHU(I)
       ENDDO
    ENDIF
    LINE=LINE+1
    READ(UNITC,*,ERR=3,END=4)NUZR
    IF(NUZR>0)THEN
       DO I=1,SIZE(IVUZR)
          DEALLOCATE(IVUZR(I)%VAR)
       ENDDO
       DEALLOCATE(IVUZR)
       ALLOCATE(IVUZR(NUZR))
       DO I=1,NUZR
          LINE=LINE+1
          ALLOCATE(IVUZR(I)%VAR(1))
          READ(UNITC,*,ERR=3,END=4)IVUZR(I)%INDEX,IVUZR(I)%VAR(1)
       ENDDO
    ENDIF
    IERR=-1
    RETURN

3   IERR=3
    RETURN

4   WRITE(6,"(A,I2,A)") &
         " Error in fort.2 or c. file: ends prematurely on line ", LINE,"."
    EOF=.TRUE.

  END SUBROUTINE READOLDC
    
! ---------- ----
  SUBROUTINE STHD(AP,ICP)

    USE COMPAT
    USE SUPPORT, ONLY: LBTYPE
    USE AUTO_CONSTANTS, ONLY : IVTHL, IVTHU, IVUZR, IVUZSTOP, unames, parnames,&
         NDIM, IRS, ILP, ISP, ISW, NBC, NINT, NMX, DS, DSMIN, DSMAX, ICU,&
         EFILE, SVFILE, SFILE, DATFILE, HCONST, NPAR, UVALS, PARVALS, SP, &
         STOPS, IBR, LAB, TY

! Write the values of the user defined parameters on unit 7.
! This identifying information is preceded by a '   0' on each line.
! The first line in the file contains the (generally) user-supplied
! limits of the bifurcation diagram, viz. RL0,RL1,A0 and A1.
! These are often convenient for an initial plot of the diagram.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    CHARACTER (LEN=*), PARAMETER :: D3 = "('   0',3(A8,ES11.4))"
    CHARACTER (LEN=*), PARAMETER :: I4 = "('   0',4(A8,I4))"
    CHARACTER (LEN=*), PARAMETER :: I5 = "('   0',2(A7,I5),3(A8,I4))"
    CHARACTER (LEN=*), PARAMETER :: I6 = "('   0',5(A8,I4))"
    INTEGER NDIMA,IPS,IRSA,ILPA,NTST,NCOL,IAD,IADS,ISPA,ISWA,IPLT,NBCA,NINTA
    INTEGER NMXA,NUZR,NPR,MXBF,IIS,IID,ITMX,ITNW,NWTN,JAC,NFPR,I,NPARA
    INTEGER ITPST,LSV,LDAT,LE,LS,INDX,io
    DOUBLE PRECISION DSA,DSMINA,DSMAXA,RL0,RL1,A0,A1,EPSL,EPSU,EPSS
    CHARACTER(LEN=11) :: SDS, SDSA, SDSMAX, SDSMAXA, SDSMIN, SDSMINA
    CHARACTER(LEN=12) :: INDSTR
    CHARACTER(LEN=13) :: name

    INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
    COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV

    NDIMA=AP%NDIM
    IPS=AP%IPS
    IRSA=AP%IRS
    ILPA=AP%ILP
    NTST=AP%NTST
    NCOL=AP%NCOL
    IAD=AP%IAD
    IADS=AP%IADS
    ISPA=AP%ISP
    ISWA=AP%ISW
    IPLT=AP%IPLT
    NBCA=AP%NBC
    NINTA=AP%NINT
    NMXA=AP%NMX
    NUZR=AP%NUZR
    NPR=AP%NPR
    MXBF=AP%MXBF
    IIS=AP%IIS
    IID=AP%IID
    ITMX=AP%ITMX
    ITNW=AP%ITNW
    NWTN=AP%NWTN
    JAC=AP%JAC
    ITPST=AP%ITPST
    NFPR=AP%NFPR
    NPARA=AP%NPAR

    DSA=AP%DS
    DSMINA=AP%DSMIN
    DSMAXA=AP%DSMAX
    RL0=AP%RL0
    RL1=AP%RL1
    A0=AP%A0
    A1=AP%A1
    EPSL=AP%EPSL
    EPSU=AP%EPSU
    EPSS=AP%EPSS

    WRITE(7,"(I4,' ',4ES12.4)")0,RL0,RL1,A0,A1
    WRITE(7,D3)'EPSL=',EPSL,'EPSU =',EPSU, 'EPSS =',EPSS
    WRITE(7,D3)'DS  =',DSA,  'DSMIN=',DSMINA,'DSMAX=',DSMAXA
    WRITE(7,I4)'NDIM=',NDIMA,'IPS =',IPS, 'IRS =',IRSA, 'ILP =',ILPA
    WRITE(7,I4)'NTST=',NTST,'NCOL=',NCOL,'IAD =',IAD, 'ISP =',ISPA
    WRITE(7,I4)'ISW =',ISWA, 'IPLT=',IPLT,'NBC =',NBCA, 'NINT=',NINTA
    WRITE(7,I5)' NMX=',NMXA, 'NPR=', NPR, 'MXBF=',MXBF,'IID =',IID, 'IADS=',IADS
    WRITE(7,I6)'ITMX=',ITMX,'ITNW=',ITNW,'NWTN=',NWTN,'JAC =',JAC,'  NUZR=',NUZR

    IF(IBR>0.OR.LAB>0.OR.LEN_TRIM(TY)>0.OR.IIS<3)THEN
       WRITE(7,"('   0')",ADVANCE="NO")
       IF(IIS<3)THEN
          WRITE(7,"(A8,I4)",ADVANCE="NO")"IIS =",IIS
       ENDIF
       IF(IBR>0)THEN
          WRITE(7,"(A8,I4)",ADVANCE="NO")"IBR =",IBR
       ENDIF
       IF(LAB>0)THEN
          WRITE(7,"(A8,I4)",ADVANCE="NO")"LAB =",LAB
       ENDIF
       IF(LEN_TRIM(TY)>0)THEN
          WRITE(7,"(A9,A,A)",ADVANCE="NO")"TY = '",TRIM(TY),"'"
       ENDIF
       WRITE(7,*)
    ENDIF
    WRITE(7,"(A,I4,A)",ADVANCE="NO")"   0   NPAR=",NPARA
    CALL WRITELIST("   THL = ",IVTHL)
    CALL WRITELIST("    THU = ",IVTHU)
    WRITE(7,*)
    IF(SIZE(IVUZR)>0)THEN
       CALL WRITEUZRLIST("   0   UZR = ",IVUZR)
       WRITE(7,*)
    ENDIF
    IF(SIZE(IVUZSTOP)>0)THEN
       CALL WRITEUZRLIST("   0   UZSTOP = ",IVUZSTOP)
       WRITE(7,*)
    ENDIF
    IF(IPS==9)THEN
       !homcont constants
       WRITE(7,"('   0   ',2(A,I4),2(A8,I2),(A8,I4))") &
            'NUNSTAB=',NUNSTAB,' NSTAB=',NSTAB,&
            'IEQUIB=',HCONST%IEQUIB,'ITWIST=',HCONST%ITWIST,&
            'ISTART=',ISTART
       IF(SIZE(HCONST%IREV)>0.OR.SIZE(HCONST%IFIXED)>0.OR.&
            SIZE(HCONST%IPSI)>0)THEN
          WRITE(7,"('   0  ')",ADVANCE='NO')
          CALL WRITEINTLIST(" IREV=",HCONST%IREV)
          CALL WRITEINTLIST(" IFIXED=",HCONST%IFIXED)
          CALL WRITEINTLIST(" IPSI=",HCONST%IPSI)
          WRITE(7,*)
       ENDIF
    ENDIF
    LE=LEN_TRIM(EFILE)
    LSV=LEN_TRIM(SVFILE)
    LS=LEN_TRIM(SFILE)
    LDAT=LEN_TRIM(DATFILE)
    IF(LE>0.OR.LSV>0.OR.LS>0.OR.LDAT>0)THEN
       WRITE(7,"('   0  ')",ADVANCE="NO")
       IF(LE>0)THEN
          WRITE(7,"(A,A,A)",ADVANCE="NO")" e = '",TRIM(EFILE),"'"
       ENDIF
       IF(LS>0)THEN
          WRITE(7,"(A,A,A)",ADVANCE="NO")" s = '",TRIM(SFILE),"'"
       ENDIF
       IF(LDAT>0)THEN
          WRITE(7,"(A,A,A)",ADVANCE="NO")" dat = '",TRIM(DATFILE),"'"
       ENDIF
       IF(LSV>0)THEN
          WRITE(7,"(A,A,A)",ADVANCE="NO")" sv = '",TRIM(SVFILE),"'"
       ENDIF
       WRITE(7,*)
    ENDIF
    IF(SIZE(parnames)>0)THEN
       CALL WRITESTRLIST("   0   parnames = ",parnames)
       WRITE(7,*)
    ENDIF
    IF(SIZE(unames)>0)THEN
       CALL WRITESTRLIST("   0   unames   = ",unames)
       WRITE(7,*)
    ENDIF
    IF(SIZE(PARVALS)>0)THEN
       CALL WRITELIST("   0   PAR     = ",PARVALS)
       WRITE(7,*)
    ENDIF
    IF(SIZE(UVALS)>0)THEN
       CALL WRITELIST("   0   U       = ",UVALS)
       WRITE(7,*)
    ENDIF
    IF(SIZE(SP)>0)THEN
       WRITE(7,"(A,A,A)", ADVANCE="NO")"   0   SP=['",TRIM(SP(1)),"'"
       DO I=2,SIZE(SP)
          WRITE(7,"(A,A,A)", ADVANCE="NO")", '",TRIM(SP(I)),"'"
       ENDDO
       WRITE(7,"(A)")']'
    ENDIF
    IF(SIZE(STOPS)>0)THEN
       WRITE(7,"(A,A,A)", ADVANCE="NO")"   0   STOP=['",TRIM(STOPS(1)),"'"
       DO I=2,SIZE(STOPS)
          WRITE(7,"(A,A,A)", ADVANCE="NO")", '",TRIM(STOPS(I)),"'"
       ENDDO
       WRITE(7,"(A)")']'
    ENDIF

    WRITE(SDS,    "(ES11.4)")DS
    WRITE(SDSA,   "(ES11.4)")DSA
    WRITE(SDSMIN, "(ES11.4)")DSMIN
    WRITE(SDSMINA,"(ES11.4)")DSMINA
    WRITE(SDSMAX, "(ES11.4)")DSMAX
    WRITE(SDSMAXA,"(ES11.4)")DSMAXA

    IF(SDS/=SDSA.OR.SDSMIN/=SDSMINA.OR.SDSMAX/=SDSMAXA.OR. &
       NDIM/=NDIMA.OR.IRS/=IRSA.OR.ILP/=ILPA.OR.NPAR/=NPARA.OR. &
       NMX/=NMXA.OR.ISP/=ISPA.OR.ISW/=ISWA.OR.NBC/=NBCA.OR.NINT/=NINTA)THEN
       WRITE(7,"('   0   User-specified constants, where different from above:')")
       IF(SDS/=SDSA.OR.SDSMIN/=SDSMINA.OR.SDSMAX/=SDSMAXA)THEN
          WRITE(7,"('   0')", ADVANCE="NO")
          IF(SDS/=SDSA)THEN
             WRITE(7, "(A8,A)", ADVANCE="NO")'DS  =',SDS
          ENDIF
          IF(SDSMIN/=SDSMINA)THEN
             WRITE(7, "(A8,A)", ADVANCE="NO")'DSMIN=',SDSMIN
          ENDIF
          IF(SDSMAX/=SDSMAXA)THEN
             WRITE(7, "(A8,A)", ADVANCE="NO")'DSMAX=',SDSMAX
          ENDIF
          WRITE(7,*)
       ENDIF
       IF(NDIM/=NDIMA.OR.IRS/=IRSA.OR.ILP/=ILPA.OR.NPAR/=NPARA)THEN
          WRITE(7,"('   0')", ADVANCE="NO")
          IF(NDIM/=NDIMA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'NDIM=',NDIM
          ENDIF
          IF(IRS/=IRSA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'IRS =',IRS
          ENDIF
          IF(ILP/=ILPA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'ILP =',ILP
          ENDIF
          IF(NPAR/=NPARA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'NPAR=',NPAR
          ENDIF
          WRITE(7,*)
       ENDIF
       IF(NMX/=NMXA.OR.ISP/=ISPA.OR.ISW/=ISWA.OR.NBC/=NBCA.OR.NINT/=NINTA)THEN
          WRITE(7,"('   0')", ADVANCE="NO")
          IF(NMX/=NMXA)THEN
             WRITE(7, "(A7,I5)", ADVANCE="NO")'NMX=',NMX
          ENDIF
          IF(ISP/=ISPA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'ISP =',ISP
          ENDIF
          IF(ISW/=ISWA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'ISW =',ISW
          ENDIF
          IF(NBC/=NBCA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'NBC =',NBC
          ENDIF
          IF(NINT/=NINTA)THEN
             WRITE(7, "(A8,I4)", ADVANCE="NO")'NINT=',NINT
          ENDIF
          WRITE(7,*)
       ENDIF
    ENDIF
    IF(IPS==9.AND.(NUNSTAB/=HCONST%NUNSTAB.OR.NSTAB/=HCONST%NSTAB.OR. &
         ISTART/=HCONST%ISTART))THEN
       !homcont constants
       WRITE(7,"('   0   ')", ADVANCE="NO")
       IF(NUNSTAB/=HCONST%NUNSTAB)THEN
          WRITE(7,"(A,I4)", ADVANCE="NO")'NUNSTAB=',HCONST%NUNSTAB
       ENDIF
       IF(NSTAB/=HCONST%NSTAB)THEN
          WRITE(7,"(A,I4)", ADVANCE="NO")' NSTAB=',HCONST%NSTAB
       ENDIF
       IF(ISTART/=HCONST%ISTART)THEN
          WRITE(7,"(A8,I4)", ADVANCE="NO")'ISTART=',HCONST%ISTART
       ENDIF
       WRITE(7,*)
    ENDIF

    WRITE(7,"('   0   User-specified parameter')",ADVANCE="NO")
    IF(SIZE(ICU).EQ.1)THEN
       WRITE(7,"(':       ')",ADVANCE="NO")
    ELSE
       WRITE(7,"('s:      ')",ADVANCE="NO")
    ENDIF
    DO I=1,SIZE(ICU)
       READ(ICU(I),*,IOSTAT=io)INDX
       IF(io==0)THEN
          WRITE(7,"(3X,A)",ADVANCE="NO")TRIM(ICU(I))
       ELSE
          WRITE(7,"(A,A,A)",ADVANCE="NO")" '",TRIM(ICU(I)),"'"
       ENDIF
    ENDDO
    WRITE(7,"(/'   0   Active continuation parameter')",ADVANCE="NO")
    IF(NFPR.EQ.1)THEN
       WRITE(7,"(':  ')",ADVANCE="NO")
    ELSE
       WRITE(7,"('s: ')",ADVANCE="NO")
    ENDIF
    DO I=1,NFPR
       name = getname(parnames, ICP(I))
       IF (LEN_TRIM(name)>0) THEN
          WRITE(7,"(A,A,A)",ADVANCE="NO")" '",TRIM(name),"'"
       ELSE
          WRITE(INDSTR,"(I12)")ICP(I)
          WRITE(7,"(3X,A)",ADVANCE="NO")TRIM(ADJUSTL(INDSTR))
       ENDIF
    ENDDO
    WRITE(7,*)

    IF(ITPST /= 0)THEN
       WRITE(7,"('   0   Branch type: ',I2,A,A,A)")&
            ITPST,"    TY = '",LBTYPE(ITPST),"'"
    ENDIF

    CALL AUTOFLUSH(7)

  CONTAINS

    SUBROUTINE WRITELIST(NAME,IVLIST)
      USE AUTO_CONSTANTS, ONLY: INDEXVAR
      CHARACTER(LEN=*), INTENT(IN) :: NAME
      TYPE(INDEXVAR), INTENT(IN) :: IVLIST(:)
      
      LOGICAL FIRST
      CHARACTER(LEN=15) :: INDSTR
      INTEGER INDX,io
      CHARACTER(LEN=19) :: VARSTR

      WRITE(7,"(A,A)", ADVANCE="NO")NAME,'{'
      FIRST=.TRUE.
      DO I=1,SIZE(IVLIST)
         IF(.NOT.FIRST)WRITE(7,"(A)", ADVANCE="NO")", "
         READ(IVLIST(I)%INDEX,*,IOSTAT=io)INDX
         IF(io==0)THEN
            INDSTR=IVLIST(I)%INDEX
         ELSE
            INDSTR="'"//TRIM(IVLIST(I)%INDEX)//"'"
         ENDIF
         IF(INT(IVLIST(I)%VAR)==IVLIST(I)%VAR)THEN
            WRITE(VARSTR,'(I19)')INT(IVLIST(I)%VAR)
         ELSE
            WRITE(VARSTR,'(ES19.10E3)')IVLIST(I)%VAR
         ENDIF
         WRITE(7,"(A,A,A)", ADVANCE="NO")TRIM(INDSTR),&
              ": ",TRIM(ADJUSTL(VARSTR))
         FIRST=.FALSE.
      ENDDO
      WRITE(7,"(A)", ADVANCE="NO")'}'
    END SUBROUTINE WRITELIST

    SUBROUTINE WRITEUZRLIST(NAME,IVLIST)
      USE AUTO_CONSTANTS, ONLY: INDEXMVAR
      CHARACTER(LEN=*), INTENT(IN) :: NAME
      TYPE(INDEXMVAR), INTENT(IN) :: IVLIST(:)
      
      LOGICAL FIRST
      CHARACTER(LEN=15) :: INDSTR
      INTEGER INDX,I,J,io
      CHARACTER(LEN=19) :: VARSTR
      DOUBLE PRECISION V

      WRITE(7,"(A,A)", ADVANCE="NO")NAME,'{'
      FIRST=.TRUE.
      DO I=1,SIZE(IVLIST)
         IF(.NOT.FIRST)WRITE(7,"(A)", ADVANCE="NO")", "
         READ(IVLIST(I)%INDEX,*,IOSTAT=io)INDX
         IF(io==0)THEN
            INDSTR=IVLIST(I)%INDEX
         ELSE
            INDSTR="'"//TRIM(IVLIST(I)%INDEX)//"'"
         ENDIF
         WRITE(7,"(A,A)", ADVANCE="NO")TRIM(INDSTR),": "
         IF(SIZE(IVLIST(I)%VAR)>1)WRITE(7,"(A)", ADVANCE="NO")'['
         DO J=1,SIZE(IVLIST(I)%VAR)
            IF(J>1)WRITE(7,"(A)", ADVANCE="NO")", "
            V=IVLIST(I)%VAR(J)
            IF(INT(V)==V)THEN
               WRITE(VARSTR,'(I19)')INT(V)
            ELSE
               WRITE(VARSTR,'(ES19.10E3)')V
            ENDIF
            WRITE(7,"(A)", ADVANCE="NO")TRIM(ADJUSTL(VARSTR))
         ENDDO
         IF(SIZE(IVLIST(I)%VAR)>1)WRITE(7,"(A)", ADVANCE="NO")']'
         FIRST=.FALSE.
      ENDDO
      WRITE(7,"(A)", ADVANCE="NO")'}'
    END SUBROUTINE WRITEUZRLIST

    SUBROUTINE WRITESTRLIST(NAME,ISLIST)
      USE AUTO_CONSTANTS, ONLY: INDEXSTR
      CHARACTER(LEN=*), INTENT(IN) :: NAME
      TYPE(INDEXSTR), INTENT(IN) :: ISLIST(:)
      
      LOGICAL FIRST
      CHARACTER(LEN=15) :: INDSTR

      WRITE(7,"(A,A)", ADVANCE="NO")NAME,'{'
      FIRST=.TRUE.
      DO I=1,SIZE(ISLIST)
         IF(.NOT.FIRST)WRITE(7,"(A)", ADVANCE="NO")", "
         WRITE(INDSTR,'(I15)')ISLIST(I)%INDEX
         WRITE(7,"(A,A,A,A)", ADVANCE="NO")TRIM(ADJUSTL(INDSTR)), &
              ": '",TRIM(ISLIST(I)%STR),"'"
         FIRST=.FALSE.
      ENDDO
      WRITE(7,"(A)", ADVANCE="NO")'}'
    END SUBROUTINE WRITESTRLIST

    SUBROUTINE WRITEINTLIST(NAME,ILIST)
      USE AUTO_CONSTANTS, ONLY: INDEXVAR
      CHARACTER(LEN=*), INTENT(IN) :: NAME
      INTEGER, INTENT(IN) :: ILIST(:)
      
      LOGICAL FIRST
      CHARACTER(LEN=12) :: INDSTR

      IF (SIZE(ILIST) == 0) RETURN
      WRITE(7,"(A,A)", ADVANCE="NO")NAME,'['
      FIRST=.TRUE.
      DO I=1,SIZE(ILIST)
         IF(.NOT.FIRST)WRITE(7,"(A)", ADVANCE="NO")", "
         WRITE(INDSTR,'(I12)')ILIST(I)
         WRITE(7,"(A)", ADVANCE="NO")TRIM(ADJUSTL(INDSTR))
         FIRST=.FALSE.
      ENDDO
      WRITE(7,"(A)", ADVANCE="NO")']'
    END SUBROUTINE WRITEINTLIST

  END SUBROUTINE STHD

! ---------- ------
  SUBROUTINE HEADNG(AP,ICP,IUNIT,N1,N2)

    USE COMPAT
    USE AUTO_CONSTANTS, ONLY : unames, parnames

! Prints headings above columns on unit 6, 7, and 9.
! N1 = number of parameters to print (maximum: 7 for screen output)
! N2 = number of (max) variables to print (maximum: max(0,7-N1,7))

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),IUNIT,N1,N2
! Local
    INTEGER I,J,IPS,IPLT,NDM
    CHARACTER(LEN=13) name

    IPS=AP%IPS
    IPLT=AP%IPLT
    NDM=AP%NDM

    IF(IUNIT.EQ.7)THEN
       WRITE(7,"(I4/I4,A)",ADVANCE="NO")0,0,'    PT  TY  LAB '
    ELSE
       WRITE(IUNIT,"(/A)",ADVANCE="NO")'  BR    PT  TY  LAB '
    ENDIF

    DO J=1,N1+N2+1
       IF(J==1.OR.J>N2+2)THEN
          I=1
          IF(J>1)I=J-N2-1
          name = getname(parnames, ICP(I))
          IF(LEN_TRIM(name)>0)THEN
             CALL WRITECOL(-1,name)
          ELSEIF(ICP(I)==11.AND.IPS>0.AND.IPS/=4.AND.IPS/=7)THEN
             CALL WRITECOL(5,'PERIOD')
          ELSEIF(ICP(I)==10.AND.(IPS==5.OR.IPS==15))THEN
             CALL WRITECOL(6,'FOPT')
          ELSEIF(ICP(I)==14.AND.(IPS==14.OR.IPS==16))THEN
             CALL WRITECOL(6,'TIME')
          ELSE
             CALL WRITECOL(4,'PAR',ICP(I))
          ENDIF
       ELSEIF(J==2.AND.(IPLT==0.OR.IPLT<-NDM.OR.IPLT>3*NDM))THEN
          CALL WRITECOL(4,'L2-NORM')
       ELSEIF(J==2)THEN
          name = getname(unames, MOD(ABS(IPLT)-1,NDM)+1)
          IF(LEN_TRIM(name)>0)THEN
             IF(IPLT>NDM.AND.IPLT<=2*NDM) THEN
                CALL WRITECOL(-1, 'INTEGRAL ' // name)
             ELSE IF(IPLT>2*NDM.AND.IPLT<=3*NDM) THEN
                CALL WRITECOL(-1, 'L2-NORM '// name)
             ELSE IF(ABS(IPLT)<=NDM) THEN
                IF(IPS<=1.OR.IPS==5.OR.IPS==11)THEN
                   CALL WRITECOL(2, name)
                ELSE IF(IPLT>0)THEN
                   CALL WRITECOL(-1, 'MAX ' // name)
                ELSE
                   CALL WRITECOL(-1, 'MIN ' // name)
                ENDIF
             ENDIF
          ELSE
             IF(IPLT>NDM.AND.IPLT<=2*NDM) THEN
                CALL WRITECOL(2,'INTEGRAL U',IPLT-NDM)
             ELSE IF(IPLT>2*NDM.AND.IPLT<=3*NDM) THEN
                CALL WRITECOL(2,'L2-NORM U',IPLT-2*NDM)
             ELSE IF(IPLT/=0.AND.ABS(IPLT)<=NDM) THEN
                IF(IPS<=1.OR.IPS==5.OR.IPS==11)THEN
                   CALL WRITECOL(6,'U',ABS(IPLT))
                ELSE IF(IPLT>0)THEN
                   CALL WRITECOL(4,'MAX U',IPLT)
                ELSE
                   CALL WRITECOL(4,'MIN U',-IPLT)
                ENDIF
             ENDIF
          ENDIF
       ELSE !J>2 with N2>0
          name = getname(unames, J-2)
          IF(LEN_TRIM(name)>0)THEN
             IF(IPS<=1.OR.IPS==5.OR.IPS==11)THEN
                CALL WRITECOL(-1,name)
             ELSE
                CALL WRITECOL(-1,'MAX '//name)
             ENDIF
          ELSEIF(IPS<=1.OR.IPS==5.OR.IPS==11)THEN
             CALL WRITECOL(6,'U',J-2)
          ELSE
             CALL WRITECOL(4,'MAX U',J-2)
          ENDIF
       ENDIF

    ENDDO

    WRITE(IUNIT,"()")
    CALL AUTOFLUSH(IUNIT)

  CONTAINS

    SUBROUTINE WRITECOL(II,S,N)
      INTEGER, INTENT(IN) :: II
      CHARACTER(*), INTENT(IN) :: S
      INTEGER, INTENT(IN), OPTIONAL :: N
! Local
      CHARACTER(10) SN
      CHARACTER(19) COL
      INTEGER I
      COL=' '
      I=II
      IF(I==-1)THEN
         ! centre into the column
         I=MAX(7-(LEN_TRIM(S)-1)/2,2)
      ENDIF
      IF(PRESENT(N))THEN
         WRITE(SN,"(I10)")N
         WRITE(COL(I:),"(A,A,A,A)") S,'(',TRIM(ADJUSTL(SN)),')'
      ELSE
         WRITE(COL(I:),"(A)") TRIM(S)
      ENDIF
      IF(IUNIT.EQ.7)THEN
         WRITE(IUNIT,"(A19)",ADVANCE="NO")COL
      ELSE
         WRITE(IUNIT,"(A14)",ADVANCE="NO")COL
      ENDIF
    END SUBROUTINE WRITECOL
    
  END SUBROUTINE HEADNG

! ---------- ------
  SUBROUTINE WRLINE(AP,PAR,ICU,IBR,NTOT,LAB,VAXIS,U)

    USE COMPAT
    USE SUPPORT, ONLY: LBTYPE

! Write one line of output on unit 6 and 7.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICU(*),IBR,NTOT,LAB
    DOUBLE PRECISION, INTENT(IN) :: PAR(*),U(*),VAXIS
! Local
    CHARACTER(3) ATYPE
    CHARACTER(33) :: F69 ! (I4,I6,2X,A2,I5,**********ES14.5)
    CHARACTER(33) :: F7  ! (I4,I6,I4,I5,**********ES19.10E3)
    INTEGER MTOT,NDM,ITP,NICP,N1,N2,I

    NDM=AP%NDM
    ITP=AP%ITP
    NICP=AP%NICP

    N1=NICP
    N2=NDM

    IF(N1.GT.7)THEN
       N1=7
       N2=0
    ELSEIF(N1+N2.GT.7)THEN
       N2=7-N1
    ENDIF

! Write a heading above the first line.

    IF(ABS(NTOT).EQ.1)CALL HEADNG(AP,ICU,6,N1,N2)
    IF(ABS(NTOT).EQ.1)CALL HEADNG(AP,ICU,7,NICP,N2)
    IF(AP%IID>0)CALL HEADNG(AP,ICU,9,N1,N2)

    ATYPE=ADJUSTR(LBTYPE(ITP))

    IF(NTOT>0)THEN
       MTOT=MOD(NTOT-1,9999)+1
    ELSE
       MTOT=-MOD(-NTOT-1,9999)-1
    ENDIF
    WRITE(F69,"(A,I10,A)") '(I4,I6,1X,A3,I5,',N1+N2+1,'ES14.5)'
    WRITE(F7,"(A,I10,A)") '(I4,I6,I4,I5,',NICP+N2+1,'ES19.10E3)'
    IF(MOD(ITP,10).NE.0)THEN
       WRITE(6,F69)ABS(IBR),ABS(MTOT),ATYPE,LAB,PAR(ICU(1)),VAXIS, &
            (U(I),I=1,N2),(PAR(ICU(I)),I=2,N1)
       CALL AUTOFLUSH(6)
    ENDIF
    WRITE(7,F7)IBR,MTOT,ITP,LAB,PAR(ICU(1)),VAXIS, &
         (U(I),I=1,N2),(PAR(ICU(I)),I=2,NICP)
    CALL AUTOFLUSH(7)
    IF(AP%IID>0)WRITE(9,F69)IBR,MTOT,ATYPE,LAB,PAR(ICU(1)),VAXIS, &
         (U(I),I=1,N2),(PAR(ICU(I)),I=2,N1)
  END SUBROUTINE WRLINE

! ---------- -----
  SUBROUTINE WRBAR(C,N)

    CHARACTER(1), INTENT(IN) :: C
    INTEGER, INTENT(IN) :: N
    INTEGER I

    WRITE(9,101)(C,I=1,N)
101 FORMAT(80A1)
  END SUBROUTINE WRBAR

! ---------- ------
  SUBROUTINE NEWLAB(AP)

! Determine a suitable label when restarting.

    USE AUTO_CONSTANTS, ONLY: IBR
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP

    INTEGER IPS,IRS,ISW,ITP

    IPS=AP%IPS
    IRS=AP%IRS
    ISW=AP%ISW
    ITP=AP%ITP

    IF(AP%LAB.EQ.0)AP%LAB=MLAB+1
    IF(IBR.NE.0)RETURN
    IF(ISW.LT.0.OR.IRS.EQ.0)THEN
       AP%IBR=MBR+1
    ELSEIF( (ABS(ITP).LT.10.AND.ABS(ISW).EQ.2) &
         .OR. ((IPS.EQ.2.OR.IPS.EQ.12).AND.ITP.EQ.3) &
         .OR. (IPS.EQ.4.AND.ISW.EQ.2.AND.ABS(ITP).LT.10) &
         .OR. (IPS.EQ.5.AND.MOD(ITP,10).EQ.2) )THEN
       AP%IBR=IRS
    ENDIF

  END SUBROUTINE NEWLAB

! ------- -------- --------
  INTEGER FUNCTION GETNDIM3()
    GETNDIM3 = CURSOL%NAR-1
  END FUNCTION GETNDIM3

! ------- -------- --------
  INTEGER FUNCTION GETNTST3()
    GETNTST3 = CURSOL%NTST
  END FUNCTION GETNTST3

! ------- -------- --------
  INTEGER FUNCTION GETNCOL3()
    GETNCOL3 = CURSOL%NCOL
  END FUNCTION GETNCOL3

! ------- -------- --------
  INTEGER FUNCTION GETNFPR3()
    GETNFPR3 = CURSOL%NFPR
  END FUNCTION GETNFPR3

! ------- -------- --------
  INTEGER FUNCTION GETIPS3()
    GETIPS3 = CURSOL%IPS
  END FUNCTION GETIPS3

! ---------- ------
  SUBROUTINE FINDLB(AP,UNITC,IRS,NFPR,NPAR,FOUND)

    USE AUTO_CONSTANTS, ONLY: SIRS, SFILE
    USE SUPPORT, ONLY: LBTYPE, AUTOSTOP

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: UNITC
    INTEGER, INTENT(INOUT) :: IRS
    INTEGER, INTENT(OUT) :: NFPR,NPAR
    LOGICAL, INTENT(OUT) :: FOUND

    LOGICAL EOF3
    INTEGER IBR,NTOT,ITP,LAB,NFPRR,ISWR,NTPL,NAR,NROWPR,NTST,NCOL,NPARR
    INTEGER NPARI,NDM,IPS,IPRIV
    INTEGER ISW,ITPST,I,J,ios,number,UNIT
    CHARACTER(3) :: ATYPE
    CHARACTER(100) :: HEADER

! Locates restart point with label IRS and determines type.
! If the label can not be located on unit 3 then FOUND will be .FALSE.
! If IRS is negative, then just pick the abs(IRS)th solution.

    FOUND=.FALSE.
    NFPR=0
    NPAR=0
    ISW=AP%ISW

    UNIT=3
    ios=0
    IF(LEN_TRIM(SFILE)==0)THEN
       OPEN(UNIT,FILE='fort.3',STATUS='old',ACCESS='sequential',IOSTAT=ios)
    ELSEIF(TRIM(SFILE)=='/')THEN
       SFILE=''
       UNIT=UNITC
    ELSE
       OPEN(UNIT,FILE='s.'//SFILE,STATUS='old',ACCESS='sequential',IOSTAT=ios)
    ENDIF
    IF(ios/=0)THEN
       WRITE(6,'(A,A)')'The solution file (fort.3 or s. file) ',&
            'could not be found.'
       CALL AUTOSTOP()
    ENDIF
    I=0
    J=SCAN(SIRS,"-0123456789")
    number=0
    IF(J>2)THEN
       ATYPE=SIRS(1:J-1)
       READ(SIRS(J:),'(I11)',IOSTAT=ios)number
       IF(ios/=0)THEN
          number=0
       ENDIF
    ENDIF
    DO
       I=I+1
       READ(UNIT,'(A)',END=2)HEADER
       IF(LEN_TRIM(HEADER) <= 73)THEN
          READ(HEADER,*)IBR,NTOT,ITP,LAB,NFPRR,ISWR,NTPL,NAR,NROWPR,NTST, &
               NCOL,NPARR
          NPARI=0
          NDM=0
          IPS=0
          IPRIV=0
       ELSE
          READ(HEADER,*)IBR,NTOT,ITP,LAB,NFPRR,ISWR,NTPL,NAR,NROWPR,NTST, &
               NCOL,NPARR,NPARI,NDM,IPS,IPRIV
       ENDIF
       IF(IBR>MBR)MBR=IBR
       IF(LAB>MLAB)MLAB=LAB
       IF(number>0.AND.ATYPE==LBTYPE(ITP))THEN
          number=number-1
          IF(number==0)IRS=LAB
       ENDIF

       IF((LAB==IRS.OR.IRS==-I).AND..NOT.FOUND.AND.number==0)THEN
          IRS=LAB
          NFPR=NFPRR
          NPAR=NPARR
          FOUND=.TRUE.
          IF(AP%ITP==0)AP%ITP=ITP
          IF(AP%IBR==0)AP%IBR=IBR
          IF(ABS(ISW).GE.2)THEN
             IF(ABS(ITP).LT.10)THEN
                ITPST=ABS(ITP)
             ELSE
                ITPST=ABS(ITP/10)
             ENDIF
          ELSE
             ITPST=0
          ENDIF
          AP%ITPST=ITPST
          CALL READSOL(UNIT,IBR,NTOT,ITP,LAB,NFPR,ISWR,NTPL,NAR,NROWPR,NTST,&
               NCOL,NPAR,NPARI,NDM,IPS,IPRIV)
          ! strip internal parameters from returned NPAR so they can
          ! be thrown away when possible
          NPAR=NPAR-NPARI
       ELSE
          CALL SKIPS(UNIT,NROWPR,EOF3)
          IF(EOF3)GOTO 2
       ENDIF
    ENDDO

2   CONTINUE
    CLOSE(UNIT)

  END SUBROUTINE FINDLB

! ---------- -------
  SUBROUTINE READSOL(UNIT,IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,NCOL,&
       NPAR,NPARI,NDM,IPS,IPRIV)

    INTEGER, INTENT(IN) :: UNIT,IBR,NTOT,ITP,LAB,NFPR
    INTEGER, INTENT(IN) :: ISW,NTPL,NAR,NROWPR,NTST,NCOL,NPAR
    INTEGER, INTENT(IN) :: NPARI,NDM,IPS,IPRIV

! Local
    INTEGER J, NTNC, NROWPRSMALL

    NULLIFY(ROOTSOL)
    NTNC=NTPL-1

    CALL NEWSOL(IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,NCOL,NPAR,&
         NPARI,NDM,IPS,IPRIV)
    DO J=0,NTNC
       READ(UNIT,*)CURSOL%TM(J),CURSOL%UPS(:,J)
    ENDDO

    NROWPRSMALL=((NAR-1)/7+1)*NTPL + (NPAR+6)/7
    IF(NTST>0.AND.NROWPR>NROWPRSMALL)THEN
       READ(UNIT,*)CURSOL%ICP(:)
       READ(UNIT,*)CURSOL%RLDOT(:)

! Read U-dot (derivative with respect to arclength).

       READ(UNIT,*)CURSOL%UDOTPS(:,:)
    ENDIF

! Read the parameter values.

    READ(UNIT,*)CURSOL%PAR(:)

  END SUBROUTINE READSOL

! ---------- ------
  SUBROUTINE NEWSOL(IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,NCOL,NPAR,&
       NPARI,NDM,IPS,IPRIV)

    INTEGER, INTENT(IN) :: IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,&
         NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
    TYPE(SOLUTION), POINTER :: SOL
    INTEGER NDIM,NTNC

    ALLOCATE(SOL)
    SOL%IBR = IBR
    SOL%NTOT = NTOT
    SOL%ITP = ITP
    SOL%LAB = LAB
    SOL%NFPR = NFPR
    SOL%ISW = ISW
    SOL%NTPL = NTPL
    SOL%NAR = NAR
    SOL%NROWPR = NROWPR
    SOL%NTST = NTST
    SOL%NCOL = NCOL
    SOL%NPAR = NPAR
    SOL%NPARI = NPARI
    SOL%NDM = NDM
    SOL%IPS = IPS
    SOL%IPRIV = IPRIV
    NDIM=NAR-1
    NTNC=NTPL-1
    ALLOCATE(SOL%UPS(NDIM,0:NTNC),SOL%TM(0:NTNC),SOL%PAR(NPAR))
    IF(NTST>0)THEN
       ALLOCATE(SOL%UDOTPS(NDIM,0:NTNC),SOL%ICP(NFPR),SOL%RLDOT(NFPR))
    ELSE
       NULLIFY(SOL%UDOTPS,SOL%ICP,SOL%RLDOT)
    ENDIF
    NULLIFY(SOL%NEXT)
    IF(ASSOCIATED(ROOTSOL))THEN
       CURSOL%NEXT => SOL
    ELSE
       ROOTSOL => SOL
    ENDIF
    CURSOL => SOL
  END SUBROUTINE NEWSOL

! ---------- ------
  SUBROUTINE READLB(AP,ICPRS,U,UDOT,PAR)

    USE AUTO_CONSTANTS, ONLY: UVALS, PARVALS, unames, parnames
    USE SUPPORT, ONLY: NAMEIDX
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(OUT) :: ICPRS(*)
    DOUBLE PRECISION, INTENT(OUT) :: U(*),UDOT(*),PAR(*)

    DOUBLE PRECISION, ALLOCATABLE :: UX(:),P(:)
    INTEGER I,NFPR,NPARR,NPAR,NDIM,NDM,NDMRD

    NPAR=AP%NPAR
    NDM=AP%NDM
    IF(AP%IPS==11)NDM=NDM/2

! Reads the restart data for algebraic problems.

    NFPR=CURSOL%NFPR
    NPARR=CURSOL%NPAR
    NDIM=MIN(CURSOL%NAR-1,AP%NDIM)
    U(1:NDIM)=CURSOL%UPS(1:NDIM,0)
    IF(CURSOL%NTST>0)THEN
       ICPRS(1:NFPR)=CURSOL%ICP(1:NFPR)
       UDOT(NDIM+1)=CURSOL%RLDOT(1)
       UDOT(NDIM-NFPR+2:NDIM)=CURSOL%RLDOT(2:NFPR)
       UDOT(1:NDIM)=CURSOL%UDOTPS(1:NDIM,0)
    ENDIF
    PAR(1:NPARR)=CURSOL%PAR(1:NPARR)

! override parameter/point values with values from constants file

    DO I=1,SIZE(UVALS)
       U(NAMEIDX(UVALS(I)%INDEX,unames))=UVALS(I)%VAR
    ENDDO
    DO I=1,SIZE(PARVALS)
       PAR(NAMEIDX(PARVALS(I)%INDEX,parnames))=PARVALS(I)%VAR
    ENDDO

    NDMRD=CURSOL%NDM
    IF(NDMRD==0)THEN
       ! old-style solution file: try to get NDM: this works for
       ! equilibria/maps/timeint problems (not parabolic/optimization)
       NDMRD=CURSOL%NAR-1
       IF(ABS(CURSOL%ISW)==2)THEN
          IF(CURSOL%ITP/10==3)THEN
             NDMRD=NDMRD/3 ! HB (old method)
          ELSE
             NDMRD=(NDMRD-1)/2 ! PD/BP/LP/TR
          ENDIF
       ENDIF
    ENDIF
    IF(NDM>NDMRD)THEN
       ! system is extended; call STPNT for extension
       ALLOCATE(UX(NDM),P(NPAR))
       P(:)=PAR(:NPAR)
       UX(1:NDMRD)=U(1:NDMRD)
       UX(NDMRD+1:NDM)=0.d0
       CALL STPNT(NDM,UX,P,0d0)
       U(NDMRD+1:NDM)=UX(NDMRD+1:NDM)
       DEALLOCATE(UX,P)
    ENDIF

  END SUBROUTINE READLB

! ---------- ------
  SUBROUTINE READBV(AP,PAR,ICPRS,NTSRS,NCOLRS,NDIMRD,RLDOTRS,UPS, &
       UDOTPS,TM,ITPRS,NDIM)

    USE AUTO_CONSTANTS, ONLY: PARVALS, parnames
    USE SUPPORT, ONLY: NAMEIDX
    INTEGER, INTENT(IN) :: NDIM
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(OUT) :: ICPRS(*),NTSRS,NCOLRS,NDIMRD,ITPRS
    DOUBLE PRECISION, INTENT(OUT) :: RLDOTRS(*),UPS(NDIM,0:*),UDOTPS(NDIM,0:*)
    DOUBLE PRECISION, INTENT(OUT) :: TM(0:*),PAR(*)
! Local
    INTEGER I,J,N,NFPR,NFPRS,NPARR,NPARIR,NPAR,NPARI,NDM,NDMRD
    DOUBLE PRECISION, ALLOCATABLE :: U(:),P(:)

    NPARI=AP%NPARI
    NFPR=AP%NFPR
    NPAR=AP%NPAR
    NDM=AP%NDM
    IF(AP%IPS==12)NDM=NDM/2
    ITPRS=CURSOL%ITP
    NFPRS=CURSOL%NFPR
    NTSRS=CURSOL%NTST
    NCOLRS=CURSOL%NCOL
    NPARR=CURSOL%NPAR
    NPARIR=CURSOL%NPARI

    NDIMRD=MIN(NDIM,CURSOL%NAR-1)

    DO J=0,NTSRS*NCOLRS
       IF(MOD(J,NCOLRS)==0)THEN
          TM(J/NCOLRS)=CURSOL%TM(J)
       ENDIF
       UPS(1:NDIMRD,J)=CURSOL%UPS(1:NDIMRD,J)
    ENDDO

    ICPRS(1:MIN(NFPR,NFPRS))=CURSOL%ICP(1:MIN(NFPR,NFPRS))
    RLDOTRS(1:MIN(NFPR,NFPRS))=CURSOL%RLDOT(1:MIN(NFPR,NFPRS))

! Read U-dot (derivative with respect to arclength).

    DO J=0,NTSRS*NCOLRS
       UDOTPS(1:NDIMRD,J)=CURSOL%UDOTPS(1:NDIMRD,J)
    ENDDO

! Read the internal parameter values
 
    IF(NPARI>0)THEN
       IF(NPARIR>0)THEN
          N=MIN(NPARIR,NPARI)
          PAR(NPAR-NPARI+1:NPAR-NPARI+N)= &
               CURSOL%PAR(NPARR-NPARIR+1:NPARR-NPARIR+N)
       ELSEIF(CURSOL%NDM==0)THEN ! old style solution file, copy from PAR(12:)
          N=MIN(NPARR-11,NPARI)
          IF(N>0)THEN
             PAR(NPAR-NPARI+1:NPAR-NPARI+N)=CURSOL%PAR(12:11+N)
          ENDIF
       ENDIF
    ENDIF

! Read the other parameter values.

    PAR(1:NPARR-NPARIR)=CURSOL%PAR(1:NPARR-NPARIR)

! override parameter values with values from constants file

    DO I=1,SIZE(PARVALS)
       PAR(NAMEIDX(PARVALS(I)%INDEX,parnames))=PARVALS(I)%VAR
    ENDDO

    NDMRD=CURSOL%NDM
    IF(NDMRD==0)THEN
       ! old-style solution file: try to get NDM: this works for
       ! periodic/general BVP problems (not HomCont/parabolic/optimization)
       NDMRD=CURSOL%NAR-1
       IF(ABS(CURSOL%ISW)==2)THEN
          IF(CURSOL%ITP/10==8)THEN
             NDMRD=NDMRD/3 ! TR
          ELSEIF(CURSOL%ITP/10==6.AND.CURSOL%ISW==-2)THEN
             NDMRD=NDMRD/4 ! BP start
          ELSE
             NDMRD=NDMRD/2 ! PD/BP/LP
          ENDIF
       ENDIF
    ENDIF
    IF(NDM>NDMRD)THEN
       ! system is extended; call STPNT for extension
       ALLOCATE(U(NDM),P(NPAR))
       P(:)=PAR(:NPAR)
       U(NDMRD+1:NDM)=0.d0
       DO J=0,NTSRS*NCOLRS
          U(1:NDMRD)=UPS(1:NDMRD,J)
          CALL STPNT(NDM,U,P,CURSOL%TM(J))
          UPS(NDMRD+1:NDM,J)=U(NDMRD+1:NDM)
       ENDDO
       DEALLOCATE(U,P)
    ENDIF

  END SUBROUTINE READBV

! ---------- -----
  SUBROUTINE SKIPS(UNIT,NSKIP,EOF3)

! Skips the specified number of lines on the solution file unit

    INTEGER, INTENT(IN) :: UNIT,NSKIP
    LOGICAL, INTENT(OUT) :: EOF3
    CHARACTER(12) FMT
    INTEGER I

    EOF3=.TRUE.
    IF(NSKIP<=1)THEN
       DO I=1,NSKIP
         READ(UNIT,'(A)',END=2)
       ENDDO
    ELSE
       WRITE(FMT,'(A,I9,A)')'(',NSKIP-1,'/)'
       READ(UNIT,FMT,END=2)
    ENDIF
    EOF3=.FALSE.
2   RETURN

  END SUBROUTINE SKIPS

END MODULE IO

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!                   chu :     Chua's circuit
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION ab,h,pi,alpha,beta,RK,a0,a1,x,y,z

      ab(x)=2*x*DATAN(RK*x)/pi
      h(x)=a1*x + 0.5*(a0-a1) * ( ab(x+1) - ab(x-1) ) 

       pi=4*DATAN(1.d0)
       alpha=PAR(1)
       beta =PAR(2)
       RK   =PAR(3)
       a0   =PAR(4)
       a1   =PAR(5) 

       x=U(1)
       y=U(2)
       z=U(3)   

       F(1)= alpha * ( y - h(x) )
       F(2)=  x - y + z
       F(3)= -beta * y

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=-1
       PAR(2)= 14.3 
       PAR(3)= 10.
       PAR(4)= -1./7.
       PAR(5)= 2./7.

       U(1)=0.
       U(2)=0.
       U(3)=0.

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!          Routines for Interface with User Supplied Routines
!  (To generate Jacobian by differencing, if not supplied analytically)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

      MODULE INTERFACES

      USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

      IMPLICIT NONE
      PRIVATE

      PUBLIC :: FUNI,BCNI,ICNI,PVLSI ! Interface subroutines

      PUBLIC :: FUNC,STPNT,BCND,ICND,PVLS ! User subroutines

      INTERFACE
         SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
         INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
         DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
         DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
         DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
         END SUBROUTINE FUNC

         SUBROUTINE STPNT(NDIM,U,PAR,T)
         INTEGER, INTENT(IN) :: NDIM
         DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
         DOUBLE PRECISION, INTENT(IN) :: T
         END SUBROUTINE STPNT

         SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
         INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
         DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
         DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
         DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
         END SUBROUTINE BCND

         SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJ,DINT)
         INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJ
         DOUBLE PRECISION, INTENT(IN) :: PAR(*),U(NDIM),UOLD(NDIM)
         DOUBLE PRECISION, INTENT(IN) :: UDOT(NDIM),UPOLD(NDIM)
         DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
         DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)
         END SUBROUTINE ICND

         SUBROUTINE PVLS(NDIM,U,PAR)
         INTEGER, INTENT(IN) :: NDIM
         DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
         DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
         END SUBROUTINE PVLS
      END INTERFACE

      DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

      CONTAINS

!     ---------- ----
      SUBROUTINE FUNI(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

! Interface subroutine to user supplied FUNC.

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
      DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

      INTEGER JAC,I,J,NFPR,IJC
      DOUBLE PRECISION UMX,EP,UU,P

       JAC=AP%JAC

! Generate the function.


! if the user specified the Jacobian but not the
! parameter derivatives we do not generate the Jacobian here

       IF(JAC.EQ.0.AND.IJAC.NE.0)THEN

! Generate the Jacobian by differencing.

         UMX=0.d0
         DO I=1,NDIM
           IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
         ENDDO

         EP=HMACH*(1+UMX)

         DO I=1,NDIM
           UU=U(I)
           U(I)=UU-EP
           CALL FUNC(NDIM,U,ICP,PAR,0,F,DFDU,DFDP)
           U(I)=UU+EP
           CALL FUNC(NDIM,U,ICP,PAR,0,DFDU(1,I),DFDU,DFDP)
           U(I)=UU
           DO J=1,NDIM
             DFDU(J,I)=(DFDU(J,I)-F(J))/(2*EP)
           ENDDO
         ENDDO

       ENDIF

       IF(JAC==0.OR.IJAC==0)THEN
         IJC=0
       ELSE
         IJC=1
         IF(JAC==1)THEN
            IJC=IJAC
         ENDIF
         IF(AP%NDIM>NDIM)THEN
            ! zero initialize allocated matrices for extended systems
            DFDU(:,:)=0d0
            IF(JAC==1.AND.IJAC==2)THEN
               DO I=1,AP%NFPR
                  DFDP(:,ICP(I))=0d0
               ENDDO
            ENDIF
         ENDIF
       ENDIF
       CALL FUNC(NDIM,U,ICP,PAR,IJC,F,DFDU,DFDP)
       IF(JAC==1.OR.IJAC/=2)RETURN
       NFPR=AP%NFPR
       DO I=1,NFPR
         P=PAR(ICP(I))
         EP=HMACH*( 1 +ABS(P) )
         PAR(ICP(I))=P+EP
         CALL FUNC(NDIM,U,ICP,PAR,0,DFDP(1,ICP(I)),DFDU,DFDP)
         DO J=1,NDIM
           DFDP(J,ICP(I))=(DFDP(J,ICP(I))-F(J))/EP
         ENDDO
         PAR(ICP(I))=P
       ENDDO

      END SUBROUTINE FUNI

!     ---------- ----
      SUBROUTINE BCNI(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

! Interface subroutine to the user supplied BCND.

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
      DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
! Local
      DOUBLE PRECISION EP,UMX,UU,P
      INTEGER IJC,I,J,JAC,NFPR

       JAC=AP%JAC

! Generate the function.

       IF(JAC==0 .AND. IJAC/=0)THEN

! Generate the Jacobian by differencing.

          UMX=0.d0
          DO I=1,NDIM
             IF(ABS(U0(I)).GT.UMX)UMX=ABS(U0(I))
          ENDDO

          EP=HMACH*(1+UMX)

          DO I=1,NDIM
             UU=U0(I)
             U0(I)=UU-EP
             CALL BCND(NDIM,PAR,ICP,NBC,U0,U1,F,0,DBC)
             U0(I)=UU+EP
             CALL BCND(NDIM,PAR,ICP,NBC,U0,U1,DBC(1,I),0,DBC)
             U0(I)=UU
             DO J=1,NBC
                DBC(J,I)=(DBC(J,I)-F(J))/(2*EP)
             ENDDO
          ENDDO

          UMX=0.d0
          DO I=1,NDIM
             IF(ABS(U1(I)).GT.UMX)UMX=ABS(U1(I))
          ENDDO

          EP=HMACH*(1+UMX)

          DO I=1,NDIM
             UU=U1(I)
             U1(I)=UU-EP
             CALL BCND(NDIM,PAR,ICP,NBC,U0,U1,F,0,DBC)
             U1(I)=UU+EP
             CALL BCND(NDIM,PAR,ICP,NBC,U0,U1,DBC(1,NDIM+I),0,DBC)
             U1(I)=UU
             DO J=1,NBC
                DBC(J,NDIM+I)=(DBC(J,NDIM+I)-F(J))/(2*EP)
             ENDDO
          ENDDO
       ENDIF

       IF(JAC==0.OR.IJAC==0)THEN
         IJC=0
       ELSE
         IJC=1
         IF(JAC==1)THEN
            IJC=IJAC
         ENDIF
         IF(AP%NDIM>NDIM.OR.AP%NBC>NBC)THEN
            ! zero initialize allocated matrices for extended systems
            IF(JAC==1.AND.IJAC==2)THEN
               DO I=1,AP%NFPR
                  DBC(:,2*NDIM+ICP(I))=0d0
               ENDDO
            ENDIF
            DBC(:,:2*NDIM)=0d0
         ENDIF
       ENDIF
       CALL BCND(NDIM,PAR,ICP,NBC,U0,U1,F,IJC,DBC)
       IF(JAC==1 .OR. IJAC/=2)RETURN

       NFPR=AP%NFPR
       DO I=1,NFPR
         P=PAR(ICP(I))
         EP=HMACH*( 1 +ABS(P))
         PAR(ICP(I))=P+EP
         CALL BCND(NDIM,PAR,ICP,NBC,U0,U1,DBC(1,2*NDIM+ICP(I)),0,DBC)
         DO J=1,NBC
           DBC(J,2*NDIM+ICP(I))=(DBC(J,2*NDIM+ICP(I))-F(J))/EP
         ENDDO
         PAR(ICP(I))=P
       ENDDO

      END SUBROUTINE BCNI

!     ---------- ----
      SUBROUTINE ICNI(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

! Interface subroutine to user supplied ICND.

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
      DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

      INTEGER JAC,I,J,NFPR,IJC
      DOUBLE PRECISION UMX,EP,UU,P

       JAC=AP%JAC

! Generate the integrand.

       IF(JAC==0 .AND. IJAC/=0)THEN

! Generate the Jacobian by differencing.

          UMX=0.d0
          DO I=1,NDIM
             IF(ABS(U(I)).GT.UMX)UMX=ABS(U(I))
          ENDDO

          EP=HMACH*(1+UMX)

          DO I=1,NDIM
             UU=U(I)
             U(I)=UU-EP
             CALL ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,0,DINT)
             U(I)=UU+EP
             CALL ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,DINT(1,I),0,DINT)
             U(I)=UU
             DO J=1,NINT
                DINT(J,I)=(DINT(J,I)-F(J))/(2*EP)
             ENDDO
          ENDDO
       ENDIF

       IF(JAC==0.OR.IJAC==0)THEN
         IJC=0
       ELSE
         IJC=1
         IF(JAC==1)THEN
            IJC=IJAC
         ENDIF
         IF(AP%NDIM>NDIM.OR.AP%NINT>NINT)THEN
            ! zero initialize allocated matrices for extended systems
            IF(JAC==1.AND.IJAC==2)THEN
               DO I=1,AP%NFPR
                  DINT(:,NDIM+ICP(I))=0d0
               ENDDO
            ENDIF
            DINT(:,:NDIM)=0d0
         ENDIF
       ENDIF
       CALL ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJC,DINT)
       IF(JAC==1 .OR. IJAC/=2)RETURN

       NFPR=AP%NFPR
       DO I=1,NFPR
         P=PAR(ICP(I))
         EP=HMACH*( 1 +ABS(P) )
         PAR(ICP(I))=P+EP
         CALL ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD, &
              DINT(1,NDIM+ICP(I)),0,DINT)
         DO J=1,NINT
           DINT(J,NDIM+ICP(I))=(DINT(J,NDIM+ICP(I))-F(J))/EP
         ENDDO
         PAR(ICP(I))=P
       ENDDO

      END SUBROUTINE ICNI

! ---------- -----
      SUBROUTINE PVLSI(AP,UPS,NDIM,PAR)

      USE AUTO_CONSTANTS, ONLY : NPARX
      USE SUPPORT, ONLY: AUTOSTOP

      TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:*)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

      INTEGER NDM,i

      NDM=AP%NDM
      CALL PVLS(NDM,UPS,PAR)

      DO i=NPARX,AP%NPAR+1,-1
         IF(PAR(i)/=0)THEN
            WRITE(6,"(A,I4)")'NPAR should be at least ',i
            CALL AUTOSTOP()
         ENDIF
      ENDDO

      END SUBROUTINE PVLSI

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      END MODULE INTERFACES

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!   pen :    Coupled pendula (or rotations in coupled Josephson junctions)
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION GAMMA,EPS,RI,PH1,PH2,PS1,PS2

       GAMMA = PAR(1)
       EPS   = PAR(2)
       RI    = PAR(3)

       PH1=U(1)
       PH2=U(2)
       PS1=U(3)
       PS2=U(4)

       F(1)= PS1
       F(2)= PS2
       F(3)= -EPS*PS1 - SIN(PH1) + RI + GAMMA*(PH2-PH1)
       F(4)= -EPS*PS2 - SIN(PH2) + RI + GAMMA*(PH1-PH2)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION GAMMA,EPS,RI

       GAMMA=0.175
       EPS=0.1
       RI=0.4
       PAR(1)=GAMMA
       PAR(2)=EPS
       PAR(3)=RI

! Set the actual period (since the data in pen.dat have scaled time variable)
         PAR(11)=1.5738797205

      END SUBROUTINE STPNT

      SUBROUTINE BCND
      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!     ------- ----
      PROGRAM AUTO

      USE AUTOMPI
      USE IO
      USE SUPPORT, ONLY:AP=>AV, NAMEIDX, AUTOSTOP
      USE AUTO_CONSTANTS,ONLY: ICU,parnames,AUTOPARAMETERS
!$    USE OMP_LIB
      USE COMPAT

      IMPLICIT NONE

      LOGICAL EOF,KEYS
! Local
      DOUBLE PRECISION TIME0,TIME1,TOTTIM
      INTEGER I,LINE,ios,UNITC
      INTEGER,ALLOCATABLE :: IICU(:)
      LOGICAL FIRST

! Initialization :

       CALL MPIINI()
       IF(MPIIAM()/=0)THEN
         CALL MPIWORKER(AP)
         ! never returns
       ENDIF

       FIRST=.TRUE.
       UNITC=2
       OPEN(UNITC,FILE='fort.2',STATUS='old',ACCESS='sequential',IOSTAT=ios)
       IF(ios/=0)THEN
          UNITC=5
       ENDIF

       KEYS=.FALSE.
       LINE=0
       DO
          IF(MPIKWT()>1)THEN
             CALL MPITIM(TIME0)
          ELSE
             TIME0=AUTIM()
!$           TIME0=omp_get_wtime()
          ENDIF
          CALL INIT(AP,UNITC,EOF,KEYS,LINE)
          IF(EOF)EXIT
          CALL FINDLB_OR_STOP(AP,UNITC)
          CALL MPIIAP(AP)
          ALLOCATE(IICU(SIZE(ICU)))
          DO I=1,SIZE(ICU)
             IICU(I)=NAMEIDX(ICU(I),parnames)
          ENDDO
          CALL AUTOI(AP,IICU)
          DEALLOCATE(IICU)
!-----------------------------------------------------------------------

          IF(MPIKWT()>1)THEN
             CALL MPITIM(TIME1)
          ELSE
             TIME1=AUTIM()
!$           TIME1=omp_get_wtime()
          ENDIF
          TOTTIM=TIME1-TIME0
          IF(AP%IID>0)THEN
             CALL WRBAR("=",47)
             WRITE(9,301)TOTTIM
          ENDIF
          WRITE(6,301)TOTTIM
          CALL CLEANUP()
          IF(KEYS)EXIT
       ENDDO
       CALL MPIEND()

 301  FORMAT(/,' Total Time ',E12.3)

      CONTAINS

!     ---------- ---------
      SUBROUTINE MPIWORKER(AP)
      
      USE AUTOMPI
      IMPLICIT NONE

      TYPE(AUTOPARAMETERS) AP
      INTEGER, ALLOCATABLE :: ICU(:)

      DO WHILE(.TRUE.)
         CALL MPIBCASTAP(AP)
         ALLOCATE(ICU(AP%NICP))
         CALL AUTOI(AP,ICU)
         DEALLOCATE(ICU)
         ! autoi eventually calls autobv with the subroutines based on
         ! ap, which eventually calls solvbv;
         ! a return means another init message
         IF(MPIWFI())CYCLE
      ENDDO
      END SUBROUTINE MPIWORKER

!     ---------- --------------
      SUBROUTINE FINDLB_OR_STOP(AP,UNITC)

! Find restart label and determine type of restart point.
! or stop otherwise

      USE AUTO_CONSTANTS, ONLY: SIRS
      IMPLICIT NONE
      TYPE(AUTOPARAMETERS) AP
      INTEGER, INTENT(IN) :: UNITC

      INTEGER NFPR,NPARR,IRS
      LOGICAL FOUND

      IRS=AP%IRS

      FOUND=.FALSE.
      IF(IRS/=0) THEN
         CALL FINDLB(AP,UNITC,IRS,NFPR,NPARR,FOUND)
         AP%IRS=IRS
         AP%NFPR=NFPR
         IF(.NOT.FOUND) THEN
            WRITE(6,"(' Restart label ',A,' not found')")TRIM(SIRS)
            CALL AUTOSTOP()
         ENDIF
         AP%NPAR=MAX(NPARR,AP%NPAR)
      ENDIF
      END SUBROUTINE FINDLB_OR_STOP

!     ---------- -----
      SUBROUTINE AUTOI(AP,ICU)

      USE TOOLBOXAE
      USE TOOLBOXBV
      USE EQUILIBRIUM
      USE MAPS
      USE OPTIMIZATION
      USE PARABOLIC
      USE PERIODIC
      USE HOMCONT
      USE TIMEINT
      USE AUTO_CONSTANTS, ONLY: NBC,NINT,NDIM

      IMPLICIT NONE
      TYPE(AUTOPARAMETERS) AP
      INTEGER ICU(AP%NICP)

      INTEGER IPS,ISW,NNICP,NPAR
      INTEGER, ALLOCATABLE :: ICP(:)

      IPS=AP%IPS
      ISW=AP%ISW

      ! transfer ICU array on MPI so the AUTO** subroutines can do their
      ! work normally on the workers.
      CALL MPIBCASTI(ICU,AP%NICP)
      NNICP=MAX(5*(NBC+NINT-NDIM+1)+NDIM+NINT+3,5*SIZE(ICU)+NDIM+3)
      ALLOCATE(ICP(NNICP))
      ICP(:SIZE(ICU))=ICU(:)
      ICP(SIZE(ICU)+1:)=0
      NPAR=AP%NPAR
      NPAR=MAX(MAXVAL(ABS(ICU)),NPAR)
      AP%NPAR=NPAR
      CALL INIT1(AP)

      SELECT CASE(IPS)
      CASE(0)
         ! general algebraic equations (no Hopf, eigenvalues, stability)
         CALL AUTOAEP(AP,ICP,ICU)
      CASE(1)
         ! equilibria
         CALL AUTOEQ(AP,ICP,ICU)
      CASE(-1)
         ! fixed points in maps
         CALL AUTODS(AP,ICP,ICU)
      CASE(2,4,7)
         ! periodic solutions and general BVPs
         IF(IPS==2.OR.(IPS==7.AND.ABS(ISW)<=1))THEN
            CALL AUTOPS(AP,ICP,ICU)
         ELSE
            CALL AUTOBVP(AP,ICP,ICU)
         ENDIF 
      CASE(-2)
         ! time integration
         CALL AUTOTI(AP,ICP,ICU)
      CASE(11,12,14,16,17)
         ! parabolic PDEs
         CALL AUTOPE(AP,ICP,ICU)
      CASE(5,15)
         ! optimization
         CALL AUTOOP(AP,ICP,ICU)
      CASE(9)
         ! Homoclinic bifurcation analysis.
         CALL AUTOHO(AP,ICP,ICU)
      END SELECT

      IF(AP%NTOT==0.AND.MPIIAM()==0)THEN
!        ** Error in INIT.
         WRITE(6,500)
         CALL AUTOSTOP()
      ENDIF

! Error Message.
 500  FORMAT(' Initialization Error')

      DEALLOCATE(ICP)

      END SUBROUTINE AUTOI
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    Initialization
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

!     ---------- ----
      SUBROUTINE INIT(AP,UNITC,EOF,KEYS,LINE)

      USE AUTO_CONSTANTS
      USE HOMCONT, ONLY : INSTRHO

      IMPLICIT NONE

      TYPE(AUTOPARAMETERS), INTENT(OUT) :: AP
      INTEGER, INTENT(IN) :: UNITC
      LOGICAL, INTENT(OUT) :: EOF
      LOGICAL, INTENT(INOUT) :: KEYS
      INTEGER, INTENT(INOUT) :: LINE

      INTEGER NPOS, IERR, KEYEND, POS, LISTLEN
      CHARACTER(LEN=2048) :: STR

!     set default values
      NDIM = 2
      IPS  = 1
      ILP  = 1
      NTST = 20
      NCOL = 4
      IAD  = 3
      IADS = 1
      ISP  = 2
      ISW  = 1
      IPLT = 0
      NBC  = 0
      NINT = 0
      NMX  = 0
      NPR  = 0
      MXBF = 10
      IIS  = 3
      IID  = 2
      ITMX = 9
      ITNW = 5
      NWTN = 3
      JAC  = 0
      NPAR = NPARX
      IBR  = 0
      LAB  = 0

      DS    = 0.01d0
      DSMIN = 0.005d0
      DSMAX = 0.1d0
      RL0   = -HUGE(1d0)*0.99995d0 !avoid rounding up in sthd
      RL1   = HUGE(1d0)*0.99995d0
      A0    = -HUGE(1d0)*0.99995d0
      A1    = HUGE(1d0)*0.99995d0
      EPSL  = 1d-7
      EPSU  = 1d-7
      EPSS  = 1d-5

      TY='' 
      EFILE=''
      SFILE=''
      SVFILE=''
      DATFILE=''

      ALLOCATE(ICU(1),IVUZR(0),IVUZSTOP(0),IVTHU(0),parnames(0),unames(0),SP(0))
      ALLOCATE(STOPS(0),UVALS(0),PARVALS(0))
      ICU(1)='1'

      NPOS=1
      DO
         CALL READC(UNITC,EOF,LINE,NPOS,STR,KEYEND,POS,LISTLEN,IERR)
         ! IERR=-1: old-style constants file detected and read
         ! IERR= 0: no problems
         ! IERR= 1: unknown AUTO constant: check with HomCont
         ! IERR= 3: bad value
         IF(EOF.OR.IERR==-1)EXIT
         KEYS=.TRUE.
         IF(IERR==1)THEN
            CALL INSTRHO(STR(1:KEYEND),STR(POS:),LISTLEN,IERR)
         ENDIF
         IF(IERR==1)THEN
            WRITE(6,'(A,A,A,I2)')"Unknown AUTO constant ", &
                 STR(1:KEYEND)," on line ",LINE
            CALL AUTOSTOP()
         ELSEIF(IERR==3)THEN
            WRITE(6,"(A,I2,A)") &
                 " Error in fort.2 or c. file: bad value on line ", LINE,"."
            CALL AUTOSTOP()
         ENDIF
      ENDDO

      IF(EOF.AND.IERR/=-1.AND..NOT.KEYS)THEN
         RETURN
      ENDIF

      AP%NDIM=NDIM
      AP%IPS=IPS
      AP%IRS=IRS
      AP%ILP=ILP
      AP%NTST=NTST
      AP%NCOL=NCOL
      AP%IAD=IAD
      AP%IADS=IADS
      AP%ISP=ISP
      AP%ISW=ISW
      AP%IPLT=IPLT
      AP%NBC=NBC
      AP%NINT=NINT
      AP%NMX=NMX
      AP%NUZR=0
      DO I=1,SIZE(IVUZR)
         AP%NUZR=AP%NUZR+SIZE(IVUZR(I)%VAR)
      ENDDO
      DO I=1,SIZE(IVUZSTOP)
         AP%NUZR=AP%NUZR+SIZE(IVUZSTOP(I)%VAR)
      ENDDO
      AP%NPR=NPR
      AP%MXBF=MXBF
      AP%IIS=IIS
      AP%IID=IID
      AP%ITMX=ITMX
      AP%ITNW=ITNW
      AP%NWTN=NWTN      
      AP%JAC=JAC
      AP%NPAR=NPAR
      AP%IBR=IBR
      AP%LAB=LAB
      AP%NICP=SIZE(ICU)
      AP%NTEST=2 ! LP/BP test functions active by default

      AP%NDM=NDIM
      AP%NPARI=0
      AP%ITP=0
      AP%ITPST=0
      AP%NFPR=1
      AP%NTOT=0
      AP%NINS=0

      AP%DS=DS
      AP%DSMIN=ABS(DSMIN)
      AP%DSMAX=ABS(DSMAX)
      AP%RDS=DS
      AP%RL0=RL0
      AP%RL1=RL1
      AP%A0=A0
      AP%A1=A1

      AP%EPSL=EPSL
      AP%EPSU=EPSU
      AP%EPSS=EPSS
      AP%DET=0.d0
      AP%FLDF=0.d0
      AP%HBFF=0.d0
      AP%BIFF=0.d0
      AP%SPBF=0.d0

      EOF=.FALSE.

      END SUBROUTINE INIT

!     ---------- -------
      SUBROUTINE CLEANUP()

!     Deallocate some globally allocated arrays.

      USE AUTO_CONSTANTS, ONLY : IVTHU,IVUZR,IVUZSTOP,IVTHL,ICU,parnames, &
           unames,SP,STOPS,PARVALS,UVALS

      IMPLICIT NONE

      DO I=1,SIZE(IVUZR)
         DEALLOCATE(IVUZR(I)%VAR)
      ENDDO
      DO I=1,SIZE(IVUZSTOP)
         DEALLOCATE(IVUZSTOP(I)%VAR)
      ENDDO
      DEALLOCATE(IVTHU,IVUZR,IVUZSTOP,IVTHL,ICU,parnames,unames,SP,STOPS, &
           PARVALS,UVALS)
      END SUBROUTINE CLEANUP

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!               The leading subroutines of AUTO
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

!     ---------- -----
      SUBROUTINE INIT1(AP)

      USE AUTO_CONSTANTS, ONLY:IVTHL,TY
      USE SUPPORT, ONLY: LBTYPE

      DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

! General initialization. Redefinition of constants.
! The following constants are redefined, ie. they are different than in
! fort.2 or c.*:

!   DS: if DS is set to 0 it'll be set to 0.1
!   DS: if DSMIN is set to 0 it'll be set to 1.0d-4 * |DS|
!   DSMIN is divided by 1+HMACH
!   DS and DSMAX are multiplied by 1+HMACH

!   NDIM: set to the dimension of the extended system
!   ILP: set to 0 dependent on problem type
!   ISP: set to 0 dependent on problem type
!   ISW: set to 1 if equal to 0, to -|ISW| for starts of ext systems
!   NBC: set by problem type
!   NINT: set by problem type
!   NMX: set to 5 for starts of extended systems

      TYPE(AUTOPARAMETERS) AP

! Local
      DOUBLE PRECISION DS,DSMIN,FC

       DS=AP%DS
       DSMIN=AP%DSMIN

       IF(AP%ISW.EQ.0)AP%ISW=1

! Check and perturb pseudo arclength stepsize and steplimits.
! (Perturbed to avoid exact computation of certain singular points).

       IF(DS.EQ.0.d0)DS=0.1
       IF(DSMIN.EQ.0.d0)DSMIN=1.0D-4*ABS(DS)
       FC=1.d0+HMACH
       AP%DS=FC*DS
       AP%DSMIN=DSMIN/FC
       AP%DSMAX=FC*AP%DSMAX
       AP%NPARI=0
       IF(.NOT.ALLOCATED(IVTHL))THEN
          ! set default for *THL
          IF(AP%IPS==2.OR.AP%IPS==12)THEN
             ALLOCATE(IVTHL(1))
             IVTHL(1)%INDEX='11'
             IVTHL(1)%VAR=0d0
          ELSE
             ALLOCATE(IVTHL(0))
          ENDIF
       ENDIF

!translate TY constant to typecode in AP%ITP
       IF(LEN_TRIM(TY)>=2)THEN
          DO I=-9,9
             IF(LBTYPE(I)==TY(1:2))THEN
                AP%ITP=I
                EXIT
             ENDIF
          ENDDO
          IF(TY(1:2)=='GH')THEN
             AP%ITP=-32
          ENDIF
          IF(.NOT.(AP%IPS<=1.OR.AP%IPS==5.OR.AP%IPS==11))THEN
             IF(AP%ITP==1)THEN
                AP%ITP=6
             ELSEIF(AP%ITP==2)THEN
                AP%ITP=5
             ENDIF
          ENDIF
       ENDIF

      RETURN
      END SUBROUTINE INIT1

      END PROGRAM AUTO
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

C plautcom.f
      COMMON /PLTCOM/ TMINVX,TMINVY,TMAXVX,TMAXVY,TREALX,
     1 TREALY,TIMAGX,TIMAGY,TRCOSF,TRSINF,TRSCAL,TRFACX,
     2 TRFACY,TRPAR1,TRPAR2,TRPAR3,TRPAR4,TRPAR5,TRPAR6,
     3 KMOFLG(8),KPAD2,KBAUDR,KGNFLG,KGRAFL,KHOMEY,KKMODE,
     4 KHORSZ,KVERSZ,KTBLSZ,KSIZEF,KLMRGN,KRMRGN,KFACTR,
     5 KTERM,KLINE,KZAXIS,KBEAMX,KBEAMY,KMOVEF,KPCHAR(5),
     6 KDASHT,KMINSX,KMINSY,KMAXSX,KMAXSY,KEYCON,KINLFT,
     7 KOTLFT,KUNIT

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   bru :    Time integration of a scalar nonlinear parabolic PDE
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION X,Y,A,B

        X=U(1)
        Y=U(2)
        A=PAR(1)
        B=PAR(2)

!      *Set the nonlinear term
        F(1)= X**2*Y - (B+1)*X + A
        F(2)=-X**2*Y + B*X

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,Z)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: Z

      DOUBLE PRECISION pi,A,B,Dx,Dy,RL

      pi=4*DATAN(1.d0)

!      *Set the (constant) parameters
       A  = 2.
       B  = 5.45
       Dx = 0.008
       Dy = 0.004
       RL = 0.75

       PAR(1)=A
       PAR(2)=B
       PAR(3)=RL

!      *Set the actual width of the space interval [0,PAR(11)]
       PAR(11) = 1.

!      *Set the initial data in the (scaled) interval [0,1]
       U(1) = A   - 0.5*DSIN(pi*Z)
       U(2) = B/A + 0.7*DSIN(pi*Z)

!      *Also set the space-derivative of the initial data
!      *Note the scaling by PAR(11)
       U(3) = - 0.5*pi*DCOS(pi*Z)/PAR(11)
       U(4) =   0.7*pi*DCOS(pi*Z)/PAR(11)

!      *Set the diffusion constants
       PAR(15) = Dx/RL**2
       PAR(16) = Dy/RL**2

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

!      *Define the boundary conditions (Dirichlet, in this example).
       FB(1)=U0(1)-PAR(1) 
       FB(2)=U0(2)-PAR(2)/PAR(1) 
       FB(3)=U1(1)-PAR(1) 
       FB(4)=U1(2)-PAR(2)/PAR(1) 

      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------
!---------------------------------------------------------------------
!   lin :    A problem with a "vertical" Hopf bifurcation
!---------------------------------------------------------------------
!---------------------------------------------------------------------

       SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!      ---------- ----

       IMPLICIT NONE
       INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
       DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
       DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
       DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

        F(1) = PAR(1)*U(1) - U(2)
        F(2) = U(1)*(1-U(1))

       END SUBROUTINE FUNC

       SUBROUTINE STPNT(NDIM,U,PAR,T)
!      ---------- -----

       IMPLICIT NONE
       INTEGER, INTENT(IN) :: NDIM
       DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
       DOUBLE PRECISION, INTENT(IN) :: T

        PAR(1)=-1.

        U(1)=0.0
        U(2)=0.0

       END SUBROUTINE STPNT

       SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
       RETURN
       END

       SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
       RETURN
       END

       SUBROUTINE FOPT
       END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   ppp :    A continuous dynamical system with period doubling
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      F(1)= U(1)*(1-U(1)) - PAR(4)*U(1)*U(2) 
      F(2)=-PAR(2)*U(2)   + PAR(4)*U(1)*U(2) - PAR(5)*U(2)*U(3) &
                          - PAR(1)*(1-EXP(-PAR(6)*U(2))) 
      F(3)=-PAR(3)*U(3)   + PAR(5)*U(2)*U(3) 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      U(1)=1.0 
      U(2)=0.0 
      U(3)=0.0 

      PAR(1)=0.0 
      PAR(2)=0.25 
      PAR(3)=0.5 
      PAR(4)=3.0 
      PAR(5)=3.0 
      PAR(6)=5.0 

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!       ops :    Optimization of periodic solutions 
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION x,y,z,p1,p2,p3,p4
      INTEGER I,J

       x=U(1)
       y=U(2)
       z=U(3)

       p1=PAR(1)
       p2=PAR(2)
       p3=PAR(3)
       p4=PAR(4)

       F(1)=( -p4*(x**3/3-x) + (z-x)/p2 - y ) / p1  
       F(2)=x-p3 
       F(3)=-(z-x)/p2 

      IF(IJAC.EQ.0)RETURN

       DFDU(1,1)=( -p4*(x**2-1) - 1/p2 ) /p1
       DFDU(1,2)=-1/p1
       DFDU(1,3)=1/(p2*p1)

       DFDU(2,1)=1
       DFDU(2,2)=0
       DFDU(2,3)=0

       DFDU(3,1)=1/p2
       DFDU(3,2)=0
       DFDU(3,3)=-1/p2

      IF(IJAC.EQ.1)RETURN

!      *Parameter derivatives
       DO I=1,3
         DO J=1,9
           DFDP(I,J)=0.d0
         ENDDO
       ENDDO

       DFDP(1,1)=-( -p4*(x**3/3-x) + (z-x)/p2 - y )/p1**2
       DFDP(1,2)=-(z-x)/(p2**2*p1)
       DFDP(1,3)=0
       DFDP(1,4)=-(x**3/3-x)/p1

       DFDP(2,1)=0
       DFDP(2,2)=0
       DFDP(2,3)=-1
       DFDP(2,4)=0

       DFDP(3,1)=0
       DFDP(3,2)=(z-x)/p2**2
       DFDP(3,3)=0
       DFDP(3,4)=0

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION p1,p2,p3,p4

      p1=0.5
      p2=4
      p3=0.9
      p4=2.

      U(1)=p3 
      U(2)=-p4*(p3**3/3-p3)
      U(3)=p3 

      PAR(1)=p1 
      PAR(2)=p2
      PAR(3)=p3 
      PAR(4)=p4

      END SUBROUTINE STPNT

      SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: FS
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM),DFDP(*)

      INTEGER I

       FS=PAR(3)

      IF(IJAC.EQ.0)RETURN

       DO I=1,NDIM
         DFDU(I)=0.d0
       ENDDO

      IF(IJAC.EQ.1)RETURN

!      *Parameter derivatives
       DO I=1,9
         DFDP(I)=0.d0
       ENDDO

       DFDP(3)=1.d0

      END SUBROUTINE FOPT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!======================================================================
!======================================================================
!         Utility Program for Relabeling Labeled Solutions
!                        in AUTO97 Data Files
!======================================================================
!======================================================================
!
PROGRAM RELABELF
  USE COMPAT
  IMPLICIT NONE
  CHARACTER(80) INB,OUTB,INS,OUTS
  INTEGER N,NLB
  TYPE LABEL
     INTEGER LAB
     TYPE(LABEL), POINTER :: NEXT
  END TYPE LABEL
  TYPE(LABEL), POINTER :: LIST

  N=AUTARGC()
  IF (N==4) THEN
     CALL AUTGETARG(1,INB)
     CALL AUTGETARG(2,INS)
     CALL AUTGETARG(3,OUTB)
     CALL AUTGETARG(4,OUTS)
  ELSE
     INB='fort.27'
     INS='fort.28'
     OUTB='fort.37'
     OUTS='fort.38'
  ENDIF

  OPEN(28,FILE=INS,STATUS='old',ACCESS='sequential')
  OPEN(38,FILE=OUTS,STATUS='replace',ACCESS='sequential')
  CALL SFILE(LIST,NLB)
  CLOSE(28)
  CLOSE(38)

  OPEN(27,FILE=INB,STATUS='old',ACCESS='sequential')
  OPEN(37,FILE=OUTB,STATUS='replace',ACCESS='sequential')
  CALL BFILE(LIST,NLB)
  CLOSE(27)
  CLOSE(37)

  STOP

CONTAINS

! ---------- ------
  SUBROUTINE SFILE(LIST,NLB)

    INTEGER NLB
    INTEGER IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,NCOL,NPAR
    INTEGER NPARI,NDM,IPS,IPRIV
    INTEGER I,L,LEN
    CHARACTER(150) LINE
    LOGICAL OLD
    TYPE(LABEL), POINTER :: LIST, P
!
    L=0
    NLB=0
    ALLOCATE(LIST)
    P=>LIST
    DO
       NULLIFY(P%NEXT)
       READ(28,'(A)',END=99)LINE
       IF (LEN_TRIM(LINE) == 0) GOTO 99
       IF (LEN_TRIM(LINE) <= 73) THEN
          READ(LINE,*)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL, &
               NAR,NROWPR,NTST,NCOL,NPAR
          OLD=.TRUE.
       ELSE
          READ(LINE,*)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL, &
               NAR,NROWPR,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
          OLD=.FALSE.
       ENDIF

       NLB=NLB+1
       P%LAB=LAB

       L=L+1
       IF(OLD)THEN
          WRITE(38,101)IBR,NTOT,ITP,L,NFPR,ISW,NTPL, &
               NAR,NROWPR,NTST,NCOL,NPAR
       ELSE
          WRITE(38,111)IBR,NTOT,ITP,L,NFPR,ISW,NTPL, &
               NAR,NROWPR,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
       ENDIF
       DO I=1,NROWPR
          READ(28,"(A)",ADVANCE='NO',EOR=98,END=99,SIZE=LEN)LINE
          DO
             WRITE(38,"(A)",ADVANCE='NO')LINE(1:LEN)
             READ(28,"(A)",ADVANCE='NO',EOR=98,END=99,SIZE=LEN)LINE
          ENDDO
98        CONTINUE
          WRITE(38,"(A)")LINE(1:LEN)
       ENDDO
       ALLOCATE(P%NEXT)
       P=>P%NEXT
    ENDDO

 101   FORMAT(6I6,I8,I6,I8,3I5)
 111   FORMAT(6I6,I8,I6,I8,7I5)

99  RETURN
  END SUBROUTINE SFILE

! ---------- -------
  SUBROUTINE BFILE(LIST,NLB)

    INTEGER NLB,LAB
    CHARACTER(132) LINE
    CHARACTER(1) CH1
    INTEGER I,J,I1,I2,L1,L,LNUM,LEN
    LOGICAL EOL
    CHARACTER(LEN=5) FMT ! fits "(I99)"
    TYPE(LABEL), POINTER :: LIST, P

    L=0
    LNUM=0
    L1=0
    P=>LIST
    DO
       EOL=.TRUE.
       READ(27,"(A)",ADVANCE='NO',EOR=97,END=99,SIZE=LEN)LINE
       EOL=.FALSE.
97     CONTINUE
       LNUM=LNUM+1
       J=1
       I2=0
       DO I=1,4
          ! skip spaces
          DO
             IF(LINE(J:J)/=' ')EXIT
             J=J+1
             IF(J>LEN)EXIT
          ENDDO
          ! check for header line
          IF(I==1.AND.LINE(J:J)=='0')THEN
             EXIT
          ENDIF
          ! look for next space after BR/PT/TY/LAB
          DO
             IF(LINE(J:J)==' ')EXIT
             J=J+1
             IF(J>LEN)EXIT
          ENDDO
          IF(J>LEN)THEN
             EXIT
          ENDIF
          ! Put line index for LAB, rest here
          IF(I==3)THEN
             I1=J
          ELSEIF(I==4)THEN
             I2=J
          ENDIF
       ENDDO
       LAB=0
       IF(I2/=0)THEN
          READ(LINE(I1:I2-1),*)LAB
       ENDIF

       IF(LAB/=0)THEN
          L=L+1
          IF(L>NLB.OR.LAB/=P%LAB)THEN
             WRITE(*,"(A/A,I5,A,I5/A,I5/A/A)", ADVANCE="NO") &
                  ' WARNING : The two files have incompatible labels :', &
                  '  b-file label ',LAB,' at line ',LNUM, &
                  '  s-file label ',P%LAB, &
                  ' New labels may be assigned incorrectly.', &
                  ' Continue ? : '
             READ(*,"(A1)")CH1
             IF(CH1/='y'.AND.CH1/='Y')THEN
                WRITE(*,"(A)") &
                     'Rewrite discontinued. Recover original files'
                RETURN
             ENDIF
          ENDIF
          IF(ASSOCIATED(P%NEXT))THEN
             P=P%NEXT
          ENDIF
          IF(I2-I1/=L1)THEN
             L1=I2-I1
             WRITE(FMT,"(A,I2,A)")'(I',L1,')'
          ENDIF
          WRITE(LINE(I1:I2-1),FMT)L
       ENDIF
       IF(.NOT.EOL)THEN
          DO
             WRITE(37,"(A)",ADVANCE='NO')LINE(1:LEN)
             READ(27,"(A)",ADVANCE='NO',EOR=98,SIZE=LEN)LINE
          ENDDO
98        CONTINUE
       ENDIF
       WRITE(37,"(A)")LINE(1:LEN)
    ENDDO
99  RETURN
  END SUBROUTINE BFILE

END PROGRAM RELABELF
!======================================================================
!======================================================================

MODULE EQUILIBRIUM

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
  USE AE
  USE TOOLBOXAE
  USE INTERFACES

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: AUTOEQ,INITEQ,FNCSEQF
  PUBLIC :: FNHBF,STPNHBF,FFHBX,STABEQ,PRINTEIG ! Hopf bifs

  DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

CONTAINS

! ---------- ------
  SUBROUTINE INITEQ(AP)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP

    SELECT CASE(AP%ITPST)
    CASE(3)
       ! Hopf
       AP%NDIM=2*AP%NDIM+2
       AP%NFPR=2
    CASE DEFAULT
       CALL INITAE(AP)
    END SELECT
    AP%NTEST=6

  END SUBROUTINE INITEQ

! ---------- ------
  SUBROUTINE AUTOEQ(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    CALL INITEQ(AP)

    SELECT CASE(AP%ITPST)
    CASE(0)
       ! Algebraic systems.
       CALL AUTOAE(AP,ICP,ICU,FUNI,STPNAE,FNCSEQ)
    CASE(1)
       ! ** BP cont (algebraic problems) (by F. Dercole).
       CALL AUTOAE(AP,ICP,ICU,FNBP,STPNBP,FNCSEQ)
    CASE(2)
       ! ** Fold continuation (algebraic problems).
       CALL AUTOAE(AP,ICP,ICU,FNLP,STPNLP,FNCSEQ)
    CASE(3)
       ! Hopf bifurcation continuation (ODEs).
       CALL AUTOAE(AP,ICP,ICU,FNHB,STPNHB,FNCSEQ)
    END SELECT
  END SUBROUTINE AUTOEQ

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!     Subroutines for the Continuation of Hopf Bifurcation Points
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNHB(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-parameter continuation of Hopf
    ! bifurcation points in ODE/map.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNHBF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI,FFHBX)

  END SUBROUTINE FNHB

! ---------- -----
  SUBROUTINE FNHBF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI,FUNIX)

    ! Generates the equations for the 2-parameter continuation of Hopf
    ! bifurcation points in ODE/wave/map.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),DFP(:,:),FF1(:),FF2(:)
    INTEGER NDM,NPAR,I,II,J,IJC
    DOUBLE PRECISION UU,UMX,EP,P

    NDM=AP%NDM
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN ! reduced function for Generalized-Hopf detection
       CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,0,F,DFDU,DFDP)
       RETURN
    ENDIF

    ! Generate the function.

    ALLOCATE(DFU(NDM,2*NDM+2),DFP(NDM,NPAR))
    IF(IJAC==0)THEN
       IJC=IJAC
    ELSE
       IJC=2
    ENDIF
    CALL FFHB(AP,NDIM,U,UOLD,ICP,PAR,IJC,F,NDM,DFU,DFP,FUNI,FUNIX)

    IF(IJAC.EQ.0)THEN
       DEALLOCATE(DFU,DFP)
       RETURN
    ENDIF

    ! Generate the Jacobian.

    ALLOCATE(FF1(NDIM),FF2(NDIM))
    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    DFDU(1:NDM,1:NDM)=DFU(:,:)
    DFDU(1:NDM,NDM+1:NDIM-1)=0d0
    DFDU(1:NDM,NDIM)=DFP(:,ICP(2))

    DFDU(NDM+1:2*NDM,NDM+1:NDIM-1)=DFU(1:NDM,NDM+1:2*NDM+1)

    DFDU(NDIM-1,1:NDM)=0d0
    DFDU(NDIM-1,NDM+1:2*NDM)=2*U(NDM+1:2*NDM)
    DFDU(NDIM-1,NDIM-1:NDIM)=0d0

    DFDU(NDIM,NDM+1:2*NDM)=DFU(1:NDM,2*NDM+2)

    IF(IJAC/=1)THEN
       DFDP(1:NDM,ICP(1))=DFP(:,ICP(1))
    ENDIF

    DO II=1,NDM+1
       I=II
       IF(II>NDM)I=NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FFHB(AP,NDIM,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DFP,FUNI,FUNIX)
       U(I)=UU+EP
       CALL FFHB(AP,NDIM,U,UOLD,ICP,PAR,0,FF2,NDM,DFU,DFP,FUNI,FUNIX)
       U(I)=UU
       DO J=NDM+1,NDIM
          IF(J/=NDIM-1)THEN
             DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
          ENDIF
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(FF1,DFP,DFU)
       RETURN
    ENDIF

    P=PAR(ICP(1))
    PAR(ICP(1))=P+EP

    CALL FFHB(AP,NDIM,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DFP,FUNI,FUNIX)

    DO J=NDM+1,NDIM
       IF(J/=NDIM-1)THEN
          DFDP(J,ICP(1))=(FF1(J)-F(J))/EP
       ENDIF
    ENDDO
    DFDP(NDIM-1,ICP(1))=0d0

    PAR(ICP(1))=P
    DEALLOCATE(FF1,DFP,DFU)

  END SUBROUTINE FNHBF

! ---------- ----
  SUBROUTINE FFHB(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP,FUNI,FUNIX)

    ! See Kuznetsov, 3rd ed., (10.80) and (10.83)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NDM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,2*NDM+2)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDP(NDM,*)
    include 'interfaces.h'

    PAR(ICP(2))=U(NDIM)
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,MAX(IJAC,1),F,DFDU,DFDP)
    CALL FUNIX(AP,U,PAR,DFDU,DFDU(1,NDM+1))

    CALL DGEMV('n',NDM,NDM,1.0d0,DFDU(1,NDM+1),NDM,U(NDM+1),1,0d0,F(NDM+1),1)
    F(NDIM-1)=-1+DOT_PRODUCT(U(NDM+1:2*NDM),U(NDM+1:2*NDM))

    ! This expression
    ! <DFDU' eta_0 - DFDU eta_0,eta>
    ! approximates the previously used phase condition
    ! <eta,xi_0> - <eta_0,xi>
    ! disregarding the factor T/(2*pi).
    ! where \eta=U(NDM+1:NDM*2), \eta_0=UOLD(NDM+1:NDM*2), and
    ! \xi=-T/(2*pi)*DFDU \eta
    CALL DGEMV('t',NDM,NDM,1d0,DFDU,NDM,UOLD(NDM+1),1,0d0,DFDU(1,2*NDM+2),1)
    CALL DGEMV('n',NDM,NDM,-1d0,DFDU,NDM,UOLD(NDM+1),1,1d0,DFDU(1,2*NDM+2),1)
    F(NDIM)=DOT_PRODUCT(DFDU(:,2*NDM+2),U(NDM+1:2*NDM))

  END SUBROUTINE FFHB

! ---------- -----
  SUBROUTINE FFHBX(AP,U,PAR,DFDU,DFDV)

    USE SUPPORT, ONLY: PI
    USE AUTO_CONSTANTS, ONLY: TY
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: U(AP%NDM*2+2),PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: DFDU(AP%NDM,AP%NDM)
    DOUBLE PRECISION, INTENT(OUT) :: DFDV(AP%NDM,AP%NDM+1)

    INTEGER I,NDM
    DOUBLE PRECISION PERIOD,KAPPA

    NDM=AP%NDM
    IF(AP%ITP==3)THEN
       ! initialization
       IF(LEN_TRIM(TY)>2)THEN
          READ(TY(3:),'(I5)')I
          PAR(11)=PAR(I)
       ENDIF
       PERIOD=PAR(11)
       KAPPA=(PI(2.d0)/PERIOD)**2
       U(2*NDM+1)=KAPPA
    ENDIF

    ! construct matrix for extended Hopf system
    ! Kuznetsov, 3rd ed., (10.80)
    ! A^2+kappa I and the derivative to kappa, where A=DFDU
    CALL DGEMM('n','n',NDM,NDM,NDM,1.d0,DFDU,NDM,DFDU,NDM,0.d0,DFDV,NDM)
    KAPPA=U(NDM*2+1)
    DO I=1,NDM
       DFDV(I,I)=DFDV(I,I)+KAPPA
    ENDDO
    DFDV(1:NDM,NDM+1)=U(NDM+1:2*NDM)

  END SUBROUTINE FFHBX

! ---------- ------
  SUBROUTINE STPNHB(AP,PAR,ICP,U,UDOT,NODIR)

    USE SUPPORT

    ! Generates starting data for the 2-parameter continuation of
    ! Hopf bifurcation point (ODEs).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNHBF(AP,PAR,ICP,U,UDOT,NODIR,FUNI,FFHBX)

  END SUBROUTINE STPNHB

! ---------- -------
  SUBROUTINE STPNHBF(AP,PAR,ICP,U,UDOT,NODIR,FUNI,FUNIX)

    USE IO
    USE SUPPORT
    USE TOOLBOXAE, ONLY: STPNAE

    ! Generates starting data for the 2-parameter continuation of
    ! Hopf bifurcation point (ODE/wave/map).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),V(:),F(:),UOLD(:)
    INTEGER :: ICPRS(2),NDIM,NDM,I
    DOUBLE PRECISION DFP(1)

    NDIM=AP%NDIM
    NDM=AP%NDM

    IF(ABS(AP%ITP)/10>0)THEN
       ! restart
       CALL STPNAE(AP,PAR,ICP,U,UDOT,NODIR)
       U(NDIM)=PAR(ICP(2))
       RETURN
    ENDIF

    CALL READLB(AP,ICPRS,U,UDOT,PAR)
    ALLOCATE(DFU(NDM,2*NDM+2),F(NDM),V(NDM),UOLD(NDM))
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,1,F,DFU,DFP)
    ! store matrix/derivatives for extended Hopf system in the
    ! bottom of DFDU
    CALL FUNIX(AP,U,PAR,DFU,DFU(1,NDM+1))
    CALL NLVC(NDM,NDM,2,DFU(1,NDM+1),V)
    CALL NRMLZ(NDM,V)

    DO I=1,NDM
       U(NDM+I)=V(I)
    ENDDO
    U(NDIM)=PAR(ICP(2))

    DEALLOCATE(DFU,F,V)
    NODIR=1
  END SUBROUTINE STPNHBF

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSEQ(AP,ICP,U,NDIM,PAR,ITEST,ATYPE) RESULT(Q)

    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    Q=FNCSEQF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FUNI)

  END FUNCTION FNCSEQ

! ------ --------- -------- -------
  DOUBLE PRECISION FUNCTION FNCSEQF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FUNI) &
       RESULT(Q)

    USE SUPPORT, ONLY: AA=>P0V, PI
    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    DOUBLE PRECISION KAPPA

    Q=0.d0
    ATYPE=''
    SELECT CASE(ITEST)
    CASE(0)
       IF(AP%ITPST==3)THEN
          ! Monitor period via PAR(11) on Hopf bifurcations
          KAPPA=U(NDIM-1)
          IF(KAPPA>0)THEN
             PAR(11)=PI(2.d0)/SQRT(KAPPA)
          ENDIF
       ENDIF
       Q=FNCSAEF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FUNI)
    CASE(1:3)
       Q=FNCSAEF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FUNI)
    CASE(4) ! Check for Bogdanov-Takens bifurcation
       Q=FNBTEQ(AP,ATYPE,U,AA)
    CASE(5) ! Check for generalized Hopf (Bautin)
       Q=FNGHEQ(AP,PAR,ICP,ATYPE,FUNI,U,AA)
    CASE(6) ! Check for Hopf or Zero-Hopf
       Q=FNHBEQ(AP,PAR,ATYPE,AA)
    END SELECT

  END FUNCTION FNCSEQF

! ---------- --------
  SUBROUTINE PRINTEIG(AP)

    USE SUPPORT, ONLY : EVV
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP

    INTEGER i,NTOP

    IF(AP%IID>0)THEN
       NTOP=MOD(AP%NTOT-1,9999)+1
       WRITE(9,102)ABS(AP%IBR),NTOP+1,AP%NINS
       DO i=1,AP%NDM
          WRITE(9,103)ABS(AP%IBR),NTOP+1,I,EVV(i)
       ENDDO
    ENDIF

102 FORMAT(/,I4,I6,9X,'Eigenvalues  :   Stable:',I4)
103 FORMAT(I4,I6,9X,'Eigenvalue',I3,":",2ES14.5)

  END SUBROUTINE PRINTEIG

! ---------- ------
  SUBROUTINE STABEQ(AP,AA,EV,NINS,LOC,N)
 
    ! determine stability given eigenvalues
    ! the eigenvalues are sorted by real part
    ! on output, NINS contains the number of negative (within tolerance)
    !  eigenvalues, and LOC the position of the eigenvalue nth-closest
    !  to 0 (the (n-1)th closest are assumed to be close to 0 already)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    COMPLEX(KIND(1.0D0)), INTENT(INOUT) :: EV(:)
    DOUBLE PRECISION, INTENT(IN) :: AA(AP%NDIM+1,AP%NDIM+1)
    INTEGER, INTENT(OUT) :: NINS, LOC
    INTEGER, INTENT(IN) :: N
! Local
    INTEGER NDM,I,j,k,k1,ITPST,LOCS(N)
    DOUBLE PRECISION a,AR,AREV,tol,trace
    COMPLEX(KIND(1.0D0)) ZTMP

    NDM=AP%NDM
    ITPST=AP%ITPST

! Set tolerance for deciding if an eigenvalue is in the positive
! half-plane. Use, for example, tol=1d-3 for conservative systems.

! Try to guess whether the system is probably conservative or definitely not:
! the dimension is even and the trace 0 if it is conservative.
! In that case we use a tolerance to avoid detecting spurious
! Hopf bifurcations.

    tol=0.d0
    IF(MOD(NDM,2)==0)THEN
       trace=0.d0
       DO I=1,NDM
          trace=trace+AA(i,i)
       ENDDO
       a=0.d0
       DO i=1,NDM
          DO j=1,NDM
             IF(ABS(AA(i,j))>a)THEN
                a=ABS(AA(i,j))
             ENDIF
          ENDDO
       ENDDO
       IF(ABS(trace)<HMACH*a)THEN
          tol=1.d-5
       ENDIF
    ENDIF

! Order the eigenvalues by real part first, and, for purely imaginary
! eigenvalues in conservative systems, by imaginary part second.

    DO I=1,NDM-1
       LOC=I
       DO J=I+1,NDM
          IF(ABS(REAL(EV(J)))<tol.AND.ABS(REAL(EV(LOC)))<tol)THEN
             IF(ABS(AIMAG(EV(J)))>=ABS(AIMAG(EV(LOC))))THEN
                LOC=J
             ENDIF
          ELSEIF(REAL(EV(J))>=REAL(EV(LOC)))THEN
             LOC=J
          ENDIF
       ENDDO
       IF(LOC>I) THEN
          ZTMP=EV(LOC)
          EV(LOC)=EV(I)
          EV(I)=ZTMP
       ENDIF
    ENDDO

! Compute the nth smallest real part in magnitude.

    LOCS(:)=0
    DO J=1,N
       AREV=HUGE(AREV)
       DO I=1,NDM
          K1=0
          DO K=1,N-1
             IF(I==LOCS(K))THEN
                K1=K
                EXIT
             ENDIF
          ENDDO
          IF(K1==0.AND.(AIMAG(EV(I)).NE.0.d0.OR.ITPST/=0))THEN
             AR=ABS(REAL(EV(I)))
             IF(AR.LE.AREV)THEN
                AREV=AR
                LOCS(J)=I
             ENDIF
          ENDIF
       ENDDO
    ENDDO
    LOC=LOCS(N)

! Count the number of eigenvalues with negative real part.

    NINS=0
    DO I=1,NDM
       IF(REAL(EV(I)).LE.tol)THEN
          NINS=NINS+1
       ELSE
          DO J=1,N-1
             IF(I==LOCS(J))THEN
                NINS=NINS+1
             ENDIF
          ENDDO
       ENDIF
    ENDDO
  END SUBROUTINE STABEQ

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNHBEQ(AP,PAR,ATYPE,AA)

    USE SUPPORT, ONLY: PI, EVV, EIG, CHECKSP, LBTYPE

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: AA(AP%NDIM+1,AP%NDIM+1)
! Local
    COMPLEX(KIND(1.0D0)), ALLOCATABLE :: EV(:)
    DOUBLE PRECISION, ALLOCATABLE :: AAA(:,:)
    INTEGER NDM,ISP,IID,IBR,NTOT,NTOP,NINS,LOC,ITPST
    DOUBLE PRECISION RIMHB,REV

    NDM=AP%NDM
    ISP=AP%ISP
    IID=AP%IID
    IBR=AP%IBR
    ITPST=AP%ITPST
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1
    ALLOCATE(EV(NDM))

! INITIALIZE

    FNHBEQ=0d0
    ATYPE=''

! Compute the eigenvalues of the Jacobian

    ALLOCATE(AAA(NDM,NDM))
    AAA(:,:)=AA(1:NDM,1:NDM)
    CALL EIG(AP,NDM,NDM,AAA,EV)
    DEALLOCATE(AAA)

    IF(ITPST==3)THEN ! HB
       CALL STABEQ(AP,AA,EV,NINS,LOC,3)
    ELSEIF(ITPST==2)THEN
       CALL STABEQ(AP,AA,EV,NINS,LOC,2)
    ELSE
       CALL STABEQ(AP,AA,EV,NINS,LOC,1)
    ENDIF
    EVV(:)=EV(:)

    ! do not detect special bifs on BP curves or if BT already detected
    IF(ITPST==1.OR.MOD(AP%ITP,10)==-1)GOTO 100

    REV=0.d0
    IF(LOC>0)THEN
       REV=REAL(EV(LOC))
       IF(ITPST==0)THEN ! plain Hopf bif, not Zero-Hopf
          RIMHB=ABS(AIMAG(EV(LOC)))
          IF(RIMHB>0)PAR(11)=PI(2.d0)/RIMHB
       ENDIF
    ENDIF

    IF(ITPST==0)THEN
       ATYPE='HB'
    ELSEIF(ITPST==2.OR.ITPST==3)THEN
       ATYPE='ZH' ! Check for Zero-Hopf
    ENDIF
    IF(.NOT.CHECKSP(ATYPE,AP%IPS,AP%ILP,ISP))THEN
       ATYPE=''
    ELSE
       FNHBEQ=REV
       IF(IID>=2)WRITE(9,101)ABS(IBR),NTOP+1,FNHBEQ
    ENDIF
    AP%HBFF=FNHBEQ
    IF(LEN_TRIM(ATYPE)>0)THEN
       IF(ITPST==3)THEN ! detect zero on Zero-Hopf
          IF(NINS==AP%NINS)ATYPE(3:3)='0'
       ELSE             ! detect plain Hopf or Hopf on LP
          IF(ABS(NINS-AP%NINS)<2)ATYPE(3:3)='0'
       ENDIF
    ENDIF
100 AP%NINS=NINS
    CALL PRINTEIG(AP)
    DEALLOCATE(EV)

101 FORMAT(I4,I6,9X,'Hopf Function:',ES14.5)

  END FUNCTION FNHBEQ

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNBTEQ(AP,ATYPE,U,AA)

    USE SUPPORT, ONLY: CHECKSP

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: U(AP%NDIM), AA(AP%NDIM+1,AP%NDIM+1)
! Local
    INTEGER NTOP

    FNBTEQ = 0
    ATYPE=''
    IF(.NOT.CHECKSP('BT',AP%IPS,AP%ILP,AP%ISP))THEN
       RETURN
    ENDIF

    IF(AP%ITPST==2)THEN
       ! BT on Fold curve
       FNBTEQ=FNBTAE(AP,U,AA)
    ELSEIF(AP%ITPST==3)THEN
       ! BT on Hopf curve
       FNBTEQ = U(AP%NDIM-1)
    ELSE
       RETURN
    ENDIF
    ATYPE='BT'

    NTOP=MOD(AP%NTOT-1,9999)+1
    IF(AP%IID.GE.2)WRITE(9,101)ABS(AP%IBR),NTOP+1,FNBTEQ
101 FORMAT(I4,I6,9X,'BT   Function:',ES14.5)

  END FUNCTION FNBTEQ

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNGHEQ(AP,PAR,ICP,ATYPE,FUNI,U,AA)

    ! Evaluate first Lyapunov coefficient for Bautin (GH) bifurcations
    ! and to determine if the Hopf is subcritical or supercritical.

    USE SUPPORT, ONLY: NRMLZ, NLVC, GEL, CHECKSP

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: U(AP%NDIM),AA(AP%NDIM+1,AP%NDIM+1)
    INTEGER, INTENT(IN) :: ICP(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
! Local
    DOUBLE PRECISION, ALLOCATABLE :: pR(:),qR(:),pI(:),qI(:),sR(:),sI(:),r(:)
    DOUBLE PRECISION, ALLOCATABLE :: a(:),b(:),c(:),abc(:),tmp(:)
    DOUBLE PRECISION, ALLOCATABLE :: f1(:),f2(:),x(:),SMAT(:,:),A1(:,:)
    DOUBLE PRECISION alpha,beta,DUM(1),h,omega,DET,phi
    DOUBLE PRECISION delta1,delta2,delta3,delta4,Delta
    DOUBLE PRECISION gamma1,gamma2,gamma3,gamma4,Gamma
    DOUBLE PRECISION sigma1,sigma2,Sigma
    INTEGER n,i,NTOP

    FNGHEQ = 0
    ATYPE = ''
    IF(AP%ISW/=2.OR.AP%ITPST/=3.OR..NOT.CHECKSP('GH',AP%IPS,AP%ILP,AP%ISP))THEN
       RETURN
    ENDIF
    ! do not try to compute first Lyapunov coefficient if BT already detected
    IF(MOD(AP%ITP,10)==-1)RETURN
    IF((U(AP%NDIM-1))<=0)RETURN
    omega = SQRT(U(AP%NDIM-1))

    n = AP%NDM
    ALLOCATE(pI(n),pR(n),qR(n),qI(n),sR(n),sI(n),f1(n),f2(n),x(n),r(n))
    ALLOCATE(a(n),b(n),c(n),abc(2*n),tmp(2*n),SMAT(2*n,2*n),A1(n,n))

    h = 0.d0
    DO i = 1,n
       IF(ABS(U(i))>h) h = ABS(U(i))
    ENDDO
    h = (EPSILON(h)**(1d0/3))*(1+h)

    ! Following Kuznetsov, Elements of Applied Bif. Theory, 3rd Ed., 10.2
    ! Step 1
    qR = U(n+1:2*n)
    ! qI=-AA.qR/omega
    CALL DGEMV('N',n,n,-1/omega,AA,AP%NDIM+1,qR,1,0d0,qI,1)

    ! normalize so that <qR,qI>=0
    phi = ATAN2(-2*DOT_PRODUCT(qR,qI),1-DOT_PRODUCT(qI,qI))/2
    alpha = COS(phi)
    beta = SIN(phi)
    tmp(:n) = alpha*qR-beta*qI
    tmp(n+1:) = alpha*qI+beta*qR

    ! normalize so that <qR,qR>+<qI,qI>=1
    CALL NRMLZ(2*n,tmp)
    qR = tmp(:n)
    qI = tmp(n+1:)

    ! compute pR,pI
    SMAT(:,:) = 0.d0
    DO i = 1,n
       SMAT(I,n+i) = -OMEGA
       SMAT(n+I,I) = OMEGA
    ENDDO
    DO i = 1,n
       SMAT(1:n,i) = AA(i,1:n)
    ENDDO
    SMAT(n+1:2*n,n+1:2*n) = SMAT(1:n,1:n)
    CALL NLVC(2*n,2*n,2,SMAT,tmp)
    pR = tmp(:n)
    pI = tmp(n+1:)

    ! normalize so that <pR,qI>-<pI,qR>=0
    alpha = DOT_PRODUCT(pR,qR)+DOT_PRODUCT(pI,qI)
    beta = DOT_PRODUCT(pI,qR)-DOT_PRODUCT(pR,qI)
    tmp(:n) = alpha*pR+beta*pI
    tmp(n+1:) = alpha*pI-beta*pR

    ! normalize so that <pR,qR>+<pI,qI>=1
    tmp(:) = tmp(:)/(DOT_PRODUCT(tmp(:n),qR(:))+DOT_PRODUCT(tmp(n+1:),qI(:)))
    pR = tmp(:n)
    pI = tmp(n+1:)

    ! Step 2
    a = DERIV2a(qR)
    b = DERIV2a(qI)
    c = DERIV2b(qR, qI)
    c = c/4

    ! Step 3
    A1(:,:) = AA(1:n,1:n)
    f1(:) =  a+b
    CALL GEL(n,A1,1,r,f1,DET)
    SMAT(:,:) = 0d0
    DO i = 1,n
       SMAT(i,n+i) = -2*omega
       SMAT(n+i,i) = 2*omega
    ENDDO
    SMAT(1:n,1:n) = -AA(1:n,1:n)
    SMAT(n+1:2*n,n+1:2*n) = SMAT(1:n,1:n)
    abc(:n) = a-b
    abc(n+1:) = 2*c
    CALL GEL(2*n,SMAT,1,tmp,abc,DET)
    sR = tmp(:n)
    sI = tmp(n+1:)

    ! Step 4
    sigma1 = DERIV2c(pR, qR, r)/4
    sigma2 = DERIV2c(pI, qI, r)/4
    Sigma = sigma1+sigma2

    ! Step 5
    delta1 = DERIV2c(pR, qR, sR)/4
    delta2 = DERIV2c(pR, qI, sI)/4
    delta3 = DERIV2c(pI, qR, sI)/4
    delta4 = DERIV2c(pI, qI, sR)/4
    Delta = delta1+delta2+delta3-delta4

    ! Step 6
    ! adjust h for third order derivatives
    h = h * EPSILON(h)**(-1d0/12)
    gamma1 = DERIV3(pR, qR)
    gamma2 = DERIV3(pI, qI)
    sR = pR + pI
    sI = qR + qI
    gamma3 = DERIV3(sR, sI)
    sR = pR - pI
    sI = qR - qI
    gamma4 = DERIV3(sR, sI)
    Gamma = ((gamma1+gamma2)*2)/3 + (gamma3+gamma4)/6

    ! Step 7
    FNGHEQ = (Gamma-2*Sigma+Delta)/(2*omega)

    DEALLOCATE(pI,pR,qR,qI,sR,sI,f1,f2,x,r,a,b,c,abc,tmp,SMAT,A1)
    ATYPE='GH'

    IF(AP%IID>=2)THEN
       NTOP=MOD(AP%NTOT-1,9999)+1
       WRITE(9,"(I4,I6,9X,A,ES14.5)",ADVANCE="no")&
            ABS(AP%IBR),NTOP+1,'GH   Function:',FNGHEQ
       IF(FNGHEQ>0)THEN
          WRITE(9,'(A)')' (subcritical)'
       ELSEIF(FNGHEQ<0)THEN
          WRITE(9,'(A)')' (supercritical)'
       ELSE
          WRITE(9,*)
       ENDIF
    ENDIF

    CONTAINS
      
      FUNCTION FN(x) RESULT(f)
        DOUBLE PRECISION, INTENT(INOUT) :: x(n)
        DOUBLE PRECISION f(size(x))

        CALL FUNI(AP,n,x,x,ICP,PAR,0,f,dum,dum)
      END FUNCTION FN

      FUNCTION DERIV2a(p) RESULT(d)
        DOUBLE PRECISION, INTENT(IN) :: p(n)
        DOUBLE PRECISION d(size(p))

        x(:) = U(:n) + h*p
        f1 = FN(x)
        x(:) = U(:n) - h*p
        f2 = FN(x)
        d = (f1+f2)/h**2
      END FUNCTION DERIV2a

      FUNCTION DERIV2b(p, q) RESULT(d)
        DOUBLE PRECISION, INTENT(IN) :: p(n), q(n)
        DOUBLE PRECISION d(size(p))

        x(:) = U(:n) + h*(p+q)
        f1 = FN(x)
        x(:) = U(:n) + h*(p-q)
        f2 = FN(x)
        d = f1-f2

        x(:) = U(:n) - h*(p+q)
        f1 = FN(x)
        x(:) = U(:n) - h*(p-q)
        f2 = FN(x)
        d = (d + f1-f2)/h**2
      END FUNCTION DERIV2b

      FUNCTION DERIV2c(p, q, r) RESULT(d)
        DOUBLE PRECISION, INTENT(IN) :: p(n), q(n), r(n)
        DOUBLE PRECISION d

        x(:) = U(:n) + h*(q+r)
        f1 = FN(x)
        x(:) = U(:n) + h*(q-r)
        f2 = FN(x)
        d = DOT_PRODUCT(p, f1-f2)

        x(:) = U(:n) - h*(q+r)
        f1 = FN(x)
        x(:) = U(:n) - h*(q-r)
        f2 = FN(x)
        d = (d + DOT_PRODUCT(p, f1-f2))/h**2
      END FUNCTION DERIV2c

      FUNCTION DERIV3(p, q) RESULT(d)
        DOUBLE PRECISION, INTENT(IN) :: p(n), q(n)
        DOUBLE PRECISION d

        x(:) = U(:n) + 3*h*q
        f1 = FN(x)
        d = DOT_PRODUCT(p,f1)

        x(:) = U(:n) + h*q
        f1 = FN(x)
        d = d - 3*DOT_PRODUCT(p, f1)

        x(:) = U(:n) - h*q
        f1 = FN(x)
        d = d + 3*DOT_PRODUCT(p, f1)

        x(:) = U(:n) - 3*h*q
        f1 = FN(x)
        d = (d-DOT_PRODUCT(p, f1))/(8*h**3)
      END FUNCTION DERIV3

  END FUNCTION FNGHEQ

END MODULE EQUILIBRIUM

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!     brf  :  A parabolic PDE (the Brusselator)
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!     (Discretized in space by fourth order finite differences)
!---------------------------------------------------------------------- 
!----------------------------------------------------------------------
! NOTE: The value of the constant NE is defined below in a module.
!
!      NE  :  the dimension of the PDE system
!
!      NX  :  the number of space intervals for the discretization is
!             derived from the AUTO-constant NDIM:
!             NX = NDIM/NE + 1
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      MODULE brf
        SAVE
        INTEGER, PARAMETER :: NE=2
        DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:) :: DI,DD
      END MODULE brf

      SUBROUTINE FF(NE,U,PAR,F) 
!     ---------- -- 
!     Define the nonlinear term

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NE
      DOUBLE PRECISION, INTENT(IN) :: U(NE),PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NE)

      DOUBLE PRECISION X,Y,A,B

        X=U(1)
        Y=U(2)
        A=PAR(1)
        B=PAR(2)

        F(1)= X**2*Y - (B+1)*X + A
        F(2)=-X**2*Y + B*X

      END SUBROUTINE FF

      SUBROUTINE SETDC(NE,DC,PAR) 
!     ---------- ----- 
!     Set the diffusion constants (constant, or in terms of PAR)

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NE
      DOUBLE PRECISION, INTENT(OUT) :: DC(NE)
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)

        DC(1)=PAR(3)/PAR(5)**2
        DC(2)=PAR(4)/PAR(5)**2

      END SUBROUTINE SETDC

      SUBROUTINE SETBC(NE,PAR,U0,U1) 
!     ---------- ----- 
! Set the boundary values (to be kept fixed in time)

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NE
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: U0(NE),U1(NE)

      DOUBLE PRECISION A,B

        A=PAR(1)
        B=PAR(2)

        U0(1)=A
        U0(2)=B/A
        U1(1)=A
        U1(2)=B/A


      END SUBROUTINE SETBC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 
! Define the starting stationary solution on the spatial mesh

      USE brf
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM/NE,NE),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION A,B,Dx,Dy,RL
      INTEGER I,NX

! Set the parameter values
        A=2.d0
        B=5.45d0
        Dx=0.008d0
        Dy=0.004d0
        RL=0.4

        PAR(1)=A
        PAR(2)=B
        PAR(3)=Dx
        PAR(4)=Dy
        PAR(5)=RL

! Set the starting solution at space-points i/NX, i=1,2,...,NX-1
        NX=NDIM/NE+1
        DO I=1,NX-1
          U(I,1)=A
          U(I,2)=B/A
        ENDDO

      END SUBROUTINE STPNT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!                Problem-independent subroutines
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      USE brf
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM/NE,NE), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM/NE,NE)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION W(NE),FW(NE),DC(NE)
      DOUBLE PRECISION U0(NE),U1(NE),F0(NE),F1(NE),V(NDIM/NE,NE)

      INTEGER I,J,K,NN,NX

! Problem-independent initialization :

        CALL SETDC(NE,DC,PAR)
        CALL SETBC(NE,PAR,U0,U1)
        CALL FF(NE,U0,PAR,F0)
        CALL FF(NE,U1,PAR,F1)

        NN=NDIM/NE
        NX=NN+1
        DO I=1,NN
          DO J=1,NE
            V(I,J)= DI(I, 1)*( DC(J)*NX**2*U0(J) + F0(J)/12 ) &
                  + DI(I,NN)*( DC(J)*NX**2*U1(J) + F1(J)/12 )
          ENDDO
        ENDDO

        DO I=1,NN
          DO K=1,NE
            W(K)=U(I,K)
          ENDDO
          CALL FF(NE,W,PAR,FW)
          DO J=1,NE
            F(I,J)=V(I,J) + FW(J)
            DO K=1,NN
              F(I,J)=F(I,J)+DC(J)*DD(I,K)*U(K,J)
            ENDDO
          ENDDO
        ENDDO

      END SUBROUTINE FUNC

      SUBROUTINE GENCF(PAR,NN)
!     ---------- -----

      USE brf
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NN
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)

      INTEGER NX,I,J,K
      DOUBLE PRECISION S,DET
      INTEGER, ALLOCATABLE :: IR(:),IC(:)
      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:) :: D0,D2,RI

      ALLOCATE(DI(NN,NN),DD(NN,NN))
      ALLOCATE(IR(NN),IC(NN),D0(NN,NN),D2(NN,NN),RI(NN,NN))
      NX=NN+1
      D0(:,:)=0
      D2(:,:)=0
      RI(:,:)=0
      DO I=1,NN
        D0(I,I)=10.d0/12.d0
        D2(I,I)=-2*NX**2
        RI(I,I)=1
      ENDDO

      DO I=1,NN-1
        D0(I+1,I)=1.d0/12.d0
        D0(I,I+1)=1.d0/12.d0
        D2(I+1,I)=NX**2
        D2(I,I+1)=NX**2
      ENDDO

      ! calculate DI = D0^{-1} and DD = D0^{-1} D2
      CALL GE(0,NN,NN,D0,NN,NN,DI,NN,RI,IR,IC,DET)
      DD = MATMUL(DI,D2)

      DEALLOCATE(IR,IC,D0,D2,RI)

      END SUBROUTINE GENCF

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      USE brf
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      LOGICAL, SAVE :: ifrst = .TRUE.

! Problem-independent initialization :
      IF(ifrst)THEN
         CALL GENCF(PAR,NDIM/NE)
         ifrst=.FALSE.
      ENDIF

      END SUBROUTINE PVLS

C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C    PLAUT : A program for plotting AUTO Unit 7 and Unit 8 Output
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C    AUTHORS :       - WILLIAM R. MORRILL  (MAY  15, 1982)
C                    - PATRICK P.C. LEUNG  (NOV.  3, 1982) MODIFIED
C                    - MIKE MIKALAJUNAS    (FEB.  1, 1984) MODIFIED
C                    - NGUYEN, THANH LONG  (JUN.  1, 1985) MODIFIED + 3D
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  THE MAIN PROGRAM SETS UP INITIAL USER OPTIONS. IT READS AND DECODES
C  USER OPTIONS AND COMMANDS, SETTING THE APPROPRIATE FLAGS IN COMMON
C  AREA /UOPTS/ AND CALLS SUBROUTINES TO EXECUTE THE INDICATED COMMAND.
C  USER OPTIONS CAN BE SEPARATE FROM OR PREFIXED TO THE BASIC COMMAND
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C---
       USE COMPAT
       CHARACTER*80 ISTR,OSTR,PART2*2,INB,INS
       CHARACTER*4 TTITLE*80,BTITLE*80
     * ,XLAB*80,YLAB*80
       CHARACTER*1 CH,NOTC*10
       LOGICAL DFT,USR,PLTR,BRNCH,POINT,TIT,AXLB,QLBS,GRIDS,DP
       LOGICAL TOP,BOTTOM,CHECKB,CHECKQ,SAVE,SYMBOL
       LOGICAL QSCOM,CAXIS,ERRQ,INTGLB,DDIM,IBD2
       LOGICAL B3DC
       INTEGER ERROR,XAXS,YAXS,PARRY(1999)
       INTEGER SPLPT,NVX(2)
       INTEGER SLAB(1999),ERROR8,ICD(4)
       INTEGER SYMBL(10),ITP(10)
       INTEGER ENLAB(1999),ICDS(4),ID2D(1999),IDS2D(1999)
       REAL IX,IY,MINSX,MAXSX,MINSY,MAXSY
       COMMON /LABLS/TTITLE,BTITLE,XLAB,YLAB
       COMMON /PLVARS/ IX,IY,X,Y,XMIN,XMAX,YMIN,YMAX,MINSX,MAXSX,
     * MINSY,MAXSY,NVX,SPLPT
       COMMON /UOPTS/DFT,USR,BRNCH,
     * ICL,ICT,TOP,BOTTOM,TIT,AXLB,QLBS,GRIDS,DP
       COMMON /IO/ IWRITE,ITERM,ISAVE
       COMMON /QSC/ QSCOM
       COMMON /PLOTT/ PLTR,POINT
       COMMON /INKA/ CAXIS
       COMMON /LBQ/ SLAB,NLAB,NAXIS,ENLAB,NUMLB
       COMMON /DIFFA/ DDIM
       COMMON /IAOCS/ RIDASH,RIDOT,RICIR,RISYBL,RIDIS,RIDSHS
       COMMON /UTDSH/ UDSH,UDSHS,ULD,USD,RIDS1
       COMMON /BD2/ IBD2
       COMMON /RADI/ RASY,RATY,RADI,RADINC
       COMMON /SY2D/ ID2D,IDS2D
       COMMON /BDSY/ ITP,SYMBL
       COMMON /AXB3D/ IB3DX,IB3DY,IB3DZ
       COMMON /CB3D/ B3DC
       COMMON /SPNUM/ SP1,SP2,SP3,SP4
C---
       IF(AUTARGC()==2)THEN
         CALL AUTGETARG(1,INB)
         CALL AUTGETARG(2,INS)
       ELSE
         INB='fort.17'
         INS='fort.18'
       ENDIF
       OPEN(17,FILE=INB,STATUS='unknown',ACCESS='sequential')
       OPEN(18,FILE=INS,STATUS='unknown',ACCESS='sequential')
C
       IWRITE = 6
       ITERM  = 6
       ISAVE  = 16
       NVX(1) = 1
       NVX(2) = 2
       XLAB   = ' '
       YLAB   = ' '
       TTITLE = ' '
       BTITLE = ' '
       CHECKB = .FALSE.
       CHECKQ = .FALSE.
       USR    = .FALSE.
       DFT    = .FALSE.
       QLBS   = .FALSE.
       PLTR   = .FALSE.
       POINT  = .FALSE.
       BRNCH  = .FALSE.
       DP     = .FALSE.
       SYMBOL = .FALSE.
       QSCOM  = .FALSE.
       CAXIS  = .FALSE.
       ERRQ   = .FALSE.
       INTGLB = .TRUE.
       DDIM   = .FALSE.
       IBD2   = .FALSE.
       B3DC   = .FALSE.
       SAVE   = .FALSE.
       ICD(1) = 1
       ICD(2) = 2
       ICD(3) = 3
       ICD(4) = 4
       IB3DX  = 1
       IB3DY  = 3
       IB3DZ  = 4
       CALL IBDSY(ITP,SYMBL)
       CALL ICDS0(ICDS)
C---                                    *SCREEN SIZE
       CALL DFREV
       CALL DFITVL
C---                                    *RELATIVE DIMENSION
       CALL DFSCR(MINSX,MAXSX,MINSY,MAXSY)
       OSTR = ' ENTER <HELP> IN CASE OF DIFFICULTY'
       WRITE(IWRITE,1)OSTR
 10    OSTR = ' ENTER COMMAND'
       WRITE(IWRITE,1)OSTR
       CALL READS8(ISTR)
C---                                    *TERMINATION
 11    IF(ISTR.EQ.'STOP'.OR.ISTR.EQ.'stop'.OR.
     +    ISTR.EQ.'EXIT'.OR.ISTR.EQ.'exit'.OR.
     +    ISTR.EQ.'QUIT'.OR.ISTR.EQ.'quit'.OR.
     +    ISTR.EQ.'END' .OR.ISTR.EQ.'end') STOP
C---                                    *SCREEN
       IF(ISTR.EQ.'SCR'.OR.ISTR.EQ.'SCREEN'.OR.
     +    ISTR.EQ.'scr'.OR.ISTR.EQ.'screen') THEN
         WRITE(ITERM,46) MINSX,MAXSX,MINSY,MAXSY,SP1
         READ(5,*,END=10,ERR=10) MINSX,MAXSX,MINSY,MAXSY
         GO TO 10
       END IF
C---                                    *SET SYMBOL
       IF (ISTR.EQ.'SS'.OR.ISTR.EQ.'ss'.OR.
     +     ISTR.EQ.'SET SYM'.OR.ISTR.EQ.'set sym') THEN
         RADI = RASY
         CALL SHWSYS
         GO TO 10
       END IF
C---                                    *SET DIFFERENTIAL PLOTS
         IF (ISTR.EQ.'SD '.OR.ISTR.EQ.'sd ') THEN
           CALL SDFPLT(ICD,ICDS)
           ITS = 1
           GOTO 10
         ENDIF
C---                                    *LABEL
       IF (ISTR.EQ.'LAB'.OR.ISTR.EQ.'LABEL'.OR.
     +     ISTR.EQ.'lab'.OR.ISTR.EQ.'label') THEN
         CALL GERR (ERRQ,IERR8,ERROR8,INTGLB,1)
         GO TO 10
       END IF
C---                                    *CLEAR
       IF (ISTR.EQ.'C'.OR.ISTR.EQ.'c'.OR.
     +     ISTR.EQ.'CL'.OR.ISTR.EQ.'cl'.OR.
     +     ISTR.EQ.'CLR'.OR.ISTR.EQ.'clr'.OR.
     +     ISTR.EQ.'CLEAR'.OR.ISTR.EQ.'clear') THEN
         CALL PLCMDS(1)
         CALL PLCHDW(3)
         GO TO 10
       END IF
C---                                    *SAVE
       IF (ISTR.EQ.'SAVE'.OR.ISTR.EQ.'save'.OR.
     +     ISTR.EQ.'SAV' .OR.ISTR.EQ.'sav' .OR.
     +     ISTR.EQ.'SA'  .OR.ISTR.EQ.'sa'  .OR.
     +     ISTR.EQ.'S'   .OR.ISTR.EQ.'s'   ) THEN
C---                                    *SAVE COMMAND FOR "BD"
         IF (CHECKB) THEN
           SAVE = .FALSE.
           CALL ASKSVE(SAVE)
	   IF (SAVE) CALL CRFLNM(1)
           CALL BDS(ISTR,I+2,SAVE,ICDS,ICD,SYMBOL)
           CALL PLCHDW(3)
	   IF (SAVE) CALL CRFLNM(2)
           CALL ASKSVE(SAVE)
           CHECKB = .FALSE.
         ELSE IF (CHECKQ) THEN
C---                                    *SAVE COMMAND FOR "2D"
           IWRITE = ISAVE
	   IF (SAVE) CALL CRFLNM(1)
           CALL SPAGE
           CALL DRW2D(XAXS,YAXS,PARRY,ERROR,NUM,POINT,PLTR)
           CALL PLCHDW(3)
	   IF (SAVE) CALL CRFLNM(2)
            IWRITE = ITERM
           CALL COMPLT
           CHECKQ = .FALSE.
         END IF
         GO TO 10
       END IF
C---                                    *HELP
       IF (ISTR.EQ.'HELP'.OR.ISTR.EQ.'help') THEN
         CALL HELPS(ISTR)
         IF(ISTR.NE.' ') GO TO 11
         GO TO 10
       END IF
C---                                    *SHOW SYMBOL
       IF (ISTR.EQ.'SY    '.OR.ISTR.EQ.'sy    '.OR.
     +     ISTR.EQ.'SYM   '.OR.ISTR.EQ.'sym   '.OR.
     +     ISTR.EQ.'SYMBOL'.OR.ISTR.EQ.'symbol') THEN
         SYMBOL = .TRUE.
         GO TO 10
       END IF
C---                                    *SYMBOL
       I = 1
       DO 100 J=1,6
         PART2 = ISTR(I:I+1)
         IF (PART2.EQ.'SY'.OR.PART2.EQ.'sy')  THEN
           SYMBOL = .TRUE.
           ITS    = 1
         END IF
         I = I + 2
 100   CONTINUE
C---                                    *DIFFERENTIAL PLOTS
         I = 1
         DO 103 J=1,6
           PART2 = ISTR(I:I+1)
           IF (PART2.EQ.'DP'.OR.PART2.EQ.'dp') THEN
             DP  = .TRUE.
             ITS = 1
           END IF
           I = I + 2
 103     CONTINUE
C---                                    *VERTICAL AXIS
       I = 1
       DO 105 J=1,6
         PART2 = ISTR(I:I+1)
         IF (PART2.EQ.'AX'.OR.PART2.EQ.'ax') THEN
       OSTR = ' ENTER HORIZONTAL AND VERTICAL AXIS NUMBER (1,2,...) :'
         WRITE(IWRITE,1)OSTR
         READ(5,*,ERR=10)(NVX(L),L=1,2)
         ITS  = 1
         IBD2 = .FALSE.
       ENDIF
       I = I + 2
 105   CONTINUE
C---                                    *SET TITLES
       I = 1
       DO 106 J=1,6
         PART2 = ISTR(I:I+1)
         IF (PART2.EQ.'ST'.OR.PART2.EQ.'st') THEN
           CALL ENTGRD(1)
           TIT  = .TRUE.
           AXLB = .TRUE.
           QLBS = .FALSE.
           ITS = 1
         END IF
         I = I + 2
 106   CONTINUE
C---                                    *D0
       I = 1
       DO 107 J=1,6
         PART2 = ISTR(I:I+1)
         IF (PART2.EQ.'D0'.OR.PART2.EQ.'d0') THEN
           DFT    = .TRUE.
           USR    = .FALSE.
           BRNCH  = .FALSE.
           POINT  = .FALSE.
           TIT    = .FALSE.
           TOP    = .FALSE.
           BOTTOM = .FALSE.
           AXLB   = .FALSE.
           QLBS   = .TRUE.
           GRIDS  = .FALSE.
           SYMBOL = .TRUE.
           DP     = .FALSE.
           ICD(1) = 1
           ICD(2) = 1
           ICD(3) = 1
           ICD(4) = 1
           ITS    = 1
           CALL ICDS0(ICDS)
         END IF
         I = I + 2
 107   CONTINUE
C---                                    *D1
       I = 1
       DO 108 J=1,6
         PART2 = ISTR(I:I+1)
         IF (PART2.EQ.'D1'.OR.PART2.EQ.'d1') THEN
           DFT    = .TRUE.
           USR    = .FALSE.
           BRNCH  = .FALSE.
           POINT  = .TRUE.
           TIT    = .FALSE.
           TOP    = .FALSE.
           BOTTOM = .FALSE.
           AXLB   = .FALSE.
           QLBS   = .TRUE.
           GRIDS  = .FALSE.
           SYMBOL = .TRUE.
           DP     = .TRUE.
           ICD(1) = 1
           ICD(2) = 2
           ICD(3) = 1
           ICD(4) = 2
           ITS    = 1
           CALL ICDS0(ICDS)
         END IF
         I = I + 2
 108   CONTINUE
C---                                    *D2
       I = 1
       DO 109 J=1,6
         PART2    = ISTR(I:I+1)
         IF (PART2.EQ.'D2'.OR.PART2.EQ.'d2') THEN
           DFT    = .TRUE.
           USR    = .FALSE.
           BRNCH  = .FALSE.
           POINT  = .FALSE.
           TIT    = .FALSE.
           TOP    = .FALSE.
           BOTTOM = .FALSE.
           AXLB   = .FALSE.
           QLBS   = .TRUE.
           GRIDS  = .FALSE.
           SYMBOL = .TRUE.
           DP     = .TRUE.
           ICD(1) = 1
           ICD(2) = 2
           ICD(3) = 1
           ICD(4) = 2
           ITS    = 1
           CALL ICDS0(ICDS)
         END IF
         I = I + 2
 109   CONTINUE
C---                                    *D3
       I = 1
       DO 110 J=1,6
         PART2    = ISTR(I:I+1)
         IF (PART2.EQ.'D3'.OR.PART2.EQ.'d3') THEN
           DFT    = .TRUE.
           USR    = .FALSE.
           BRNCH  = .FALSE.
           POINT  = .TRUE.
           TIT    = .FALSE.
           TOP    = .FALSE.
           BOTTOM = .FALSE.
           AXLB   = .FALSE.
           QLBS   = .TRUE.
           GRIDS  = .TRUE.
           SYMBOL = .TRUE.
           DP     = .TRUE.
           ICD(1) = 1
           ICD(2) = 2
           ICD(3) = 1
           ICD(4) = 2
           ITS    = 1
           CALL ICDS0(ICDS)
         END IF
         I = I + 2
 110   CONTINUE
C---                                    *D4
       I = 1
       DO 111 J=1,6
         PART2    = ISTR(I:I+1)
         IF (PART2.EQ.'D4'.OR.PART2.EQ.'d4') THEN
           DFT    = .TRUE.
           USR    = .FALSE.
           BRNCH  = .FALSE.
           POINT  = .FALSE.
           TIT    = .FALSE.
           TOP    = .FALSE.
           BOTTOM = .FALSE.
           AXLB   = .FALSE.
           QLBS   = .TRUE.
           GRIDS  = .TRUE.
           SYMBOL = .TRUE.
           DP     = .TRUE.
           ICD(1) = 1
           ICD(2) = 2
           ICD(3) = 1
           ICD(4) = 2
           ITS    = 1
           CALL ICDS0(ICDS)
         END IF
         I = I + 2
 111   CONTINUE
C---                                    *NU (NORMAL USE)
       I = 1
       DO 112 J=1,6
         PART2    = ISTR(I:I+1)
         IF (PART2.EQ.'NU'.OR.PART2.EQ.'nu') THEN
           DFT    = .FALSE.
           USR    = .FALSE.
           DP     = .FALSE.
           QLBS   = .FALSE.
           SYMBOL = .FALSE.
           CALL DFSCR(MINSX,MAXSX,MINSY,MAXSY)
           ICD(1) = 1
           ICD(2) = 2
           ICD(3) = 3
           ICD(4) = 4
           ITS    = 1
           IBD2   = .FALSE.
         END IF
         I = I + 2
 112   CONTINUE
C---                                    *"EXPERT"
         I = 1
         DO 113 J=1,6
           PART2 = ISTR(I:I+1)
           IF (PART2.EQ.'XP'.OR.PART2.EQ.'xp') THEN
             USR  = .TRUE.
             DFT  = .FALSE.
             QLBS = .FALSE.
             ITS  = 1
             IBD2 = .FALSE.
           END IF
           I = I + 2
 113     CONTINUE
C---                                    *EXECUTE BD COMMANDS
         I = 1
         DO 114 J=1,6
           PART2 = ISTR(I:I+1)
           IF (PART2.EQ.'BD'.OR.PART2.EQ.'bd') THEN
             IP2=I+2
             CALL BDS(ISTR,IP2,SAVE,ICDS,ICD,SYMBOL)
             CALL PLCHDW(3)
             CHECKB = .TRUE.
             ITS    = 0
             GO TO 10
           END IF
           I = I + 2
 114     CONTINUE
C---                                    *EXECUTE B3D
         IF (ISTR.EQ.'B3D'.OR.ISTR.EQ.'b3d') THEN
           QSCOM = .TRUE.
           CALL EXB3D
           QSCOM = .FALSE.
           IBD2  = .FALSE.
           GO TO 10
         END IF
C---                                    *EXECUTE HELP <3D>
        IF (ISTR.EQ.'HELP3D'.OR.ISTR.EQ.'help3d'.OR.
     +      ISTR.EQ.'H3D   '.OR.ISTR.EQ.'h3d   ') THEN
          CALL LIST3D
          OSTR = ' <RETURN> FOR MORE DETAIL ON <3D> COMMANDS'
          WRITE(IWRITE,1) OSTR
          READ(5,20,END=10) NOTC
 20       FORMAT(A10)
          IF (NOTC.NE.' ') GO TO 10
          CALL HELP3D(NOTC,0)
          GO TO 10
        END IF
C---                                    *EXECUTE <2D>
        I = 1
        PART2 = ISTR(I:I+1)
        IF (PART2.EQ.'3D'.OR.PART2.EQ.'3d') THEN
          CALL GERR(ERRQ,IERR8,ERROR8,INTGLB,3)
          IF (ERROR8.NE.0) GO TO 10
          QSCOM = .TRUE.
          CH    = ISTR(3:3)
          IF (CH.EQ.' ') I = I+1
          CALL C2D3D(ISTR,I+2,XAXS,YAXS,PARRY,NUM,CHECKQ)
          QSCOM = .FALSE.
          IBD2  = .FALSE.
          GO TO 10
        END IF
C---
        IF (PART2.EQ.'2D'.OR.PART2.EQ.'2d') THEN
          CALL GERR(ERRQ,IERR8,ERROR8,INTGLB,2)
          IF (ERROR8.NE.0) GO TO 10
          CH  = ISTR(3:3)
          IF (CH.EQ.' ') I = I+1
          CALL C2D3D(ISTR,I+2,XAXS,YAXS,PARRY,NUM,CHECKQ)
          ITS  = 1
          IBD2 = .FALSE.
          TIT  = .FALSE.
          AXLB = .FALSE.
          GO TO 10
        END IF
C---                                    *DASHED LINES
       IF (ISTR.EQ.'SDA'.OR.ISTR.EQ.'sda') THEN
         CALL DEFINE(RIDASH,1)
         GO TO 10
       END IF
C---                                    *DOTTED LINES
       IF (ISTR.EQ.'SDO'.OR.ISTR.EQ.'sdo') THEN
         CALL DEFINE(RIDOT,2)
         GO TO 10
       END IF
C---                                    *CIRCLES
       IF (ISTR.EQ.'SCI'.OR.ISTR.EQ.'sci') THEN
         CALL DEFINE(RICIR,3)
         GO TO 10
       END IF
C---                                    *SYMBOLS
       IF (ISTR.EQ.'SSY'.OR.ISTR.EQ.'ssy') THEN
         CALL DEFINE(RISYBL,4)
         GO TO 10
       END IF
C---                                    *PLOTTING ACCURACY
       IF (ISTR.EQ.'PA'.OR.ISTR.EQ.'pa') THEN
         CALL DEFINE(RIDIS,5)
         GO TO 10
       END IF
C---                                    *DASH-DOT
       IF (ISTR.EQ.'SDD'.OR.ISTR.EQ.'sdd') THEN
         CALL DEFINE(RIDSHS,6)
         GO TO 10
       END IF
C---                                    *LONG-SHORT DASH
       IF (ISTR.EQ.'SLS'.OR.ISTR.EQ.'sls') THEN
         CALL DEFINE(RIDS1,6)
         GO TO 10
       END IF
C---                                    *DASHES
       IF (ISTR.EQ.'LDA'.OR.ISTR.EQ.'lda') THEN
         OSTR = ' DASH LENGTH IS '
         WRITE(ITERM,2) OSTR(1:15),UDSH
         OSTR = ' ENTER NEW DASH LENGTH '
         WRITE(ITERM,1) OSTR
         READ(5,*,ERR=10) UNIT
         IF (UNIT.LT.1.AND.UNIT.GT.0) THEN
           UDSH = UNIT
         ELSE
           OSTR = ' ERROR, DASH LENGTH MUST SATISFY : 0 < LENGTH < 1'
           WRITE(ITERM,1) OSTR
         END IF
         GO TO 10
       END IF
C---                                    *DASHES
       IF (ISTR.EQ.'US'.OR.ISTR.EQ.'us') THEN
         OSTR = ' DASH LENGTH IS '
         WRITE(ITERM,2) OSTR(1:15),UDSHS
         OSTR = ' ENTER NEW LENGTH'
         WRITE(ITERM,1) OSTR
         READ(5,*,ERR=10) UNIT
         IF (UNIT.LT.1.AND.UNIT.GT.0) THEN
           UDSHS = UNIT
         ELSE
           OSTR = ' ERROR, DASH LENGTH MUST SATISFY :  0 < LENGTH < 1'
           WRITE(ITERM,1) OSTR
         END IF
         GO TO 10
       END IF
C---                                    *LONG-SHORT DASH
       IF (ISTR.EQ.'LLS'.OR.ISTR.EQ.'lss') THEN
         OSTR = ' LONG AND SHORT DASH LENGTHS ARE : '
         WRITE(ITERM,2) OSTR(1:33),ULD,USD
         OSTR = ' ENTER NEW LENGTHS'
         WRITE(ITERM,1) OSTR
         OSTR = ' '
         READ(5,*,ERR=10) UNIT1,UNIT2
         IF (UNIT1.LE.0.OR.UNIT2.LE.0) THEN
           OSTR = '  ERROR - 0 < LONG, SHORT DASH < 1'
         ELSE IF (UNIT1.GE.1.OR.UNIT2.GE.1) THEN
           OSTR = '  ERROR - 0 < LONG, SHORT DASH < 1'
         ELSE IF ((UNIT1+UNIT2).GE.1) THEN
           OSTR = '  ERROR - 0 < LONG, SHORT DASH < 1'
         ELSE
           ULD = UNIT1
           USD = UNIT2
         END IF
         IF (OSTR.NE.' ') WRITE(6,1) OSTR
         GO TO 10
       END IF
C---                                    *RADIUS OF SYMBOL IN <SS>
       IF (ISTR.EQ.'RSS'.OR.ISTR.EQ.'rss') THEN
         CALL DFRADI(RASY,1)
         GO TO 10
       END IF
C---                                    *RADIUS OF SYMBOL IN <SD>
       IF (ISTR.EQ.'RCS'.OR.ISTR.EQ.'rcs') THEN
         CALL DFRADI(RATY,2)
         GO TO 10
       END IF
C---                                    *RESET
       IF (ISTR.EQ.'RES'.OR.ISTR.EQ.'res') THEN
         CALL DFITVL
         GO TO 10
       END IF
       IF(ITS.EQ.0) THEN
         OSTR = ' ILLEGAL COMMAND - REENTER'
       ELSE IF (ITS.EQ.1.AND.ISTR(3:3).EQ.' ') THEN
         OSTR = ' '
         ITS  = 0
       END IF
       WRITE(ITERM,1) OSTR
       GO TO 10
 1     FORMAT(A80)
 2     FORMAT(A,2F7.3)
 46    FORMAT(/,' THE DEFAULT SETTING FOR THE RELATIVE DIMENSION OF',
     + ' THE SCREEN IS :',//,' MIN(X) =',F8.2,4X,'MAX(X) =',F8.2,
     + 4X,'MIN(Y) =',F8.2,4X,'MAX(Y) =',F8.2,//,
     + ' ENTER THE NEW SCREEN DIMENSION SUCH THAT MIN(X) >',F8.2)
       END
C---
C-----------------------------------------------------------------------
C     LISTS THE POSSIBLE COMMANDS.
C-----------------------------------------------------------------------
       SUBROUTINE HELPS(ISTR)
       CHARACTER*80 ISTR
       COMMON /IO/ IWRITE,ITERM,ISAVE
C---
       CALL PLCMDS(1)
       WRITE(ITERM,1)
 1     FORMAT(
     +       /,'         Principal PLAUT Commands :'
     +    ,///,'  <BD0>   Bifurcation diagram with default limits'
     +     ,//,'  <BD>    Bifurcation diagram with user-limits'
     +     ,//,'  <AX>    To select bifurcation diagram axes'
     +     ,//,'  <2D>    2D plot of labeled solutions'
     +     ,//,'  <SAV>   To save the current plot in a file'
     +     ,//,'  <CL>    To clear the graphics window'
     +     ,//,'  <LAB>   List all labeled solutions in Unit 8'
     +     ,//,'  <END>   To End PLAUT'
     +    ,///,'  Press RETURN for more or Enter Command ...'
     +      )
C
       CALL READS8(ISTR)
       IF(ISTR.NE.' ') RETURN
C---
       CALL PLCMDS(1)
       WRITE(ITERM,2)
 2     FORMAT(
     +       /,'        PLAUT Default Options :'
     +    ,///,'  <D0>    Use solid curves, symbols, but no labels'
     +     ,//,'  <D1>    As <D0>, showing stability and labels' 
     +     ,//,'  <D2>    As <D1>, without labels'
     +     ,//,'  <D3>    As <D1>, with grid lines'
     +     ,//,'  <D4>    AS <D2>, with grid lines'
     +    ,///,'        Individual Options :'
     +    ,///,'  <SY>    Use symbols for special points'
     +     ,//,'  <DP>    Differential Plot (show stability)'
     +     ,//,'  <ST>    Set up titles and axes labels'
     +     ,//,'  <NU>    Normal usage (Reset special options)'
     +    ,///,'  Press RETURN for more or Enter Command ...'
     +      )
C
       CALL READS8(ISTR)
       IF(ISTR.NE.' ') RETURN
C---
       CALL PLCMDS(1)
       WRITE(ITERM,3)
 3     FORMAT(
     +       /,'        Additional PLAUT Commands :'
     +    ,///,'  <SCR>   To change the plot size'
     +      ,/,'  <SS>    To define symbols'
     +      ,/,'  <RSS>   Set symbol size'
     +      ,/,'  <XP>    "Expert" (Abbreviated prompts)'
     +      ,/,'  <SD>    To change curve type'
     +     ,//,'  <SDA>   Set dash spacing'
     +      ,/,'  <LDA>   Set dash size'
     +      ,/,'  <SDO>   Set dot spacing'
     +      ,/,'  <SCI>   Set circle spacing'
     +      ,/,'  <SSY>   Set curve-symbol spacing'
     +      )
       WRITE(ITERM,4)
 4     FORMAT( '  <RCS>   Set curve-symbol size'
     +      ,/,'  <SDD>   Set dash-dot spacing'
     +      ,/,'  <SLS>   Set long-short dash spacing'
     +      ,/,'  <LLS>   Set long-short dash size'
     +      ,/,'  <PA>    Set plotting accuracy'
     +      ,/,'  <RES>   Reset curves and symbols'
     +    ,///,'  <3D>    3D plot of labeled solutions'
     +      ,/,'  <B3D>   3D bifurcation diagram'
     +      ,/,'  <H3D>   For list of <3D> and <B3D> commands'
     +    ,///,'         --- End of Help ---',//
     +      )
C---
       RETURN
       END
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   she : Heteroclinic Orbits In a Model of Shearing Instabilities
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

      INTEGER I,J
      DOUBLE PRECISION P11SS,T02CS,P12CS,P01CS,A01CS,MUS,Q,SIGMA,ZETA,PI2

      P11SS=U(1)
      T02CS=U(2)
      P12CS=U(3)
      P01CS=U(4)
      A01CS=U(5)

      MUS=PAR(1)
      Q=PAR(2)
      SIGMA=PAR(3)
      ZETA=PAR(4)
      PI2=3.141592654D0*3.141592654D0

      F(1)=P11SS*T02CS+P11SS*MUS-P12CS*P01CS 
      F(2)=-(P11SS**2+T02CS)
      F(3)=P12CS*MUS+P11SS*P01CS-9*SIGMA*P12CS/(4*(SIGMA+1))
      F(4)=(-Q*SIGMA*A01CS/PI2-SIGMA*P01CS+(3*P11SS*P12CS*(1+1/SIGMA)))/4
      F(5)=ZETA*(P01CS-A01CS)/4

      IF(IJAC.EQ.0)RETURN

      DFDU(1,1)=T02CS+MUS    
      DFDU(1,2)=P11SS
      DFDU(1,3)=-P01CS
      DFDU(1,4)=-P12CS
      DFDU(1,5)=0

      DFDU(2,1)=-2*P11SS
      DFDU(2,2)=-1
      DFDU(2,3:5)=0

      DFDU(3,1)=P01CS
      DFDU(3,3)=MUS-9*SIGMA/(4*(SIGMA+1))
      DFDU(3,4)=P11SS
      DFDU(3,5)=0

      DFDU(4,1)=3*P12CS*(SIGMA+1)/(4*SIGMA)
      DFDU(4,2)=0
      DFDU(4,3)=3*P11SS*(SIGMA+1)/(4*SIGMA)
      DFDU(4,4)=-SIGMA/4
      DFDU(4,5)=-Q*SIGMA/(4*PI2)

      DFDU(5,1:3)=0
      DFDU(5,4)=ZETA/4
      DFDU(5,5)=-ZETA/4

      IF(IJAC.EQ.1)RETURN 

      DFDP(1,1)=P11SS
      DFDP(1,2:4)=0

      DFDP(3,1)=P12CS
      DFDP(3,2)=0
      DFDP(3,3)=-9*P12CS/(4*(SIGMA+1)**2)
      DFDP(3,4)=0

      DFDP(4,1)=0
      DFDP(4,2)=-SIGMA*A01CS/(4*PI2)
      DFDP(4,3)=(-Q*A01CS/PI2-P01CS-3*P11SS*P12CS/SIGMA**2)/4
      DFDP(4,4)=0

      DFDP(5,1:3)=0
      DFDP(5,4)=(P01CS-A01CS)/4

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T
! 
!----------------------------------------------------------------------
! Problem parameters (only PAR(1-9) are available to the user) :

       PAR(1)=0.163875d0          ! mu
       PAR(2)=0.0d0               ! q
       PAR(3)=0.5d0               ! sigma
       PAR(4)=0.2                 ! zeta

       PAR(11)=85.07              ! Truncated time interval 

!----------------------------------------------------------------------
! If IEQUIB =-2 put initial approximations to equilibria in 
!   PAR(11+i), i=1,...,NDIM :        left-hand equilibrium
!   PAR(11+i), i=NDIM+1,...,2*NDIM   right-hand equilibrium                    

       PAR(12) = 0.4048147d0
       PAR(13) = -0.163875d0
       PAR(14) = 0.0
       PAR(15) = 0.0
       PAR(16) = 0.0

       PAR(17) = 0.0
       PAR(18) = 0.0
       PAR(19) = 0.0
       PAR(20) = 0.0
       PAR(21) = 0.0

      END SUBROUTINE STPNT

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
! Homoclinic bifurcations COMMON block needed here :
      COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      INTEGER I

! If IEQUIB =-1 put analytic expressions for equilibria in
!   PAR(11+i), i=1,..,NDIM         left-hand equilibrium
!   PAR(11+i), i=NDIM+1,...,2*NDIM right-hand equilibrium
      IF(IEQUIB.EQ.-1)THEN
        PAR(12)=DSQRT(PAR(1))
        PAR(13)=-PAR(1)
        PAR(14)=0.0d0
        PAR(15)=0.0d0
        PAR(16)=0.0d0
        DO I=NDIM+1,2*NDIM
          PAR(11+I)= 0.0
        ENDDO
      ENDIF

      END SUBROUTINE PVLS

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for the Continuation of general algebraic equations
!        (incl. BPs and Folds)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
MODULE TOOLBOXAE

  USE AUTO_CONSTANTS, ONLY : AUTOPARAMETERS
  USE AE
  USE INTERFACES
  USE SUPPORT

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: AUTOAEP,INITAE,STPNAE,FNCSAE,FNCSAEF,FNBTAE
  PUBLIC :: FNLP,FNLPF,STPNLP,STPNLPF ! Folds (Algebraic Problems)
  PUBLIC :: FNBP,FNBPF,STPNBP,STPNBPF ! Branch points

  DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

CONTAINS

! ---------- ------
  SUBROUTINE INITAE(AP)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP

    INTEGER NDIM, NFPR

    NDIM = AP%NDIM
    NFPR = 1
    SELECT CASE(AP%ITPST)
    CASE(1)
       ! ** BP cont (Algebraic Problems) (by F. Dercole)
       NDIM=2*NDIM+2
       NFPR=ABS(AP%ISW)
    CASE(2)
       ! ** Fold
       NDIM=2*NDIM+1
       NFPR=2
    END SELECT
    AP%NDIM = NDIM
    AP%NFPR = NFPR

  END SUBROUTINE INITAE

! ---------- -------
  SUBROUTINE AUTOAEP(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    CALL INITAE(AP)

    SELECT CASE(AP%ITPST)
    CASE(0)
       ! Algebraic systems.
       CALL AUTOAE(AP,ICP,ICU,FUNI,STPNAE,FNCSAE)
    CASE(1)
       ! ** BP cont (algebraic problems) (by F. Dercole).
       CALL AUTOAE(AP,ICP,ICU,FNBP,STPNBP,FNCSAE)
    CASE(2)
       ! ** Fold continuation (algebraic problems).
       CALL AUTOAE(AP,ICP,ICU,FNLP,STPNLP,FNCSAE)
    END SELECT
  END SUBROUTINE AUTOAEP

! ---------- ------
  SUBROUTINE STPNUS(AP,PAR,U,UDOT,NODIR)

! Gets the starting data from user supplied STPNT

    USE AUTO_CONSTANTS, ONLY : UVALS, PARVALS, unames, parnames
    USE SUPPORT, ONLY: NAMEIDX
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: U(*),UDOT(*),PAR(*)

    INTEGER NDIM,I
    DOUBLE PRECISION T

    NDIM=AP%NDIM
    T=0.d0
    U(:NDIM)=0.d0

    CALL STPNT(NDIM,U,PAR,T)

! override parameter/point values with values from constants file

    DO I=1,SIZE(UVALS)
       U(NAMEIDX(UVALS(I)%INDEX,unames))=UVALS(I)%VAR
    ENDDO
    DO I=1,SIZE(PARVALS)
       PAR(NAMEIDX(PARVALS(I)%INDEX,parnames))=PARVALS(I)%VAR
    ENDDO

    UDOT(1)=0
    NODIR=1
    
  END SUBROUTINE STPNUS

! ---------- ------
  SUBROUTINE STPNAE(AP,PAR,ICP,U,UDOT,NODIR)

    USE IO

    ! Gets the starting data from unit 3
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: U(*),UDOT(*),PAR(*)

    INTEGER NFPR,NFPRS,I
    INTEGER,ALLOCATABLE :: ICPRS(:)

    IF(AP%IRS==0)THEN
       CALL STPNUS(AP,PAR,U,UDOT,NODIR)
       RETURN
    ENDIF

    NFPRS=GETNFPR3()
    ALLOCATE(ICPRS(NFPRS))
    ICPRS(:)=0
    CALL READLB(AP,ICPRS,U,UDOT,PAR)
  
    ! Take care of the case where the free parameters have been changed at
    ! the restart point.

    NODIR=0
    NFPR=AP%NFPR
    IF(NFPRS/=NFPR)THEN
       NODIR=1
    ELSE
       DO I=1,NFPR
          IF(ICPRS(I)/=ICP(I)) THEN
             NODIR=1
             EXIT
          ENDIF
       ENDDO
    ENDIF
    DEALLOCATE(ICPRS)

  END SUBROUTINE STPNAE

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  Subroutines for the Continuation of Folds (Algebraic Problems)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNLP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-par continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNLPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

  END SUBROUTINE FNLP

! ---------- -----
  SUBROUTINE FNLPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

    ! Generates the equations for the 2-par continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),FF1(:),FF2(:)
    INTEGER NDM,NPAR,I,II,J,IJC
    DOUBLE PRECISION UMX,EP,P,UU,DUMDP(1)

    NDM=AP%NDM
    NPAR=AP%NPAR

    IF(NDIM==NDM)THEN ! reduced function for Cusp detection
       CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,0,F,DFDU,DFDP)
       RETURN
    ENDIF

    ! Generate the function.

    IF(IJAC==0)THEN
       IJC=IJAC
    ELSE
       IJC=2
    ENDIF
    CALL FFLP(AP,NDIM,U,UOLD,ICP,PAR,IJC,F,NDM,DFDU,DFDP,FUNI)

    IF(IJAC.EQ.0)RETURN

    ! Generate the Jacobian.

    UMX=0.d0
    DO I=1,NDM
       IF(DABS(U(I)).GT.UMX)UMX=DABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,AP%NPAR,NDM,NDIM)
    DFDU(1:NDM,NDM+1:2*NDM)=0d0
    DFDU(1:NDM,NDIM)=DFDP(:,ICP(2))

    DFDU(NDM+1:2*NDM,NDM+1:2*NDM)=DFDU(1:NDM,1:NDM)
    IF(AP%ITPST==7)THEN ! PD bif for maps
       DO I=1,NDM
          DFDU(NDM+I,NDM+I)=DFDU(NDM+I,NDM+I)+2
       ENDDO
    ENDIF

    DFDU(NDIM,1:NDM)=0d0
    DFDU(NDIM,NDM+1:2*NDM)=2*U(NDM+1:NDM*2)
    DFDU(NDIM,NDIM)=0d0

    ALLOCATE(DFU(NDM,NDM),FF1(NDIM),FF2(NDIM))
    DO II=1,NDM+1
       I=II
       IF(I>NDM)I=NDIM
       UU=U(I)
       U(I)=UU-EP
       CALL FFLP(AP,NDIM,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DUMDP,FUNI)
       U(I)=UU+EP
       CALL FFLP(AP,NDIM,U,UOLD,ICP,PAR,0,FF2,NDM,DFU,DUMDP,FUNI)
       U(I)=UU
       DO J=NDM+1,2*NDM
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(FF1,DFU)
       RETURN
    ENDIF
    P=PAR(ICP(1))
    PAR(ICP(1))=P+EP

    CALL FFLP(AP,NDIM,U,UOLD,ICP,PAR,0,FF1,NDM,DFU,DUMDP,FUNI)

    DO J=NDM+1,2*NDM
       DFDP(J,ICP(1))=(FF1(J)-F(J))/EP
    ENDDO
    DFDP(NDIM,ICP(1))=0d0

    PAR(ICP(1))=P
    DEALLOCATE(FF1,DFU)

  END SUBROUTINE FNLPF

! ---------- ----
  SUBROUTINE FFLP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,NDM,DFDU,DFDP,FUNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NDM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    include 'interfaces.h'

    INTEGER IJC,I,J

    PAR(ICP(2))=U(NDIM)
    IJC=MAX(IJAC,1)
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IJC,F,DFDU,DFDP)

    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(I,J)*U(NDM+J)
       ENDDO
    ENDDO
    IF(AP%ITPST==7)THEN ! PD bif for maps
       DO I=1,NDM
          F(NDM+I)=F(NDM+I)+2*U(NDM+I)
       ENDDO
    ENDIF

    F(NDIM)=-1

    DO I=1,NDM
       F(NDIM)=F(NDIM)+U(NDM+I)*U(NDM+I)
    ENDDO

  END SUBROUTINE FFLP

! ---------- -------
  SUBROUTINE STPNLP(AP,PAR,ICP,U,UDOT,NODIR)

    ! Generates starting data for the continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNLPF(AP,PAR,ICP,U,UDOT,NODIR,FUNI)

  END SUBROUTINE STPNLP

! ---------- -------
  SUBROUTINE STPNLPF(AP,PAR,ICP,U,UDOT,NODIR,FUNI)

    USE IO
    USE SUPPORT

    ! Generates starting data for the continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),V(:),F(:)
    DOUBLE PRECISION DUMDFP(1)
    INTEGER ICPRS(2),NDIM,NDM,I

    NDIM=AP%NDIM
    NDM=AP%NDM

    IF(ABS(AP%ITP)/10>0)THEN
       ! restart
       CALL STPNAE(AP,PAR,ICP,U,UDOT,NODIR)
       U(NDIM)=PAR(ICP(2))
       RETURN
    ENDIF

    CALL READLB(AP,ICPRS,U,UDOT,PAR)

    ALLOCATE(DFU(NDM,NDM),V(NDM),F(NDM))
    CALL FUNI(AP,NDM,U,U,ICP,PAR,1,F,DFU,DUMDFP)
    IF(AP%ITPST==7)THEN ! PD bif for maps
       DO I=1,NDM
          DFU(I,I)=DFU(I,I)+2
       ENDDO
    ENDIF
    CALL NLVC(NDM,NDM,1,DFU,V)
    CALL NRMLZ(NDM,V)
    DO I=1,NDM
       U(NDM+I)=V(I)
    ENDDO
    DEALLOCATE(DFU,V,F)
    U(NDIM)=PAR(ICP(2))
    NODIR=1

  END SUBROUTINE STPNLPF

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!   Subroutines for BP cont (Algebraic Problems) (by F. Dercole)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNBP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-par continuation of BP.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNBPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

  END SUBROUTINE FNBP

! ---------- -----
  SUBROUTINE FNBPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FUNI)

    ! Generates the equations for the 2-par continuation of BP.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    include 'interfaces.h'
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:),DFP(:),FF1(:),FF2(:)
    INTEGER NDM,NPAR,I,II,J
    DOUBLE PRECISION UMX,EP,P,UU

    NDM=AP%NDM
    NPAR=AP%NPAR

    ! Generate the function.

    CALL FFBP(AP,NDIM,U,UOLD,ICP,PAR,F,NDM,DFDU,DFDP,FUNI)

    IF(IJAC.EQ.0)RETURN

    ! Generate the Jacobian.

    ! derivatives for F(x,p)=0 (5)
    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    CALL EXPANDJAC(DFDP,AP%NPAR,NDM,NDIM)
    DFDU(1:NDM,NDM+1:2*NDM)=0d0
    DFDU(1:NDM,NDIM-1)=DFDP(1:NDM,ICP(2))

    IF(AP%ISW==2) THEN
       !        ** Non-generic case, derivatives of b phi^* in (18)
       DO I=1,NDM
          DFDU(I,NDM+I)=U(NDIM) ! b
          DFDU(I,NDIM)=U(NDM+I) ! phi^*
       ENDDO
       DFDU(NDM+1:2*NDM,NDIM)=0 ! d(13a)/db
       DFDU(NDIM-1,NDIM)=0      ! d(13b)/db
    ELSE
       DFDU(1:NDM,NDIM)=DFDP(1:NDM,ICP(3)) ! (5)
    ENDIF

    DO I=1,NDM
       DFDU(NDM+I,NDM+1:2*NDM)=DFDU(1:NDM,I) ! F_x(x,p)^T (13a)
    ENDDO
    DFDU(NDIM-1,NDM+1:2*NDM)=DFDP(1:NDM,ICP(1)) ! F_p(x,p)^T (13b)

    ! derivatives for (13c)
    DFDU(NDIM,1:NDM)=0d0
    DFDU(NDIM,NDM+1:2*NDM)=2*U(NDM+1:NDM*2)
    DFDU(NDIM,NDIM-1:NDIM)=0

    UMX=0.d0
    DO I=1,NDIM
       IF(ABS(U(I))>UMX)UMX=ABS(U(I))
    ENDDO

    EP=HMACH*(1+UMX)

    ALLOCATE(FF1(NDIM),FF2(NDIM),DFU(NDM*NDM),DFP(NDM*NPAR))
    DO II=1,NDM+2
       I=II
       IF(I>NDM)I=II+NDM
       IF(I==NDIM.AND.AP%ISW==2)EXIT ! Non-generic
       UU=U(I)
       U(I)=UU-EP
       CALL FFBP(AP,NDIM,U,UOLD,ICP,PAR,FF1,NDM,DFU,DFP,FUNI)
       U(I)=UU+EP
       CALL FFBP(AP,NDIM,U,UOLD,ICP,PAR,FF2,NDM,DFU,DFP,FUNI)
       U(I)=UU
       DO J=NDM+1,NDIM-1
          DFDU(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DEALLOCATE(FF2)
    IF(IJAC.EQ.1)THEN
       DEALLOCATE(FF1,DFU,DFP)
       RETURN
    ENDIF
    P=PAR(ICP(1))
    PAR(ICP(1))=P+EP

    CALL FFBP(AP,NDIM,U,UOLD,ICP,PAR,FF1,NDM,DFU,DFP,FUNI)

    DO J=NDM+1,NDIM-1
       DFDP(J,ICP(1))=(FF1(J)-F(J))/EP
    ENDDO
    DFDP(NDIM,ICP(1))=0

    PAR(ICP(1))=P
    DEALLOCATE(FF1,DFU,DFP)

  END SUBROUTINE FNBPF

! ---------- ----
  SUBROUTINE FFBP(AP,NDIM,U,UOLD,ICP,PAR,F,NDM,DFDU,DFDP,FUNI)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NDM
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDM,NDM),DFDP(NDM,*)
    include 'interfaces.h'

    INTEGER ISW,I,J

    ISW=AP%ISW

    IF(ISW.EQ.3) THEN
       !        ** Generic case
       PAR(ICP(3))=U(NDIM)
    ENDIF
    PAR(ICP(2))=U(NDIM-1)

    ! (5) F(x,p) = 0
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,2,F,DFDU,DFDP)

    IF(ISW.EQ.2) THEN
       !        ** Non-generic case (18) F(x,p) + b phi^* = 0
       DO I=1,NDM
          F(I)=F(I)+U(NDIM)*U(NDM+I)
       ENDDO
    ENDIF

    ! (13a) F_x(x,p)^T phi^* = 0
    DO I=1,NDM
       F(NDM+I)=0.d0
       DO J=1,NDM
          F(NDM+I)=F(NDM+I)+DFDU(J,I)*U(NDM+J)
       ENDDO
    ENDDO

    ! (13b) F_p(x,p)^T phi^* = 0
    F(NDIM-1)=0.d0
    DO I=1,NDM
       F(NDIM-1)=F(NDIM-1)+DFDP(I,ICP(1))*U(NDM+I)
    ENDDO

    ! (13c) <phi^*,phi^*> - 1 = 0
    F(NDIM)=-1
    DO I=1,NDM
       F(NDIM)=F(NDIM)+U(NDM+I)*U(NDM+I)
    ENDDO

  END SUBROUTINE FFBP

! ---------- ------
  SUBROUTINE STPNBP(AP,PAR,ICP,U,UDOT,NODIR)

    ! Generates starting data for the continuation of BP.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNBPF(AP,PAR,ICP,U,UDOT,NODIR,FUNI)

  END SUBROUTINE STPNBP

! ---------- -------
  SUBROUTINE STPNBPF(AP,PAR,ICP,U,UDOT,NODIR,FUNI)

    USE IO
    USE SUPPORT

    ! Generates starting data for the continuation of BP.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)
    include 'interfaces.h'

    ! Local
    DOUBLE PRECISION, ALLOCATABLE ::DFU(:,:),DFP(:,:),A(:,:),V(:),F(:)
    INTEGER :: ICPRS(3),NDIM,ISW,NDM,NPAR,I,J

    NDIM=AP%NDIM
    ISW=AP%ISW
    NDM=AP%NDM
    NPAR=AP%NPAR

    IF(ABS(AP%ITP)/10>0)THEN
       ! restart
       CALL STPNAE(AP,PAR,ICP,U,UDOT,NODIR)
       U(NDIM-1)=PAR(ICP(2))
       IF(ISW==3) THEN 
          U(NDIM)=PAR(ICP(3)) ! Generic case
       ELSE
          U(NDIM)=0.d0        ! Non-generic case
       ENDIF
       RETURN
    ENDIF

    CALL READLB(AP,ICPRS,U,UDOT,PAR)

    ALLOCATE(DFU(NDM,NDM),DFP(NDM,NPAR),A(NDM,NDM+1))
    ALLOCATE(V(NDM+1),F(NDM))
    CALL FUNI(AP,NDM,U,U,ICP,PAR,2,F,DFU,DFP)
    A(:,1:NDM)=DFU(:,:)
    A(:,NDM+1)=DFP(:,ICP(1))
    CALL NLVC(NDM,NDM+1,2,A,V)
    DEALLOCATE(A)
    ALLOCATE(A(NDM+1,NDM+1))
    DO I=1,NDM
       DO J=1,NDM
          A(I,J)=DFU(J,I)
       ENDDO
       A(NDM+1,I)=DFP(I,ICP(1))
    ENDDO
    DO I=1,NDM+1
       A(I,NDM+1)=V(I)
    ENDDO
    CALL NLVC(NDM+1,NDM+1,1,A,V)
    CALL NRMLZ(NDM,V)
    DO I=1,NDM
       U(NDM+I)=V(I)
    ENDDO
    DEALLOCATE(DFU,DFP,A,V,F)
    U(NDIM-1)=PAR(ICP(2))
    IF(ISW.EQ.3) THEN
       !        ** Generic case
       U(NDIM)=PAR(ICP(3))
    ELSE
       !        ** Non-generic case
       U(NDIM)=0.d0
    ENDIF

    NODIR=1
  END SUBROUTINE STPNBPF

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSAE(AP,ICP,U,NDIM,PAR,ITEST,ATYPE) RESULT(Q)

    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    Q=FNCSAEF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FUNI)

  END FUNCTION FNCSAE

! ------ --------- -------- -------
  DOUBLE PRECISION FUNCTION FNCSAEF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FUNI) &
       RESULT(Q)

    USE SUPPORT, ONLY: AA=>P0V, PI
    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    Q=0.d0
    ATYPE=''
    SELECT CASE(ITEST)
    CASE(0)
       CALL PVLSI(AP,U,NDIM,PAR)
    CASE(1) ! Check for fold
       Q=FNLPAE(AP,ATYPE,AA)
    CASE(2) ! Check for branch point
       Q=FNBPAE(AP,ATYPE)
    CASE(3) ! Check for cusp on fold
       Q=FNCPAE(AP,PAR,ICP,ATYPE,FUNI,U,AA)
    END SELECT

  END FUNCTION FNCSAEF

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNBPAE(AP,ATYPE)

    USE SUPPORT, ONLY: CHECKSP

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    INTEGER IID,IBR,NTOT,NTOP
    DOUBLE PRECISION DET

    ATYPE=''
    FNBPAE=0d0
    IF(.NOT.CHECKSP('BP',AP%IPS,AP%ILP,AP%ISP))RETURN

    IID=AP%IID
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    DET=AP%DET
    FNBPAE=DET
    ATYPE='BP'

! If requested write additional output on unit 9 :

    IF(IID.GE.2)WRITE(9,101)IBR,NTOP+1,FNBPAE
101 FORMAT(I4,I6,9X,'BP   Function:',ES14.5)

  END FUNCTION FNBPAE

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNLPAE(AP,ATYPE,AA)

    USE SUPPORT

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: AA(AP%NDIM+1,AP%NDIM+1)
! Local
    DOUBLE PRECISION, ALLOCATABLE :: UD(:),AAA(:,:),RHS(:)

    INTEGER NDIM,IID,IBR,NTOT,NTOP
    DOUBLE PRECISION DET

    ATYPE=''
    FNLPAE=0d0
    IF(.NOT.CHECKSP('LP',AP%IPS,AP%ILP,AP%ISP))RETURN

    NDIM=AP%NDIM
    IID=AP%IID
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    ALLOCATE(AAA(NDIM+1,NDIM+1),RHS(NDIM+1))
    AAA(:,:)=AA(:,:)
    RHS(1:NDIM)=0.d0
    RHS(NDIM+1)=1.d0

    ALLOCATE(UD(NDIM+1))
    CALL GEL(NDIM+1,AAA,1,UD,RHS,DET)
!   don't store DET here: it is for a different matrix than
!   used with pseudo arclength continuation and sometimes has
!   a  different sign
    CALL NRMLZ(NDIM+1,UD)
    FNLPAE=UD(NDIM+1)
    DEALLOCATE(UD,AAA,RHS)
    AP%FLDF=FNLPAE
    ATYPE='LP'

! If requested write additional output on unit 9 :

    IF(IID.GE.2)WRITE(9,101)ABS(IBR),NTOP+1,FNLPAE
101 FORMAT(I4,I6,9X,'Fold Function:',ES14.5)

  END FUNCTION FNLPAE

! ---------- -------
  SUBROUTINE RNULLVC(AP,AA,V)

    ! get null vector for the transposed Jacobian for BT/CP detection

    USE SUPPORT, ONLY: NLVC, NRMLZ

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    DOUBLE PRECISION, INTENT(IN) :: AA(AP%NDIM+1,AP%NDIM+1)
    DOUBLE PRECISION, INTENT(INOUT) :: V(AP%NDM)

    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:)
    DOUBLE PRECISION, ALLOCATABLE, SAVE :: VOLD(:)
    INTEGER NDM,I

    NDM=AP%NDM
    IF(.NOT.ALLOCATED(VOLD))THEN
       ALLOCATE(VOLD(NDM))
       VOLD(:)=0
    ENDIF
    ALLOCATE(DFU(NDM,NDM))
    DO I=1,NDM
       DFU(1:NDM,I)=AA(NDM+I,NDM+1:2*NDM)
    ENDDO
    CALL NLVC(NDM,NDM,1,DFU,V)
    CALL NRMLZ(NDM,V)
    IF(DOT_PRODUCT(V,VOLD)<0)THEN
       V(:)=-V(:)
    ENDIF
    VOLD(:)=V(:)
    DEALLOCATE(DFU)
  END SUBROUTINE RNULLVC

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNBTAE(AP,U,AA)

    ! evaluate Bogdanov-Takens/1:1/1:2-resonance test function
    ! this function is used by equilibrium.f90 and maps.f90.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    DOUBLE PRECISION, INTENT(IN) :: U(AP%NDIM), AA(AP%NDIM+1,AP%NDIM+1)
! Local
    INTEGER NDM
    DOUBLE PRECISION, ALLOCATABLE :: V(:)

    FNBTAE = 0

    NDM=AP%NDM

    ! take the inner product with the null vector for the Jacobian
    ALLOCATE(V(NDM))
    CALL RNULLVC(AP,AA,V)
    FNBTAE = DOT_PRODUCT(U(NDM+1:2*NDM),V(1:NDM))
    DEALLOCATE(V)

  END FUNCTION FNBTAE

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCPAE(AP,PAR,ICP,ATYPE,FUNI,U,AA)

    USE SUPPORT, ONLY: CHECKSP

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    DOUBLE PRECISION, INTENT(IN) :: U(AP%NDIM),AA(AP%NDM)
    INTEGER, INTENT(IN) :: ICP(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
! Local
    DOUBLE PRECISION, ALLOCATABLE :: F(:),UU(:),V(:)
    DOUBLE PRECISION DUM(1),H
    INTEGER NDM,NTOP,I

    FNCPAE = 0
    ATYPE=''
    IF(AP%ISW/=2.OR.AP%ITPST/=2.OR..NOT.CHECKSP('CP',AP%IPS,AP%ILP,AP%ISP))THEN
       RETURN
    ENDIF

    NDM=AP%NDM
    ALLOCATE(UU(NDM),F(NDM),V(NDM))

    CALL RNULLVC(AP,AA,V)

    ! Evaluate cusp function:
    H=0.d0
    DO I=1,NDM
       IF(ABS(U(I))>H)H=ABS(U(I))
    ENDDO
    H=(EPSILON(H)**(1d0/3))*(1+H)

    UU(:)=U(:NDM)+U(NDM+1:2*NDM)*H
    CALL FUNI(AP,NDM,UU,UU,ICP,PAR,0,F,DUM,DUM)
    FNCPAE=DOT_PRODUCT(V(:),F(:))
    UU(:)=U(:NDM)-U(NDM+1:2*NDM)*H
    CALL FUNI(AP,NDM,UU,UU,ICP,PAR,0,F,DUM,DUM)
    FNCPAE=(FNCPAE+DOT_PRODUCT(V(:),F(:)))/H**2

    DEALLOCATE(UU,F,V)
    ATYPE='CP'

    NTOP=MOD(AP%NTOT-1,9999)+1
    IF(AP%IID.GE.2)WRITE(9,101)ABS(AP%IBR),NTOP+1,FNCPAE
101 FORMAT(I4,I6,9X,'Cusp Function:',ES14.5)

  END FUNCTION FNCPAE

END MODULE TOOLBOXAE

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   hom : Homoclinic bifurcations in general test example equation 
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      F(1)= PAR(1)*U(1) + PAR(2)*U(2) - PAR(1)*U(1)*U(1)                &
          + (PAR(8) - PAR(4)*U(3)) * U(1)*(2.0D0 - 3.0D0*U(1))
      F(2)= PAR(2)*U(1) + PAR(1)*U(2)                                   &
          - 1.5D0*PAR(2)*U(1)*U(1) - 1.5D0*PAR(1)*U(1)*U(2)             &
          - (PAR(8) - PAR(4)*U(3)) * 2.0D0*U(2)
      F(3)= PAR(3)*U(3) + PAR(7)*U(1) + PAR(6)*U(1)*U(3)                &
          + PAR(4)*PAR(5)*(U(1)*U(1)*(1.0D0-U(1))-U(2)*U(2))

      IF(IJAC.EQ.0)RETURN

      DFDU(1,1)= PAR(1) - 2.0D0*PAR(1)*U(1)                             &
          + (PAR(8)-PAR(4)*U(3)) * (2.0D0-6.0D0*U(1))
      DFDU(1,2)= PAR(2) 
      DFDU(1,3)= - PAR(4) * U(1)*(2.0D0-3.0D0*U(1))

      DFDU(2,1)= PAR(2) - 3.0D0*PAR(2)*U(1) - 1.5D0*PAR(1)*U(2)
      DFDU(2,2)= PAR(1) - 1.5D0*PAR(1)*U(1)                             &
          - (PAR(8)-PAR(4)*U(3)) * 2.0D0
      DFDU(2,3)= 2.0D0*PAR(4)*U(2)

      DFDU(3,1)= PAR(7) + PAR(6)*U(3)                                   &
          + PAR(4)*PAR(5) * U(1)*(2.0D0-3.0D0*U(1))
      DFDU(3,2)= -2.0D0*PAR(4)*PAR(5) * U(2)
      DFDU(3,3)= PAR(3) + PAR(6)*U(1)

      IF(IJAC.EQ.1)RETURN

! No parameter derivatives are specified with this example

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ----------------

! Sets parameter values for homoclinic bifurcation analysis (IPS=9).

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T
!
! COMMON block needed if IPS=9 (homoclinic bifurcations) :
      INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      DOUBLE PRECISION S

!----------------------------------------------------------------------
! Problem parameters (only PAR(1-9) are available to the user) :

        PAR(1) = 0.0D0           ! a
        PAR(2) = 1.0D0           ! b
        PAR(3) = -2.0D0          ! c
        PAR(4) = 0.0D0           ! alpha
        PAR(5) = 1.0D0           ! beta
        PAR(6) = 0.0D0           ! gamma
        PAR(7) = 0.0D0           ! mu
        PAR(8) = 0.0D0           ! tilde mu

        PAR(11)=  20.0D0         ! truncated time interval 
!----------------------------------------------------------------------
! If IEQUIB=1 then put initial equilibrium in PAR(11+i), i=1,...,NDIM :

        IF (IEQUIB.NE.0) THEN
          PAR(12) = 0.0
          PAR(13) = 0.0
          PAR(14) = 0.0
        ENDIF
!----------------------------------------------------------------------
! IF ISTART=2 then put analytic homoclinic orbit here with T in the
!   interval [0,1]
! 
! test example (a=0,b=1)

      S=(T-0.5)*PAR(11)
      U(1) = 1.0D0 - ( (1.0D0-DEXP(S))/(1.0D0+DEXP(S)) )**2
      U(2) = 4.0D0 * DEXP(S) * (1.0D0-DEXP(S)) / (1.0D0+DEXP(S))**3
      U(3) = 0.0D0

      END SUBROUTINE STPNT



      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      INTEGER I

! If IEQUIB=0 put analytic equilibrium in PAR(11+i), i=1,...,NDIM :

      DO I=1,NDIM
         PAR(11+i)=0
      ENDDO

      END SUBROUTINE PVLS

      SUBROUTINE BCND
      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

!------------------------------------------------------------
!------------------------------------------------------------
!     pla :     Plant's Model of Bursting Nerve Cells
!------------------------------------------------------------
!------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)
      DOUBLE PRECISION VI,VK,VL,VCa,gK,gL,Kp,Kc,rho,txT,zeta,gi,gP,gT
      DOUBLE PRECISION V,xT,xK,yI,c,a,b,Vs,am,ah,an,bm,bh,bn,si,sK
      DOUBLE PRECISION txK,tyI,zI,sT

       VI=30
       VK=-75
       VL=-40
       VCa=140
       gK=0.3
       gL=0.003
       Kp=0.5
       Kc=0.0085
       rho=0.0003
       txT=235
       zeta=1

       gI=PAR(1)
       gP=PAR(2)
       gT=PAR(3)

       V =U(1)
       xT=U(2)
       xK=U(3)
       yI=U(4)
       c =U(5)

       a=127/(VI-VK)
       b=(115*VK+12*VI)/(VI-VK)
       Vs=a*V-b

       am=0.1*(50-Vs)/(DEXP((50-Vs)/10)-1)
       ah=0.07*DEXP((25-Vs)/20)
       an=0.01*(55-Vs)/(DEXP((55-Vs)/10)-1)
       bm=4*DEXP((25-Vs)/18)
       bh=1./(DEXP((55-Vs)/10)+1)
       bn=0.125*DEXP((45-Vs)/80)

       sI=am/(am+bm)
       sK=an/(an+bn)
       txK=12.5/(an+bn)
       tyI=12.5/(ah+bh)
       zI=ah/(ah+bh)
       sT=1./(DEXP(0.15*(-50-V))+1)

       F(1)=  (gI*sI**3*yI + gT*xT) * (VI-V)                            &
            + (gK*xK**4 + gP*c/(Kp+c)) * (VK-V)                         &
            + gL * (VL-V)
       F(2)=  (sT-xT) / (txT*zeta)
       F(3)=  (sK-xK) / (txK*zeta)
       F(4)=  (zI-yI) / (tyI*zeta)
       F(5)=  rho * (Kc*xT*(VCa-V) - c)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION gI,gP,gT

       gI=50.
       gP=0.03
       gT=0.01

       PAR(1)=gI
       PAR(2)=gP
       PAR(3)=gT

       U(1)=-2.329601E+00
       U(2)= 9.992162E-01
       U(3)= 7.373314E-01
       U(4)= 6.135948E-03
       U(5)= 1.208853E+00

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS 
      END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   aut.f90 :     Model AUTO-equations file
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----
!
! Evaluates the algebraic equations or ODE right hand side
!
! Input arguments :
!      NDIM   :   Dimension of the algebraic or ODE system 
!      U      :   State variables
!      ICP    :   Array indicating the free parameter(s)
!      PAR    :   Equation parameters
!
! Values to be returned :
!      F      :   Equation or ODE right hand side values
!
! Normally unused Jacobian arguments : IJAC, DFDU, DFDP (see manual)

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

       F(1)= ....
       F(2)= ....

      END SUBROUTINE FUNC
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE STPNT(NDIM,U,PAR)
!     ---------- -----
!
! Input arguments :
!      NDIM   :   Dimension of the algebraic or ODE system 
!
! Values to be returned :
!      U      :   A starting solution vector
!      PAR    :   The corresponding equation-parameter values
!
! Note : For time- or space-dependent solutions this subroutine has
!        arguments (NDIM,U,PAR,T), where the scalar input parameter T
!        contains the varying time or space variable value.

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

! Initialize the equation parameters
       PAR(1)= ....
       PAR(2)= ....

! Initialize the solution
       U(1)= ....
       U(2)= ....

      END SUBROUTINE STPNT
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----
!
! Boundary Conditions
!
! Input arguments :
!      NDIM   :   Dimension of the ODE system 
!      PAR    :   Equation parameters
!      ICP    :   Array indicating the free parameter(s)
!      NBC    :   Number of boundary conditions
!      U0     :   State variable values at the left boundary
!      U1     :   State variable values at the right boundary
!
! Values to be returned :
!      FB     :   The values of the boundary condition functions 
!
! Normally unused Jacobian arguments : IJAC, DBC (see manual)

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

!XXX   FB(1)=
!XXX   FB(2)=

      END SUBROUTINE BCND
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!     ---------- ----
!
! Integral Conditions
!
! Input arguments :
!      NDIM   :   Dimension of the ODE system 
!      PAR    :   Equation parameters
!      ICP    :   Array indicating the free parameter(s)
!      NINT   :   Number of integral conditions
!      U      :   Value of the vector function U at `time' t
!
! The following input arguments, which are normally not needed,
! correspond to the preceding point on the solution branch
!      UOLD   :   The state vector at 'time' t
!      UDOT   :   Derivative of UOLD with respect to arclength
!      UPOLD  :   Derivative of UOLD with respect to `time'
!
! Normally unused Jacobian arguments : IJAC, DINT
!
! Values to be returned :
!      FI     :   The value of the vector integrand 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

!XXX   FI(1)=

      END SUBROUTINE ICND
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP)
!     ---------- ----
!
! Defines the objective function for algebraic optimization problems
!
! Supplied variables :
!      NDIM   :   Dimension of the state equation
!      U      :   The state vector
!      ICP    :   Indices of the control parameters
!      PAR    :   The vector of control parameters
!
! Values to be returned :
!      FS      :   The value of the objective function
!
! Normally unused Jacobian argument : IJAC, DFDP

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: FS
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM),DFDP(*)

!XXX   FS=

      END SUBROUTINE FOPT
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

!---------------------------------------------------------------------- 
! NOTE : 
! Parameters set in this subroutine should be considered as ``solution 
! measures'' and be used for output purposes only.
! 
! They should never be used as `true'' continuation parameters. 
!
! They may, however, be added as ``over-specified parameters'' in the 
! parameter list associated with the AUTO-Constant NICP, in order to 
! print their values on the screen and in the ``p.xxx file.
!
! They may also appear in the list associated with AUTO-Constant NUZR.
!
!---------------------------------------------------------------------- 
! For algebraic problems the argument U is, as usual, the state vector.
! For differential equations the argument U represents the approximate 
! solution on the entire interval [0,1]. In this case its values must 
! be accessed indirectly by calls to GETP, as illustrated below.
!---------------------------------------------------------------------- 
!
! Set PAR(2) equal to the L2-norm of U(1)
!XX       PAR(2)=GETP('NRM',1,U)
!
! Set PAR(3) equal to the minimum of U(2)
!XX       PAR(3)=GETP('MIN',2,U)
!
! Set PAR(4) equal to the value of U(2) at the left boundary.
!XX       PAR(4)=GETP('BV0',2,U)
!
! Set PAR(5) equal to the pseudo-arclength step size used.
!XX       PAR(5)=GETP('STP',1,U)
!
!---------------------------------------------------------------------- 
! The first argument of GETP may be one of the following:
!        'NRM' (L2-norm),     'MAX' (maximum),
!        'INT' (integral),    'BV0 (left boundary value),
!        'MIN' (minimum),     'BV1' (right boundary value).
!
! Also available are
!   'STP' (Pseudo-arclength step size used).
!   'FLD' (`Fold function', which vanishes at folds).
!   'BIF' (`Bifurcation function', which vanishes at singular points).
!   'HBF' (`Hopf function'; which vanishes at Hopf points).
!   'SPB' ( Function which vanishes at secondary periodic bifurcations).
!---------------------------------------------------------------------- 

      END SUBROUTINE PVLS
!----------------------------------------------------------------------
!----------------------------------------------------------------------

module compat

implicit none
public :: autoflush, autim

contains

! This file calls some F2003/F95 functions that were previously only
! available as Unix extensions.

  subroutine autoflush(i)
! The Fortran 2003 way:
    integer, intent(in) :: i
    flush(i)
  end subroutine autoflush

!-----------------------------------------------------------------------
!          Timing AUTO
!-----------------------------------------------------------------------

! ------ --------- --------
  double precision function autim()

    real etime

    call cpu_time(etime)
    autim = etime

  end function autim

  integer function autargc()
    autargc = command_argument_count()
  end function autargc

  subroutine autgetarg(number,value)
    integer, intent(in) :: number
    character(len=*), intent(out) :: value
    call get_command_argument(number,value)
  end subroutine autgetarg

end module compat

!======================================================================
!======================================================================
! Utility Module for Listing, Deleting, Relabeling Labeled Solutions
!                        in AUTO-07p Data Files
!======================================================================
!======================================================================
!
MODULE UTILITY

  IMPLICIT NONE
  PRIVATE
  PUBLIC KEEPMAIN,RDFILE7,RDFILE8,LISTLB,INLIST,WRFILE7,WRFILE8,RELABEL
  PUBLIC GTFILE7, GTFILE8, LABEL
 
  TYPE LABEL
     INTEGER BR, PT, TY, LAB
     TYPE(LABEL), POINTER :: NEXT
  END TYPE LABEL

CONTAINS

! ---------- --------
  SUBROUTINE KEEPMAIN(DELETEFN)
    LOGICAL, EXTERNAL :: DELETEFN

    INTEGER, ALLOCATABLE :: LBR(:),LPT(:),LTY(:),LLB(:),LNL(:)
    TYPE(LABEL), POINTER :: LIST
    INTEGER DUM(1)
    INTEGER NLB,I

    OPEN(27,FILE='fort.27',STATUS='old',ACCESS='sequential')
    OPEN(28,FILE='fort.28',STATUS='old',ACCESS='sequential')
    OPEN(37,FILE='fort.37',STATUS='unknown',ACCESS='sequential')
    OPEN(38,FILE='fort.38',STATUS='unknown',ACCESS='sequential')

    NULLIFY(LIST)
    CALL RDFILE8(LIST,NLB,28)
    ALLOCATE(LBR(NLB),LPT(NLB),LTY(NLB),LLB(NLB),LNL(NLB))
    CALL GTFILE8(LIST,NLB,LBR,LPT,LTY,LLB,LNL)
    DO I=1,NLB
       IF(DELETEFN(I,MOD(LTY(I),10)))THEN
          LNL(I)=0
          LTY(I)=0
       ENDIF
    ENDDO
    CALL WRFILE7(0,DUM,NLB,LLB,LNL)
    CALL WRFILE8(LBR,LNL)

  END SUBROUTINE KEEPMAIN

! ---------- -------
  SUBROUTINE GTFILE7(LIST,NBR,BBR,BNB)

    TYPE(LABEL), POINTER :: LIST
    INTEGER NBR
    INTEGER BBR(NBR),BNB(NBR)
    TYPE(LABEL), POINTER :: P,Q
    INTEGER I

    P=>LIST
    DO I=1,NBR
       BBR(I)=P%BR
       BNB(I)=P%BR
       Q=>P
       P=>P%NEXT
       DEALLOCATE(Q)
    ENDDO
    IF(ASSOCIATED(P))DEALLOCATE(P)
    NULLIFY(LIST)
  END SUBROUTINE GTFILE7

! ---------- -------
  SUBROUTINE RDFILE7(LIST,NBR,NLB,LBI,UNIT)

    ! just scan branch numbers and labels on the branch
    TYPE(LABEL), POINTER :: LIST
    INTEGER, INTENT(IN) :: NLB, UNIT
    INTEGER, INTENT(OUT) :: NBR
    INTEGER, INTENT(OUT) :: LBI(NLB)
    INTEGER J,IBR,IPT,ITY,ILB,PREVPT
    TYPE(LABEL), POINTER :: P

    NBR=0
    J=1
    ALLOCATE(LIST)
    P=>LIST
    DO
       NULLIFY(P%NEXT)
       DO
          READ(UNIT,*,END=99,ERR=99)IBR
          IF(IBR/=0)EXIT
       ENDDO
       NBR=NBR+1
       P%BR=ABS(IBR)
       BACKSPACE UNIT
       READ(UNIT,*,END=99,ERR=98)IBR,IPT,ITY,ILB
       DO
          PREVPT=ABS(IPT)
          IF(ILB/=0)THEN
             LBI(J)=NBR
             J=J+1
          ENDIF
          READ(UNIT,*,END=99,ERR=98)IBR,IPT,ITY,ILB
          IF(IBR==0)EXIT
          IF(ABS(IPT)==1.AND.PREVPT/=9999.AND.PREVPT/=0)THEN
             BACKSPACE UNIT
             EXIT
          ENDIF
       ENDDO
98     CONTINUE
       ALLOCATE(P%NEXT)
       P=>P%NEXT
    ENDDO
99  RETURN
  END SUBROUTINE RDFILE7

! ---------- -------
  SUBROUTINE GTFILE8(LIST,NLB,LBR,LPT,LTY,LLB,LNL)

    TYPE(LABEL), POINTER :: LIST
    INTEGER NLB
    INTEGER LBR(NLB),LPT(NLB),LTY(NLB),LLB(NLB),LNL(NLB)
    TYPE(LABEL), POINTER :: P,Q
    INTEGER I

    P=>LIST
    DO I=1,NLB
       LBR(I)=P%BR
       LPT(I)=P%PT
       LTY(I)=P%TY
       LLB(I)=P%LAB
       LNL(I)=P%LAB
       Q=>P
       P=>P%NEXT
       DEALLOCATE(Q)
    ENDDO
    IF(ASSOCIATED(P))DEALLOCATE(P)
    NULLIFY(LIST)
  END SUBROUTINE GTFILE8

! ---------- -------
  SUBROUTINE RDFILE8(LIST,NLB,UNIT)

    TYPE(LABEL), POINTER :: LIST
    INTEGER NLB,UNIT
    LOGICAL EOF
    INTEGER IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NSKIP
    TYPE(LABEL), POINTER :: P

    NLB=0
    ALLOCATE(LIST)
    P=>LIST
    DO
       NULLIFY(P%NEXT)
       READ(UNIT,*,END=2)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NSKIP
       NLB=NLB+1
       P%BR=ABS(IBR)
       P%PT=ABS(NTOT)
       P%TY=ITP
       P%LAB=LAB
       CALL SKIP(UNIT,NSKIP,EOF)
       IF(EOF)RETURN
       ALLOCATE(P%NEXT)
       P=>P%NEXT
    ENDDO
2   RETURN

  END SUBROUTINE RDFILE8

! ---------- -------
  SUBROUTINE WRFILE7(NBR,BNB,NLB,LLB,LNL)

    INTEGER NBR,NEWBR,NLB
    INTEGER BNB(NBR),LLB(NLB),LNL(NLB)
    CHARACTER(LEN=132) LINE
    CHARACTER(LEN=1) CH1
    CHARACTER(LEN=17) FMT ! fits "(I99,I99,I99,I99)"
    INTEGER I,J,L,LNUM,LEN,BRI,BR,PREVPT,PT,TY,LAB,IND(4),L0,L1,L2,L3
    LOGICAL EOL, HEADER

    L=0
    LNUM=0
    L0=0
    L1=0
    L2=0
    L3=0
    BRI=0
    HEADER=.FALSE.
    PT=0
    REWIND 27
    DO
       EOL=.TRUE.
       READ(27,"(A)",ADVANCE='NO',EOR=97,END=99,SIZE=LEN)LINE
       EOL=.FALSE.
97     CONTINUE
       LNUM=LNUM+1
       J=1
       IND(1)=0
       DO I=1,4
          ! skip spaces
          DO
             IF(LINE(J:J)/=' ')EXIT
             J=J+1
             IF(J>LEN)EXIT
          ENDDO
          ! check for header line
          IF(I==1.AND.LINE(J:J)=='0')THEN
             IF(.NOT.HEADER)THEN
                BRI=BRI+1
             ENDIF
             HEADER=.TRUE.
             EXIT
          ENDIF
          ! look for next space after BR/PT/TY/LAB
          DO
             IF(LINE(J:J)==' ')EXIT
             J=J+1
             IF(J>LEN)EXIT
          ENDDO
          IF(J>LEN)THEN
             IND(1)=0
             EXIT
          ENDIF
          ! Put line index for PT, TY, LAB, rest here
          IND(I)=J
       ENDDO
       LAB=0
       BR=0
       IF(IND(1)/=0)THEN
          PREVPT=PT
          READ(LINE(:IND(4)-1),*)BR,PT,TY,LAB
          IF(.NOT.HEADER.AND.PT==1.AND.PREVPT/=9999.AND.PREVPT/=0)THEN
             BRI=BRI+1
          ENDIF
          HEADER=.FALSE.
       ENDIF
       NEWBR=BR
       IF(BRI<=NBR)THEN
          NEWBR=BNB(BRI)
          IF(IND(1)/=0)THEN
             NEWBR=SIGN(NEWBR,BR)
          ELSE
             BR=NEWBR
          ENDIF
       ENDIF

       IF(LAB/=0.OR.NEWBR/=BR)THEN
          IF(LAB/=0)L=L+1
          IF(LAB/=0.AND.LAB/=LLB(L))THEN
             WRITE(6,"(A/A,I5,A,I5/A,I5/A/A)", ADVANCE="NO") &
                  ' WARNING : The two files have incompatible labels :', &
                  '  b-file label',LAB,' at line ',LNUM, &
                  '  s-file label',LLB(L), &
                  ' New labels may be assigned incorrectly.', &
                  ' Continue ? : '
             READ(5,"(A1)")CH1
             IF(CH1/='y'.AND.CH1/='Y')THEN
                WRITE(6,"(A)") &
                     'Rewrite discontinued. Recover original files'
                RETURN
             ENDIF
          ENDIF
          IF(IND(1)-1/=L0.OR.IND(2)-IND(1)/=L1.OR. &
               IND(3)-IND(2)/=L2.OR.IND(4)-IND(3)/=L3) THEN
             L0=IND(1)-1
             L1=IND(2)-IND(1)
             L2=IND(3)-IND(2)
             L3=IND(4)-IND(3)
             WRITE(FMT,"(A,I2,A,I2,A,I2,A,I2,A)")&
                  '(I',L0,',I',L1,',I',L2,',I',L3,')'
          ENDIF
          IF(LAB==0)THEN
             WRITE(LINE(:IND(4)-1),FMT)NEWBR,PT,TY,LAB
          ELSE
             WRITE(LINE(:IND(4)-1),FMT)NEWBR,PT,TY,LNL(L)
          ENDIF
       ENDIF
       IF(NEWBR==0)THEN ! deleted branch; don't write
          IF(.NOT.EOL)THEN
             READ(27,"()",END=99)
          ENDIF
          CYCLE
       ENDIF
       IF(.NOT.EOL)THEN
          DO
             WRITE(37,"(A)",ADVANCE='NO')LINE(1:LEN)
             READ(27,"(A)",ADVANCE='NO',EOR=98,SIZE=LEN)LINE
          ENDDO
98        CONTINUE
       ENDIF
       WRITE(37,"(A)")LINE(1:LEN)
    ENDDO
99  RETURN
  END SUBROUTINE WRFILE7

! ---------- -------
  SUBROUTINE WRFILE8(LBR,LNL)

    INTEGER LBR(*),LNL(*)
    INTEGER IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,NCOL,NPAR
    INTEGER NPARI,NDM,IPS,IPRIV
    INTEGER I,L
    CHARACTER(150) LINE
    LOGICAL EOF
!
    L=0
    REWIND 28
    DO
       READ(28,'(A)',END=99)LINE
       IF (LEN_TRIM(LINE) <= 73) THEN
          READ(LINE,*)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL, &
               NAR,NROWPR,NTST,NCOL,NPAR
          L=L+1
          IF(LNL(L)>0)THEN
             WRITE(38,101)LBR(L),NTOT,ITP,LNL(L),NFPR,ISW,NTPL, &
                  NAR,NROWPR,NTST,NCOL,NPAR
          ENDIF
       ELSE
          READ(LINE,*)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL, &
               NAR,NROWPR,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
          L=L+1
          IF(LNL(L)>0)THEN
             WRITE(38,111)LBR(L),NTOT,ITP,LNL(L),NFPR,ISW,NTPL, &
                  NAR,NROWPR,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
          ENDIF
       ENDIF
       IF(LNL(L)>0)THEN
          DO I=1,NROWPR
             LINE(:)=' '
             READ(28,'(A)',END=99)LINE
             WRITE(38,'(A)')LINE(1:LEN_TRIM(LINE))
          ENDDO
       ELSE
          CALL SKIP(28,NROWPR,EOF)
          IF(EOF)RETURN
       ENDIF
    ENDDO

 101   FORMAT(6I6,I8,I6,I8,3I5)
 111   FORMAT(6I6,I8,I6,I8,7I5)

99  RETURN
  END SUBROUTINE WRFILE8

! ------- -------- ------
  LOGICAL FUNCTION INLIST(NLB,LAB,NL,LFR,LTO)

    INTEGER NLB,LAB,NL,LFR(NLB),LTO(NLB)
    INTEGER I

    INLIST=.FALSE.
    DO I=1,NL
       IF(LAB.GE.LFR(I).AND.LAB.LE.LTO(I))THEN
          INLIST=.TRUE.
          RETURN
       ENDIF
    ENDDO

  END FUNCTION INLIST
!
! ---------- ----
  SUBROUTINE SKIP(IUNIT,NSKIP,EOF)
!
! Skips the specified number of lines on fort.IUNIT.
!
    INTEGER, INTENT(IN) :: IUNIT,NSKIP
    LOGICAL, INTENT(OUT) :: EOF
    CHARACTER(12) FMT
!
    WRITE(FMT,'(A,I9,A)')'(',NSKIP-1,'/)'
    EOF=.TRUE.
    READ(IUNIT,FMT,END=2)
    EOF=.FALSE.
2   RETURN

  END SUBROUTINE SKIP
!
! LISTLB, TYPE, and RELABEL are used by listlabels.f, autlab.f, or relabel.f
!
! ---------- ------
  SUBROUTINE LISTLB(NLB,LBR,LPT,LTY,LLB,LNL,NL,LFR,LTO,NEW)
!
    LOGICAL NEW
    INTEGER NLB,LBR(NLB),LPT(NLB),LTY(NLB),LLB(NLB),LNL(NLB)
    INTEGER NL,LFR(NLB),LTO(NLB)
    LOGICAL FIRST
    INTEGER I
!
    IF(NLB.EQ.0)THEN
       WRITE(6,"(/,' Empty solutions file')")
       RETURN
    ENDIF

    FIRST=.TRUE.
    DO I=1,NLB
       IF(NL==0 .OR. INLIST(NLB,LLB(I),NL,LFR,LTO))THEN
          IF(FIRST)THEN
             IF(NEW)THEN
                WRITE(6,"(/,'  BR    PT  TY  LAB  NEW')")
             ELSE
                WRITE(6,"(/,'  BR    PT  TY  LAB')")
             ENDIF
             FIRST=.FALSE.
          ENDIF
          WRITE(6,"(I4,I6,1X,A3,I5)",ADVANCE="no")LBR(I),LPT(I), &
               ADJUSTR(TYPE(LTY(I))),LLB(I)
          IF(.NOT.NEW)THEN
             WRITE(6,"()")
          ELSEIF(LLB(I)==LNL(I).OR.LNL(I)/=0)THEN
             WRITE(6,"(I5)")LNL(I)
          ELSE
             WRITE(6,"('        DELETED')")
          ENDIF
       ENDIF
    ENDDO

  CONTAINS

    CHARACTER(3) FUNCTION TYPE(ITP)

      ! returns the string label type corresponding to numerical type ITP
      INTEGER, INTENT(IN) :: ITP

      CHARACTER(2), PARAMETER :: ATYPES(-9:9) = &
           (/ 'MX','R4','R3','R2','R1','UZ','ZH','CP','BT','  ', &
              'BP','LP','HB','  ','LP','BP','PD','TR','EP' /)

      SELECT CASE(ITP)
      CASE(-32)
         TYPE='GH'
      CASE(23,83)
         TYPE='LTR'
      CASE(77,87)
         TYPE='PTR'
      CASE(28,78)
         TYPE='LPD'
      CASE(88)
         TYPE='TTR'
      CASE DEFAULT
         TYPE=ATYPES(MOD(ITP,10))
      END SELECT
    END FUNCTION TYPE

  END SUBROUTINE LISTLB

! ---------- -------
  SUBROUTINE RELABEL(S,NLB,LLB,LNL,NL,LFR,LTO)

    CHARACTER(*) S
    INTEGER NLB,NL
    INTEGER LLB(NLB),LNL(NLB)
    INTEGER LFR(NLB),LTO(NLB)
    INTEGER NN,I

    IF(NL==0)THEN
       NN=0
       DO I=1,NLB
          IF(LNL(I)>0)THEN
             NN=NN+1
             LNL(I)=NN
          ENDIF
       ENDDO
    ELSE
       DO I=1,NLB
          IF(NL==0 .OR. &
               (LNL(I)>0 .AND. INLIST(NLB,LLB(I),NL,LFR,LTO)) )THEN
             WRITE(6,"(' Old ',A,I5,';  Enter new ',A,' : ')", &
                  ADVANCE="no")S,LLB(I),S
             READ(5,*)LNL(I)
          ENDIF
       ENDDO
    ENDIF
  END SUBROUTINE RELABEL
!======================================================================
!======================================================================
END MODULE UTILITY

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   pvl :  Setting functional parameter values (for Bratu's equation)
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,*), DFDP(NDIM,*)

      DOUBLE PRECISION E

       E=EXP(U(1)) 
       F(1)=U(2) 
       F(2)=-PAR(1)*E 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T) 
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0
       U(1)=0.0
       U(2)=0.0

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

       FB(1)=U0(1)
       FB(2)=U1(1)

      END SUBROUTINE BCND

      DOUBLE PRECISION FUNCTION GETU2(U,NDX,NTST,NCOL)
!     ------ --------- -------- -----
      INTEGER, INTENT(IN) :: NDX,NCOL,NTST
      DOUBLE PRECISION, INTENT(IN) :: U(NDX,0:NCOL*NTST)

        GETU2 = U(2,0)

      END FUNCTION GETU2

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

      DOUBLE PRECISION, EXTERNAL :: GETP,GETU2
      INTEGER NDX,NCOL,NTST
!---------------------------------------------------------------------- 
! NOTE : 
! Parameters set in this subroutine should be considered as ``solution 
! measures'' and be used for output purposes only.
! 
! They should never be used as `true'' continuation parameters. 
!
! They may, however, be added as ``over-specified parameters'' in the 
! parameter list associated with the AUTO-Constant NICP, in order to 
! print their values on the screen and in the ``p.xxx file.
!
! They may also appear in the list associated with AUTO-constant NUZR.
!
!---------------------------------------------------------------------- 
! For algebraic problems the argument U is, as usual, the state vector.
! For differential equations the argument U represents the approximate 
! solution on the entire interval [0,1]. In this case its values can
! be accessed indirectly by calls to GETP, as illustrated below, or
! by obtaining NDIM, NCOL, NTST via GETP and then dimensioning U as
! U(NDIM,0:NCOL*NTST) in a seperate subroutine that is called by PVLS.
!---------------------------------------------------------------------- 

! Set PAR(2) equal to the L2-norm of U(1)
       PAR(2)=GETP('NRM',1,U)

! Set PAR(3) equal to the minimum of U(2)
       PAR(3)=GETP('MIN',2,U)

! Set PAR(4) equal to the value of U(2) at the left boundary.
       PAR(4)=GETP('BV0',2,U)

! Set PAR(5) equal to the value of U(2) at the left boundary using
! another method
       NDX=NINT(GETP('NDX',0,U))
       NTST=NINT(GETP('NTST',0,U))
       NCOL=NINT(GETP('NCOL',0,U))
       PAR(5)=GETU2(U,NDX,NTST,NCOL)
!---------------------------------------------------------------------- 
! The first argument of GETP may be one of the following:
!        'NRM' (L2-norm),     'MAX' (maximum),
!        'INT' (integral),    'BV0 (left boundary value),
!        'MIN' (minimum),     'BV1' (right boundary value).
!        'MNT' (t value for minimum)
!        'MXT' (t value for maximum)
!        'NDIM', 'NDX' (effective (active) number of dimensions)
!        'NTST' (NTST from constant file)
!        'NCOL' (NCOL from constant file)
!        'NBC'  (active NBC)
!        'NINT' (active NINT)
!        'DTM'  (delta t for all t values, I=1...NTST)
!        'WINT' (integration weights used for interpolation, I=0...NCOL)
!
! Also available are
!   'STP' (Pseudo-arclength step size used).
!   'FLD' (`Fold function', which vanishes at folds).
!   'BIF' (`Bifurcation function', which vanishes at singular points).
!   'HBF' (`Hopf function'; which vanishes at Hopf points).
!   'SPB' ( Function which vanishes at secondary periodic bifurcations).
!   'EIG' ( Eigenvalues/multipliers, I=1...2*NDIM, alternates real/imag parts).
!   'STA' ( Number of stable eigenvalues/multipliers).
!---------------------------------------------------------------------- 

      END SUBROUTINE PVLS

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for Homoclinic Bifurcation Analysis
!       (A. R. Champneys, Yu. A. Kuznetsov, B. Sandstede,
!        B. E. Oldeman, E. J. Doedel)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE HOMCONT

  USE AUTO_CONSTANTS, ONLY : AUTOPARAMETERS,HCONST,NPARX,NEWCFILE
  USE BVP
  USE TOOLBOXBV

  IMPLICIT NONE

  PRIVATE

  PUBLIC :: AUTOHO,INSTRHO

! This common block is also used by demos: don't remove it!!
! Also, don't use the common variables in FNHO and ICHO because 
! the MPI code does not transfer them.

  INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
  COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV

  INTEGER, ALLOCATABLE, TARGET :: IREV(:),IFIXED(:),IPSI(:)
  LOGICAL, SAVE :: INITCNST=.FALSE.
  DOUBLE PRECISION, SAVE :: COMPZERO

  DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

CONTAINS

! ---------- ------
  SUBROUTINE AUTOHO(AP,ICP,ICU)

    USE AUTOMPI, ONLY : MPIIAM,MPIBCASTI,MPIBCASTAP

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    ! Redefine AUTO constants for homoclinic orbits
    ! (only on the first node for MPI)
    IF(MPIIAM()==0)THEN
       CALL INHO(AP,ICP)
    ENDIF
    CALL MPIBCASTAP(AP)
    CALL MPIBCASTI(ICP,AP%NFPR)

    CALL INITBVP(AP,ICP)
    IF(ABS(AP%ISW)==2.AND.(AP%ITP==5.OR.(ABS(AP%ITP)/10)==5))THEN
       IF(AP%ITP==5) THEN 
          ! ** Fold continuation (start).
          CALL AUTOBV(AP,ICP,ICU,FNHOL,BCHOL,ICHOL,STPNHO,FNCSHO)
       ELSE
          ! ** Fold continuation (restart).
          CALL AUTOBV(AP,ICP,ICU,FNHOL,BCHOL,ICHOL,STPNHO,FNCSHO)
       ENDIF
    ELSE
       CALL AUTOBV(AP,ICP,ICU,FNHO,BCHO,ICHO,STPNHO,FNCSHO)
    ENDIF

  END SUBROUTINE AUTOHO

! ---------- ----
  SUBROUTINE FNHO(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for homoclinic bifurcation analysis

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),DFP(:,:),FF1(:)
    INTEGER NDM,NFPR,I,J,IT,IEQMAX
    DOUBLE PRECISION UMX,EP,P,UU

    NDM=AP%NDM
    NFPR=AP%NFPR

    ! Generate the function.

    IF(NDIM==NDM)THEN
       !    *Evaluate the R.-H. sides
       CALL FFHO(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,11)
       RETURN
    ENDIF

    ALLOCATE(DFU(NDM,NDM),DFP(NDM,AP%NPAR))

    IF(AP%NPARI>0)THEN
       !    Homoclinic branch switching
       DO J=0,NDIM-NDM,NDM
          IF(IJAC==2)THEN
             DO I=1,NFPR
                DFP(:,ICP(I))=0d0
             ENDDO
          ENDIF
          IF(J==0)THEN
             IT=10
          ELSEIF(J==NDIM-NDM)THEN
             IT=11
          ELSE
             IT=19+(J/NDM)*2
          ENDIF
          CALL FFHO(AP,NDM,U(J+1),UOLD(J+1),ICP,PAR,IJAC,F(J+1),DFU,DFP,IT)
          IF(IJAC/=0)THEN
             DFDU(J+1:J+NDM,J+1:J+NDM)=DFU(:,:)
          ENDIF
          IF(IJAC==2)THEN
             DO I=1,NFPR
                DFDP(J+1:J+NDM,ICP(I))=DFP(:,ICP(I))
             ENDDO
          ENDIF
       ENDDO
       DEALLOCATE(DFU,DFP)
       RETURN
    ENDIF


    ! Generate the function + adjoint variational equation for ITWIST=1

    IF(IJAC/=0)THEN

       ! Generate dF/du for F = - (Df(u))^T U + PAR(10)*f(u)

       UMX=0.d0
       DO I=1,NDIM
          IF(DABS(U(I))>UMX)UMX=DABS(U(I))
       ENDDO

       EP=HMACH*(1+UMX)

       DO I=1,NDM
          UU=U(I)
          U(I)=UU-EP
          CALL FFHO(AP,NDIM,U,UOLD,ICP,PAR,1,DFDU(1,I),DFU,DFP,11)
          U(I)=UU+EP
          CALL FFHO(AP,NDIM,U,UOLD,ICP,PAR,1,F,DFU,DFP,11)
          U(I)=UU
          DO J=NDM+1,NDIM
             DFDU(J,I)=(F(J)-DFDU(J,I))/(2*EP)
          ENDDO
       ENDDO
    ENDIF

    IF(IJAC==2)THEN
       DO I=1,NFPR
          DFP(:,ICP(I))=0d0
       ENDDO
    ENDIF

    CALL FFHO(AP,NDIM,U,UOLD,ICP,PAR,MAX(IJAC,1),F,DFU,DFP,11)
    IF(IJAC==0)THEN
       DEALLOCATE(DFU,DFP)
       RETURN
    ENDIF

    DFDU(1:NDM,1:NDM)=DFU(:,:)
    DFDU(1:NDM,NDM+1:NDIM)=0d0
    ! *Adjoint variational equations for normal vector
    ! *Set dF/dU for F = - (Df(u))^T U + PAR(10)*f(u)
    DO J=1,NDM
       DO I=1,NDM
          DFDU(NDM+J,NDM+I)=-DFU(I,J)
       ENDDO
    ENDDO

    IF(IJAC==1)THEN
       DEALLOCATE(DFU,DFP)
       RETURN
    ENDIF

    ALLOCATE(FF1(NDIM))
    DO I=1,NFPR
       DFDP(1:NDM,ICP(I))=DFP(:,ICP(I))
    ENDDO
    IF(IEQUIB<0)THEN
       ! heteroclinic equilibrium parameters
       IEQMAX=11+NDM*2
    ELSE
       ! homoclinic equilibrium parameters
       IEQMAX=11+NDM
    ENDIF
    DO I=1,NFPR
       IF(ICP(I)==10)THEN
          DFDP(NDM+1:NDIM,10)=F(:NDM)
       ELSEIF(ICP(I)==11)THEN
          DFDP(NDM+1:NDIM,11)=(F(NDM+1:NDIM)+PAR(10)*F(1:NDM))/PAR(11)
       ENDIF
       IF(ICP(I)>=10.AND.ICP(I)<=IEQMAX)CYCLE
       P=PAR(ICP(I))
       EP=HMACH*( 1 +ABS(P) )
       PAR(ICP(I))=P+EP
       CALL FFHO(AP,NDIM,U,UOLD,ICP,PAR,1,FF1,DFU,DFP,11)
       DO J=NDM+1,NDIM
          DFDP(J,ICP(I))=(FF1(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(FF1,DFU,DFP)

  END SUBROUTINE FNHO

! ---------- ----
  SUBROUTINE FFHO(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,IT)

    USE INTERFACES, ONLY:FUNI,FUNC

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC,IT
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(AP%NDM,AP%NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDP(AP%NDM,*)

    ! Local
    INTEGER I,J,NDM
    DOUBLE PRECISION DUM1,T

    NDM=AP%NDM

    ! Generate the function.

    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    T=PAR(IT)
    IF(AP%NPARI==0)THEN
       IF(NDIM>NDM)THEN        
          !       *Adjoint variational equations for normal vector
          !       *Set F = - (Df)^T u
          DO J=1,NDM
             DUM1=0.0D0
             DO I=1,NDM
                DUM1=DUM1+DFDU(I,J)*U(NDM+I)
             ENDDO
             F(NDM+J) = -DUM1
          ENDDO
          !       *Set F =  F + PAR(10) * f
          DO J=1,NDM
             F(NDM+J) = F(NDM+J) + PAR(10) * F(J)
          ENDDO
       ENDIF
    ENDIF

    ! Scale by truncation interval T

    IF(IJAC/=0)THEN
       DFDU(:,:)=T*DFDU(:,:)
       IF(IJAC==2)THEN
          !       **Derivative to truncation interval
          DO J=1,AP%NFPR
             IF(ICP(J)==IT)THEN
                DFDP(:,IT)=F(:)
             ELSE
                DFDP(:,ICP(J))=T*DFDP(:,ICP(J))
             ENDIF
          ENDDO
       ENDIF
    ENDIF
    F(:)=T*F(:)

  END SUBROUTINE FFHO

! ---------- ----
  SUBROUTINE BCHO(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    ! Generates the boundary conditions for homoclinic bifurcation analysis

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: UU(:),FF1(:),FF2(:)
    INTEGER NFPR,I,J
    DOUBLE PRECISION UMX,EP,P

    NFPR=AP%NFPR

    ! Generate the function.

    CALL FBHO(AP,NDIM,PAR,ICP,NBC,.TRUE.,U0,U1,F)

    IF(IJAC==0)RETURN
    ALLOCATE(UU(NDIM),FF1(NBC),FF2(NBC))

    ! Derivatives with respect to U0.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U0(I))>UMX)UMX=DABS(U0(I))
    ENDDO
    EP=HMACH*(1+UMX)
    DO I=1,NDIM
       UU(I)=U0(I)
    ENDDO
    DO I=1,NDIM
       UU(I)=U0(I)-EP
       CALL FBHO(AP,NDIM,PAR,ICP,NBC,.FALSE.,UU,U1,FF1)
       UU(I)=U0(I)+EP
       CALL FBHO(AP,NDIM,PAR,ICP,NBC,.FALSE.,UU,U1,FF2)
       UU(I)=U0(I)
       DO J=1,NBC
          DBC(J,I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    ! Derivatives with respect to U1.

    UMX=0.d0
    DO I=1,NDIM
       IF(DABS(U1(I))>UMX)UMX=DABS(U1(I))
    ENDDO
    EP=HMACH*(1+UMX)
    DO I=1,NDIM
       UU(I)=U1(I)
    ENDDO
    DO I=1,NDIM
       UU(I)=U1(I)-EP
       CALL FBHO(AP,NDIM,PAR,ICP,NBC,.FALSE.,U0,UU,FF1)
       UU(I)=U1(I)+EP
       CALL FBHO(AP,NDIM,PAR,ICP,NBC,.FALSE.,U0,UU,FF2)
       UU(I)=U1(I)
       DO J=1,NBC
          DBC(J,NDIM+I)=(FF2(J)-FF1(J))/(2*EP)
       ENDDO
    ENDDO

    DO I=1,NFPR
       P=PAR(ICP(I))
       PAR(ICP(I))=P+EP
       CALL FBHO(AP,NDIM,PAR,ICP,NBC,.FALSE.,U0,U1,FF2)
       DO J=1,NBC
          DBC(J,2*NDIM+ICP(I))=(FF2(J)-F(J))/EP
       ENDDO
       PAR(ICP(I))=P
    ENDDO

    DEALLOCATE(FF1,FF2,UU)
  END SUBROUTINE BCHO

! ---------- ----
  SUBROUTINE FBHO(AP,NDIM,PAR,ICP,NBC,CSAVE,U0,U1,FB)

    USE SUPPORT, ONLY: PI
    USE BVP, ONLY: NRTN, IRTN
    USE INTERFACES, ONLY: FUNC,BCND,PVLS
    USE SUPPORT, ONLY: AUTOSTOP

    ! Generates the boundary conditions for homoclinic orbits.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NBC
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*),U0(NDIM),U1(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    LOGICAL, INTENT(IN) :: CSAVE
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: VR(:,:,:),VT(:,:,:)
    DOUBLE PRECISION, ALLOCATABLE :: BOUND(:,:),RR(:,:),RI(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: XEQUIB1(:),XEQUIB2(:)
    DOUBLE PRECISION, ALLOCATABLE, SAVE :: UMAX(:)

    LOGICAL INEIG
    INTEGER NDM,NPAR,NBCN,JB,I,J,K,IP,KP
    DOUBLE PRECISION DUM,DUM1(1),DUM2(1)

    NDM=AP%NDM
    NPAR=AP%NPAR
    ALLOCATE(VR(NDM,NDM,2),VT(NDM,NDM,2),BOUND(NDM,NDM))
    ALLOCATE(RR(NDM,2),RI(NDM,2),XEQUIB1(NDM),XEQUIB2(NDM))

    ! *Initialization
    DO I=1,NBC
       FB(I) = 0.0D0
    ENDDO
    JB = 1

    IF ((IEQUIB==0).OR.(IEQUIB==-1)) THEN
       CALL PVLS(NDM,U0,PAR)
    ENDIF
    !          write(9,*) 'Xequib:'
    DO I=1,NDM
       XEQUIB1(I)=PAR(11+I)
       !          write(9,*) I,XEQUIB1(I)
    ENDDO
    ! ** Rotations */
    IF(IRTN/=0)THEN
       DO I=1,NDM
          XEQUIB2(I)=XEQUIB1(I)
          IF(NRTN(I)/=0)THEN
             IF(ISTART<0)THEN
                NRTN(I)=-ISTART*NRTN(I)
             ENDIF
             XEQUIB2(I)=XEQUIB2(I)+PI(2.d0)*NRTN(I)
          ENDIF
       ENDDO
    ELSEIF(IEQUIB.GE.0) THEN
       DO I=1,NDM
          XEQUIB2(I)=PAR(11+I)
       ENDDO
    ELSE
       DO I=1,NDM
          XEQUIB2(I)=PAR(NDM+11+I)
       ENDDO
    ENDIF

    ! **Regular Continuation**
    IF(ISTART/=3) THEN
       !    *Projection boundary conditions for the homoclinic orbit
       !    *NSTAB boundary conditions at t=0
       CALL PRJCTN(AP,BOUND,CSAVE,XEQUIB1,ICP,PAR,-1,1,1,NDM)
       DO I=1,NSTAB
          DO K=1,NDM
             FB(JB)=FB(JB)+(U0(K)-XEQUIB1(K))*BOUND(K,I)
          ENDDO
          JB = JB+1
       ENDDO

       !    *NUNSTAB boundary conditions at t=1
       IF(AP%NREV==0) THEN
          CALL PRJCTN(AP,BOUND,CSAVE,XEQUIB2,ICP,PAR,1,2,1,NDM)
          DO I=1,NUNSTAB
             DO K=1,NDM
                IF (ISTART.GE.0) THEN
                   FB(JB)=FB(JB)+(U1(K)-XEQUIB2(K))*BOUND(K,I)
                ELSE
                   FB(JB)=FB(JB)+(U1(NDIM-NDM+K)-XEQUIB2(K))*BOUND(K,I)
                   IF (ITWIST==0) THEN
                      !                 allow jump at end.
                      FB(JB)=FB(JB)+PAR(22)
                   ENDIF
                ENDIF
             ENDDO
             JB = JB+1
          ENDDO
       ELSE
          !     *NUNSTAB symmetric boundary conditions at t=1 if NREV=1

          DO I=1,NDIM
             IF(IREV(I)>0) THEN
                FB(JB)=U1(I)  
                JB=JB+1
             ENDIF
          ENDDO
       ENDIF
       INEIG=.FALSE.
       !    *NFIXED extra boundary conditions for the fixed conditions
       IF (NFIXED>0) THEN
          CALL EIGHO(AP,2,RR(1,1),RI(1,1),VR(1,1,1),XEQUIB1,ICP,PAR,NDM)
          IF(IEQUIB<0) THEN
             CALL EIGHO(AP,2,RR(1,2),RI(1,2),VR(1,1,2),XEQUIB2,ICP,PAR,NDM)
          ENDIF
          DO I=1,NFIXED
             IF((IFIXED(I)>10).AND..NOT.INEIG) THEN
                CALL EIGHO(AP,1,RR(1,1),RI(1,1),VT(1,1,1),XEQUIB1,ICP,PAR,NDM)
                INEIG=.TRUE.
                IF(IEQUIB<0) THEN
                   CALL EIGHO(AP,1,RR(1,2),RI(1,2),VT(1,1,2), &
                        XEQUIB2,ICP,PAR,NDM)
                ENDIF
             ENDIF
             FB(JB)=PSIHO(NDM,IFIXED(I),RR,RI,VR,VT,ICP,PAR,U0,U1)
             JB = JB+1 
          ENDDO
       ENDIF
       !    *extra boundary condition in the case of a saddle-node homoclinic
       IF (IEQUIB==2) THEN
          IF(.NOT.INEIG) THEN
             CALL EIGHO(AP,1,RR(1,1),RI(1,1),VT(1,1,1),XEQUIB1,ICP,PAR,NDM)
             INEIG=.TRUE.
          ENDIF
          FB(JB)=RR(NSTAB+1,1)
          JB=JB+1
       ENDIF
       !    *NDM initial conditions for the equilibrium if IEQUIB=1,2,-2
       IF ((IEQUIB/=0).AND.(IEQUIB/=-1)) THEN
          CALL FUNC(NDM,XEQUIB1,ICP,PAR,0,FB(JB),DUM1,DUM2)
          JB=JB+NDM
          !    *NDM extra initial conditions for the equilibrium if IEQUIB=-2
          IF (IEQUIB==-2) THEN
             CALL FUNC(NDM,XEQUIB2,ICP,PAR,0,FB(JB),DUM1,DUM2)
             JB=JB+NDM
          ENDIF
       ENDIF
       !    *boundary conditions for normal vector
       IF ((ISTART.GE.0).AND.(ITWIST==1)) THEN
          !       *-orthogonal to the unstable directions of A  at t=0
          CALL PRJCTN(AP,BOUND,CSAVE,XEQUIB1,ICP,PAR,1,1,2,NDM)
          DO I=1,NUNSTAB
             DUM=0.0
             DO K=1,NDM
                DUM=DUM+U0(NDM+K)*BOUND(K,I)
             ENDDO
             FB(JB)=DUM 
             JB = JB+1
          ENDDO
          !       *-orthogonal to the stable directions of A  at t=1
          CALL PRJCTN(AP,BOUND,CSAVE,XEQUIB2,ICP,PAR,-1,2,2,NDM)
          DO I=1,NSTAB
             DUM=0.0
             DO K=1,NDM
                DUM=DUM+U1(NDM+K)*BOUND(K,I)
             ENDDO
             FB(JB)=DUM 
             JB = JB+1
          ENDDO
          !  Branch switching to n-homoclinic orbits.
       ELSEIF(ISTART<0) THEN
          !     More boundary conditions: continuity+gaps
          DO K=0,NDIM/NDM-2
             DO I=1,NDM
                FB(JB)=U0(NDM*(K+1)+I)-U1(NDM*K+I)
                IF (ITWIST==1) THEN 
                   ! Lin(-Sandstede): PAR(20,22,...) contain the gap sizes,
                   ! PAR(NPAR-2*NDM+1...NPAR-NDM) contains the adjoint unit
                   ! vector at the gaps.
                   FB(JB)=FB(JB)-PAR(20+2*K)*PAR(NPAR-2*NDM+I)
                ENDIF
                JB = JB+1
             ENDDO
          ENDDO
          ! Poincare sections: <x-x_0,\dot x_0>=0
          ! PAR(NPAR-NDM+1...NPAR) contains the derivatives of the
          ! point x_0 in the original
          ! homoclinic orbit that is furthest from the equilibrium.
          ! x_0=umax is initialized at each run to an end point, and so
          ! is always in the Poincare section
          IF (.NOT.ALLOCATED(UMAX)) THEN
             ALLOCATE(UMAX(NDIM))
             DO I=1,NDIM
                UMAX(I) = U1(I)
             ENDDO
          ENDIF
          DO K=0,NDIM/NDM-2
             DO I=1,NDM
                FB(JB)=FB(JB)+(U1(K*NDM+I)-UMAX(K*NDM+I))*PAR(NPAR-NDM+I)
             ENDDO
             JB = JB + 1
          ENDDO
       ENDIF
    ELSE
       ! **Starting Solutions using Homotopy**
       IP=12
       IF(IEQUIB.GE.0) THEN 
          IP=IP+NDM
       ELSE
          IP=IP+2*NDM
       ENDIF
       KP=IP
       !    *Explicit boundary conditions for homoclinic orbit at t=0
       CALL EIGHO(AP,2,RR,RI,VR,XEQUIB1,ICP,PAR,NDM)
       JB=NDM+1
       IF(NUNSTAB>1) THEN
          FB(JB)=0.0
          KP=IP+NUNSTAB
          DO J=1,NUNSTAB
             DO I=1,NDM
                FB(I)=FB(I)+U0(I)-XEQUIB1(I)-PAR(IP+J)*VR(NDM-NUNSTAB+J,I,1)
             ENDDO
             FB(JB)=FB(JB)+PAR(IP+J)**2
          ENDDO
          FB(JB)=FB(JB)-PAR(IP)**2
          JB=JB+1
       ELSE
          KP=IP+1
          DO I=1,NDM
             FB(I)=U0(I)-XEQUIB1(I)-PAR(IP)*VR(NDM-NUNSTAB+1,I,1)
          ENDDO
       ENDIF
       !    *Projection boundary conditions for the homoclinic orbit at t=1
       CALL EIGHO(AP,1,RR,RI,VT,XEQUIB2,ICP,PAR,NDM)
       DO I=NDM-NUNSTAB+1,NDM
          DUM=0.0D0
          DO J=1,NDM
             DUM=DUM+(U1(J)-XEQUIB2(J))*VT(I,J,1)
          ENDDO
          KP=KP+1
          FB(JB)=DUM-PAR(KP)
          JB=JB+1
       ENDDO
       !    *NDM initial conditions for the equilibrium if IEQUIB=1,2,-2
       IF ((IEQUIB/=0).AND.(IEQUIB/=-1)) THEN
          CALL FUNC(NDM,XEQUIB1,ICP,PAR,0,FB(JB),DUM1,DUM2)
          JB=JB+NDM
          !    *NDM extra initial conditions for the equilibrium if IEQUIB=-2
          IF (IEQUIB==-2) THEN
             CALL FUNC(NDM,XEQUIB2,ICP,PAR,0,FB(JB),DUM1,DUM2)
             JB=JB+NDM
          ENDIF
       ENDIF
    ENDIF

    NBCN=NBC-JB+1
    !  write(9,*) NBCN,NBC
    ! *user defined extra boundary conditions
    IF (NBCN>0) THEN
       CALL BCND(NDIM,PAR,ICP,NBCN,U0,U1,FB(JB),0,DUM2)
    ELSEIF (NBCN<0) THEN
       PRINT*,'Evil BUG!: Negative number of boundary conditions left'
       CALL AUTOSTOP()
    END IF

    DEALLOCATE(VR,VT,BOUND,RR,RI,XEQUIB1,XEQUIB2)
  END SUBROUTINE FBHO

! ---------- ----
  SUBROUTINE ICHO(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Generates integral conditions for homoclinic bifurcation analysis

    USE INTERFACES
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    INTEGER NDM,NPAR,I,JB
    DOUBLE PRECISION, ALLOCATABLE :: DNT(:,:)
    DOUBLE PRECISION DUM,DUM1(1)

    NDM=AP%NDM
    NPAR=AP%NPAR
    JB=0

    ! Integral phase condition for homoclinic orbit

    IF(AP%NREV==0.AND.(AP%NPARI==0.OR.NDIM==NDM)) THEN
       DUM=0.d0
       DO I=1,NDM
          DUM=DUM+UPOLD(I)*(U(I)-UOLD(I))
       ENDDO
       JB=JB+1
       F(JB)=DUM
       IF(IJAC/=0)THEN
          DINT(JB,1:NDM)=UPOLD(1:NDM)
          DINT(JB,NDM+1:NDIM+NPAR)=0.d0
       ENDIF

       ! Integral phase condition for adjoint equation     

       IF (NDIM>NDM) THEN
          DUM=0.d0
          DO I=1,NDM
             DUM=DUM+UOLD(NDM+I)*(U(NDM+I)-UOLD(NDM+I))
          ENDDO
          JB=JB+1
          F(JB)=DUM
          IF(IJAC/=0)THEN
             DINT(JB,1:NDM)=0.d0
             DINT(JB,NDM+1:2*NDM)=UOLD(NDM+1:2*NDM)
             DINT(JB,2*NDM+1:NDIM+NPAR)=0.d0
          ENDIF
       ENDIF
    ENDIF

    ! User-defined integral constraints

    IF (JB<NINT) THEN
       IF(IJAC/=0)THEN
          ALLOCATE(DNT(NINT-JB,NDM))
          CALL ICNI(AP,NDM,PAR,ICP,NINT-JB,U,UOLD,UDOT,UPOLD,F(JB),IJAC,DNT)
          DINT(JB+1:NINT,1:NDM)=DNT(1:NINT-JB,1:NDM)
          DINT(JB+1:NINT,NDM+1:NDIM)=0d0
          DINT(JB+1:NINT,NDIM+1:NDIM+NPAR)=DNT(1:NINT-JB,1:NDM+NPAR)
          DEALLOCATE(DNT)
       ELSE
          CALL ICNI(AP,NDM,PAR,ICP,NINT-JB,U,UOLD,UDOT,UPOLD,F(JB),0,DUM1)
       ENDIF
    END IF

  END SUBROUTINE ICHO

! ---------- -----
  SUBROUTINE FNHOL(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates starting data for the continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNBLF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNHO)

  END SUBROUTINE FNHOL

! ---------- ----
  SUBROUTINE BCHOL(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC)

    ! Generates the boundary conditions for continuation of folds for
    ! homoclinic bifurcation analysis

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,ICP(*),NBC,IJAC
    DOUBLE PRECISION, INTENT(INOUT) :: U0(NDIM),U1(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    CALL BCBLF(AP,NDIM,PAR,ICP,NBC,U0,U1,F,IJAC,DBC,BCHO)

  END SUBROUTINE BCHOL

! ---------- -----
  SUBROUTINE ICHOL(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Generates integral conditions for folds in homoclinic bifurcation analysis

    USE INTERFACES
    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    CALL ICBLF(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT,ICHO)

  END SUBROUTINE ICHOL

! ---------- -------
  SUBROUTINE INSTRHO(KEYSTR,VALSTR,LISTLEN,IERR)

    CHARACTER(LEN=*), INTENT(IN) :: KEYSTR, VALSTR
    INTEGER, INTENT(IN) :: LISTLEN
    INTEGER, INTENT(OUT) :: IERR
    INTEGER NDIM,I

    ! read HomCont constants from a string

    IERR = 0
    IF(.NOT.INITCNST)THEN
       NUNSTAB=-1
       NSTAB=-1
       IEQUIB=1
       ITWIST=0
       ISTART=5 ! default is 1 or 4 depending on IPS from solution
       NREV=0
       NFIXED=0
       NPSI=0
       ALLOCATE(IREV(0),IFIXED(0),IPSI(0))
    ENDIF
    INITCNST = .TRUE.
    SELECT CASE(KEYSTR)
    CASE('NUNSTAB')
       READ(VALSTR,*,ERR=3)NUNSTAB
    CASE('NSTAB')
       READ(VALSTR,*,ERR=3)NSTAB
    CASE('IEQUIB')
       READ(VALSTR,*,ERR=3)IEQUIB
    CASE('ISTART')
       READ(VALSTR,*,ERR=3)ISTART
    CASE('ITWIST')
       READ(VALSTR,*,ERR=3)ITWIST
    CASE('IREV')
       NDIM=LISTLEN
       IF(ALLOCATED(IREV))DEALLOCATE(IREV)
       ALLOCATE(IREV(NDIM))
       READ(VALSTR,*,ERR=3)(IREV(I),I=1,NDIM)
       NREV=1
    CASE('IFIXED')
       NFIXED=LISTLEN
       IF(ALLOCATED(IFIXED))DEALLOCATE(IFIXED)
       ALLOCATE(IFIXED(NFIXED))
       READ(VALSTR,*,ERR=3)(IFIXED(I),I=1,NFIXED)
    CASE('IPSI')
       NPSI=LISTLEN
       IF(ALLOCATED(IPSI))DEALLOCATE(IPSI)
       ALLOCATE(IPSI(NPSI))
       READ(VALSTR,*,ERR=3)(IPSI(I),I=1,NPSI)
    CASE DEFAULT
       IERR = 1
    END SELECT
    RETURN
3   IERR = 3
  END SUBROUTINE INSTRHO

! ---------- ----
  SUBROUTINE INHO(AP,ICP)

    USE IO, ONLY: GETIPS3
    USE SUPPORT, ONLY: AUTOSTOP

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    DOUBLE PRECISION, PARAMETER :: HMACHHO=1.0d-13
    INTEGER, INTENT(INOUT) :: ICP(*)

    INTEGER NDIM,ISW,NBC,NINT,NDM,stat,I,ICORR,LINE,NBCPROJ,NFREE
    INTEGER NPARI,NPAR,IPS3,IRS

    ! Reads from fort.11 specific constants for homoclinic continuation.
    ! Sets up re-defined constants in AP. 
    ! Sets other constants in the module common blocks.

    ! set various constants 

    NDIM=AP%NDIM
    IRS=AP%IRS
    ISW=AP%ISW
    NBC=AP%NBC
    NINT=AP%NINT
    NDM=NDIM
    COMPZERO=HMACHHO

    OPEN(UNIT=12,FILE='fort.12',STATUS='OLD',ACCESS='sequential',IOSTAT=stat)
    IF(STAT/=0)THEN
       IF(.NOT.NEWCFILE)THEN
          WRITE(6,"(A)") &
           " Error: Using HomCont without fort.12, h., or new-style c. file."
          CALL AUTOSTOP()
       ENDIF
    ELSE
       LINE=1
       READ(12,*,ERR=1,END=2)NUNSTAB,NSTAB,IEQUIB,ITWIST,ISTART

       ! updated reading in of constants for reversible equations
       ! replaces location in datafile of compzero

       IF(ALLOCATED(IREV))DEALLOCATE(IREV)
       LINE=LINE+1
       READ(12,*,ERR=1,END=2)NREV
       IF(NREV>0)THEN
          ALLOCATE(IREV(NDM))
          LINE=LINE+1
          READ(12,*,ERR=1,END=2)(IREV(I),I=1,NDM)
       ELSE
          ALLOCATE(IREV(0))
       ENDIF

       LINE=LINE+1
       READ(12,*,ERR=1,END=2)NFIXED
       IF(ALLOCATED(IFIXED))DEALLOCATE(IFIXED)
       ALLOCATE(IFIXED(NFIXED))
       IF (NFIXED>0)THEN
          LINE=LINE+1
          READ(12,*,ERR=1,END=2)(IFIXED(I),I=1,NFIXED)
       ENDIF
       LINE=LINE+1
       READ(12,*,ERR=1,END=2)NPSI
       IF(ALLOCATED(IPSI))DEALLOCATE(IPSI)
       ALLOCATE(IPSI(NPSI))
       IF (NPSI>0)THEN
          LINE=LINE+1
          READ(12,*,ERR=1,END=2)(IPSI(I),I=1,NPSI)
       ENDIF
       CLOSE(UNIT=12,STATUS='KEEP')
    ENDIF
    NFREE=2+NFIXED-NREV+NINT+NBC
    IF (ISTART<0) THEN
       !    n-homoclinic branch switching
       NFREE=NFREE-ISTART-1
       NDIM=NDM*(-ISTART+1)
       ! make sure there is enough room for the Lin vector etc.
       NPARI=2*NDM
       AP%NPARI=NPARI

       ! Free parameter (artificial parameter for psi)
       ! nondegeneracy parameter of the adjoint

    ELSE
       IF (NPSI>0) THEN
          NPAR=AP%NPAR
          NPAR=MAX(20+MAXVAL(IPSI),NPAR)
          AP%NPAR=NPAR
       ENDIF
       IF (ITWIST==1) THEN
          NFREE = NFREE + 1
          ICP(NFREE) = 10
          NDIM=NDM*2
       ENDIF
    ENDIF

    ! Extra free parameters for equilibrium if iequib=1,2,-2

    IF ((IEQUIB/=0).AND.(IEQUIB/=-1)) THEN
       DO I=1,NDM
          ICP(NFREE+I)=11+I
       ENDDO
    ENDIF

    IF (IEQUIB==-2) THEN
       DO I=1,NDM
          ICP(NFREE+NDM+I)=11+NDM+I
       ENDDO
    ENDIF

    HCONST%NUNSTAB=NUNSTAB
    HCONST%NSTAB=NSTAB
    HCONST%IEQUIB=IEQUIB
    HCONST%ITWIST=ITWIST
    HCONST%ISTART=ISTART
    HCONST%IREV=>IREV
    HCONST%IFIXED=>IFIXED
    HCONST%IPSI=>IPSI
    IF (ISTART==5) THEN
       ISTART=1
       IF(IRS/=0)THEN
          IPS3=GETIPS3()
          IF(IPS3/=9.AND.IPS3/=0)THEN
             ISTART=4
          ENDIF
       ENDIF
    ENDIF
    IF(NSTAB==-1.OR.NUNSTAB==-1)THEN
       IF (IEQUIB==2) THEN
          NBCPROJ=NDM-1
       ELSE
          NBCPROJ=NDM
       ENDIF
    ELSE
       NBCPROJ=NSTAB+NUNSTAB
    ENDIF
    IF(NSTAB==-1.AND.NUNSTAB/=-1)THEN
       NSTAB=NBCPROJ-NUNSTAB
    ELSEIF(NUNSTAB==-1.AND.NSTAB/=-1)THEN
       NUNSTAB=NBCPROJ-NSTAB
    ENDIF

    IF (ISTART/=3) THEN
       ! *regular continuation
       IF (ISTART.GE.0) THEN
          NINT=NINT+ITWIST+1-NREV
       ENDIF
       IF (ISW==2.AND.AP%ITP/=5.AND.ABS(AP%ITP)/10/=5)THEN
          ICORR = 2
       ELSE
          ICORR = 1
       ENDIF
       NBC=NBC+NBCPROJ+NDIM-NDM+IEQUIB*NDM+NFREE-NINT-ICORR
       IF (IEQUIB==2) THEN
          NBC=NBC-NDM+1
       ENDIF
       IF (IEQUIB<0) THEN
          NBC=NBC-(3*IEQUIB+2)*NDM
       ENDIF
    ELSE
       ! *starting solutions using homotopy
       IF (ABS(NUNSTAB)==1) THEN
          NBC=NDM*(1+IEQUIB)+1
       ELSE
          NBC=NDM*(1+IEQUIB)+NUNSTAB+1
       ENDIF
       IF (IEQUIB==2.AND.AP%IID>0) THEN 
          WRITE(9,*)'WARNING: IEQUIB=2 NOT ALLOWED WITH ISTART=3'
       ENDIF
       IF (IEQUIB<0) THEN
          NBC=NBC-NDM*(3*IEQUIB+2)
       ENDIF
       NINT=0
    ENDIF

    ! write new constants into AP

    AP%NDIM=NDIM
    AP%NBC=NBC
    AP%NINT=NINT
    AP%NDM=NDM
    AP%NREV=NREV
    AP%NFPR=NBC+NINT-NDIM+1

    RETURN

1   WRITE(6,"(A,I2,A)") &
         " Error in fort.12 or h. file: bad integer on line ",LINE,"."
    GOTO 3
2   WRITE(6,"(A,I2,A)") &
         " Error in fort.12 or h. file: ends prematurely on line ",LINE,"."
3   CLOSE(UNIT=12,STATUS='KEEP')
    CALL AUTOSTOP()

  END SUBROUTINE INHO

! ---------- ------
  SUBROUTINE INTPHO(NDM,NCOLRS,TM,DTM,UPS,UDOTPS,T,DT,N,NDIM,J,J1)

    USE MESH, ONLY: INTWTS
    INTEGER, INTENT(IN) :: NDM,NCOLRS,N,NDIM,J,J1
    DOUBLE PRECISION, INTENT(IN) :: TM,DTM,T,DT
    DOUBLE PRECISION, INTENT(INOUT) :: UPS(NDIM,0:*),UDOTPS(NDIM,0:*)

    ! Local

    INTEGER I,JJ,K
    DOUBLE PRECISION W(0:NCOLRS)

    ! Finds interpolant (TM(.) , UPS(.), UDOTPS(.) ) on the new mesh
    ! at times TM,TM+DTM using the old mesh at times T,T+DT.

    ! Used by TRANHO to initiate branch switching to n-homoclinic orbits.

    DO I=0,NCOLRS-1
       CALL INTWTS(NCOLRS,(NCOLRS*(T-TM)+DT*I)/DTM,W)
       JJ=J1+I
       DO K=1,NDM
          UPS(N+K,JJ)=DOT_PRODUCT(W(:),UPS(N+K,J:J+NCOLRS))
          UDOTPS(N+K,JJ)=DOT_PRODUCT(W(:),UDOTPS(N+K,J:J+NCOLRS))
       ENDDO
    ENDDO

  END SUBROUTINE INTPHO

! ---------- ------
  SUBROUTINE TRANHO(NTSR,NCOLRS,NDM,NDIM,TM,UPS,UDOTPS,PAR,ICP,NPAR)

    ! Transform the data representation of the homoclinic orbit into
    ! an object suitable for homoclinic branch switching:

    ! dim|1...............NDM|NDM+1......NDIM-NDM|NDIM-NDM+1......NDIM|
    !    |                   |                   |                    |
    ! t=0|start of hom. orbit|maximum from equil.| maximum from equil.|
    !    |       :           |       :           |       :            |
    !    |       :           |end of hom. orbit  |       :            |
    !    |       :           |start of hom. orbit|       :            |
    !    |       :           |        :          |       :            |
    ! t=1|maximum from equil.|maximum from equil.| end of hom. orbit  |

    ! Called by PREHO

    USE BVP, ONLY: NRTN,IRTN
    USE SUPPORT, ONLY: PI
    USE INTERFACES, ONLY: FUNC
    INTEGER, INTENT(IN) :: NCOLRS,NDM,NDIM,ICP(*),NPAR
    INTEGER, INTENT(INOUT) :: NTSR
    DOUBLE PRECISION, INTENT(INOUT) :: TM(0:*), UPS(NDIM,0:*), &
         UDOTPS(NDIM,0:*), PAR(*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: TTM(:)
    INTEGER J2(3),I2L(1),I,I2,J,JJ,JMAX,K,K2,L,LL,LLL,IADDPH,NTNC
    DOUBLE PRECISION A(3),B(3),T(3),TT(3),DUM1(1),DUM2(1)
    DOUBLE PRECISION D1,DNORM,DTM,P,PHDIFF,TMMAX,UPSI,UPSMAX

    ALLOCATE(TTM(0:NTSR*2-1))

    ! First find maximum from the equilibrium

    UPSMAX=0
    JMAX=0
    DO J=0,NTSR
       UPSI=0
       DO I=1,NDM
          UPSI=UPSI+(UPS(I,J*NCOLRS)-PAR(11+I))**2
       ENDDO
       IF (UPSI>UPSMAX) THEN
          UPSMAX=UPSI
          JMAX=J
       ENDIF
    ENDDO
    IF(IRTN/=0)THEN
       ! Just use the point in the middle
       UPSMAX = 0
       DO I=1,NDM
          IF(NRTN(I)/=0)EXIT
       ENDDO
       DO J=0,NTSR
          D1=ABS(UPS(I,J*NCOLRS)-PAR(I+11))
          UPSI=ABS(UPS(I,J*NCOLRS)-(PAR(I+11)+PI(2.d0)*NRTN(I)))
          IF(D1<UPSI)UPSI=D1
          IF(UPSI>UPSMAX)THEN
             UPSMAX=UPSI
             JMAX=J
          ENDIF
       ENDDO
    ENDIF
    TMMAX=TM(JMAX)
    CALL FUNC(NDM,UPS(1,JMAX*NCOLRS),ICP,PAR,0,PAR(NPAR-NDM+1),DUM1,DUM2)

    ! PAR(NPAR-NDM+1...NPAR) contains the point furthest from
    ! the equilibrium.
    ! PAR(10)=the time for the unstable manifold tail.
    ! PAR(11)=the time for the stable manifold tail.
    ! PAR(20,22,...) contain the gap sizes.
    ! PAR(21,23,...) contain the times between Poincare sections

    PAR(10)=PAR(11)*TMMAX
    PAR(20)=0D0
    DO K=1,NDIM/NDM-2
       PAR(19+2*K)=PAR(11)
       PAR(20+2*K)=0D0
    ENDDO
    PAR(11)=PAR(11)*(1D0-TMMAX)

    ! Remember adjoint at maximum for applying Lin's method
    ! PAR(NPAR-2*NDM+1...NPAR-NDM) will contain the adjoint unit
    ! vector at the gaps.

    IF (ITWIST==1) THEN
       DNORM=0.D0
       DO I=1,NDM
          PAR(NPAR-2*NDM+I)=UPS(NDM+I,JMAX*NCOLRS)
          DNORM=DNORM+UPS(NDM+I,JMAX*NCOLRS)**2
       ENDDO
       DNORM=SQRT(DNORM)
       DO I=1,NDM
          PAR(NPAR-2*NDM+I)=PAR(NPAR-2*NDM+I)/DNORM
       ENDDO
    ENDIF

    ! Prepare the new NDIM*NCOLRS dimensional UPS matrix
    ! Move everything to the end in "middle part format"
    ! so that we can subsequently overwrite the beginning.

    PHDIFF=0
    IADDPH=1
    DO L=2*NTSR-1,NTSR-1,-1
       J=L-(2*NTSR-1)+JMAX
       ! move J=0...JMAX to
       !  L=2*NTSR-1-JMAX...2*NTSR-1
       ! move J=JMAX...NTSR-1 to
       !  L=NTSR-1...2*NTSR-2-JMAX
       IF (J<0) THEN
          J=J+NTSR
          IADDPH=0
       ENDIF
       TTM(L)=TM(J)-TMMAX
       IF (TTM(L)<0) TTM(L)=TTM(L)+1D0
       DO K=0,NCOLRS-1
          JJ=J*NCOLRS+K
          LL=L*NCOLRS+K
          DO I=1,NDM
             IF(IRTN/=0)THEN
                PHDIFF=0
                IF(IADDPH/=0)PHDIFF=PI(2.d0)*NRTN(MOD(I-1,NDM)+1)
             ENDIF
             UPS(I+NDM,LL)=UPS(I,JJ)+PHDIFF
             UDOTPS(I+NDM,LL)=UDOTPS(I,JJ)+PHDIFF
             UPS(I,LL)=UPS(I,JJ)
             UDOTPS(I,LL)=UDOTPS(I,JJ)
             IF (L<2*NTSR-JMAX) THEN
                ! move J=JMAX...NTSR to
                !  L+JMAX=NTSR-1+JMAX...2*NTSR-1
                IF(IRTN/=0)THEN
                   PHDIFF=PI(2.d0)*NRTN(MOD(I-1,NDM)+1)*(-ISTART-1)
                ENDIF
                LLL=LL+JMAX*NCOLRS
                IF(L==2*NTSR-JMAX-1)THEN
                   UPS(I+NDIM-NDM,LLL)=UPS(I,NTSR*NCOLRS)+PHDIFF
                   UDOTPS(I+NDIM-NDM,LLL)=UDOTPS(I,NTSR*NCOLRS)+PHDIFF
                ELSE
                   UPS(I+NDIM-NDM,LLL)=UPS(I,JJ)+PHDIFF
                   UDOTPS(I+NDIM-NDM,LLL)=UDOTPS(I,JJ)+PHDIFF
                ENDIF
             ENDIF
          ENDDO
       ENDDO
    ENDDO
    TTM(2*NTSR-1)=1D0

    ! create matching mesh
    ! merge TM(1..JMAX)/TMMAX, TM(JMAX..NTSR)-TMMAX,
    !       TM(1..JMAX)+1D0-TMMAX, 
    !       (TM(JMAX..NTSR)-TMMAX)/(1D0-TMMAX)

    J2(1) = 2*NTSR-JMAX
    J2(2) = NTSR
    J2(3) = NTSR
    A(1) = TMMAX-1D0
    A(2) = 0D0
    A(3) = 0D0
    B(1) = TMMAX
    B(2) = 1D0
    B(3) = 1D0-TMMAX
    NTSR=NTSR*2-2
    DO I=1,3
       T(I) = (TTM(J2(I))+A(I))/B(I)
       TT(I) = (TTM(J2(I)-1)+A(I))/B(I)
    ENDDO
    DO J=0,NTSR-1
       I2L=MINLOC(T)
       I2=I2L(1)
       TM(J+1)=T(I2)
       JJ=J*NCOLRS
       DTM=TM(J+1)-TM(J)

       ! Replace UPS and UDOTPS by its interpolant on the new mesh :

       CALL INTPHO(NDM,NCOLRS,TT(1),T(1)-TT(1),UPS,UDOTPS, &
            TM(J),DTM,0,NDIM,(J2(1)-1)*NCOLRS,JJ)

       ! Remesh middle part :

       CALL INTPHO(NDM,NCOLRS,TT(2),T(2)-TT(2),UPS,UDOTPS, &
            TM(J),DTM,NDM,NDIM,(J2(2)-1)*NCOLRS,JJ)

       ! Remesh last part :

       CALL INTPHO(NDM,NCOLRS,TT(3),T(3)-TT(3),UPS,UDOTPS, &
            TM(J),DTM,NDIM-NDM,NDIM,(J2(3)+JMAX-1)*NCOLRS,JJ)

       ! Copy middle parts, this applies only for 1->n switching
       ! where n>=3 and NDIM=(n+1)*NDM: (NDIM/NDM)-3 times.

       DO K2=NDM,NDIM-3*NDM,NDM
          DO K=0,NCOLRS-1
             DO I=NDM+1,2*NDM
                IF(IRTN/=0)THEN
                   PHDIFF=PI(2.d0)*NRTN(MOD(I-1,NDM)+1)*(K2/NDM)
                ENDIF
                UPS(I+K2,JJ+K)=UPS(I,JJ+K)+PHDIFF
                UDOTPS(I+K2,JJ+K)=UDOTPS(I,JJ+K)+PHDIFF
             ENDDO
          ENDDO
       ENDDO
       J2(I2)=J2(I2)+1
       TT(I2)=T(I2)
       IF(J<NTSR-1)THEN
          T(I2)=(TTM(J2(I2))+A(I2))/B(I2)
       ENDIF
    ENDDO

    ! Adjust end points

    NTNC=NTSR*NCOLRS
    DO I=1,NDM
       IF(IRTN/=0)PHDIFF=PI(2.d0)*NRTN(I)
       DO K2=I,NDIM-NDM,NDM
          P=PHDIFF*((K2-I)/NDM-1)
          UPS(K2,NTNC)=UPS(I+NDM,NTNC+NCOLRS)+P
          UDOTPS(K2,NTNC)=UDOTPS(I+NDM,NTNC+NCOLRS)+P
       ENDDO
       UPS(I+NDIM-NDM,NTNC)=UPS(I+NDIM-NDM,NTNC+NCOLRS)
       UDOTPS(I+NDIM-NDM,NTNC)=UDOTPS(I+NDIM-NDM,NTNC+NCOLRS)
    ENDDO

    ! Rotations: NRTN needs adjustment

    IF(IRTN/=0)THEN
       NRTN(1:NDM)=NRTN(1:NDM)*(-ISTART)
    ENDIF
    DEALLOCATE(TTM)
  END SUBROUTINE TRANHO

! ---------- ------
  SUBROUTINE CPBKHO(NTSR,NCOLRS,NAR,NDM,TM,UPS,UDOTPS,PAR)

    INTEGER, INTENT(IN) :: NCOLRS,NDM
    INTEGER, INTENT(INOUT) :: NTSR,NAR
    DOUBLE PRECISION, INTENT(INOUT) :: UPS(NAR,0:*), UDOTPS(NAR,0:*)
    DOUBLE PRECISION, INTENT(INOUT) :: TM(0:*), PAR(*)

    INTEGER NCOPY,I,J,K,M
    DOUBLE PRECISION TIME,TBASE

    ! Copy the homoclinic orbit back from the special representation 
    ! gotten from TRANHO to the usual representation.
    ! This is called from PREHO in order to perform normal continuation
    ! again once the branch switching is complete.

    NCOPY=NAR/NDM
    TIME=PAR(10)+PAR(11)
    DO K=1,NCOPY-2
       TIME=TIME+PAR(19+2*K)
    ENDDO
    TBASE=TIME-PAR(11)
    TM(NTSR*NCOPY)=1.0D0

    ! first init last point; otherwise it's overwritten

    DO K=1,NDM
       UPS(K,NTSR*NCOPY*NCOLRS)=UPS(K+(NCOPY-1)*NDM,NTSR*NCOLRS)
       UDOTPS(K,NTSR*NCOPY*NCOLRS)=UDOTPS(K+(NCOPY-1)*NDM,NTSR*NCOLRS)
    ENDDO
    DO K=NCOPY-1,0,-1
       DO J=NCOLRS*NTSR-1,0,-1
          I=J+NTSR*NCOLRS*K
          DO M=1,NDM
             UPS(M,I)=UPS(K*NDM+M,J)
             UDOTPS(M,I)=UDOTPS(K*NDM+M,J)
          ENDDO
       ENDDO
    ENDDO
    DO J=NTSR,1,-1
       TM(J+NTSR*(NCOPY-1))=(TBASE+TM(J)*PAR(11))/TIME
    ENDDO
    DO K=NCOPY-2,1,-1
       TBASE=TBASE-PAR(19+2*K)
       DO J=NTSR,1,-1
          TM(J+NTSR*K)=(TBASE+TM(J)*PAR(19+K*2))/TIME
       ENDDO
    ENDDO
    DO J=1,NTSR
       TM(J)=TM(J)*PAR(10)/TIME
    ENDDO
    NTSR=NTSR*NCOPY

    PAR(10)=0.D0
    PAR(11)=TIME
    NAR=NDM
  END SUBROUTINE CPBKHO

! ---------- -----
  SUBROUTINE PREHO(AP,PAR,ICP,NTSR,NAR,NCOLRS,UPS,UDOTPS,TM)

    ! Special homoclinic orbit preprocessing.

    USE BVP, ONLY: IRTN,NRTN,SETRTN
    USE SUPPORT, ONLY: PI
    USE INTERFACES, ONLY: FUNC

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NCOLRS
    INTEGER, INTENT(INOUT) :: NTSR,NAR
    DOUBLE PRECISION, INTENT(INOUT) :: UPS(AP%NDIM,0:NTSR*NCOLRS), &
         TM(0:NTSR),UDOTPS(AP%NDIM,0:NTSR*NCOLRS),PAR(*)

    ! Local

    DOUBLE PRECISION, ALLOCATABLE :: F(:)
    INTEGER NDIM,NDM,NPAR,II,IT,IST,I,J,J1,J2,JMIN,JR
    DOUBLE PRECISION T,TMMIN,UPSI,UPSMIN,DUM1(1),DUM2(1)

    NDIM=AP%NDIM
    NDM=AP%NDM
    NPAR=AP%NPAR

    IF (ISTART.GE.0.AND.NAR>2*NDM) THEN
       !    Use the usual representation again for normal continuation.
       CALL CPBKHO(NTSR,NCOLRS,NAR,NDM,TM,UPS,UDOTPS,PAR)
    ENDIF
    ! Look for rotations
    IF(IEQUIB.GE.0)THEN
       CALL SETRTN(NDM,NTSR*NCOLRS,NDIM,UPS)
    ENDIF
    IF (ISTART<0 .AND. .NOT.(NAR<NDIM .AND. NAR<3*NDM)) THEN
       !    Adjust rotations
       IF(IRTN==0)ALLOCATE(NRTN(NDM))
       IRTN=0
       DO I=1,NDM
          NRTN(I)=NINT( (UPS(NAR-NDM+I,NTSR*NCOLRS)-UPS(I,0)) / &
               (PI(2.d0) * (-ISTART)) )
          IF(NRTN(I)/=0)THEN
             IRTN=1
          ENDIF
       ENDDO
       IF(IRTN==0)DEALLOCATE(NRTN)
    ENDIF

    ! Shift phase if necessary if continuing from
    ! a periodic orbit into a homoclinic one

    IF (ISTART==4) THEN

       ! Try to find an approximate value for the equilibrium if it's not
       ! explicitely given. This is just the point where the speed is minimal.
       ! We hope that Newton's method will do the rest.

       IF (IEQUIB>0) THEN
          ALLOCATE(F(NDM))
          UPSMIN=HUGE(1.d0)
          JMIN=0
          DO J=0,NTSR*NCOLRS
             CALL FUNC(NDM,UPS(1,J),ICP,PAR,0,F,DUM1,DUM2)
             UPSI=0
             DO I=1,NDM
                UPSI=UPSI+F(I)*F(I)
             ENDDO
             IF (UPSI<UPSMIN) THEN
                JMIN = J
                UPSMIN = UPSI
             ENDIF
          ENDDO
          PAR(12:12+NDM-1)=UPS(:,JMIN)
          DEALLOCATE(F)
       ENDIF

       ! Find smallest value in norm

       UPSMIN=HUGE(1.d0)
       JMIN=0
       DO J=0,NTSR
          UPSI=0
          DO I=1,NDM
             UPSI=UPSI+(UPS(I,J*NCOLRS)-PAR(11+I))**2
          ENDDO
          IF (UPSI<UPSMIN) THEN
             UPSMIN=UPSI
             JMIN=J
          ENDIF
       ENDDO
       IF(UPSMIN<COMPZERO)THEN

          !  try to get time central value if all points within a range
          !  are within an epsilon neighbourhood of the equilibrium

          T=0
          J2=JMIN
          J1=J2
          J=JMIN-1
          DO WHILE(J/=JMIN+1)
             IF(J==-1)J=NTSR
             UPSI=0
             DO I=1,NDM
                UPSI=UPSI+(UPS(I,J*NCOLRS)-PAR(I+11))**2
             ENDDO
             IF(UPSI>COMPZERO)THEN
                J1=J+1
                IF(J1==NTSR+1)J1=0
                EXIT
             ENDIF
             J=J-1
          ENDDO
          J=JMIN+1
          DO WHILE(J/=J1)
             IF(J==NTSR+1)J=0
             UPSI=0
             DO I=1,NDM
                UPSI=UPSI+(UPS(I,J*NCOLRS)-PAR(I+11))**2
             ENDDO
             IF(UPSI>COMPZERO)THEN
                J2=J-1
                IF(J2==-1)J2=NTSR
                EXIT
             ENDIF
             J=J+1
          ENDDO
          T=(TM(J2)+TM(J1))/2
          IF(J1>J2)THEN
             T=(TM(J2)+TM(J1)+1)/2
             IF(T>=1)T=T-1
             IF(TM(J1)<=T)THEN
                J2=NTSR
             ELSE
                J1=0
             ENDIF
          ENDIF
          DO WHILE((TM(J1)<=T).AND.(J1<J2))
             J1=J1+1
          ENDDO
          JMIN=J1
          IF(JMIN==0)THEN
             IF(T-TM(NTSR)<TM(0)-T) JMIN=NTSR
          ELSE
             IF(T-TM(JMIN-1)<TM(JMIN)-T) JMIN=JMIN-1
          ENDIF
       ENDIF
       TMMIN=TM(JMIN)

       ! And then do the actual shift

       IF (JMIN/=0) THEN
          IST=-1
          J=NTSR*NCOLRS
          DO II=0,NTSR*NCOLRS-1
             IF (J==NTSR*NCOLRS) THEN
                IST=IST+1
                IF(MOD(IST,NCOLRS)==0)THEN
                   TM(NTSR)=TM(IST/NCOLRS)
                ENDIF
                UPS(:,J)=UPS(:,IST)
                UDOTPS(:,J)=UDOTPS(:,IST)
                J=IST
             ENDIF
             I=J
             J=J+JMIN*NCOLRS
             IF (J>=NTSR*NCOLRS) J=J-NTSR*NCOLRS
             IF (J==IST) J=NTSR*NCOLRS
             IF(MOD(I,NCOLRS)==0)THEN
                IT=I/NCOLRS
                TM(IT)=TM(J/NCOLRS)-TMMIN
                IF (TM(IT)<0) TM(IT)=TM(IT)+1.0D0
             ENDIF
             UPS(:,I)=UPS(:,J)
             UDOTPS(:,I)=UDOTPS(:,J)
          ENDDO

          ! Last equal to first

          TM(NTSR)=1.0D0
          UPS(:,NCOLRS*NTSR)=UPS(:,0)
          UDOTPS(:,NCOLRS*NTSR)=UDOTPS(:,0)

          ! Rotations

          IF(IRTN/=0)THEN
             JR=-1
             ntsrloop: DO J=0,NTSR*NCOLRS,NCOLRS
                DO I=1,NDM
                   IF(NRTN(I)/=0) THEN
                      IF(ABS((UPS(I,J+NCOLRS)-UPS(I,J))/NRTN(I))>ABS(PI(1d0)))&
                           THEN
                         JR=J+NCOLRS
                         EXIT ntsrloop
                      ENDIF
                   ENDIF
                ENDDO
             ENDDO ntsrloop
             IF(JR/=-1)THEN
                DO I=1,NDIM
                   IF (NRTN(I)/=0) THEN
                      DO J=JR,NTSR*NCOLRS
                         UPS(I,J)=UPS(I,J)+PI(2.d0)*NRTN(I)
                      ENDDO
                   ENDIF
                ENDDO
             ENDIF
          ENDIF

       ENDIF
    ENDIF

    ! If ISTART<0 we perform homoclinic branch switching and need
    ! to change the representation of the homoclinic orbit in UPS and
    ! UDOTPS.

    IF (ISTART<0 .AND. NAR<NDIM .AND. NAR<3*NDM) THEN
       CALL TRANHO(NTSR,NCOLRS,NDM,NDIM,TM,UPS,UDOTPS,PAR,ICP,NPAR)
    ELSEIF (ISTART<0 .AND. NAR<NDIM .AND. NAR.GE.3*NDM) THEN
       ! Copy forelast part
       DO J=0,NTSR*NCOLRS
          DO I=NDIM,NAR-NDM+1,-1
             UPS(I,J)=UPS(I-NDIM+NAR,J)
             UDOTPS(I,J)=UDOTPS(I-NDIM+NAR,J)
          ENDDO
       ENDDO
       DO I=1,(NDIM-NAR)/NDM
          PAR(16+2*(NAR/NDM+I))=PAR(16+2*NAR/NDM)
          PAR(15+2*(NAR/NDM+I))=PAR(15+2*NAR/NDM)
       ENDDO
       PAR(16+2*NAR/NDM)=(UPS(NAR-NDM+1,1)- &
            UPS(NAR-2*NDM+1,NTSR+1))/ PAR(NPAR-2*NDM+1)
    ENDIF

    ! Preprocesses (perturbs) restart data to enable 
    ! initial computation of the adjoint variable

    IF (NAR/=NDIM .AND. ISTART.GE.0 .AND. ITWIST==1) THEN
       PAR(10)= 0.0D0
       UPS(NAR+1:NDIM,:)=0.1d0
    ENDIF

  END SUBROUTINE PREHO

! ---------- ------
  SUBROUTINE STPNHO(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

    USE TOOLBOXBV, ONLY: STPNBV,STPNBV1,STPNBL
    USE BVP, ONLY: SETRTN
    USE MESH, ONLY: ADAPT2
    USE IO, ONLY: GETNDIM3
    USE INTERFACES, ONLY: PVLS

    ! Generates a starting point for the continuation of a branch of
    ! of solutions to general boundary value problems by calling the user
    ! supplied subroutine STPNT where an analytical solution is given.


    ! Generates a starting point for homoclinic continuation
    ! If ISTART=2 it calls STPNBV (STPNUB).
    ! If ISTART=3 it sets up the homotopy method.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(INOUT) :: NTSR,NCOLRS
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),RLDOT(AP%NFPR), &
         UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*),TM(0:*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: RR(:),RI(:),VR(:,:),VT(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: UPSR(:,:),UDOTPSR(:,:),TMR(:)
    INTEGER NDIM,IRS,NTST,NCOL,NDM,NDIM3,NDIMRD,NDIMU,NTSTCU
    INTEGER IP,KP,I,J,K
    DOUBLE PRECISION T,P

    NDIM=AP%NDIM
    IRS=AP%IRS
    NTST=AP%NTST
    NCOL=AP%NCOL
    NDM=AP%NDM

    IF(AP%ITP==5.AND.ABS(AP%ISW)==2) THEN 
       ! ** Fold continuation (start).
       CALL STPNBL(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)
       IF(IEQUIB.GE.0)THEN
          CALL SETRTN(NDM,NTSR*NCOLRS,NDIM,UPS)
       ENDIF
    ELSEIF(IRS>0)THEN

       ! Special case : Preprocess restart data in case of homoclinic
       ! continuation

       NTSTCU=2*NTSR*NCOLRS
       NDIMU=NDIM
       ! Autodetect special case when homoclinic branch switching is
       ! completed and the orbit's representation has to be
       ! changed.
       NDIM3=GETNDIM3()
       IF(NDIM3>(NDM*2).AND.NDIM3>NDIM)THEN
          NTSTCU=NTSR*(NDIM3/NDM)*NCOLRS
          NDIMU=NDIM3
       ENDIF
       ALLOCATE(UPSR(NDIMU,0:NTSTCU),UDOTPSR(NDIMU,0:NTSTCU),TMR(0:NTSTCU))
       CALL STPNBV1(AP,PAR,ICP,NDIMU,NTSR,NDIMRD,NCOLRS,RLDOT, &
            UPSR,UDOTPSR,TMR,NODIR)
       CALL PREHO(AP,PAR,ICP,NTSR,NDIMRD,NCOLRS,UPSR,UDOTPSR,TMR)
       CALL ADAPT2(NTSR,NCOLRS,NDIMU,NTST,NCOL,NDIM, &
            TMR,UPSR,UDOTPSR,TM,UPS,UDOTPS,.FALSE.)
       DEALLOCATE(TMR,UPSR,UDOTPSR)
    ELSE

       ! Generate the (initially uniform) mesh.

       CALL STPNBV(AP,PAR,ICP,NTSR,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)

       ! Initialize solution and additional parameters

       IF(IEQUIB.GE.0)THEN
          CALL SETRTN(NDM,NTSR*NCOLRS,NDIM,UPS)
       ENDIF
    ENDIF

    ALLOCATE(RR(NDM),RI(NDM),VR(NDM,NDM),VT(NDM,NDM))
    CALL PVLS(NDM,UPS,PAR)
    CALL EIGHO(AP,1,RR,RI,VT,PAR(12),ICP,PAR,NDM)
    CALL GETSTAB(NUNSTAB,RR,1)
    CALL EIGHO(AP,2,RR,RI,VR,PAR(12),ICP,PAR,NDM)
    CALL GETSTAB(NSTAB,RR,-1)

    IF (IRS>0.OR.ISTART/=3)THEN
       DEALLOCATE(RR,RI,VR,VT)
       RETURN
    ENDIF

    ! Set up artificial parameters at the left-hand end point of orbit

    IP=12
    IF(IEQUIB.GE.0) THEN 
       IP=IP+NDM
    ELSE
       IP=IP+2*NDM
    ENDIF
    KP=IP

    ! Parameters xi_1=eps_0, xi_i=0, i=2,NSTAB

    PAR(IP+1)=PAR(IP)
    DO I=2,NUNSTAB
       PAR(IP+I)=0.0
    ENDDO
    IP=IP+NUNSTAB

    ! Starting guess for homoclinic orbit in real principal unstable direction

    DO J=0,NTST*NCOL
       T=PAR(11)*J/(NTST*NCOL)
       DO K=1,NDIM
          UPS(K,J)=PAR(11+K)+VR(NSTAB+1,K)*PAR(KP)*EXP(RR(NSTAB+1)*T)
       ENDDO
       IF(AP%IID>0)THEN
          write(9,111)(ups(k,j),k=1,ndim)
       ENDIF
111    format('stpho : ',e20.10)
    ENDDO

    ! Artificial parameters at the right-hand end point of the orbit
    ! omega_i=<x(1)-x_o,w_i^*>

    DO I=1,NUNSTAB
       PAR(IP+I)=0.0
       DO J=1,NDM
          IF(IEQUIB.GE.0) THEN 
             P=0
          ELSE
             P=PAR(11+J)-PAR(11+NDM+J)
          ENDIF
          PAR(IP+I)=PAR(IP+I)+(P+VR(NSTAB+1,J)*PAR(KP)* &
               EXP(RR(NSTAB+1)*PAR(11)))*VT(NSTAB+I,J)
       ENDDO
    ENDDO
    IP=IP+NUNSTAB

    DEALLOCATE(RR,RI,VR,VT)
  END SUBROUTINE STPNHO

! ------ --------- --------
  DOUBLE PRECISION FUNCTION FNCSHO(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE)

    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    USE TOOLBOXBV, ONLY: FNCSBV
    USE AUTOMPI, ONLY : MPIIAM
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: UPS(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: PU0(:),PU1(:),RR(:,:),RI(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: V(:,:,:),VT(:,:,:)
    INTEGER IID,NDM,NTST,NCOL,I,J
    LOGICAL INEIG
    DOUBLE PRECISION ORIENT

    FNCSHO=FNCSBV(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE)
    IF(ITEST>0)RETURN
    IF(MPIIAM()>0)RETURN

    ALLOCATE(PU0(NDIM),PU1(NDIM))
    ALLOCATE(RR(NDIM,2),RI(NDIM,2),V(NDIM,NDIM,2),VT(NDIM,NDIM,2))

    IID=AP%IID
    NDM=AP%NDM
    NTST=AP%NTST
    NCOL=AP%NCOL

    !  *Compute eigenvalues
    INEIG=.FALSE.
    CALL EIGHO(AP,2,RR(1,1),RI(1,1),V(1,1,1),PAR(12),ICP,PAR,NDM)
    IF(IEQUIB<0)THEN
       CALL EIGHO(AP,2,RR(1,2),RI(1,2),V(1,1,2),PAR(12+NDM),ICP,PAR,NDM)
    ENDIF
    IF(IID.GE.3)THEN
       WRITE(9,*) 'EIGENVALUES'
       DO J=1,NDM
          WRITE(9,101) RR(J,1),RI(J,1)
       ENDDO
       IF(IEQUIB<0)THEN
          WRITE(9,*) 'EIGENVALUES of RHS equilibrium'
          DO J=1,NDM
             WRITE(9,101) RR(J,2),RI(J,2)
          ENDDO
       ENDIF
    ENDIF
    IF (((ITWIST==1).AND.(ISTART.GE.0)).OR.NPSI>0) THEN
       DO I=1,NDIM
          PU0(I)=UPS(I)
          PU1(I)=UPS(I+NTST*NCOL*NDIM)
       ENDDO
    ENDIF
    IF ((ITWIST==1).AND.(ISTART.GE.0)) THEN
       CALL EIGHO(AP,1,RR(1,1),RI(1,1),VT(1,1,1),PAR(12),ICP,PAR,NDM)
       IF(IEQUIB<0)THEN
          CALL EIGHO(AP,1,RR(1,2),RI(1,2),VT(1,1,2),PAR(12+NDM),ICP,PAR,NDM)
       ENDIF
       INEIG=.TRUE.
       ORIENT = PSIHO(NDM,0,RR,RI,V,VT,ICP,PAR,PU0,PU1)
       IF(IID.GE.3)THEN
          IF (ORIENT<0.0D0) THEN
             WRITE(9,102) ORIENT             
          ELSE
             WRITE(9,103) ORIENT   
          ENDIF
       ENDIF
    ENDIF

    DO I=1,NPSI
       IF((IPSI(I)>10).AND..NOT.INEIG) THEN
          CALL EIGHO(AP,1,RR(1,1),RI(1,1),VT(1,1,1),PAR(12),ICP,PAR,NDM)
          IF(IEQUIB<0)THEN
             CALL EIGHO(AP,1,RR(1,2),RI(1,2),VT(1,1,2),PAR(12+NDM),ICP,PAR,NDM)
          ENDIF
          INEIG=.TRUE.
       ENDIF
       PAR(20+IPSI(I))=PSIHO(NDM,IPSI(I),RR,RI,V,VT,ICP,PAR,PU0,PU1)
       IF(IID.GE.3)WRITE(9,104)IPSI(I),PAR(20+IPSI(I))
    ENDDO

    DEALLOCATE(PU0,PU1,RR,RI,V,VT)

101 FORMAT(1X,'(',F12.7,',',1X,F12.7,')')
102 FORMAT(1X,'Non-orientable',' (',E20.10,')')
103 FORMAT(1X,'orientable',' (',E20.10,')')      
104 FORMAT(1X,'PSI(',I2,')=',E20.10)

  END FUNCTION FNCSHO

! ------ --------- -------- -----
  DOUBLE PRECISION FUNCTION PSIHO(NDM,IS,RR,RI,V,VT,ICP,PAR,PU0,PU1)

    ! The conditions for degenerate homoclinic orbits are given by PSI(IS)=0.

    ! RR and RI contain the real and imaginary parts of eigenvalues which are
    ! ordered with respect to their real parts (smallest first).    
    ! The (generalised) real eigenvectors are stored as the ROWS of V. 
    ! The (generalised) real left eigenvectors are in the ROWS of VT.
    ! In the block ENDPTS are stored the co-ordinates of the left (PU0)
    ! and right (PU1) endpoints of the solution (+  vector if that is computed)

    USE INTERFACES, ONLY: FUNC
    INTEGER, INTENT(IN) :: ICP(*),NDM,IS
    DOUBLE PRECISION, INTENT(IN) :: PAR(*),RR(NDM,*),RI(NDM,*), &
         V(NDM,NDM,*),VT(NDM,NDM,*),PU0(*),PU1(*)
    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: F0(:),F1(:)
    INTEGER I,J
    DOUBLE PRECISION DROOT,DUM1(1),DUM2(1),F0NORM,F1NORM,S1,S2
    DOUBLE PRECISION U0NORM,U1NORM,VNORM1,VNORM2

    ALLOCATE(F0(NDM),F1(NDM))
    CALL FUNC(NDM,PU0,ICP,PAR,0,F0,DUM1,DUM2)
    CALL FUNC(NDM,PU1,ICP,PAR,0,F1,DUM1,DUM2)

    PSIHO=0.0D0

    !  Compute orientation

    IF (IS==0) THEN
       S1 = 0.0D0
       S2 = 0.0D0
       F0NORM = 0.0D0
       F1NORM = 0.0D0
       U0NORM = 0.0D0
       U1NORM = 0.0D0
       DO J=1,NDM
          S1 = S1 + F1(J)*PU0(NDM+J)
          S2 = S2 + F0(J)*PU1(NDM+J) 
          F0NORM=F0NORM+F0(J)**2
          F1NORM=F1NORM+F1(J)**2
          U0NORM=U0NORM+PU0(J+NDM)**2
          U1NORM=U1NORM+PU1(J+NDM)**2
       ENDDO
       DROOT=DSQRT(F0NORM*F1NORM*U0NORM*U1NORM)
       IF(DROOT/=0.d0)THEN
          PSIHO= - S1*S2/DROOT
       ELSE
          PSIHO=0.d0
       ENDIF
       RETURN
    ENDIF

    IF(IS/=11)DEALLOCATE(F1)
    IF(IS/=12)DEALLOCATE(F0)
    SELECT CASE(IS)

    CASE(1)
       ! Resonant eigenvalues (neutral saddle)
       PSIHO=RR(NSTAB,1)+RR(NSTAB+1,1)+RI(NSTAB,1)+RI(NSTAB+1,1)

    CASE(2)
       ! Double real leading eigenvalues (stable)
       !   (saddle, saddle-focus transition)
       IF (ABS(RI(NSTAB,1))>COMPZERO) THEN
          PSIHO=-(RI(NSTAB,1)-RI(NSTAB-1,1))**2
       ELSE
          PSIHO=(RR(NSTAB,1)-RR(NSTAB-1,1))**2
       ENDIF

    CASE(3)
       ! Double real positive eigenvalues (unstable)
       !   (saddle, saddle-focus transition)
       IF (ABS(RI(NSTAB+1,1))>COMPZERO) THEN
          PSIHO=-(RI(NSTAB+1,1)-RI(NSTAB+2,1))**2
       ELSE
          PSIHO=(RR(NSTAB+1,1)-RR(NSTAB+2,1))**2
       ENDIF

    CASE(4)
       ! Neutral saddle, saddle-focus or bi-focus (includes 1, above, also) 
       PSIHO=RR(NSTAB,1)+RR(NSTAB+1,1)

    CASE(5)
       ! Neutrally-divergent saddle-focus (stable eigenvalues complex)
       PSIHO=RR(NSTAB,1)+RR(NSTAB+1,1)+RR(NSTAB-1,1)

    CASE(6)
       ! Neutrally-divergent saddle-focus (unstable eigenvalues complex)
       PSIHO=RR(NSTAB,1)+RR(NSTAB+1,1)+RR(NSTAB+2,1)

    CASE(7)
       ! Three leading eigenvalues (stable)
       VNORM1 = 0D0
       VNORM2 = 0D0      
       DO I=1,NDM
          VNORM1 = VNORM1 + ABS(V(NSTAB,I,1))
          VNORM2 = VNORM2 + ABS(V(NSTAB-2,I,1))
       ENDDO
       IF (VNORM1>VNORM2) THEN
          PSIHO=RR(NSTAB,1)-RR(NSTAB-2,1)
       ELSE
          PSIHO=RR(NSTAB-2,1)-RR(NSTAB,1)
       ENDIF

    CASE(8)
       ! Three leading eigenvalues (unstable)
       VNORM1 = 0D0
       VNORM2 = 0D0      
       DO I=1,NDM
          VNORM1 = VNORM1 + ABS(V(NSTAB+1,I,1))
          VNORM2 = VNORM2 + ABS(V(NSTAB+3,I,1))
       ENDDO
       IF (VNORM1>VNORM2) THEN
          PSIHO=RR(NSTAB+1,1)-RR(NSTAB+3,1)
       ELSE
          PSIHO=RR(NSTAB+3,1)-RR(NSTAB+1,1)
       ENDIF

    CASE(9)
       ! Local bifurcation (zero eigenvalue or Hopf): NSTAB decreases
       !  (nb. the problem becomes ill-posed after a zero of 9 or 10)
       PSIHO=RR(NSTAB,1)

    CASE(10)
       ! Local bifurcation (zero eigenvalue or Hopf): NSTAB increases 
       PSIHO=RR(NSTAB+1,1) 

    CASE(11)
       ! Orbit flip (with respect to leading stable direction)
       ! e.g. 1D unstable manifold
       DO J=1,NDM
          PSIHO= PSIHO + F1(J)*VT(NSTAB,J,1)
       ENDDO
       PSIHO= PSIHO * EXP(-PAR(11)*RR(NSTAB,1)/2.0D0)
       DEALLOCATE(F1)

    CASE(12)
       ! Orbit flip (with respect to leading unstable direction)
       ! e.g. 1D stable manifold
       DO J=1,NDM
          PSIHO= PSIHO + F0(J)*VT(NSTAB+1,J,1)
       ENDDO
       PSIHO= PSIHO * EXP(PAR(11)*RR(NSTAB+1,1)/2.0D0)
       DEALLOCATE(F0)

    CASE(13)
       ! Inclination flip (critically twisted) with respect to stable manifold
       !   e.g. 1D unstable manifold   
       DO I=1,NDM
          PSIHO= PSIHO + PU0(NDM+I)*V(NSTAB,I,1)
       ENDDO
       PSIHO= PSIHO * EXP(-PAR(11)*RR(NSTAB,1)/2.0D0)

    CASE(14)
       ! Inclination flip (critically twisted) with respect to unstable manifold
       !   e.g. 1D stable manifold
       DO I=1,NDM
          PSIHO= PSIHO + PU1(NDM+I)*V(NSTAB+1,I,1)
       ENDDO
       PSIHO= PSIHO * EXP(PAR(11)*RR(NSTAB+1,1)/2.0D0)

    CASE(15)
       ! Non-central homoclinic to saddle-node (in stable manifold)
       DO I=1,NDM 
          PSIHO=PSIHO+(PAR(11+I)-PU1(I))*V(NSTAB+1,I,1)
       ENDDO

    CASE(16)
       ! Non-central homoclinic to saddle-node (in unstable manifold)
       DO I=1,NDM 
          PSIHO=PSIHO+(PAR(11+I)-PU0(I))*V(NSTAB+1,I,1)
       ENDDO

    END SELECT
  END FUNCTION PSIHO

! ---------- -------
  SUBROUTINE GETSTAB(N,RR,STAB)

    ! Determine number of stable (STAB==-1) or unstable (STAB==1)
    ! eigenvalues in RR

    INTEGER, INTENT(INOUT) :: N
    DOUBLE PRECISION, INTENT(IN) :: RR(:)
    INTEGER, INTENT(IN) :: STAB

    INTEGER I,IAMIN

    IF(N/=-1)RETURN

    IAMIN=0
    IF(IEQUIB==2)THEN
       !exclude eigenvalue closest to zero for saddle-node homs
       IAMIN=1
       DO I=1,SIZE(RR)
          IF(ABS(RR(I))<ABS(RR(IAMIN)))THEN
             IAMIN=I
          ENDIF
       ENDDO
    ENDIF
    N=0
    DO I=1,SIZE(RR)
       IF(I/=IAMIN.AND.RR(I)*STAB>0)THEN
          N=N+1
       ENDIF
    ENDDO
  END SUBROUTINE GETSTAB

! ---------- -----
  SUBROUTINE EIGHO(AP,ITRANS,RR,RI,VRET,XEQUIB,ICP,PAR,NDM)

    ! Uses LAPACK routine DGEEV to calculate the eigenvalues/eigenvectors
    ! of the linearization matrix a (obtained from DFHO) and orders them
    ! according to their real parts. Simple continuity with respect
    ! previous call with same value of ITRANS.

    ! input variables
    !         ITRANS = 1 use transpose of A (left eigenvectors)
    !                = 2 otherwise (right eigenvectors)

    ! output variables
    !         RR,RI real and imaginary parts of eigenvalues, ordered w.r.t
    !            real parts (largest first)
    !         VRET the rows of which are real parts of corresponding 
    !            eigenvectors 

    USE INTERFACES, ONLY:FUNI

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ITRANS,NDM
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*),XEQUIB(*)
    DOUBLE PRECISION, INTENT(OUT) :: RR(NDM),RI(NDM),VRET(NDM,NDM)
    ! Local
    LOGICAL, SAVE :: IEIGC(2) = (/.FALSE.,.FALSE./)
    CHARACTER(1) JOBVL,JOBVR
    DOUBLE PRECISION, ALLOCATABLE :: DFDU(:,:),DFDP(:,:),ZZ(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: F(:),WORK(:)
    DOUBLE PRECISION, SAVE, ALLOCATABLE :: VRPREV(:,:,:)
    INTEGER NPAR,IFAIL,LWORK,I,J,K,L,M
    DOUBLE PRECISION TMP,WORKINFO(1)
    INTEGER, EXTERNAL :: IDAMAX

    NPAR=AP%NPAR
    ALLOCATE(DFDU(NDM,NDM),DFDP(NDM,NPAR),ZZ(NDM,NDM),F(NDM))
    DFDU(:,:)=0.d0
    DFDP(:,:)=0.d0
    IFAIL=0

    CALL FUNI(AP,NDM,XEQUIB,XEQUIB,ICP,PAR,1,F,DFDU,DFDP)
    IF(PAR(11)<0)THEN
       ! reverse time: reverse eigenvalues/vectors
       DFDU(:,:)=-DFDU(:,:)
    ENDIF

    IF (ITRANS==1) THEN
       JOBVL='V'
       JOBVR='N'
    ELSE
       JOBVL='N'
       JOBVR='V'
    ENDIF

    ! LAPACK call for eigenvalues and eigenvectors
    CALL DGEEV(JOBVL,JOBVR,NDM,DFDU,NDM,RR,RI,ZZ,NDM,ZZ,NDM,WORKINFO,-1,IFAIL)
    LWORK=NINT(WORKINFO(1))
    ALLOCATE(WORK(LWORK))
    CALL DGEEV(JOBVL,JOBVR,NDM,DFDU,NDM,RR,RI,ZZ,NDM,ZZ,NDM,WORK,LWORK,IFAIL)
    DEALLOCATE(WORK)

    IF (IFAIL/=0.AND.AP%IID>0) THEN   
       WRITE(9,*) 'LAPACK EIGENVALUE ROUTINE FAILED !'
    ENDIF

    J=1
    DO WHILE(J<NDM)
       IF(RR(J)==RR(J+1).AND.RI(J)/=0.d0)THEN
          ! complex conjugate
          ZZ(:,J+1)=ZZ(:,J)
          J=J+1
       ENDIF
       J=J+1
    ENDDO

    ! Order the eigenvectors/values according size of real part of eigenvalue.
    ! (smallest first)

    DO I=1,NDM-1
       J=I
       DO L=I+1,NDM
          IF (RR(L)<RR(J)) THEN
             J=L
          ENDIF
       ENDDO
       IF(J>I)THEN
          TMP=RR(I)
          RR(I)=RR(J)
          RR(J)=TMP
          TMP=RI(I)
          RI(I)=RI(J)
          RI(J)=TMP
          DO K=1,NDM
             TMP=ZZ(K,I)
             ZZ(K,I)=ZZ(K,J)
             ZZ(K,J)=TMP
          ENDDO
       ENDIF
    ENDDO

    ! Choose sign of real part of eigenvectors to be 
    ! commensurate with that of the corresponding eigenvector 
    ! from the previous call with the same value of ITRANS

    IF (.NOT.IEIGC(ITRANS)) THEN
       IF(.NOT.ALLOCATED(VRPREV))ALLOCATE(VRPREV(NDM,NDM,2))
       ! normalize eigenvector so that the largest (in absolute value)
       ! component is positive
       DO I=1,NDM
          M=IDAMAX(NDM,ZZ(1,I),1)
          IF(ZZ(M,I)<0)THEN
             ZZ(:,I)=-ZZ(:,I)
          ENDIF
       ENDDO
       IEIGC(ITRANS)=.TRUE.
    ELSE
       DO I=1,NDM
          IF (DOT_PRODUCT(ZZ(:,I),VRPREV(:,I,ITRANS))<0.0D0) THEN
             ZZ(:,I)=-ZZ(:,I)
          ENDIF
       ENDDO
    ENDIF
    VRPREV(:,:,ITRANS)=ZZ(:,:)

    ! Send back the transpose of the matrix of real parts of eigenvectors

    DO I=1,NDM
       VRET(I,:)=ZZ(:,I)
    ENDDO

    DEALLOCATE(F,DFDU,DFDP,ZZ)

  END SUBROUTINE EIGHO

! ------- -------- ------
  LOGICAL FUNCTION SELPOS(ER, EI)
    DOUBLE PRECISION, INTENT(IN) :: ER,EI
    SELPOS = ER>0
  END FUNCTION SELPOS

! ------- -------- ------
  LOGICAL FUNCTION SELNEG(ER, EI)
    DOUBLE PRECISION, INTENT(IN) :: ER,EI
    SELNEG = ER<0
  END FUNCTION SELNEG

! ---------- ------
  SUBROUTINE PRJCTN(AP,BOUND,CSAVE,XEQUIB,ICP,PAR,IMFD,IS,ITRANS,NDM)

    ! Compute NUNSTAB (or NSTAB) projection boundary condition functions
    ! onto to the UNSTABLE (or STABLE) manifold of the appropriate equilibrium

    ! IMFD   = -1 stable eigenspace
    !        =  1 unstable eigenspace
    ! ITRANS =  1 use transpose of A
    !        =  2 otherwise
    ! IS     =  I (1 or 2) implies use the ith equilibrium in XEQUIB

    ! Use the normalization in Beyn 1990 (4.4) to ensure continuity 
    ! w.r.t parameters.
    ! For the purposes of this routine the "previous point on the
    ! branch" is at the values of PAR at which the routine was last
    ! called with the same values of IS and ITRANS.

    USE INTERFACES, ONLY:FUNI
    USE SUPPORT, ONLY: GEL

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),IMFD,IS,ITRANS,NDM
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*),XEQUIB(*)
    DOUBLE PRECISION, INTENT(OUT) :: BOUND(NDM,*)
    LOGICAL, INTENT(IN) :: CSAVE
    ! Local
    LOGICAL , SAVE :: IFLAG(2,2) = &
         RESHAPE((/.TRUE.,.TRUE.,.TRUE.,.TRUE./),(/2,2/))
    LOGICAL, ALLOCATABLE :: BWORK(:)
    DOUBLE PRECISION DDUM(1)
    DOUBLE PRECISION, ALLOCATABLE :: ER(:),EI(:),D(:,:),CPREV(:,:,:,:)
    DOUBLE PRECISION, ALLOCATABLE :: DUM1(:,:),DUM2(:,:),FDUM(:)
    DOUBLE PRECISION, ALLOCATABLE :: WORK(:),A(:,:),V(:,:)
    INTEGER MCOND,IFAIL,LWORK,ISDIM,I,J
    INTEGER LOC(1),IWORK(1)
    DOUBLE PRECISION TMP,DET,S,SEP

    SAVE CPREV

    ALLOCATE(A(NDM,NDM),FDUM(NDM))
    A(:,:)=0.d0
    CALL FUNI(AP,NDM,XEQUIB,XEQUIB,ICP,PAR,1,FDUM,A,DDUM)
    IF(PAR(11)<0)THEN
       ! reverse time: reverse eigenvalues/vectors
       A(:,:)=-A(:,:)
    ENDIF
    DEALLOCATE(FDUM)

    ! Compute transpose of A if ITRANS=1
    IF (ITRANS==1) THEN
       DO I=1,NDM
          DO J=1,I-1
             TMP=A(I,J)
             A(I,J)=A(J,I)
             A(J,I)=TMP
          ENDDO
       ENDDO
    ENDIF

    IF (IMFD==1) THEN
       MCOND = NUNSTAB
    ELSE
       MCOND = NSTAB
    ENDIF

    ! Call LAPACK routine for the Schur decomposition of A

    ALLOCATE(ER(NDM),EI(NDM),BWORK(NDM))
    CALL DGEES('V', 'S', SELNEG, NDM, A, NDM, ISDIM, ER, &
         EI, BOUND, NDM, DDUM, -1, BWORK, IFAIL)
    LWORK = NINT(DDUM(1))
    ALLOCATE(WORK(LWORK))
    IF(IMFD==-1)THEN
       CALL DGEES('V', 'S', SELNEG, NDM, A, NDM, ISDIM, ER, &
            EI, BOUND, NDM, WORK, LWORK, BWORK, IFAIL)
    ELSE
       CALL DGEES('V', 'S', SELPOS, NDM, A, NDM, ISDIM, ER, &
            EI, BOUND, NDM, WORK, LWORK, BWORK, IFAIL)
    ENDIF
    IF (IFAIL==0.AND.ISDIM/=MCOND) THEN
       BWORK=.TRUE.

       ! Get orthonormal basis for the nstab lowest eigenvalues
       ! or nunstab highest eigenvalues (real part),
       ! which do not necessarily all have to be negative/positive

       DO I=1,MCOND
          IF (IMFD==-1) THEN
             LOC=MINLOC(ER,BWORK)
          ELSE
             LOC=MAXLOC(ER,BWORK)
          ENDIF
          BWORK(LOC(1))=.FALSE.
       ENDDO
       BWORK=.NOT.BWORK
       CALL DTRSEN('N', 'V', BWORK, NDM, A, NDM, BOUND, NDM, ER, EI, &
            ISDIM, S, SEP, WORK, LWORK, IWORK, 1, IFAIL)
       IF (IFAIL/=0.AND.AP%IID>0) THEN
          WRITE(9,*)'LAPACK SCHUR DECOMPOSITION ROUTINE FAILED !'
       ENDIF
    ENDIF
    DEALLOCATE(A,ER,EI,WORK,BWORK)

    ! Set previous matrix to be the present one if this is the first call
    IF (IFLAG(IS,ITRANS)) THEN
       IF (.NOT.ALLOCATED(CPREV))ALLOCATE(CPREV(NDM,NDM,2,2))
       CPREV(1:NDM,1:MCOND,IS,ITRANS)=BOUND(1:NDM,1:MCOND)
       IFLAG(IS,ITRANS)=.FALSE.
       RETURN
    ENDIF

    ! Calculate the BEYN matrix D and hence BOUND
    ! This amounts to solving (CPREV^T * V) * D = CPREV^T * CPREV
    ! and then calculating BOUND = V * D

    IF(MCOND==0)RETURN

    ALLOCATE(D(MCOND,MCOND),DUM1(MCOND,MCOND),DUM2(MCOND,MCOND))
    ! DUM1 = CPREV^T * BOUND
    CALL DGEMM('T','N',MCOND,MCOND,NDM,1.d0,CPREV(1,1,IS,ITRANS), &
         NDM,BOUND,NDM,0.d0,DUM1,MCOND)
    ! DUM2 = CPREV^T * CPREV
    CALL DGEMM('T','N',MCOND,MCOND,NDM,1.d0,CPREV(1,1,IS,ITRANS), &
         NDM,CPREV(1,1,IS,ITRANS),NDM,0.d0,DUM2,MCOND)

    ! D = DUM1^-1 * DUM2
    CALL GEL(MCOND,DUM1,MCOND,D,DUM2,DET)

    ! BOUND = BOUND * D
    ALLOCATE(V(NDM,MCOND))
    CALL DGEMM('N','N',NDM,MCOND,MCOND,1d0,BOUND,NDM,D,MCOND,0d0,V,NDM)
    BOUND(1:NDM,1:MCOND)=V(1:NDM,1:MCOND)
    DEALLOCATE(V,D,DUM1,DUM2)

    IF(CSAVE)THEN
       CPREV(1:NDM,1:MCOND,IS,ITRANS)=BOUND(1:NDM,1:MCOND)
    ENDIF

  END SUBROUTINE PRJCTN

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

END MODULE HOMCONT

BLOCK DATA
   INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
   COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
   DATA ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV &
        /0,5,1,0,0,-1,-1,0/
END BLOCK DATA

!======================================================================
!======================================================================
! Utility Program for Listing, Deleting, Relabeling Labeled Solutions
!                        in AUTO97 Data Files
!======================================================================
!======================================================================
!
PROGRAM AUTLAB
  USE UTILITY

  IMPLICIT NONE
  INTEGER, ALLOCATABLE :: LBR(:),LPT(:),LTY(:),LLB(:),LNL(:)
  INTEGER, ALLOCATABLE :: LFR(:),LTO(:),LBI(:)
  INTEGER, ALLOCATABLE :: BBR(:),BNB(:)
  TYPE(LABEL), POINTER :: LIST
  CHARACTER(2) CMD
  INTEGER NBR,NLB,NL,ILB

  OPEN(27,FILE='fort.27',STATUS='old',ACCESS='sequential')
  OPEN(28,FILE='fort.28',STATUS='old',ACCESS='sequential')

  NULLIFY(LIST)
  CALL RDFILE8(LIST,NLB,28)
  ALLOCATE(LBR(NLB),LPT(NLB),LTY(NLB),LLB(NLB),LNL(NLB),&
       LFR(NLB),LTO(NLB),LBI(NLB))
  CALL GTFILE8(LIST,NLB,LBR,LPT,LTY,LLB,LNL)
  CALL RDFILE7(LIST,NBR,NLB,LBI,27)
  ALLOCATE(BBR(NBR),BNB(NBR))
  CALL GTFILE7(LIST,NBR,BBR,BNB)
  CALL SYSTEM('clear')
  DO
     CALL RDCMD(NLB,CMD,NL,LFR,LTO)
     SELECT CASE(TRIM(CMD))
     CASE('H')
        CALL SYSTEM('clear')
        CALL HELP
     CASE('L')
        CALL LISTLB(NLB,LBR,LPT,LTY,LLB,LNL,NL,LFR,LTO,.TRUE.)
     CASE('LB')
        CALL LISTBR(NBR,BBR,BNB,NLB,LBI,LNL,NL,LFR,LTO)
     CASE('D')
        CALL DELETE('label',NLB,LLB,LNL,NL,LFR,LTO)
     CASE('DB')
        CALL DELETE('branch',NBR,BBR,BNB,NL,LFR,LTO)
        ! delete all labels on the branch
        DO ILB=1,NLB
           IF(LBI(ILB)/=0)THEN
              IF(BNB(LBI(ILB))==0)THEN
                 LNL(ILB)=0
              ENDIF
           ENDIF
        ENDDO
     CASE('R')
        CALL RELABEL('label',NLB,LLB,LNL,NL,LFR,LTO)
     CASE('RB')
        CALL RELABEL('branch',NBR,BBR,BNB,NL,LFR,LTO)
        DO ILB=1,NLB ! sync solutions
           IF(LBI(ILB)/=0)THEN
              LBR(ILB)=BNB(LBI(ILB))
           ENDIF
        ENDDO
     CASE('W')
        IF(CHCKLB(NLB,LNL))THEN
           WRITE(6,"(/,' Rewriting files ... ')")
           OPEN(37,FILE='fort.37',STATUS='unknown',ACCESS='sequential')
           OPEN(38,FILE='fort.38',STATUS='unknown',ACCESS='sequential')
           CALL WRFILE7(NBR,BNB,NLB,LLB,LNL)
           CALL WRFILE8(LBR,LNL)
           STOP
        ENDIF
     CASE('Q')
        WRITE(6,"(' Relabeling discontinued. Recover original files')")
        STOP
     END SELECT
  ENDDO

CONTAINS

!--------- -----
SUBROUTINE RDCMD(NLB,CMD,NL,LFR,LTO)

  INTEGER NLB,NL
  INTEGER LFR(NLB),LTO(NLB)
  CHARACTER(1) CMD1
  CHARACTER(2) CMD

  INTEGER, SAVE :: IFIRST
  CHARACTER(1) CHR
  CHARACTER(80) LINE
  INTEGER IP,i

  DO
     IF(IFIRST.NE.1)THEN
        WRITE(6,'(/A)',ADVANCE="no")' Enter Command ( h for Help) : '
        IFIRST=1
     ELSE
        WRITE(6,'(/A)',ADVANCE="no")' Enter Command : '
     ENDIF

     LINE=' '
     READ(5,'(A80)')LINE
     IP=1
     CMD1=GETCHR(LINE,IP)
     i=INDEX('hldrwq',CMD1)
     IF(i>=1)THEN
        CMD1='HLDRWQ'(i:i)
        EXIT
     ENDIF
     WRITE(6,'(/A)',ADVANCE="no")' Invalid Command '
     IFIRST=0
  ENDDO
  CMD=CMD1
  IF(CMD1=='L'.OR.CMD1=='D'.OR.CMD1=='R')THEN
     NL=0
     DO
        CHR=GETCHR(LINE,IP)
        IF(CHR=='b'.OR.CHR=='B')THEN
           CMD(2:2)='B'
           CYCLE
        ENDIF
        IF(INDEX('0123456789',CHR)==0)EXIT
        IP=IP-1
        NL=NL+1
        LFR(NL)=GETNUM(LINE,IP)
        CHR=GETCHR(LINE,IP)
        IF(CHR=='-')THEN
           LTO(NL)=GETNUM(LINE,IP)
        ELSE
           IP=IP-1
           LTO(NL)=LFR(NL)
        ENDIF
     ENDDO
  ENDIF

END SUBROUTINE RDCMD

!----------- -------- ------
CHARACTER(1) FUNCTION GETCHR(LINE,IP)
  !
  ! Gets next character from LINE that is not a ' ' or ','
  !
  CHARACTER(80), INTENT(IN) :: LINE
  INTEGER, INTENT(INOUT) :: IP

  INTEGER I

  I=VERIFY(LINE(IP:),' ,')
  IF(I>0)THEN
     IP=IP+I
     GETCHR=LINE(IP-1:IP-1)
  ELSE
     IP=81
     GETCHR=' '
  ENDIF

END FUNCTION GETCHR

!------ -------- ------
INTEGER FUNCTION GETNUM(LINE,IP)

  CHARACTER(80), INTENT(IN) :: LINE
  INTEGER, INTENT(INOUT) :: IP

  INTEGER I

  GETNUM=0
  I=SCAN(LINE(IP+1:),'-, ')
  IF(I>0)THEN
     READ(LINE(IP:IP+I-1),*)GETNUM
     IP=IP+I
  ELSE
     READ(LINE(IP:),*)GETNUM
     IP=81
  ENDIF

END FUNCTION GETNUM

!--------- ----
SUBROUTINE HELP

  WRITE(6,"(/A//A/A/A/A/A/A/A)") &
       ' Available commands : ', &
       '   l  :  list labels', &
       '   lb :  list branch numbers', &
       '   d  :  delete labels', &
       '   db :  delete branches', &
       '   r  :  relabel', &
       '   rb :  relabel branches', &
       '   w  :  rewrite files', &
       '   q  :  quit ', &
       '   h  :  help '
  WRITE(6,"(//A/A//A/A/A/A)") &
       ' The l, d, r, lb, db, and rb commands can be followed on the ', &
       ' same line by a list of labels, for example, ', &
       ' l 13           (list label 13)', &
       ' d 7 13         (delete labels 7 and 13)', &
       ' r 1 13 6-9     (relabel 1, 13, and 6 to 9)', &
       ' rb 1, 3-5, 7-9 (relabel branches 1, 3 to 5, and 7 to 9)'
  WRITE(6,"(//A//A/A/A/A/)") &
       ' If a list is not specified then the actions are', &
       ' l              (list all labels)', &
       ' d              (delete/confirm all labels)', &
       ' r              (automatic relabeling)', &
       ' rb             (automatic relabeling of branches)'

END SUBROUTINE HELP

!--------- ------
SUBROUTINE DELETE(S,NLB,LLB,LNL,NL,LFR,LTO)

  USE UTILITY
  CHARACTER(*) S
  INTEGER NLB,LLB(NLB),LNL(NLB),LFR(NLB),LTO(NLB),NL
  CHARACTER(1) CH1
  INTEGER I

  IF(NL.EQ.0)THEN
     DO I=1,NLB
        IF(LNL(I).GT.0)THEN
           WRITE(6,"(A,A,I5,A)",ADVANCE="no") &
                ' Delete (old) ',TRIM(S),LLB(I),' ? : '
           READ(5,'(A1)')CH1
           IF(CH1.EQ.'y'.OR.CH1.EQ.'Y')THEN
              LNL(I)=0
           ENDIF
        ENDIF
     ENDDO
  ELSE
     DO I=1,NLB
        IF(INLIST(NLB,LLB(I),NL,LFR,LTO))THEN
           LNL(I)=0
        ENDIF
     ENDDO
  ENDIF

END SUBROUTINE DELETE

!------ -------- ------
LOGICAL FUNCTION CHCKLB(NLB,LNL)

  INTEGER, INTENT(IN) :: NLB, LNL(NLB)
  INTEGER I, J

  CHCKLB=.TRUE.
  DO I=1,NLB
     IF(LNL(I).GT.0)THEN
        DO J=1,NLB
           IF(J.NE.I .AND. LNL(J).GT.0)THEN
              IF(LNL(J).EQ.LNL(I))THEN
                 WRITE(6,101)
                 CHCKLB=.FALSE.
                 RETURN
              ENDIF
           ENDIF
        ENDDO
     ENDIF
  ENDDO

101 FORMAT(' Duplicate labels: File not written')

  RETURN
END FUNCTION CHCKLB

! ---------- ------
  SUBROUTINE LISTBR(NBR,BBR,BNB,NLB,LBI,LNL,NB,BFR,BTO)
!
    USE UTILITY
    INTEGER NBR,BBR(NBR),BNB(NBR),NLB,LBI(NLB),LNL(NLB)
    INTEGER NB,BFR(NBR),BTO(NBR)
    LOGICAL FIRST
    INTEGER I, J
!
    IF(NBR.EQ.0)THEN
       WRITE(6,"(/,' Empty bifurcation diagram file')")
       RETURN
    ENDIF

    FIRST=.TRUE.
    J=1
    DO I=1,NBR
       IF(NB==0 .OR. INLIST(NLB,I,NB,BFR,BTO))THEN
          IF(FIRST)THEN
             WRITE(6,"(/,'  BR NEW  Labels in branch')")
             FIRST=.FALSE.
          ENDIF
          WRITE(6,"(I4)",ADVANCE="no")BBR(I)
          IF(I==BNB(I).OR.BNB(I)/=0)THEN
             WRITE(6,"(I4)",ADVANCE="no")BNB(I)
             IF(J<=NLB)THEN
                IF(LBI(J)==I)THEN
                   WRITE(6,"(I5)",ADVANCE="no")LNL(J)
                   J=J+1
                   DO WHILE(LBI(J)==I)
                      WRITE(6,"(A,I5)",ADVANCE="no")", ",LNL(J)
                      J=J+1
                   ENDDO
                ENDIF
             ENDIF
             WRITE(6,"()")
          ELSE
             WRITE(6,"('        DELETED')")
          ENDIF
       ENDIF
    ENDDO

  END SUBROUTINE LISTBR
!======================================================================

END PROGRAM AUTLAB
!======================================================================

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!    Floquet Multiplier Computation (Tom Fairgrieve, U. of Toronto)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  References:
!  T. F. Fairgrieve, PhD Thesis, University of Toronto, 1994.
!
!  T. F. Fairgrieve, A. D. Jepson, O.K. Floquet multipliers,
!  SIAM J. Numer. Anal. 28. No. 5, 1991, 1446-1462.
!
!  Please inform Tom Fairgrieve (tff@na.utoronto.ca) of any 
!  modifications to or errors in these routines.
!  Mailing Address: T.F. Fairgrieve, Department of Computer Science,
!  University of Toronto, Toronto, Ontario, CANADA  M5S 1A4C
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  Routines included in this file:
!
!  subroutine flowkm : new routine to compute floquet multipliers
!  subroutine dhhpr  : compute a Householder matrix
!  subroutine dhhap  : appy a Householder matrix
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  Required library routines (included in the file eispack.f) :
!
!  subroutine qzhes  : QZ reduction to Hessenberg form             (EISPACK)
!  subroutine qzit   : QZ reduction to quasi-upper triangular form (EISPACK)
!  subroutine qzval  : QZ calculation of eigenvalues               (EISPACK)
!  function   epslon : machine constant routine                    (EISPACK)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  function   dnrm2  : compute l2-norm of a vector                 (BLAS-1)
!  function   ddot   : dot product of two vectors                  (BLAS-1)
!  subroutine dscal  : scale a vector by a constant                (BLAS-1)
!  function   idamax : find index of element with max abs value    (BLAS-1)
!  subroutine daxpy  : constant times a vector plus a vector       (BLAS-1)
!  subroutine drot   : apply a plane rotation                      (BLAS-1)
!  subroutine dswap  : swap two vectors                            (BLAS-1)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  subroutine xerbla : BLAS error handling routine                 (BLAS-2)
!  function   lsame  : compare character strings                   (BLAS-2)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  subroutine dgemm  : matrix-matrix multiply                      (BLAS-3)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  subroutines ezsvd, ndrotg, ndsvd, prse, sig22, sigmin, sndrtg :
!                      Demmel-Kahan svd routines 
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE FLOQUET

  IMPLICIT NONE

  PRIVATE

  PUBLIC :: FLOWKM

CONTAINS

  SUBROUTINE FLOWKM (NDIM, P0, P1, IID, EV)

    !  Subroutine to compute Floquet multipliers via the "deflated circuit 
    !  pencil" method. This routine is called by the AUTO routine FNSPBV

    !  Parameter declarations:

    INTEGER, INTENT(IN) :: NDIM, IID
    DOUBLE PRECISION, INTENT(IN) :: P0(NDIM, NDIM), P1(NDIM, NDIM)
    COMPLEX(KIND(1.0D0)), INTENT(OUT) :: EV(NDIM)

    !  Local declarations:


    !  Maximum order of problem.  **** (To avoid changing too many AUTO'86
    !  routines, I need to declare some local array storage here )

    INTEGER           LEFT, RIGHT
    PARAMETER         (LEFT = 1, RIGHT = 2)

    INTEGER           I, J, NDIMM1
    DOUBLE PRECISION  X(:),BETA,V(:),C0(:,:),C1(:,:),RWORK(:,:), &
                      NRMC0X, NRMC1X, CONST
    LOGICAL           INFEV

    !  storage for SVD computations

    INTEGER           SVDINF, SVDLWRK
    DOUBLE PRECISION  SVDS(:), SVDE(:), SVDWRK(:), SVDV(:,:)
    ALLOCATABLE       C0,C1,RWORK,X,V,SVDS,SVDE,SVDWRK,SVDV
    !  compute right singular vectors only
    CHARACTER(1), PARAMETER :: SVDJOBA = 'G', SVDJOBU = 'N', SVDJOBV = 'V'

    !  storage for generalized eigenvalue computations

    INTEGER           QZIERR
    DOUBLE PRECISION  QZZ(1, 1), QZEPS1, QZALFR(:), QZALFI(:), QZBETA(:)
    ALLOCATABLE       QZALFR,QZALFI,QZBETA
    LOGICAL           QZMATZ
    !  don't want to accumulate the transforms --- vectors not needed
    PARAMETER         (QZMATZ = .FALSE.)
    PARAMETER         (QZEPS1 = 0.0D0)

    !  BLAS routines

    DOUBLE PRECISION  DNRM2
    EXTERNAL          DNRM2, DGEMM

    !  routines from LAPACK

    EXTERNAL          DGESVJ, DGGEV

    !  builtin F77 functions

    INTRINSIC         MAX, ABS, CMPLX

    SVDLWRK = MAX(6,2*NDIM)
    ALLOCATE(C0(NDIM,NDIM),C1(NDIM,NDIM),RWORK(NDIM,NDIM))
    ALLOCATE(SVDE(NDIM),SVDS(NDIM+1),SVDV(NDIM,NDIM),V(NDIM),X(NDIM))
    ALLOCATE(QZALFI(NDIM),QZBETA(NDIM),QZALFR(NDIM),SVDWRK(SVDLWRK))

    ! Change sign of P1 so that we get the sign of the multipliers right.

    C0=P0
    C1=-P1

    !  Print the undeflated circuit pencil (C0, C1).

    IF(IID>4) THEN
       WRITE(9,101)
       WRITE(9,102)
       DO I=1,NDIM
          WRITE(9,104)(C0(I,J),J=1,NDIM)
       ENDDO
       WRITE(9,103)
       DO I=1,NDIM
          WRITE(9,104)(C1(I,J),J=1,NDIM)
       ENDDO
    END IF

    !  PART I:
    !  =======

    !  Deflate the Floquet multiplier at +1.0 so that the deflated 
    !  circuit pencil is not defective at periodic branch turning points.

    !  The matrix (C0 - C1) should be (nearly) singular.  Find an approximation 
    !  to the right null vector (call it X).  This will be our approximation 
    !  to the eigenvector corresponding to the fixed multiplier at +1.0.  
    !  
    !  There are many ways to get this approximation.  We could use
    !    1) p'(0) = f(p(0))
    !    2) AUTO'86 routine NLVC applied to C0-C1
    !    3) the right singular vector corresponding to the smallest 
    !       singular value of C0-C1

    !  I've chosen option 3) because it should introduce as little roundoff
    !  error as possible.  Although it is more expensive, this is insignificant
    !  relative to the rest of the AUTO computations. Also, the SVD does give a
    !  version of the Householder matrix which we would have to compute
    !  anyways.  But note that it gives V = ( X perp | X ) and not (X | Xperp),
    !  which the Householder routine would give.  This will permute the deflated
    !  circuit pencil, so that the part to be deflated is in the last column,
    !  not it the first column, as was shown in the paper.

    RWORK = C0 - C1

    CALL DGESVJ( SVDJOBA, SVDJOBU, SVDJOBV, NDIM, NDIM, RWORK, NDIM, &
         SVDS, 0, SVDV, NDIM, SVDWRK, SVDLWRK, SVDINF )
    IF (SVDINF /= 0) WRITE (9, 901) SVDINF

    !  Apply a Householder matrix (call it H1) based on the null vector
    !  to (C0, C1) from the right.  H1 = SVDV = ( Xperp | X ), where X
    !  is the null vector.

    CALL DGEMM ( 'n', 'n', NDIM, NDIM, NDIM, 1.0d0, C0, NDIM, &
         SVDV, NDIM, 0.0d0, RWORK, NDIM )
    C0 = RWORK
    CALL DGEMM ( 'n', 'n', NDIM, NDIM, NDIM, 1.0d0, C1, NDIM, &
         SVDV, NDIM, 0.0d0, RWORK, NDIM )
    C1 = RWORK

    !  Apply a Householder matrix (call it H2) based on 
    !  (C0*X/||C0*X|| + C1*X/||C1*X||) / 2 
    !  to (C0*H1, C1*H1) from the left.

    NRMC0X = DNRM2( NDIM, C0(1,NDIM), 1)
    NRMC1X = DNRM2( NDIM, C1(1,NDIM), 1)
    DO I = 1, NDIM
       X(I) = ((C0(I,NDIM)/NRMC0X)+(C1(I,NDIM)/NRMC1X)) / 2.0D0 
    ENDDO
    CALL DHHPR ( 1, NDIM, NDIM, X, 1, BETA, V )
    CALL DHHAP ( 1, NDIM, NDIM, NDIM, BETA, V, LEFT, C0, NDIM)
    CALL DHHAP ( 1, NDIM, NDIM, NDIM, BETA, V, LEFT, C1, NDIM)

    !  Rescale so that (H2^T)*C0*(H1)(1,NDIM) ~= (H2^T)*C1*(H1)(1,NDIM) ~= 1.0

    CONST = MAX(ABS(C0(1,NDIM)), ABS(C1(1,NDIM)))
    DO J = 1, NDIM
       DO I = 1, NDIM
          C0(I,J) = C0(I,J) / CONST
          C1(I,J) = C1(I,J) / CONST
       ENDDO
    ENDDO

    !  Finished the deflation process! Print the deflated circuit pencil.

    IF(IID>4) THEN
       WRITE(9,105)
       WRITE(9,106)
       DO I=1,NDIM
          WRITE(9,104)(C0(I,J),J=1,NDIM)
       ENDDO
       WRITE(9,107)
       DO I=1,NDIM
          WRITE(9,104)(C1(I,J),J=1,NDIM)
       ENDDO
    END IF

    !  At this point we have

    !     (C0Bar, C1Bar) 
    ! ::= (H2^T)*(C0, C1)*(H1).

    !     (( B0^T     | Beta0  )  ( B1^T     | Beta1  ))  1
    !   = (( ----------------- ), ( ----------------- ))
    !     (( C0BarDef | Delta0 )  ( C1BarDef | Delta1 )) NDIM-1

    !         NDIM-1      1          NDIM-1      1

    !  and approximations to the Floquet multipliers are 
    !  (Beta0/Beta1) union the eigenvalues of the deflated pencil 
    !  (C0BarDef, C1BarDef).

    !  PART II:
    !  ========

    !  Compute the eigenvalues of the deflated circuit pencil 
    !  (C0BarDef, C1BarDef)
    !  by using the QZ routines from EISPACK.

    NDIMM1 = NDIM - 1

    !  compute the eigenvalues for the generalized eigenvalue problem

    CALL DGGEV('N', 'N', NDIMM1, C0(2,1), NDIM, C1(2,1), NDIM, QZALFR, &
         QZALFI, QZBETA, QZZ, 1, QZZ, 1, SVDWRK, -1, QZIERR)
    SVDLWRK = NINT(SVDWRK(1))
    DEALLOCATE(SVDWRK)
    ALLOCATE(SVDWRK(SVDLWRK))
    CALL DGGEV('N', 'N', NDIMM1, C0(2,1), NDIM, C1(2,1), NDIM, QZALFR, &
         QZALFI, QZBETA, QZZ, 1, QZZ, 1, SVDWRK, SVDLWRK, QZIERR)
    IF (QZIERR /= 0) WRITE (9, 902) QZIERR

    !  Pack the eigenvalues into complex form.

    EV(1) = CMPLX( C0(1,NDIM) / C1(1,NDIM), 0.0D0, KIND(1.0D0) )
    INFEV = .FALSE.
    DO J = 1, NDIMM1
       IF (QZBETA(J) /= 0.0D0) THEN
          EV(J+1) = CMPLX( QZALFR(J)/QZBETA(J), QZALFI(J)/QZBETA(J), &
               KIND(1.0D0) )
       ELSE
          EV(J+1) = CMPLX( HUGE(1.0D0), HUGE(1.0D0), KIND(1.0D0) )
          INFEV = .TRUE.
       END IF
    ENDDO
    IF (INFEV) WRITE (9, 903) 

    !  Done!

    DEALLOCATE(C0,C1,RWORK,X,V,SVDS,SVDE,SVDWRK,SVDV,QZALFR,QZALFI,QZBETA)

    !  Format statements

101 FORMAT(' Undeflated circuit pencil (C0, C1) ')
102 FORMAT('   C0 : ')
103 FORMAT('   C1 : ')
104 FORMAT(1X,6E23.16)
105 FORMAT(' Deflated circuit pencil (H2^T)*(C0, C1)*(H1) ')
106 FORMAT('   (H2^T)*C0*(H1) : ')
107 FORMAT('   (H2^T)*C1*(H1) : ')
901 FORMAT(' NOTE : Warning from subroutine FLOWKM : ', &
          /,'        SVD routine returned SVDINF = ', I4, &
          /,'        Floquet multiplier calculations may be wrong')
902 FORMAT(' NOTE : Warning from subroutine FLOWKM : ', &
          /,'        QZ routine returned QZIERR = ', I4, &
          /,'        Floquet multiplier calculations may be wrong ')
903 FORMAT(' NOTE : Warning from subroutine FLOWKM : ', &
          /,'        Infinite Floquet multiplier represented by ', &
          /,'        CMPLX( HUGE(1.0D0), HUGE(1.0D0) )')

  END SUBROUTINE FLOWKM

  ! **************************
  ! *  Householder routines  *
  ! **************************


  !  Subroutines for performing Householder plane rotations.

  !  DHHPR: for computing Householder transformations and
  !  DHHAP: for applying them.

  !  Ref: Golub and van Loan, Matrix Calcualtions, 
  !       First Edition, Pages 38-43

  SUBROUTINE DHHPR ( K, J, N, X, INCX, BETA, V )
    USE SUPPORT, ONLY: AUTOSTOP
    !     .. Scalar Arguments ..
    INTEGER, INTENT(IN) :: J, K, N, INCX
    DOUBLE PRECISION, INTENT(OUT) :: BETA
    !     .. Array Arguments ..
    DOUBLE PRECISION, INTENT(IN) :: X( * )
    DOUBLE PRECISION, INTENT(INOUT) :: V( * )
    !     ..

    !  Purpose
    !  =======

    !  DHHPR  computes a Householder Plane Rotation (G&vL Alg. 3.3-1)
    !  defined by v and beta.
    !  (I - beta v vt) * x is such that x_i = 0 for i=k+1 to j.

    !  Parameters
    !  ==========

    !  K      - INTEGER.
    !           On entry, K specifies that the K+1st entry of X 
    !           be the first to be zeroed.
    !           K must be at least one.
    !           Unchanged on exit.

    !  J      - INTEGER.
    !           On entry, J specifies the last entry of X to be zeroed.
    !           J must be >= K and <= N.
    !           Unchanged on exit.

    !  N      - INTEGER.
    !           On entry, N specifies the (logical) length of X.
    !           Unchanged on exit.

    !  X      - DOUBLE PRECISION array of DIMENSION at least
    !           ( 1 + ( N - 1 )*abs( INCX ) ). 
    !           On entry, X specifies the vector to be (partially) zeroed.
    !           Unchanged on exit.

    !  INCX   - INTEGER.
    !           On entry, INCX specifies the increment for the elements of
    !           X. INCX must be > zero. If X represents part of a matrix, 
    !           then use INCX = 1 if a column vector is being zeroed and 
    !           INCX = NDIM if a row vector is being zeroed.
    !           Unchanged on exit.

    !  BETA   - DOUBLE PRECISION.
    !           BETA specifies the scalar beta. (see pg. 40 of G and v.L.)

    !  V      - DOUBLE PRECISION array of DIMENSION at least n.
    !           Is updated to be the appropriate Householder vector for
    !           the given problem. (Note: space for the implicit zeroes is
    !           assumed to be present. Will save on time for index translation.)

    !  -- Written by Tom Fairgrieve,
    !                Department of Computer Science,
    !                University of Toronto,
    !                Toronto, Ontario CANADA  M5S 1A4 

    !     .. Local Scalars ..
    DOUBLE PRECISION   ALPHA, M
    INTEGER            I, L, JMKP1, IEND, ISTART
    !     .. External Functions from BLAS ..
    INTEGER            IDAMAX
    DOUBLE PRECISION   DNRM2
    EXTERNAL           IDAMAX, DNRM2
    !     .. External Subroutines from BLAS ..
    EXTERNAL           DSCAL
    !     .. Intrinsic Functions ..
    INTRINSIC          ABS, SIGN

    !     .. Executable Statements ..

    !  Test the input parameters.

    IF ((K < 1) .OR. (K > J)) THEN
       WRITE (9,*) 'Domain error for K in DHHPR'
       CALL AUTOSTOP()
    END IF
    IF (J > N) THEN
       WRITE (9,*) 'Domain error for J in DHHPR'
       CALL AUTOSTOP()
    END IF
    IF (INCX < 1) THEN
       WRITE (9,*) 'Domain error for INCX in DHHPR'
       CALL AUTOSTOP()
    END IF

    !  Number of potential non-zero elements in V.

    JMKP1 = J - K + 1

    !  Find M := max{ |x_k|, ... , |x_j| }

    M = ABS( X( IDAMAX( JMKP1, X(K), INCX ) ) )

    !  alpha := 0
    !  For i = k to j
    !      v_i = x_i / m
    !      alpha := alpha + v_i^2    (i.e. alpha = vtv)
    !  End For
    !  alpha :=  sqrt( alpha )

    !  Copy X(K)/M, ... , X(J)/M to V(K), ... , V(J)

    IF (INCX == 1) THEN
       DO I = K, J
          V(I) = X(I)/M
       ENDDO
    ELSE
       IEND = JMKP1*INCX
       ISTART = (K-1)*INCX + 1
       L = K
       DO I = ISTART, IEND, INCX
          V(L) = X(I)/M
          L = L + 1
       ENDDO
    END IF

    !  Compute alpha

    ALPHA = DNRM2(JMKP1, V(K), 1)

    !  beta := 1/(alpha(alpha + |V_k|))

    BETA = 1.0D0 / (ALPHA*(ALPHA+ABS(V(K))))

    !  v_k := v_k + sign(v_k)*alpha

    V(K) = V(K) + SIGN(1.0D0,V(K))*ALPHA

    !  Done !
    !     End of DHHPR.

  END SUBROUTINE DHHPR

  SUBROUTINE DHHAP ( K, J, N, Q, BETA, V, JOB, A, LDA )
    USE SUPPORT, ONLY: AUTOSTOP
    !     .. Scalar Arguments ..
    INTEGER, INTENT(IN) :: J, K, N, Q, JOB, LDA
    DOUBLE PRECISION, INTENT(IN) :: BETA
    !     .. Array Arguments ..
    DOUBLE PRECISION, INTENT(IN) :: V( * )
    DOUBLE PRECISION, INTENT(INOUT) :: A( LDA, * )
    !     ..

    !  Purpose
    !  =======

    !  DHHAP applies a Householder Plane Rotation defined by v and beta
    !  to the matrix A.  If JOB = 1 then A := (I - beta*v*vt)A and if 
    !  JOB = 2 then A := A(I - beta*v*vt). (See Golub and van Loan
    !  Alg. 3.3-2.)

    !  Parameters
    !  ==========

    !  K      - INTEGER.
    !           On entry, K specifies that the V(K) may be the first 
    !           non-zero entry of V. 
    !           K must be at least one.
    !           Unchanged on exit.

    !  J      - INTEGER.
    !           On entry, J specifies the last non-zero entry of V.
    !           J must be >= K and <= N.
    !           Unchanged on exit.

    !  N      - INTEGER.
    !           On entry, N specifies the row dimension of A.
    !           Unchanged on exit.

    !  Q      - INTEGER.
    !           On entry, Q specifies the column dimension of A.
    !           Unchanged on exit.

    !  BETA   - DOUBLE PRECISION.
    !           BETA specifies the scalar beta. (see pg. 40 of G and v.L.)
    !           Unchanged on exit.

    !  V      - DOUBLE PRECISION array of DIMENSION at least n.
    !           Householder vector v.
    !           Unchanged on exit.

    !  JOB    - INTEGER.
    !           On entry, JOB specifies the order of the Householder application.
    !           If JOB = 1 then A := (I - beta*v*vt)A and if JOB = 2 then
    !           A := A(I - beta*v*vt)
    !           Unchanged on exit.

    !  A      - DOUBLE PRECISION array of DIMENSION at least
    !           ( LDA, Q ).
    !           On entry, A specifies the matrix to be transformed.
    !           On exit, A specifies the transformed matrix.

    !  LDA    - INTEGER.
    !           On entry, LDA specifies the declared leading dimension of A.
    !           Unchanged on exit.

    !  -- Written by Tom Fairgrieve,
    !                Department of Computer Science,
    !                University of Toronto,
    !                Toronto, Ontario CANADA  M5S 1A4 

    !     .. Local Scalars ..
    DOUBLE PRECISION  S
    INTEGER           JMKP1, ROW, COL
    !     .. External Functions from BLAS ..
    DOUBLE PRECISION  DDOT
    EXTERNAL          DDOT

    !     .. Executable Statements ..

    !  Test the input parameters.

    IF ((JOB /= 1) .AND. (JOB /= 2)) THEN
       WRITE (9,*) 'Domain error for JOB in DHHAP'
       CALL AUTOSTOP()
    END IF
    IF ((K < 1) .OR. (K > J)) THEN
       WRITE (9,*) 'Domain error for K in DHHAP'
       CALL AUTOSTOP()
    END IF
    IF (JOB == 1) THEN
       IF (J > N) THEN
          WRITE (9,*) 'Domain error for J in DHHAP'
          CALL AUTOSTOP()
       END IF
    ELSE
       IF (J > Q) THEN
          WRITE (9,*) 'Domain error for J in DHHAP'
          CALL AUTOSTOP()
       END IF
    END IF

    !  Minimum {row,col} dimension of update.

    JMKP1 = J - K + 1

    ! If (JOB = 1) then
    !     For p = 1, ... , q
    !         s := beta*(v_k*a_k,p + ... + v_j*a_j,p)
    !         For i = k, ..., j
    !             a_i,p := a_i,p - s*v_i
    !         End For
    !     End For
    ! Else % JOB=2
    !     For p = 1, ... , n
    !         s := beta*(v_k*a_p,k + ... + v_j*a_p,j)
    !         For i = k, ..., j
    !             a_p,i := a_p,i - s*v_i
    !         End For
    !     End For
    ! End If

    IF (JOB == 1) THEN
       DO COL = 1, Q
          S = BETA * DDOT(JMKP1, V(K), 1, A(K, COL), 1)
          DO ROW = K, J
             A(ROW,COL) = A(ROW,COL) - S*V(ROW)
          ENDDO
       ENDDO
    ELSE
       DO ROW = 1, N
          S = BETA * DDOT(JMKP1, V(K), 1, A(ROW, K), LDA)
          DO COL = K, J
             A(ROW,COL) = A(ROW,COL) - S*V(COL)
          ENDDO
       ENDDO
    END IF

    ! Done !
    ! End of DHHAP.

  END SUBROUTINE DHHAP
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
END MODULE FLOQUET

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   lor :     The Lorenz Equations
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

       F(1)= PAR(3) * (U(2)- U(1))
       F(2)= PAR(1)*U(1) - U(2) - U(1)*U(3)
       F(3)= U(1)*U(2) -  PAR(2)*U(3)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

! Parameter values for the starting orbit in lor.dat :
         PAR(1)=280.
         PAR(2)= 8.d0/3.d0 
         PAR(3)=10. 

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   cusp.f90 - cusp normal form
!----------------------------------------------------------------------
!----------------------------------------------------------------------

SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!--------- ----

! Evaluates the algebraic equations or ODE right hand side

! Input arguments :
!      NDIM   :   Dimension of the algebraic or ODE system 
!      U      :   State variables
!      ICP    :   Array indicating the free parameter(s)
!      PAR    :   Equation parameters

! Values to be returned :
!      F      :   Equation or ODE right hand side values

! Normally unused Jacobian arguments : IJAC, DFDU, DFDP (see manual)

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
  DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
  DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

  DOUBLE PRECISION x, mu, lambda

  x = U(1)
  lambda = PAR(1)
  mu = PAR(2)
  F(1)= mu + lambda*x - x**3

END SUBROUTINE FUNC

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

SUBROUTINE STPNT(NDIM,U,PAR,T)
!--------- -----

! Input arguments :
!      NDIM   :   Dimension of the algebraic or ODE system 

! Values to be returned :
!      U      :   A starting solution vector
!      PAR    :   The corresponding equation-parameter values

! Note : For time- or space-dependent solutions this subroutine has
!        the scalar input parameter T contains the varying time or space
!        variable value.
  
  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM
  DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
  DOUBLE PRECISION, INTENT(IN) :: T

! Initialize the equation parameters
  PAR(1:2) = (/ 1.0d0, 0.0d0 /)

! Initialize the solution
  U(1) = 0.0d0
   
END SUBROUTINE STPNT

!----------------------------------------------------------------------
!----------------------------------------------------------------------

SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!--------- ----

! Boundary Conditions

! Input arguments :
!      NDIM   :   Dimension of the ODE system 
!      PAR    :   Equation parameters
!      ICP    :   Array indicating the free parameter(s)
!      NBC    :   Number of boundary conditions
!      U0     :   State variable values at the left boundary
!      U1     :   State variable values at the right boundary

! Values to be returned :
!      FB     :   The values of the boundary condition functions 

! Normally unused Jacobian arguments : IJAC, DBC (see manual)

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
  DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
  DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
  DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

!X FB(1)=
!X FB(2)=

END SUBROUTINE BCND

!----------------------------------------------------------------------
!----------------------------------------------------------------------

SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!--------- ----

! Integral Conditions

! Input arguments :
!      NDIM   :   Dimension of the ODE system 
!      PAR    :   Equation parameters
!      ICP    :   Array indicating the free parameter(s)
!      NINT   :   Number of integral conditions
!      U      :   Value of the vector function U at `time' t

! The following input arguments, which are normally not needed,
! correspond to the preceding point on the solution branch
!      UOLD   :   The state vector at 'time' t
!      UDOT   :   Derivative of UOLD with respect to arclength
!      UPOLD  :   Derivative of UOLD with respect to `time'

! Normally unused Jacobian arguments : IJAC, DINT

! Values to be returned :
!      FI     :   The value of the vector integrand 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
  DOUBLE PRECISION, INTENT(IN) :: PAR(*)
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
  DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
  DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

!X FI(1)=

END SUBROUTINE ICND

!----------------------------------------------------------------------
!----------------------------------------------------------------------

SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP)
!--------- ----
!
! Defines the objective function for algebraic optimization problems
!
! Supplied variables :
!      NDIM   :   Dimension of the state equation
!      U      :   The state vector
!      ICP    :   Indices of the control parameters
!      PAR    :   The vector of control parameters
!
! Values to be returned :
!      FS      :   The value of the objective function
!
! Normally unused Jacobian argument : IJAC, DFDP

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
  DOUBLE PRECISION, INTENT(OUT) :: FS
  DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM),DFDP(*)

!X FS=

END SUBROUTINE FOPT

!----------------------------------------------------------------------
!----------------------------------------------------------------------

SUBROUTINE PVLS(NDIM,U,PAR)
!--------- ----

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
  DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

!---------------------------------------------------------------------- 
! NOTE : 
! Parameters set in this subroutine should be considered as ``solution 
! measures'' and be used for output purposes only.
! 
! They should never be used as `true'' continuation parameters. 
!
! They may, however, be added as ``over-specified parameters'' in the 
! parameter list associated with the AUTO-Constant NICP, in order to 
! print their values on the screen and in the ``p.xxx file.
!
! They may also appear in the list associated with AUTO-Constant NUZR.
!
!---------------------------------------------------------------------- 
! For algebraic problems the argument U is, as usual, the state vector.
! For differential equations the argument U represents the approximate 
! solution on the entire interval [0,1]. In this case its values must 
! be accessed indirectly by calls to GETP, as illustrated below.
!---------------------------------------------------------------------- 
!
! Set PAR(2) equal to the L2-norm of U(1)
!X PAR(2)=GETP('NRM',1,U)
!
! Set PAR(3) equal to the minimum of U(2)
!X PAR(3)=GETP('MIN',2,U)
!
! Set PAR(4) equal to the value of U(2) at the left boundary.
!X PAR(4)=GETP('BV0',2,U)
!
! Set PAR(5) equal to the pseudo-arclength step size used.
!X PAR(5)=GETP('STP',1,U)
!
!---------------------------------------------------------------------- 
! The first argument of GETP may be one of the following:
!        'NRM' (L2-norm),     'MAX' (maximum),
!        'INT' (integral),    'BV0 (left boundary value),
!        'MIN' (minimum),     'BV1' (right boundary value).
!
! Also available are
!   'STP' (Pseudo-arclength step size used).
!   'FLD' (`Fold function', which vanishes at folds).
!   'BIF' (`Bifurcation function', which vanishes at singular points).
!   'HBF' (`Hopf function'; which vanishes at Hopf points).
!   'SPB' ( Function which vanishes at secondary periodic bifurcations).
!---------------------------------------------------------------------- 


END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!     Redoing the local bifurcation of the model analysed by
!     Martin Boer, ch. 4 of thesis.
!     Cycle-to-cycle connection 3D food chain
!
!     Homoclinic, but set up also for heteroclinic
!
!     U(1-3) = limit cycle
!     U(4-6) = eigenfunction (ef) stable
!     U(7-9) = limit cycle again ("second cycle")
!     U(10-12) = ef unstable
!     U(13-15) = connecting orbit
!
!     George van Voorn, June 20th 2007
!     Bart Oldeman, December 2008
!---------------------------------------------------------------------- 

  SUBROUTINE RHS(N,U,PAR,F,DFDU,IJAC)
! ---------- --- 

    IMPLICIT NONE
    INTEGER N
    DOUBLE PRECISION U(N),PAR(*),F(N),DFDU(N,N)
    LOGICAL IJAC
    DOUBLE PRECISION f1,f2
    DOUBLE PRECISION d1,d2,x,y,z,a1,a2,b1,b2
!     Declaring variables
    x=U(1)
    y=U(2)
    z=U(3)
!     Parameter values
    d1=PAR(1)
    d2=PAR(2)

    a1 = 5.d0
    a2 = 0.1d0
    b1 = 3.d0
    b2 = 2.d0

    f1=a1/(1d0 + b1*x)
    f2=a2/(1d0 + b2*y)
!     Formulas
    F(1)= x*(1d0 - x) - f1*x*y
    F(2)= f1*x*y - d1*y - f2*y*z
    F(3)= f2*y*z - d2*z

    IF(.NOT.IJAC)RETURN

!     Jacobian elements
    DFDU(1,1)=1d0-2*x-f1*y+b1*x*y*(f1**2)/a1
    DFDU(1,2)=-f1*x
    DFDU(1,3)=0.0d0
    DFDU(2,1)=f1*y-b1*x*y*(f1**2)/a1
    DFDU(2,2)=f1*x-d1-f2*z+b2*y*z*(f2**2)/a2
    DFDU(2,3)=-f2*y
    DFDU(3,1)=0.0d0
    DFDU(3,2)=f2*z-b2*y*z*(f2**2)/a2
    DFDU(3,3)=f2*y-d2

  END SUBROUTINE RHS

  SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
! ---------- --- 

    IMPLICIT NONE
    INTEGER NDIM,ICP(*),IJAC
    DOUBLE PRECISION U(NDIM),PAR(*),F(NDIM),DFDU(NDIM,*),DFDP(NDIM,*)
    DOUBLE PRECISION A(3,3)

    CALL RHS(3,U,PAR,F,A,NDIM/=3)
    IF(NDIM==3)RETURN

    F(1:3) = PAR(11)*F(1:3)

    IF(NDIM==6)THEN
!     Variational equations
!     PAR(11) = cycle period
!     PAR(12) = log(FM) 
       F(4:6) = PAR(11)*MATMUL(A(:,:),U(4:6))-PAR(12)*U(4:6)
       RETURN
    ENDIF

!     Adjoint variational equations
!     PAR(11) = cycle period
!     PAR(4) = log(FM) 
    F(4:6) = -PAR(11)*MATMUL(TRANSPOSE(A(:,:)),U(4:6))-PAR(4)*U(4:6)

!     Functions limit cycle doubled U(7-9)
!     We pretend this is a second different cycle
    CALL RHS(3,U(7:9),PAR,F(7:9),A,.TRUE.)
    F(7:9) = PAR(6)*F(7:9)
!     Period=PAR(6), obviously equal to PAR(11), U(10-12)
!     PAR(5) = log(FM) 
    F(10:12) = -PAR(6)*MATMUL(TRANSPOSE(A(:,:)),U(10:12))-PAR(5)*U(10:12)

    IF(NDIM==12)RETURN

!     Connection rescaled, PAR(7) = Tc
    CALL RHS(3,U(13:15),PAR,F(13:15),A,.FALSE.)
    F(13:15) = PAR(7)*F(13:15)

  END SUBROUTINE FUNC

  SUBROUTINE STPNT(NDIM,U,PAR) 
! ---------- --- 

    IMPLICIT NONE
    INTEGER NDIM
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM), PAR(*)

    DOUBLE PRECISION FLOQ,epsilon

    IF(NDIM==12)THEN
       ! extending from NDIM=6 to NDIM=12
       U(7:12)=U(1:6)
       RETURN
    ELSEIF(NDIM==15)THEN
       ! extending from NDIM=12 to NDIM=15
       epsilon=PAR(13)
       U(13:15)=PAR(14:16) + epsilon*PAR(17:19)
       RETURN
    ENDIF

!     0.16<par1=d1<0.32,0.0075<par2=d2<0.015

    PAR(1)=0.5d0
    PAR(2)=0.0125d0
    U(1)=0.7415816238d0
    U(2)=0.1666666667d0
    U(3)=8.664398854d0

!     Guess for FM
    FLOQ=-10d0
    PAR(4)=FLOQ
    PAR(5)=FLOQ
    PAR(12)=FLOQ
    PAR(13)=0.01d0 ! epsilon

!     Eigenvector norms
    PAR(10)=0.

    PAR(25)=0.
    PAR(26)=0.

  END SUBROUTINE STPNT

  SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
! ---------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
    DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

    DOUBLE PRECISION g1(3),h1(3),h2(3),A(3,3)
    DOUBLE PRECISION epsilon

!     Periodicity boundary conditions 
!     -------------------------------

    FB(1:3) = U0(1:3) - U1(1:3)
    FB(4:6) = U1(4:6) - U0(4:6)

    IF(NBC==7)THEN
       FB(7) = DOT_PRODUCT(U0(4:6),U0(4:6)) - PAR(10)
       RETURN
    ENDIF

    FB(7) = DOT_PRODUCT(U0(4:6),U0(4:6)) - PAR(25)

    ! Double

    FB(8:10) = U0(7:9) - U1(7:9)
    FB(11:13) = U1(10:12) - U0(10:12)

    FB(14) = DOT_PRODUCT(U0(10:12),U0(10:12)) - PAR(26)

    IF(NBC==14)RETURN

    ! Cycle 1 end-point connection
    CALL RHS(3,U0(1:3),PAR,g1,A,.FALSE.)
    ! Displacement from the cycle; end connection
    h1(1:3)=U1(13:15)-U0(1:3)
     
    ! Eq.(12g)/(17h) - h11
    FB(15) = DOT_PRODUCT(h1(1:3),g1(1:3)) - PAR(21)

    ! cycle 2 starting point connection
    ! For coherence we use U(7-9)
    CALL RHS(3,U0(7:9),PAR,g1,A,.FALSE.)
    ! Displacement from the cycle; start connection
    h2(1:3)=U0(13:15)-U0(7:9)

    ! Eq.(12h)/(17i) - h12
    FB(16) = DOT_PRODUCT(h2(1:3),g1(1:3)) - PAR(22)
    ! Eq.(12i)/(17j) - h21
    FB(17) = DOT_PRODUCT(U0(4:6),h1(1:3)) - PAR(23)
    ! Eq.(12j)/(17k) - h22
    FB(18) = DOT_PRODUCT(U0(10:12),h2(1:3)) - PAR(24)
    ! Eq.(12k)
    FB(19) = DOT_PRODUCT(h2(1:3),h2(1:3)) - PAR(8)
  END SUBROUTINE BCND

  SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT) 
! ---------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
    DOUBLE PRECISION, INTENT(IN) :: PAR(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM),UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

!   Integral phase condition 
!   ------------------------
    FI(1) = U(1)*UPOLD(1)+U(2)*UPOLD(2)+U(3)*UPOLD(3)
    IF(NINT==1)RETURN
    FI(2) = U(7)*UPOLD(7)+U(8)*UPOLD(8)+U(9)*UPOLD(9)

  END SUBROUTINE ICND

  SUBROUTINE FOPT 
  END SUBROUTINE FOPT

  SUBROUTINE PVLS(NDIM,U,PAR)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    DOUBLE PRECISION GETP

    DOUBLE PRECISION u0(12),g1(3),g2(3),h1(3),h2(3),A(3,3),b(3),epsilon
    INTEGER I

    IF(NDIM==6)THEN
       DO I=1,6
          PAR(13+I)=GETP('BV0',I,U)
       ENDDO
       PAR(6)=PAR(11)
    ELSEIF(NDIM==12)THEN
      DO I=1,12
         u0(I) = GETP('BV0',I,U)
      ENDDO

      ! f' at base point cycle 1
      CALL RHS(3,u0(1:3),PAR,g1,A,.FALSE.)
      ! f' at base point cycle 2
      CALL RHS(3,u0(7:9),PAR,g2,A,.FALSE.)
      ! start & end of initial point
      epsilon=PAR(13)
      b(1:3) = PAR(14:16)+epsilon*PAR(17:19)

      ! Displacement from the cycle at end connection
      h1(1:3)=b(1:3)-u0(1:3)
      ! Displacement from the cycle at start connection
      h2(1:3)=b(1:3)-u0(7:9)

!     Homotopy parameter values at start continuation
      ! Eq.(12h)/(17i)
      PAR(21) = DOT_PRODUCT(h1(1:3),g1(1:3))
      ! Eq.(12i)/(17j)
      PAR(22) = DOT_PRODUCT(h2(1:3),g2(1:3))
      ! Eq.(12j)/(17k)
      PAR(23) = DOT_PRODUCT(u0(4:6),h1(1:3))
      ! Eq.(12k)/(17l)
      PAR(24) = DOT_PRODUCT(u0(10:12),h2(1:3))

      ! for BC(19)/Eq.(12k)
      PAR(8) = DOT_PRODUCT(h2(1:3),h2(1:3))
   ELSEIF(NDIM==15)THEN
      PAR(27)=GETP('MIN',3,U)
      PAR(28)=GETP('MIN',15,U)
   ENDIF


  END SUBROUTINE PVLS

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!   frc :      A periodically forced system
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION a,b,c,amp,beta,x,y,sn,cs,ss

! FHN parameters
       a = PAR(1) 
       b = PAR(2) 
       c = PAR(3) 

! Forcing parameters
       amp = PAR(4) 
       beta= PAR(5) 

! FHN variables
       x=U(1)
       y=U(2)

! Forcing variables
       sn=U(3)
       cs=U(4)
       ss = sn**2 + cs**2    

! FHN equations
       F(1)= c * ( x - x**3/3 + y - amp*cs )
       F(2)=-( x - a + b*y ) / c

! Oscillator
       F(3) =  sn + beta*cs - sn*ss    
       F(4) = -beta*sn + cs - cs*ss    

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,t)  
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: t

      DOUBLE PRECISION a,b,c,amp,beta,TPI

! FHN parameters
       a = 0.
       b = 0.8
       c = 3.

       PAR(1)=a
       PAR(2)=b
       PAR(3)=c

! Forcing parameters
       amp=0.
       beta=10

       PAR(4)=amp
       PAR(5)=beta

       TPI=8*ATAN(1.d0)
       PAR(11)=TPI/beta

!      Initial FHB stationary solution (assuming a=0)
       U(1)= 0.
       U(2)= 0.

! Initialize the oscillator
       U(3)=SIN(TPI*t)      
       U(4)=COS(TPI*t)      

      END SUBROUTINE STPNT

      SUBROUTINE BCND
      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   ivp :    Time integration (using Implicit Euler)
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION E

       E=EXP(-PAR(3)*U(1)) 
       F(1)=PAR(2)*U(1)*(1-U(1)) - U(1)*U(2) - PAR(1)*(1-E) 
       F(2)=-U(2) + PAR(4)*U(1)*U(2) 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

!      **Set (constant) parameters
       PAR(1)=0. 
       PAR(2)=3.0 
       PAR(3)=5.0 
       PAR(4)=3.0 

!      **Set initial values 
       U(1)=0.3
       U(2)=0.3 

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!------ --------------
! these are the AUTO constants, *exactly* as given in the fort.2 or c. file
! don't use this module from any parallellized function (FUNI and ICNI).
MODULE AUTO_CONSTANTS

  IMPLICIT NONE
  INTEGER NPARX
  INCLUDE 'auto.h'

  INTEGER NDIM,IPS,IRS,ILP
  CHARACTER(13), ALLOCATABLE :: ICU(:)
  INTEGER NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
  INTEGER NMX
  DOUBLE PRECISION RL0,RL1,A0,A1
  INTEGER NPR,MXBF,IIS,IID,ITMX,ITNW,NWTN,JAC
  DOUBLE PRECISION EPSL,EPSU,EPSS
  DOUBLE PRECISION DS,DSMIN,DSMAX
  INTEGER IADS,NPAR,IBR,LAB
  TYPE INDEXVAR
     CHARACTER(13) INDEX
     DOUBLE PRECISION VAR
  END TYPE INDEXVAR
  TYPE(INDEXVAR),ALLOCATABLE :: IVTHL(:),IVTHU(:),UVALS(:),PARVALS(:)
  TYPE INDEXMVAR
     CHARACTER(13) INDEX
     DOUBLE PRECISION, POINTER :: VAR(:)
  END TYPE INDEXMVAR
  TYPE(INDEXMVAR),ALLOCATABLE :: IVUZR(:)
  TYPE(INDEXMVAR),ALLOCATABLE :: IVUZSTOP(:)

  TYPE INDEXSTR
     INTEGER INDEX
     CHARACTER(13) STR
  END TYPE INDEXSTR
  TYPE(INDEXSTR), ALLOCATABLE :: unames(:), parnames(:)
  CHARACTER(13), ALLOCATABLE :: SP(:), STOPS(:)
  CHARACTER(13) :: SIRS, TY
  CHARACTER(256) :: EFILE, SFILE, SVFILE, DATFILE

! HomCont comstants:
  TYPE HCONST_TYPE
     INTEGER NUNSTAB,NSTAB,IEQUIB,ITWIST,ISTART
     INTEGER, POINTER :: IREV(:),IFIXED(:),IPSI(:)
  END TYPE
  TYPE(HCONST_TYPE)HCONST

  LOGICAL, SAVE :: NEWCFILE=.FALSE.

  ! these are the AUTO parameters, as used to be in the IAP and RAP arrays.
  ! NOTE: for MPI:
  ! * SEQUENCE is necessary, first comes double precision, then integer
  ! * DS should be the first double precision variable
  ! * NDIM should be the first integer variable  
  ! * NIAP and NRAP are used!
  ! * For alignment, always keep an even number of integer variables.
  !   (NIAP should be even;  make the structure length a multiple of its
  !    largest element)
  INTEGER, PARAMETER :: NIAP = 36
  INTEGER, PARAMETER :: NRAP = 16
  TYPE AUTOPARAMETERS
     SEQUENCE

     DOUBLE PRECISION DS, DSMIN, DSMAX, RDS, RL0, RL1, A0, A1
     DOUBLE PRECISION EPSL, EPSU, EPSS

     DOUBLE PRECISION DET, FLDF, HBFF, BIFF, SPBF

     INTEGER NDIM, IPS, IRS, ILP, NTST, NCOL, IAD, IADS, ISP, ISW
     INTEGER IPLT, NBC, NINT, NMX, NUZR, NPR, MXBF, IIS, IID, ITMX, ITNW
     INTEGER NWTN, JAC, NPAR, NREV

     INTEGER NDM, NPARI, ITP, ITPST, NFPR, IBR, NTOT
     INTEGER NINS, LAB, NICP, NTEST

  END TYPE AUTOPARAMETERS

END MODULE AUTO_CONSTANTS

!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!        Subroutines for Time Integration of ODEs
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE TIMEINT

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
  USE AE
  USE TOOLBOXAE
  USE INTERFACES

  IMPLICIT NONE
  PRIVATE
  PUBLIC :: AUTOTI

CONTAINS

! ---------- ------
  SUBROUTINE AUTOTI(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    ! ** Time integration (IPS==-2)
    AP%NFPR=1
    AP%ISP=0
    AP%ILP=0
    ICP(1)=14
    CALL AUTOAE(AP,ICP,ICU,FNTI,STPNAE,FNCSAE)
  END SUBROUTINE AUTOTI

! ---------- ----
  SUBROUTINE FNTI(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generate the equations for time integration.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    INTEGER I,J
    DOUBLE PRECISION TOLD,DT

    CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    TOLD=UOLD(NDIM+1)
    DT=PAR(ICP(1))-TOLD

    DO I=1,NDIM
       DFDP(I,ICP(1))=F(I)
       F(I)= DT*F(I) - U(I) + UOLD(I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    DO I=1,NDIM
       DO J=1,NDIM
          DFDU(I,J)= DT*DFDU(I,J)
       ENDDO
       DFDU(I,I)= DFDU(I,I) - 1.d0
    ENDDO
  END SUBROUTINE FNTI

END MODULE TIMEINT

! This file contains all MPI specific functions in AUTO, both the
! master and workers side.
!
! External subroutines called from the main part of AUTO:
!
! mpiini: inits MPI, and the worker receives some constants
! mpiiap: the master sends constants so that the workers can determine
!         the funi and icni functions to use
! mpiwfi: main workers' loop, called by AUTOBV with funi and icni known
!         contains the client side of CONPAR and SETUBV   
! mpisbv: sends solvbv input from master to workers
! mpireduce: MPI communication for REDUCE
! mpibcksub: MPI communication for BCKSUB
! mpibcast: front-end to MPI_Bcast
! mpigat: front-end to MPI_Gatherv
! mpiend: master tells workers to stop

module autompi

use auto_constants, only: autoparameters, niap, nrap
use mpi
!$ use omp_lib

implicit none
private

public :: mpiini, mpiiap, mpiwfi, mpireduce, mpibcksub, mpisbv, mpicbv
public :: mpibcast, mpibcast1, mpibcasti, mpibcast1i, mpibcast1l, mpibcastap
public :: mpireducemax, mpireducemin
public :: mpigat, mpiscat, mpiend, mpitim, mpiiam, mpikwt, partition
public :: mpigats

integer, parameter :: AUTO_MPI_KILL_MESSAGE = 0, AUTO_MPI_SOLVBV_MESSAGE = 1
integer, parameter :: AUTO_MPI_INIT_MESSAGE = 2

contains

subroutine mpiini()

  integer ierr,iam,namelen,provided
  character(len=MPI_MAX_PROCESSOR_NAME) processor_name
  integer :: message_type

  provided = MPI_THREAD_SINGLE
!$ if (omp_get_max_threads() > 1) then
!$   call MPI_Init_thread(MPI_THREAD_FUNNELED,provided,ierr)
!$ endif
  if (provided == MPI_THREAD_SINGLE) then
     ! if MPI lib doesn't officially support threads try anyway
     ! since we only call MPI when no other threads are active
     call MPI_Init(ierr)
  endif
  call MPI_Comm_rank(MPI_COMM_WORLD,iam,ierr)
  call MPI_Get_processor_name(processor_name,namelen,ierr)
!  print *,'Process ',iam,' on ',processor_name
  if(iam/=0)then
    call MPI_Bcast(message_type,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
    if(message_type /= AUTO_MPI_INIT_MESSAGE)then
       print *,'Fatal: no init message, message received: ', message_type
       call MPI_Finalize(ierr)
       stop
    endif
 endif

end subroutine mpiini

integer function mpiiam()
  integer ierr
  call MPI_Comm_rank(MPI_COMM_WORLD,mpiiam,ierr)
end function mpiiam

integer function mpikwt()
  integer ierr
  call MPI_Comm_size(MPI_COMM_WORLD,mpikwt,ierr)
end function mpikwt

subroutine mpiiap(ap)
  type(autoparameters) :: ap

  integer ierr

  ! Send message to get worker into init mode
  call MPI_Bcast(AUTO_MPI_INIT_MESSAGE,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  call mpibcastap(ap)

end subroutine mpiiap

logical function mpiwfi()
  integer :: message_type, ierr

  mpiwfi = .false.

  call MPI_Bcast(message_type,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  
  select case(message_type)
  case(AUTO_MPI_KILL_MESSAGE) ! The kill message
     call MPI_Finalize(ierr)
     stop
  case(AUTO_MPI_INIT_MESSAGE)
     ! do nothing
  case(AUTO_MPI_SOLVBV_MESSAGE) ! The solvbv message
     mpiwfi = .true.
  case default
     print *,'Unknown message recieved: ', message_type
  end select
end function mpiwfi

!--------- ---------
subroutine partition(n,kwt,m)
!
! Linear distribution of NTST over all nodes
  integer n,kwt,m(kwt)
  integer i
  do i=1,kwt
     m(i) = (i*n+kwt-1)/kwt - ((i-1)*n+kwt-1)/kwt
  enddo
end subroutine partition

subroutine mpireduce(a1,a2,bb,cc,c2,dd,faa,fcfc,ntst,nov,ncb,nrc,ifst,nllv,&
     lo,hi,level)
  integer, intent(in) :: ntst,nov,ncb,nrc,ifst,nllv,lo,hi,level
  double precision, intent(inout) :: a1(nov,nov,*),a2(nov,nov,*),bb(ncb,nov,*)
  double precision, intent(inout) :: cc(nov,nrc,*),c2(nov,nrc,*)
  double precision, intent(inout) :: dd(ncb,nrc,*),faa(nov,*)
  double precision, intent(inout) :: fcfc(nrc,*)

  integer :: iam,kwt,mid,nlo,nmid1,hi1,mid1,base,na

  iam=mpiiam()
  kwt=mpikwt()
  mid=(lo+hi)/2
  nlo=(lo-1)*kwt/ntst
  nmid1=mid*kwt/ntst
  base=(iam*ntst+kwt-1)/kwt
  na=((iam+1)*ntst+kwt-1)/kwt-base
  mid1=mid-base
  if(mid1>na)then
     mid1=na+level+1
  endif
  hi1=hi-base
  if(hi1>na)then
     hi1=na+level
  endif
  if(nmid1==iam.and.nlo<iam)then
     if(nllv.eq.0)then
        call mpisend(faa(1,hi1),nov,nlo)
        call mpisend(fcfc(1,hi1),nrc,nlo)
     endif
     if(ifst.eq.1)then
        ! send hi to lo
        call mpisend(a1(1,1,mid1+1),nov*nov,nlo)
        call mpisend(a2(1,1,hi1),nov*nov,nlo)
        call mpisend(bb(1,1,hi1),nov*ncb,nlo)
        call mpisend(cc(1,1,mid1+1),nov*nrc,nlo)
        call mpisend(c2(1,1,hi1),nov*nrc,nlo)
        call mpisend(dd(1,1,hi1),ncb*nrc,nlo)
     endif
  elseif(nmid1>iam.and.nlo==iam)then
     if(nllv.eq.0)then
        call mpirecv(faa(1,hi1),nov,nmid1)
        call mpirecv(fcfc(1,hi1),nrc,nmid1)
     else
        faa(:,hi1)=0
        fcfc(:,hi1)=0
     endif
     if(ifst.eq.1)then
        ! receive hi
        call mpirecv(a1(1,1,mid1+1),nov*nov,nmid1)
        call mpirecv(a2(1,1,hi1),nov*nov,nmid1)
        call mpirecv(bb(1,1,hi1),nov*ncb,nmid1)
        call mpirecv(cc(1,1,mid1+1),nov*nrc,nmid1)
        call mpirecv(c2(1,1,hi1),nov*nrc,nmid1)
        call mpirecv(dd(1,1,hi1),ncb*nrc,nmid1)
     endif
  endif
end subroutine mpireduce

subroutine mpibcksub(sol,fc,ntst,nov,ncb,lo,hi,level)
  integer, intent(in) :: ntst,nov,ncb,lo,hi,level
  double precision, intent(inout) :: sol(nov,*),fc(*)
  integer :: iam,kwt,mid,nlo,nmid1,hi1,mid1,base,na

  iam=mpiiam()
  kwt=mpikwt()
  mid=(lo+hi)/2
  nlo=(lo-1)*kwt/ntst
  nmid1=mid*kwt/ntst
  base=(iam*ntst+kwt-1)/kwt
  na=((iam+1)*ntst+kwt-1)/kwt-base
  mid1=mid-base
  if(mid1>na)then
     mid1=na+level+1
  endif
  hi1=hi-base
  if(hi1>na)then
     hi1=na+level
  endif
  if(nmid1==iam.and.nlo<iam)then
     call mpirecv(sol(1,mid1+1),nov,nlo)
     call mpirecv(sol(1,hi1+1),nov,nlo)
     call mpirecv(fc,nov+ncb,nlo)
  elseif(nmid1>iam.and.nlo==iam)then
     call mpisend(sol(1,mid1+1),nov,nmid1)
     call mpisend(sol(1,hi1+1),nov,nmid1)
     call mpisend(fc,nov+ncb,nmid1)
  endif
end subroutine mpibcksub

subroutine mpirecv(a,isize,isrc)
  integer, intent(in) :: isize, isrc
  double precision, intent(out) :: a(isize)

  integer ierr
  integer status(MPI_STATUS_SIZE)
  call MPI_Recv(a,isize,MPI_DOUBLE_PRECISION,isrc, &
       MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr)
end subroutine mpirecv

subroutine mpisend(a,isize,idest)
  integer, intent(in) :: isize, idest
  double precision, intent(in) :: a(isize)

  integer ierr
  call MPI_Send(a,isize,MPI_DOUBLE_PRECISION,idest, &
       0, MPI_COMM_WORLD, ierr)
end subroutine mpisend

subroutine mpisbv(solvbv)

  logical, intent(in) :: solvbv

  integer :: ierr
  integer :: message

  ! Send message to get worker into solvbv/init cnrlbv mode
  if(solvbv)then
     message=AUTO_MPI_SOLVBV_MESSAGE
  else
     message=AUTO_MPI_INIT_MESSAGE
  endif
  call MPI_Bcast(message,1,MPI_INTEGER,0, &
       MPI_COMM_WORLD,ierr)

end subroutine mpisbv

subroutine mpicbv(npar,par,rds)

  integer, intent(in) :: npar
  double precision :: par(npar)
  double precision :: rds

  integer :: iam,bufsize
  double precision, allocatable :: buffer(:)

  iam=mpiiam()
  bufsize = npar+1
  allocate(buffer(bufsize))

  if(iam==0)then
     buffer(1:npar)=par(:)
     buffer(npar+1)=rds
  endif

  call mpibcast(buffer,bufsize)

  if(iam>0)then
     par(1:npar)=buffer(1:npar)
     rds=buffer(npar+1)
  endif

  deallocate(buffer)

  ! Worker runs here

end subroutine mpicbv

subroutine mpibcast(buf,len)
  integer, intent(in) :: len
  double precision, intent(inout) :: buf(len)

  integer :: ierr

  call MPI_Bcast(buf,len,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
end subroutine mpibcast

subroutine mpibcast1(buf)
  double precision, intent(inout) :: buf

  integer :: ierr

  call MPI_Bcast(buf,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
end subroutine mpibcast1

subroutine mpibcasti(buf,len)
  integer, intent(in) :: len
  integer, intent(inout) :: buf(len)

  integer :: ierr

  call MPI_Bcast(buf,len,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
end subroutine mpibcasti

subroutine mpibcast1i(buf)
  integer, intent(inout) :: buf

  integer :: ierr

  call MPI_Bcast(buf,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
end subroutine mpibcast1i

subroutine mpibcast1l(buf)
  logical, intent(inout) :: buf

  integer :: ierr

  call MPI_Bcast(buf,1,MPI_LOGICAL,0,MPI_COMM_WORLD,ierr)
end subroutine mpibcast1l

subroutine mpibcastap(ap)
  type(autoparameters), intent(inout) :: ap

  integer :: ierr

  call MPI_Bcast(ap%ndim,NIAP,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  call MPI_Bcast(ap%ds,NRAP,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

end subroutine mpibcastap

subroutine mpicounts(np,kwt,ndx,add,counts,displacements)
  integer, intent(in) :: np(kwt), kwt, ndx, add
  integer, intent(out) :: counts(kwt), displacements(kwt)
  
  integer i, loop_start

  loop_start = 0
  do i=1,kwt
     counts(i) = ndx*np(i)+add
     displacements(i) = ndx*loop_start
     loop_start = loop_start + np(i)
  enddo

end subroutine mpicounts

subroutine mpiscat(buf,ndx,n,add)
  integer, intent(in) :: ndx,n,add
  double precision, intent(inout) :: buf(*)

  integer, allocatable :: counts(:), displacements(:), np(:)
  integer ierr, iam, kwt, na0

  call MPI_Comm_size(MPI_COMM_WORLD,kwt,ierr)
  allocate(np(kwt))
  call partition(n,kwt,np)

  call MPI_Comm_rank(MPI_COMM_WORLD,iam,ierr)
  if(iam==0)then
     allocate(counts(kwt),displacements(kwt))
     call mpicounts(np,kwt,ndx,add,counts,displacements)
     call MPI_Scatterv(buf,counts,displacements,MPI_DOUBLE_PRECISION, &
          MPI_IN_PLACE,0,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
     deallocate(counts,displacements)
  else
     na0=np(iam+1)*ndx+add
     call MPI_Scatterv(buf,counts,displacements,MPI_DOUBLE_PRECISION, &
          buf,na0,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
  endif

  deallocate(np)
end subroutine mpiscat

subroutine mpigat(buf,ndx,n)
  integer, intent(in) :: ndx,n
  double precision, intent(inout) :: buf(ndx,*)

  integer, allocatable :: counts(:), displacements(:), np(:)
  integer ierr, iam, kwt, na0

  call MPI_Comm_size(MPI_COMM_WORLD,kwt,ierr)
  allocate(np(kwt))
  call partition(n,kwt,np)

  call MPI_Comm_rank(MPI_COMM_WORLD,iam,ierr)
  if(iam==0)then
     allocate(counts(kwt),displacements(kwt))
     call mpicounts(np,kwt,ndx,0,counts,displacements)
     call MPI_Gatherv(MPI_IN_PLACE,0,MPI_DOUBLE_PRECISION, &
          buf,counts,displacements,MPI_DOUBLE_PRECISION, &
          0,MPI_COMM_WORLD,ierr)
     deallocate(counts,displacements)
  else
     na0=np(iam+1)*ndx
     call MPI_Gatherv(buf,na0,MPI_DOUBLE_PRECISION, &
          buf,counts,displacements,MPI_DOUBLE_PRECISION, &
          0,MPI_COMM_WORLD,ierr)
  endif

  deallocate(np)
end subroutine mpigat

subroutine mpigats(buf,ndx,n,linelen)
  ! gather line strings from each worker for output to fort.8/s.*
  integer, intent(in) :: ndx,n,linelen
  character(linelen), intent(inout) :: buf(*)

  integer, allocatable :: counts(:), displacements(:), np(:)
  integer ierr, iam, kwt, na0, line

  call MPI_Comm_size(MPI_COMM_WORLD,kwt,ierr)
  allocate(np(kwt))
  call partition(n,kwt,np)

  call MPI_Comm_rank(MPI_COMM_WORLD,iam,ierr)
  call MPI_Type_contiguous(linelen,MPI_CHARACTER,line,ierr)
  call MPI_Type_commit(line,ierr)
  if(iam==0)then
     allocate(counts(kwt),displacements(kwt))
     call mpicounts(np,kwt,ndx,0,counts,displacements)
     call MPI_Gatherv(MPI_IN_PLACE,0,line,buf,counts,displacements, &
          line,0,MPI_COMM_WORLD,ierr)
     deallocate(counts,displacements)
  else
     na0=np(iam+1)*ndx
     call MPI_Gatherv(buf,na0,line,buf,counts,displacements, &
          line,0,MPI_COMM_WORLD,ierr)
  endif
  call MPI_Type_free(line,ierr)

  deallocate(np)
end subroutine mpigats

subroutine mpireducemax(buf,n)
  integer, intent(in) :: n
  double precision, intent(inout) :: buf(n)

  integer ierr

  if (mpiiam()==0)then
     call MPI_Reduce(MPI_IN_PLACE, buf, n, MPI_DOUBLE_PRECISION, &
          MPI_MAX, 0, MPI_COMM_WORLD, ierr)
  else
     call MPI_Reduce(buf, buf, n, MPI_DOUBLE_PRECISION, &
          MPI_MAX, 0, MPI_COMM_WORLD, ierr)
  endif
end subroutine mpireducemax

subroutine mpireducemin(buf,n)
  integer, intent(in) :: n
  double precision, intent(inout) :: buf(n)

  integer ierr

  if (mpiiam()==0)then
     call MPI_Reduce(MPI_IN_PLACE, buf, n, MPI_DOUBLE_PRECISION, &
          MPI_MIN, 0, MPI_COMM_WORLD, ierr)
  else
     call MPI_Reduce(buf, buf, n, MPI_DOUBLE_PRECISION, &
          MPI_MIN, 0, MPI_COMM_WORLD, ierr)
  endif
end subroutine mpireducemin

subroutine mpiend()
  integer ierr

  call MPI_Bcast(AUTO_MPI_KILL_MESSAGE,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)

  call MPI_Finalize(ierr)
end subroutine mpiend

subroutine mpitim(tim)
  double precision tim
  tim = MPI_Wtime()
end subroutine mpitim  

end module autompi

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   cir :    Homoclinic Bifurcation in an Electronic Circuit
!                (the same equations as in demo tor)
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION P

       P=PAR(1) 

       F(1)= U(2)
       F(2)= U(3)
       F(3)= U(4)
       F(4)= -P*U(3)-U(1)+U(1)**3

       IF(IJAC.EQ.0)RETURN

       DFDU(1,1)=0.0d0
       DFDU(1,2)=1.0d0
       DFDU(1,3)=0.0d0
       DFDU(1,4)=0.0d0

       DFDU(2,1)=0.0d0
       DFDU(2,2)=0.0d0
       DFDU(2,3)=1.0d0
       DFDU(2,4)=0.0d0

       DFDU(3,1)=0.0d0
       DFDU(3,2)=0.0d0
       DFDU(3,3)=0.0d0
       DFDU(3,4)=1.0d0

       DFDU(4,1)=-1.0+3.0d0*U(1)**2
       DFDU(4,2)=0.0d0
       DFDU(4,3)=-P
       DFDU(4,4)=0.0d0

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DFDP(1,1)=0.0d0
       DFDP(2,1)=0.0d0
       DFDP(3,1)=0.0d0
       DFDP(4,1)=-U(3)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

!----------------------------------------------------------------------
! Problem parameters (only PAR(1-9) are available to the user) :

       PAR(1)=1.6                ! P

!----------------------------------------------------------------------
! If IEQUIB >0 put initial equilibrium in PAR(11+i), i=1,...,NDIM :

      PAR(12) = 0.0
      PAR(13) = 0.0
      PAR(14) = 0.0
      PAR(15) = 0.0

      END SUBROUTINE STPNT

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
! Homoclinic bifurcations COMMON block needed here :
      COMMON /BLHOM/ ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      INTEGER ITWIST,ISTART,IEQUIB,NFIXED,NPSI,NUNSTAB,NSTAB,NREV
      INTEGER I

! If IEQUIB =0 put analytic equilibrium in PAR(11+i), i=1..NDIM

      IF(IEQUIB.EQ.0)THEN
        DO I=1,NDIM
          PAR(11+I)= 0.0
        ENDDO
      ENDIF

      END SUBROUTINE PVLS

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   man :  Stable manifold of the origen in the Lorenz model 
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION Period

       Period=PAR(11)

       F(1)= Period * (PAR(3) * (U(2)- U(1)))
       F(2)= Period * (PAR(1)*U(1) - U(2) - U(1)*U(3))
       F(3)= Period * (U(1)*U(2) -  PAR(2)*U(3))

      END SUBROUTINE FUNC
!---------------------------------------------------------------------- 
      SUBROUTINE STPNT(NDIM,U,PAR,T) 
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION rad,h,Period,RLength,pi,theta,cs,sn,V1(3),V2(3)

       PAR(1)=28.
       PAR(2)=8.d0/3.d0 
       PAR(3)=10. 

       rad=5.0
       h=0.1
       Period=1e-5
       RLength=0.

       PAR(4)=rad
       PAR(5)=h

       CALL EIGV(NDIM,PAR,V1,V2)

! Set initial approximate solution (for small Period)
       pi=4*ATAN(1.d0)
       theta=2*pi*h
       cs=COS(theta)
       sn=SIN(theta)

       U(1)= rad * ( cs*V1(1) + sn*V2(1) )
       U(2)= rad * ( cs*V1(2) + sn*V2(2) )
       U(3)= rad * ( cs*V1(3) + sn*V2(3) )

       PAR(6) = U(1)
       PAR(7) = U(2)
       PAR(8) = U(3)
       PAR(9) = SQRT(U(1)**2 + U(2)**2 + U(3)**2)      
       PAR(11)=Period   
       PAR(12)=RLength

      END SUBROUTINE STPNT
!---------------------------------------------------------------------- 
      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

      DOUBLE PRECISION V1(3),V2(3),pi,rad,h,theta,cs,sn

       CALL EIGV(NDIM,PAR,V1,V2)

       pi=4*ATAN(1.d0)
       rad=PAR(4)
       h=PAR(5)
       theta=2*pi*h
       cs=COS(theta)
       sn=SIN(theta)
! At time=0
       FB(1)= U0(1) - rad * ( cs*V1(1) + sn*V2(1) )
       FB(2)= U0(2) - rad * ( cs*V1(2) + sn*V2(2) )
       FB(3)= U0(3) - rad * ( cs*V1(3) + sn*V2(3) )
! At time=1
       FB(4)= U1(1) - PAR(6)
       FB(5)= U1(2) - PAR(7)
       FB(6)= U1(3) - PAR(8)
       FB(7)= SQRT(U1(1)**2 + U1(2)**2 + U1(3)**2) - PAR(9)

      END SUBROUTINE BCND
!---------------------------------------------------------------------- 
      SUBROUTINE EIGV(NDIM,PAR,V1,V2) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: V1(NDIM),V2(NDIM)
      LOGICAL, SAVE :: ifirst = .TRUE.

      DOUBLE PRECISION e,ss

! Stable eigenvalue/vector 1
       V1(1)= 0.
       V1(2)= 0.
       V1(3)= 1./2.66667

! Stable eigenvalue/vector 2
       e=-(11+SQRT(1201.d0))/2
       V2(1)=1+e
       V2(2)=PAR(1)
       V2(3)= 0.
       ss=SQRT(V2(1)**2+V2(2)**2)
       V2(1)=V2(1)/(ss*22.8277)
       V2(2)=V2(2)/(ss*22.8277)
       IF(ifirst)THEN
         WRITE(10,*)V2(1),V2(2)
         ifirst=.FALSE.
       ENDIF

      END SUBROUTINE EIGV
!---------------------------------------------------------------------- 
      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
      DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

      DOUBLE PRECISION FF(3),DFDU(1),DFDP(1)

       CALL FUNC(NDIM,U,ICP,PAR,0,FF,DFDU,DFDP) 
       FI(1)=SQRT(FF(1)**2 + FF(2)**2 + FF(3)**2 ) - PAR(12) 

      END SUBROUTINE ICND

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   log :    The logistic map
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION x, mu

      x=U(1)
      mu=PAR(1)

       F(1)=mu*x*(1-x)

      IF(IJAC.EQ.0)RETURN 

       DFDU(1,1)=mu*(1-2*x)

      IF(IJAC.EQ.1)RETURN 

       DFDP(1,1)=x*(1-x)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0 ! mu
       U(1)=0 ! x

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    Mesh and Weight Generation
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
MODULE MESH

  IMPLICIT NONE
  PRIVATE
  PUBLIC :: MSH,GENWTS,WINT,ADPTDS,ADAPT,ADAPT2,INTWTS,SCALEB,SCALEBP
  PUBLIC :: RNRMSQ,RNRMSQP,RINTG,RINTGP,RNRM2,RNRM2P,RMXUPS,RMNUPS
  PUBLIC :: RMXUPST,RMNUPST,MXUPSP,RMXUPSP,RMNUPSP

CONTAINS

! ---------- ---
  SUBROUTINE MSH(NTST,TM)

! Generates a uniform mesh on [0,1].

    INTEGER, INTENT(IN) :: NTST
    DOUBLE PRECISION, INTENT(OUT) :: TM(0:NTST)

    INTEGER J

    DO J=0,NTST
       TM(J)=DBLE(J)/NTST
    ENDDO

  END SUBROUTINE MSH

! ---------- ------
  SUBROUTINE GENWTS(NCOL,WT,WP)

! Generates weights of the collocation method. The user selected
! number of collocation points (ncol) must be one of { 2,...,7 }.
!
! The following weights are generated :
!
!         WT : for the function value,
!         WP : for the first derivative,

    INTEGER, INTENT(IN) :: NCOL
    DOUBLE PRECISION, INTENT(OUT) :: WT(0:NCOL,NCOL),WP(0:NCOL,NCOL)
! Local
    INTEGER IB,IC,K,L,DENOM
    DOUBLE PRECISION ZM(NCOL),P,SUM

! Generate the collocation points :
    CALL CPNTS(NCOL,ZM)

! Generate weights :

    DO IB=0,NCOL
       DENOM=1
       DO K=0,NCOL
          IF(K/=IB)DENOM=DENOM*(IB-K)
       ENDDO
       DO IC=1,NCOL
! Weights for the function values :
          P=1.d0
          DO K=0,NCOL
             IF(K/=IB)P=P*( ZM(IC)*NCOL-K )
          ENDDO
          WT(IB,IC)=P/DENOM
! Weights for derivatives :
          SUM=0.d0
          DO L=0,NCOL
             IF(L/=IB)THEN
                P=1.d0
                DO K=0,NCOL
                   IF(K/=IB.AND.K/=L)P=P*( ZM(IC)*NCOL-K )
                ENDDO
                SUM=SUM+P*NCOL
             ENDIF
          ENDDO
          WP(IB,IC)=SUM/DENOM
       ENDDO
    ENDDO
  END SUBROUTINE GENWTS

! ---------- -----
  SUBROUTINE CPNTS(NCOL,ZM)

! Generates the collocation points with respect to [0,1].

    INTEGER, INTENT(IN) :: NCOL
    DOUBLE PRECISION, INTENT(OUT) :: ZM(NCOL)

    DOUBLE PRECISION, PARAMETER :: &
         C51 = .5d0*0.90617984593866399280d0, &
         C52 = .5d0*0.53846931010568309104d0, &
         C61 = .5d0*0.93246951420315202781d0, &
         C62 = .5d0*0.66120938646626451366d0, &
         C63 = .5d0*0.23861918608319690863d0, &
         C71 = .5d0*0.949107991234275852452d0, &
         C72 = .5d0*0.74153118559939443986d0, &
         C73 = .5d0*0.40584515137739716690d0, &
         R = 6.0d0/7.0d0

    DOUBLE PRECISION C21,C31,C4,C41,C42

    SELECT CASE(NCOL)
       CASE(2)
          C21 = .5d0/SQRT(3.0d0)
          ZM(1) = .5d0-C21
          ZM(2) = .5d0+C21
       CASE(3)
          C31 = .5d0*SQRT(0.6d0)
          ZM(1) = .5d0-C31
          ZM(2) = .5d0
          ZM(3) = .5d0+C31
       CASE(4)
          C4  = .5d0*SQRT(R**2-12.0d0/35.0d0)
          C41 = .5d0*SQRT(3.0d0/7.0d0+C4)
          C42 = .5d0*SQRT(3.0d0/7.0d0-C4)
          ZM(1) = .5d0-C41
          ZM(2) = .5d0-C42
          ZM(3) = .5d0+C42
          ZM(4) = .5d0+C41
       CASE(5)
          ZM(:) = (/ .5d0-C51, .5d0-C52, .5d0, .5d0+C52, .5d0+C51 /)
       CASE(6)
          ZM(:) = (/ .5d0-C61, .5d0-C62, .5d0-C63, &
                     .5d0+C63, .5d0+C62, .5d0+C61 /)
       CASE(7)
          ZM(:) = (/ .5d0-C71, .5d0-C72, .5d0-C73, .5d0, &
                     .5d0+C73, .5d0+C72, .5d0+C71  /)
    END SELECT
  END SUBROUTINE CPNTS

! ---------- ------
  SUBROUTINE CNTDIF(N,D)

! Generates the coefficients of the central difference formula for
! Nth derivative at uniformly spaced points
!              0 = x  < x  < ... < x  = 1.
!                   0    1          N
    INTEGER, INTENT(IN) :: N
    INTEGER, INTENT(OUT) :: D(0:N)

    INTEGER I,K

    D(0)=1
    IF(N.EQ.0)RETURN

    DO I=1,N
       D(I)=0
       DO K=I,1,-1
          D(K)=D(K-1)-D(K)
       ENDDO
       D(0)=-D(0)
    ENDDO

  END SUBROUTINE CNTDIF

! ---------- ----
  SUBROUTINE WINT(NCOL,WI)

! Generates the weights for the integration formula based on polynomial
! interpolation at NCOL+1 equally spaced points in [0,1].

    INTEGER, INTENT(IN) :: NCOL
    DOUBLE PRECISION, INTENT(OUT) :: WI(0:NCOL)

    DOUBLE PRECISION C

    SELECT CASE(NCOL)
    CASE(2)
       C=1.d0/6.0d0
       WI(0)=C
       WI(1)=4.0d0*C
       WI(2)=C
    CASE(3)
       C=1.d0/8.0d0
       WI(0)=C
       WI(1)=3.0d0*C
       WI(2)=WI(1)
       WI(3)=C
    CASE(4)
       C=1.d0/90.0d0
       WI(0)=7.0d0*C
       WI(1)=32.0d0*C
       WI(2)=12.0d0*C
       WI(3)=WI(1)
       WI(4)=WI(0)
    CASE(5)
       WI(0)=19.0d0/288.0d0
       WI(1)=25.0d0/96.0d0
       WI(2)=25.0d0/144.0d0
       WI(3)=WI(2)
       WI(4)=WI(1)
       WI(5)=WI(0)
    CASE(6)
       WI(0)=41.0d0/840.0d0
       WI(1)=9.0d0/35.0d0
       WI(2)=9.0d0/280.0d0
       WI(3)=34.0d0/105.0d0
       WI(4)=WI(2)
       WI(5)=WI(1)
       WI(6)=WI(0)
    CASE(7)
       WI(0)=751.0d0/17280.0d0
       WI(1)=3577.0d0/17280.0d0
       WI(2)=49.0d0/640.0d0
       WI(3)=2989.0d0/17280.0d0
       WI(4)=WI(3)
       WI(5)=WI(2)
       WI(6)=WI(1)
       WI(7)=WI(0)
    END SELECT

  END SUBROUTINE WINT

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!          Stepsize and Mesh Adaption
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ------
  SUBROUTINE ADPTDS(NIT,ITNW,IBR,NTOP,IID,DSMAX,RDS)

    INTEGER, INTENT(IN) :: NIT,ITNW,IBR,NTOP,IID
    DOUBLE PRECISION, INTENT(IN) :: DSMAX
    DOUBLE PRECISION, INTENT(INOUT) :: RDS
! Local
    DOUBLE PRECISION ARDS

! The stepsize along the branch of solutions is adapted depending on the
! number of Newton iterations in the previous step (called if IADS > 0).

    SELECT CASE(NIT)
    CASE(0:1)
       RDS= 2.d0*RDS
    CASE(2)
       RDS= 1.5*RDS
    CASE(3:)
       IF(NIT<=ITNW/2)THEN
          RDS= 1.1*RDS
       ELSE IF(NIT>=ITNW)THEN
          RDS=.5d0*RDS
       ENDIF
    END SELECT

    ARDS= ABS(RDS)
    IF(ARDS>DSMAX)RDS=RDS*DSMAX/ARDS

    IF(IID>0)THEN
       WRITE(9,"(/,I4,I6,8X,A,I3)")ABS(IBR),NTOP,' Iterations   : ',NIT
       WRITE(9,"(I4,I6,8X,A,ES13.5)")ABS(IBR),NTOP,' Next Step    : ',RDS
    ENDIF

  END SUBROUTINE ADPTDS

! ---------- -----
  SUBROUTINE ADAPT(NTST,NTSTNA,NCOL,NDIM,TM,DTM,UPS,VPS,IPER)

    USE AUTOMPI

! Adapts the distribution of the mesh points so that the increase of the
! monotone function EQDF becomes approximately equidistributed over the
! intervals. The functions UPS and VPS are interpolated on new mesh.

    INTEGER, INTENT(IN) :: NTST,NTSTNA,NCOL,NDIM
! For periodic boundary conditions extrapolate by periodicity.
    LOGICAL, INTENT(IN) :: IPER
    DOUBLE PRECISION, INTENT(INOUT) :: UPS(NDIM,0:NTSTNA*NCOL), &
         VPS(NDIM,0:NTSTNA*NCOL),TM(0:NTSTNA),DTM(NTSTNA)
! Local
    INTEGER :: IAM
    DOUBLE PRECISION, ALLOCATABLE :: TINT(:),UINT(:,:),VINT(:,:)

! Generate the new mesh :

    IAM=MPIIAM()
    IF(IAM==0)THEN
       ALLOCATE(TINT(0:NTST),UINT(NDIM,0:NTST*NCOL),VINT(NDIM,0:NTST*NCOL))

       CALL NEWMSH(NDIM,NDIM,UPS,NTST,NCOL,TM,DTM,NTST,TINT,IPER)

       CALL MPISCAT(TINT,1,NTST,1)

! Replace UPS/VPS by their interpolants on the new mesh :

       CALL INTERP(NDIM,NTST,NCOL,TM,UPS,VPS,NDIM,NTST,NCOL,TINT, &
         UINT,VINT)

       CALL MPISCAT(UINT,NDIM*NCOL,NTST,NDIM)
       CALL MPISCAT(VINT,NDIM*NCOL,NTST,NDIM)

       UPS(:,:)=UINT(:,:)
       VPS(:,:)=VINT(:,:)

! Replace old mesh :

       DTM(:)=TINT(1:NTST)-TINT(0:NTST-1)
       TM(:)=TINT(:)

       DEALLOCATE(TINT,UINT)
    ELSE
       CALL MPISCAT(TM,1,NTST,1)
       DTM(:)=TM(1:NTSTNA)-TM(0:NTSTNA-1)
       CALL MPISCAT(UPS,NDIM*NCOL,NTST,NDIM)
       CALL MPISCAT(VPS,NDIM*NCOL,NTST,NDIM)
    ENDIF

  END SUBROUTINE ADAPT

! ---------- ------
  SUBROUTINE ADAPT2(NOLD,NCOLD,NDOLD,NNEW,NCNEW,NDIM, &
       TMR,UPSR,VPSR,TM,UPS,VPS,IPER)

! Adapts the distribution of the mesh points so that the increase of the
! monotone function EQDF becomes approximately equidistributed over the
! intervals. The functions UPS and VPS are interpolated on new mesh.

    INTEGER, INTENT(IN) :: NOLD,NCOLD,NDOLD,NNEW,NCNEW,NDIM
    LOGICAL, INTENT(IN) :: IPER
    DOUBLE PRECISION, INTENT(IN) :: UPSR(NDOLD,0:*),VPSR(NDOLD,0:*),TMR(0:NOLD)
    DOUBLE PRECISION, INTENT(OUT) :: UPS(NDIM,0:*),VPS(NDIM,0:*),TM(0:*)
! Local
    INTEGER J,NDM
    DOUBLE PRECISION, ALLOCATABLE :: DTM(:)

    NDM=MIN(NDOLD,NDIM)
    IF(NOLD==NNEW.AND.NCOLD==NCNEW)THEN
! Just copy
       DO J=0,NCNEW*NNEW
          UPS(1:NDM,J)=UPSR(1:NDM,J)
          VPS(1:NDM,J)=VPSR(1:NDM,J)
       ENDDO
       TM(0:NNEW)=TMR(0:NNEW)
       RETURN
    ENDIF

! Generate the new mesh :

    ALLOCATE(DTM(NOLD))
    DTM(:)=TMR(1:NOLD)-TMR(0:NOLD-1)
    CALL NEWMSH(NDM,NDOLD,UPSR,NOLD,NCOLD,TMR,DTM,NNEW,TM,IPER)
    DEALLOCATE(DTM)

! Replace UPS/VPS by their interpolants on the new mesh :

    CALL INTERP(NDIM,NOLD,NCOLD,TMR,UPSR,VPSR,NDOLD,NNEW,NCNEW, &
         TM,UPS,VPS)

  END SUBROUTINE ADAPT2

! ---------- ------
  SUBROUTINE INTERP(NDIM,N,NC,TM,UPS,VPS,NDOLD,N1,NC1,TM1,UPS1,VPS1)

! Finds interpolant (TM(.) , UPS(.) ) on new mesh TM1.

    INTEGER, INTENT(IN) :: NDIM,N,NC,N1,NC1,NDOLD
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDOLD,0:N*NC),VPS(NDOLD,0:N*NC)
    DOUBLE PRECISION, INTENT(IN) :: TM(0:N),TM1(0:N1)
    DOUBLE PRECISION, INTENT(OUT) :: UPS1(NDIM,0:N1*NC1),VPS1(NDIM,0:N1*NC1)
! Local
    INTEGER I,J,J1,K,NDM
    DOUBLE PRECISION W(0:NC),Z,D,DT

    J=1
    NDM=MIN(NDIM,NDOLD)
    DO J1=0,N1-1
       DT=TM1(J1+1)-TM1(J1)
       DO I=0,NC1-1
          Z=TM1(J1)+I*DT/NC1
          DO
             IF(J>N)EXIT
             IF(TM(J)>Z)EXIT
             J=J+1
          ENDDO
          J=J-1
          D=TM(J+1)-TM(J)
          CALL INTWTS(NC,NC*(Z-TM(J))/D,W)
          DO K=1,NDM
             UPS1(K,J1*NC1+I)=DOT_PRODUCT(W(:),UPS(K,J*NC:J*NC+NC))
             VPS1(K,J1*NC1+I)=DOT_PRODUCT(W(:),VPS(K,J*NC:J*NC+NC))
          ENDDO
       ENDDO
    ENDDO

    DO I=1,NDM
       UPS1(I,N1*NC1)=UPS(I,N*NC)
       VPS1(I,N1*NC1)=VPS(I,N*NC)
    ENDDO

  END SUBROUTINE INTERP

! ---------- ------
  SUBROUTINE NEWMSH(NDIM,NDOLD,UPS,NOLD,NCOLD,TMOLD,DTMOLD,NNEW,TMNEW,IPER)

! Redistributes the mesh according to the function EQDF.

    INTEGER, INTENT(IN) :: NDIM,NDOLD,NOLD,NCOLD,NNEW
    LOGICAL, INTENT(IN) :: IPER
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDOLD,0:*),TMOLD(0:NOLD),DTMOLD(NOLD)
    DOUBLE PRECISION, INTENT(OUT) :: TMNEW(0:NNEW)
! Local
    INTEGER J,J1
    DOUBLE PRECISION DAL,UNEQ
    DOUBLE PRECISION, ALLOCATABLE :: EQF(:),DEQF(:)
    ALLOCATE(EQF(0:NOLD),DEQF(NOLD))

! Put the values of the monotonely increasing function EQDF in EQF.

    CALL EQDF(NOLD,NDIM,NCOLD,DTMOLD,UPS,NDOLD,EQF,DEQF,IPER)

! Uniformly divide the range of EQDF :

    DAL=EQF(NOLD)/NNEW

! Generate the new mesh in TMNEW :

! Assign TMNEW(0) and TMNEW(NNEW) explicitly because of loss of precision
! problems when the corresponding EQF values are very close

    TMNEW(0)=TMOLD(0)
    J=1
    DO J1=1,NNEW-1

! EQF is an ascending array with values in [0,EQF(NOLD)]. Get the
! value of the index of the TM-interval in which EQF(i) lies.
       UNEQ=J1*DAL
       DO
          IF(J>NOLD)EXIT
          IF(EQF(J)>UNEQ)EXIT
          J=J+1
       ENDDO
       J=J-1
       TMNEW(J1)=TMOLD(J)+(UNEQ-EQF(J))/DEQF(J+1)
    ENDDO

    TMNEW(NNEW)=TMOLD(NOLD)

    DEALLOCATE(EQF,DEQF)
  END SUBROUTINE NEWMSH

! ---------- ------
  SUBROUTINE INTWTS(N,DT1DT,WTS)

! Generates weights for Lagrange interpolation.

    INTEGER, INTENT(IN) :: N
    DOUBLE PRECISION, INTENT(IN) :: DT1DT
    DOUBLE PRECISION, INTENT(OUT) :: WTS(0:N)

    INTEGER IB,K,DENOM
    DOUBLE PRECISION P

    DENOM=1
    DO K=2,N
       DENOM=DENOM*K
    ENDDO
    DO IB=0,N
       P=1.d0
       DO K=0,N
          IF(K/=IB)THEN
             P=P*( K-DT1DT )
          ENDIF
       ENDDO
       WTS(IB)=P/DENOM
       IF(IB<N)DENOM=DENOM/(N-IB)*(-1-IB)
    ENDDO

  END SUBROUTINE INTWTS

! ---------- ----
  SUBROUTINE EQDF(NTST,NDIM,NCOL,DTM,UPS,NDOLD,EQF,DEQF,IPER)

    DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

    INTEGER, INTENT(IN) :: NTST,NDIM,NCOL,NDOLD
    LOGICAL, INTENT(IN) :: IPER
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDOLD,0:NTST*NCOL),DTM(NTST)
    DOUBLE PRECISION, INTENT(OUT) :: EQF(0:NTST),DEQF(NTST)

! Local
    DOUBLE PRECISION SC,E,PWR,DTAV,ND
    DOUBLE PRECISION, ALLOCATABLE :: HD(:)
    LOGICAL SMALL
    INTEGER I,J,WH(0:NCOL)

    ALLOCATE(HD(NDIM))
    CALL CNTDIF(NCOL,WH)

! Compute approximation to NCOL-th and (NCOL+1)-st derivative
! and define the equidistribution function :

    SMALL=.TRUE.
    PWR=1.d0/(NCOL+1.d0)
    EQF(0)=0.d0
    DO J=1,NTST
       E=0.d0
       SC=(NCOL/DTM(J))**NCOL
       DO I=1,NDIM
          ND=SC*DOT_PRODUCT(WH(:),UPS(I,(J-1)*NCOL:J*NCOL))
          IF(J>1)THEN
             E=E+ABS( 2*( ND-HD(I) )/(DTM(J-1)+DTM(J)) )**PWR
          ENDIF
          IF(ABS(ND)>HMACH)SMALL=.FALSE.
          HD(I)=ND
       ENDDO
       IF(J>1)THEN
          EQF(J-1)=EQF(J-2)+DTM(J-1)*E
          DEQF(J-1)=E
       ENDIF
    ENDDO

    E=0.d0
    IF(IPER)THEN
!      *Extend by periodicity :
       J=1
       DTAV=(DTM(NTST)+DTM(1))/2
    ELSE
!      *Extend by extrapolation :
       J=NTST-1
       DTAV=DTM(NTST)
    ENDIF
    SC=(NCOL/DTM(J))**NCOL
    DO I=1,NDIM
       ND=SC*DOT_PRODUCT(WH(:),UPS(I,(J-1)*NCOL:J*NCOL))
       E=E+ABS( (ND-HD(I))/DTAV )**PWR
       IF(ABS(ND)>HMACH)SMALL=.FALSE.
    ENDDO
    EQF(NTST)=EQF(NTST-1)+DTM(NTST)*E
    DEQF(NTST)=E

! Take care of "small derivative" case.

    IF(SMALL)THEN
       EQF(0)=0
       DO I=1,NTST
          EQF(I)=I
          DEQF(I)=1.0d0/DTM(I)
       ENDDO
    ENDIF

    DEALLOCATE(HD)
  END SUBROUTINE EQDF

! ------ --------- -------- -----
  DOUBLE PRECISION FUNCTION RNRMSQ(NTST,NCOL,NDIM,NDIM1,UPS,DTM,THU)

! Finds the norm-squared of UPS (first NDIM1 components are included only).

    INTEGER, INTENT(IN) :: NTST,NCOL,NDIM,NDIM1
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NCOL*NTST)
    DOUBLE PRECISION, INTENT(IN) :: DTM(*),THU(*)
! Local
    INTEGER I,J,K,KC
    DOUBLE PRECISION S,SJ,SK,WI(0:NCOL)

! Weights for the integration formulae :
    CALL WINT(NCOL,WI)

    S=0.d0
    K=0
    DO J=1,NTST
       SJ=0.d0
       DO KC=0,NCOL
          SK=0.d0
          DO I=1,NDIM1
             SK=SK+THU(I)*UPS(I,K+KC)**2
          ENDDO
          SJ=SJ+SK*WI(KC)
       ENDDO
       K=K+NCOL
       S=S+DTM(J)*SJ
    ENDDO

    RNRMSQ=S

  END FUNCTION RNRMSQ

! ------ --------- -------- -------
  DOUBLE PRECISION FUNCTION RNRMSQP(NTST,NCOL,NDIM,NDIM1,UPS,DTM,THU,NA)

    USE AUTOMPI

! Finds the norm-squared of UPS (first NDIM1 components are included only).
! Parallelized using MPI without MPI_Reduce so addition order is consistent.

    INTEGER, INTENT(IN) :: NTST,NCOL,NDIM,NDIM1,NA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NCOL*NTST)
    DOUBLE PRECISION, INTENT(IN) :: DTM(*),THU(*)
! Local
    INTEGER I,J,K,KC
    DOUBLE PRECISION S,SJ,SK,WI(0:NCOL)
    DOUBLE PRECISION, ALLOCATABLE :: SS(:)

! Weights for the integration formulae :

    IF(MPIKWT()==1)THEN
       RNRMSQP=RNRMSQ(NTST,NCOL,NDIM,NDIM1,UPS,DTM,THU)
       RETURN
    ENDIF

    CALL WINT(NCOL,WI)

    ALLOCATE(SS(NTST))
    K=0
    DO J=1,NA
       SJ=0.d0
       DO KC=0,NCOL
          SK=0.d0
          DO I=1,NDIM1
             SK=SK+THU(I)*UPS(I,K+KC)**2
          ENDDO
          SJ=SJ+SK*WI(KC)
       ENDDO
       K=K+NCOL
       SS(J)=DTM(J)*SJ
    ENDDO

    CALL MPIGAT(SS,1,NTST)
    S=0.d0
    IF(MPIIAM()==0)THEN
       DO J=1,NTST
          S=S+SS(J)
       ENDDO
    ENDIF

    DEALLOCATE(SS)
    RNRMSQP=S

  END FUNCTION RNRMSQP

! ------ --------- -------- -----
  DOUBLE PRECISION FUNCTION RINTG(NTST,NCOL,NDIM,IC,UPS,DTM)

! Computes the integral of the IC'th component of UPS.

    INTEGER, INTENT(IN) :: IC,NDIM,NCOL,NTST
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL),DTM(NTST)
! Local
    DOUBLE PRECISION WI(0:NCOL)
    INTEGER J,K
    DOUBLE PRECISION S

! Weights for the integration formulae :
    CALL WINT(NCOL,WI)

    S=0.d0
    K=0
    DO J=1,NTST
       S=S+DTM(J)*DOT_PRODUCT(WI,UPS(IC,K:K+NCOL))
       K=K+NCOL
    ENDDO

    RINTG=S

  END FUNCTION RINTG

! ------ --------- -------- -----
  DOUBLE PRECISION FUNCTION RINTGP(NTST,NCOL,NDIM,IC,UPS,DTM,NA)

    USE AUTOMPI

! Computes the integral of the IC'th component of UPS.
! Parallelized using MPI without MPI_Reduce so addition order is consistent.

    INTEGER, INTENT(IN) :: IC,NDIM,NCOL,NTST,NA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL),DTM(NTST)
! Local
    DOUBLE PRECISION WI(0:NCOL)
    INTEGER J,K
    DOUBLE PRECISION S
    DOUBLE PRECISION, ALLOCATABLE :: SS(:)

    IF(MPIKWT()==1)THEN
       RINTGP=RINTG(NTST,NCOL,NDIM,IC,UPS,DTM)
       RETURN
    ENDIF

! Weights for the integration formulae :
    CALL WINT(NCOL,WI)

    ALLOCATE(SS(NTST))
    K=0
    DO J=1,NA
       SS(J)=DTM(J)*DOT_PRODUCT(WI,UPS(IC,K:K+NCOL))
       K=K+NCOL
    ENDDO

    CALL MPIGAT(SS,1,NTST)
    S=0.d0
    IF(MPIIAM()==0)THEN
       DO J=1,NTST
          S=S+SS(J)
       ENDDO
    ENDIF

    DEALLOCATE(SS)
    RINTGP=S

  END FUNCTION RINTGP

! ------ --------- -------- -----
  DOUBLE PRECISION FUNCTION RNRM2(NTST,NCOL,NDIM,IC,UPS,DTM)

! Computes the L2-norm of the IC'th component of UPS.
 
    INTEGER, INTENT(IN) :: IC,NDIM,NCOL,NTST
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL),DTM(NTST)
! Local
    DOUBLE PRECISION WI(0:NCOL)
    INTEGER J,K
    DOUBLE PRECISION S

! Weights for the integration formulae :
    CALL WINT(NCOL,WI)

    S=0.d0
    K=0
    DO J=1,NTST
       S=S+DTM(J)*DOT_PRODUCT(WI,UPS(IC,K:K+NCOL)**2)
       K=K+NCOL
    ENDDO

    RNRM2=SQRT(S)

  END FUNCTION RNRM2

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION RNRM2P(NTST,NCOL,NDIM,IC,UPS,DTM,NA)

    USE AUTOMPI

! Computes the L2-norm of the IC'th component of UPS.
! Parallelized using MPI without MPI_Reduce so addition order is consistent.

    INTEGER, INTENT(IN) :: IC,NDIM,NCOL,NTST,NA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL),DTM(NTST)
! Local
    DOUBLE PRECISION WI(0:NCOL)
    INTEGER J,K
    DOUBLE PRECISION S
    DOUBLE PRECISION, ALLOCATABLE :: SS(:)

    IF(MPIKWT()==1)THEN
       RNRM2P=RNRM2(NTST,NCOL,NDIM,IC,UPS,DTM)
       RETURN
    ENDIF

! Weights for the integration formulae :
    CALL WINT(NCOL,WI)

    ALLOCATE(SS(NTST))
    K=0
    DO J=1,NA
       SS(J)=DTM(J)*DOT_PRODUCT(WI,UPS(IC,K:K+NCOL)**2)
       K=K+NCOL
    ENDDO

    CALL MPIGAT(SS,1,NTST)
    S=0.d0
    IF(MPIIAM()==0)THEN
       DO J=1,NTST
          S=S+SS(J)
       ENDDO
    ENDIF

    DEALLOCATE(SS)
    RNRM2P=SQRT(S)

  END FUNCTION RNRM2P

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION RMXUPS(NTST,NCOL,NDIM,I,UPS)

! Computes the maximum of the I'th component of UPS.

    INTEGER, INTENT(IN) :: I,NDIM,NCOL,NTST
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL)

    RMXUPS=MAXVAL(UPS(I,:))

  END FUNCTION RMXUPS

! ------ --------- -------- -------
  DOUBLE PRECISION FUNCTION RMXUPSP(NA,NCOL,NDIM,I,UPS)

    USE AUTOMPI

! Computes the maximum of the I'th component of UPS (using MPI).

    INTEGER, INTENT(IN) :: I,NDIM,NCOL,NA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NA*NCOL)

    DOUBLE PRECISION BUF(1)

    BUF(1)=MAXVAL(UPS(I,:))
    CALL MPIREDUCEMAX(BUF,1)
    RMXUPSP=BUF(1)

  END FUNCTION RMXUPSP

! ---------- ------
  SUBROUTINE MXUPSP(NA,NCOL,NDIM,NDM,UPS,UMX)

    USE AUTOMPI

! Computes the maximum of all components of UPS (using MPI).

    INTEGER, INTENT(IN) :: NDIM,NDM,NCOL,NA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NA*NCOL)
    DOUBLE PRECISION, INTENT(OUT) :: UMX(NDIM)

    INTEGER I

    DO I=1,NDM
       UMX(I)=MAXVAL(UPS(I,:))
    ENDDO
    CALL MPIREDUCEMAX(UMX,NDM)

  END SUBROUTINE MXUPSP

! ------ --------- -------- -------
  DOUBLE PRECISION FUNCTION RMXUPST(NTST,NCOL,NDIM,I,UPS,DTM)

! Computes the t value for the maximum of the I'th component of UPS.

    INTEGER, INTENT(IN) :: I,NDIM,NCOL,NTST
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL),DTM(NTST)

    INTEGER LOC(1),J,L,M

    LOC=MAXLOC(UPS(I,:))
    L=LOC(1)-1
    J=L/NCOL
    RMXUPST=SUM(DTM(1:J))
    M=MOD(L,NCOL)
    IF(M>0)THEN
       RMXUPST=RMXUPST+DTM(J+1)*M/NCOL
    ENDIF

  END FUNCTION RMXUPST

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION RMNUPS(NTST,NCOL,NDIM,I,UPS)

! Computes the minimum of the I'th component of UPS.

    INTEGER, INTENT(IN) :: I,NDIM,NCOL,NTST
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL)

    RMNUPS=MINVAL(UPS(I,:))

  END FUNCTION RMNUPS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION RMNUPSP(NA,NCOL,NDIM,I,UPS)

    USE AUTOMPI

! Computes the minimum of the I'th component of UPS (using MPI).

    INTEGER, INTENT(IN) :: I,NDIM,NCOL,NA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NA*NCOL)

    DOUBLE PRECISION BUF(1)

    BUF(1)=MINVAL(UPS(I,:))
    CALL MPIREDUCEMIN(BUF,1)
    RMNUPSP=BUF(1)
    
  END FUNCTION RMNUPSP

! ------ --------- -------- -------
  DOUBLE PRECISION FUNCTION RMNUPST(NTST,NCOL,NDIM,I,UPS,DTM)

! Computes the t value for the minimum of the I'th component of UPS.

    INTEGER, INTENT(IN) :: I,NDIM,NCOL,NTST
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTST*NCOL),DTM(NTST)

    INTEGER LOC(1),J,L,M

    LOC=MINLOC(UPS(I,:))
    L=LOC(1)-1
    J=L/NCOL
    RMNUPST=SUM(DTM(1:J))
    M=MOD(L,NCOL)
    IF(M>0)THEN
       RMNUPST=RMNUPST+DTM(J+1)*M/NCOL
    ENDIF

  END FUNCTION RMNUPST

! ---------- ------
  SUBROUTINE SCALEB(NTST,NCOL,NDIM,NFPR,DVPS,RLD,DTM,THL,THU)

! Scales the vector (DVPS,RLD) so its norm becomes 1.

    INTEGER, INTENT(IN) :: NTST,NCOL,NDIM,NFPR
    DOUBLE PRECISION, INTENT(IN) :: DTM(*),THL(NFPR),THU(*)
    DOUBLE PRECISION, INTENT(INOUT) :: DVPS(NDIM,0:NCOL*NTST),RLD(NFPR)

    DOUBLE PRECISION SS

    SS=SQRT(RNRMSQ(NTST,NCOL,NDIM,NDIM,DVPS,DTM,THU)+ &
         DOT_PRODUCT(THL(:),RLD(:)**2))

    DVPS(:,:)=DVPS(:,:)/SS
    RLD(:)=RLD(:)/SS

  END SUBROUTINE SCALEB

! ---------- -------
  SUBROUTINE SCALEBP(NTST,NCOL,NDIM,NFPR,DVPS,RLD,DTM,THL,THU,NA)

    USE AUTOMPI

! Scales the vector (DVPS,RLD) so its norm becomes 1.
! Parallelized using MPI

    INTEGER, INTENT(IN) :: NTST,NCOL,NDIM,NFPR,NA
    DOUBLE PRECISION, INTENT(IN) :: DTM(*),THL(NFPR),THU(*)
    DOUBLE PRECISION, INTENT(INOUT) :: DVPS(NDIM,0:NCOL*NTST),RLD(NFPR)

    DOUBLE PRECISION SS

    SS=RNRMSQP(NTST,NCOL,NDIM,NDIM,DVPS,DTM,THU,NA)

    IF(MPIIAM()==0)THEN
       SS=SQRT(SS+DOT_PRODUCT(THL(:),RLD(:)**2))
    ENDIF

    CALL MPIBCAST1(SS)

    DVPS(:,0:NCOL*NA)=DVPS(:,0:NCOL*NA)/SS
    IF(MPIIAM()==0.AND.NTST>NA)THEN
       DVPS(:,NCOL*NTST)=DVPS(:,NCOL*NTST)/SS
    ENDIF
    RLD(:)=RLD(:)/SS

  END SUBROUTINE SCALEBP

END MODULE MESH

C     ------- ------
      PROGRAM AUTCON
C
C This program converts a data file into a labeled AUTO solution
C
C
      IMPLICIT NONE
      include 'fcon.h'
C
      INTEGER NDIM,NOLD,NTST,NCOL,ISW,IPS,NPAR,I,J,ios
      DOUBLE PRECISION TEMP,T,PERIOD
      DOUBLE PRECISION, ALLOCATABLE :: U(:),TM(:),UPS(:,:)
      DOUBLE PRECISION, ALLOCATABLE :: TMR(:),UPSR(:,:),PAR(:)
C
       OPEN(2,FILE='fort.2',STATUS='old',ACCESS='sequential',IOSTAT=ios)
       IF(ios/=0)THEN
          WRITE(6,'(A,A)')'The constants file (fort.2 or c. file) ',
     *         'could not be found.'
          STOP
       ENDIF
       OPEN(3,FILE='fort.3',STATUS='unknown',ACCESS='sequential')
       OPEN(8,FILE='fort.8',STATUS='unknown',ACCESS='sequential')
C
        CALL INIT(NDIM,IPS,NTST,NCOL,ISW,NPAR)
        ALLOCATE(U(NDIM),PAR(NPAR))
        PAR(:)=0d0
C
        NOLD=0
        DO
          NOLD=NOLD+1
          READ(3,*,END=2)TEMP,(TEMP,I=1,NDIM)
        ENDDO
C
 2      NOLD=NOLD-2
        ALLOCATE(TM(0:NTST),TMR(0:NOLD))
        ALLOCATE(UPSR(NDIM,0:NOLD),UPS(NDIM,0:NTST*NCOL))
C
        REWIND 3
        DO J=0,NOLD
          READ(3,*)TMR(J),UPSR(1:NDIM,J)
        ENDDO
C
        PERIOD=TMR(NOLD)-TMR(0)
        DO I=NOLD,0,-1
          TMR(I)=(TMR(I)-TMR(0))/PERIOD
        ENDDO
        CALL ADAPT(NOLD,NDIM,NTST,NCOL,NDIM,TMR,UPSR,TM,UPS,
     &       ((IPS.EQ.2.OR.IPS.EQ.12) .AND. ABS(ISW).LE.1))
C
        PAR(11)=PERIOD
        CALL STPNT(NDIM,U,PAR,T)
        CALL WRTBV8(NDIM,NTST,NCOL,ISW,PAR,UPS,TM,NPAR)
C
        DEALLOCATE(U,TM,TMR,UPS,UPSR)
C
      STOP
      CONTAINS

C     ---------- ----
      SUBROUTINE INIT(NDIM,IPS,NTST,NCOL,ISW,NPAR)
C
      IMPLICIT NONE
      INTEGER, INTENT(OUT) :: NDIM,IPS,NTST,NCOL,ISW,NPAR
      CHARACTER(LEN=2048) :: STR
C
C Reads the file of continuation constants
C
      INTEGER KEYEND,POS,NPOS
      INTEGER LINE
C
C Defaults
C
      NDIM=2
      IPS=1
      NTST=20
      NCOL=4
      ISW=1
      NPAR=NPARX

      LINE=0
      NPOS=1
      scanloop: DO
         IF(NPOS==1)THEN
            LINE=LINE+1
            READ(2,'(A)',END=1) STR
         ELSE
            STR=STR(NPOS:)
         ENDIF
         STR=ADJUSTL(STR)
         IF(LEN_TRIM(STR)==0)CYCLE
         DO I=1,LEN_TRIM(STR)
            ! comment on line
            IF(STR(I:I)=='#'.OR.STR(I:I)=='!')THEN
               NPOS=1
               CYCLE scanloop
            ENDIF
            ! keyword detected
            IF((LGE(STR(I:I),'A').AND.LLE(STR(I:I),'Z')).OR.
     &         (LGE(STR(I:I),'a').AND.LLE(STR(I:I),'z')))THEN
               STR=STR(I:)
               EXIT
            ELSE
               EXIT scanloop
            ENDIF
            IF(I==LEN_TRIM(STR))THEN
               NPOS=1
               CYCLE scanloop
            ENDIF
         ENDDO
         ! look for = after keyword
         KEYEND=SCAN(STR,'= ')-1
         IF(KEYEND==-1)THEN
            LINE=LINE-1
            EXIT scanloop
         ENDIF
         POS=SCAN(STR,'=')+1
         STR(POS:)=ADJUSTL(STR(POS:))
         NPOS=SCANVALUE(STR(POS:))
         IF(NPOS/=1)THEN
            NPOS=NPOS+POS-1
         ENDIF
         SELECT CASE(STR(1:KEYEND))
         CASE('NDIM')
            READ(STR(POS:),*,ERR=3)NDIM
         CASE('IPS')
            READ(STR(POS:),*,ERR=3)IPS
         CASE('NTST')
            READ(STR(POS:),*,ERR=3)NTST
         CASE('NCOL')
            READ(STR(POS:),*,ERR=3)NCOL
         CASE('ISW')
            READ(STR(POS:),*,ERR=3)ISW
         CASE('NPAR')
            READ(STR(POS:),*,ERR=3)NPAR
         ! ignore all others
         END SELECT
      ENDDO scanloop

      BACKSPACE 2
      READ(2,*,ERR=3,END=4) NDIM,IPS
      LINE=LINE+1
      READ(2,*,ERR=3,END=4)
      LINE=LINE+1
      READ(2,*,ERR=3,END=4) NTST,NCOL,ISW,ISW,ISW

 1    CONTINUE
      RETURN
 3    WRITE(6,"(A,I2,A)")
     *     " Error in fort.2 or c. file: bad value on line ",
     *     LINE,"."
      STOP
 4    WRITE(6,"(A,I2,A)")
     *     " Error in fort.2 or c. file: ends prematurely on line ",
     *     LINE,"."
      STOP
      END SUBROUTINE INIT

C     ------- -------- ---------
      INTEGER FUNCTION SCANVALUE(STR)
      IMPLICIT NONE
C
C     Scans STR(:) for a value
C     NPOS points to the next keyword on the same line,
C       or is set to 1 if there is none
C
      CHARACTER(*), INTENT(INOUT) :: STR

      INTEGER NPOS,I,LEVEL,LENSTR,ios
      CHARACTER(1) C,PREV,QUOTE
      LOGICAL QUOTEESC
      LEVEL=0
      QUOTE=' '
      QUOTEESC=.FALSE.
      PREV=' '

      NPOS=1
      LENSTR=LEN_TRIM(STR)
      I=1
      DO
         IF(I>LENSTR)THEN
            IF(LEVEL==0)EXIT
            LENSTR=LEN_TRIM(STR)
            READ(2,'(A)',IOSTAT=ios) STR(LENSTR+1:)
            IF(ios/=0)EXIT
            LENSTR=LEN_TRIM(STR)
         ENDIF
         NPOS=I
         C=STR(I:I)
         IF(QUOTE==' ')THEN
            SELECT CASE(C)
            CASE(',',' ')
               IF(LEVEL==0)EXIT
               IF(PREV==':')C=PREV !eat ',' and ' ' after ':'
            CASE(':')
            CASE(']','}')
               LEVEL=LEVEL-1
            CASE DEFAULT
               SELECT CASE(C)
               CASE('[','{')
                  LEVEL=LEVEL+1
               CASE('"',"'")
                  QUOTE=C
               END SELECT
            END SELECT
         ELSEIF(C==QUOTE)THEN
            ! ignore "" and ''
            IF(STR(I+1:I+1)==C.OR.QUOTEESC)THEN
               QUOTEESC=.NOT.QUOTEESC
            ELSE
               QUOTE=' '
            ENDIF
         ENDIF
         PREV=C
         I=I+1
      ENDDO
      NPOS=NPOS+VERIFY(STR(NPOS:)," ,")-1
      IF(NPOS>=LEN_TRIM(STR))NPOS=1
      SCANVALUE=NPOS
      END FUNCTION SCANVALUE
C
C     ---------- -----
      SUBROUTINE ADAPT(NOLD,NDOLD,NNEW,NCNEW,NDIM,
     &     TMR,UPSR,TM,UPS,IPER)

C Adapts the distribution of the mesh points so that the increase of the
C monotone function EQDF becomes approximately equidistributed over the
C intervals. The function UPS is interpolated on new mesh.

      INTEGER, INTENT(IN) :: NOLD,NDOLD,NNEW,NCNEW,NDIM
      LOGICAL, INTENT(IN) :: IPER
      DOUBLE PRECISION, INTENT(IN) :: UPSR(NDOLD,0:*), TMR(0:NOLD)
      DOUBLE PRECISION, INTENT(OUT) :: UPS(NDIM,0:*), TM(0:*)

C Generate the new mesh :

       CALL NEWMSH(NDIM,NDOLD,UPSR,NOLD,TMR,NNEW,TM,IPER)

C Replace UPS by its interpolant on the new mesh :

       CALL INTERP(NDIM,NOLD,TMR,UPSR,NDOLD,NNEW,NCNEW,TM,UPS)

      END SUBROUTINE ADAPT

C     ---------- ------
      SUBROUTINE INTERP(NDIM,N,TM,UPS,NDOLD,N1,NC1,TM1,UPS1)

C Finds interpolant (TM(.) , UPS(.) ) on new mesh TM1.

      INTEGER, INTENT(IN) :: NDIM,N,N1,NC1,NDOLD
      DOUBLE PRECISION, INTENT(IN) :: UPS(NDOLD,0:N)
      DOUBLE PRECISION, INTENT(IN) :: TM(0:N),TM1(0:N1)
      DOUBLE PRECISION, INTENT(OUT) :: UPS1(NDIM,0:N1*NC1)
C Local
      INTEGER I,J,J1,K
      DOUBLE PRECISION W0,W1,Z

       J=1
       DO J1=0,N1-1
         DO I=0,NC1-1
           Z=TM1(J1)+I*( TM1(J1+1)-TM1(J1) )/NC1
           DO
             IF(J>N)EXIT
             IF(TM(J)>Z)EXIT
             J=J+1
           ENDDO
           J=J-1
           W0=( Z-TM(J+1) )/( TM(J)-TM(J+1) )
           W1=( Z-TM(J) )/( TM(J+1)-TM(J) )
           DO K=1,NDIM
             UPS1(K,J1*NC1+I)=W0*UPS(K,J)+W1*UPS(K,J+1)
           ENDDO
         ENDDO
       ENDDO

       DO I=1,NDIM
         UPS1(I,N1*NC1)=UPS(I,N)
       ENDDO

      END SUBROUTINE INTERP

C     ---------- ------
      SUBROUTINE NEWMSH(NDIM,NDOLD,UPS,NOLD,TMOLD,NNEW,TMNEW,IPER)

C Redistributes the mesh according to the function EQDF.

      INTEGER, INTENT(IN) :: NDIM,NDOLD,NOLD,NNEW
      LOGICAL, INTENT(IN) :: IPER
      DOUBLE PRECISION, INTENT(IN) :: UPS(NDOLD,0:*),TMOLD(0:NOLD)
      DOUBLE PRECISION, INTENT(OUT) :: TMNEW(0:NNEW)
C Local
      INTEGER J,J1
      DOUBLE PRECISION DAL,UNEQ
      DOUBLE PRECISION, ALLOCATABLE :: EQF(:),DEQF(:)
      ALLOCATE(EQF(0:NOLD),DEQF(1:NOLD))

C Put the values of the monotonely increasing function EQDF in EQF.

       CALL EQDF(NOLD,NDIM,TMOLD,UPS,NDOLD,EQF,DEQF,IPER)

C Uniformly divide the range of EQDF :

       DAL=EQF(NOLD)/NNEW

C Generate the new mesh in TMNEW :

       J=1
       DO J1=0,NNEW-1

C EQF is an ascending array with values in [0,1]. Get the
C value of the index of the TM-interval in which EQF(i) lies.
        UNEQ=J1*DAL
        DO
          IF(J>NOLD)EXIT
          IF(EQF(J)>UNEQ)EXIT
          J=J+1
        ENDDO
        J=J-1
        TMNEW(J1)=TMOLD(J)+(UNEQ-EQF(J))/DEQF(J+1)
      ENDDO

C Assign TMNEW(NNEW) explicitly because of loss of precision
C problems when EQF(NOLD) and EQF(NOLD-1) are very close

      TMNEW(NNEW)=TMOLD(NOLD)

      DEALLOCATE(EQF,DEQF)
      END SUBROUTINE NEWMSH

C     ---------- ----
      SUBROUTINE EQDF(NTST,NDIM,TM,UPS,NDOLD,EQF,DEQF,IPER)

      DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

      INTEGER, INTENT(IN) :: NTST,NDIM,NDOLD
      LOGICAL, INTENT(IN) :: IPER
      DOUBLE PRECISION, INTENT(IN) :: UPS(NDOLD,0:NTST),TM(0:NTST)
      DOUBLE PRECISION, INTENT(OUT) :: EQF(0:NTST),DEQF(NTST)

C Local
      DOUBLE PRECISION E,DTAV,ND,DT
      DOUBLE PRECISION, ALLOCATABLE :: HD(:)
      LOGICAL SMALL
      INTEGER I,J

       ALLOCATE(HD(NDIM))

C Compute approximation to NCOL-th and (NCOL+1)-st derivative
C and define the equidistribution function :

       SMALL=.TRUE.
       EQF(0)=0.d0
       DO J=1,NTST
         E=0.d0
         DT=TM(J)-TM(J-1)
         DO I=1,NDIM
           ND=(UPS(I,J)-UPS(I,J-1))/DT
           IF(J>1)THEN
             E=E+SQRT(ABS( 2*( ND-HD(I) )/(TM(J)-TM(J-2)) ))
           ENDIF
           IF(ABS(ND)>HMACH)SMALL=.FALSE.
           HD(I)=ND
         ENDDO
         IF(J>1)THEN
            EQF(J-1)=EQF(J-2)+(TM(J-1)-TM(J-2))*E
            DEQF(J-1)=E
         ENDIF
       ENDDO

       E=0.d0
       J=NTST-1
       DTAV=TM(NTST)-TM(NTST-1)
       IF(IPER)THEN
C      *Extend by periodicity :
         J=1
         DTAV=(DTAV+TM(1)-TM(0))/2
       ENDIF
C      *else extend by extrapolation :
       DO I=1,NDIM
         ND=(UPS(I,J)-UPS(I,J-1))/(TM(J)-TM(J-1))
         E=E+SQRT(ABS( (ND-HD(I))/DTAV ))
         IF(ABS(ND)>HMACH)SMALL=.FALSE.
       ENDDO
       EQF(NTST)=EQF(NTST-1)+(TM(NTST)-TM(NTST-1))*E
       DEQF(NTST)=E

C Take care of "small derivative" case.

       IF(SMALL)THEN
         EQF(0)=0
         DO I=1,NTST
            EQF(I)=I
            DEQF(I)=1.0d0/(TM(I)-TM(I-1))
         ENDDO
       ENDIF

       DEALLOCATE(HD)
      END SUBROUTINE EQDF

C     ---------- ------
      SUBROUTINE WRTBV8(NDIM,NTST,NCOL,ISW,PAR,UPS,TM,NPAR)

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NDIM,NTST,NCOL,ISW,NPAR
      DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:*),TM(0:*),PAR(*)

      INTEGER IBR,ITP,NFPR,NTOT,LAB,NTPL,NAR,NROWPR,MTOT

       ITP=9
       NFPR=1
       IBR=1
       NTOT=1
       LAB=1

C Write information identifying the solution :

       NTPL=NCOL*NTST+1
       NAR=NDIM+1
       NROWPR=((NDIM+6)/7)*NTPL + (NPAR+6)/7
       MTOT=MOD(NTOT-1,9999)+1
       WRITE(8,101)IBR,MTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,
     &      NTST,NCOL,NPAR

C Write the entire solution on unit 8 :

       DO J=0,NTST*NCOL
         T=TM(J/NCOL)+MOD(J,NCOL)*(TM(J/NCOL+1)-TM(J/NCOL))/NCOL
         WRITE(8,102)T,UPS(:,J)
       ENDDO

C Write the parameter values.

       WRITE(8,102)(PAR(I),I=1,NPAR)

 101   FORMAT(6I6,I8,I6,I8,3I5)
 102   FORMAT(4X,7ES19.10E3)

      END SUBROUTINE WRTBV8

      END PROGRAM AUTCON

C
      DOUBLE PRECISION FUNCTION GETP(CODE,IC,UPS)
C Dummy routine (in case GETP is called in the user routine PVLS)
      GETP=0.0d0
      END FUNCTION GETP

!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    Algebraic Problems
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
MODULE AE

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

  IMPLICIT NONE
  PRIVATE
  PUBLIC :: AUTOAE

CONTAINS

! ---------- ------
  SUBROUTINE AUTOAE(AP,ICP,ICU,FUNI,STPNAEI,FNCI)

! This is the entry subroutine for algebraic systems.

    USE AUTOMPI

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ICU(*)

    include 'interfaces.h'

    IF(MPIIAM()>0)THEN
       RETURN
    ENDIF
    IF(MPIKWT()>1)THEN
       WRITE(9,"(A)")' NOTE: MPI is not used for algebraic problems'
    ENDIF
    CALL CNRLAE(AP,ICP,ICU,FUNI,STPNAEI,FNCI)

  END SUBROUTINE AUTOAE

! ---------- ------
  SUBROUTINE CNRLAE(AP,ICP,ICU,FUNI,STPNAEI,FNCI)

    USE IO
    USE MESH
    USE SUPPORT, ONLY: AA=>P0V, P1V, EVV, FNCS, STOPPED, INIT2, INIT3, &
         INITSTOPCNTS, PVLI, LBITP
    USE AUTO_CONSTANTS, ONLY: NPARX

! Controls the bifurcation analysis of algebraic problems

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ICU(*)
! Local
    DOUBLE PRECISION, ALLOCATABLE :: &
         PAR(:),VUZ(:),THU(:),THL(:), &
         U(:),UDOT(:),STUD(:,:),STU(:,:),TEST(:)
    INTEGER, ALLOCATABLE :: IUZ(:)
    LOGICAL IPOS
    INTEGER NDIM,IPS,IRS,ILP,IADS,ISP,ISW,NUZR,MXBF,NBIFS,NBFCS,ITPST
    INTEGER ITNW,ITP,I,ITEST,NINS,NBIF,NBFC,NODIR,NIT,NTOT,NTOP
    INTEGER NDM,IFOUND,ISTEPPED
    DOUBLE PRECISION DS,DSMAX,RDS,DSTEST,TMP
    LOGICAL ISTOP,STEPPED
    INTEGER STOPCNTS(-9:14)
    CHARACTER(4) ATYPE,ATYPEDUM

    CALL INIT2(AP,ICP,ICU)

    NDIM=AP%NDIM
    NDM=AP%NDM
    IPS=AP%IPS
    IRS=AP%IRS
    ILP=AP%ILP
    IADS=AP%IADS
    ISP=AP%ISP
    ISW=AP%ISW
    NUZR=AP%NUZR
    MXBF=AP%MXBF
    NBIFS=ABS(MXBF)
    IF(MXBF>0)THEN
       NBFCS=2*NBIFS
    ELSE
       NBFCS=NBIFS
    ENDIF
    ITPST=AP%ITPST

    DS=AP%DS

    ! allocate a minimum of NPARX so we can detect overflows 
    ! past NPAR gracefully
    ! set thu to 1 higher than NDIM for (u,par) representation
    ALLOCATE(PAR(MAX(AP%NPAR,NPARX)),THL(AP%NFPR),THU(NDIM+1))
    ALLOCATE(IUZ(NUZR),VUZ(NUZR))
    CALL INIT3(AP,ICP,PAR,THL,THU,IUZ,VUZ)
    THU(AP%NDIM+1)=THL(1)

    ALLOCATE(AA(NDIM+1,NDIM+1),U(NDIM+1),UDOT(NDIM+1))
    ALLOCATE(STUD(NBIFS,NDIM+1),STU(NBIFS,NDIM+1),TEST(AP%NTEST),EVV(NDM))
    ALLOCATE(P1V(NDIM+1,NDIM+1))

    NINS=0
    AP%NINS=NINS
    RDS=DS
    NBIF=0
    IPOS=.TRUE.

    DO I=1,NDIM
       U(I)=0.d0
       UDOT(I)=0.d0
    ENDDO
    ! init P1 to identity matrix so that GETMDMX in support.f90 makes sense
    P1V(:,:)=0.d0
    DO I=1,NDIM+1
       P1V(I,I)=1.d0
    ENDDO

! Generate the starting point

    NODIR=1
    CALL STPNAEI(AP,PAR,ICP,U,UDOT,NODIR)
    CALL PVLI(AP,ICP,U,NDIM,PAR,FNCI)

! Determine a suitable starting label and branch number

    CALL NEWLAB(AP)

! Write constants

    CALL STHD(AP,ICP)

    DO NBFC=0,NBFCS !bifurcation switch loop

       DO I=1,AP%NTEST
          TEST(I)=0.d0
       ENDDO

       NTOT=0
       AP%NTOT=NTOT
       CALL INITSTOPCNTS(ISP,ILP,ITPST,STOPCNTS)
       ISTOP=.FALSE.
       NIT=1

       IF(IRS.EQ.0) THEN
          ITP=9+10*ITPST
       ELSE
          ITP=0
       ENDIF
       AP%ITP=ITP
       U(NDIM+1)=PAR(ICP(1))

! Starting procedure  (to get direction vector) :

       IF(NODIR==1.AND.ISW>=0)THEN
          CALL STPRAE(AP,PAR,ICP,FUNI,U,UDOT,THU,0,AA)
       ELSEIF(IRS/=0.AND.ISW<0)THEN
          CALL STPRAE(AP,PAR,ICP,FUNI,U,UDOT,THU,1,AA)
       ELSEIF(ABS(IPS)==1.OR.IPS==11)THEN
          CALL STPRAE(AP,PAR,ICP,FUNI,U,UDOT,THU,-1,AA)
       ENDIF
       IF(ABS(IPS)==1.OR.IPS==11)THEN
          ! Get stability
          TMP=FNCI(AP,ICP,U,NDIM,PAR,6,ATYPEDUM)
       ENDIF

! Store plotting data for first point on the bifurcating branch
! or for the starting point

       CALL PVLI(AP,ICP,U,NDIM,PAR,FNCI)
       CALL STPLAE(AP,PAR,ICP,ICU,U,UDOT,NIT,ISTOP)

       IF(.NOT.ISTOP)THEN

! Provide initial approximation to the second point on the branch and
! determine the second point on the bifurcating or original branch
          CALL STEPAE(AP,PAR,ICP,FUNI,RDS,AA,U,UDOT,THU,NIT,ISW<0)
          IF(NIT>0)CALL PVLI(AP,ICP,U,NDIM,PAR,FNCI)

          IF(ISW<0.OR.NIT==0)THEN
             IF(ABS(IPS)==1.OR.IPS==11)THEN
                ! Get stability
                TMP=FNCI(AP,ICP,U,NDIM,PAR,6,ATYPEDUM)
             ENDIF
             ! Store plotting data for second point :
             CALL PVLI(AP,ICP,U,NDIM,PAR,FNCI)
             CALL STPLAE(AP,PAR,ICP,ICU,U,UDOT,NIT,ISTOP)
          ENDIF
       ENDIF

       DO WHILE(.NOT.ISTOP) ! branch computation loop
          ITP=0
          AP%ITP=ITP
          NINS=AP%NINS

! Find the next solution point on the branch
          CALL STEPAE(AP,PAR,ICP,FUNI,RDS,AA,U,UDOT,THU,NIT)
          ISTOP=NIT==0
          IF(.NOT.ISTOP)THEN
             CALL PVLI(AP,ICP,U,NDIM,PAR,FNCI)
          ENDIF
          DSTEST=RDS

          IFOUND=0
          IF(ISTOP)THEN
             ISTEPPED=AP%NTEST+1
          ELSE
             ISTEPPED=0
             DO ITEST=1,AP%NTEST
                ! Check for special points
                CALL LCSPAE(AP,DSTEST,PAR,ICP,ITEST,FUNI,FNCI,AA,&
                     U,UDOT,TEST(ITEST),THU,IUZ,VUZ,NIT,ATYPE,STEPPED)
                IF(STEPPED)ISTEPPED=ITEST
                IF(LEN_TRIM(ATYPE)>0)THEN
                   IFOUND=ITEST
                   AP%ITP=LBITP(ATYPE,.FALSE.)
                   AP%ITP=AP%ITP+SIGN(10,AP%ITP)*ITPST
                ENDIF
             ENDDO
          ENDIF

          DO ITEST=1,ISTEPPED-1
             ! evaluate the test functions for the next step
             TEST(ITEST)=FNCS(AP,ICP,U,PAR,ATYPEDUM,IUZ,VUZ,ITEST,FNCI)
          ENDDO

          ITP=AP%ITP
          IF(ITP/=0)THEN
             IF(STOPPED(IUZ,IFOUND,NUZR,ITP,STOPCNTS))THEN
                ISTOP=.TRUE. ! *Stop at the first found bifurcation
             ENDIF
             IF(MOD(ITP,10)==1)THEN
                ! Check for branch point, and if so store data :
                CALL STBIF(NDIM,NBIF,NBIFS,STUD,STU,U,UDOT)
             ENDIF
             IF(MOD(ITP,10)/=-4)THEN
                ! for plotter: use stability of previous point
                ! for bifurcation points
                AP%NINS=NINS
             ENDIF
          ENDIF

! Store plotting data on unit 7 :

          NTOT=AP%NTOT
          CALL PVLI(AP,ICP,U,NDIM,PAR,FNCI)
          CALL STPLAE(AP,PAR,ICP,ICU,U,UDOT,NIT,ISTOP)

! Adapt the stepsize along the branch

          IF(IADS.NE.0 .AND. MOD(NTOT,IADS).EQ.0 &
               .AND. ( MOD(ITP,10).EQ.0 .OR. MOD(ITP,10).EQ.4) )THEN
             ITNW=AP%ITNW
             NTOP=MOD(NTOT-1,9999)+1
             DSMAX=AP%DSMAX
             CALL ADPTDS(NIT,ITNW,AP%IBR,NTOP,AP%IID,DSMAX,RDS)
             AP%RDS=RDS
          ENDIF
       ENDDO !from branch computation loop

       IF(NBIF==0.OR.NBFC>=NBFCS)EXIT

       ! Initialize computation of the next bifurcating branch.

       CALL SWPNT(AP,DS,PAR,ICP,RDS,NBIF,NBIFS,STUD,STU,U,UDOT,IPOS)

       IF(IPOS)THEN
          NBIF=NBIF-1
       ENDIF

       IF(.NOT.IPOS .OR. MXBF.LT.0 )AP%IBR=AP%IBR+1

       ! IRS and ISW are for internal use: don't store in AP!
       IRS=1
       ISW=-1
    ENDDO !from bifurcation switch loop

    DEALLOCATE(PAR,THL,THU,IUZ,VUZ,EVV,AA,P1V,U,UDOT,STUD,STU,TEST)
  END SUBROUTINE CNRLAE

! ---------- ------
  SUBROUTINE STPRAE(AP,PAR,ICP,FUNI,U,UDOT,THU,IPERP,AA)

    USE SUPPORT

! Finds the second point on the initial solution branch.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS) AP
    INTEGER ICP(*),IPERP
    DOUBLE PRECISION U(AP%NDIM+1),UDOT(AP%NDIM+1),THU(*),PAR(*)
    DOUBLE PRECISION AA(AP%NDIM+1,AP%NDIM+1)

! Local
    DOUBLE PRECISION, ALLOCATABLE :: AAA(:,:),F(:),UOLD(:),DFDU(:,:),DFDP(:,:)
    INTEGER NDIM,IID,NPAR,I,J
    DOUBLE PRECISION SS

    NDIM=AP%NDIM
    IID=AP%IID
    NPAR=AP%NPAR

    ALLOCATE(F(NDIM),UOLD(NDIM+1),DFDU(NDIM,NDIM),DFDP(NDIM,NPAR))
    UOLD(:)=U(:)
    DFDU(:,:)=0.d0
    DFDP(:,:)=0.d0

! Determine the direction of the branch at the starting point

    CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,2,F,DFDU,DFDP)

    IF(IPERP==1)THEN
       AA(:NDIM,:NDIM)=DFDU(:,:)
       AA(:NDIM,NDIM+1)=DFDP(:,ICP(1))
       AA(NDIM+1,:)=UDOT(:)
       IF(IID.GE.3)CALL WRJAC(NDIM+1,NDIM+1,AA,F)
       CALL NLVC(NDIM+1,NDIM+1,1,AA,UDOT)
    ELSEIF(IPERP==0)THEN
       ALLOCATE(AAA(NDIM,NDIM+1))
       AAA(:,1:NDIM)=DFDU(:,:)
       AAA(:,NDIM+1)=DFDP(:,ICP(1))
       IF(IID.GE.3)CALL WRJAC(NDIM,NDIM+1,AAA,F)
       CALL NLVC(NDIM,NDIM+1,1,AAA,UDOT)
       DEALLOCATE(AAA)
    ENDIF

! Scale and make sure that PAR(ICP(1))-dot is positive.
! If PAR(ICP(1))-dot is close to zero, then make sure
! that the first away-from-zero coordinate is positive.

    SS=0.d0
    DO I=1,NDIM+1
       SS=SS+THU(I)*UDOT(I)**2
    ENDDO
    UDOT(:)=UDOT(:)/SQRT(SS)

    IF(ABS(UDOT(NDIM+1))/(1.d0+ABS(U(NDIM+1)))>AP%EPSL)THEN
       IF(UDOT(NDIM+1)<0.d0)THEN
          UDOT(:)=-UDOT(:)
       ENDIF
    ELSE
       DO I=1,NDIM
          IF(I<AP%NFPR)THEN
             J=NDIM-AP%NFPR+I+1
          ELSE
             J=I-AP%NFPR+1
          ENDIF
          IF(ABS(UDOT(J))/(1.d0+ABS(U(J)))>AP%EPSU)THEN
             IF(UDOT(J)<0.d0)THEN
                UDOT(:)=-UDOT(:)
             ENDIF
             EXIT
          ENDIF
       ENDDO
    ENDIF

! Get the Jacobian for stability computation.
    AA(:NDIM,:NDIM)=DFDU(:,:)
    AA(:NDIM,NDIM+1)=DFDP(:,ICP(1))
    AA(NDIM+1,:)=UDOT(:)

    DEALLOCATE(F,DFDU,DFDP)

  END SUBROUTINE STPRAE

! ---------- ------
  SUBROUTINE STEPAE(AP,PAR,ICP,FUNI,RDS,AA,U,UDOT,THU,NIT,SW)

! This is the subroutine for computing solution branches. It solves
! the equations for finding the next point on the branch at distance RDS
! from the current point. RDS is adapted if there is no convergence.

! It also controls the computation of the second point on a bifurcating branch.
! This point is required to lie in a hyper-plane at distance DS from the
! branch point. This hyper-plane is parallel to the tangent of the
! known branch at the branch point.

    USE MESH
    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NIT
    DOUBLE PRECISION, INTENT(IN) :: THU(*)
    DOUBLE PRECISION, INTENT(OUT) :: AA(AP%NDIM+1,AP%NDIM+1)
    DOUBLE PRECISION, INTENT(INOUT) :: U(*),UDOT(*),PAR(*),RDS
    LOGICAL, OPTIONAL, INTENT(IN) :: SW
! Local
    INTEGER IADS,IID,ITNW,IBR,NTOT,NTOP
    LOGICAL BSW
    DOUBLE PRECISION DSMIN,DSMAX
    CHARACTER (LEN=7) FIXEDMINIMUM

    IADS=AP%IADS
    IID=AP%IID
    ITNW=AP%ITNW
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    DSMIN=AP%DSMIN
    DSMAX=AP%DSMAX

    BSW=.FALSE.
    IF(PRESENT(SW))BSW=SW
    
    DO
       CALL SOLVAE(AP,PAR,ICP,FUNI,RDS,AA,U,UDOT,THU,NIT,BSW)
       IF(NIT>0)RETURN

! Maximum number of iterations has been reached.

       IF(IADS.EQ.0)EXIT

! Reduce stepsize and try again.

       CALL ADPTDS(ITNW,ITNW,IBR,NTOP,IID,DSMAX,RDS)
       AP%RDS=RDS
       IF(ABS(RDS).LT.DSMIN)EXIT
       IF(IID.GE.2)THEN
          WRITE(9,"(I4,I6,A)")IBR,NTOP,' NOTE:Retrying step'
       ENDIF
    ENDDO

! Minimum stepsize reached.

    IF(IADS==0)THEN
       FIXEDMINIMUM='fixed'
    ELSE
       FIXEDMINIMUM='minimum'
    ENDIF
    IF(IID>0)THEN
       IF(BSW)THEN
          WRITE(9,"(I4,I6,A,A,A)")&
               IBR,NTOP,' NOTE:No convergence when switching branches with ',&
               FIXEDMINIMUM,' step size'
       ELSE
          WRITE(9,"(I4,I6,A,A,A)")&
               IBR,NTOP,' NOTE:No convergence with ',FIXEDMINIMUM,' step size'
       ENDIF
    ENDIF
  END SUBROUTINE STEPAE

! ---------- ------
  SUBROUTINE SOLVAE(AP,PAR,ICP,FUNI,RDS,AA,U,UDOT,THU,NIT,BSW)

! This subroutine contains the main predictor-corrector loop
! Input: U, UDOT, PAR : extended solution
!        RDS: step-size
!        AP AP ICP, THU, FUNI: constants & function interface
!        BSW: if true, switch branches, else do normal continuation
! Output: NIT: number of iterations taken to converge
!         after successful convergence (NIT>0):
!           AP%DET contains the determinant 
!           AA contains the extended Jacobian matrix
!           U, UDOT, PAR are updated
!         else (NIT==0):
!           U, UDOT, PAR are not updated

    USE IO
    USE SUPPORT

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NIT
    LOGICAL, INTENT(IN) :: BSW
    DOUBLE PRECISION, INTENT(IN) :: RDS,THU(*)
    DOUBLE PRECISION, INTENT(OUT) :: AA(AP%NDIM+1,AP%NDIM+1)
    DOUBLE PRECISION, INTENT(INOUT) :: U(AP%NDIM+1),UDOT(AP%NDIM+1),PAR(*)

! Local
    INTEGER NDIM,IID,ITNW,IBR,NTOT,NTOP,NIT1,NPAR,I,K,NDM
    LOGICAL CONVERGED
    DOUBLE PRECISION, ALLOCATABLE :: RHS(:),DU(:), &
         DFDU(:,:),DFDP(:,:),UOLD(:)
    DOUBLE PRECISION EPSL,EPSU,SS,UMX,DUMX,RDRLM,RDUMX,DELREF,ADU,AU,DET
    CHARACTER (LEN=*), PARAMETER :: O9 = & 
     "(' Branch ',I2,' N=',I5,1X,'IT=',I2,1X,'PAR(',I2,')=', &
        &ES11.3,1X,'U=',7ES11.3)"

    NDIM=AP%NDIM
    IID=AP%IID
    ITNW=AP%ITNW
    NDM=AP%NDM
    IBR=AP%IBR
    NPAR=AP%NPAR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    EPSL=AP%EPSL
    EPSU=AP%EPSU

    ALLOCATE(RHS(NDIM+1),DU(NDIM+1),DFDU(NDIM,NDIM),DFDP(NDIM,NPAR))
    DFDU(:,:)=0.d0
    DFDP(:,:)=0.d0

    ALLOCATE(UOLD(NDIM+1))
    UOLD(:)=U(:)
    U(:)=UOLD(:)+RDS*UDOT(:)

! Write additional output on unit 9 if requested :

    IF(IID.GE.2)THEN
       CALL WRBAR("=",47)
       IF(BSW)THEN
          WRITE(9,O9)IBR,NTOP,0,ICP(1), &
               U(NDIM+1),(U(I),I=1,MIN(NDIM,6))
       ELSE
          WRITE(9,100)
          WRITE(9,101)IBR,NTOP+1,0,U(NDIM+1),RNRMV(NDM,U)
100       FORMAT(/,'  BR    PT  IT         PAR',11X,'L2-NORM')
101       FORMAT(I4,I6,I4,5X,2ES14.5)
       ENDIF
    ENDIF

! Call user-supplied FUNC to evaluate the right hand side of the
! differential equation and its derivatives :

    CONVERGED=.FALSE.
    DELREF=0
    DO NIT1=1,ITNW

       NIT=NIT1
       PAR(ICP(1))=U(NDIM+1)
       CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,2,RHS,DFDU,DFDP)

! Set up the Jacobian matrix and the right hand side :

       DO I=1,NDIM
          AA(I,NDIM+1)=DFDP(I,ICP(1))
          RHS(I)=-RHS(I)
          DO K=1,NDIM
             AA(I,K)=DFDU(I,K)
          ENDDO
       ENDDO
       SS=0.d0
       IF(BSW)THEN
          ! Branch switch
          DO K=1,NDIM+1
             AA(NDIM+1,K)=THU(K)*UDOT(K)
             SS=SS+THU(K)*(U(K)-UOLD(K)-RDS*UDOT(K))*UDOT(K)
          ENDDO
          RHS(NDIM+1)=-SS
       ELSE
          DO K=1,NDIM+1
             AA(NDIM+1,K)=2.d0*THU(K)*(U(K)-UOLD(K))/RDS
             SS=SS+THU(K)*(U(K)-UOLD(K))**2
          ENDDO
          RHS(NDIM+1)=RDS-SS/RDS
       ENDIF

! Use Gauss elimination with pivoting to solve the linearized system :

       IF(IID.GE.5)CALL WRJAC(NDIM+1,NDIM+1,AA,RHS)
       CALL GEL(NDIM+1,AA,1,DU,RHS,DET)
       AP%DET=DET

! Add the Newton increments :

       DO I=1,NDIM+1
          U(I)=U(I)+DU(I)
       ENDDO
       DUMX=0.d0
       UMX=0.d0
       DO I=1,NDIM
          ADU=ABS(DU(I))
          AU=ABS(U(I))
          IF(AU>UMX)UMX=AU
          IF(ADU>DUMX)DUMX=ADU
       ENDDO

       IF(IID.GE.2)THEN
          IF(BSW)THEN
             WRITE(9,O9)IBR,NTOP,NIT,ICP(1),U(NDIM+1),(U(I),I=1,MIN(NDIM,6))
          ELSE
             WRITE(9,101)IBR,NTOP+1,NIT,U(NDIM+1),RNRMV(NDM,U)
          ENDIF
       ENDIF

! Check whether relative error has reached user-supplied tolerance :

       RDRLM=ABS(DU(NDIM+1))/(1.d0+ABS(U(NDIM+1)))
       RDUMX=DUMX/(1.d0+UMX)
       IF(RDRLM.LE.EPSL.AND.RDUMX.LE.EPSU)THEN
! Recompute Jacobian for test functions
          PAR(ICP(1))=U(NDIM+1)
          CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,2,RHS,DFDU,DFDP)
          DO I=1,NDIM
             AA(I,NDIM+1)=DFDP(I,ICP(1))
             DO K=1,NDIM
                AA(I,K)=DFDU(I,K)
             ENDDO
          ENDDO
          DO K=1,NDIM+1
             AA(NDIM+1,K)=UDOT(K)
          ENDDO
          IF(IID.GE.2)WRITE(9,*)
! This subroutine determines an initial approximation to the next
! solution on a branch by extrapolating from the two preceding points.
          UDOT(:)=(U(:)-UOLD(:))/RDS
          CONVERGED=.TRUE.
          EXIT
       ENDIF

       IF(.NOT.BSW)THEN
          IF(NIT.EQ.1)THEN
             DELREF=20*MAX(RDRLM,RDUMX)
          ELSE
             IF(MAX(RDRLM,RDUMX).GT.DELREF)EXIT
          ENDIF
       ENDIF

    ENDDO
    IF(.NOT.CONVERGED)THEN
       DO I=1,NDIM+1
          U(I)=UOLD(I)
       ENDDO
       PAR(ICP(1))=U(NDIM+1)
       NIT=0
    ENDIF
    DEALLOCATE(RHS,DU,DFDU,DFDP,UOLD)

  END SUBROUTINE SOLVAE
!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!               Detection of Singular Points
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
! ---------- ------
  SUBROUTINE LCSPAE(AP,DSTEST,PAR,ICP,ITEST,FUNI,FNCI,AA, &
       U,UDOT,Q,THU,IUZ,VUZ,NIT,ATYPE,STEPPED)

    USE SUPPORT

    DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

! This subroutine uses the secant method to accurately locate special
! points (branch points, folds, Hopf bifurcations, user zeroes).
! These are characterized as zeroes of the function FNCS.
! This subroutine calls CONT and STEPAE with varying stepsize RDS.
! The special point is assumed to have been found with sufficient
! accuracy if the ratio between RDS and the user supplied value of
! DS is less than the user-supplied toler EPSS.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),IUZ(*),ITEST
    INTEGER, INTENT(INOUT) :: NIT
    DOUBLE PRECISION, INTENT(IN) :: THU(*),VUZ(*)
    DOUBLE PRECISION, INTENT(INOUT) :: DSTEST,Q
    DOUBLE PRECISION, INTENT(INOUT) :: AA(AP%NDIM+1,AP%NDIM+1) 
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*),U(AP%NDIM+1)
    DOUBLE PRECISION, INTENT(INOUT) :: UDOT(AP%NDIM+1)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    LOGICAL, INTENT(OUT) :: STEPPED

    INTEGER I,IID,ITMX,IBR,ITLCSP,NTOT,NITS
    DOUBLE PRECISION DS,DSMAX,EPSS,Q0,Q1,DQ,S0,S1,RDS,RRDS
    DOUBLE PRECISION DETS,DSTESTS
    DOUBLE PRECISION, ALLOCATABLE :: US(:),UDOTS(:),AAS(:,:)
    CHARACTER(4) ATYPEDUM

    IID=AP%IID
    ITMX=AP%ITMX
    IBR=AP%IBR
    NTOT=AP%NTOT

    DS=AP%DS
    DSMAX=AP%DSMAX
    EPSS=AP%EPSS

    STEPPED=.FALSE.

! Check whether FNCS has changed sign.

    Q0=Q
    Q1=FNCS(AP,ICP,U,PAR,ATYPE,IUZ,VUZ,ITEST,FNCI)
    ! disable detected potential bifurcations without stability changes
    I=LEN_TRIM(ATYPE)
    IF(I>0)THEN
       IF(ATYPE(I:I)=='0')ATYPE=''
    ENDIF

    IF(AP%ITP/=0.AND.ABS((1.d0+HMACH)*Q1*DSTEST) < &
         EPSS*(1+SQRT(ABS(DS*DSMAX)))*ABS(Q0-Q1))THEN
       ! there could be multiple test functions going through zero
       ! at a point, for instance CP/LP and BP/CP.
       ! In general, use "first come, first served", but
       ! bifurcations override UZ, and CP overrides LP.
       IF((MOD(AP%ITP,10)==-4.AND.LEN_TRIM(ATYPE)>0.AND.TRIM(ATYPE)/='UZ').OR. &
          (AP%ITP==22.AND.TRIM(ATYPE)=='CP'))THEN
          Q=0.d0
          IF(IID>0)WRITE(9,102)RDS
          RETURN
       ENDIF
       Q1=0.d0
    ENDIF

    ! do not test via Q0*Q1 to avoid overflow.
    IF((Q0>=0.AND.Q1>=0) .OR. (Q0<=0.AND.Q1<=0) .OR. LEN_TRIM(ATYPE)==0)THEN
       ATYPE=''
       Q=Q1
       RETURN
    ENDIF

! Use the secant method for the first step:

    S0=0.d0
    S1=DSTEST
    DQ=Q0-Q1
    RDS=Q1/DQ*(S1-S0)

    RDS=(1.d0+HMACH)*RDS

! Return if relative tolerance has been met :

    RRDS=ABS(RDS)/(1+SQRT(ABS(DS*DSMAX)))
    IF(RRDS.LT.EPSS)THEN
       Q=0.d0
       IF(IID>0)WRITE(9,102)RDS
       RETURN
    ENDIF

    ALLOCATE(US(AP%NDIM+1),UDOTS(AP%NDIM+1),AAS(AP%NDIM+1,AP%NDIM+1))
    ! save state to restore in case of non-convergence or
    ! "possible special point"
    US(:)=U(:)
    UDOTS(:)=UDOT(:)
    AAS(:,:)=AA(:,:)
    DETS=AP%DET
    DSTESTS=DSTEST
    NITS=NIT

    DO ITLCSP=0,ITMX

! If requested write additional output on unit 9 :

       IF(IID.GE.2)THEN
          WRITE(9,101)ITLCSP,RDS
       ENDIF

       CALL STEPAE(AP,PAR,ICP,FUNI,RDS,AA,U,UDOT,THU,NIT)
       IF(NIT==0)EXIT

       STEPPED=.TRUE.

       CALL PVLI(AP,ICP,U,AP%NDIM,PAR,FNCI)

       Q=FNCS(AP,ICP,U,PAR,ATYPE,IUZ,VUZ,ITEST,FNCI)
       ! ignore stability changes
       I=LEN_TRIM(ATYPE)
       IF(ATYPE(I:I)=='0')ATYPE=ATYPE(1:I-1)

!        Use Mueller's method with bracketing for subsequent steps
       DSTEST=S1+RDS
       CALL MUELLER(Q0,Q1,Q,S0,S1,DSTEST,RDS)

       RDS=(1.d0+HMACH)*RDS

! Return if relative tolerance has been met :

       RRDS=ABS(RDS)/(1+SQRT(ABS(DS*DSMAX)))
       IF(RRDS.LT.EPSS)THEN
          Q=0.d0
          IF(IID>0)WRITE(9,102)RDS
          DEALLOCATE(US,UDOTS,AAS)
          STEPPED=.TRUE.
          RETURN
       ENDIF

    ENDDO

    IF(IID>0)WRITE(9,103)IBR,MOD(NTOT-1,9999)+1
    ATYPE=''
    ! set back to previous (converged) state
    U(:)=US(:)
    UDOT(:)=UDOTS(:)
    AA(:,:)=AAS(:,:)
    DO I=1,AP%NFPR
       PAR(ICP(I))=U(AP%NDIM+2-I)
    ENDDO
    AP%DET=DETS
    NIT=NITS
    DSTEST=DSTESTS
    CALL PVLI(AP,ICP,U,AP%NDIM,PAR,FNCI)
    Q=FNCS(AP,ICP,U,PAR,ATYPEDUM,IUZ,VUZ,ITEST,FNCI)
    DEALLOCATE(US,UDOTS,AAS)

101 FORMAT(' ==> Location of special point :  Iteration ',I3, &
         '  Step size = ',ES13.5)
102 FORMAT(' ==> Location of special point : ', &
         ' Convergence.   Step size = ',ES13.5)
103 FORMAT(I4,I6,' NOTE:Possible special point')
  END SUBROUTINE LCSPAE

!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                   Branch Switching for Algebraic Problems
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
! ---------- -----
  SUBROUTINE STBIF(NDIM,NBIF,NBIFS,STUD,STU,U,UDOT)

    USE SUPPORT

! Stores branching data in the following arrays :
!        STU    ( the solution vector U | PAR(ICP(1)) )
!        STUD   ( U-dot | PAR(ICP(1))-dot )
! Here the vector ( U-dot, PAR(ICP(1))-dot ) is the direction vector of
! known branch at this point.

    INTEGER, INTENT(IN) :: NDIM,NBIFS
    INTEGER, INTENT(INOUT) :: NBIF
    DOUBLE PRECISION, INTENT(OUT) :: STUD(NBIFS,NDIM+1),STU(NBIFS,NDIM+1)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM+1),UDOT(NDIM+1)

! Keep track of the number of branch points stored.

    IF(NBIF==NBIFS)RETURN
    NBIF=NBIF+1

    STU(NBIF,:)=U(:)
    STUD(NBIF,:)=UDOT(:)

  END SUBROUTINE STBIF

! ---------- -----
  SUBROUTINE SWPNT(AP,DS,PAR,ICP,RDS,NBIF,NBIFS,STUD,STU,U,UDOT,IPOS)

! This subroutine retrieves the branching data U, U-dot, PAR(ICP(1)),
! PAR(ICP(1))-dot. If this initialization corresponds to the computation
! of the bifurcating branch in opposite direction, then only the sign of
!  the stepsize ( DS ) along the branch is reversed.

    TYPE(AUTOPARAMETERS) AP
    INTEGER ICP(*)
    INTEGER, INTENT(IN) :: NBIF,NBIFS
    DOUBLE PRECISION, INTENT(IN) :: DS
    DOUBLE PRECISION, INTENT(OUT) :: RDS
    DOUBLE PRECISION PAR(*),U(*),UDOT(*),STUD(NBIFS,*),STU(NBIFS,*)
    LOGICAL IPOS

    INTEGER NDIM,ISW,MXBF,I,I1

    NDIM=AP%NDIM
    ISW=AP%ISW
    MXBF=AP%MXBF

    RDS=DS
    IF(.NOT.IPOS)RDS=-DS
    DO I=1,NDIM+1
       U(I)=STU(1,I)
       UDOT(I)=STUD(1,I)
    ENDDO
    PAR(ICP(1))=U(NDIM+1)
    IF(ABS(ISW).EQ.2)PAR(ICP(2))=U(NDIM)

    IF(MXBF.GE.0)THEN
       IPOS=.NOT.IPOS
    ENDIF
    IF(.NOT.IPOS)RETURN

    DO I=1,NBIF-1
       DO I1=1,NDIM+1
          STU(I,I1)=STU(I+1,I1)
          STUD(I,I1)=STUD(I+1,I1)
       ENDDO
    ENDDO

  END SUBROUTINE SWPNT

! ---------- ------
  SUBROUTINE STPLAE(AP,PAR,ICP,ICU,U,UDOT,NIT,ISTOP)

    USE IO
    USE SUPPORT

! Stores the bifurcation diagram on unit 7 (Algebraic Problems).
! Every line written contains, in order, the following:
!
!  IBR    : The label of the branch.
!  NTOT   : The index of the point on the branch.
!           (Points are numbered consecutively along a branch).
!           If IPS=1, 11, or -1, then the sign of NTOT indicates stability :
!            - = stable , + = unstable, unknown, or not relevant.
!  ITP    : An integer indicating the type of point :
!
!             1  (BP)  :   Branch point.
!             2  (LP)  :   Fold.
!             3  (HB)  :   Hopf bifurcation point.
!             4  (  )  :   Output point (Every NPR steps along branch).
!            -4  (UZ)  :   Output point (Zero of user function).
!             9  (EP)  :   End point of branch, normal termination.
!            -9  (MX)  :   End point of branch, abnormal termination.
!
!  LAB        : The label of a special point.
!  PAR(ICP(1)): The principal parameter.
!  A          : The L2-norm of the solution vector, or other measure of
!               the solution (see the user-supplied parameter IPLT).
!  U          : The first few components of the solution vector.
!  PAR(ICP(*)): Further free parameters (if any).
!
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ICU(*),NIT
    DOUBLE PRECISION, INTENT(IN) :: U(*),UDOT(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    LOGICAL, INTENT(INOUT) :: ISTOP

    INTEGER NDIM,IPS,ISW,IPLT,NMX,NPR,NDM,ITP,ITPST,IBR
    INTEGER NTOT,NTOTS,IAB,LABW,NINS
    DOUBLE PRECISION RL0,RL1,A0,A1,AMP

    NDIM=AP%NDIM
    IPS=AP%IPS
    ISW=AP%ISW
    IPLT=AP%IPLT
    NMX=AP%NMX
    NPR=AP%NPR
    NDM=AP%NDM
    ITP=AP%ITP
    ITPST=AP%ITPST
    IBR=AP%IBR

    RL0=AP%RL0
    RL1=AP%RL1
    A0=AP%A0
    A1=AP%A1

    NTOT=AP%NTOT
    NTOT=NTOT+1
    AP%NTOT=NTOT

! ITP is set to 4 every NPR steps along a branch, and the entire
! solution is written on unit 8.

    IF(NPR.NE.0)THEN
       IF(MOD(NTOT,NPR).EQ.0 .AND. MOD(ITP,10).EQ.0)ITP=4+10*ITPST
       AP%ITP=ITP
    ENDIF

! CHECK WHETHER LIMITS OF THE BIFURCATION DIAGRAM HAVE BEEN REACHED :

    IAB=ABS(IPLT)

    IF(IAB.LE.NDIM .AND. IAB.GT.0)THEN
       AMP=U(IAB)
    ELSE IF(IPLT.GT.NDIM.AND.IPLT.LE.2*NDIM)THEN
       AMP=U(IPLT-NDIM)
    ELSE IF(IPLT.GT.2*NDIM.AND.IPLT.LE.3*NDIM)THEN
       AMP=U(IPLT-2*NDIM)
    ELSE
       AMP=RNRMV(NDM,U)
    ENDIF

    IF(NIT==0)THEN
!        Maximum number of iterations reached somewhere.
       ISTOP=.TRUE.
       ITP=-9-10*ITPST
       AP%ITP=ITP
    ELSEIF(U(NDIM+1).LT.RL0.OR.U(NDIM+1).GT.RL1 &
         .OR. AMP.LT.A0.OR.AMP.GT.A1 &
         .OR. NTOT.EQ.NMX) THEN
       ISTOP=.TRUE.
       ITP=9+10*ITPST
       AP%ITP=ITP
    ENDIF

    LABW=0
    IF(MOD(ITP,10).NE.0)THEN
       LABW=AP%LAB
    ENDIF

! Determine stability and print output on units 6 and 7.

    NTOTS=NTOT
    NINS=AP%NINS
    IF((ABS(IPS)==1.OR.IPS==11) .AND. ABS(ISW)<=1)THEN
       IF(NINS.EQ.NDIM)NTOTS=-NTOT
    ENDIF
    CALL WRLINE(AP,PAR,ICU,IBR,NTOTS,LABW,AMP,U)

! Write restart information for multi-parameter analysis :

    IF(LABW.NE.0)THEN
       CALL WRTSP8(AP,PAR,ICP,LABW,U,UDOT)
       AP%LAB=AP%LAB+1
    ENDIF
!
  END SUBROUTINE STPLAE

! ---------- ------
  SUBROUTINE WRTSP8(AP,PAR,ICP,LAB,U,UDOT)

    USE COMPAT
    USE SUPPORT, ONLY: DIRECTION
    USE AUTO_CONSTANTS, ONLY: IPS, NDIMU => NDIM

! Write restart information on singular points, plotting points, etc.,
! on unit 8.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),LAB
    DOUBLE PRECISION, INTENT(IN) :: U(*),UDOT(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

    INTEGER NDIM,ISW,ITP,IBR,NFPR,NPAR,NTOT,NROWPR,MTOT,NAR,NTPL,I,K
    INTEGER NPARI,NTST
    DOUBLE PRECISION T
    LOGICAL DIR

    NDIM=AP%NDIM
    ISW=AP%ISW
    NPARI=AP%NPARI
    ITP=AP%ITP
    IBR=AP%IBR
    NFPR=AP%NFPR
    NPAR=AP%NPAR
    NTOT=AP%NTOT

    NTPL=1
    NAR=NDIM+1

! skip direction info based on IIS and ITP
    DIR=DIRECTION(AP%IIS,ITP)
    NROWPR=NDIM/7 + 1 + (NPAR+6)/7
    NTST=0
    IF(DIR)THEN
       NROWPR=NROWPR + (NFPR+19)/20 + (NFPR+6)/7 + (NDIM+6)/7
       NTST=1
    ENDIF
    PAR(ICP(1))=U(NDIM+1)
    T=0.d0

    MTOT=MOD(NTOT-1,9999)+1
    WRITE(8,101)IBR,MTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,0,NPAR,&
         NPARI,NDIMU,IPS,0
    WRITE(8,102)T,(U(I),I=1,NDIM)
    IF(DIR)THEN
! Write the free parameter indices:
       WRITE(8,103)(ICP(I),I=1,NFPR)
! Write the direction of the branch:
       WRITE(8,102)UDOT(NDIM+1),(UDOT(NDIM-NFPR+I),I=2,NFPR)
       WRITE(8,102)(UDOT(K),K=1,NDIM)
    ENDIF
! Write the parameter values.
    WRITE(8,102)(PAR(I),I=1,NPAR)

101 FORMAT(6I6,I8,I6,I8,7I5)
102 FORMAT(4X,7ES19.10E3)
103 FORMAT(20I5)

    CALL AUTOFLUSH(8)
  END SUBROUTINE WRTSP8

! ---------- ------
  SUBROUTINE WRJAC(M,N,AA,RHS)

    INTEGER, INTENT(IN) :: M,N
    DOUBLE PRECISION, INTENT(IN) :: AA(M,N),RHS(M)
    INTEGER I,J

    WRITE(9,"(A)")' Residual vector :'
    WRITE(9,"(1X,12E10.3)")RHS(:),(0d0,I=M+1,N)
    WRITE(9,"(A)")' Jacobian matrix :'
    DO I=1,M
       WRITE(9,"(1X,12E10.3)")(AA(I,J),J=1,N)
    ENDDO
    DO I=M+1,N
       WRITE(9,"(1X,12E10.3)")(0d0,J=1,N)
    ENDDO

  END SUBROUTINE WRJAC

END MODULE AE

!==============================================================================
!==============================================================================
!      Utility Program for ``doubling'' solutions in an AUTO q.xxx file
!==============================================================================
!==============================================================================
!
PROGRAM DOUBLE
  IMPLICIT NONE
!
  DOUBLE PRECISION, ALLOCATABLE :: TM(:),RLDOT(:),PAR(:),U(:,:)
  INTEGER, ALLOCATABLE :: ICP(:)
  LOGICAL OLD
  CHARACTER(100) LINE
  DOUBLE PRECISION, PARAMETER :: EPS = 1d-16
  INTEGER I,J,L,IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL,NTPL1,NROWPRSMALL
  INTEGER NAR,NROWPR,NROWPR1,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
!
  L=0
  OPEN(28,FILE='fort.28',STATUS='old',ACCESS='sequential')
  OPEN(38,FILE='fort.38',STATUS='unknown',ACCESS='sequential')
1 CONTINUE
  READ(28,'(A)',END=99)LINE
  IF (LEN_TRIM(LINE) <= 73) THEN
     READ(LINE,*)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL, &
          NAR,NROWPR,NTST,NCOL,NPAR
     OLD=.TRUE.
  ELSE
     READ(LINE,*)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL, &
          NAR,NROWPR,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
     OLD=.FALSE.
  ENDIF
  NROWPRSMALL=((NAR-1)/7+1)*NTPL + (NPAR+6)/7
  IF(NTPL.EQ.1)THEN
     NTPL1=NTPL
     NROWPR1=NROWPR
  ELSE
     NTST=2*NTST
     NTPL1=2*NTPL-1
     NROWPR1=NROWPR+NTPL-1
     IF(NTST.NE.0.AND.NROWPR.GT.NROWPRSMALL)THEN
        NROWPR1=NROWPR1+NTPL-1
     ENDIF
  ENDIF
  IF(OLD)THEN
     WRITE(38,101)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL1, &
          NAR,NROWPR1,NTST,NCOL,NPAR
  ELSE
     WRITE(38,111)IBR,NTOT,ITP,LAB,NFPR,ISW,NTPL1, &
          NAR,NROWPR1,NTST,NCOL,NPAR,NPARI,NDM,IPS,IPRIV
  ENDIF
  ALLOCATE(TM(NTPL),U(NTPL,NAR-1))
  DO J=1,NTPL
     READ(28,*) TM(J),(U(J,I),I=1,NAR-1) 
     WRITE(38,102)TM(J)/2,(U(J,I),I=1,NAR-1)
  ENDDO
  IF(NTPL.GT.1)THEN
     DO J=2,NTPL
        WRITE(38,102)(1+TM(J))/2, &
             (U(J,I)+U(NTPL,I)-U(1,I),I=1,NAR-1)
     ENDDO
  ENDIF
  IF(NTST.NE.0.AND.NROWPR.GT.NROWPRSMALL)THEN
     ALLOCATE(RLDOT(NPAR),ICP(NPAR))
     READ(28,*) (ICP(I),I=1,NFPR)
     WRITE(38,103)(ICP(I),I=1,NFPR)
     READ(28,*) (RLDOT(I),I=1,NFPR)
     WRITE(38,102)(RLDOT(I),I=1,NFPR)
     DO J=1,NTPL
        READ(28,*) (U(J,I),I=1,NAR-1) 
        WRITE(38,102)(U(J,I),I=1,NAR-1)
     ENDDO
     IF(NTPL.GT.1)THEN
        DO J=2,NTPL
           WRITE(38,102)(U(J,I),I=1,NAR-1)
        ENDDO
     ENDIF
     DEALLOCATE(RLDOT,ICP)
  ENDIF
  ALLOCATE(PAR(NPAR))
  READ(28,*) (PAR(I),I=1,NPAR)
  IF(NTPL.GT.1)THEN
     PAR(11)=2*PAR(11)
  ENDIF
  WRITE(38,102)(PAR(I),I=1,NPAR)
  DEALLOCATE(PAR,TM,U)
  GOTO 1

101 FORMAT(6I6,I8,I6,I8,3I5)
111 FORMAT(6I6,I8,I6,I8,7I5)
102 FORMAT(4X,7ES19.10E3)
103 FORMAT(20I5)

99 STOP
END PROGRAM DOUBLE
!==============================================================================
!==============================================================================

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!          Parabolic PDEs
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

MODULE PARABOLIC

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
  USE INTERFACES
  USE EQUILIBRIUM
  USE PERIODIC
  USE AE
  USE TOOLBOXAE
  USE BVP
  USE TOOLBOXBV
  USE SUPPORT

  IMPLICIT NONE
  PRIVATE

  PUBLIC :: AUTOPE

CONTAINS


!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!          Travelling Wave Solutions to Parabolic PDEs
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ------
  SUBROUTINE AUTOPE(AP,ICP,ICU)

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(INOUT) :: ICP(:)
    INTEGER, INTENT(IN) :: ICU(:)

    INTEGER IPS, ISW, ITP, NDM, NDIM
    IPS = AP%IPS
    ISW = AP%ISW
    ITP = AP%ITP
    NDIM = AP%NDIM

! Redefinition for waves
    NDIM = 2*NDIM
    AP%NDIM = NDIM
    IF(IPS==11.OR.IPS==12)THEN
       NDM=NDIM
       AP%NDM=NDM
    ELSEIF(IPS==14.OR.IPS==16.OR.IPS==17)THEN
       ! **Evolution calculations for Parabolic Systems
       ! **Stationary calculations for Parabolic Systems
       AP%NBC=NDIM
       AP%NINT=0
       AP%NFPR=1
       IF(IPS/=17)THEN
          AP%ILP=0
          AP%ISP=0
          ICP(1)=14
       ENDIF
    ENDIF

    SELECT CASE(IPS)
    CASE(11)
       ! ** Waves : Spatially homogeneous solutions
       CALL INITEQ(AP)
       IF(ABS(ISW)==1 ) THEN   
          CALL AUTOAE(AP,ICP,ICU,FNWS,STPNAE,FNCSWS)
       ELSEIF(ABS(ISW)==2)THEN
          IF(ITP==2.OR.ITP==7.OR.ABS(ITP)/10==2.OR.ABS(ITP)/10==7) THEN
             ! ** Fold/PD continuation.
             CALL AUTOAE(AP,ICP,ICU,FNWL,STPNWL,FNCSWS)
          ELSEIF(ITP==3.OR.ITP==8.OR.ABS(ITP)/10==3.OR.ABS(ITP)/10==8)THEN
             ! ** Hopf/Neimark-Sacker bifurcation continuation.
             CALL AUTOAE(AP,ICP,ICU,FNHW,STPNHW,FNCSWS)
          ENDIF
       ENDIF
    CASE(12) 
       ! ** Wave train solutions to parabolic systems.
       CALL INITPS(AP,ICP)
       IF(ABS(ISW)<=1) THEN
          CALL AUTOBV(AP,ICP,ICU,FNWP,BCPS,ICPS,STPNPS,FNCSPS)
       ELSE IF(ABS(ISW)==2) THEN
          IF(ITP==5) THEN 
             ! ** Fold continuation (start).
             CALL AUTOBV(AP,ICP,ICU,FNWPL,BCPL,ICPL,STPNPL,FNCSPS)
          ELSE IF(ABS(ITP)/10==5) THEN
             ! ** Fold continuation (restart).
             CALL AUTOBV(AP,ICP,ICU,FNWPL,BCPL,ICPL,STPNBV,FNCSPS)
          ENDIF
       ENDIF
    CASE(14) 
       ! ** Evolution calculations for parabolic systems.
       !    (Periodic boundary conditions.)
       CALL AUTOBV(AP,ICP,ICU,FNPE,BCPS,ICPE,STPNBV,FNCSPE)
    CASE(16)
       ! ** Evolution calculations for parabolic systems.
       !    (User supplied boundary conditions.)
       CALL AUTOBV(AP,ICP,ICU,FNPE,BCNI,ICPE,STPNBV,FNCSPE)
    CASE(17)
       ! ** Continuation of stationary states of parabolic systems.
       !    (User supplied boundary conditions.)
       CALL AUTOBV(AP,ICP,ICU,FNSP,BCNI,ICPE,STPNBV,FNCSBV)
    END SELECT
  END SUBROUTINE AUTOPE

! ---------- ----
  SUBROUTINE FNWS(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Sets up equations for the continuation of spatially homogeneous
    ! solutions to parabolic systems, for the purpose of finding
    ! bifurcations to travelling wave solutions.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    INTEGER NDM,I,J
    DOUBLE PRECISION C

    ! Generate the function.

    NDM=AP%NDM/2

    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    C=PAR(10)
    DO I=1,NDM
       F(NDM+I)=-( C*U(NDM+I) + F(I) )/PAR(14+I)
       F(I)=U(NDM+I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    DO I=1,NDM
       DO J=1,NDM
          DFDU(I+NDM,J)    =-DFDU(I,J)/PAR(14+I)
          DFDU(I,J)        =0.d0
          DFDU(I,J+NDM)    =0.d0
          DFDU(I+NDM,J+NDM)=0.d0
       ENDDO
       DFDU(I,I+NDM)     =1
       DFDU(I+NDM,I+NDM)=-C/PAR(14+I)
    ENDDO

    IF(IJAC.EQ.1)RETURN

    CALL EXPANDJAC(DFDP,AP%NPAR,NDM,NDIM)
    DO I=1,NDM
       IF(ICP(1)/=10)THEN
          DFDP(I+NDM,ICP(1))=-DFDP(I,ICP(1))/PAR(14+I)
          DFDP(I,ICP(1))    =0.d0
       ENDIF
       IF(AP%NFPR>1.AND.ICP(2)/=10)THEN
          DFDP(I+NDM,ICP(2))=-DFDP(I,ICP(2))/PAR(14+I)
          DFDP(I,ICP(2))    =0.d0
       ENDIF
    ENDDO

    ! Derivative with respect to the wave speed.

    DO I=1,NDM
       DFDP(I,10)    =0.d0
       DFDP(I+NDM,10)=-U(NDM+I)/PAR(14+I)
    ENDDO

    ! Derivatives with respect to the diffusion coefficients.

    DO J=1,NDM
       DO I=1,NDM
          DFDP(I,14+J)    =0.d0
          DFDP(I+NDM,14+J)=0.d0
       ENDDO
       DFDP(J+NDM,14+J)=-F(J+NDM)/PAR(14+J)
    ENDDO

  END SUBROUTINE FNWS

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSWS(AP,ICP,U,NDIM,PAR,ITEST,ATYPE) RESULT(Q)

    USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: U(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    Q=FNCSEQF(AP,ICP,U,NDIM,PAR,ITEST,ATYPE,FNWS)

  END FUNCTION FNCSWS

! ---------- ----
  SUBROUTINE FNWL(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-par continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNLPF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNWS)

  END SUBROUTINE FNWL

! ---------- -------
  SUBROUTINE STPNWL(AP,PAR,ICP,U,UDOT,NODIR)

    USE IO
    USE SUPPORT

    ! Generates starting data for the continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNLPF(AP,PAR,ICP,U,UDOT,NODIR,FNWS)

  END SUBROUTINE STPNWL

! ---------- ----
  SUBROUTINE FNHW(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for the 2-parameter continuation of Hopf
    ! bifurcation points in waves.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNHBF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNWS,FFHBX)

  END SUBROUTINE FNHW

! ---------- ------
  SUBROUTINE STPNHW(AP,PAR,ICP,U,UDOT,NODIR)

    USE SUPPORT, ONLY: PI

    ! Generates starting data for the 2-parameter continuation of
    ! Hopf bifurcation point (ODE/wave/map).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*)
    INTEGER, INTENT(OUT) :: NODIR
    DOUBLE PRECISION, INTENT(OUT) :: PAR(*),U(*),UDOT(*)

    CALL STPNHBF(AP,PAR,ICP,U,UDOT,NODIR,FNWS,FFHBX)

  END SUBROUTINE STPNHW

! ---------- ----
  SUBROUTINE FNWP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Equations for the continuation of traveling waves.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    INTEGER J
    DOUBLE PRECISION PERIOD

    ! Generate the function and Jacobian.

    CALL FNWS(AP,NDIM,U,UOLD,ICP,PAR,ABS(IJAC),F,DFDU,DFDP)
    PERIOD=PAR(11)
    IF(IJAC==2.OR.IJAC==-1)THEN
       DO J=1,AP%NFPR
          IF(ICP(J)==11)THEN
             !          **Variable wave length
             DFDP(:,11)=F(:)
          ELSEIF(IJAC==2.AND.ICP(J)<=AP%NPAR-AP%NPARI)THEN
             DFDP(:,ICP(J))=PERIOD*DFDP(:,ICP(J))
          ENDIF
       ENDDO
    ENDIF
    F(:)=PERIOD*F(:)
    IF(IJAC.EQ.0)RETURN
    DFDU(:,:NDIM)=PERIOD*DFDU(:,:NDIM)

  END SUBROUTINE FNWP

! ---------- -----
  SUBROUTINE FNWPL(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates starting data for the continuation of folds.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)

    CALL FNPLF(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP,FNWP)

  END SUBROUTINE FNWPL

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!             Parabolic PDEs : Stationary States
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNSP(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for taking one time step (Implicit Euler).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    INTEGER NDM,NPAR,I,J
    DOUBLE PRECISION PERIOD

    NDM=AP%NDM
    NPAR=AP%NPAR

    ! Generate the function and Jacobian.

    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IJAC,F(NDM+1),DFDU,DFDP)

    PERIOD=PAR(11)
    DO I=1,NDM
       F(I)    = PERIOD*U(NDM+I)
       F(NDM+I)=-PERIOD*F(NDM+I)/PAR(14+I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    DO I=1,NDM
       DO J=1,NDM
          DFDU(I+NDM,J)    =-PERIOD*DFDU(I,J)/PAR(14+I)
          DFDU(I,J)        =0.d0
          DFDU(I,J+NDM)    =0.d0
          DFDU(I+NDM,J+NDM)=0.d0
       ENDDO
       DFDU(I,I+NDM)     =PERIOD
    ENDDO
    IF(IJAC.EQ.1)RETURN
    CALL EXPANDJAC(DFDP,AP%NPAR,NDM,NDIM)
    DO I=1,NDM
       IF(ICP(1).EQ.11)THEN
          DFDP(I,ICP(1))    = F(I)/PERIOD
          DFDP(NDM+I,ICP(1))= F(NDM+I)/PERIOD
       ELSEIF(ICP(1).EQ.14+I)THEN
          DFDP(I,ICP(1))    = 0.d0
          DFDP(NDM+I,ICP(1))=-F(NDM+I)/PAR(14+I)
       ELSEIF(ICP(1).NE.11 .AND. &
            .NOT. (ICP(1).GT.14 .AND. ICP(1).LE.14+NDM) )THEN
          DFDP(I+NDM,ICP(1))=-PERIOD*DFDP(I,ICP(1))/PAR(14+I)
          DFDP(I,ICP(1))    =0.d0
       ENDIF
    ENDDO

  END SUBROUTINE FNSP

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!            Time Evolution of Parabolic PDEs
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ----
  SUBROUTINE FNPE(AP,NDIM,U,UOLD,ICP,PAR,IJAC,F,DFDU,DFDP)

    ! Generates the equations for taking one time step (Implicit Euler).

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(*)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM),DFDP(NDIM,*)
    ! Local
    INTEGER NDM,IIJAC,I,J
    DOUBLE PRECISION T,DT,PERIOD,RLOLD

    NDM=AP%NDM

    ! Generate the function and Jacobian.

    IIJAC=IJAC
    IF(IJAC.GT.1)IIJAC=1
    CALL FUNI(AP,NDM,U,UOLD,ICP,PAR,IIJAC,F(NDM+1),DFDU,DFDP)

    PERIOD=PAR(11)
    T=PAR(ICP(1))
    RLOLD=PAR(12)
    IF(T==RLOLD)THEN
       ! Two reasons:
       ! 1. at the start, then UOLD==U, so we can set DT to 1,
       !    because it is irrelevant.
       ! 2. from STUPBV, to calculate UPOLDP, which is not needed
       !    because NINT is forced to 0.
       DT=1.d0
    ELSE
       DT=T-RLOLD
    ENDIF

    DO I=1,NDM
       F(I)=PERIOD*U(NDM+I)
       F(NDM+I)=PERIOD*( (U(I)-UOLD(I))/DT - F(NDM+I) )/PAR(14+I)
    ENDDO

    IF(IJAC.EQ.0)RETURN

    CALL EXPANDJAC(DFDU,NDM,NDM,NDIM)
    DO I=1,NDM
       DO J=1,NDM
          DFDU(I+NDM,J)    =-PERIOD*DFDU(I,J)/PAR(14+I)
          DFDU(I,J)        =0.d0
          DFDU(I,J+NDM)    =0.d0
          DFDU(I+NDM,J+NDM)=0.d0
       ENDDO
       DFDU(I,I+NDM)     =PERIOD
       DFDU(I+NDM,I)     =DFDU(I+NDM,I) + PERIOD/(DT*PAR(14+I))
    ENDDO
    IF(IJAC.EQ.1)RETURN

    DO I=1,NDM
       DFDP(I,ICP(1))    =0.d0
       DFDP(I+NDM,ICP(1))=-PERIOD*(U(I)-UOLD(I))/(DT**2*PAR(14+I))
    ENDDO

  END SUBROUTINE FNPE

! ---------- ----
  SUBROUTINE ICPE(AP,NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,F,IJAC,DINT)

    ! Dummy integral condition subroutine for parabolic systems.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NINT,IJAC
    DOUBLE PRECISION, INTENT(IN) :: UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
    DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NINT)
    DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

    F(:)=0d0
  END SUBROUTINE ICPE

! ------ --------- -------- ------
  DOUBLE PRECISION FUNCTION FNCSPE(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE) RESULT(Q)

    USE BVP
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(IN) :: UPS(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    INTEGER, INTENT(IN) :: ITEST
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE

    !     save old time

    PAR(12)=PAR(ICP(1))
    Q=FNCSBV(AP,ICP,UPS,NDIM,PAR,ITEST,ATYPE)

  END FUNCTION FNCSPE

END MODULE PARABOLIC

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   lor :     The Lorenz Equations
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION x, y, z, rho, beta, sigma

      x=U(1)
      y=U(2)
      z=U(3)

      rho=PAR(1)
      beta=PAR(2)
      sigma=PAR(3)

       F(1)= sigma * (y-x)
       F(2)= rho*x - y - x*z
       F(3)= x*y -  beta*z

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

       PAR(1)=0.
       PAR(2)= 8.d0/3.d0 
       PAR(3)=10. 

       U(1)=0.
       U(2)=0.
       U(3)=0.

      END SUBROUTINE STPNT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   pd1 :    Time integration of a scalar nonlinear parabolic PDE
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)
! 
!      *Set the nonlinear term
       F(1)= PAR(1)*U(1)*( 1. - U(1) ) - U(1)*U(2)
       F(2)= -U(2) + U(1)*U(2)

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,X)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: X

      DOUBLE PRECISION pi

      pi=4*ATAN(1.d0)

!      *Set the (constant) parameter 
       PAR(1) = 12.

!      *Set the actual width of the space interval [0,PAR(11)]
       PAR(11) = 1.

!      *Set the initial data in the (scaled) interval [0,1]
       U(1) = SIN(pi*X) 
       U(2) = 1. 

!      *Also set the space-derivative of the initial data
!      *Note the scaling by 1/PAR(11) !
       U(3) = pi * COS(pi*X) /PAR(11)
       U(4) = 0. / PAR(11)

!      *Set the diffusion constants
       PAR(15) = 1.
       PAR(16) = 1.

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

!      *Define the boundary conditions.
       FB(1)=U0(1) 
       FB(2)=U0(2)-1. 
       FB(3)=U1(1) 
       FB(4)=U1(2)-1. 

      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!---------------------------------------------------------------------
!---------------------------------------------------------------------
!   lin :    A linear ODE eigenvalue problem
!---------------------------------------------------------------------
!---------------------------------------------------------------------

       SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!      ---------- ----

       IMPLICIT NONE
       INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
       DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
       DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
       DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

       DOUBLE PRECISION PI

        PI=4*ATAN(1.0D0)
        F(1) = U(2)
        F(2) = -( PAR(1)*PI )**2 * U(1)

       END SUBROUTINE FUNC

       SUBROUTINE STPNT(NDIM,U,PAR,T)
!      ---------- -----

       IMPLICIT NONE
       INTEGER, INTENT(IN) :: NDIM
       DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
       DOUBLE PRECISION, INTENT(IN) :: T

        PAR(1)=0.
        PAR(2)=0.
        PAR(3)=0.

        U(1)=0.0
        U(2)=0.0

       END SUBROUTINE STPNT

       SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!      ---------- ----

       IMPLICIT NONE
       INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
       DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
       DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
       DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

        FB(1)=U0(1)-PAR(2)
        FB(2)=U1(1)

       END SUBROUTINE BCND

       SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!      ---------- ----

       IMPLICIT NONE
       INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
       DOUBLE PRECISION, INTENT(IN) :: PAR(*)
       DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
       DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
       DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

        FI(1)=U(1)*U(1)-PAR(3)

       END SUBROUTINE ICND

       SUBROUTINE FOPT
       END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    General Boundary Value Problems
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
MODULE BVP

  USE AUTO_CONSTANTS, ONLY: AUTOPARAMETERS

  IMPLICIT NONE
  PRIVATE
  PUBLIC :: AUTOBV,SETRTN,IRTN,NRTN,STSDRBV

  INTEGER, ALLOCATABLE :: NRTN(:)
  INTEGER IRTN

CONTAINS

! ---------- ------
  SUBROUTINE AUTOBV(AP,ICP,ICU,FUNI,BCNI,ICNI,STPNBVI,FNCI)

! THIS IS THE ENTRY ROUTINE FOR GENERAL BOUNDARY VALUE PROBLEMS.

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ICU(*)

    include 'interfaces.h'

    CALL CNRLBV(AP,ICP,ICU,FUNI,BCNI,ICNI,STPNBVI,FNCI)

  END SUBROUTINE AUTOBV

! ---------- -----------------
  subroutine mpi_setubv_worker(funi,icni,bcni)
    use autompi
    use solvebv

    integer iam,kwt
    include 'interfaces.h'

    integer :: ndim, na, ncol, ntst, nfpr, npar
    type(autoparameters) ap

    double precision, allocatable :: ups(:,:), udotps(:,:), rldot(:)
    double precision, allocatable :: dups(:,:), drl(:), par(:), tm(:)
    integer, allocatable :: icp(:),np(:)

    call mpibcastap(ap)
    iam=mpiiam()
    kwt=mpikwt()

    ndim=ap%ndim
    ntst=ap%ntst
    ncol=ap%ncol
    nfpr=ap%nfpr
    npar=ap%npar

    allocate(np(kwt))
    call partition(ntst,kwt,np)
    na=np(iam+1)
    deallocate(np)

    allocate(icp(nfpr),rldot(nfpr),par(npar),tm(0:na))
    allocate(ups(ndim,0:na*ncol),udotps(ndim,0:na*ncol))
    allocate(dups(ndim,0:na*ncol),drl(nfpr))

    ap%iid=0
    call stsdrbv(ap,par,icp,funi,bcni,icni, &
         rldot,ups,udotps,tm,dups,drl)

    ! free input arrays
    deallocate(ups,udotps,tm,dups,drl,par,rldot,icp)

  end subroutine mpi_setubv_worker

! ---------- ------
  SUBROUTINE CNRLBV(AP,ICP,ICU,FUNI,BCNI,ICNI,STPNBVI,FNCI)

    USE IO
    USE MESH
    USE SUPPORT, ONLY: DTM=>DTV, P0=>P0V, P1=>P1V, EV=>EVV, CHECKSP, STOPPED, &
         INITSTOPCNTS, INIT2, INIT3, FNCS, PVLI, LBITP
    USE AUTO_CONSTANTS, ONLY: NPARX
    USE AUTOMPI

! Controls the computation of solution branches.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ICU(*)
! Local
    INTEGER, ALLOCATABLE :: IUZ(:),NP(:)
    DOUBLE PRECISION, ALLOCATABLE :: PAR(:),VUZ(:),THU(:),THL(:)
    DOUBLE PRECISION, ALLOCATABLE :: RLCUR(:),RLOLD(:),RLDOT(:)
    DOUBLE PRECISION, ALLOCATABLE :: UPS(:,:),UOLDPS(:,:),UPOLDP(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: UDOTPS(:,:),TM(:),TEST(:)
    INTEGER NDIM,IPS,IRS,ILP,NTST,NCOL,IAD,IADS,ISP,ISW,NUZR,ITP,ITPST,NFPR
    INTEGER IBR,IPERP,ISTOP,ITNW,ITEST,I,NITPS,NODIR,NTOP,NTOT,NPAR,NINS
    INTEGER IFOUND,ISTEPPED,IAM,KWT,NA,NTSTNA,IID
    INTEGER STOPCNTS(-9:14)
    DOUBLE PRECISION DS,DSMAX,DSOLD,DSTEST,RDS,SP1
    LOGICAL STEPPED
    CHARACTER(4) ATYPE,ATYPEDUM

! INITIALIZE COMPUTATION OF BRANCH

    IAM=MPIIAM()
    IF(IAM==0)THEN
       IF(AP%ISW==-2.OR.AP%ISW==-3)THEN
          AP%ILP=0
          AP%ISP=0
          AP%NMX=5
          WRITE(6,"(/,A,A)")' Generating starting data :', &
               ' Restart at EP label below :'
       ENDIF
       CALL INIT2(AP,ICP,ICU)
    ENDIF

    CALL MPIBCASTAP(AP)

    NDIM=AP%NDIM
    IPS=AP%IPS
    IRS=AP%IRS
    ILP=AP%ILP
    NTST=AP%NTST
    NCOL=AP%NCOL
    IAD=AP%IAD
    IADS=AP%IADS
    ISP=AP%ISP
    ISW=AP%ISW
    NUZR=AP%NUZR
    ITP=AP%ITP
    ITPST=AP%ITPST
    NFPR=AP%NFPR
    NPAR=AP%NPAR

    ! allocate a minimum of NPARX so we can detect overflows 
    ! past NPAR gracefully
    ALLOCATE(PAR(MAX(NPAR,NPARX)),THL(NFPR),THU(NDIM),IUZ(NUZR),VUZ(NUZR))

    IF(IAM==0)CALL INIT3(AP,ICP,PAR,THL,THU,IUZ,VUZ)

    CALL MPIBCAST(THU,NDIM)

    KWT=MPIKWT()
    ALLOCATE(NP(KWT))
    CALL PARTITION(NTST,KWT,NP)
    NA=NP(IAM+1)
    DEALLOCATE(NP)
    IID=AP%IID

    IF(IAM==0)THEN
       NTSTNA=NTST
    ELSE
       NTSTNA=NA
    ENDIF

    ALLOCATE(RLCUR(NFPR),RLDOT(NFPR),RLOLD(NFPR))
    ALLOCATE(UPS(NDIM,0:NTSTNA*NCOL),UOLDPS(NDIM,0:NTSTNA*NCOL))
    ALLOCATE(UPOLDP(NDIM,0:NA*NCOL),UDOTPS(NDIM,0:NTSTNA*NCOL))
    ALLOCATE(TM(0:NTSTNA),DTM(NTSTNA))
    ALLOCATE(P0(NDIM,NDIM),P1(NDIM,NDIM),TEST(AP%NTEST),EV(AP%NDM))

    DS=AP%DS

    RDS=DS
    DSOLD=RDS
    IF(IAM==0)CALL INITSTOPCNTS(ISP,ILP,ITPST,STOPCNTS)
    IF(ISP.LT.0)THEN
       ISP=-ISP
       AP%ISP=ISP
    ENDIF
    DO I=1,AP%NTEST
       TEST(I)=0.d0
    ENDDO
    NITPS=0
    NTOT=0
    AP%NTOT=NTOT
    ISTOP=0

    DO I=1,NFPR
       RLCUR(I)=0.d0
       RLOLD(I)=0.d0
       RLDOT(I)=0.d0
    ENDDO

    UPS(:,:)=0.d0
    UOLDPS(:,:)=0.d0
    UPOLDP(:,:)=0.d0
    UDOTPS(:,:)=0.d0

    NODIR=0
    IF(IAM==0)THEN
       CALL RSPTBV(AP,PAR,ICP,STPNBVI,FNCI,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,NODIR)
    ELSE
       ! RSPTBV calls STPNBVI which sometimes calls SOLVBV so we need
       ! to check if parallel work needs to be done
       DO WHILE(MPIWFI())
          CALL MPI_SETUBV_WORKER(FUNI,ICNI,BCNI)
       ENDDO
       PAR(:)=0.d0
    ENDIF

    ! call PVLS here the first time so the parameters can be initialized
    ! some demos use PVLS to set some global storage, so
    ! for MPI it needs to be called at init time only,
    ! though PAR is thrown away for IAM>0
    CALL PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)

    CALL STUDPBV(AP,PAR,ICP,FUNI,RLCUR,RLOLD, &
         NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,TM,NODIR,THU,NTSTNA,NA)

    IF(IAM==0)THEN
!     don't set global rotations here for homoclinics, but in autlib5.f
       IF(IPS.NE.9)CALL SETRTN(AP%NDM,NTST*NCOL,NDIM,UPS)
    ELSE
       DTM(:)=TM(1:NA)-TM(0:NA-1)
    ENDIF

    CALL MPIBCAST1I(NODIR)
    IPERP=2
    IF(NODIR.EQ.1 .AND. ISW.GT.0)THEN
       ! no direction given or valid; no branch switch
       IPERP=0
    ELSEIF(IRS.NE.0 .AND. ISW.LT.0)THEN
       ! branch switch
       IPERP=1
    ELSEIF(ITP==3 .OR. ABS(ITP/10)==3) THEN
       ! Hopf bifurcation
       IPERP=3
    ELSEIF( ISP/=0 .AND. (IPS==2.OR.IPS==7.OR.IPS==12)) THEN
       ! periodic orbit with detection of special points: compute FMs
       IPERP=-1
    ENDIF
    IF(IPERP/=0.AND.IPERP/=3)THEN
       CALL MPISCAT(UDOTPS,NDIM*NCOL,NTST,NDIM)
       CALL MPIBCAST(RLDOT,AP%NFPR)
    ENDIF
    IF(IPERP<2)THEN
       CALL STDRBV(AP,PAR,ICP,FUNI,BCNI,ICNI,RLCUR,RLOLD,RLDOT,NDIM, &
            UPS,UOLDPS,UDOTPS,UPOLDP,DTM,IPERP,P0,P1,THL,THU,NA)
       IF(IAM==0 .AND. ISP/=0 .AND. (IPS==2.OR.IPS==7.OR.IPS==12) )THEN
          ! determine and print Floquet multipliers and stability
          SP1 = FNCI(AP,ICP,UPS,NDIM,PAR,3,ATYPEDUM)
       ENDIF
    ENDIF

! Store plotting data for restart point :

    IF(IAM==0)CALL STHD(AP,ICP)
    IF(IRS.EQ.0) THEN
       ITP=9+10*ITPST
    ELSE
       ITP=0
    ENDIF
    AP%ITP=ITP
    IF(IAM==0)CALL PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)
    CALL MPIBCAST(PAR,NPAR)
    CALL MPIBCAST1I(ISTOP)
    CALL STPLBV(AP,PAR,ICP,ICU,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,THU,ISTOP,NA)

    DO WHILE(ISTOP==0)
       ITP=0
       AP%ITP=ITP
       NINS=AP%NINS
       CALL STEPBV(AP,DSOLD,PAR,ICP,FUNI,BCNI,ICNI,RDS, &
            RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP, &
            TM,DTM,P0,P1,THL,THU,NITPS,ISTOP,NTSTNA)

       IFOUND=0
       DSTEST=DSOLD
       IF(ISTOP/=0)THEN
          ISTEPPED=AP%NTEST+1
       ELSE
          ISTEPPED=0
          IF(IAM==0)THEN
             CALL PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)
             IF(IID.GE.2)WRITE(9,*)
          ENDIF
          DO ITEST=1,AP%NTEST
             ! Check for special points
             CALL LCSPBV(AP,DSOLD,DSTEST,PAR,ICP,ITEST,FUNI,BCNI,ICNI,FNCI, &
                  TEST(ITEST),RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS, &
                  UPOLDP,TM,DTM,P0,P1,EV,THL,THU,IUZ,VUZ,NITPS,ATYPE,STEPPED, &
                  NTSTNA)
             IF(STEPPED)ISTEPPED=ITEST
             IF(LEN_TRIM(ATYPE)>0)THEN
                IFOUND=ITEST
                AP%ITP=LBITP(ATYPE,.TRUE.)
                AP%ITP=AP%ITP+SIGN(10,AP%ITP)*ITPST
             ENDIF
          ENDDO
       ENDIF

       IF(IAM==0)THEN
          DO ITEST=1,ISTEPPED-1
             ! evaluate the test functions for the next step
             TEST(ITEST)=FNCS(AP,ICP,UPS,PAR,ATYPEDUM,IUZ,VUZ,ITEST,FNCI)
          ENDDO
       ENDIF

       ITP=AP%ITP
       IF(ITP/=0)THEN
          IF(STOPPED(IUZ,IFOUND,NUZR,ITP,STOPCNTS))THEN
             ISTOP=-1 ! *Stop at the first found bifurcation
          ENDIF
          IF(MOD(ITP,10)/=-4)THEN
             ! for plotter: use stability of previous point
             ! for bifurcation points
             AP%NINS=NINS
          ENDIF
       ENDIF

! Store plotting data.

       CALL MPIBCAST1I(ISTOP)
       IF(IAM==0)CALL PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)
       CALL STPLBV(AP,PAR,ICP,ICU,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,THU,ISTOP,NA)

       IF(ISTOP/=0)EXIT
       NTOT=AP%NTOT

! Adapt the mesh to the solution.

       IF(IAD.NE.0)THEN
          IF(MOD(NTOT,IAD).EQ.0)THEN
             CALL ADAPT(NTST,NTSTNA,NCOL,NDIM,TM,DTM,UPS,UOLDPS, &
                  ((IPS==2.OR.IPS==12) .AND. ABS(ISW)<=1))
          ENDIF
       ENDIF

! Adapt the stepsize along the branch.

       IF(IADS.NE.0)THEN
          IF(MOD(NTOT,IADS).EQ.0)THEN
             ITNW=AP%ITNW
             IBR=AP%IBR
             NTOP=MOD(NTOT-1,9999)+1
             DSMAX=AP%DSMAX
             CALL ADPTDS(NITPS,ITNW,IBR,NTOP,IID,DSMAX,RDS)
             AP%RDS=RDS
          ENDIF
       ENDIF

! Update UOLDPS, UDOTPS, UPOLDP, RLOLD, and RLDOT.

       CALL MPICBV(AP%NPAR,PAR,RDS)
       CALL CONTBV(AP,DSOLD,PAR,ICP,FUNI,RLCUR,RLOLD,RLDOT, &
            NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,THL,THU)

    ENDDO
    DEALLOCATE(PAR,THL,THU,IUZ,VUZ)
    DEALLOCATE(EV,UPS,UOLDPS,UPOLDP,UDOTPS,TM,DTM,P0,P1)
    DEALLOCATE(TEST,RLCUR,RLOLD,RLDOT)

  END SUBROUTINE CNRLBV

! ---------- ------
  SUBROUTINE CONTBV(AP,DSOLD,PAR,ICP,FUNI,RLCUR,RLOLD,RLDOT, &
       NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,THL,THU)

    USE MESH
    USE AUTOMPI

! Computes new rate of change (UDOTPS,RLDOT) and time derivative (UPOLDP)
! arrays depending on (UOLDPS,RLOLD) and (UPS,RLCUR), and then replaces
! (UOLDPS,RLOLD) with the current solution in (UPS,RLCUR).
! The stepsize used in the preceding step has been stored in DSOLD.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    DOUBLE PRECISION, INTENT(IN) :: DSOLD
    INTEGER, INTENT(IN) :: ICP(*),NDIM
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*), UPS(NDIM,0:*), UOLDPS(NDIM,0:*)
    DOUBLE PRECISION, INTENT(OUT) :: UDOTPS(NDIM,0:*), UPOLDP(NDIM,0:*)
    DOUBLE PRECISION, INTENT(IN) :: RLCUR(AP%NFPR), DTM(*), THL(AP%NFPR), THU(*)
    DOUBLE PRECISION, INTENT(INOUT) :: RLOLD(AP%NFPR)
    DOUBLE PRECISION, INTENT(OUT) :: RLDOT(AP%NFPR)

    INTEGER NTST,NCOL,IAM,KWT,NA
    INTEGER, ALLOCATABLE :: NP(:)

    NTST=AP%NTST
    NCOL=AP%NCOL

    IAM=MPIIAM()
    KWT=MPIKWT()
    ALLOCATE(NP(KWT))
    CALL PARTITION(NTST,KWT,NP)
    NA=NP(IAM+1)
    DEALLOCATE(NP)

! Compute rate of change (along branch) of PAR(ICP(1)) and U :

    UDOTPS(:,0:NCOL*NA)=(UPS(:,0:NCOL*NA)-UOLDPS(:,0:NCOL*NA))/DSOLD
    IF(IAM==0.AND.NTST>NA)THEN
       UDOTPS(:,NCOL*NTST)=(UPS(:,NCOL*NTST)-UOLDPS(:,NCOL*NTST))/DSOLD
    ENDIF
    RLDOT(:)=(RLCUR(:)-RLOLD(:))/DSOLD

! Rescale, to set the norm of (UDOTPS,RLDOT) equal to 1.

    CALL SCALEBP(NTST,NCOL,NDIM,AP%NFPR,UDOTPS,RLDOT,DTM,THL,THU,NA)

! Store time-derivative.

!$OMP PARALLEL
    CALL STUPBV(AP,PAR,ICP,FUNI,NDIM,UPS,UPOLDP,NA)
!$OMP END PARALLEL

    RLOLD(:)=RLCUR(:)
    IF(IAM==0)THEN
       UOLDPS(:,0:NCOL*NTST)=UPS(:,0:NCOL*NTST)
    ELSE
       UOLDPS(:,0:NCOL*NA)=UPS(:,0:NCOL*NA)
    ENDIF

  END SUBROUTINE CONTBV

! ---------- ------
  SUBROUTINE STUPBV(AP,PAR,ICP,FUNI,NDIM,UPS,UPOLDP,NTSTNA)

! Stores U-prime (derivative with respect to T) in UPOLDP.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NTSTNA
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:*), PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: UPOLDP(NDIM,0:*)
! Local
    INTEGER NCOL,NPAR,J
    DOUBLE PRECISION, ALLOCATABLE :: U(:),DFDU(:,:),DFDP(:,:),PRM(:)

    NCOL=AP%NCOL
    NPAR=AP%NPAR

    ALLOCATE(U(3*NDIM+AP%NFPR),DFDU(NDIM,NDIM),DFDP(NDIM,NPAR),PRM(NPAR))
    PRM(:)=PAR(:NPAR)
    DFDU(:,:)=0.d0
    DFDP(:,:)=0.d0

!$OMP DO
    DO J=0,NTSTNA*NCOL
       U(:NDIM)=UPS(:,J)
       U(NDIM+1:2*NDIM)=UPS(:,J) ! UOLD
       U(2*NDIM+1:)=0 ! set RLOLD/UPOLD input to 0
       CALL FUNI(AP,NDIM,U,U(NDIM+1),ICP,PRM,0,UPOLDP(1,J),&
            DFDU,DFDP)
    ENDDO
!$OMP END DO NOWAIT

    DEALLOCATE(U,DFDU,DFDP,PRM)
  END SUBROUTINE STUPBV

! ---------- ------
  SUBROUTINE STEPBV(AP,DSOLD,PAR,ICP,FUNI,BCNI,ICNI,RDS, &
       RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP, &
       TM,DTM,P0,P1,THL,THU,NITPS,ISTOP,NTSTNA)

    USE MESH
    USE AUTOMPI

! Controls the solution of the nonlinear equations (by Newton's method)
! for the next solution (PAR(ICP(*)) , U) on a branch of solutions.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*), NDIM, NTSTNA
    INTEGER, INTENT(OUT) :: ISTOP, NITPS
    DOUBLE PRECISION, INTENT(OUT) :: UPS(NDIM,0:*), RLCUR(AP%NFPR)
    DOUBLE PRECISION, INTENT(IN) :: UOLDPS(NDIM,0:*), RLOLD(AP%NFPR)
    DOUBLE PRECISION, INTENT(IN) :: UDOTPS(NDIM,0:*), RLDOT(AP%NFPR), UPOLDP(NDIM,0:*)
    DOUBLE PRECISION, INTENT(IN) :: TM(*), DTM(*), THL(*), THU(*)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*), RDS
    DOUBLE PRECISION, INTENT(OUT) :: DSOLD, P0(*),P1(*)

    INTEGER NCOL,IADS,IID,ITNW,NFPR,IBR,NTOT,NTOP,I,IAM
    DOUBLE PRECISION DSMIN,DSMAX
    LOGICAL CONVERGED

    NCOL=AP%NCOL
    IADS=AP%IADS
    IID=AP%IID
    ITNW=AP%ITNW
    NFPR=AP%NFPR
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1

    DSMIN=AP%DSMIN

    IAM=MPIIAM()
    IF(IAM>0)IID=0

    ISTOP=0
    DO
       DSOLD=RDS

! Perform Newton iterations

       CALL NEWTONBV(AP,PAR,ICP,FUNI,BCNI,ICNI,RDS, &
            RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP, &
            TM,DTM,P0,P1,THL,THU,NITPS,CONVERGED)
       IF(CONVERGED)THEN
          ! Global concatenation of the solution from each node.
          CALL MPIGAT(UPS,NDIM*NCOL,AP%NTST)
          RETURN
       ENDIF

! Maximum number of iterations reached.

       IF(IADS.EQ.0)THEN
          IF(IID>0)WRITE(9,101)IBR,NTOP
          ISTOP=1
          EXIT
       ENDIF

! Reduce stepsize and try again.

       DSMAX=AP%DSMAX
       NITPS=ITNW
       CALL ADPTDS(NITPS,ITNW,IBR,NTOP,IID,DSMAX,RDS)
       AP%RDS=RDS
       IF(IAM==0.AND.ABS(RDS).LT.DSMIN)THEN
          ! Minimum stepsize reached.
          IF(IID>0)WRITE(9,103)IBR,NTOP
          ISTOP=1
       ENDIF
       CALL MPIBCAST1I(ISTOP)
       IF(ISTOP==1)EXIT
       IF(IID.GE.2)WRITE(9,102)IBR,NTOP
    ENDDO

! Minimum stepsize reached.

    DO I=1,NFPR
       RLCUR(I)=RLOLD(I)
       PAR(ICP(I))=RLCUR(I)
    ENDDO
    UPS(:,0:NCOL*NTSTNA)=UOLDPS(:,0:NCOL*NTSTNA)

101 FORMAT(I4,I6,' NOTE:No convergence with fixed step size')
102 FORMAT(I4,I6,' NOTE:Retrying step')
103 FORMAT(I4,I6,' NOTE:No convergence using minimum step size')

  END SUBROUTINE STEPBV

! ---------- --------
  SUBROUTINE NEWTONBV(AP,PAR,ICP,FUNI,BCNI,ICNI,RDS, &
       RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP, &
       TM,DTM,P0,P1,THL,THU,NITPS,CONVERGED)

! This subroutine contains the main predictor-corrector loop

    USE MESH, ONLY: RNRMSQP
    USE SOLVEBV, ONLY: SOLVBV
    USE SUPPORT, ONLY: CHECKSP, PVLI
    USE AUTOMPI, ONLY: MPIIAM, MPIKWT, MPIBCAST1I, PARTITION, MPIGAT, MPIREDUCEMAX

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*), NDIM
    INTEGER, INTENT(OUT) :: NITPS
    DOUBLE PRECISION, INTENT(OUT) :: UPS(NDIM,0:*), RLCUR(AP%NFPR)
    DOUBLE PRECISION, INTENT(IN) :: UOLDPS(NDIM,0:*), RLOLD(AP%NFPR)
    DOUBLE PRECISION, INTENT(IN) :: UDOTPS(NDIM,0:*), RLDOT(AP%NFPR), UPOLDP(NDIM,0:*)
    DOUBLE PRECISION, INTENT(IN) :: TM(*), DTM(*), THL(AP%NFPR), THU(*), RDS
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: P0(*),P1(*)
    LOGICAL, INTENT(OUT) :: CONVERGED

    INTEGER NTST,NCOL,IID,ITNW,NWTN,NFPR,IFST,NLLV,I,J,NIT1,IPS,ILP,ISP
    INTEGER IAM, KWT, NA, NTSTNA, STATE
    INTEGER, PARAMETER :: NEWTON_CYCLE=0, NEWTON_EXIT=1
    INTEGER, PARAMETER :: NEWTON_CONVERGED=2, NEWTON_CONVERGED_FLDF=3
    INTEGER, ALLOCATABLE :: NP(:)
    DOUBLE PRECISION EPSL,EPSU,DELREF,DELMAX,ADRL,ADU,AU,DET,SS
    DOUBLE PRECISION DUMX,RDRL,RDUMX,UMX,RDSZ,UMXDUMX(2)
    DOUBLE PRECISION, ALLOCATABLE :: DUPS(:,:),DRL(:),P0T(:),P1T(:)
    LOGICAL DONE

    IPS=AP%IPS
    ILP=AP%ILP
    NTST=AP%NTST
    NCOL=AP%NCOL
    ISP=AP%ISP
    IID=AP%IID
    ITNW=AP%ITNW
    NWTN=AP%NWTN
    NFPR=AP%NFPR

    EPSL=AP%EPSL
    EPSU=AP%EPSU

    IAM=MPIIAM()
    KWT=MPIKWT()
    ALLOCATE(NP(KWT))
    CALL PARTITION(NTST,KWT,NP)
    NA=NP(IAM+1)
    DEALLOCATE(NP)
    IF(IAM==0)THEN
       NTSTNA=NTST
    ELSE
       NTSTNA=NA
    ENDIF

    ! Extrapolate to get the approximation to the next solution point.

    RLCUR(:)=RLOLD(:)+RDS*RLDOT(:)
    UPS(:,0:NCOL*NA)=UOLDPS(:,0:NCOL*NA)+RDS*UDOTPS(:,0:NCOL*NA)
    IF(IAM==0.AND.NTST>NA)THEN
       UPS(:,NCOL*NTST)=UOLDPS(:,NCOL*NTST)+RDS*UDOTPS(:,NCOL*NTST)
    ENDIF

! Write additional output on unit 9 if requested.

    NITPS=0
    CALL WRTBV9(AP,RLCUR,NDIM,UPS,TM,DTM,THU,NITPS,NA)

! Generate the Jacobian matrix and the right hand side.

    ALLOCATE(DUPS(NDIM,0:NTSTNA*NCOL),DRL(NFPR))
    CONVERGED=.FALSE.
    STATE=NEWTON_CYCLE
    DELREF=0
    DO NIT1=1,ITNW

       NITPS=NIT1
       NLLV=0

       IFST=0
       IF(NITPS.LE.NWTN)IFST=1

       CALL SOLVBV(IFST,AP,DET,PAR,ICP,FUNI,BCNI,ICNI,RDS,NLLV, &
            RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,DUPS,DRL, &
            P0,P1,THL,THU)
       AP%DET=DET

! Add Newton increments.

       DO I=1,NFPR
          RLCUR(I)=RLCUR(I)+DRL(I)
          PAR(ICP(I))=RLCUR(I)
       ENDDO

       DUMX=0.d0
       UMX=0.d0
       DO J=0,NA*NCOL
          DO I=1,NDIM
             ADU=ABS(DUPS(I,J))
             IF(ADU.GT.DUMX)DUMX=ADU
             AU=ABS(UPS(I,J))
             IF(AU.GT.UMX)UMX=AU
             UPS(I,J)=UPS(I,J)+DUPS(I,J)
          ENDDO
       ENDDO

       UMXDUMX(1)=UMX
       UMXDUMX(2)=DUMX

       IF(IAM==0.AND.NTSTNA>NA)THEN
          UPS(:,NTST*NCOL)=UPS(:,NTST*NCOL)+DUPS(:,NTST*NCOL)
       ENDIF

       CALL WRTBV9(AP,RLCUR,NDIM,UPS,TM,DTM,THU,NITPS,NA)
       CALL MPIREDUCEMAX(UMXDUMX, 2)

       IF(IAM==0)THEN
          UMX=UMXDUMX(1)
          DUMX=UMXDUMX(2)

! Check whether user-supplied error tolerances have been met :

          DONE=.TRUE.
          RDRL=0.d0
          DO I=1,NFPR
             ADRL=ABS(DRL(I))/(1.d0+ABS(RLCUR(I)))
             IF(ADRL.GT.EPSL)DONE=.FALSE.
             IF(ADRL.GT.RDRL)RDRL=ADRL
          ENDDO
          RDUMX=DUMX/(1.d0+UMX)
          IF(DONE.AND.RDUMX.LT.EPSU)THEN
             STATE=NEWTON_CONVERGED
             IF(CHECKSP('LP',IPS,ILP,ISP))THEN
                STATE=NEWTON_CONVERGED_FLDF
             ENDIF
          ELSEIF(NITPS.EQ.1)THEN
             DELREF=20*DMAX1(RDRL,RDUMX)
          ELSE
             DELMAX=DMAX1(RDRL,RDUMX)
             IF(DELMAX.GT.DELREF)THEN
                STATE=NEWTON_EXIT
             ENDIF
          ENDIF
       ENDIF

       CALL MPIBCAST1I(STATE)

       IF(STATE==NEWTON_EXIT)EXIT

       IF(STATE==NEWTON_CONVERGED_FLDF)THEN
          ! Find the direction vector (for test functions)
          ALLOCATE(P0T(NDIM*NDIM),P1T(NDIM*NDIM))
          NLLV=-1
          IFST=0
          RDSZ=0.d0

          CALL SOLVBV(IFST,AP,DET,PAR,ICP,FUNI,BCNI,ICNI,RDSZ,NLLV, &
               RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,DUPS,&
               DRL,P0T,P1T,THL,THU)

          ! Scale the direction vector.
          SS=RNRMSQP(NTST,NCOL,NDIM,NDIM,DUPS,DTM,THU,NA)
          IF(IAM==0)THEN
             SS=SQRT(SS+DOT_PRODUCT(THL(:),DRL(:)**2))
             AP%FLDF=DRL(1)/SS
          ENDIF

          STATE=NEWTON_CONVERGED
          DEALLOCATE(P0T,P1T)
       ENDIF

       IF(STATE==NEWTON_CONVERGED)THEN
          CONVERGED=.TRUE.
          EXIT
       ENDIF

    ENDDO
    DEALLOCATE(DUPS,DRL)

  END SUBROUTINE NEWTONBV

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!      Restart of Solution Branches ( Differential Equations )
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ------
  SUBROUTINE RSPTBV(AP,PAR,ICP,STPNBVI,FNCI,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,NODIR)

    USE IO
    USE MESH
    USE SUPPORT, ONLY: PVLI
    USE AUTO_CONSTANTS, ONLY: TY
    USE AUTOMPI

! Restarts computation of a branch of solutions at point labelled IRS.
! The output written on unit 8 by a previous run is now expected as
! input on unit 3. The label IRS, where computation is to resume, must
! be specified in the user-supplied subroutine INIT.
! If IRS=0 then the starting point must be provided analytically in the
! user-supplied subroutine STPNT.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER ICP(*),NDIM,NODIR
    DOUBLE PRECISION UPS(NDIM,0:*),UDOTPS(NDIM,0:*),TM(0:*),DTM(*),PAR(*)
    DOUBLE PRECISION RLDOT(AP%NFPR)

    DOUBLE PRECISION, ALLOCATABLE :: U(:),UDOT(:)
    INTEGER :: ICPRS(2),IRS,NTST,NCOL,ITP,NFPR,NCOLRS,NTSRS,I,J

    IRS=AP%IRS
    NTST=AP%NTST
    NCOL=AP%NCOL
    ITP=AP%ITP
    NFPR=AP%NFPR

! Get restart data :

    IF(IRS>0)THEN
       NTSRS=GETNTST3()
       NCOLRS=GETNCOL3()
    ELSE
       NTSRS=NTST
       NCOLRS=NCOL
    ENDIF

    IF(NCOLRS*NTSRS==0)THEN
       ALLOCATE(U(NDIM),UDOT(NDIM+1))
       CALL READLB(AP,ICPRS,U,UDOT,PAR)

! Generate the (initially uniform) mesh.

       CALL MSH(NTST,TM)

       DO J=0,NTST*NCOL
          UPS(:,J)=U(:)
       ENDDO

       IF(ITP==3 .OR. ABS(ITP/10)==3) THEN
          IF(LEN_TRIM(TY)>2)THEN
             READ(TY(3:),'(I5)')I
             PAR(11)=PAR(I)
          ENDIF
          ! Hopf bifurcation
          NODIR=-1
       ELSE
          ! else we just use the uniform mesh with no direction given
          NODIR=1
       ENDIF
       DEALLOCATE(U,UDOT)
    ELSE
       CALL STPNBVI(AP,PAR,ICP,NTSRS,NCOLRS,RLDOT,UPS,UDOTPS,TM,NODIR)
    ENDIF

    CALL MPISBV(.FALSE.)

! Determine a suitable starting label and branch number.

    CALL NEWLAB(AP)
    DTM(1:NTST)=TM(1:NTST)-TM(0:NTST-1)

  END SUBROUTINE RSPTBV

! ---------- -------
  SUBROUTINE STUDPBV(AP,PAR,ICP,FUNI,RLCUR,RLOLD, &
       NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,TM,NODIR,THU,NTSTNA,NA)

    USE AUTOMPI

! Compute UOLDPS, RLOLD, RLCUR, UPOLDP
! Also compute UDOTPS for Hopf bifurcations

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),NDIM,NTSTNA,NA
    INTEGER, INTENT(INOUT) :: NODIR
    DOUBLE PRECISION, INTENT(INOUT) :: UPS(NDIM,0:*),UDOTPS(NDIM,0:*),PAR(*)
    DOUBLE PRECISION, INTENT(INOUT) :: TM(0:*)
    DOUBLE PRECISION, INTENT(OUT) :: UPOLDP(NDIM,0:*),UOLDPS(NDIM,0:*)
    DOUBLE PRECISION, INTENT(OUT) :: RLCUR(AP%NFPR),RLOLD(AP%NFPR)
    DOUBLE PRECISION, INTENT(IN) :: THU(*)

    INTEGER :: NTST,NCOL,I

    NTST=AP%NTST
    NCOL=AP%NCOL

    CALL MPISCAT(UPS,NDIM*NCOL,NTST,NDIM)
    CALL MPISCAT(TM,1,NTST,1)
    CALL MPIBCAST(PAR,AP%NPAR)
    CALL MPIBCAST1I(NODIR)

    ! Set UOLDPS, RLOLD.

    DO I=1,AP%NFPR
       RLCUR(I)=PAR(ICP(I))
       RLOLD(I)=RLCUR(I)
    ENDDO

    UOLDPS(:,0:NCOL*NTSTNA)=UPS(:,0:NCOL*NTSTNA)

! Store U-prime (derivative with respect to time or space variable).

    IF(NODIR.EQ.-1)THEN
!      ** Restart from a Hopf bifurcation.
       NODIR=0
       CALL STHOPF(AP,UPS,PAR,ICP,NTST,NCOL, &
            NDIM,UDOTPS,UPOLDP,THU,FUNI)
       AP%ISW=1
    ELSE
!      ** Restart from orbit.
!$OMP PARALLEL
       CALL STUPBV(AP,PAR,ICP,FUNI,NDIM,UPS,UPOLDP,NA)
!$OMP END PARALLEL
    ENDIF

  END SUBROUTINE STUDPBV

! ---------- ------
  SUBROUTINE STHOPF(AP,U,PAR,ICP,NTST,NCOL, &
       NDIM,UDOTPS,UPOLDP,THU,FUNI)

    USE IO
    USE MESH
    USE SUPPORT
    USE AUTOMPI

!  Generates starting data for a periodic orbit from a Hopf
!  bifurcation point (for waves or periodic orbits)

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER ICP(*),NDIM,NTST,NCOL
    DOUBLE PRECISION U(NDIM),PAR(*),THU(*)
    DOUBLE PRECISION UDOTPS(NDIM,0:*),UPOLDP(NDIM,0:*)
    include 'interfaces.h'
! Local
    INTEGER I,J,IAM,KWT,OFFSET,NTSTNA,NA
    INTEGER, ALLOCATABLE :: NP(:)
    DOUBLE PRECISION, ALLOCATABLE :: DFU(:,:),SMAT(:,:),RNLLV(:),F(:)
    DOUBLE PRECISION, ALLOCATABLE :: DTM(:),UOLD(:)
    DOUBLE PRECISION DUMDFP(1)
    DOUBLE PRECISION PERIOD,TPI,RIMHB,T,C,S,SS(1)

    ALLOCATE(DFU(NDIM,NDIM),F(NDIM),RNLLV(2*NDIM),SMAT(2*NDIM,2*NDIM))
    ALLOCATE(UOLD(NDIM))

    IAM=MPIIAM()
    KWT=MPIKWT()
    ALLOCATE(NP(KWT))
    CALL PARTITION(NTST,KWT,NP)
    OFFSET=0
    DO I=1,IAM
       OFFSET=OFFSET+NP(I)
    ENDDO
    OFFSET=OFFSET*NCOL
    NA=NP(IAM+1)
    DEALLOCATE(NP)
    IF(IAM==0)THEN
       NTSTNA=NTST
    ELSE
       NTSTNA=NA
    ENDIF

    PERIOD=PAR(11)
    TPI=PI(2.d0)
    RIMHB=TPI/PERIOD

    SMAT(:,:)=0.d0

    DO I=1,NDIM
       SMAT(I,I)=-RIMHB
       SMAT(NDIM+I,NDIM+I)=RIMHB
    ENDDO

    UOLD(:)=U(:)
    CALL FUNI(AP,NDIM,U,UOLD,ICP,PAR,1,F,DFU,DUMDFP)

! Note that the period-scaling in FUNC is taken into account:
    SMAT(1:NDIM,NDIM+1:2*NDIM)=DFU(:,:)/PAR(11)
    SMAT(NDIM+1:2*NDIM,1:NDIM)=DFU(:,:)/PAR(11)

    CALL NLVC(2*NDIM,2*NDIM,2,SMAT,RNLLV)
    CALL NRMLZ(2*NDIM,RNLLV)

    DO J=0,NTSTNA*NCOL
       T=(J+OFFSET)*TPI/(NTST*NCOL)
       S=SIN(T)
       C=COS(T)
       UDOTPS(:,J)=S*RNLLV(1:NDIM)+C*RNLLV(NDIM+1:2*NDIM)
       IF(J<=NA*NCOL)THEN
          UPOLDP(:,J)=C*RNLLV(1:NDIM)-S*RNLLV(NDIM+1:2*NDIM)
       ENDIF
    ENDDO

    ALLOCATE(DTM(NA))
    DTM(:)=1.d0/NTST
    SS(1)=SQRT(RNRMSQP(NTST,NCOL,NDIM,NDIM,UDOTPS,DTM,THU,NA))
    DEALLOCATE(DTM)

    CALL MPIBCAST(SS,1)
    UDOTPS(:,0:NA*NCOL)=UDOTPS(:,0:NA*NCOL)/SS(1)
    IF(IAM==0.AND.NTST>NA)THEN
       UDOTPS(:,NTST*NCOL)=UDOTPS(:,NTST*NCOL)/SS(1)
    ENDIF

    DEALLOCATE(DFU,F,RNLLV,SMAT,UOLD)
  END SUBROUTINE STHOPF

! ---------- ------
  SUBROUTINE SETRTN(NDM,NTNC,NDIM,UPS)

    USE SUPPORT

! Initialization for rotations
    
    INTEGER, INTENT(IN) :: NDM, NTNC, NDIM
    DOUBLE PRECISION, INTENT(IN) :: UPS(NDIM,0:NTNC)

    INTEGER I

    ALLOCATE(NRTN(NDM))
    IRTN=0
    DO I=1,NDM
       NRTN(I)=NINT( (UPS(I,NTNC)-UPS(I,0)) / PI(2.d0) )
       IF(NRTN(I).NE.0)THEN
          IRTN=1
       ENDIF
    ENDDO
    IF(IRTN.EQ.0)DEALLOCATE(NRTN)

  END SUBROUTINE SETRTN

! ---------- ------
  SUBROUTINE STDRBV(AP,PAR,ICP,FUNI,BCNI,ICNI,RLCUR,RLOLD, &
       RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,IPERP, &
       P0,P1,THL,THU,NA)

    USE MESH
    USE SOLVEBV
    USE AUTOMPI

! Generates a direction vector (UDOTPS,RLDOT) that is needed to start
! the computation of a branch when no direction vector is given.

    include 'interfaces.h'

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER ICP(*),NDIM,IPERP,NA
    DOUBLE PRECISION UDOTPS(NDIM,0:*),DTM(*)
    DOUBLE PRECISION PAR(*),RLCUR(AP%NFPR),RLOLD(AP%NFPR),RLDOT(AP%NFPR)
    DOUBLE PRECISION THL(AP%NFPR),THU(*),UPS(NDIM,0:AP%NTST*AP%NCOL)
    DOUBLE PRECISION UOLDPS(*),UPOLDP(*),P0(*),P1(*)

    INTEGER NTST,NCOL,IID,NFPR,NLLV,IFST,I,IAM,NTSTNA
    DOUBLE PRECISION RDSZ,DET,SS,SS1(1)
    DOUBLE PRECISION, ALLOCATABLE :: DUPS(:,:),DRL(:)

! Generate the Jacobian matrix with zero direction vector.
! (Then the last row of the Jacobian will be zero)
! in case the starting direction is to be determined.

    IAM=MPIIAM()    
    NTST=AP%NTST
    NCOL=AP%NCOL
    IID=AP%IID
    NTSTNA=AP%NTST
    IF(IAM>0)THEN
       IID=0
       NTSTNA=NA
    ENDIF
    NFPR=AP%NFPR

    IF(IPERP.EQ.0)THEN
       UDOTPS(:,0:NCOL*NA)=0.d0
       IF(IAM==0.AND.NTST>NA)THEN
          UDOTPS(:,NCOL*NTST)=0.d0
       ENDIF
       RLDOT(:)=0.d0
    ENDIF

    RDSZ=0.d0
    NLLV=1
    IFST=1

    ALLOCATE(DUPS(NDIM,0:NCOL*NTSTNA),DRL(NFPR))
    CALL SOLVBV(IFST,AP,DET,PAR,ICP,FUNI,BCNI,ICNI,RDSZ,NLLV, &
         RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,DUPS,DRL, &
         P0,P1,THL,THU)

    IF(IPERP==-1)THEN
       DEALLOCATE(DUPS,DRL)
       RETURN
    ENDIF
    
! Compute the starting direction.

    DO I=1,NFPR
       RLDOT(I)=DRL(I)
       PAR(ICP(I))=RLCUR(I)
    ENDDO

    UDOTPS(:,0:NCOL*NA)=DUPS(:,0:NCOL*NA)
    IF(IAM==0.AND.NTST>NA)THEN
       UDOTPS(:,NCOL*NTST)=DUPS(:,NCOL*NTST)
    ENDIF
    DEALLOCATE(DUPS,DRL)

! Scale the starting direction.

    I=0
    SS=RNRMSQP(NTST,NCOL,NDIM,NDIM,UDOTPS,DTM,THU,NA)
    IF(IAM==0)THEN
       SS=SQRT(SS+DOT_PRODUCT(THL(:),RLDOT(:)**2))

! Make sure that RLDOT(1) is positive (unless practically zero: then look
! at other variables).

       DO I=1,NFPR
          IF(ABS(RLDOT(I)/SS)/(1.d0+ABS(RLCUR(I)))>AP%EPSL)THEN
             IF(RLDOT(I)<0.d0)THEN
                SS=-SS
             ENDIF
             EXIT
          ENDIF
       ENDDO
       IF(I>NFPR)THEN
          DO I=1,NDIM
             IF(ABS(UDOTPS(I,NTST*NCOL)/SS)/(1.d0+ABS(UPS(I,NTST*NCOL)))> &
                  AP%EPSU)THEN
                IF(UDOTPS(I,NTST*NCOL)<0.d0)THEN
                   SS=-SS
                ENDIF
                EXIT
             ENDIF
          ENDDO
       ENDIF
    ENDIF

    SS1(1)=SS
    CALL MPIBCAST(SS1,1)
    SS=SS1(1)

    RLDOT(:)=RLDOT(:)/SS
    UDOTPS(:,0:NCOL*NA)=UDOTPS(:,0:NCOL*NA)/SS
    IF(IAM==0.AND.NTST>NA)THEN
       UDOTPS(:,NCOL*NTST)=UDOTPS(:,NCOL*NTST)/SS
    ENDIF

    IF(IID.GE.2)THEN
       WRITE(9,101)
       DO I=1,NFPR 
          WRITE(9,102)ICP(I),RLDOT(I)
       ENDDO
    ENDIF

101 FORMAT(/,' Starting direction of the free parameter(s) : ')
102 FORMAT(' PAR(',I3,') :',E20.12)

  END SUBROUTINE STDRBV

! ---------- -------
  SUBROUTINE STSDRBV(AP,PAR,ICP,FUNI,BCNI,ICNI, &
       RLDOT,UPS,UDOTPS,TM,DUPS,DRL)

    USE MESH
    USE SOLVEBV
    USE AUTOMPI

! Call SOLVEBV from starting data to obtain second null vector
! This is used by BPCONT in periodic.f90 and toolboxbv.f90

    include 'interfaces.h'
    TYPE(AUTOPARAMETERS) :: AP
    INTEGER ICP(*)
    DOUBLE PRECISION PAR(*),RLDOT(AP%NFPR),DRL(AP%NFPR)
    DOUBLE PRECISION UPS(AP%NDIM,0:*),UDOTPS(AP%NDIM,0:*)
    DOUBLE PRECISION TM(0:*),DUPS(AP%NDIM,0:*)

    ! Local
    DOUBLE PRECISION, ALLOCATABLE :: RLOLD(:),RLCUR(:)
    DOUBLE PRECISION, ALLOCATABLE :: UOLDPS(:,:),UPOLDP(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: THU(:),THL(:),DTM(:)
    DOUBLE PRECISION, ALLOCATABLE :: P0(:,:),P1(:,:)
    INTEGER, ALLOCATABLE :: NP(:)
    INTEGER IAM,KWT,NDIM,NFPR,NCOL,NTST,NA,NTSTNA,I,IFST,NLLV
    DOUBLE PRECISION DET,RDS

    NDIM=AP%NDIM
    NFPR=AP%NFPR
    NCOL=AP%NCOL
    NTST=AP%NTST

    IAM=MPIIAM()
    KWT=MPIKWT()
    ALLOCATE(NP(KWT))
    CALL PARTITION(NTST,KWT,NP)
    NA=NP(IAM+1)
    DEALLOCATE(NP)
    IF(IAM==0)THEN
       NTSTNA=NTST
       CALL MPISBV(.TRUE.)
       CALL MPIBCASTAP(AP)
    ELSE
       NTSTNA=NA
    ENDIF

    CALL MPIBCAST(PAR,AP%NPAR)
    CALL MPIBCASTI(ICP,NFPR)
    CALL MPIBCAST(RLDOT,NFPR)
    CALL MPISCAT(UPS,NDIM*NCOL,NTST,NDIM)
    CALL MPISCAT(UDOTPS,NDIM*NCOL,NTST,NDIM)
    CALL MPISCAT(TM,1,NTST,1)

    ALLOCATE(THU(NDIM),THL(NFPR))
    ALLOCATE(P0(NDIM,NDIM),P1(NDIM,NDIM))
    ALLOCATE(UPOLDP(NDIM,0:NA*NCOL),UOLDPS(NDIM,0:NTSTNA*NCOL))
    ALLOCATE(DTM(NTSTNA),RLCUR(NFPR),RLOLD(NFPR))

    DTM(1:NTSTNA)=TM(1:NTSTNA)-TM(0:NTSTNA-1)

    DO I=1,NFPR
       RLCUR(I)=PAR(ICP(I))
       RLOLD(I)=RLCUR(I)
    ENDDO

    UOLDPS(:,0:NTSTNA*NCOL)=UPS(:,0:NTSTNA*NCOL)
    ! ** compute UPOLDP
!$OMP PARALLEL
    CALL STUPBV(AP,PAR,ICP,FUNI,NDIM,UPS,UPOLDP,NA)
!$OMP END PARALLEL

    ! ** unit weights
    THL(1:NFPR)=1.d0
    THU(1:NDIM)=1.d0

    ! ** call SOLVBV
    RDS=0.d0
    NLLV=1
    IFST=1
      
    CALL SOLVBV(IFST,AP,DET,PAR,ICP,FUNI,BCNI,ICNI,RDS,  &
         NLLV,RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM, &
         DUPS,DRL,P0,P1,THL,THU)

    ! ** Global concatenation of the solution from each node.
    CALL MPIGAT(DUPS,NDIM*NCOL,NTST)

    IF(IAM==0)THEN
       ! ** normalization
       CALL SCALEB(NTST,NCOL,NDIM,NFPR,UDOTPS,RLDOT,DTM,THL,THU)
       CALL SCALEB(NTST,NCOL,NDIM,NFPR,DUPS,DRL,DTM,THL,THU)
    ENDIF

    DEALLOCATE(THU,THL,P0,P1,UPOLDP,UOLDPS,DTM,RLCUR,RLOLD)

  END SUBROUTINE STSDRBV

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!  Detection and Location of Branch Points in Boundary Value Problems
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ------
  SUBROUTINE LCSPBV(AP,DSOLD,DSTEST,PAR,ICP,ITEST,FUNI,BCNI,ICNI,FNCI,Q, &
       RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP, &
       TM,DTM,P0,P1,EV,THL,THU,IUZ,VUZ,NITPS,ATYPE,STEPPED,NTSTNA)

    USE SUPPORT
    USE AUTOMPI

    DOUBLE PRECISION, PARAMETER :: HMACH=1.0d-7

! This subroutine uses the Secant method to accurately locate folds
! branch points, and zero(es) of user parameter values.
! Such points are located as points on a solution branch where the
! function FNCS changes sign.
! It involves calling the basic solution subroutines CONTBV and STEP
! with decreasing values of RDS (stepsize along branch).
! The point is assumed to have been found with sufficient accuracy if
! the ratio between RDS and the user supplied value of DS is less than
! the user-supplied tolerance EPSS.
! This subroutine is called from CNRLB, which controls the computation
! of branches of solutions to general boundary value problems.

    include 'interfaces.h'
    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER, INTENT(IN) :: ICP(*),ITEST,IUZ(*),NDIM,NTSTNA
    INTEGER, INTENT(INOUT) :: NITPS
    COMPLEX(KIND(1.0D0)), INTENT(INOUT) :: EV(AP%NDM)
    DOUBLE PRECISION, INTENT(INOUT) :: PAR(*), UPS(NDIM,0:AP%NCOL*NTSTNA)
    DOUBLE PRECISION, INTENT(INOUT) :: UOLDPS(NDIM,0:AP%NCOL*NTSTNA)
    DOUBLE PRECISION, INTENT(INOUT) :: UDOTPS(NDIM,0:AP%NCOL*NTSTNA)
    DOUBLE PRECISION, INTENT(INOUT) :: UPOLDP(NDIM,0:AP%NCOL*NTSTNA)
    DOUBLE PRECISION, INTENT(IN) :: TM(*),DTM(*),THL(*),THU(*),VUZ(*)
    DOUBLE PRECISION, INTENT(INOUT) :: DSOLD,DSTEST,Q
    DOUBLE PRECISION, INTENT(INOUT) :: RLCUR(AP%NFPR),RLOLD(AP%NFPR)
    DOUBLE PRECISION, INTENT(INOUT) :: RLDOT(AP%NFPR)
    DOUBLE PRECISION, INTENT(INOUT) :: P0(NDIM,NDIM),P1(NDIM,NDIM)
    CHARACTER(LEN=*), INTENT(OUT) :: ATYPE
    LOGICAL, INTENT(OUT) :: STEPPED

    INTEGER I,IAM,IID,ITMX,IBR,NTOT,NTOP,NITSP1,ISTOP,NCOL,NFPR,NITPSS
    LOGICAL SEARCH
    DOUBLE PRECISION DS,DSMAX,EPSS,Q0,Q1,DQ,RDS,RRDS,S0,S1
    DOUBLE PRECISION DETS,FLDFS,DSOLDS,DSTESTS
    CHARACTER(4) :: ATYPEDUM

    DOUBLE PRECISION, ALLOCATABLE :: RLOLDS(:),UOLDPSS(:,:),P0S(:,:),P1S(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: RLCURS(:),UPSS(:,:)
    DOUBLE PRECISION, ALLOCATABLE :: RLDOTS(:),UDOTPSS(:,:)
    COMPLEX(KIND(1.0D0)), ALLOCATABLE :: EVS(:)

    IAM=MPIIAM()
    IID=AP%IID
    ITMX=AP%ITMX
    IBR=AP%IBR
    NTOT=AP%NTOT
    NTOP=MOD(NTOT-1,9999)+1
    NCOL=AP%NCOL
    NFPR=AP%NFPR

    DS=AP%DS
    DSMAX=AP%DSMAX
    EPSS=AP%EPSS

    SEARCH=.FALSE.
    STEPPED=.FALSE.
    ATYPE=''

    IF(IAM==0)THEN

! Check for zero.

       Q0=Q
       Q1=FNCS(AP,ICP,UPS,PAR,ATYPE,IUZ,VUZ,ITEST,FNCI)

       ! disable detected potential bifurcations without stability changes
       I=LEN_TRIM(ATYPE)
       IF(I>0)THEN
          IF(ATYPE(I:I)=='0')ATYPE=''
       ENDIF

       IF(AP%ITP/=0.AND.ABS((1.d0+HMACH)*Q1*DSTEST) < &
            EPSS*(1+SQRT(ABS(DS*DSMAX)))*ABS(Q0-Q1))THEN
          ! there could be multiple test functions going through zero
          ! at a point. In general, use "first come, first served", but
          ! In general, use "first come, first served", but
          ! bifurcations override UZ.
          IF(MOD(AP%ITP,10)==-4.AND.LEN_TRIM(ATYPE)>0.AND.TRIM(ATYPE)/='UZ')THEN
             CALL MPIBCAST1L(SEARCH)
             Q=0.d0
             IF(IID>0)WRITE(9,102)DSTEST
             RETURN
          ENDIF
          Q1=0.d0
       ENDIF

! do not test via Q0*Q1 to avoid overflow.
       IF((Q0>=0.AND.Q1>=0) .OR. (Q0<=0.AND.Q1<=0) .OR. LEN_TRIM(ATYPE)==0)THEN
          CALL MPIBCAST1L(SEARCH)
          ATYPE=''
          Q=Q1
          RETURN
       ENDIF

! Use the secant method for the first step:
       
       S0=0.d0
       S1=DSTEST
       DQ=Q0-Q1
       RDS=Q1/DQ*(S1-S0)
       RDS=(1.d0+HMACH)*RDS

! Return if tolerance has been met :

       RRDS=ABS(RDS)/(1+SQRT(ABS(DS*DSMAX)))
       IF(RRDS.LT.EPSS) THEN
          CALL MPIBCAST1L(SEARCH)
          Q=0.d0
          IF(IID>0)WRITE(9,102)RDS
          RETURN
       ENDIF
       SEARCH=.TRUE.
    ENDIF
    CALL MPIBCAST1L(SEARCH)
    IF (.NOT.SEARCH) THEN
       RETURN
    ENDIF

    ALLOCATE(UOLDPSS(NDIM,0:NTSTNA*NCOL),RLOLDS(NFPR))
    ALLOCATE(UDOTPSS(NDIM,0:NTSTNA*NCOL),RLDOTS(NFPR))
    ALLOCATE(UPSS(NDIM,0:NTSTNA*NCOL),RLCURS(NFPR))
    ALLOCATE(P0S(NDIM,NDIM),P1S(NDIM,NDIM),EVS(AP%NDM))
    ! save state to restore in case of non-convergence or
    ! "possible special point"
    UPSS(:,:)=UPS(:,:)
    UDOTPSS(:,:)=UDOTPS(:,:)
    UOLDPSS(:,:)=UOLDPS(:,:)
    RLCURS(:)=RLCUR(:)
    RLDOTS(:)=RLDOT(:)
    RLOLDS(:)=RLOLD(:)
    P0S(:,:)=P0(:,:)
    P1S(:,:)=P1(:,:)
    EVS(:)=EV(:)
    DETS=AP%DET
    FLDFS=AP%FLDF
    DSOLDS=DSOLD
    NITPSS=NITPS
    DSTESTS=DSTEST

    DO NITSP1=0,ITMX
       IF(IAM==0)THEN

! If requested write additional output on unit 9 :

          IF(IID.GE.2)THEN
             WRITE(9,101)NITSP1,RDS
          ENDIF
       ENDIF

       CALL MPICBV(AP%NPAR,PAR,RDS)
       CALL CONTBV(AP,DSOLD,PAR,ICP,FUNI,RLCUR,RLOLD,RLDOT, &
            NDIM,UPS,UOLDPS,UDOTPS,UPOLDP,DTM,THL,THU)
       CALL STEPBV(AP,DSOLD,PAR,ICP,FUNI,BCNI,ICNI,RDS, &
            RLCUR,RLOLD,RLDOT,NDIM,UPS,UOLDPS,UDOTPS,UPOLDP, &
            TM,DTM,P0,P1,THL,THU,NITPS,ISTOP,NTSTNA)
       IF(ISTOP.NE.0)EXIT

       IF(IAM/=0)THEN
          CALL MPIBCAST1L(STEPPED)
          IF(STEPPED)THEN
             DEALLOCATE(UPSS,RLCURS,UOLDPSS,RLOLDS,UDOTPSS,RLDOTS,P0S,P1S)
             RETURN
          ENDIF
          CYCLE
       ENDIF

! Check for zero.

       CALL PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)
       IF(IID.GE.2)WRITE(9,*)
       Q=FNCS(AP,ICP,UPS,PAR,ATYPE,IUZ,VUZ,ITEST,FNCI)
       ! ignore stability changes
       I=LEN_TRIM(ATYPE)
       IF(ATYPE(I:I)=='0')ATYPE=ATYPE(1:I-1)

!        Use Mueller's method with bracketing for subsequent steps
       DSTEST=S1+RDS
       CALL MUELLER(Q0,Q1,Q,S0,S1,DSTEST,RDS)

       RDS=(1.d0+HMACH)*RDS

! Return if tolerance has been met :

       RRDS=ABS(RDS)/(1+SQRT(ABS(DS*DSMAX)))
       IF(RRDS.LT.EPSS) THEN
          STEPPED=.TRUE.
          CALL MPIBCAST1L(STEPPED)
          Q=0.d0
          IF(IID>0)WRITE(9,102)RDS
          DEALLOCATE(UPSS,RLCURS,UOLDPSS,RLOLDS,UDOTPSS,RLDOTS,P0S,P1S)
          RETURN
       ENDIF

       CALL MPIBCAST1L(STEPPED)
    ENDDO

    IF(IAM==0.AND.IID>0)WRITE(9,103)IBR,NTOP+1
    ATYPE=''
    ! set back to previous (converged) state
    UPS(:,:)=UPSS(:,:)
    UDOTPS(:,:)=UDOTPSS(:,:)
    UOLDPS(:,:)=UOLDPSS(:,:)
    RLCUR(:)=RLCURS(:)
    DO I=1,NFPR
       PAR(ICP(I))=RLCUR(I)
    ENDDO
    RLDOT(:)=RLDOTS(:)
    RLOLD(:)=RLOLDS(:)
    P0(:,:)=P0S(:,:)
    P1(:,:)=P1S(:,:)
    EV(:)=EVS(:)
    AP%DET=DETS
    AP%FLDF=FLDFS
    DSOLD=DSOLDS
    DSTEST=DSTESTS
    NITPS=NITPSS
    IF(IAM==0)THEN
       CALL PVLI(AP,ICP,UPS,NDIM,PAR,FNCI)
       Q=FNCS(AP,ICP,UPS,PAR,ATYPEDUM,IUZ,VUZ,ITEST,FNCI)
    ENDIF
    DEALLOCATE(UPSS,RLCURS,UOLDPSS,RLOLDS,UDOTPSS,RLDOTS,P0S,P1S)

101 FORMAT(' ==> Location of special point :  Iteration ',I3, &
         '  Step size = ',ES13.5)
102 FORMAT(' ==> Location of special point : ', &
         ' Convergence.   Step size = ',ES13.5)
103 FORMAT(I4,I6,' NOTE:Possible special point')

  END SUBROUTINE LCSPBV

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                    Output (Boundary Value Problems)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

! ---------- ------
  SUBROUTINE STPLBV(AP,PAR,ICP,ICU,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,THU,ISTOP,NA)

    USE IO
    USE MESH
    USE AUTOMPI

! Writes the bifurcation diagram on unit 7 (Differential Equations)
! (Also controls the writing of complete solutions on unit 8).
! Every line written contains, in order, the following:
!
!  IBR    : The label of the branch.
!  NTOT   : The index of the point on the branch.
!           (Points are numbered consecutively along a branch).
!           If IPS=2 or 3, then the sign of NTOT indicates stability :
!            - = stable , + = unstable, or unknown.
!  ITP    : An integer indicating the type of point :
!
!             4  (  )  :   Output point (Every NPR steps along branch).
!            -4  (UZ)  :   Output point (Zero of user function).
!             5  (LP)  :   Fold (fold).
!             6  (BP)  :   Branch point.
!             7  (PD)  :   Period doubling bifurcation.
!             8  (TR)  :   Bifurcation to an invariant torus.
!             9  (EP)  :   End point of branch, normal termination.
!            -9  (MX)  :   End point of branch, abnormal termination.
!
!  LAB        : The label of a special point.
!  PAR(ICP(1)): The principal parameter.
!  A          : The L2-norm of the solution vector, or other measure of
!               the solution (see the user-supplied parameter IPLT).
!  MAX U(*)   : The maxima of the first few solution components.
!  PAR(ICP(*)): Further free parameters (if any).

    TYPE(AUTOPARAMETERS), INTENT(INOUT) :: AP
    INTEGER ICP(*),ICU(*),NDIM,ISTOP,NA
    DOUBLE PRECISION PAR(*),TM(*),DTM(*),UPS(*),THU(*)
    DOUBLE PRECISION RLDOT(AP%NFPR),UDOTPS(*)
! Local
    DOUBLE PRECISION UMX(7)
    INTEGER IPS,NTST,NCOL,ISW,IPLT,NMX,NPR,NDM,ITP,ITPST,IBR,IAB,IBRS
    INTEGER LABW,NINS,NTOT,NTOTS,IAM
    DOUBLE PRECISION RL0,RL1,A0,A1,AMP

    IAM=MPIIAM()

    IPS=AP%IPS
    NTST=AP%NTST
    NCOL=AP%NCOL
    ISW=AP%ISW
    IPLT=AP%IPLT
    NMX=AP%NMX
    NPR=AP%NPR
    NDM=AP%NDM
    ITP=AP%ITP
    ITPST=AP%ITPST
    IBR=AP%IBR

    RL0=AP%RL0
    RL1=AP%RL1
    A0=AP%A0
    A1=AP%A1

    NTOT=AP%NTOT
    NTOT=NTOT+1
    AP%NTOT=NTOT

! ITP is set to 4 every NPR steps along a branch of solns and the entire
! solution is written on unit 8.

    IF(NPR.NE.0)THEN
       IF(MOD(NTOT,NPR).EQ.0 .AND. MOD(ITP,10).EQ.0)ITP=4+10*ITPST
       AP%ITP=ITP
    ENDIF

! Compute maxima of solution components.

    CALL MXUPSP(NA,NCOL,NDIM,MIN(NDM,7),UPS,UMX)

! Check whether limits of the bifurcation diagram have been reached :

    IAB=ABS(IPLT)
    IF(IAB.EQ.0.OR.IAB.GT.3*NDM) &
         AMP=SQRT(RNRMSQP(NTST,NCOL,NDIM,NDM,UPS,DTM,THU,NA))
    IF(IPLT.GT.0.AND.IAB.LE.NDM)THEN
       IF(IAB.LE.7)THEN
          AMP=UMX(IAB)
       ELSE
          AMP=RMXUPSP(NA,NCOL,NDIM,IAB,UPS)
       ENDIF
    ENDIF
    IF(IPLT.GT.NDM.AND.IAB.LE.2*NDM) &
         AMP=RINTGP(NTST,NCOL,NDIM,IAB-NDM,UPS,DTM,NA)
    IF(IPLT.GT.2*NDM.AND.IAB.LE.3*NDM) &
         AMP=RNRM2P(NTST,NCOL,NDIM,IAB-2*NDM,UPS,DTM,NA)
    IF(IPLT.LT.0.AND.IAB.LE.NDM)AMP=RMNUPSP(NA,NCOL,NDIM,IAB,UPS)

    IF(ISTOP.EQ.1)THEN
!      ** Maximum number of iterations reached somewhere.
       ITP=-9-10*ITPST
    ELSE
       IF(PAR(ICP(1)).LT.RL0.OR.PAR(ICP(1)).GT.RL1 &
            .OR. AMP.LT.A0.OR.AMP.GT.A1 .OR. NTOT.EQ.NMX)THEN
          ITP=9+10*ITPST+1000
       ENDIF
       CALL MPIBCAST1I(ITP)
       ! to distinguish between EP for 1st point and EP for end point
       IF(ITP>1000)THEN
          ITP=ITP-1000
          ISTOP=1
       ENDIF
    ENDIF
    AP%ITP=ITP

! All special points receive label:

    LABW=0
    IF(MOD(ITP,10).NE.0) THEN
       LABW=AP%LAB
    ENDIF

! Branch number is negative for periodic solutions

    IF(IPS.EQ.2.OR.IPS.EQ.12)THEN
       IBRS=-IBR
    ELSE
       IBRS=IBR
    ENDIF

! Determine stability, and write output on units 7 and 8.

    NTOTS=NTOT
    IF(ABS(ISW).LE.1 .AND. (IPS.EQ.2.OR.IPS.EQ.7.OR.IPS.EQ.12))THEN
       NINS=AP%NINS
       IF(NINS.EQ.NDIM)NTOTS=-NTOT
    ENDIF
    IF(IAM==0)CALL WRLINE(AP,PAR,ICU,IBRS,NTOTS,LABW,AMP,UMX)

! Write plotting and restart data on unit 8.

    IF(MOD(ITP,10).NE.0)THEN
       CALL WRTBV8(AP,PAR,ICP,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,NA)
       AP%LAB=AP%LAB+1
    ENDIF

  END SUBROUTINE STPLBV

! ---------- ------
  SUBROUTINE WRTBV8(AP,PAR,ICP,RLDOT,NDIM,UPS,UDOTPS,TM,DTM,NA)

    USE COMPAT
    USE SUPPORT, ONLY: DIRECTION
    USE AUTO_CONSTANTS, ONLY: IPS, NDIMU => NDIM
    USE AUTOMPI

! Writes plotting and restart data on unit 8, viz.:
! (1) data identifying the corresponding point on unit 7,
! (2) the complete solution,
! (3) the direction of the branch.
!
! Specifically the following is written:
!
!  IBR   : The index of the branch.
!  NTOT  : The index of the point.
!  ITP   : The type of point (see STPLBV above).
!  LAB   : The label of the point.
!  NFPR : The number of free parameters used in the computation.
!  ISW   : The value of ISW used in the computation.
!  NTPL  : The number of points in the time interval [0,1] for which
!          solution values are written.
!  NAR   : The number of values written per point.
!          (NAR=NDIM+1, since T and U(i), i=1,..,NDIM are written).
!  NROWPR: The number of lines printed following the identifying line
!          and before the next data set or the end of the file.
!          (Used for quickly skipping a data set when searching).
!  NTST  : The number of time intervals used in the discretization.
!  NCOL  : The number of collocation points used.
!  NPAR  : The dimension of the array PAR.
!  NPARI : Number of internal parameters, at the end of the array PAR.
!  NDIMU : The user-specified dimension.
!  IPS   : The problem type. 
!  IPRIV : Private field for use by toolboxes.
!
!  Following the above described identifying line there are NTPL lines
! containing :
!     T , U-1(T) , U-2(T) , ... , U-NDIM(T),
! where NDIM is the dimension of the system of differential equations.
!
! Following this is a line containing the indices of the free parameters
!    ICP(I),I=1,NFPR,
!
! followed by a line containing the values
!    RL-dot(i) , i=1,NFPR,
!
! and following this are NTPL lines each containing
!    U-dot-1(T), U-dot-2(T), ... , U-dot-NDIM(T).
!
! Finally the parameter values PAR(i) , i=1,NPAR, are written.
!
!  Above, RL-dot(.) and U-dot(.) specify the direction of the branch.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER ICP(*),NDIM,NA
    DOUBLE PRECISION UPS(NDIM,0:*),UDOTPS(NDIM,0:*),TM(0:*),DTM(*)
    DOUBLE PRECISION PAR(*),RLDOT(AP%NFPR)

    INTEGER NTST,NCOL,ISW,ITP,NFPR,IBR,NPAR,NTOT,LAB,NTPL,NAR,NROWPR
    INTEGER NROW,MTOT,I,J,K,NPARI,IAM
    DOUBLE PRECISION T
    LOGICAL DIR
    CHARACTER(137), ALLOCATABLE :: S(:)
!xxx====================================================================
!xxx Test problem: compute the error
!    err(x,t)=x - 2*DATAN(1.d0)*PAR(2)*DSIN(4*DATAN(1.d0)*t)
!xxx====================================================================

    IAM=MPIIAM()

    NTST=AP%NTST
    NCOL=AP%NCOL
    ISW=AP%ISW
    NPARI=AP%NPARI
    ITP=AP%ITP
    NFPR=AP%NFPR
    IBR=AP%IBR
    NPAR=AP%NPAR
    NTOT=AP%NTOT
    LAB=AP%LAB

! Write information identifying the solution :
! skip direction info based on IIS and ITP
    DIR=DIRECTION(AP%IIS,ITP)

    NTPL=NCOL*NTST+1
    NAR=NDIM+1
    NROWPR=(NDIM/7+1)*NTPL + (NPAR+6)/7
    IF(DIR)THEN
       NROWPR=NROWPR + (NFPR+19)/20 + (NFPR+6)/7 + ((NDIM+6)/7)*NTPL
    ENDIF
    MTOT=MOD(NTOT-1,9999)+1
    IF(IAM==0)WRITE(8,101)IBR,MTOT,ITP,LAB,NFPR,ISW,NTPL,NAR,NROWPR,NTST,NCOL,NPAR, &
         NPARI,NDIMU,IPS,0

! Write the entire solution on unit 8 :

!xxx====================================================================
!xxx Test problem
    !xxx eg=0.d0
    !xxx em=0.d0
!xxx====================================================================
    NROW=NDIM/7+1
    ! each worker writes to a line string, the lines are then gathered
    ALLOCATE(S(0:NTST*NCOL*NROW-1))
!$OMP PARALLEL DO PRIVATE(T,J,K)
    DO J=0,NA*NCOL-1
       T=TM(J/NCOL)+MOD(J,NCOL)*DTM(J/NCOL+1)/NCOL
       WRITE(S(J*NROW),102)T,UPS(:MIN(NDIM,6),J)
       DO K=1,NROW-1
          WRITE(S(J*NROW+K),102)UPS(K*7:MIN(NDIM,K*7+6),J)
       ENDDO
!xxx====================================================================
!xxx Test problem
       !xxx er = err(ups(1,j),T)
       !xxx if(dabs(er).gt.eg)eg=dabs(er)
       !xxx if(i.eq.1 .and. dabs(er).gt.em)em=dabs(er)
!xxx====================================================================
    ENDDO
!$OMP END PARALLEL DO
    CALL MPIGATS(S,NCOL*NROW,NTST,4+7*19)

    IF(IAM==0)THEN
       DO J=0,NTST*NCOL*NROW-1
          WRITE(8,'(A)')TRIM(S(J))
       ENDDO
       WRITE(8,102)1.0d0,UPS(:,NTST*NCOL)
    ENDIF

!xxx====================================================================
!xxx Test problem
! Write global error and mesh error
!xxx       write(10,100)ncol,ntst,eg,em
!xxx 100   FORMAT(4X,I2,I4,7ES11.3)
!xxx====================================================================

    IF(DIR)THEN
! Write the direction of the branch:
       NROW=(NDIM+6)/7
!$OMP PARALLEL DO PRIVATE(T,J,K)
       DO J=0,NA*NCOL-1
          DO K=0,NROW-1
             WRITE(S(J*NROW+K),102)UDOTPS(K*7+1:MIN(NDIM,K*7+7),J)
          ENDDO
       ENDDO
!$OMP END PARALLEL DO
       CALL MPIGATS(S,NCOL*NROW,NTST,4+7*19)
    ENDIF

    IF(IAM/=0)THEN
       DEALLOCATE(S)
       RETURN
    ENDIF

    IF(DIR)THEN
! Write the free parameter indices:

       WRITE(8,103)(ICP(I),I=1,NFPR)

! Write the direction of the branch:

       WRITE(8,102)(RLDOT(I),I=1,NFPR)
       DO J=0,NTST*NCOL*NROW-1
          WRITE(8,'(A)')TRIM(S(J))
       ENDDO
       WRITE(8,102)UDOTPS(:,NTST*NCOL)
    ENDIF
    DEALLOCATE(S)

! Write the parameter values.

    WRITE(8,102)(PAR(I),I=1,NPAR)

101 FORMAT(6I6,I8,I6,I8,7I5)
102 FORMAT(4X,7ES19.10E3)
103 FORMAT(20I5)

    CALL AUTOFLUSH(8)
  END SUBROUTINE WRTBV8

! ---------- ------
  SUBROUTINE WRTBV9(AP,RLCUR,NDIM,UPS,TM,DTM,THU,NITPS,NA)

    USE IO
    USE MESH
    USE AUTOMPI

! Writes additional output on unit 9.

    TYPE(AUTOPARAMETERS), INTENT(IN) :: AP
    INTEGER, INTENT(IN) :: NDIM,NITPS,NA
    DOUBLE PRECISION, INTENT(IN) :: RLCUR(AP%NFPR),DTM(*),UPS(NDIM,0:*)
    DOUBLE PRECISION, INTENT(IN) :: TM(0:*),THU(*)

    INTEGER NTST,NCOL,IPLT,IID,NDM,IBR,NTOT,J,K,MTOT,NROW
    DOUBLE PRECISION T,AMP
    CHARACTER(1+7*14), ALLOCATABLE :: S(:)

    IID=AP%IID
    IF(IID<2)RETURN

    NTST=AP%NTST
    NCOL=AP%NCOL
    IPLT=AP%IPLT
    NDM=AP%NDM
    IBR=AP%IBR
    NTOT=AP%NTOT

    IF(IPLT>0.AND.IPLT<=NDIM)THEN
       AMP=RMXUPSP(NA,NCOL,NDIM,IPLT,UPS)
    ELSEIF(IPLT<0.AND.IPLT>=-NDIM)THEN
       AMP=RMNUPSP(NA,NCOL,NDIM,-IPLT,UPS)
    ELSE
       AMP=SQRT(RNRMSQP(NTST,NCOL,NDIM,NDM,UPS,DTM,THU,NA))
    ENDIF

    IF(MPIIAM()==0)THEN
       IF(NITPS.EQ.0)CALL WRBAR("=",47)
       IF(NITPS.EQ.0 .OR. IID.GE.3)THEN
          WRITE(9,102)
       ENDIF
       MTOT=MOD(NTOT-1,9999)+1
       WRITE(9,103)IBR,MTOT+1,NITPS,RLCUR(1),AMP
102    FORMAT(/,'  BR    PT  IT         PAR',11X,'L2-NORM')
103    FORMAT(I4,I6,I4,5X,6ES14.5)
    ENDIF

    IF(IID<5)RETURN

    ! each worker writes to a line string, the lines are then gathered
    NROW=NDIM/7+1
    ALLOCATE(S(0:NTST*NCOL*NROW-1))
    DO J=0,NA*NCOL-1
       T=TM(J/NCOL)+MOD(J,NCOL)*DTM(J/NCOL+1)/NCOL
       WRITE(S(J*NROW),105)T,UPS(:MIN(NDIM,6),J)
       DO K=1,NROW-1
          WRITE(S(J*NROW+K),105)UPS(K*7:MIN(NDIM,K*7+6),J)
       ENDDO
    ENDDO

    CALL MPIGATS(S,NCOL*NROW,NTST,1+7*14)

    IF(MPIIAM()==0)THEN
       WRITE(9,104)
       DO J=0,NTST*NCOL*NROW-1
          WRITE(9,'(A)')TRIM(S(J))
       ENDDO
       WRITE(9,105)1.0d0,UPS(:,NTST*NCOL)
104    FORMAT(' UPS :')
105    FORMAT(1X,7ES14.5)
    ENDIF
    DEALLOCATE(S)

  END SUBROUTINE WRTBV9

END MODULE BVP

!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   opt :    A model algebraic optimization problem
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION X1,X2,X3,X4,X5

       X1=U(1) 
       X2=PAR(1) 
       X3=PAR(2) 
       X4=PAR(3) 
       X5=PAR(4) 

       F(1)=X1*X1 + X2*X2 + X3*X3 + X4*X4 + X5*X5 - 1 

      IF(IJAC.EQ.0)RETURN 

       DFDU(1,1)=2*X1 

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DFDP(1,1)=2*X2 
       DFDP(1,2)=2*X3 
       DFDP(1,3)=2*X4 
       DFDP(1,4)=2*X5 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      DOUBLE PRECISION X1,X2,X3,X4,X5

       X1=1.0 
       X2=0.0 
       X3=0.0 
       X4=0.0 
       X5=0.0 

       U(1)=X1 

       PAR(1)=X2 
       PAR(2)=X3 
       PAR(3)=X4 
       PAR(4)=X5 

      END SUBROUTINE STPNT

      SUBROUTINE FOPT(NDIM,U,ICP,PAR,IJAC,FS,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: FS
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM),DFDP(*)

      DOUBLE PRECISION X1,X2,X3,X4,X5

       X1=U(1) 
       X2=PAR(1) 
       X3=PAR(2) 
       X4=PAR(3) 
       X5=PAR(4) 

       FS=X1 + X2 + X3 + X4 + X5 

      IF(IJAC.EQ.0)RETURN 

       DFDU(1)=1.0 

      IF(IJAC.EQ.1)RETURN 

!      *Parameter derivatives
       DFDP(1)=1.0 
       DFDP(2)=1.0 
       DFDP(3)=1.0 
       DFDP(4)=1.0 

      END SUBROUTINE FOPT

      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

# 
#  This file has to be sourced before activating AUTO if you are using
#  a 'sh' compatible shell, such as sh, bash, ksh, or ash.
#
AUTO_DIR=$HOME/auto/07p
PATH=$AUTO_DIR/cmds:$AUTO_DIR/bin:$PATH
# the following is an example (to be uncommented) for Windows+MSYS:
#PATH="/c/Python27:/bin:/c/Program Files/gfortran/bin:$PATH"
export AUTO_DIR
export PATH
#
# DON'T ADD ANYTHING AFTER THIS LINE
#

AUTO_DIR=~/src/auto/2000
PYTHONPATH=$AUTO_DIR/python:$AUTO_DIR/python/graphics:~/src/DataViewer/Python_interface/python_script:$AUTO_DIR/python/lib/Linux_OpenGL:$AUTO_DIR/python/lib/Linux_Mesa:.
DV=~/src/DataViewer
PATH=$PATH:$AUTO_DIR/bin
